clear all
nfig=0;

k=0.5:0.1:2.0;


%%%%------SETTING INPUT DATA------%%%%%%
if exist('nsample') == 0 nsample=1000; end
if exist('isampleplot') == 0 isampleplot=1; end


for snratio=5:2:5    
for nlog=9:12
for ifunction=1:1
  
switch ifunction 
  case 1, fun='Bumps'; wtype='Daubechies'; filtersize=6;
  case 2, fun='Blocks'; wtype='Haar'; filtersize=[];
  case 3, fun='HeaviSine'; wtype='Symmlet'; filtersize=8;
  case 4, fun='Doppler'; wtype='Symmlet'; filtersize=8;
end


%%%%%%%%%%%%%%%%INIZIALIZING%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=2^nlog;  %number of observed data

nk=length(k);
ycumul=zeros(nk,n);
MSE=zeros(nsample,nk);

qmf = MakeONFilter(wtype, filtersize); % making wavelet filters

step=1/n;
x=[0:step:1-step];
%
% GENERATING TRUE FUNCTION
%
ytrue=MakeSignalnewb(fun,n); 
sigma=std(ytrue);

randn('state', 0) %initializing random noise generator

caseplot=sprintf('n=%i snr=%i',n,snratio);
caseplot1=[ fun ];
caseplot=[ fun ' - ' caseplot ];

for isample=1:nsample
    
 %%%% GENERATING SAMPLE OF NOISE%%%% 
    noise=randn(1,n); 
    y = ytrue+sigma*noise/snratio;
 
    for i=1:nk
        ysmooth=recMode2(y,qmf,k(i));
        ycumul(i,:) = ycumul(i,:) + ysmooth;  %needed for calculating the bias
        MSE(isample,i)=sum((ytrue-ysmooth).^2)/n;
    end
       
end % sample iteration

AMSE=zeros(nk,1);
STDMSE=zeros(nk,1);
BIAS2=zeros(nk,1);
VARIANCE=zeros(nk,1);
ymean=zeros(nk,n);
ycumul=zeros(nk,n);

for i=1:nk
    ymean(i,:)=ycumul(i,:)/nsample;
    AMSE(i)=mean(MSE(:,i));
    STDMSE(i)=std(MSE(:,i));
    BIAS2(i) = 1/n * sum((ytrue - ymean(i,:)).^2);
    VARIANCE(i) = AMSE(i) - BIAS2(i);
end

    MSE_methods= MSE;
   
    nfig=nfig+1;
    figure(1)
    subplot(4,1,nfig)
    boxplot(MSE_methods)
    %title([caseplot1])
    xlabel('')
    casey=sprintf('N=%i',n);
    ylabel([casey])
    
    set(gca,'xticklabel',k);
    
    if nfig==4
     gname1=sprintf('./figure/snr%iAMSE_dt_bump.eps',snratio);
     stringa=['print -deps ' gname1];
     eval(stringa);
    end

 fprintf('\n\n Signal to Noise ratio: %i\n',snratio);
fprintf(' Size of the sample: %i=2^%i\n',n,nlog);
fprintf(' Test function: %s\n',fun);
fprintf(' Wavelet type: %s\n',wtype);
fprintf(' Wavelet filter size: %i \n',filtersize);
fprintf(' Number of random samples: %i\n',nsample);
fprintf(' \n');
fprintf('      K        |    AMSE    |       STD     |      BIAS^2    | VARIANCE \n');
fprintf('---------------+------------+---------------+----------------+-------------\n');
for i=1:nk
    fprintf('   %2.1f        |%d | %d | %d | %d | \n',k(i),AMSE(i),STDMSE(i),BIAS2(i),VARIANCE(i));
end
    
    

fname=sprintf('./output/t%in%is%i_bump.out',ifunction,n,snratio); %filename containing the output
    fid=fopen(fname,'w');
fprintf(fid,'\n\n Signal to Noise ratio: %i\n',snratio);
fprintf(fid,' Size of the sample: %i=2^%i\n',n,nlog);
fprintf(fid,' Test function: %s\n',fun);
fprintf(fid,' Wavelet type: %s\n',wtype);
fprintf(fid,' Wavelet filter size: %i \n',filtersize);
fprintf(fid,' Number of random samples: %i\n',nsample);
fprintf(fid,' \n');
fprintf(fid,' \n');
fprintf(fid,'      K       |    AMSE     |       STD     |      BIAS^2    | VARIANCE \n');
fprintf(fid,'--------------+-------------+---------------+----------------+-------------\n');
for i=1:nk
    fprintf(fid,'   %2.1f        |%d | %d | %d | %d | \n',k(i),AMSE(i),STDMSE(i),BIAS2(i),VARIANCE(i));
end

fclose(fid);

    
end % ifunction
end % nlog
end % SNRATIO

