function[ysure]=mysure(y,minlev,qmf) 

% %%%%%%%%%%%%%%%%%%%%%%%%%%%USAGE%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%Theory about SURE from Statistical modeling by wavelets, B.Vidakovic pages.199-200
%
% INPUT: y           vector of noisy observation in the physical domain 
%                    normalized such that the variance of the noise is =1.
%                     the size of y should be an integer power of two.
%        minlev      coarsest level decomposition i.e.,any positive integer number
%                     less than log2(length(y)).
%        qmf         Output of MakeONFilter
%
% OUTPUT: ysure      vector of smoothed data in the physical domain
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


n=length(y);
nlog=log2(n);
w=fwt_po(y,minlev,qmf);
 for lev=minlev:nlog-1
            dummy=w(dyad(lev));
            dummysure=0.*dummy;     
            sj2=sum(dummy.^2-1)/2^lev; 
           if sj2 <=(1/sqrt(2^lev))*log2(2^lev)^1.5 
              thresh=sqrt(2*log(n));
             dummysure= HardThresh(dummy,thresh);
             wsure(dyad(lev))=dummysure;
            clear dummymod
            clear dummysure
           else
              a = sort(abs(dummy)).^2 ;
	          b = cumsum(a);
	          n = length(dummy);
	          c = linspace(n-1,0,n);
	          s = b+c.*a;
	          risk = (n - ( 2 .* (1:n ))  + s)/n;
	          [guess,ibest] = min(risk);
	          thresh = sqrt(a(ibest));       
              dummysure= SoftThresh(dummy,thresh);
               wsure(dyad(lev))=dummysure;
            clear dummymod
            clear dummysure
        end
        
 end 
wsure(1:2^minlev)=w(1:2^minlev);
ysure=iwt_po(wsure,minlev,qmf);  





 