% Compute the rule in Eq.(8) from 'Efficiency of linear rules....', Vidakovic & Dasgupta (1996)

function[]=plotrule(eps0,m,xmin,xmax)
%
 if nargin < 3,
    xmin=-8;
    xmax=8;
end

x=[xmin:0.05:xmax]; %ATTENTION: numerical cancellation when x is large and m(i) is small (due to 0/0)
      
       phi=1/sqrt(2*pi)*exp(-0.5*x.^2); 

        Num=eps0*x.*phi;

       Denum=eps0*phi;

        cn=(1-eps0)/(2*m);
        Num=Num-cn*(1/sqrt(2*pi))*(exp(-0.5*(x+m).^2)-exp(-0.5*(x-m).^2));
        Denum=Denum+cn*0.5*(erf((x+m)/sqrt(2))-erf((x-m)/sqrt(2))+eps); %since PHI(x)=0.5+0.5*efr(x/sqrt(2))
  
     
    Deltarule=sign(x).*(min(abs((x-Num./Denum)),m)); %evaluate  deltarule 
  
    plot(x,Deltarule,'b',x,x,'m',[xmin,xmax],[m,m],'y',[xmin,xmax],[-m,-m],'y')
   
   
