   function smo_data=recmybams(data,filt)
   
    N=length(data);
    coarsest=floor(log2( log (N))) + 1; %coarsest level
    finest_lev=log2(N)-1;
      
    data_wd = FWT_PO (data, coarsest, filt);
    data_smowd = data_wd;
   
    %----------setting the parameters: mu----------------------
    niz=data_wd(dyad(finest_lev));
    nizo=sort(niz); mm=length(nizo);
    low=floor(1/4 * mm); high=floor(3/4 * mm);
    pseudos = abs(nizo(high)-nizo(low))/1.5; %hoaglin, mosteller, tukey: book
    mu = 1/pseudos^2;                        %Robust EDA, Wiley 1983
    %----------setting the parameters: tau and epsilon (levelwise)-------
    shape=ones(1, finest_lev);
    tauu= sqrt((std(data).^2 - 1/mu));
    for i = finest_lev:-1:coarsest,
          eps(i) = 1 - 1/(i - coarsest +1)^1.5;
          tau(i) = tauu;
    %----------------------------------------------------------
           a = data_wd(dyad(i));
           b = 0 .* a;
           nn=length(a);
                  for  j = 1:nn,
                    [zz,  b(j)] = bayesrule(a(j), mu, tau(i), eps(i));
                  end
           data_smowd(dyad(i))= b; 
    end
    smo_data = IWT_PO( data_smowd, coarsest, filt);