clear all
nfig=1;

gamma=[1:0.1:3];
ngamma=length(gamma);

%%%%------SETTING INPUT DATA------%%%%%%
if exist('nsample') == 0 nsample=200; end
if exist('isampleplot') == 0 isampleplot=1; end

for  nlog=8:10
for snratio=3:2:7     
for ifunction=1:9   
switch ifunction
  case 1, fun='Wave'; wtype='Symmlet'; filtersize=8;
  case 2, fun='Blocks'; wtype='Haar'; filtersize=[];
  case 3, fun='HeaviSine'; wtype='Symmlet'; filtersize=8;
  case 4, fun='Doppler'; wtype='Symmlet'; filtersize=8;
  case 5, fun='Corner'; wtype='Symmlet'; filtersize=8;
  case 6, fun='Blip'; wtype='Symmlet'; filtersize=8;
  case 7, fun='Angles'; wtype='Symmlet'; filtersize=8;
  case 8, fun='Parabolas'; wtype='Symmlet'; filtersize=8;
  case 9, fun='Time Shifted Sine'; wtype='Symmlet';filtersize=8;   
end

%%%%%%%%%%%%%%%%INIZIALIZING%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=2^nlog;  %number of observed data

minlev=floor(log2(log(n))) + 1;

ycumul=zeros(1,n);

MSE=zeros(nsample,1);

qmf = MakeONFilter(wtype, filtersize); % making wavelet filters

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 randn('state', 0)    
%%%%%%%%%%% GENERATING TRUE FUNCTION
step=1/n;
x=[0:step:1-step];
ytrue=MakeSignalNewb(fun,n); 

sigma=std(ytrue);
randn('state', 0) %initializing random noise generator

caseplot=sprintf('n=%i snr=%i',n,snratio);
caseplot1=[ fun ];
caseplot=[ fun ' - ' caseplot ];

for isample=1:nsample
    ysmooth=zeros(ngamma,n);
 %%%% GENERATING SAMPLE OF NOISE%%%% 
    noise=randn(1,n); 
    y = ytrue+sigma*noise/snratio;
      igamma=0;
      MSE=zeros(ngamma,nsample);
        for gamma0=gamma
           igamma=igamma+1;    
           ysmooth(igamma,:)=recgamma(y,qmf,gamma0);
           MSE(igamma,isample)=sum((ytrue-ysmooth(igamma,:)).^2)/n;     
           clear ysmooth
        end 
end

for i=1:ngamma
AMSE(i)=mean(MSE(i,:));
end
clear MSE

c(1,1:3)=[1 0 0];
c(2,1:3)=[0 1 0];
c(3,1:3)=[0 0 1];
c(4,1:3)=[1 1 0];
c(5,1:3)=[0 1 1];


if snratio==1
    ncolore=4;
elseif snratio==3;
    ncolore=1;
elseif snratio==5
    ncolore=2;
else
    ncolore=3;
end
figure(nfig) 
subplot(3,3,ifunction)
plot(gamma,AMSE,'Color',c(ncolore,:))
hold on
  if ncolore==1
      title([caseplot1]) 
      if ifunction==7 | ifunction==8 | ifunction==9
        xlabel('gamma')
      else
        xlabel('')
      end      
      if ifunction==1| ifunction==4| ifunction==7 
        ylabel('AMSE')
      else
        ylabel('')
      end
  end
  clear AMSE
end % ifunction
end %end SNRATIO
figure(nfig)
name1=sprintf('G_AMSEn%i.eps',n); %filename containing the output
     set(gcf,'PaperType','A4'); 
     set(gcf,'paperpositionmode','manual'); 
     set(gcf,'paperposition',[0.5 1.5 20 25]); 
     set(gcf,'PaperUnits', 'centimeters'); 
     stringa=['print -depsc ' name1];
     eval(stringa);
nfig=nfig+1;
end %nlog