% Application of the Gamma-minimax rule on an the Atomic Force Microscopy signal.
%----------------------------
%INITIALIZING  PARAMETERS
%----------------------------
clear all 
close all
%==========
 lw = 2;  
 set(0, 'DefaultAxesFontSize', 16);
 fs = 15;
 msize = 5;
%==========



wtype='Symmlet'; %Choiche of the vavelet filter
filtersize=8;

k1=4; % default choice of the free prior parameter of the ML-IIThresh

k2=4.5; % alternative choiche for the free prior parameter of the ML-IIThresh when using the AFM Dataset 

%--------------------------------------------------------------------------------
% making wavelet filters
qmf = MakeONFilter(wtype, filtersize);


% loading the data set    
load afm.dat

nlog=11;
n=2^nlog;  %number of observed data

signal=afm(:); % the first n component of the AFM data are considered
y=signal(1:n)';

step=1/(n-1);
grid=0:step:1;

   
%     y0_G = recModeExp(y,qmf,k1,mu1);
%          
%     y1_G = recModeExp(y,qmf,k2,mu2);
%  

   y0_G = recMode2(y,qmf,k1);
          
    y1_G = recMode2(y,qmf,k2);
  

figure(1)
   subplot(3,1,1)
        plot(grid,y)
        axis([0 1 -0.05 0.15])
   subplot(3,1,2)
        plot(grid,y0_G)
        axis([0 1 -0.05 0.15])
   subplot(3,1,3)
        plot(grid,y1_G)  
        axis([0 1 -0.05 0.15])    

     print -depsc C:\Brani\WorkGT\Fabrizio\Milano\Figures\atomic.eps;
     
   
     
     %
% Copyright (c) 2002
%
% Claudia Angelini
% Istituto per le Applicazioni del Calcolo 'M. Picone' - Napoli Section
% Consiglio Nazionale delle Ricerche
% Via P. Castellino 111
% 80131 Napoli
% Italy
%
% mailto: angelini@iam.na.cnr.it
%
% and
%
% Theofanis Sapatinas
% Department of Mathematics and Statistics
% University of Cyprus
% P.O. Box 20537  
% CY 1678 Nicosia
% Cyprus.
%
% mailto: T.Sapatinas@ucy.ac.cy 

