clear all
nfig=0;

k=1.5:0.1:3.5;  % **** modify 01

%%%%------SETTING INPUT DATA------%%%%%%
if exist('nsample') == 0 nsample=1000; end
if exist('isampleplot') == 0 isampleplot=1; end

fname2=sprintf('./output/table1_optimalk_exp.out');  % **** modify 02
fid2=fopen(fname2,'w');

minAMSE_exp=zeros(3,3,4); % **** modify 03
minkmat_exp=zeros(3,3,4); % **** modify 04
snratio2=1;
nlog2=1;

for snratio=3:2:7    
for nlog=9:11
for ifunction=1:4
  
switch ifunction 
  case 1, fun='Bumps'; wtype='Daubechies'; filtersize=6;
  case 2, fun='Blocks'; wtype='Haar'; filtersize=[];
  case 3, fun='HeaviSine'; wtype='Symmlet'; filtersize=8;
  case 4, fun='Doppler'; wtype='Symmlet'; filtersize=8;
end


%%%%%%%%%%%%%%%%INIZIALIZING%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=2^nlog;  %number of observed data

nk=length(k);
ycumul=zeros(nk,n);
MSE=zeros(nsample,nk);

qmf = MakeONFilter(wtype, filtersize); % making wavelet filters

step=1/n;
x=[0:step:1-step];
%
% GENERATING TRUE FUNCTION
%
ytrue=MakeSignalnewb(fun,n); 
sigma=std(ytrue);

randn('state', 0) %initializing random noise generator

caseplot=sprintf('n=%i snr=%i',n,snratio);
caseplot1=[ fun ];
caseplot=[ fun ' - ' caseplot ];

for isample=1:nsample
    
 %%%% GENERATING SAMPLE OF NOISE%%%% 
    noise=randn(1,n); 
    y = ytrue+sigma*noise/snratio;
    for i=1:nk
        ysmooth=recMode2_exp(y,qmf,k(i));  % **** modify 05
        ycumul(i,:) = ycumul(i,:) + ysmooth;  %needed for calculating the bias
        MSE(isample,i)=sum((ytrue-ysmooth).^2)/n;
    end
       
end % sample iteration

AMSE=zeros(nk,1);
STDMSE=zeros(nk,1);
BIAS2=zeros(nk,1);
VARIANCE=zeros(nk,1);
ymean=zeros(nk,n);
ycumul=zeros(nk,n);

for i=1:nk
    ymean(i,:)=ycumul(i,:)/nsample;
    AMSE(i)=mean(MSE(:,i));
    STDMSE(i)=std(MSE(:,i));
    BIAS2(i) = 1/n * sum((ytrue - ymean(i,:)).^2);
    VARIANCE(i) = AMSE(i) - BIAS2(i);
end

    MSE_methods= MSE;
   
%     if ifunction==1
%         nfig=nfig+1;
%     end
%     
%     figure(nfig)
%     subplot(4,1,ifunction)
%     boxplot(MSE_methods)
%     %title([caseplot1])
%     xlabel('')
%     if ifunction==1  
%        ylabel('Bumps')
%     elseif ifunction==2
%        ylabel('Blocks')
%     elseif ifunction==3
%        ylabel('HeaviSine')
%     elseif ifunction==4
%        ylabel('Doppler')
%     end
%      
%     
%     set(gca,'xticklabel',k);
%     
%     if ifunction==4
%      gname1=sprintf('./figure/n%isnr%iAMSE_dt.eps',n,snratio);
%      stringa=['print -deps ' gname1];
%      eval(stringa);
%     end

minAMSE=min(AMSE);
minkind=find(AMSE==minAMSE);
mink=k(minkind);
minAMSE_exp(snratio2,nlog2,ifunction)=minAMSE; % **** modify 06
minkmat_exp(snratio2,nlog2,ifunction)=mink; % **** modify 07

fprintf('\n\n Signal to Noise ratio: %i\n',snratio);
fprintf(' Size of the sample: %i=2^%i\n',n,nlog);
fprintf(' Test function: %s\n',fun);
fprintf(' Wavelet type: %s\n',wtype);
fprintf(' Wavelet filter size: %i \n',filtersize);
fprintf(' Number of random samples: %i\n',nsample);
fprintf(' \n');
fprintf(' Optimal K: %2.1f\n',mink);
fprintf(' \n');
fprintf('      K        |    AMSE    |       STD     |      BIAS^2    | VARIANCE \n');
fprintf('---------------+------------+---------------+----------------+-------------\n');
for i=1:nk
    fprintf('   %2.1f        |%d | %d | %d | %d | \n',k(i),AMSE(i),STDMSE(i),BIAS2(i),VARIANCE(i));
end
    
    

fname=sprintf('./output/table1_t%in%is%i_exp.out',ifunction,n,snratio); %filename containing the output   % **** modify 08
    fid=fopen(fname,'w');
fprintf(fid,'\n\n Signal to Noise ratio: %i\n',snratio);
fprintf(fid,' Size of the sample: %i=2^%i\n',n,nlog);
fprintf(fid,' Test function: %s\n',fun);
fprintf(fid,' Wavelet type: %s\n',wtype);
fprintf(fid,' Wavelet filter size: %i \n',filtersize);
fprintf(fid,' Number of random samples: %i\n',nsample);
fprintf(fid,' \n');
fprintf(fid,' Optimal K: %2.1f\n',mink);
fprintf(fid,' \n');
fprintf(fid,'      K       |    AMSE     |       STD     |      BIAS^2    | VARIANCE \n');
fprintf(fid,'--------------+-------------+---------------+----------------+-------------\n');
for i=1:nk
    fprintf(fid,'   %2.1f        |%d | %d | %d | %d | \n',k(i),AMSE(i),STDMSE(i),BIAS2(i),VARIANCE(i));
end

fclose(fid);


 fprintf(fid2,'\n\n Signal to Noise ratio: %i\n',snratio);
 fprintf(fid2,' Size of the sample: %i=2^%i\n',n,nlog);
 fprintf(fid2,' Test function: %s\n',fun);
 fprintf(fid2,' Optimal K: %2.1f\n',mink);



end % ifunction
nlog2=nlog2+1;

end % nlog
snratio2=snratio2+1;
nlog2=1;

end % SNRATIO

fclose(fid2);
save minkmat_exp;  % **** modify 09
save minAMSE_exp;  % **** modify 10