(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    233199,       7308]*)
(*NotebookOutlinePosition[    233843,       7330]*)
(*  CellTagsIndexPosition[    233799,       7326]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
    StyleBox[\(Exact\ Risk\ Properties\),
      "Title",
      FontSize->36], "\[IndentingNewLine]", 
    StyleBox[\(\(\ \)\(Threshold\)\(\ \)\),
      "Subtitle"], "\[IndentingNewLine]", "Null"}], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(Risk\\)\\\" is similar to existing symbol \\\
\"\\!\\(Disk\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(Exact\ Properties\ Risk\)], "Output"],

Cell[BoxData[
    \(Threshold\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(lambda[sig_, k_] := \((2\ sig)\)\ Sqrt[2\ k\  - \ 1];\)\)], "Input"],

Cell[BoxData[
    \(\[IndentingNewLine]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(Threshold\)\(\ \)\(for\)\(\ \)\(different\)\(\ \)\(k'\) \
\(s\)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(for\\)\\\" is similar to existing symbol \
\\\"\\!\\(For\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(different\ for\ s\ Threshold\ \((0 &)\)\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      StyleBox["\[IndentingNewLine]",
        "Subtitle"], \(Plot[lambda[2, k], {k, 1/2, 1}, \ 
        PlotRange\  \[Rule] \ All, \ AxesLabel\  \[Rule] \ {k, \[Lambda]}, \ 
        PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \[IndentingNewLine]\ 
        DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
-0.928572 1.90476 0.0145949 0.147181 [
[.02381 .00209 -9.125 -15.75 ]
[.02381 .00209 9.125 0 ]
[.21429 .00209 -9.125 -15.75 ]
[.21429 .00209 9.125 0 ]
[.40476 .00209 -9.125 -15.75 ]
[.40476 .00209 9.125 0 ]
[.59524 .00209 -9.125 -15.75 ]
[.59524 .00209 9.125 0 ]
[.78571 .00209 -9.125 -15.75 ]
[.78571 .00209 9.125 0 ]
[1.025 .01459 0 -7.875 ]
[1.025 .01459 23.9375 7.875 ]
[.96369 .16178 -9.6875 -7.875 ]
[.96369 .16178 0 7.875 ]
[.96369 .30896 -9.6875 -7.875 ]
[.96369 .30896 0 7.875 ]
[.96369 .45614 -9.6875 -7.875 ]
[.96369 .45614 0 7.875 ]
[.96369 .60332 -9.6875 -7.875 ]
[.96369 .60332 0 7.875 ]
[.97619 .64303 -5.09375 0 ]
[.97619 .64303 5.09375 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01459 m
.02381 .02084 L
s
gsave
.02381 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.21429 .01459 m
.21429 .02084 L
s
gsave
.21429 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.6) show
1.000 setlinewidth
grestore
.40476 .01459 m
.40476 .02084 L
s
gsave
.40476 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.7) show
1.000 setlinewidth
grestore
.59524 .01459 m
.59524 .02084 L
s
gsave
.59524 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.8) show
1.000 setlinewidth
grestore
.78571 .01459 m
.78571 .02084 L
s
gsave
.78571 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.9) show
1.000 setlinewidth
grestore
.125 Mabswid
.0619 .01459 m
.0619 .01834 L
s
.1 .01459 m
.1 .01834 L
s
.1381 .01459 m
.1381 .01834 L
s
.17619 .01459 m
.17619 .01834 L
s
.25238 .01459 m
.25238 .01834 L
s
.29048 .01459 m
.29048 .01834 L
s
.32857 .01459 m
.32857 .01834 L
s
.36667 .01459 m
.36667 .01834 L
s
.44286 .01459 m
.44286 .01834 L
s
.48095 .01459 m
.48095 .01834 L
s
.51905 .01459 m
.51905 .01834 L
s
.55714 .01459 m
.55714 .01834 L
s
.63333 .01459 m
.63333 .01834 L
s
.67143 .01459 m
.67143 .01834 L
s
.70952 .01459 m
.70952 .01834 L
s
.74762 .01459 m
.74762 .01834 L
s
.82381 .01459 m
.82381 .01834 L
s
.8619 .01459 m
.8619 .01834 L
s
.9 .01459 m
.9 .01834 L
s
.9381 .01459 m
.9381 .01834 L
s
.25 Mabswid
0 .01459 m
1 .01459 L
s
gsave
1.025 .01459 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.61) show
1.000 setlinewidth
grestore
.97619 .16178 m
.98244 .16178 L
s
gsave
.96369 .16178 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.97619 .30896 m
.98244 .30896 L
s
gsave
.96369 .30896 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.97619 .45614 m
.98244 .45614 L
s
gsave
.96369 .45614 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.97619 .60332 m
.98244 .60332 L
s
gsave
.96369 .60332 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.97619 .04403 m
.97994 .04403 L
s
.97619 .07347 m
.97994 .07347 L
s
.97619 .1029 m
.97994 .1029 L
s
.97619 .13234 m
.97994 .13234 L
s
.97619 .19121 m
.97994 .19121 L
s
.97619 .22065 m
.97994 .22065 L
s
.97619 .25008 m
.97994 .25008 L
s
.97619 .27952 m
.97994 .27952 L
s
.97619 .33839 m
.97994 .33839 L
s
.97619 .36783 m
.97994 .36783 L
s
.97619 .39727 m
.97994 .39727 L
s
.97619 .4267 m
.97994 .4267 L
s
.97619 .48557 m
.97994 .48557 L
s
.97619 .51501 m
.97994 .51501 L
s
.97619 .54445 m
.97994 .54445 L
s
.97619 .57388 m
.97994 .57388 L
s
.25 Mabswid
.97619 0 m
.97619 .61803 L
s
gsave
.97619 .64303 -66.0938 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(l) show
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.02499 .03528 L
.02605 .04318 L
.02846 .05572 L
.03279 .07175 L
.03784 .08605 L
.04262 .09733 L
.06244 .13317 L
.08265 .16093 L
.10458 .18604 L
.14545 .22499 L
.1848 .25664 L
.22263 .28359 L
.26292 .30958 L
.30169 .3326 L
.34292 .35538 L
.38262 .37596 L
.42082 .3947 L
.46146 .41369 L
.50059 .43114 L
.54217 .44893 L
.58224 .4654 L
.62079 .4807 L
.6618 .49644 L
.70128 .51113 L
.73925 .52486 L
.77968 .53908 L
.81859 .55241 L
.85995 .56622 L
.89979 .57921 L
.93812 .59143 L
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`004@3oool300000080oooo00@0
00000?ooo`3oool0oooo0`00000O0?ooo`<000000P3oool010000000oooo0?ooo`3oool3000001l0
oooo0`0000020?ooo`030000003oool0oooo02@0oooo0`0000020?ooo`040000003oool0oooo0?oo
o`<000007`3oool300000080oooo00@000000?ooo`3oool0oooo0P00001G0?ooo`00403oool20000
00030?ooo`000000oooo00@0oooo00@000000?ooo`3oool000007P3oool2000000030?ooo`000000
oooo00@0oooo0P0000000`3oool000000?ooo`0M0?ooo`80000000<0oooo0000003oool01P3oool0
0`000000oooo0?ooo`0N0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`02
000001d0oooo0P0000000`3oool000000?ooo`040?ooo`040000003oool0oooo000005H0oooo000@
0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000001d0oooo00<00000
0?ooo`3oool00P0000040?ooo`030000003oool0oooo008000007@3oool00`000000oooo0?ooo`02
000000H0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`02000000@0oooo00D00000
0?ooo`3oool0oooo0000000M0?ooo`030000003oool0oooo00800000103oool2000000030?ooo`00
0000000005D0oooo000@0?ooo`030000003oool0oooo00800000203oool00`000000oooo0?ooo`0K
0?ooo`030000003oool0oooo00800000103oool01@000000oooo0?ooo`3oool0000001d0oooo00<0
00000?ooo`3oool00P0000060?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool00P00
00040?ooo`050000003oool0oooo0?ooo`0000007@3oool00`000000oooo0?ooo`02000000L0oooo
0P00001E0?ooo`00403oool01@000000oooo0?ooo`3oool0000000L0oooo0P00000M0?ooo`050000
003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`02000001d0oooo00D000000?ooo`3o
ool0oooo000000060?ooo`030000003oool0oooo01h0oooo00D000000?ooo`3oool0oooo00000004
0?ooo`030000003oool0oooo008000007@3oool01@000000oooo0?ooo`3oool0000000D0oooo1000
001E0?ooo`00403oool01@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3oool00000
7P3oool01@000000oooo0?ooo`3oool0000000@0oooo0P0000000`3oool000000?ooo`0M0?ooo`05
0000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`0M0?ooo`050000003oool0oooo
0?ooo`0000001@3oool3000001h0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003o
ool0oooo00800000E@3oool00100oooo00<000000?ooo`3oool00P0000040?ooo`@000007P3oool0
0`000000oooo0?ooo`02000000@0oooo00<000000?ooo`0000007`3oool00`000000oooo0?ooo`02
000000L0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`02000000@0oooo0P000000
0`3oool000000?ooo`0M0?ooo`030000003oool0oooo00800000103oool01@000000oooo0?ooo`3o
ool0000005D0oooo000@0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo00800000103oool010000000oooo0?ooo`00000N0?ooo`030000003o
ool0oooo00800000103oool01@000000oooo0?ooo`3oool0000001h0oooo00<000000?ooo`3oool0
0P0000040?ooo`030000003oool0oooo008000007@3oool00`000000oooo0?ooo`02000000@0oooo
00<000000?ooo`3oool00P00001E0?ooo`00403oool2000000030?ooo`000000oooo00@0oooo00<0
00000?ooo`3oool07`3oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`0000007P3o
ool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`0000000P00000N0?ooo`80000000<0
oooo0000003oool0103oool2000000030?ooo`000000oooo01d0oooo0P0000000`3oool000000?oo
o`040?ooo`80000000<0oooo0000003oool0E@3oool00140oooo0`0000050?ooo`<00000803oool3
000000H0oooo0`00000O0?ooo`<000001@3oool200000080oooo00<000000?ooo`3oool07@3oool3
000000H0oooo0`00000O0?ooo`<000001P3oool3000005H0oooo003m0?ooo`<000000P3oool01000
0000oooo0?ooo`3oool3000000<0oooo0P00000B0?ooo`00kP3oool00`000000oooo0?ooo`0;0?oo
o`80000000<0oooo0000003oool0103oool2000000030?ooo`000000oooo00<0oooo00<000000?oo
o`3oool0403oool00>h0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`02000000@0
oooo00<000000?ooo`3oool00P0000030?ooo`030000003oool0oooo0100oooo003^0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool00P0000040?ooo`050000003oool0oooo0?ooo`00
00000`3oool00`000000oooo0?ooo`0@0?ooo`004@3ooooT000000L0oooo00D000000?ooo`3oool0
oooo000000040?ooo`030000003oool0oooo008000000`3oool00`000000oooo0?ooo`0@0?ooo`00
5@3oool2000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool02`3oool01@000000oooo0?ooo`3oool0000000@0
oooo0P0000000`3oool000000?ooo`030?ooo`030000003oool0oooo0100oooo000E0?ooo`800000
:P3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0
:03oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0
0P0000040?ooo`030000003oool0000000D0oooo00<000000?ooo`3oool0403oool001D0oooo0P00
003G0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool00P0000040?ooo`040000003o
ool0oooo000000@0oooo00<000000?ooo`3oool0403oool001D0oooo0P00003G0?ooo`030000003o
ool0oooo00/0oooo0P0000000`3oool000000?ooo`050?ooo`030000003oool0000000<0oooo0P00
000B0?ooo`005P3oool00`000000oooo0?ooo`3E0?ooo`030000003oool0oooo00`0oooo0`000006
0?ooo`<00000103oool00`000000oooo0?ooo`0@0?ooo`005P3oool200000=H0oooo00<000000?oo
o`3oool0;`3oool001L0oooo00<000000?ooo`3oool0e03oool200000300oooo000F0?ooo`800000
eP3oool00`000000oooo0?ooo`0_0?ooo`005P3oool300000=D0oooo00<000000?ooo`3oool0;`3o
ool001L0oooo0P00003E0?ooo`030000003oool0oooo02l0oooo000G0?ooo`800000e@3oool00`00
0000oooo0?ooo`0_0?ooo`005`3oool200000=D0oooo00<000000?ooo`3oool0;`3oool001L0oooo
0`00003D0?ooo`030000003oool0oooo02l0oooo000H0?ooo`800000e03oool200000300oooo000H
0?ooo`800000e03oool00`000000oooo0?ooo`0_0?ooo`00603oool300000=<0oooo00<000000?oo
o`3oool0;`3oool001T0oooo0P00003C0?ooo`030000003oool0oooo02l0oooo000I0?ooo`800000
d`3oool00`000000oooo0?ooo`0_0?ooo`006P3oool00`000000oooo0?ooo`3A0?ooo`030000003o
ool0oooo02l0oooo000J0?ooo`800000dP3oool200000300oooo000K0?ooo`800000d@3oool00`00
0000oooo0?ooo`0_0?ooo`00703oool00`000000oooo0?ooo`3?0?ooo`030000003oool0oooo02l0
oooo000L0?ooo`800000d03oool00`000000oooo0?ooo`0_0?ooo`007@3oool00`000000oooo0?oo
o`3>0?ooo`030000003oool0oooo02l0oooo000M0?ooo`800000c`3oool00`000000oooo0?ooo`0_
0?ooo`007P3oool200000<h0oooo00<000000?ooo`3oool0;`3oool001l0oooo00<000000?ooo`3o
ool0c03oool200000300oooo000O0?ooo`800000c@3oool00`000000oooo0?ooo`0_0?ooo`00803o
ool200000<`0oooo00<000000?ooo`3oool0;`3oool00240oooo00<000000?ooo`3oool0`P3oool2
000000H0oooo00<000000?ooo`3oool0;`3oool00240oooo0P0000340?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool0;`3oool00280oooo0P0000330?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0;`3oool002<0oooo0P0000320?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool0;`3oool002<0oooo0`0000310?ooo`030000003oool0oooo00@0oooo0`00
000_0?ooo`00903oool200000<40oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0_
0?ooo`009@3oool200000<00oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0_0?oo
o`009@3oool300000;l0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0_0?ooo`00
9P3oool300000;d0oooo0P0000060?ooo`030000003oool0oooo02l0oooo000W0?ooo`<00000_@3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo02l0oooo000X0?ooo`<00000``3oool2
00000300oooo000Y0?ooo`<00000`P3oool00`000000oooo0?ooo`0_0?ooo`00:P3oool300000<40
oooo00<000000?ooo`3oool0;`3oool002/0oooo1000002o0?ooo`030000003oool0oooo02l0oooo
000/0?ooo`@00000_P3oool00`000000oooo0?ooo`0_0?ooo`00;P3oool300000;d0oooo00<00000
0?ooo`3oool0;`3oool002l0oooo0`00002l0?ooo`030000003oool0oooo02l0oooo000`0?ooo`<0
0000^`3oool200000300oooo000a0?ooo`<00000^P3oool00`000000oooo0?ooo`0_0?ooo`00<P3o
ool400000;P0oooo00<000000?ooo`3oool0;`3oool003<0oooo1000002g0?ooo`030000003oool0
oooo02l0oooo000e0?ooo`<00000]P3oool00`000000oooo0?ooo`0_0?ooo`00=P3oool300000;D0
oooo00<000000?ooo`3oool0;`3oool003L0oooo1000002c0?ooo`030000003oool0oooo02l0oooo
000h0?ooo`@00000/P3oool200000300oooo000j0?ooo`<00000/@3oool00`000000oooo0?ooo`0_
0?ooo`00>`3oool400000:l0oooo00<000000?ooo`3oool0;`3oool003`0oooo1000002^0?ooo`03
0000003oool0oooo02l0oooo000n0?ooo`<00000[@3oool00`000000oooo0?ooo`0_0?ooo`00?`3o
ool400000:/0oooo00<000000?ooo`3oool0;`3oool00400oooo1000002Z0?ooo`800000<03oool0
0480oooo0`00002Y0?ooo`030000003oool0oooo02l0oooo00130?ooo`@00000Y`3oool00`000000
oooo0?ooo`0_0?ooo`00A03oool4000009l0oooo0P0000050?ooo`030000003oool0oooo02l0oooo
00160?ooo`@00000V`3oool3000000030?ooo`000000oooo00<0oooo00<000000?ooo`3oool0;`3o
ool004L0oooo1000002J0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0;`3oool0
04T0oooo1000002H0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0;`3oool004X0
oooo1@00002G0?ooo`8000001P3oool3000002l0oooo001<0?ooo`D00000U`3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo02l0oooo001>0?ooo`@00000UP3oool2000000@0oooo00<0
00000?ooo`3oool0;`3oool00500oooo1000002A0?ooo`050000003oool0oooo0?ooo`000000103o
ool00`000000oooo0?ooo`0_0?ooo`00D@3oool5000008l0oooo00<000000?ooo`3oool00P000004
0?ooo`030000003oool0oooo02l0oooo001C0?ooo`D00000SP3oool3000000D0oooo00<000000?oo
o`3oool0;`3oool005D0oooo1@00002D0?ooo`030000003oool0oooo02l0oooo001G0?ooo`@00000
T`3oool200000300oooo001I0?ooo`@00000T@3oool00`000000oooo0?ooo`0_0?ooo`00FP3oool5
000008l0oooo00<000000?ooo`3oool0;`3oool005`0oooo1@00002=0?ooo`030000003oool0oooo
02l0oooo001N0?ooo`D00000R`3oool00`000000oooo0?ooo`0_0?ooo`00H03oool4000008X0oooo
00<000000?ooo`3oool0;`3oool00680oooo100000280?ooo`800000<03oool006<0oooo1@000026
0?ooo`030000003oool0oooo02l0oooo001U0?ooo`D00000Q03oool00`000000oooo0?ooo`0_0?oo
o`00I`3oool500000880oooo00<000000?ooo`3oool0;`3oool006T0oooo1P00001o0?ooo`030000
003oool0oooo02l0oooo001[0?ooo`H00000O@3oool00`000000oooo0?ooo`0_0?ooo`00KP3oool5
000007/0oooo00<000000?ooo`3oool0;`3oool00700oooo1@00001i0?ooo`800000<03oool00780
oooo1000001h0?ooo`030000003oool0oooo02l0oooo001d0?ooo`@00000MP3oool00`000000oooo
0?ooo`0_0?ooo`00M@3oool5000007@0oooo00<000000?ooo`3oool0;`3oool007L0oooo1@00001b
0?ooo`030000003oool0oooo02l0oooo001i0?ooo`D00000L03oool00`000000oooo0?ooo`0_0?oo
o`00N`3oool6000006d0oooo00<000000?ooo`3oool0;`3oool007d0oooo1P00001[0?ooo`800000
<03oool00800oooo1@00001Y0?ooo`030000003oool0oooo02l0oooo00220?ooo`H00000GP3oool3
000000D0oooo00<000000?ooo`3oool0;`3oool008@0oooo1P00001K0?ooo`030000003oool0oooo
00800000103oool00`000000oooo0?ooo`0_0?ooo`00Q`3oool6000005P0oooo00D000000?ooo`3o
ool0oooo000000040?ooo`030000003oool0oooo02l0oooo00290?ooo`L00000F@3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo02l0oooo002<0?ooo`L00000E@3oool00`000000oooo
0?ooo`030?ooo`<00000;`3oool008l0oooo1`00001A0?ooo`8000001@3oool00`000000oooo0?oo
o`0_0?ooo`00TP3oool600000500oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0_
0?ooo`00U@3oool5000004/0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo
02l0oooo002G0?ooo`D00000B@3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo
02l0oooo002I0?ooo`D00000B03oool3000000D0oooo00<000000?ooo`3oool0;`3oool009/0oooo
1P00001=0?ooo`030000003oool0oooo02l0oooo002M0?ooo`L00000BP3oool200000300oooo002Q
0?ooo`H00000A`3oool00`000000oooo0?ooo`0_0?ooo`00Y03oool6000004@0oooo00<000000?oo
o`3oool0;`3oool00:L0oooo1@0000120?ooo`030000003oool0oooo02l0oooo002Y0?ooo`H00000
?`3oool00`000000oooo0?ooo`0_0?ooo`00Z`3oool6000003d0oooo00<000000?ooo`3oool0;`3o
ool00:h0oooo1P00000j0?ooo`030000003oool0oooo02l0oooo002`0?ooo`H00000>03oool20000
0300oooo002c0?ooo`H00000=@3oool00`000000oooo0?ooo`0_0?ooo`00]@3oool700000380oooo
00<000000?ooo`3oool0;`3oool00;P0oooo1`00000_0?ooo`030000003oool0oooo02l0oooo002l
0?ooo`H00000;03oool00`000000oooo0?ooo`0_0?ooo`00_`3oool7000002P0oooo00<000000?oo
o`3oool0;`3oool00<80oooo1P00000V0?ooo`800000<03oool00<D0oooo1P00000S0?ooo`030000
003oool0oooo02l0oooo00370?ooo`L00000803oool00`000000oooo0?ooo`0_0?ooo`00bP3oool7
000001d0oooo00<000000?ooo`3oool0;`3oool00<h0oooo1P00000J0?ooo`030000003oool0oooo
02l0oooo003A0?ooo`L000005P3oool00`000000oooo0?ooo`0_0?ooo`00e03oool7000001<0oooo
00<000000?ooo`3oool0;`3oool00=L0oooo1`00000@0?ooo`800000<03oool00=X0oooo1`00000=
0?ooo`030000003oool0oooo02l0oooo003M0?ooo`H000002`3oool00`000000oooo0?ooo`0_0?oo
o`00h03oool6000000030?ooo`000000000000D0oooo00<000000?ooo`3oool0;`3oool00>80oooo
1`0000050?ooo`030000003oool0oooo02l0oooo003U0?ooo`L000000P3oool00`000000oooo0?oo
o`0_0?ooo`00i@3oool:00000340oooo003U0?ooo`040000003oool0000000000080oooo1P00000_
0?ooo`00iP3oool3000000D0oooo00<000000?ooo`3oool0;`3oool00>H0oooo0`0000050?ooo`03
0000003oool0oooo02l0oooo003W0?ooo`8000001@3oool00`000000oooo0?ooo`0_0?ooo`00i`3o
ool2000003L0oooo003X0?ooo`030000003oool0oooo03D0oooo003o0?ooob40oooo003o0?ooob40
oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40
oooo003o0?ooob40oooo003[0?ooo`040000003oool0oooo0?ooo`800000;`3oool00>/0oooo00@0
00000?ooo`3oool00000<@3oool00>`0oooo00<000000?ooo`000000<@3oool00>`0oooo00<00000
0?ooo`000000<@3oool00>d0oooo0P00000a0?ooo`00kP3oool00`000000oooo0?ooo`0_0?ooo`00
kP3oool00`000000oooo0?ooo`0_0?ooo`00k03oool200000380oooo003o0?ooob40oooo003o0?oo
ob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.447935, -0.556585, \
0.00231369, 0.0299429}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(\ \)\(\(Mode\)\(\ \)\(2\)\(\ \)\)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(2\ Mode\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(\(mode2[d_, sig_, 
          k_] := \((d\  + \ 
              Sign[d]\ \ \ Sqrt[d^2 - 4\ sig^2\ \((2\ k - 1)\)])\)/
          2;\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(k = 0.7; \ s2\  = \ 2^2; \ 
    Plot[\[IndentingNewLine]{Abs[
              th]^\((1 - 
                2\ k)\)\ Exp[\(-\((0.7 - \ 
                      th)\)^2\)/\((2\ s2)\)], \[IndentingNewLine]Abs[
              th]^\((1 - 
                2\ k)\)\ Exp[\(-\((3\  - \ 
                      th)\)^2\)/\((2\ s2)\)], \[IndentingNewLine]Abs[
              th]^\((1 - 
                2\ k)\)\ Exp[\(-\((4\  - \ 
                      th)\)^2\)/\((2\ s2)\)]\[IndentingNewLine]}, \ {th, \ \
\(-3\), \ 8}, \ \ PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \ 
      AxesLabel\  \[Rule] \ {\[Theta], \[Pi] \((\[Theta] | d)\)}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.28355 0.0865801 0.0147151 0.290429 [
[.11039 .00222 -9.03125 -15.75 ]
[.11039 .00222 9.03125 0 ]
[.45671 .00222 -4.84375 -15.75 ]
[.45671 .00222 4.84375 0 ]
[.62987 .00222 -4.84375 -15.75 ]
[.62987 .00222 4.84375 0 ]
[.80303 .00222 -4.84375 -15.75 ]
[.80303 .00222 4.84375 0 ]
[.97619 .00222 -4.84375 -15.75 ]
[.97619 .00222 4.84375 0 ]
[1.025 .01472 0 -7.875 ]
[1.025 .01472 9.4375 7.875 ]
[.27105 .15993 -18.25 -7.875 ]
[.27105 .15993 0 7.875 ]
[.27105 .30514 -9.6875 -7.875 ]
[.27105 .30514 0 7.875 ]
[.27105 .45036 -18.25 -7.875 ]
[.27105 .45036 0 7.875 ]
[.27105 .59557 -9.6875 -7.875 ]
[.27105 .59557 0 7.875 ]
[.28355 .64303 -19.5625 0 ]
[.28355 .64303 19.5625 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11039 .01472 m
.11039 .02097 L
s
gsave
.11039 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.45671 .01472 m
.45671 .02097 L
s
gsave
.45671 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.62987 .01472 m
.62987 .02097 L
s
gsave
.62987 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.80303 .01472 m
.80303 .02097 L
s
gsave
.80303 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.97619 .01472 m
.97619 .02097 L
s
gsave
.97619 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.15368 .01472 m
.15368 .01847 L
s
.19697 .01472 m
.19697 .01847 L
s
.24026 .01472 m
.24026 .01847 L
s
.32684 .01472 m
.32684 .01847 L
s
.37013 .01472 m
.37013 .01847 L
s
.41342 .01472 m
.41342 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.54329 .01472 m
.54329 .01847 L
s
.58658 .01472 m
.58658 .01847 L
s
.67316 .01472 m
.67316 .01847 L
s
.71645 .01472 m
.71645 .01847 L
s
.75974 .01472 m
.75974 .01847 L
s
.84632 .01472 m
.84632 .01847 L
s
.88961 .01472 m
.88961 .01847 L
s
.9329 .01472 m
.9329 .01847 L
s
.0671 .01472 m
.0671 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.28355 .15993 m
.2898 .15993 L
s
gsave
.27105 .15993 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.28355 .30514 m
.2898 .30514 L
s
gsave
.27105 .30514 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.28355 .45036 m
.2898 .45036 L
s
gsave
.27105 .45036 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.28355 .59557 m
.2898 .59557 L
s
gsave
.27105 .59557 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.125 Mabswid
.28355 .04376 m
.2873 .04376 L
s
.28355 .0728 m
.2873 .0728 L
s
.28355 .10184 m
.2873 .10184 L
s
.28355 .13089 m
.2873 .13089 L
s
.28355 .18897 m
.2873 .18897 L
s
.28355 .21802 m
.2873 .21802 L
s
.28355 .24706 m
.2873 .24706 L
s
.28355 .2761 m
.2873 .2761 L
s
.28355 .33419 m
.2873 .33419 L
s
.28355 .36323 m
.2873 .36323 L
s
.28355 .39227 m
.2873 .39227 L
s
.28355 .42132 m
.2873 .42132 L
s
.28355 .4794 m
.2873 .4794 L
s
.28355 .50844 m
.2873 .50844 L
s
.28355 .53749 m
.2873 .53749 L
s
.28355 .56653 m
.2873 .56653 L
s
.25 Mabswid
.28355 0 m
.28355 .61803 L
s
gsave
.28355 .64303 -80.5625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(p) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
71.563 15.750 moveto
(H) show
75.375 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
83.188 15.750 moveto
(\\310) show
88.313 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
%%BeginResource: font Roman-MISO
%%BeginFont: Roman-MISO
/Roman /Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Roman-MISO
%%IncludeFont: Roman-MISO
/Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
94.313 15.750 moveto
(L) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .04852 m
.04262 .05706 L
.06244 .06786 L
.10458 .09813 L
.14264 .13615 L
.16385 .16308 L
.18314 .19236 L
.20342 .23002 L
.22214 .27466 L
.23125 .30198 L
.24128 .33904 L
.25137 .38852 L
.25689 .42449 L
.26207 .468 L
.26703 .52491 L
.26984 .56831 L
s
.26984 .56831 m
.27231 .61803 L
s
.29624 .61803 m
.29829 .58406 L
.30084 .55089 L
.30584 .50239 L
.31038 .46999 L
.31563 .44092 L
.32058 .41888 L
.32939 .38789 L
.33895 .36178 L
.35882 .32076 L
.37987 .28717 L
.41775 .23739 L
.45809 .19141 L
.49692 .15192 L
.53819 .1154 L
.57796 .08626 L
.6162 .06406 L
.63756 .05407 L
.6569 .0464 L
.69608 .03443 L
.71536 .03006 L
.7362 .02627 L
.75618 .0234 L
.77725 .02106 L
.79693 .01938 L
.81528 .01819 L
.83567 .01718 L
.85424 .0165 L
.87336 .01598 L
.89414 .01557 L
.91395 .0153 L
.92395 .01519 L
.93497 .0151 L
.95436 .01497 L
.96525 .01492 L
.97523 .01488 L
.97619 .01488 L
s
.02381 .01679 m
.04262 .01767 L
.06244 .01894 L
.08255 .02073 L
.10458 .02349 L
.12415 .02687 L
.14509 .03182 L
.16639 .0388 L
.18653 .04795 L
.19623 .05355 L
.20651 .06063 L
.22495 .07737 L
.23436 .08886 L
.24448 .10481 L
.24938 .11448 L
.25404 .12541 L
.25854 .13819 L
.26278 .15315 L
.2652 .16347 L
.26781 .17676 L
.26998 .19014 L
.27237 .20839 L
.27496 .23497 L
.27637 .2544 L
.27769 .27777 L
.27893 .30711 L
.28006 .34496 L
.28136 .41714 L
.28259 .58058 L
s
.28259 .58058 m
.28263 .61803 L
s
.2847 .61803 m
.28481 .53279 L
.28602 .41413 L
.28716 .36125 L
.28823 .33015 L
.2892 .30958 L
.29027 .29232 L
.2914 .27813 L
.29254 .26656 L
.29377 .25648 L
.29597 .24242 L
.29859 .23021 L
.30098 .22187 L
.30582 .20993 L
.30827 .2056 L
.31096 .20176 L
.31325 .19908 L
.31571 .19668 L
.32016 .19337 L
.32283 .19187 L
.32574 .19058 L
.32848 .18963 L
.33103 .18894 L
.33355 .18843 L
.33584 .18809 L
.33711 .18794 L
.33848 .18782 L
.33977 .18773 L
.34096 .18767 L
.34223 .18764 L
.34343 .18762 L
.3445 .18763 L
.34567 .18765 L
.34695 .1877 L
.34759 .18772 L
.3483 .18776 L
.35072 .18793 L
.35298 .18813 L
.35542 .18841 L
.35982 .18901 L
.37061 .19097 L
.3805 .19315 L
.42017 .20266 L
.43047 .20482 L
.44018 .20661 L
.44963 .20807 L
.45833 .20913 L
.46283 .20957 L
.46777 .20996 L
.47273 .21024 L
Mistroke
.47545 .21035 L
.47798 .21042 L
.47928 .21045 L
.47997 .21046 L
.4807 .21047 L
.48133 .21048 L
.48203 .21048 L
.48327 .21049 L
.48447 .21048 L
.48576 .21047 L
.48698 .21045 L
.4881 .21043 L
.4894 .2104 L
.49062 .21036 L
.49338 .21025 L
.49607 .2101 L
.49895 .20991 L
.50427 .20945 L
.50917 .2089 L
.52027 .20724 L
.53005 .20527 L
.54041 .20268 L
.55996 .19642 L
.57827 .18905 L
.61706 .16937 L
.6583 .14435 L
.69803 .11885 L
.73625 .09526 L
.77691 .07299 L
.81606 .05533 L
.85766 .04094 L
.87855 .03533 L
.89775 .03104 L
.93632 .02456 L
.95516 .02228 L
.97583 .0203 L
.97619 .02027 L
Mfstroke
.02381 .01512 m
.03279 .01521 L
.04262 .01533 L
.06244 .01565 L
.07298 .01587 L
.08426 .01617 L
.10458 .0169 L
.1148 .01738 L
.12589 .01802 L
.13547 .01869 L
.14603 .01958 L
.16586 .0218 L
.17672 .02341 L
.18689 .02525 L
.19727 .02755 L
.20714 .03022 L
.22566 .03709 L
.23525 .04205 L
.24547 .04904 L
.25043 .05338 L
.25511 .0583 L
.25963 .06413 L
.26386 .07096 L
.26851 .08101 L
.27098 .08807 L
.27362 .09791 L
.27495 .10423 L
.27639 .11271 L
.27775 .12307 L
.27902 .13603 L
.28015 .15264 L
.2814 .18286 L
.28271 .26305 L
.28393 .35924 L
.28501 .21915 L
.28619 .17829 L
.28743 .15708 L
.28857 .14475 L
.28965 .13651 L
.29063 .13075 L
.29282 .12147 L
.29405 .1177 L
.29519 .11482 L
.29775 .10983 L
.30001 .10664 L
.30241 .1041 L
.30494 .10208 L
.30734 .10064 L
.30949 .09965 L
.31184 .09883 L
Mistroke
.31439 .09819 L
.31582 .09794 L
.3171 .09775 L
.31831 .09762 L
.31962 .09752 L
.32085 .09746 L
.32198 .09744 L
.32304 .09744 L
.32418 .09746 L
.32526 .0975 L
.32623 .09755 L
.32738 .09763 L
.32863 .09774 L
.33089 .098 L
.33578 .09875 L
.34029 .09967 L
.359 .10499 L
.37961 .11276 L
.41987 .13081 L
.45861 .14909 L
.4998 .1666 L
.52037 .17372 L
.53948 .179 L
.54898 .18107 L
.55794 .18267 L
.5629 .1834 L
.56827 .18405 L
.57279 .1845 L
.57764 .18488 L
.5802 .18503 L
.58254 .18514 L
.58367 .18518 L
.5849 .18522 L
.58605 .18525 L
.58713 .18527 L
.58837 .18529 L
.58904 .1853 L
.58975 .1853 L
.59046 .18531 L
.59121 .18531 L
.59184 .1853 L
.59254 .1853 L
.59379 .18528 L
.5945 .18527 L
.59514 .18526 L
.59755 .18519 L
.59886 .18515 L
.60025 .18509 L
.60274 .18495 L
.60838 .18454 L
Mistroke
.61325 .18406 L
.61861 .18339 L
.62875 .18173 L
.63803 .17979 L
.65892 .17398 L
.67792 .1671 L
.69864 .1581 L
.73931 .13711 L
.77846 .11478 L
.82006 .09131 L
.86015 .0709 L
.89872 .05443 L
.93974 .04077 L
.97619 .03182 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00<`3oool2000004T0oooo0P00
000U0?ooo`800000903oool3000002D0oooo0`00000Z0?ooo`00<@3oool3000000030?ooo`000000
oooo04D0oooo0`0000000`3oool000000?ooo`0S0?ooo`8000008`3oool2000000030?ooo`000000
oooo02<0oooo00<000000?ooo`3oool00P00000Y0?ooo`00<@3oool00`000000oooo0?ooo`180?oo
o`030000003oool0oooo02H0oooo0P00000S0?ooo`030000003oool0oooo008000008`3oool01@00
0000oooo0?ooo`3oool0000002T0oooo000a0?ooo`030000003oool0oooo04P0oooo00<000000?oo
o`3oool0903oool4000002<0oooo00D000000?ooo`3oool0oooo0000000S0?ooo`050000003oool0
oooo0?ooo`000000:@3oool002T0oooo1`0000020?ooo`800000B@3oool2000002@0oooo00@00000
0?ooo`00000000008`3oool00`000000oooo0?ooo`02000002<0oooo00<000000?ooo`3oool00P00
000Y0?ooo`00=03oool00`000000oooo0?ooo`180?ooo`030000003oool0oooo0280oooo0`00000S
0?ooo`80000000<0oooo0000003oool0903oool3000002X0oooo000d0?ooo`800000B@3oool20000
02<0oooo0`00000S0?ooo`030000003oool0000002D0oooo0P0000000`3oool000000?ooo`0Y0?oo
o`00<@3oool01@000000oooo0?ooo`3oool0000004H0oooo00D000000?ooo`3oool0oooo0000000T
0?ooo`8000008`3oool010000000oooo0?ooo`00000T0?ooo`030000003oool0oooo00800000:@3o
ool00340oooo00<000000?ooo`3oool00P0000160?ooo`030000003oool0oooo00800000903oool2
000002@0oooo00<000000?ooo`000000903oool2000000030?ooo`000000oooo02T0oooo000b0?oo
o`<00000B03oool3000002H0oooo00<000000?ooo`3oool08P3oool3000002D0oooo0`00000Z0?oo
o`00o`3ooolQ0?ooo`00EP3oool00`000000oooo0?ooo`2Y0?ooo`800000703oool005H0oooo00<0
00000?ooo`3oool0Z03oool010000000oooo0?ooo`00000K0?ooo`00EP3oool00`000000oooo0?oo
o`2X0?ooo`040000003oool0oooo000001/0oooo000F0?ooon@000001`3oool01@000000oooo0?oo
o`3oool0000001X0oooo000J0?ooob8000001`3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`040000003o
ool0oooo0?ooobl00000303oool5000001X0oooo000J0?ooobL000005@3oool00`000000oooo0?oo
o`0U0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool05@3ooolK000000h0oooo3`00
000=0?ooo`040000003oool0oooo000001X0oooo000Y0?ooo`h000001@3oool:00000100oooo00<0
00000?ooo`3oool0G`3oool>000001`0oooo3@00000C0?ooo`040000003oool0oooo000001X0oooo
000b0?ooo`P000001P3oool9000000d0oooo00<000000?ooo`3oool0F`3oool900000200oooo2@00
000:0?ooo`D000003P3oool3000001X0oooo000g0?ooo`H00000203oool7000000X0oooo00<00000
0?ooo`3oool0E`3oool800000240oooo2@0000090?ooo`X00000:`3oool003T0oooo1P00000:0?oo
o`@000002@3oool00`000000oooo0?ooo`1B0?ooo`T000008P3oool7000000/0oooo2000000`0?oo
o`006`3oool00`000000oooo0?ooo`0N0?ooo`D000002P3oool4000000L0oooo0P00001A0?ooo`L0
00008`3oool6000000`0oooo1`00000d0?ooo`006P3oool400000200oooo1P0000080?ooo`@00000
1P3oool00`000000oooo0?ooo`1>0?ooo`D000008`3oool7000000`0oooo1`00000g0?ooo`006`3o
ool6000001l0oooo1@0000090?ooo`<000001@3oool00`000000oooo0?ooo`1;0?ooo`H000008`3o
ool6000000d0oooo1P00000j0?ooo`007@3oool600000200oooo0`0000090?ooo`<00000103oool0
0`000000oooo0?ooo`190?ooo`H000008P3oool6000000d0oooo1P00000m0?ooo`00803oool50000
01l0oooo0`0000090?ooo`800000103oool00`000000oooo0?ooo`170?ooo`D000008`3oool60000
00d0oooo1P00000o0?ooo`008P3oool4000001l0oooo100000080?ooo`8000000`3oool00`000000
oooo0?ooo`150?ooo`D000008`3oool5000000h0oooo1@0000120?ooo`00903oool4000001h0oooo
100000080?ooo`040000003oool0oooo0?ooo`800000A@3oool4000002<0oooo1@00000>0?ooo`D0
0000A03oool002D0oooo1000000O0?ooo`800000203oool200000080oooo00<000000?ooo`3oool0
@P3oool4000002<0oooo1@00000>0?ooo`D00000AP3oool002L0oooo1000000N0?ooo`800000203o
ool010000000oooo0?ooo`0000120?ooo`D000008`3oool4000000l0oooo100000180?ooo`00:03o
ool4000001h0oooo0P0000060?ooo`8000000P3oool00`000000oooo0?ooo`0o0?ooo`@000008`3o
ool4000000l0oooo1000001:0?ooo`00:P3oool4000001d0oooo00<000000?ooo`3oool01@3oool0
10000000oooo0?ooo`00000o0?ooo`@000008`3oool5000000h0oooo1@00001;0?ooo`00:`3oool4
000001`0oooo0P0000060?ooo`80000000<0oooo0000003oool0?@3oool400000280oooo1@00000>
0?ooo`D00000C@3oool002d0oooo0`00000L0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`000000103oool;000002h0oooo0`00000S0?ooo`@000003P3oool5000004l0oooo000^0?ooo`<0
00006`3oool2000000H0oooo00@000000?ooo`00000000000P3oool>000002/0oooo0`00000R0?oo
o`@000003`3oool400000540oooo000_0?ooo`<000006`3oool2000000D0oooo0`0000020?ooo`@0
0000203oool7000002D0oooo1000000R0?ooo`@000003P3oool4000005<0oooo000`0?ooo`<00000
6P3oool3000000D0oooo0P0000020?ooo`800000303oool800000240oooo1000000Q0?ooo`@00000
3P3oool5000005@0oooo000a0?ooo`8000006`3oool2000000@0oooo0`000000103oool000000000
0000000A0?ooo`D000007P3oool300000280oooo1000000=0?ooo`D00000EP3oool00380oooo0P00
000K0?ooo`8000000`3oool6000001@0oooo1P00000J0?ooo`<000008@3oool4000000d0oooo1@00
001H0?ooo`00<P3oool3000001/0oooo00@000000?ooo`3oool0oooo1P00000F0?ooo`H000005`3o
ool300000240oooo1000000=0?ooo`@00000FP3oool003<0oooo0`00000J0?ooo`8000000P3oool5
000001X0oooo1@00000C0?ooo`@00000803oool4000000d0oooo1000001L0?ooo`00=03oool30000
01T0oooo0P0000020?ooo`D00000703oool500000100oooo1000000P0?ooo`@00000303oool50000
05d0oooo000e0?ooo`<00000603oool3000000030?ooo`000000000000<000007P3oool4000000h0
oooo0`00000P0?ooo`@00000303oool5000005l0oooo000f0?ooo`<00000303oool300000080oooo
00@000000?ooo`3oool0oooo1@0000020?ooo`@00000803oool4000000/0oooo0`00000P0?ooo`@0
00002`3oool500000640oooo000g0?ooo`8000002`3oool2000000030?ooo`000000oooo00@0oooo
00<000000?ooo`3oool00`0000020?ooo`<000008P3oool5000000P0oooo0`00000O0?ooo`@00000
303oool4000006<0oooo000h0?ooo`8000002P3oool00`000000oooo0?ooo`02000000@0oooo00<0
00000?ooo`3oool00`0000020?ooo`<00000903oool5000000D0oooo0`00000N0?ooo`D000002`3o
ool4000006D0oooo000h0?ooo`<000002@3oool00`000000oooo0?ooo`02000000P0oooo0P000002
0?ooo`<000009P3oool500000080oooo0`00000N0?ooo`@000002`3oool5000006H0oooo000i0?oo
o`<00000203oool01@000000oooo0?ooo`3oool0000000L0oooo0`0000020?ooo`@000009`3oool7
000001d0oooo1000000:0?ooo`H00000J03oool003X0oooo0`0000070?ooo`050000003oool0oooo
0?ooo`000000103oool00`000000oooo0?ooo`04000000040?ooo`0000000000000002X0oooo1P00
000J0?ooo`D000002@3oool6000006X0oooo000k0?ooo`<000001P3oool00`000000oooo0?ooo`02
000000@0oooo10000000103oool000000000003oool3000002X0oooo2P00000D0?ooo`D000001`3o
ool7000006d0oooo000l0?ooo`8000001P3oool00`000000oooo0?ooo`02000000@0oooo00<00000
0?ooo`3oool00P3oool2000000040?ooo`0000000000000002T0oooo0`0000030?ooo`T000003P3o
ool5000000H0oooo1`00001`0?ooo`00?@3oool2000000D0oooo0P0000000`3oool000000?ooo`04
0?ooo`030000003oool0oooo0080oooo0P000000103oool0000000000000000X0?ooo`<000002@3o
ool8000000T0oooo100000060?ooo`H00000L`3oool003d0oooo0`0000050?ooo`<000001@3oool3
00000080oooo0P000000103oool0000000000000000W0?ooo`<000003P3oool8000000<0oooo1000
00020?ooo`T00000MP3oool003h0oooo0`00000A0?ooo`80000000@0oooo00000000000000002@3o
ool6000001L0oooo0`00000B0?oooaD00000N03oool003l0oooo0P00000A0?ooo`H000001P3oool?
00000100oooo0`00000E0?ooo`d00000OP3oool00400oooo0P00000A0?ooo`D000001@3oool60000
0080oooo3000000;0?ooo`<00000503oool6000008L0oooo00110?ooo`030000003oool0oooo00l0
oooo1@0000040?ooo`@00000303oool9000000L0oooo0P00000C0?ooo`D00000RP3oool00440oooo
0P00000@0?ooo`D000000`3oool3000001<0oooo3000000?0?ooo`P00000S03oool00480oooo00<0
00000?ooo`3oool03P3oool500000080oooo1000000G0?ooo`d00000103oool<000008h0oooo0012
0?ooo`030000003oool0oooo00h0oooo1@0000020?ooo`8000007@3ooolD000009<0oooo00120?oo
o`8000003`3oool500000080oooo0P00000L0?ooo`<000001@3oool7000009T0oooo00130?ooo`03
0000003oool0oooo00d0oooo1@000000103oool0000000000000000K0?ooo`<00000YP3oool004<0
oooo0P00000>0?ooo`D0000000<0oooo000000000000703oool200000:L0oooo00140?ooo`800000
3@3oool5000000030?ooo`000000000001/0oooo0P00002X0?ooo`00A03oool2000000d0oooo1@00
00000`3oool000000000000J0?ooo`<00000Z03oool004@0oooo0P00000>0?ooo`@0000000<0oooo
0000000000006@3oool300000:T0oooo00140?ooo`<000003@3oool7000001P0oooo0`00002Z0?oo
o`00A@3oool2000000d0oooo1P00000I0?ooo`800000Z`3oool004D0oooo0`00000<0?ooo`H00000
603oool200000:`0oooo00160?ooo`800000303oool6000001L0oooo0`00002/0?ooo`00AP3oool2
000000`0oooo1P00000F0?ooo`<00000[@3oool004H0oooo0`00000;0?ooo`D000005P3oool30000
0:h0oooo00170?ooo`8000002`3oool5000001D0oooo0`00002_0?ooo`00A`3oool3000000X0oooo
1@00000E0?ooo`800000/03oool004P0oooo0P00000:0?ooo`D00000503oool200000;40oooo0018
0?ooo`8000002P3oool5000001<0oooo0`00002a0?ooo`00B03oool3000000<0oooo0P0000040?oo
o`D000004`3oool200000;80oooo00190?ooo`800000103oool00`000000oooo0?ooo`020?ooo`D0
00004P3oool200000;<0oooo00190?ooo`800000103oool00`000000oooo0?ooo`020?ooo`D00000
4@3oool200000;@0oooo00190?ooo`<000000`3oool00`000000oooo0?ooo`020?ooo`D000004@3o
ool00`000000oooo0?ooo`2c0?ooo`00BP3oool2000000<0oooo00<000000?ooo`3oool00P3oool5
00000100oooo0P00002e0?ooo`00BP3oool2000000<0oooo00<000000?ooo`3oool00P3oool50000
0100oooo00<000000?ooo`3oool0]03oool004X0oooo0`0000020?ooo`030000003oool0oooo00<0
oooo1000000?0?ooo`800000]P3oool004/0oooo0P0000020?ooo`030000003oool0oooo00<0oooo
1000000>0?ooo`800000]`3oool004/0oooo0P0000000`3oool00000000000050?ooo`@000003P3o
ool00`000000oooo0?ooo`2f0?ooo`00B`3oool3000000030?ooo`000000oooo00@0oooo1000000=
0?ooo`800000^03oool004`0oooo0P0000070?ooo`<000003P3oool00`000000oooo0?ooo`2g0?oo
o`00C03oool2000000L0oooo0`00000=0?ooo`800000^@3oool004`0oooo0P0000070?ooo`<00000
3@3oool00`000000oooo0?ooo`2h0?ooo`00C@3oool2000000H0oooo0`00000=0?ooo`030000003o
ool0oooo0;P0oooo001=0?ooo`8000001P3oool3000000`0oooo0P00002j0?ooo`00C@3oool20000
00H0oooo0`00000<0?ooo`030000003oool0oooo0;T0oooo001=0?ooo`8000001P3oool3000000/0
oooo0P00002k0?ooo`00C@3oool2000000H0oooo0`00000;0?ooo`030000003oool0oooo0;X0oooo
001>0?ooo`8000001@3oool3000000X0oooo0P00002l0?ooo`00CP3oool2000000D0oooo0`00000:
0?ooo`800000_03oool004h0oooo0P0000050?ooo`<000002@3oool300000;`0oooo001>0?ooo`80
00001@3oool3000000T0oooo0P00002m0?ooo`00CP3oool2000000D0oooo0`0000090?ooo`800000
_@3oool004h0oooo0P0000050?ooo`<00000203oool300000;d0oooo001?0?ooo`800000103oool3
000000P0oooo0P00002n0?ooo`00C`3oool2000000@0oooo0`0000080?ooo`800000_P3oool004l0
oooo0P0000040?ooo`<000001`3oool300000;h0oooo001?0?ooo`800000103oool3000000L0oooo
0P00002o0?ooo`00C`3oool2000000@0oooo0`0000070?ooo`800000_`3oool004l0oooo0P000004
0?ooo`<000001`3oool200000;l0oooo001?0?ooo`800000103oool3000000H0oooo0`00002o0?oo
o`00C`3oool2000000@0oooo0`0000060?ooo`800000`03oool00500oooo0P0000030?ooo`<00000
1P3oool200000<00oooo00150?ooo`8000000`3oool010000000oooo0?ooo`3oool4000000<0oooo
0`0000060?ooo`800000`03oool004H0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`02000000<0oooo0`0000060?ooo`800000`03oool004H0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`02000000<0oooo0`0000050?ooo`800000`@3oool004H0oooo00<000000?oo
o`3oool01`3oool2000000<0oooo0`0000050?ooo`800000`@3oool004H0oooo00<000000?ooo`3o
ool01`3oool2000000<0oooo100000040?ooo`800000`@3oool004H0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`02000000<0oooo0`0000040?ooo`<00000`@3oool004H0oooo00<0
00000?ooo`3oool0103oool5000000<0oooo0`0000040?ooo`800000`P3oool004H0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`02000000<0oooo0`0000040?ooo`800000`P3oool0
04D0oooo0P0000060?ooo`030000003oool0oooo008000000`3oool3000000<0oooo0`0000320?oo
o`00AP3oool00`000000oooo0?ooo`040?ooo`<0000000<0oooo0000000000000P3oool3000000<0
oooo0P0000330?ooo`00D@3oool200000080oooo0`0000030?ooo`800000``3oool00540oooo0P00
00020?ooo`<000000`3oool200000<<0oooo001A0?ooo`8000000P3oool3000000<0oooo0P000033
0?ooo`00D@3oool200000080oooo0`0000030?ooo`800000``3oool00540oooo0P0000020?ooo`<0
00000`3oool200000<<0oooo001B0?ooo`80000000@0oooo00000000000000000`3oool200000<<0
oooo001B0?ooo`80000000@0oooo00000000000000000P3oool200000<@0oooo001B0?ooo`800000
00@0oooo00000000000000000P3oool200000<@0oooo001B0?ooo`80000000@0oooo000000000000
00000P3oool200000<@0oooo001B0?ooo`80000000@0oooo00000000000000000P3oool200000<@0
oooo001B0?ooo`80000000@0oooo00000000000000000P3oool200000<@0oooo001B0?ooo`800000
00@0oooo00000000000000000P3oool200000<@0oooo001B0?ooo`80000000@0oooo000000000000
00000P3oool200000<@0oooo001B0?ooo`80000000@0oooo00000000000000000P3oool200000<@0
oooo001B0?ooo`80000000@0oooo00000000000000000P3oool200000<@0oooo001B0?ooo`800000
00@0oooo00000000000000000P3oool200000<@0oooo001B0?ooo`80000000@0oooo000000000000
00000P3oool200000<@0oooo001B0?ooo`80000000D0oooo00000000000000000?ooo`0200000<D0
oooo001B0?ooo`80000000D0oooo00000000000000000?ooo`0200000<D0oooo001B0?ooo`800000
00D0oooo00000000000000000?ooo`0200000<D0oooo001B0?ooo`80000000D0oooo000000000000
00000?ooo`0200000<D0oooo001B0?ooo`H0000000<0oooo000000000000a@3oool00580oooo1P00
00000`3oool00000000000350?ooo`00C`3oool200000080oooo1@0000000`3oool0000000000035
0?ooo`00C@3oool3000000030?ooo`000000oooo00D0000000<0oooo000000000000a@3oool004d0
oooo00<000000?ooo`3oool00`3oool5000000030?ooo`00000000000<D0oooo001=0?ooo`030000
003oool0oooo00<0oooo1@0000000`3oool00000000000350?ooo`00CP3oool2000000<0oooo2000
00350?ooo`00D03oool00`000000oooo0?ooo`05000000030?ooo`00000000000<D0oooo001@0?oo
o`80000000<0oooo0000000000000`0000000`3oool00000000000350?ooo`00C@3oool01P000000
oooo0?ooo`3oool000000?ooo`D0000000<0oooo000000000000a@3oool004d0oooo00<000000?oo
o`3oool00P0000000`3oool0000000000003000000030?ooo`00000000000<D0oooo001>0?ooo`<0
00000P3oool700000<H0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?oo
ob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo001@0?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2i0?oo
o`00C`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool0^03oool004D0oooo00<000000?ooo`3oool00P0000040?ooo`040000003oool0oooo0?ooo`80
00001P3oool00`000000oooo0?ooo`030?ooo`@000000P3oool00`000000oooo0?ooo`2g0?ooo`00
AP3oool00`000000oooo000000050?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`0000000P3oool00`00
0000oooo0?ooo`2g0?ooo`00AP3oool00`000000oooo000000050?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`2g0?ooo`00A`3oool00`000000oooo000000040?oo
o`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`2g0?ooo`00A@3oool0
1@000000oooo0000003oool0000000@0oooo00<000000?ooo`3oool01@0000040?ooo`030000003o
ool0oooo0080oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0;L0oooo
00160?ooo`D000000`3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo008000000P3oool00`000000oooo
0?ooo`2g0?ooo`00CP3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`030?ooo`80000000D0oooo0000003oool0oooo0000002i0?ooo`00
C`3oool010000000oooo0?ooo`3oool3000000@0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0000002j0?ooo`00D03oool00`000000oooo0?ooo`0@0?ooo`800000^`3oool00?l0oooo8@3o
ool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-4.41831, -0.281979, \
0.0508908, 0.0151711}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
        False,
        Editable->False], "\[IndentingNewLine]"}]], "Input"],

Cell[BoxData[
    RowBox[{\(Syntax::"noinfo"\), \(\(:\)\(\ \)\), "\<\"Input expression \
contains insufficient information to interpret result. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Syntax::noinfo\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(k = \(-0.75\); \ s2\  = \ 2^2; \ 
    Plot[\[IndentingNewLine]{Abs[
              th]^\((1 - 
                2\ k)\)\ Exp[\(-\((\(-2\)\  - \ 
                      th)\)^2\)/\((2\ s2)\)], \[IndentingNewLine]Abs[
              th]^\((1 - 
                2\ k)\)\ Exp[\(-\((\(-3\)\  - \ 
                      th)\)^2\)/\((2\ s2)\)], \[IndentingNewLine]Abs[
              th]^\((1 - 
                2\ k)\)\ Exp[\(-\((\(-4\)\  - \ 
                      th)\)^2\)/\((2\ s2)\)]\[IndentingNewLine]}, \ {th, \ \
\(-8\), \ 3}, \ \ PlotStyle\  \[Rule] \ {{Thickness[
              0.01]}}, \ \ AxesLabel\  \[Rule] \ {\[Theta], \[Pi] \((\[Theta] \
| d)\)}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\(\[IndentingNewLine]\)
    \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.71645 0.0865801 0.0147151 0.0108868 [
[.02381 .00222 -9.03125 -15.75 ]
[.02381 .00222 9.03125 0 ]
[.19697 .00222 -9.03125 -15.75 ]
[.19697 .00222 9.03125 0 ]
[.37013 .00222 -9.03125 -15.75 ]
[.37013 .00222 9.03125 0 ]
[.54329 .00222 -9.03125 -15.75 ]
[.54329 .00222 9.03125 0 ]
[.88961 .00222 -4.84375 -15.75 ]
[.88961 .00222 4.84375 0 ]
[1.025 .01472 0 -7.875 ]
[1.025 .01472 9.4375 7.875 ]
[.70395 .12358 -15.375 -7.875 ]
[.70395 .12358 0 7.875 ]
[.70395 .23245 -15.375 -7.875 ]
[.70395 .23245 0 7.875 ]
[.70395 .34132 -15.375 -7.875 ]
[.70395 .34132 0 7.875 ]
[.70395 .45019 -15.375 -7.875 ]
[.70395 .45019 0 7.875 ]
[.70395 .55906 -15.375 -7.875 ]
[.70395 .55906 0 7.875 ]
[.71645 .64303 -19.5625 0 ]
[.71645 .64303 19.5625 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01472 m
.02381 .02097 L
s
gsave
.02381 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.19697 .01472 m
.19697 .02097 L
s
gsave
.19697 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.37013 .01472 m
.37013 .02097 L
s
gsave
.37013 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.54329 .01472 m
.54329 .02097 L
s
gsave
.54329 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.88961 .01472 m
.88961 .02097 L
s
gsave
.88961 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.125 Mabswid
.0671 .01472 m
.0671 .01847 L
s
.11039 .01472 m
.11039 .01847 L
s
.15368 .01472 m
.15368 .01847 L
s
.24026 .01472 m
.24026 .01847 L
s
.28355 .01472 m
.28355 .01847 L
s
.32684 .01472 m
.32684 .01847 L
s
.41342 .01472 m
.41342 .01847 L
s
.45671 .01472 m
.45671 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.58658 .01472 m
.58658 .01847 L
s
.62987 .01472 m
.62987 .01847 L
s
.67316 .01472 m
.67316 .01847 L
s
.75974 .01472 m
.75974 .01847 L
s
.80303 .01472 m
.80303 .01847 L
s
.84632 .01472 m
.84632 .01847 L
s
.9329 .01472 m
.9329 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.71645 .12358 m
.7227 .12358 L
s
gsave
.70395 .12358 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.71645 .23245 m
.7227 .23245 L
s
gsave
.70395 .23245 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
1.000 setlinewidth
grestore
.71645 .34132 m
.7227 .34132 L
s
gsave
.70395 .34132 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(30) show
1.000 setlinewidth
grestore
.71645 .45019 m
.7227 .45019 L
s
gsave
.70395 .45019 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(40) show
1.000 setlinewidth
grestore
.71645 .55906 m
.7227 .55906 L
s
gsave
.70395 .55906 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(50) show
1.000 setlinewidth
grestore
.125 Mabswid
.71645 .03649 m
.7202 .03649 L
s
.71645 .05826 m
.7202 .05826 L
s
.71645 .08004 m
.7202 .08004 L
s
.71645 .10181 m
.7202 .10181 L
s
.71645 .14536 m
.7202 .14536 L
s
.71645 .16713 m
.7202 .16713 L
s
.71645 .1889 m
.7202 .1889 L
s
.71645 .21068 m
.7202 .21068 L
s
.71645 .25423 m
.7202 .25423 L
s
.71645 .276 m
.7202 .276 L
s
.71645 .29777 m
.7202 .29777 L
s
.71645 .31955 m
.7202 .31955 L
s
.71645 .36309 m
.7202 .36309 L
s
.71645 .38487 m
.7202 .38487 L
s
.71645 .40664 m
.7202 .40664 L
s
.71645 .42842 m
.7202 .42842 L
s
.71645 .47196 m
.7202 .47196 L
s
.71645 .49374 m
.7202 .49374 L
s
.71645 .51551 m
.7202 .51551 L
s
.71645 .53728 m
.7202 .53728 L
s
.71645 .58083 m
.7202 .58083 L
s
.71645 .6026 m
.7202 .6026 L
s
.25 Mabswid
.71645 0 m
.71645 .61803 L
s
gsave
.71645 .64303 -80.5625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(p) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
71.563 15.750 moveto
(H) show
75.375 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
83.188 15.750 moveto
(\\310) show
88.313 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
%%BeginResource: font Roman-MISO
%%BeginFont: Roman-MISO
/Roman /Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Roman-MISO
%%IncludeFont: Roman-MISO
/Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
94.313 15.750 moveto
(L) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .03661 m
.04262 .04286 L
.06244 .05085 L
.10458 .07308 L
.14264 .09939 L
.18314 .1326 L
.22214 .16657 L
.26358 .19951 L
.28435 .21275 L
.29347 .21757 L
.30351 .22206 L
.31314 .22551 L
.32216 .22791 L
.32713 .22888 L
.33168 .22953 L
.33419 .2298 L
.33552 .22992 L
.33693 .23002 L
.33829 .23009 L
.33952 .23014 L
.34076 .23018 L
.34193 .2302 L
.34309 .2302 L
.34433 .23019 L
.34551 .23016 L
.34658 .23012 L
.34784 .23006 L
.34921 .22997 L
.35169 .22975 L
.35429 .22946 L
.35705 .22906 L
.36201 .22813 L
.37079 .22582 L
.38048 .22228 L
.39982 .21226 L
.42068 .19747 L
.46182 .15928 L
.50145 .11747 L
.53955 .07966 L
.5608 .06165 L
.58011 .04783 L
.60043 .03615 L
.61916 .02795 L
.63834 .02195 L
.64845 .01967 L
.65914 .01782 L
.66858 .01662 L
.67388 .0161 L
.67872 .01572 L
.68321 .01543 L
Mistroke
.68811 .01519 L
.69274 .01501 L
.69703 .01489 L
.69968 .01483 L
.70212 .01479 L
.7048 .01476 L
.70615 .01475 L
.70762 .01474 L
.70893 .01473 L
.71012 .01473 L
.71077 .01472 L
.71149 .01472 L
.71278 .01472 L
.71399 .01472 L
.71528 .01472 L
.71638 .01472 L
.71759 .01472 L
.71877 .01472 L
.72001 .01472 L
.72106 .01472 L
.72222 .01472 L
.72347 .01473 L
.7248 .01473 L
.7272 .01475 L
.72963 .01477 L
.73192 .0148 L
.73621 .01486 L
.74086 .01495 L
.74596 .01509 L
.75626 .01545 L
.76581 .01589 L
.77473 .01637 L
.81361 .01901 L
.83339 .02039 L
.85493 .02169 L
.86495 .02219 L
.87561 .02262 L
.8847 .02292 L
.89475 .02316 L
.89965 .02325 L
.90233 .02328 L
.90482 .02331 L
.90714 .02333 L
.90924 .02335 L
.91157 .02336 L
.91286 .02337 L
.91407 .02337 L
.91527 .02337 L
.91596 .02337 L
.9166 .02337 L
Mistroke
.91789 .02337 L
.91861 .02337 L
.91927 .02337 L
.92045 .02337 L
.92173 .02337 L
.92294 .02336 L
.92407 .02335 L
.92683 .02334 L
.92932 .02331 L
.93492 .02325 L
.9398 .02317 L
.94495 .02308 L
.95418 .02286 L
.975 .02221 L
.97619 .02217 L
Mfstroke
.02381 .1013 m
.06244 .14253 L
.10458 .19754 L
.14415 .25456 L
.18221 .30781 L
.20342 .33394 L
.22272 .354 L
.23233 .36236 L
.24276 .37001 L
.25261 .37579 L
.26171 .3798 L
.26637 .38133 L
.26894 .38202 L
.27138 .38258 L
.27364 .383 L
.27611 .38337 L
.27719 .3835 L
.27835 .38361 L
.27936 .38369 L
.28044 .38376 L
.2811 .38379 L
.28183 .38382 L
.28311 .38384 L
.28383 .38384 L
.28461 .38384 L
.28534 .38382 L
.28601 .38379 L
.2873 .38372 L
.28803 .38367 L
.2887 .38362 L
.29125 .38333 L
.29351 .38299 L
.29601 .3825 L
.30106 .38119 L
.30598 .37949 L
.31115 .37725 L
.32041 .37213 L
.33037 .36503 L
.34126 .35548 L
.38182 .30588 L
.42087 .24419 L
.46237 .17525 L
.50235 .11583 L
.54082 .07142 L
.56069 .05418 L
.58173 .04005 L
.60131 .03038 L
.61962 .02397 L
.63003 .02128 L
.63991 .01929 L
Mistroke
.64878 .01789 L
.65845 .01674 L
.66378 .01625 L
.66879 .01587 L
.67335 .01559 L
.67816 .01534 L
.68342 .01513 L
.68825 .01498 L
.69344 .01487 L
.69639 .01482 L
.69914 .01479 L
.70175 .01476 L
.70417 .01474 L
.70681 .01473 L
.70815 .01473 L
.70962 .01472 L
.71091 .01472 L
.71209 .01472 L
.71338 .01472 L
.71403 .01472 L
.71474 .01472 L
.71594 .01472 L
.71723 .01472 L
.71844 .01472 L
.71954 .01472 L
.7207 .01472 L
.72193 .01472 L
.72297 .01472 L
.72413 .01472 L
.72669 .01473 L
.72909 .01474 L
.73344 .01477 L
.7381 .01481 L
.74338 .01486 L
.74826 .01493 L
.75932 .01512 L
.77943 .01558 L
.79966 .0161 L
.81867 .01657 L
.83703 .01695 L
.84705 .01711 L
.85639 .01723 L
.86601 .01733 L
.8711 .01736 L
.87371 .01738 L
.87654 .01739 L
.87913 .0174 L
.88152 .01741 L
.88381 .01742 L
.88496 .01742 L
Mistroke
.88623 .01742 L
.88738 .01742 L
.88842 .01742 L
.88963 .01742 L
.89078 .01742 L
.89184 .01742 L
.89282 .01742 L
.89389 .01742 L
.89504 .01742 L
.89765 .01741 L
.9004 .0174 L
.90534 .01738 L
.91064 .01736 L
.91647 .01732 L
.93664 .01713 L
.97619 .0166 L
Mfstroke
.02381 .28142 m
.06244 .36685 L
.10458 .4607 L
.12507 .50236 L
.14415 .53662 L
.16371 .56564 L
.18221 .58613 L
.192 .59391 L
.19752 .5973 L
.20262 .59977 L
.20692 .60136 L
.20936 .60205 L
.21164 .60256 L
.21287 .60279 L
.21405 .60296 L
.21511 .60309 L
.21625 .6032 L
.21748 .60327 L
.21862 .60331 L
.21931 .60332 L
.21997 .60331 L
.2212 .60327 L
.22236 .6032 L
.22361 .60309 L
.22478 .60294 L
.22586 .60277 L
.22848 .60225 L
.23096 .60159 L
.2359 .5998 L
.24128 .59715 L
.25087 .5906 L
.25975 .58252 L
.27842 .55948 L
.29902 .52545 L
.33922 .43929 L
.37791 .34353 L
.41905 .24348 L
.45867 .16083 L
.49678 .10015 L
.51639 .07656 L
.53734 .05675 L
.55869 .04169 L
.56848 .03629 L
.57884 .03148 L
.58837 .02781 L
.59885 .0245 L
.60832 .02208 L
.61731 .02023 L
.62747 .01858 L
.63675 .01742 L
Mistroke
.64675 .01648 L
.65236 .01607 L
.65765 .01576 L
.66262 .01551 L
.66799 .0153 L
.67246 .01515 L
.67736 .01502 L
.68268 .01492 L
.68539 .01488 L
.68829 .01484 L
.69102 .01481 L
.69349 .01478 L
.6958 .01477 L
.69834 .01475 L
.70083 .01474 L
.70317 .01473 L
.70563 .01472 L
.70701 .01472 L
.70828 .01472 L
.70932 .01472 L
.71042 .01472 L
.71163 .01472 L
.71276 .01472 L
.71403 .01472 L
.71523 .01472 L
.7163 .01472 L
.71747 .01472 L
.71876 .01472 L
.71997 .01472 L
.72067 .01472 L
.7213 .01472 L
.72272 .01472 L
.72409 .01472 L
.72558 .01472 L
.72828 .01472 L
.73079 .01473 L
.73345 .01474 L
.73824 .01475 L
.7476 .01479 L
.75769 .01485 L
.77596 .01499 L
.79558 .01514 L
.80597 .01521 L
.81707 .01528 L
.8278 .01534 L
.83757 .01537 L
.84228 .01539 L
.84738 .0154 L
.85221 .01541 L
.85666 .01542 L
Mistroke
.8591 .01542 L
.86132 .01542 L
.86255 .01542 L
.8632 .01542 L
.86389 .01542 L
.86516 .01542 L
.86634 .01542 L
.86751 .01542 L
.86879 .01542 L
.86999 .01542 L
.87109 .01542 L
.87209 .01542 L
.87319 .01542 L
.8754 .01542 L
.87809 .01542 L
.88055 .01541 L
.88607 .01541 L
.89603 .01539 L
.90595 .01536 L
.91513 .01533 L
.93589 .01525 L
.97518 .01509 L
.97619 .01509 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{44, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`008@3oool3000002@0oooo0`00
000U0?ooo`8000009@3oool2000004T0oooo0P00000l0?ooo`00803oool00`000000oooo0?ooo`02
00000280oooo0P0000000`3oool000000?ooo`0T0?ooo`8000008`3oool3000000030?ooo`000000
oooo04D0oooo0`0000000`3oool000000?ooo`0j0?ooo`00803oool01@000000oooo0?ooo`3oool0
00000280oooo00<000000?ooo`3oool00P00000T0?ooo`8000008`3oool00`000000oooo0?ooo`18
0?ooo`030000003oool0oooo03d0oooo000P0?ooo`050000003oool0oooo0?ooo`0000008P3oool0
1@000000oooo0?ooo`3oool000000280oooo1000000S0?ooo`030000003oool0oooo04P0oooo00<0
00000?ooo`3oool0?@3oool001L0oooo1`0000020?ooo`030000003oool0oooo008000006P3oool7
000000040?ooo`000000oooo0?ooo`8000006P3oool7000000030?ooo`000000oooo008000006`3o
ool700000080oooo0P0000190?ooo`800000?@3oool00240oooo0`00000S0?ooo`80000000<0oooo
0000003oool08`3oool3000002H0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0j
0?ooo`00803oool2000000030?ooo`000000oooo0280oooo00<000000?ooo`0000009@3oool30000
02H0oooo0P0000190?ooo`800000>`3oool00200oooo00<000000?ooo`3oool00P00000R0?ooo`04
0000003oool0oooo000002D0oooo0P00000S0?ooo`050000003oool0oooo0?ooo`000000AP3oool0
1@000000oooo0?ooo`3oool0000003/0oooo000P0?ooo`80000000<0oooo0000003oool08`3oool0
0`000000oooo0000000U0?ooo`8000008`3oool00`000000oooo0?ooo`02000004H0oooo00<00000
0?ooo`3oool00P00000k0?ooo`008@3oool3000002@0oooo0`00000V0?ooo`030000003oool0oooo
0280oooo0`0000180?ooo`<00000?03oool00?l0oooo8@3oool00;X0oooo00<000000?ooo`3oool0
AP3oool2000001/0oooo002j0?ooo`030000003oool0oooo04D0oooo00@000000?ooo`3oool00000
6P3oool00;X0oooo00<000000?ooo`3oool0A@3oool010000000oooo0?ooo`00000J0?ooo`00603o
oooT000000H0oooo00D000000?ooo`3oool0oooo0000000I0?ooo`007@3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo0080ooooE000000<0?ooo`D000006@3oool001d0oooo00<00000
0?ooo`3oool0903oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo02@0oooo00<00000
0?ooo`3oool01`3ooolD000000T0oooo00<000000?ooo`3oool02`3oool^000000d0oooo00@00000
0?ooo`3oool000006@3oool009/0oooo3P00000A0?ooo`030000003oool0oooo01d0oooo7000000=
0?ooo`040000003oool0oooo000001T0oooo000M0?ooo`030000003oool0oooo07T0oooo3000000E
0?ooo`030000003oool0oooo04L0oooo0`00000I0?ooo`00703oool4000007L0oooo3000000G0?oo
o`800000I03oool001d0oooo1@00001d0?ooo`/000006@3oool00`000000oooo0?ooo`1S0?ooo`00
7`3oool7000006h0oooo100000000`3oool0000000000004000001/0oooo00<000000?ooo`3oool0
H`3oool00240oooo2000001Z0?ooo`/00000703oool00`000000oooo0?ooo`1S0?ooo`009P3oool5
000006L0oooo0`0000000`3oool0000000000004000001h0oooo00<000000?ooo`3oool0H`3oool0
02P0oooo1@00001T0?ooo`<0000000<0oooo0000000000001000000O0?ooo`800000I03oool002X0
oooo1@00001P0?ooo`@0000000<0oooo0000000000000`00000Q0?ooo`030000003oool0oooo06<0
oooo000/0?ooo`D00000G@3oool4000000030?ooo`000000000000<000008P3oool00`000000oooo
0?ooo`1S0?ooo`00;P3oool4000005/0oooo0`0000020?ooo`D000008`3oool00`000000oooo0?oo
o`1S0?ooo`00<03oool4000005T0oooo0P0000020?ooo`@000009@3oool00`000000oooo0?ooo`1S
0?ooo`00<@3oool4000005L0oooo0P0000020?ooo`@000009P3oool2000006@0oooo000c0?ooo`<0
0000E@3oool200000080oooo1000000W0?ooo`030000003oool0oooo06<0oooo000d0?ooo`@00000
D`3oool00`000000oooo0?ooo`04000002P0oooo00<000000?ooo`3oool0H`3oool003D0oooo1000
001A0?ooo`8000000P3oool3000002T0oooo00<000000?ooo`3oool0H`3oool001d0oooo00<00000
0?ooo`3oool05`3oool3000004l0oooo0P0000020?ooo`<00000:P3oool00`000000oooo0?ooo`1S
0?ooo`00703oool3000001T0oooo0`00001>0?ooo`030000003oool0oooo00<00000:`3oool20000
06@0oooo000M0?ooo`<000006@3oool3000004`0oooo0P000000103oool0000000000000000N0?oo
o`800000103oool3000000D0oooo00<000000?ooo`3oool0H`3oool001h0oooo0`00000I0?ooo`<0
0000BP3oool2000000040?ooo`000000000000000200oooo00@000000?ooo`3oool0oooo0P000000
0`3oool000000?ooo`040?ooo`030000003oool0oooo06<0oooo000O0?ooo`<000006@3oool40000
04P0oooo00<000000?ooo`0000000P00000Q0?ooo`050000003oool0oooo0?ooo`0000000P3oool2
000000@0oooo00<000000?ooo`3oool0H`3oool00200oooo0`00000I0?ooo`@00000AP3oool50000
0280oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103oool00`000000oooo0?ooo`1S
0?ooo`008@3oool3000001X0oooo0`0000140?ooo`D000008`3oool01@000000oooo0?ooo`3oool0
000000<0oooo00<000000?ooo`3oool00P3oool3000006<0oooo000R0?ooo`<000006P3oool30000
0480oooo1@00000T0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo06<0oooo000S0?ooo`<000006P3oool300000440oooo1@00000T0?oo
o`050000003oool0oooo0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3oool0H`3oool0
02@0oooo0`00000J0?ooo`<00000?`3oool5000002D0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`800000103oool00`000000oooo0?ooo`1S0?ooo`009@3oool2000001/0oooo0`00000m0?oo
o`D000009@3oool2000000<0oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo
06<0oooo000V0?ooo`8000006`3oool3000003`0oooo1@00000V0?ooo`030000003oool0oooo0080
oooo0`0000050?ooo`800000I03oool002L0oooo0P00000K0?ooo`@00000>@3oool5000003@0oooo
00<000000?ooo`3oool0H`3oool002P0oooo0P00000K0?ooo`@00000=`3oool6000003@0oooo00<0
00000?ooo`3oool0H`3oool002T0oooo00<000000?ooo`3oool06`3oool3000003H0oooo1@00000e
0?ooo`030000003oool0oooo06<0oooo000Y0?ooo`8000007@3oool3000003@0oooo0`0000000`3o
ool000000?ooo`0e0?ooo`030000003oool0oooo06<0oooo000Z0?ooo`8000007@3oool300000380
oooo0`0000000`3oool000000000000f0?ooo`800000I03oool002/0oooo0P00000M0?ooo`@00000
;`3oool3000000030?ooo`000000000003L0oooo00<000000?ooo`3oool0H`3oool002`0oooo0P00
000M0?ooo`@00000;03oool400000080oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?oo
o`1S0?ooo`00;@3oool00`000000oooo0?ooo`0M0?ooo`@00000:@3oool5000000030?ooo`000000
000003P0oooo00<000000?ooo`3oool0H`3oool002d0oooo0P00000O0?ooo`@000009`3oool30000
00030?ooo`000000oooo00800000>@3oool00`000000oooo0?ooo`1S0?ooo`00;P3oool200000200
oooo1000000T0?ooo`<0000000D0oooo000000000000oooo0000000j0?ooo`800000I03oool002l0
oooo0P00000P0?ooo`@000008P3oool300000080oooo00@000000?ooo`0000000000>P3oool00`00
0000oooo0?ooo`1S0?ooo`00<03oool00`000000oooo0?ooo`0P0?ooo`<00000803oool300000080
oooo1000000k0?ooo`030000003oool0oooo06<0oooo000`0?ooo`8000008P3oool4000001`0oooo
100000030?ooo`030000003oool0000003`0oooo00<000000?ooo`3oool0H`3oool00340oooo0P00
000R0?ooo`@000006P3oool4000000@0oooo0`00000l0?ooo`030000003oool0oooo06<0oooo000b
0?ooo`030000003oool0oooo0280oooo1000000E0?ooo`D000001@3oool3000003d0oooo0P00001T
0?ooo`00<P3oool2000002@0oooo1P00000@0?ooo`H000001P3oool200000340oooo0P0000030?oo
o`<000001@3oool00`000000oooo0?ooo`1S0?ooo`00<`3oool00`000000oooo0?ooo`0T0?ooo`H0
0000303oool5000000P0oooo0`00000_0?ooo`<0000000<0oooo0000003oool00P0000000`3oool0
00000?ooo`040?ooo`030000003oool0oooo06<0oooo000c0?ooo`800000:03oool5000000P0oooo
1@00000:0?ooo`800000<03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00800000
103oool00`000000oooo0?ooo`1S0?ooo`00=03oool2000002T0oooo3P00000;0?ooo`800000<@3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00800000103oool00`000000oooo0?oo
o`1S0?ooo`00=@3oool00`000000oooo0?ooo`0Y0?ooo`X000003@3oool200000380oooo0P000003
0?ooo`050000003oool0oooo0?ooo`000000103oool3000006<0oooo000e0?ooo`800000@03oool2
000003D0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo06<0oooo000f0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0=03oool2
000000040?ooo`000000oooo0?ooo`800000103oool00`000000oooo0?ooo`1S0?ooo`00=P3oool2
000003h0oooo0P00000c0?ooo`070000003oool0oooo0?ooo`000000oooo000000020?ooo`800000
103oool00`000000oooo0?ooo`1S0?ooo`00=`3oool2000003`0oooo0`00000c0?ooo`030000003o
ool0oooo0080000000D0oooo000000000000oooo000000050?ooo`030000003oool0oooo06<0oooo
000h0?ooo`030000003oool0oooo03X0oooo0`00000d0?ooo`<000000`3oool3000000D0oooo0P00
001T0?ooo`00>03oool2000003X0oooo0`0000130?ooo`030000003oool0oooo06<0oooo000i0?oo
o`800000>03oool4000004<0oooo00<000000?ooo`3oool0H`3oool003X0oooo0P00000g0?ooo`<0
0000A03oool00`000000oooo0?ooo`1S0?ooo`00>`3oool00`000000oooo0?ooo`0d0?ooo`@00000
A03oool2000006@0oooo000M0?ooo`030000003oool0oooo01/0oooo0P00000e0?ooo`@00000A03o
ool00`000000oooo0?ooo`1S0?ooo`007@3oool00`000000oooo0?ooo`0L0?ooo`800000<`3oool4
000004D0oooo00<000000?ooo`3oool0H`3oool001d0oooo0P00000N0?ooo`800000<@3oool50000
04D0oooo00<000000?ooo`3oool0H`3oool001h0oooo00<000000?ooo`3oool07@3oool00`000000
oooo0?ooo`0_0?ooo`040000003oool00000000004H0oooo00<000000?ooo`3oool0H`3oool001h0
oooo0P00000N0?ooo`800000;`3oool2000000030?ooo`000000000004H0oooo0P00001T0?ooo`00
7`3oool00`000000oooo0?ooo`0M0?ooo`800000;@3oool2000000040?ooo`0000000000000004H0
oooo00<000000?ooo`3oool0H`3oool001l0oooo0P00000O0?ooo`800000:`3oool200000080oooo
0P0000170?ooo`030000003oool0oooo06<0oooo000P0?ooo`030000003oool0oooo01h0oooo0P00
000Y0?ooo`<0000000@0oooo0000000000000000A`3oool00`000000oooo0?ooo`1S0?ooo`00803o
ool2000001l0oooo0`00000X0?ooo`8000000P3oool2000004P0oooo00<000000?ooo`3oool0H`3o
ool00240oooo00<000000?ooo`3oool07P3oool2000002L0oooo0P0000030?ooo`800000B03oool2
000006@0oooo000Q0?ooo`030000003oool0oooo01l0oooo0P00000U0?ooo`<000000P3oool30000
03X0oooo0`0000030?ooo`<000001@3oool00`000000oooo0?ooo`1S0?ooo`008@3oool200000240
oooo0P00000S0?ooo`<000000`3oool2000003X0oooo00<000000?ooo`3oool00P0000001@3oool0
00000000003oool0000000D0oooo00<000000?ooo`3oool0H`3oool00280oooo00<000000?ooo`3o
ool07`3oool300000240oooo0`0000030?ooo`<00000>P3oool01`000000oooo0?ooo`3oool00000
0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3oool0H`3oool00280oooo0P00000Q0?oo
o`<000007`3oool3000000@0oooo0P00000o0?ooo`030000003oool000000080oooo0P0000040?oo
o`030000003oool0oooo06<0oooo000S0?ooo`030000003oool0oooo0200oooo0`00000N0?ooo`80
00001@3oool2000003h0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`020?oo
o`<00000H`3oool002<0oooo0P00000R0?ooo`<00000703oool2000000D0oooo0`00000m0?ooo`80
00000P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0H`3oool002@0
oooo00<000000?ooo`3oool08@3oool3000001X0oooo0`0000050?ooo`800000?`3oool010000000
oooo0?ooo`0000020?ooo`800000103oool00`000000oooo0?ooo`1S0?ooo`00903oool2000002<0
oooo0`00000I0?ooo`8000001@3oool3000003`0oooo00<000000?ooo`3oool00P000000103oool0
00000?ooo`3oool2000000@0oooo00<000000?ooo`3oool0H`3oool002D0oooo00<000000?ooo`3o
ool08P3oool4000001H0oooo0P0000060?ooo`800000?@3oool010000000oooo0?ooo`0000020?oo
o`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`1S0?ooo`009@3oool2000002@0
oooo1000000D0?ooo`8000001`3oool2000003h0oooo0`0000030?ooo`<000001@3oool2000006@0
oooo000V0?ooo`030000003oool0oooo02@0oooo0`00000A0?ooo`<000001`3oool3000004`0oooo
00<000000?ooo`3oool0H`3oool002H0oooo0P00000V0?ooo`@00000303oool6000000L0oooo0P00
001=0?ooo`030000003oool0oooo06<0oooo000W0?ooo`030000003oool0oooo02D0oooo1@000009
0?ooo`D00000203oool3000004d0oooo00<000000?ooo`3oool0H`3oool002L0oooo0P00000X0?oo
o`D000001@3oool4000000/0oooo0P00001>0?ooo`030000003oool0oooo06<0oooo000X0?ooo`03
0000003oool0oooo02P0oooo2`00000<0?ooo`800000CP3oool2000006@0oooo000X0?ooo`800000
:`3oool7000000d0oooo0`00001>0?ooo`030000003oool0oooo06<0oooo000Y0?ooo`030000003o
ool0oooo03d0oooo0P00001?0?ooo`030000003oool0oooo06<0oooo000Y0?ooo`800000?@3oool3
000004l0oooo00<000000?ooo`3oool0H`3oool002X0oooo00<000000?ooo`3oool0>`3oool20000
0500oooo00<000000?ooo`3oool0H`3oool002X0oooo0P00000l0?ooo`800000D03oool2000006@0
oooo000[0?ooo`030000003oool0oooo03T0oooo0`00001@0?ooo`030000003oool0oooo06<0oooo
000[0?ooo`030000003oool0oooo03T0oooo0P00001A0?ooo`030000003oool0oooo06<0oooo000[
0?ooo`800000>@3oool300000540oooo00<000000?ooo`3oool0H`3oool002`0oooo00<000000?oo
o`3oool0=`3oool200000580oooo00<000000?ooo`3oool0H`3oool002`0oooo0P00000h0?ooo`80
0000DP3oool2000006@0oooo000]0?ooo`030000003oool0oooo03D0oooo0P0000160?ooo`800000
0`3oool3000000D0oooo00<000000?ooo`3oool0H`3oool002d0oooo0P00000f0?ooo`800000AP3o
ool200000080oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo06<0oooo000^
0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0A@3oool200000080oooo00<00000
0?ooo`3oool00P0000040?ooo`030000003oool0oooo06<0oooo000^0?ooo`800000=03oool20000
04D0oooo100000020?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`1S0?oo
o`00;`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo04@0oooo00@000000?ooo`00
000000000P3oool01@000000oooo0?ooo`3oool0000000@0oooo0`00001S0?ooo`00;`3oool20000
0380oooo0P0000170?ooo`<000000P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<00000
0?ooo`3oool0H`3oool00300oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`160?oo
o`<000000P3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0H`3oool00300
oooo0P00000`0?ooo`800000B@3oool200000080oooo00<000000?ooo`3oool00P0000040?ooo`03
0000003oool0oooo06<0oooo000`0?ooo`800000<03oool00`000000oooo0?ooo`180?ooo`800000
0P3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0H`3oool00300oooo0`00
000^0?ooo`800000B`3oool010000000oooo0?ooo`3oool3000000D0oooo0P00001T0?ooo`00<@3o
ool2000002h0oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`1S0?ooo`00<@3oool3
000002`0oooo0P00001H0?ooo`030000003oool0oooo06<0oooo000b0?ooo`800000;03oool00`00
0000oooo0?ooo`1G0?ooo`030000003oool0oooo06<0oooo000b0?ooo`800000;03oool00`000000
oooo0?ooo`1G0?ooo`030000003oool0oooo06<0oooo000c0?ooo`800000:P3oool2000005T0oooo
0P00001T0?ooo`00<`3oool2000002X0oooo00<000000?ooo`3oool0F03oool00`000000oooo0?oo
o`1S0?ooo`00=03oool00`000000oooo0?ooo`0W0?ooo`800000FP3oool00`000000oooo0?ooo`1S
0?ooo`00=03oool2000002P0oooo00<000000?ooo`3oool0F@3oool00`000000oooo0?ooo`1S0?oo
o`00=@3oool00`000000oooo0?ooo`0U0?ooo`800000F`3oool00`000000oooo0?ooo`1S0?ooo`00
=@3oool2000002H0oooo00<000000?ooo`3oool0FP3oool2000006@0oooo000f0?ooo`030000003o
ool0oooo02<0oooo0P00001L0?ooo`030000003oool0oooo06<0oooo000f0?ooo`800000903oool0
0`000000oooo0?ooo`1K0?ooo`030000003oool0oooo06<0oooo000g0?ooo`030000003oool0oooo
0240oooo0P00001M0?ooo`030000003oool0oooo06<0oooo000g0?ooo`8000008@3oool2000005h0
oooo00<000000?ooo`3oool0H`3oool003P0oooo0P00000P0?ooo`030000003oool0oooo05d0oooo
0P00001T0?ooo`00>03oool3000001h0oooo0P00001A0?ooo`<000000`3oool3000000D0oooo00<0
00000?ooo`3oool0H`3oool003T0oooo0P00000N0?ooo`030000003oool0oooo04l0oooo00@00000
0?ooo`3oool000000P3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0H`3o
ool003X0oooo0P00000L0?ooo`800000D@3oool00`000000oooo0?ooo`02000000040?ooo`000000
oooo0?ooo`800000103oool00`000000oooo0?ooo`1S0?ooo`00>P3oool3000001X0oooo0P00001F
0?ooo`030000003oool000000080oooo0P0000040?ooo`030000003oool0oooo06<0oooo000k0?oo
o`<00000603oool2000005H0oooo0P0000000`3oool000000?ooo`020?ooo`030000003oool0oooo
0080oooo0`00001S0?ooo`00?03oool3000001H0oooo0`00001C0?ooo`040000003oool0oooo0000
0080oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo06<0oooo000m0?oo
o`<000005@3oool2000005@0oooo100000020?ooo`030000003oool0oooo00800000103oool00`00
0000oooo0?ooo`1S0?ooo`00?P3oool2000001@0oooo0P00001E0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo06<0oooo000o0?ooo`800000
4P3oool3000005D0oooo00<000000?ooo`3oool00`3oool2000000030?ooo`000000oooo00@0oooo
00<000000?ooo`3oool0H`3oool003l0oooo0`00000@0?ooo`<00000EP3oool3000000@0oooo0`00
00050?ooo`800000I03oool00400oooo0`00000>0?ooo`<00000IP3oool00`000000oooo0?ooo`1S
0?ooo`00@@3oool3000000/0oooo1000001W0?ooo`030000003oool0oooo06<0oooo00120?ooo`D0
00001P3oool5000006P0oooo00<000000?ooo`3oool0H`3oool004<0oooo1P0000020?ooo`D00000
JP3oool00`000000oooo0?ooo`1S0?ooo`00AP3oool8000006`0oooo0P00001T0?ooo`00B03oool4
000006h0oooo00<000000?ooo`3oool0H`3oool00;X0oooo00<000000?ooo`3oool0H`3oool00;X0
oooo00<000000?ooo`3oool0H`3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0;@0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
05D0oooo002c0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`1D0?ooo`00Z@3oool00`000000oooo0?ooo`02000000@0oooo00@000000?ooo`3oool0
oooo0P0000060?ooo`030000003oool0oooo00<0oooo100000020?ooo`030000003oool0oooo05<0
oooo002Z0?ooo`030000003oool0000000D0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00D000000?ooo`3oool0oooo000000020?oo
o`030000003oool0oooo05<0oooo002Z0?ooo`030000003oool0000000D0oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00D000000?oo
o`3oool0oooo000000020?ooo`030000003oool0oooo05<0oooo002[0?ooo`030000003oool00000
00@0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo0080oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo05<0oooo002Y
0?ooo`050000003oool000000?ooo`000000103oool00`000000oooo0?ooo`05000000@0oooo00<0
00000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
D`3oool00:X0oooo1@0000030?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P0000020?ooo`030000
003oool0oooo05<0oooo002b0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00<0oooo0P0000001@3oool000000?ooo`3oool0000005D0
oooo002c0?ooo`040000003oool0oooo0?ooo`<00000103oool00`000000oooo0?ooo`060?ooo`03
0000003oool0000005H0oooo002d0?ooo`030000003oool0oooo0100oooo0P00001G0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-9.51061, -7.5224, \
0.0508908, 0.404722}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(LPMRule[d_, sig_, k_] := 
      If[\((Abs[d] \[GreaterEqual] lambda[sig, k])\), mode2[d, sig, k], 
        0]\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\(\(\(Plot\)\([\)\({d, \ LPMRule[d, 2, 0.75]}, {d, \(-5\), 5}, \ 
          PlotStyle\  \[Rule] \ {{Dashing[{0.02}]}}, {Thickness[
              0.01]}\)\)\(}\)\), \ 
      AspectRatio\  \[Rule] \ 
        Automatic, \[IndentingNewLine]PlotRange\  \[Rule] \ All, \ 
      AxesLabel\  \[Rule] \ {d, \ None}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}\)\(]\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{\(Syntax::"bktmcp"\), \(\(:\)\(\ \)\), "\<\"Expression \
\\\"\\!\\(Plot[\\(\\(\\(\\({d, \\(\\(LPMRule[\\(\\(d, 2, \
0.75\\)\\)]\\)\\)}\\)\\), \\(\\({d, \\(\\(-5\\)\\), 5}\\)\\), \\(\\(PlotStyle \
\[Rule] \\(\\({\\(Dashing[\\(\\({0.02}\\)\\)]\\)}\\)\\)\\)\\), \
\\(\\({\\(Thickness[0.01]\\)}\\)\\)\\)\\)\\)\\\" has no closing \
\\\"\\!\\(\\\"]\\\"\\)\\\".\\!\\(\\\"\\\"\\) \\!\\(\\*ButtonBox[\\\"More\
\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::bktmcp\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    StyleBox[
      ErrorBox[\(\(\(\(\(Plot\)\([\)\({d, LPMRule[d, 2, 0.75]}, {d, \(-5\), 
                5}, PlotStyle \[Rule] {Dashing[{0.02}]}, {Thickness[
                  0.01]}\)\)\(}\)\), AspectRatio \[Rule] Automatic, 
          PlotRange \[Rule] All, AxesLabel \[Rule] {d, None}, 
          DefaultFont \[Rule] {"\<Roman\>", 12}\)\(]\)\)],
      ShowStringCharacters->True]], "Message"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[
    \(\(phi[\ d_, \ th_, \ s2_] := \ 
        1/Sqrt[2\ Pi\ s2]\ \ Exp[\ \(-\ \((d\  - \ 
                      th)\)^2\)/\((2\ s2)\)];\)\)], "Input"],

Cell[BoxData[
    \(\[IndentingNewLine]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(Here\ is\ the\ Exact\ Risk\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(Exact\ Here\ is\ Risk\ the ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ sig\  = \ 2, \ 
      k\  = \ 3/
          4\ *) \)\(\[IndentingNewLine]\)\(Plot[\[IndentingNewLine]NIntegrate[\
\ \ \((th\  - 1/2 \((\ 
                      d\  - \ Sqrt[
                          d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ phi[
              d, \ th, \ 
              2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                2\ 3/4\  - 
                  1]}]\  + \[IndentingNewLine]NIntegrate[\ \ th^2\ phi[d, \ 
              th, \ 2^2], {d, \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                2\ 3/4\  - 1], \ \((2\ \ 2)\)\ \ Sqrt[
                2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
        NIntegrate[\ \ \((th\  - 
                  1/2 \((\ 
                      d\  + \ Sqrt[
                          d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ phi[
              d, \ th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
            Infinity}], \[IndentingNewLine]{th, \(-10\), 10}\ , 
      PlotRange\  \[Rule] \ {0, \ 7}, \[IndentingNewLine]\ 
      PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \ 
      AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 -2.08167e-017 0.0882906 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .08829 -9.6875 -7.875 ]
[.4875 .08829 0 7.875 ]
[.4875 .17658 -9.6875 -7.875 ]
[.4875 .17658 0 7.875 ]
[.4875 .26487 -9.6875 -7.875 ]
[.4875 .26487 0 7.875 ]
[.4875 .35316 -9.6875 -7.875 ]
[.4875 .35316 0 7.875 ]
[.4875 .44145 -9.6875 -7.875 ]
[.4875 .44145 0 7.875 ]
[.4875 .52974 -9.6875 -7.875 ]
[.4875 .52974 0 7.875 ]
[.4875 .61803 -9.6875 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .08829 m
.50625 .08829 L
s
gsave
.4875 .08829 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .17658 m
.50625 .17658 L
s
gsave
.4875 .17658 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .26487 m
.50625 .26487 L
s
gsave
.4875 .26487 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 .35316 m
.50625 .35316 L
s
gsave
.4875 .35316 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .44145 m
.50625 .44145 L
s
gsave
.4875 .44145 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 .52974 m
.50625 .52974 L
s
gsave
.4875 .52974 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01766 m
.50375 .01766 L
s
.5 .03532 m
.50375 .03532 L
s
.5 .05297 m
.50375 .05297 L
s
.5 .07063 m
.50375 .07063 L
s
.5 .10595 m
.50375 .10595 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .14126 m
.50375 .14126 L
s
.5 .15892 m
.50375 .15892 L
s
.5 .19424 m
.50375 .19424 L
s
.5 .2119 m
.50375 .2119 L
s
.5 .22956 m
.50375 .22956 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .28253 m
.50375 .28253 L
s
.5 .30019 m
.50375 .30019 L
s
.5 .31785 m
.50375 .31785 L
s
.5 .3355 m
.50375 .3355 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .38848 m
.50375 .38848 L
s
.5 .40614 m
.50375 .40614 L
s
.5 .42379 m
.50375 .42379 L
s
.5 .45911 m
.50375 .45911 L
s
.5 .47677 m
.50375 .47677 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .51209 m
.50375 .51209 L
s
.5 .5474 m
.50375 .5474 L
s
.5 .56506 m
.50375 .56506 L
s
.5 .58272 m
.50375 .58272 L
s
.5 .60038 m
.50375 .60038 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .37592 m
.04262 .37886 L
.06244 .38284 L
.08255 .38817 L
.10458 .39609 L
.12415 .40557 L
.14509 .41895 L
.16639 .43659 L
.18653 .4572 L
.22495 .50484 L
.24439 .52998 L
.25471 .54236 L
.26581 .55417 L
.27642 .56336 L
.28146 .56683 L
.28613 .56944 L
.2908 .57143 L
.29326 .5722 L
.29452 .57252 L
.29589 .57281 L
.29719 .57303 L
.29839 .57318 L
.29954 .57327 L
.30075 .57332 L
.30184 .57332 L
.30286 .57328 L
.30397 .5732 L
.30517 .57305 L
.30638 .57285 L
.30773 .57257 L
.31045 .57177 L
.31297 .57077 L
.31534 .5696 L
.32066 .56613 L
.32641 .56104 L
.3369 .54804 L
.34653 .53188 L
.36545 .48879 L
.38615 .42704 L
.42671 .2857 L
.44545 .22553 L
.45531 .19843 L
.46576 .1744 L
.47105 .16434 L
.47686 .15505 L
.48221 .14824 L
.4871 .14353 L
.48968 .14164 L
.49212 .14023 L
.49337 .13966 L
Mistroke
.4947 .13915 L
.49547 .13891 L
.49616 .13873 L
.49682 .13858 L
.49751 .13846 L
.49877 .13831 L
.49993 .13826 L
.50117 .1383 L
.50188 .13837 L
.50253 .13846 L
.50373 .1387 L
.50481 .139 L
.50725 .13993 L
.50955 .14116 L
.51208 .14289 L
.51719 .1476 L
.52193 .15337 L
.52638 .15999 L
.53638 .17889 L
.54715 .20483 L
.58834 .33861 L
.60891 .41062 L
.62802 .47075 L
.64648 .51766 L
.65681 .53794 L
.66618 .55236 L
.67105 .55832 L
.67619 .56351 L
.68058 .56705 L
.6854 .56999 L
.68812 .57123 L
.69059 .57211 L
.69196 .57249 L
.69345 .57282 L
.69414 .57295 L
.69486 .57306 L
.69616 .57321 L
.69735 .57329 L
.69863 .57333 L
.69983 .5733 L
.70094 .57324 L
.70217 .57311 L
.70286 .57302 L
.70351 .57292 L
.70622 .57234 L
.70884 .57155 L
.71125 .57063 L
.71672 .56792 L
.72665 .56095 L
.74523 .54242 L
Mistroke
.7846 .49236 L
.82245 .44754 L
.84351 .42786 L
.86276 .4135 L
.88265 .40198 L
.90155 .39362 L
.92137 .387 L
.93977 .38234 L
.95887 .3786 L
.97619 .37592 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005`3oool2000000@0oooo0`00
000d0?ooo`<00000K03oool3000003@0oooo0P0000040?ooo`<000007@3oool001P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0b0?ooo`040000003oool0oooo000006/0oooo
00@000000?ooo`3oool00000=@3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01`0oooo000H0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?oo
o`3oool00P00001Z0?ooo`030000003oool0oooo00800000=03oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000L0?ooo`00603oool01@000000oooo0?ooo`3oool000000080oooo0P00000f
0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0<P3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000L0?ooo`003P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02L0oooo1`0000050?ooo`800000K@3oool2000003@0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01X0oooo000H0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0`0?ooo`040000003oool0oooo000006/0
oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool06P3oool001P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000<P3oool4
000006/0oooo1000000e0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo000H
0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0f0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo
000G0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0e0?ooo`8000000`3oool2000000030?ooo`000000oooo01`0oooo000H
0?ooo`030000003oool0oooo0080oooo0`00000c0?ooo`<00000K03oool3000003H0oooo00<00000
0?ooo`3oool00P3oool3000001d0oooo003o0?ooob40oooo003o0?ooo`h0oooo0P00000A0?ooo`00
o`3oool=0?ooo`040000003oool0oooo00000100oooo003o0?ooo`d0oooo00@000000?ooo`3oool0
0000403oool00140oooom00000070?ooo`050000003oool0oooo0?ooo`0000003`3oool001L0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00/0oooo
1@00000?0?ooo`005`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00`0oooo00@0
00000?ooo`3oool000003`3oool008X0oooo00<000000?ooo`3oool0P03oool010000000oooo0?oo
o`00000?0?ooo`00RP3oool00`000000oooo0?ooo`210?ooo`<000003`3oool008X0oooo0P00002D
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0
oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<00000
0?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3o
ool0T`3oool00880oooo0P0000060?ooo`800000U03oool008<0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`2C0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo09<0oooo00230?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008<0
oooo00<000000?ooo`3oool0103oool3000009<0oooo00230?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool0T`3oool008<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`2C0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo00220?oo
o`8000001P3oool2000009@0oooo00230?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3o
ool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000
oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00Q`3oool700000980oooo0026
0?ooo`T00000T@3oool008H0oooo0`000000103oool000000?ooo`3oool300000900oooo00250?oo
o`8000000`3oool010000000oooo0?ooo`3oool3000008l0oooo00240?ooo`800000103oool00`00
0000oooo0?ooo`020?ooo`<00000SP3oool008<0oooo0`0000040?ooo`800000103oool3000008d0
oooo00210?ooo`D00000103oool00`000000oooo0?ooo`040?ooo`800000S@3oool00840oooo0`00
00060?ooo`030000003oool0oooo00@0oooo0P00002=0?ooo`00P@3oool3000000H0oooo00<00000
0?ooo`3oool01@3oool2000008`0oooo00220?ooo`8000001P3oool3000000D0oooo0P00002<0?oo
o`00P@3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`2:0?ooo`00P@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0
1P3oool2000008/0oooo00200?ooo`8000000`3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool0R@3oool00800oooo0P0000020?ooo`800000103oool0
0`000000oooo0?ooo`070?ooo`800000RP3oool007l0oooo0P000000103oool00000000000000005
0?ooo`8000002@3oool00`000000oooo0?ooo`280?ooo`00O`3oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo00P0oooo0P0000290?ooo`00OP3oool2000000X0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`270?ooo`00OP3oool2000000X0oooo00<000000?ooo`3oool0
2@3oool2000008P0oooo001m0?ooo`<000002P3oool2000000X0oooo0P0000280?ooo`00O@3oool2
000000/0oooo00<000000?ooo`3oool02@3oool3000008L0oooo001m0?ooo`8000002`3oool00`00
0000oooo0?ooo`0:0?ooo`800000Q`3oool007`0oooo0`00000;0?ooo`030000003oool0oooo00X0
oooo0P0000270?ooo`00O03oool2000000`0oooo0P00000;0?ooo`800000Q`3oool007`0oooo0P00
000<0?ooo`030000003oool0oooo00X0oooo0`0000260?ooo`00N`3oool3000000`0oooo00<00000
0?ooo`3oool02`3oool2000008H0oooo001k0?ooo`8000003@3oool00`000000oooo0?ooo`0;0?oo
o`800000QP3oool007/0oooo0P00000=0?ooo`800000303oool3000008D0oooo001j0?ooo`<00000
1@3oool3000000D0oooo00<000000?ooo`3oool0303oool2000008D0oooo001j0?ooo`8000001@3o
ool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0303oool2000008D0oooo001j
0?ooo`8000001@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0303o
ool3000008@0oooo001i0?ooo`<000002@3oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo00d0oooo0P0000240?ooo`00N@3oool2000000T0oooo00<000000?ooo`3oool00`3oool30000
00d0oooo0P0000240?ooo`00N@3oool2000000P0oooo0P0000050?ooo`030000003oool0oooo00d0
oooo0P0000240?ooo`00N03oool3000000T0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`0=0?ooo`<00000P`3oool007P0oooo0P0000070?ooo`030000003oool0oooo00800000103o
ool00`000000oooo0?ooo`0>0?ooo`800000P`3oool007P0oooo0P0000070?ooo`040000003oool0
oooo000000D0oooo0P00000?0?ooo`800000P`3oool007L0oooo0`0000080?ooo`<000001@3oool0
0`000000oooo0?ooo`0>0?ooo`<00000PP3oool007L0oooo0P00000A0?ooo`030000003oool0oooo
00l0oooo0P0000220?ooo`00M`3oool200000140oooo00<000000?ooo`3oool03`3oool200000880
oooo001g0?ooo`8000004@3oool200000100oooo0`0000210?ooo`00MP3oool300000140oooo00<0
00000?ooo`3oool0403oool200000840oooo001f0?ooo`8000004P3oool00`000000oooo0?ooo`0@
0?ooo`800000P@3oool007H0oooo0P00000B0?ooo`030000003oool0oooo0100oooo0`0000200?oo
o`00MP3oool200000180oooo00<000000?ooo`3oool04@3oool200000800oooo001e0?ooo`<00000
4P3oool200000180oooo0P0000200?ooo`00M@3oool2000001<0oooo00<000000?ooo`3oool04@3o
ool200000800oooo001e0?ooo`8000004`3oool00`000000oooo0?ooo`0A0?ooo`<00000O`3oool0
07@0oooo0`00000C0?ooo`030000003oool0oooo0180oooo0P00001o0?ooo`00M03oool2000000d0
oooo0P0000050?ooo`8000004`3oool2000007l0oooo001d0?ooo`8000003@3oool2000000D0oooo
00<000000?ooo`3oool04P3oool3000007h0oooo001d0?ooo`8000003@3oool2000000D0oooo00<0
00000?ooo`3oool04`3oool2000007h0oooo001c0?ooo`<000002`3oool4000000D0oooo00<00000
0?ooo`3oool04`3oool2000007h0oooo001c0?ooo`800000303oool010000000oooo000000000005
0?ooo`<000004`3oool3000007d0oooo001c0?ooo`8000003@3oool3000000D0oooo00<000000?oo
o`3oool0503oool2000007d0oooo001c0?ooo`8000003@3oool3000000D0oooo00<000000?ooo`3o
ool0503oool2000007d0oooo001b0?ooo`<000003P3oool2000000D0oooo00<000000?ooo`3oool0
503oool2000007d0oooo001b0?ooo`8000003`3oool2000000D0oooo00<000000?ooo`3oool0503o
ool3000007`0oooo001b0?ooo`800000403oool00`000000oooo0?ooo`030?ooo`8000005P3oool2
000007`0oooo000F0?ooo`X00000DP3oool2000001H0oooo00<000000?ooo`3oool05@3oool20000
0540oooo2P00000Q0?ooo`005P3oool=000004h0oooo0`00000F0?ooo`030000003oool0oooo01D0
oooo0`00001<0?ooo`h000008@3oool00200oooo1P00001;0?ooo`8000005`3oool00`000000oooo
0?ooo`0F0?ooo`800000B@3oool7000002/0oooo000R0?ooo`H00000B@3oool2000001L0oooo0P00
000G0?ooo`800000A`3oool6000002h0oooo000U0?ooo`H00000A@3oool3000001L0oooo00<00000
0?ooo`3oool05P3oool2000004@0oooo1P00000a0?ooo`009`3oool6000004<0oooo0P00000H0?oo
o`030000003oool0oooo01H0oooo0`0000110?ooo`H00000<`3oool002X0oooo1P0000100?ooo`80
0000603oool00`000000oooo0?ooo`0G0?ooo`800000?`3oool5000003H0oooo000/0?ooo`H00000
?P3oool2000001P0oooo0P00000H0?ooo`800000?P3oool4000003P0oooo000_0?ooo`@00000?03o
ool3000001P0oooo00<000000?ooo`3oool05`3oool3000003/0oooo1000000j0?ooo`00<@3oool4
000003X0oooo0P00000I0?ooo`030000003oool0oooo01P0oooo0P00000j0?ooo`@00000>`3oool0
0380oooo1000000i0?ooo`8000006@3oool00`000000oooo0?ooo`0H0?ooo`800000>03oool40000
03d0oooo000d0?ooo`<00000>03oool2000001T0oooo0P00000I0?ooo`800000=`3oool4000003h0
oooo000e0?ooo`<00000=P3oool300000140oooo0`0000050?ooo`030000003oool0oooo01P0oooo
0`00000e0?ooo`<00000@03oool003H0oooo0`00000e0?ooo`8000004@3oool010000000oooo0?oo
o`0000050?ooo`030000003oool0oooo01T0oooo0P00000d0?ooo`<00000@@3oool003L0oooo0`00
000d0?ooo`8000004@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool06@3o
ool2000003<0oooo0`0000120?ooo`00>03oool300000380oooo0`00000E0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool06@3oool200000380oooo0`0000130?ooo`00>@3oool30000
0340oooo0P00000E0?ooo`800000103oool3000001T0oooo0`00000`0?ooo`<00000A03oool003X0
oooo0`00000`0?ooo`8000004P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo
01X0oooo0P00000_0?ooo`<00000A@3oool003/0oooo0`00000^0?ooo`<000004P3oool4000000D0
oooo00<000000?ooo`3oool06P3oool2000002h0oooo0`0000160?ooo`00?03oool3000002d0oooo
0P00000C0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool06P3oool3000002`0oooo
0`0000170?ooo`00?@3oool3000002`0oooo0P00000C0?ooo`030000003oool0oooo00H0oooo0P00
000L0?ooo`800000:`3oool3000004P0oooo000n0?ooo`<00000:P3oool3000001<0oooo0`000006
0?ooo`030000003oool0oooo01/0oooo0P00000Z0?ooo`<00000B@3oool003l0oooo0P00000Z0?oo
o`8000007@3oool00`000000oooo0?ooo`0K0?ooo`800000:P3oool2000004X0oooo00100?ooo`80
0000:@3oool2000001d0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0W0?ooo`80
0000B`3oool00400oooo0`00000W0?ooo`<000007@3oool2000001d0oooo0P00000W0?ooo`<00000
B`3oool00440oooo0`00000V0?ooo`8000007P3oool00`000000oooo0?ooo`0M0?ooo`030000003o
ool0oooo02@0oooo0`00001<0?ooo`00@P3oool3000002D0oooo0P00000N0?ooo`030000003oool0
oooo01d0oooo0P00000T0?ooo`<00000C@3oool004<0oooo0`00000T0?ooo`030000003oool0oooo
01d0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0Q0?ooo`<00000CP3oool004@0
oooo0P00000S0?ooo`8000007`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo0240
oooo0P00001?0?ooo`00A@3oool200000280oooo00<000000?ooo`3oool07P3oool2000001l0oooo
0P00000Q0?ooo`800000D03oool004D0oooo0`00000P0?ooo`800000803oool00`000000oooo0?oo
o`0O0?ooo`030000003oool0oooo01h0oooo0P00001A0?ooo`00AP3oool3000001l0oooo00<00000
0?ooo`3oool07`3oool00`000000oooo0?ooo`0O0?ooo`8000007P3oool200000580oooo00170?oo
o`<000007@3oool200000240oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0L0?oo
o`030000003oool0oooo0540oooo00180?ooo`8000007@3oool00`000000oooo0?ooo`0H0?ooo`<0
00001@3oool200000240oooo0P00000L0?ooo`800000D`3oool004T0oooo0P00000L0?ooo`030000
003oool0oooo01L0oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool06@3oool2000005@0oooo00190?ooo`<000006P3oool2000001T0oooo00<0
00000?ooo`3oool00P0000040?ooo`030000003oool0oooo0240oooo0P00000I0?ooo`800000E@3o
ool004X0oooo0`00000I0?ooo`030000003oool0oooo01P0oooo00D000000?ooo`3oool0oooo0000
00040?ooo`030000003oool0oooo0240oooo0`00000H0?ooo`030000003oool0oooo05@0oooo001;
0?ooo`<000005`3oool2000001X0oooo00<000000?ooo`3oool00P0000040?ooo`<000008@3oool3
000001L0oooo0P00001F0?ooo`00C03oool3000001H0oooo00<000000?ooo`3oool06@3oool20000
00030?ooo`000000oooo00@0oooo00<000000?ooo`3oool08P3oool2000001H0oooo0P00001G0?oo
o`00C@3oool3000001@0oooo0P00000K0?ooo`030000003oool0000000H0oooo00<000000?ooo`3o
ool08`3oool00`000000oooo0?ooo`0C0?ooo`800000F03oool004h0oooo0P00000D0?ooo`030000
003oool0oooo01X0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`0S0?ooo`80
00004`3oool3000005P0oooo001?0?ooo`8000004P3oool2000001d0oooo00<000000?ooo`000000
1@3oool2000002D0oooo00<000000?ooo`3oool0403oool3000005T0oooo001@0?ooo`800000403o
ool2000001h0oooo0`0000050?ooo`030000003oool0oooo02D0oooo0P00000?0?ooo`<00000FP3o
ool00540oooo0P00000>0?ooo`<000009P3oool00`000000oooo0?ooo`0V0?ooo`8000003@3oool3
000005/0oooo001A0?ooo`@000002`3oool3000002L0oooo00<000000?ooo`3oool09P3oool30000
00/0oooo0`00001L0?ooo`00DP3oool4000000T0oooo0`00000X0?ooo`030000003oool0oooo02L0
oooo0`0000080?ooo`@00000G@3oool005@0oooo0`0000060?ooo`@00000:@3oool2000002T0oooo
0`0000060?ooo`@00000GP3oool005D0oooo100000020?ooo`D00000:P3oool00`000000oooo0?oo
o`0Y0?ooo`@000000P3oool400000600oooo001F0?ooo`P00000;03oool00`000000oooo0?ooo`0Z
0?ooo`P00000H@3oool005L0oooo1P00000]0?ooo`030000003oool0oooo02/0oooo1@00001S0?oo
o`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003o
ool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0
oooo00<000000?ooo`3oool0T`3oool008<0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`2C0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo0023
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008<0oooo00<000000?oo
o`3oool0103oool3000009<0oooo00240?ooo`030000003oool0oooo09T0oooo00240?ooo`030000
003oool0oooo09T0oooo00210?ooo`050000003oool0oooo0?ooo`000000VP3oool00840oooo00<0
00000?ooo`0000000P00002J0?ooo`00P@3oool200000080oooo00<000000?ooo`3oool0V03oool0
0?l0oooo8@3oool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9865, -0.87528, \
0.0863677, 0.046582}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(Here\ is\ the\ Exact\ Bias\ Squared\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(Bias\ Exact\ Here\ is\ Squared\ the ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ sig\  = \ 2, \ 
      k\  = \ 3/
          4\ *) \)\(\[IndentingNewLine]\)\(Plot[\[IndentingNewLine]\((th\ \  \
- \ NIntegrate[\ \ 1/2 \((\ 
                  d\  - \ Sqrt[d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ phi[
                  d, \ th, \ 
                  2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                    2\ 3/4\  - 1]}]\  - \[IndentingNewLine]\ 
            NIntegrate[\ 
              1/2 \((\ d\  + \ 
                    Sqrt[d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ \ phi[d, \ 
                  th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                Infinity}])\)^2, \[IndentingNewLine]{th, \(-10\), 10}, \ 
      PlotRange\  \[Rule] \ {0, \ 1}, \ 
      AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
      PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \ 
      DefaultFont\  \[Rule] \ {"\<Times\>", 12}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.618034 [
[.02381 -0.0125 -12.1875 -15.5 ]
[.02381 -0.0125 12.1875 0 ]
[.2619 -0.0125 -9.1875 -15.5 ]
[.2619 -0.0125 9.1875 0 ]
[.7381 -0.0125 -5 -15.5 ]
[.7381 -0.0125 5 0 ]
[.97619 -0.0125 -8 -15.5 ]
[.97619 -0.0125 8 0 ]
[1.025 0 0 -7.75 ]
[1.025 0 9.4375 7.75 ]
[.4875 .12361 -19 -7.75 ]
[.4875 .12361 0 7.75 ]
[.4875 .24721 -19 -7.75 ]
[.4875 .24721 0 7.75 ]
[.4875 .37082 -19 -7.75 ]
[.4875 .37082 0 7.75 ]
[.4875 .49443 -19 -7.75 ]
[.4875 .49443 0 7.75 ]
[.4875 .61803 -10 -7.75 ]
[.4875 .61803 0 7.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -73.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -66 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .12361 m
.50625 .12361 L
s
gsave
.4875 .12361 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
1.000 setlinewidth
grestore
.5 .24721 m
.50625 .24721 L
s
gsave
.4875 .24721 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.4) show
1.000 setlinewidth
grestore
.5 .37082 m
.50625 .37082 L
s
gsave
.4875 .37082 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.6) show
1.000 setlinewidth
grestore
.5 .49443 m
.50625 .49443 L
s
gsave
.4875 .49443 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.8) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .0309 m
.50375 .0309 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .15451 m
.50375 .15451 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .30902 m
.50375 .30902 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .46353 m
.50375 .46353 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .58713 m
.50375 .58713 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .02867 m
.04262 .03164 L
.06244 .03541 L
.08255 .04014 L
.10458 .04681 L
.12415 .05461 L
.14509 .06577 L
.16639 .0814 L
.18653 .10176 L
.20651 .12918 L
.22495 .16257 L
.24367 .20572 L
.2643 .26444 L
.30459 .40171 L
.32312 .46171 L
.33292 .48803 L
.34336 .50965 L
.34632 .5143 L
.34911 .51802 L
.35182 .52099 L
.35432 .52312 L
.35669 .52461 L
.35789 .52515 L
.35921 .52557 L
.36053 .52583 L
.36127 .52589 L
.36194 .52591 L
.36325 .52579 L
.36449 .52552 L
.36564 .52511 L
.36692 .52451 L
.36824 .52369 L
.36949 .52274 L
.37172 .52063 L
.37412 .51773 L
.37958 .50875 L
.38458 .49756 L
.39439 .46764 L
.40351 .43085 L
.42421 .32205 L
.44294 .2088 L
.46325 .09603 L
.46865 .07131 L
.47436 .04855 L
.47965 .03099 L
.4846 .01792 L
.48922 .00883 L
.49182 .0051 L
.49419 .00257 L
.49554 .00152 L
Mistroke
.49678 .00079 L
.4975 .00048 L
.49815 .00026 L
.4989 9e-005 L
.49961 1e-005 L
.5009 6e-005 L
.50208 .00033 L
.50338 .00087 L
.50403 .00124 L
.50475 .00172 L
.50727 .00403 L
.50869 .00576 L
.51001 .00762 L
.51498 .01697 L
.5195 .02851 L
.5243 .04375 L
.53425 .08424 L
.54523 .14007 L
.56624 .26469 L
.58548 .37656 L
.59527 .42531 L
.60437 .46309 L
.61385 .49349 L
.61887 .50558 L
.62147 .51073 L
.62422 .51535 L
.62677 .51888 L
.62957 .52191 L
.6308 .52297 L
.63211 .52392 L
.63335 .52465 L
.63449 .52517 L
.63518 .52542 L
.63592 .52562 L
.63666 .52578 L
.63747 .52588 L
.63818 .52591 L
.63893 .52588 L
.63965 .52581 L
.6403 .52569 L
.64154 .52535 L
.64224 .52509 L
.64289 .52481 L
.64419 .52412 L
.64561 .52318 L
.64823 .52093 L
.65071 .51824 L
.65535 .51176 L
.66577 .49115 L
.67522 .4665 L
Mistroke
.68562 .43462 L
.70666 .36236 L
.72771 .29002 L
.74697 .23096 L
.76709 .17974 L
.78576 .14215 L
.80476 .11272 L
.82549 .08885 L
.84602 .07167 L
.86464 .06016 L
.8839 .05115 L
.90472 .04377 L
.92468 .03831 L
.94574 .03376 L
.97619 .02867 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005P3oool3000000<0oooo0`00
000c0?ooo`<00000K03oool3000003D0oooo0`0000030?ooo`<000007P3oool001L0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo01/0oooo000=0?ooo`L000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0:03oool7000000D0oooo00<000000?ooo`3o
ool0K03oool00`000000oooo0?ooo`0b0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01/0oooo000G0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo06`0oooo00<00000
0?ooo`3oool0<`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06`3o
ool001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0340oooo0P00
001]0?ooo`800000=P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
6`3oool001H0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000<`3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo03@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00007@3oool001L0oooo00<000000?ooo`3oool00P3oool3000003D0oooo0`00001/0?ooo`<00000
=03oool00`000000oooo0?ooo`020?ooo`<000007P3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo3P3oool200000140oooo003o0?ooo`d0oooo00@000000?ooo`3oool00000403oool00?l0
oooo3@3oool010000000oooo0?ooo`00000@0?ooo`004@3ooood000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`005P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`L00000203oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`0;0?ooo`D000003`3oool001H0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0d0?ooo`@0000000<0oooo000000000000=P3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo00`0oooo00@000000?ooo`3oool000003`3oool008L0oooo0P000000103oool00000
0?ooo`3oool2000007h0oooo00@000000?ooo`3oool000003`3oool008L0oooo00@000000?ooo`3o
ool000000`3oool00`000000oooo0?ooo`1m0?ooo`<000003`3oool008H0oooo0P0000020?ooo`04
0000003oool0oooo0?ooo`800000T03oool001D0oooo00<000000?ooo`3oool0KP3oool01@000000
oooo0?ooo`3oool0000000<0oooo0P00002@0?ooo`005@3oool6000006X0oooo0P0000030?ooo`04
0000003oool0oooo0?ooo`<00000IP3oool800000240oooo000F0?ooo`X00000I@3oool00`000000
oooo0?ooo`020?ooo`8000000`3oool200000640oooo3@00000Q0?ooo`006`3oool:000005l0oooo
0P0000040?ooo`030000003oool0oooo0080oooo0P00001N0?ooo`P00000:@3oool00200oooo2000
001L0?ooo`800000103oool00`000000oooo0?ooo`020?ooo`800000G03oool6000002d0oooo000U
0?ooo`H00000F@3oool2000000@0oooo00<000000?ooo`3oool00P3oool3000005P0oooo1P00000`
0?ooo`009`3oool8000005@0oooo0`0000040?ooo`030000003oool0oooo00<0oooo0P00001F0?oo
o`H00000<P3oool002X0oooo2000001A0?ooo`8000001@3oool00`000000oooo0?ooo`030?ooo`80
0000D`3oool6000003D0oooo000_0?ooo`@00000D03oool2000000D0oooo00<000000?ooo`3oool0
0`3oool300000500oooo1P00000g0?ooo`00<@3oool4000004h0oooo0P0000050?ooo`8000001@3o
ool2000004l0oooo1000000j0?ooo`00<P3oool4000004d0oooo0P0000050?ooo`030000003oool0
oooo00@0oooo0P00001=0?ooo`@00000?03oool003@0oooo0`00001;0?ooo`8000001P3oool00`00
0000oooo0?ooo`040?ooo`800000C03oool4000003d0oooo000e0?ooo`@00000B@3oool2000000H0
oooo00<000000?ooo`3oool0103oool3000004X0oooo0`00000o0?ooo`00=P3oool4000004P0oooo
0P0000060?ooo`030000003oool0oooo00D0oooo0P0000180?ooo`@00000@03oool003P0oooo0`00
00160?ooo`<000001P3oool00`000000oooo0?ooo`050?ooo`800000A`3oool400000440oooo000i
0?ooo`<00000A@3oool2000000L0oooo00<000000?ooo`3oool01@3oool2000004H0oooo0`000013
0?ooo`00>P3oool3000004@0oooo0P0000070?ooo`030000003oool0oooo00H0oooo0P0000140?oo
o`<00000A03oool003/0oooo0`0000130?ooo`8000001`3oool2000000L0oooo0P0000130?ooo`<0
0000A@3oool003`0oooo0`0000110?ooo`<000001`3oool00`000000oooo0?ooo`060?ooo`800000
@P3oool3000004H0oooo000m0?ooo`800000@@3oool2000000P0oooo00<000000?ooo`3oool01P3o
ool200000480oooo0P0000170?ooo`00?P3oool200000400oooo0P0000080?ooo`030000003oool0
oooo00H0oooo0P0000110?ooo`800000B03oool003l0oooo0P00000f0?ooo`<000000`3oool00`00
0000oooo00000004000000H0oooo00<000000?ooo`3oool01P3oool200000400oooo0`0000180?oo
o`00@03oool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000001@3oool20000
00030?ooo`000000oooo00D0oooo00<000000?ooo`3oool01`3oool2000003l0oooo0P0000190?oo
o`00@03oool2000003@0oooo00D000000?ooo`3oool0oooo000000050?ooo`800000203oool00`00
0000oooo0?ooo`070?ooo`800000?P3oool2000004X0oooo00110?ooo`800000<`3oool01@000000
oooo0?ooo`3oool0000000D0oooo0`0000070?ooo`<000001`3oool2000003d0oooo0P00001;0?oo
o`00@P3oool200000380oooo00D000000?ooo`3oool0oooo000000040?ooo`8000000P3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00L0oooo0P00000l0?ooo`800000C03oool004<0
oooo00<000000?ooo`3oool0<03oool01@000000oooo0?ooo`3oool0000000@0oooo0P0000020?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool01`3oool2000003`0oooo00<000000?oo
o`3oool0B`3oool004<0oooo0P00000a0?ooo`050000003oool0oooo0?ooo`000000103oool20000
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`070?ooo`800000>`3oool20000
04d0oooo00140?ooo`030000003oool0oooo02l0oooo00D000000?ooo`3oool0oooo000000040?oo
o`8000000P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00L0oooo0P00000j0?oo
o`800000CP3oool004@0oooo0P00000a0?ooo`<000001@3oool4000000L0oooo00<000000?ooo`3o
ool0203oool2000003T0oooo00<000000?ooo`3oool0C@3oool004D0oooo00<000000?ooo`3oool0
=`3oool2000000T0oooo00<000000?ooo`3oool0203oool2000003P0oooo0P00001?0?ooo`00A@3o
ool2000003P0oooo0P0000090?ooo`030000003oool0oooo00P0oooo0P00000h0?ooo`030000003o
ool0oooo04h0oooo00160?ooo`030000003oool0oooo03D0oooo0P00000:0?ooo`8000002@3oool2
000003L0oooo0P00001@0?ooo`00AP3oool2000003H0oooo0P00000:0?ooo`030000003oool0oooo
00P0oooo0P00000g0?ooo`030000003oool0oooo04l0oooo00170?ooo`030000003oool0oooo03@0
oooo0P00000:0?ooo`030000003oool0oooo00T0oooo0P00000f0?ooo`030000003oool0oooo04l0
oooo00170?ooo`800000=@3oool2000000X0oooo00<000000?ooo`3oool02@3oool2000003D0oooo
0P00001A0?ooo`00B03oool00`000000oooo0?ooo`0c0?ooo`8000002P3oool00`000000oooo0?oo
o`090?ooo`800000=@3oool00`000000oooo0?ooo`1@0?ooo`00B03oool2000003@0oooo0P00000:
0?ooo`030000003oool0oooo00T0oooo0P00000d0?ooo`800000DP3oool004T0oooo00<000000?oo
o`3oool0<P3oool2000000X0oooo00<000000?ooo`3oool02@3oool2000003<0oooo0P00001C0?oo
o`00B@3oool200000380oooo0P00000;0?ooo`8000002`3oool200000380oooo0P00001C0?ooo`00
BP3oool00`000000oooo0?ooo`0`0?ooo`8000002`3oool00`000000oooo0?ooo`0:0?ooo`800000
<@3oool3000005<0oooo001:0?ooo`800000<@3oool2000000/0oooo00<000000?ooo`3oool02P3o
ool200000340oooo0P00001D0?ooo`00B`3oool00`000000oooo0?ooo`0_0?ooo`8000002`3oool0
0`000000oooo0?ooo`0:0?ooo`800000<@3oool2000005@0oooo001;0?ooo`800000<03oool20000
00/0oooo00<000000?ooo`3oool02P3oool200000300oooo0`00001D0?ooo`00C03oool00`000000
oooo0?ooo`0^0?ooo`8000002`3oool00`000000oooo0?ooo`0;0?ooo`800000;`3oool2000005D0
oooo001<0?ooo`800000;P3oool2000000`0oooo00<000000?ooo`3oool02`3oool2000002h0oooo
0`00001E0?ooo`00C03oool2000002h0oooo0P00000<0?ooo`030000003oool0oooo00/0oooo0P00
000^0?ooo`800000EP3oool004`0oooo0`00000]0?ooo`800000303oool2000000`0oooo0P00000^
0?ooo`800000EP3oool004d0oooo0P00000]0?ooo`800000303oool00`000000oooo0?ooo`0;0?oo
o`800000;@3oool3000005H0oooo001=0?ooo`800000;@3oool2000000`0oooo00<000000?ooo`3o
ool0303oool2000002`0oooo0P00001G0?ooo`00C@3oool3000002`0oooo0P00000<0?ooo`030000
003oool0oooo00`0oooo0P00000[0?ooo`<00000E`3oool004h0oooo0P00000W0?ooo`<0000000@0
oooo00000000000000001@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00`0oooo
0P00000[0?ooo`800000F03oool004h0oooo0P00000V0?ooo`040000003oool0oooo0?ooo`<00000
1P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00`0oooo0P00000[0?ooo`800000
F03oool004h0oooo0`00000U0?ooo`040000003oool0oooo0?ooo`<000000P3oool6000000D0oooo
00<000000?ooo`3oool0303oool2000002X0oooo0`00001H0?ooo`00C`3oool2000002D0oooo00@0
00000?ooo`3oool0oooo0`0000020?ooo`050000003oool0oooo0?ooo`0000001P3oool3000000d0
oooo0P00000Y0?ooo`800000F@3oool004l0oooo0P00000U0?ooo`040000003oool0oooo0?ooo`<0
00000`3oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo00d0oooo0P00000Y0?oo
o`800000F@3oool004l0oooo0`00000T0?ooo`040000003oool0oooo0?ooo`<00000103oool00`00
0000oooo000000060?ooo`030000003oool0oooo00d0oooo0P00000X0?ooo`<00000F@3oool00500
oooo0P00000T0?ooo`040000003oool0oooo0?ooo`8000001@3oool00`000000oooo000000060?oo
o`030000003oool0oooo00d0oooo0P00000X0?ooo`800000FP3oool00500oooo0P00000T0?ooo`04
0000003oool0oooo0?ooo`8000001P3oool2000000H0oooo00<000000?ooo`3oool03@3oool20000
02P0oooo0P00001J0?ooo`00D03oool3000002@0oooo1@0000070?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool03@3oool2000002L0oooo0`00001J0?ooo`00D@3oool2000002L0oooo
0P00000>0?ooo`030000003oool0oooo00h0oooo0P00000V0?ooo`800000F`3oool00540oooo0P00
000W0?ooo`8000003P3oool00`000000oooo0?ooo`0>0?ooo`8000009P3oool2000005/0oooo001A
0?ooo`<000009@3oool2000000l0oooo0P00000?0?ooo`8000009@3oool3000005/0oooo001B0?oo
o`8000009@3oool2000000l0oooo00<000000?ooo`3oool03P3oool2000002D0oooo0P00001L0?oo
o`00DP3oool2000002D0oooo0P00000?0?ooo`030000003oool0oooo00h0oooo0P00000U0?ooo`80
0000G03oool00580oooo0P00000U0?ooo`8000003`3oool00`000000oooo0?ooo`0>0?ooo`800000
903oool3000005`0oooo001B0?ooo`<00000903oool2000000l0oooo00<000000?ooo`3oool03`3o
ool2000002<0oooo0P00001M0?ooo`00D`3oool2000002@0oooo0P00000?0?ooo`030000003oool0
oooo00l0oooo0P00000S0?ooo`800000G@3oool005<0oooo0P00000S0?ooo`800000403oool00`00
0000oooo0?ooo`0?0?ooo`8000008P3oool3000005d0oooo001C0?ooo`<000008P3oool200000100
oooo0P00000@0?ooo`8000008P3oool2000005h0oooo001D0?ooo`8000008P3oool200000100oooo
00<000000?ooo`3oool03`3oool200000280oooo0P00001N0?ooo`00E03oool200000280oooo0P00
000@0?ooo`030000003oool0oooo00l0oooo0P00000R0?ooo`800000GP3oool005@0oooo0`00000Q
0?ooo`800000403oool00`000000oooo0?ooo`0?0?ooo`8000008@3oool3000005h0oooo001E0?oo
o`800000803oool200000140oooo00<000000?ooo`3oool0403oool200000200oooo0P00001O0?oo
o`00E@3oool200000200oooo0P00000A0?ooo`030000003oool0oooo0100oooo0P00000P0?ooo`80
0000G`3oool005D0oooo0P00000P0?ooo`8000004@3oool00`000000oooo0?ooo`0@0?ooo`800000
7`3oool3000005l0oooo001E0?ooo`<000007`3oool200000140oooo00<000000?ooo`3oool0403o
ool2000001l0oooo0P00001P0?ooo`00EP3oool2000001l0oooo0P00000A0?ooo`8000004@3oool2
000001l0oooo0P00001P0?ooo`00EP3oool2000001l0oooo0P00000A0?ooo`030000003oool0oooo
0100oooo0P00000O0?ooo`800000H03oool005H0oooo0`00000M0?ooo`8000004P3oool00`000000
oooo0?ooo`0@0?ooo`8000007P3oool300000600oooo001G0?ooo`8000007@3oool200000180oooo
00<000000?ooo`3oool04@3oool2000001d0oooo0P00001Q0?ooo`00E`3oool2000001d0oooo1000
00030?ooo`030000003oool0oooo00<000001`3oool00`000000oooo0?ooo`0A0?ooo`8000007@3o
ool200000640oooo001G0?ooo`<00000703oool200000080oooo00<000000?ooo`3oool00P3oool0
1@000000oooo0?ooo`3oool0000000H0oooo00<000000?ooo`3oool04@3oool2000001`0oooo0`00
001Q0?ooo`00F03oool2000001`0oooo0P0000020?ooo`030000003oool0oooo0080oooo00D00000
0?ooo`3oool0oooo000000060?ooo`030000003oool0oooo0140oooo0P00000L0?ooo`800000HP3o
ool005P0oooo0P00000K0?ooo`8000000`3oool00`000000oooo0?ooo`020?ooo`050000003oool0
oooo0?ooo`0000001P3oool300000140oooo0P00000L0?ooo`800000HP3oool005P0oooo0`00000J
0?ooo`8000000`3oool00`000000oooo0?ooo`020?ooo`8000000P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo0140oooo0P00000L0?ooo`800000HP3oool005T0oooo0P00000J0?oo
o`8000000`3oool00`000000oooo0?ooo`020?ooo`040000003oool00000000000L0oooo00<00000
0?ooo`3oool04@3oool3000001X0oooo0`00001R0?ooo`00F@3oool2000001X0oooo0P0000030?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0B0?oo
o`8000006P3oool2000006<0oooo001I0?ooo`8000006P3oool2000000<0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0180oooo0P00000J0?ooo`80
0000H`3oool005T0oooo0`00000H0?ooo`80000000@0oooo0000000000000000203oool2000000H0
oooo00<000000?ooo`3oool04P3oool2000001T0oooo0`00001S0?ooo`00FP3oool2000001P0oooo
0P00000D0?ooo`030000003oool0oooo0180oooo0`00000H0?ooo`800000I03oool005X0oooo0P00
000H0?ooo`800000503oool00`000000oooo0?ooo`0C0?ooo`800000603oool2000006@0oooo001J
0?ooo`<000005`3oool2000001@0oooo0P00000D0?ooo`800000603oool2000006@0oooo001K0?oo
o`8000005`3oool2000001@0oooo00<000000?ooo`3oool04`3oool2000001L0oooo0`00001T0?oo
o`00F`3oool2000001H0oooo0P00000E0?ooo`030000003oool0oooo01<0oooo0`00000F0?ooo`80
0000I@3oool005/0oooo0P00000F0?ooo`8000005@3oool00`000000oooo0?ooo`0D0?ooo`800000
5P3oool2000006D0oooo001K0?ooo`<000005@3oool2000001D0oooo00<000000?ooo`3oool0503o
ool2000001D0oooo0`00001U0?ooo`00G03oool2000001D0oooo0P00000E0?ooo`030000003oool0
oooo01@0oooo0P00000E0?ooo`800000IP3oool005`0oooo0P00000E0?ooo`8000005@3oool00`00
0000oooo0?ooo`0D0?ooo`<00000503oool2000006H0oooo001L0?ooo`800000503oool2000001H0
oooo00<000000?ooo`3oool05@3oool2000001@0oooo0P00001V0?ooo`00G03oool3000001<0oooo
0P00000F0?ooo`8000005P3oool2000001<0oooo0`00001V0?ooo`00G@3oool2000001<0oooo0P00
000F0?ooo`030000003oool0oooo01D0oooo0P00000C0?ooo`800000I`3oool005d0oooo0P00000C
0?ooo`8000005P3oool00`000000oooo0?ooo`0E0?ooo`8000004`3oool2000006L0oooo001M0?oo
o`<000004@3oool3000001H0oooo00<000000?ooo`3oool05@3oool300000140oooo0`00001W0?oo
o`00GP3oool200000140oooo0P00000G0?ooo`030000003oool0oooo01H0oooo0P00000A0?ooo`80
0000J03oool005h0oooo0P00000A0?ooo`8000005`3oool00`000000oooo0?ooo`0F0?ooo`800000
403oool3000006P0oooo001N0?ooo`8000004@3oool2000001L0oooo00<000000?ooo`3oool05P3o
ool200000100oooo0P00001Y0?ooo`00G`3oool00`000000oooo0?ooo`0?0?ooo`8000005`3oool2
000001L0oooo0`00000?0?ooo`800000J@3oool005l0oooo0P00000?0?ooo`<000005`3oool00`00
0000oooo0?ooo`0G0?ooo`8000003P3oool3000006T0oooo001P0?ooo`030000003oool0oooo00d0
oooo0P00000H0?ooo`030000003oool0oooo01L0oooo0P00000>0?ooo`800000JP3oool00600oooo
0P00000=0?ooo`<00000603oool00`000000oooo0?ooo`0G0?ooo`8000003P3oool2000006X0oooo
001Q0?ooo`030000003oool0oooo00/0oooo0P00000I0?ooo`030000003oool0oooo01L0oooo0`00
000<0?ooo`<00000JP3oool00640oooo0P00000<0?ooo`8000001P3oool3000000<0oooo00<00000
0?ooo`3oool00`0000070?ooo`030000003oool0oooo01P0oooo0P00000<0?ooo`800000J`3oool0
0680oooo00<000000?ooo`3oool02@3oool3000000D0oooo00D000000?ooo`3oool0oooo00000004
0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`0H0?ooo`800000303o
ool2000006/0oooo001R0?ooo`8000002P3oool2000000H0oooo00D000000?ooo`3oool0oooo0000
00040?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`0H0?ooo`<00000
2`3oool00`000000oooo0?ooo`1Z0?ooo`00HP3oool2000000T0oooo0`0000060?ooo`050000003o
ool0oooo0?ooo`0000001@3oool00`000000oooo000000070?ooo`<000006@3oool2000000X0oooo
0P00001/0?ooo`00HP3oool3000000P0oooo0P0000070?ooo`050000003oool0oooo0?ooo`000000
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo01T0oooo0P0000090?ooo`800000
K@3oool006<0oooo0P0000080?ooo`8000001`3oool01@000000oooo0?ooo`3oool0000000D0oooo
00<000000?ooo`0000001`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool0K03oool006<0oooo0`0000070?ooo`030000003oool0oooo00H0oooo00D0
00000?ooo`3oool0oooo000000040?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000
oooo0?ooo`0J0?ooo`8000001`3oool2000006h0oooo001T0?ooo`<000001@3oool2000000P0oooo
00D000000?ooo`3oool0oooo000000040?ooo`050000003oool0oooo0?ooo`0000001P3oool00`00
0000oooo0?ooo`0K0?ooo`8000001@3oool2000006l0oooo001U0?ooo`800000103oool2000000X0
oooo0`0000060?ooo`<000001`3oool00`000000oooo0?ooo`0K0?ooo`800000103oool3000006l0
oooo001U0?ooo`<000000P3oool3000001d0oooo00<000000?ooo`3oool06`3oool3000000<0oooo
0P00001`0?ooo`00IP3oool6000001h0oooo0P00000L0?ooo`P00000L03oool006L0oooo1@00000N
0?ooo`030000003oool0oooo01`0oooo1P00001a0?ooo`00RP3oool00`000000oooo0?ooo`2C0?oo
o`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000
003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo
00<000000?ooo`3oool0T`3oool00800oooo0`0000070?ooo`030000003oool0oooo09<0oooo0021
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`<0
0000T`3oool00840oooo00<000000?ooo`3oool0W03oool00840oooo00<000000?ooo`3oool0W03o
ool00840oooo00<000000?ooo`3oool0W03oool00800oooo0P00002N0?ooo`00P@3oool00`000000
oooo0?ooo`2L0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9695, -0.123125, \
0.086157, 0.00663834}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(\ \)\(Here\ is\ the\ Exact\ Variance\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(Exact\ Here\ is\ the\ Variance ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ sig\  = \ 2, \ 
      k\  = \ 3/4\ *) \)\(\[IndentingNewLine]\)\(Plot[\[IndentingNewLine]\ 
      NIntegrate[\ \ \((1/2 \((\ 
                    d\  - \ Sqrt[
                        d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ \ phi[
              d, \ th, \ 
              2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
        NIntegrate[\ \((\ 
                1/2 \((\ 
                    d\  + \ Sqrt[
                        d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ \ phi[
              d, \ th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
            Infinity}] - \ \((NIntegrate[\ \ 1/2 \((\ 
                    d\  - \ Sqrt[
                        d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ phi[d, \ 
                    th, \ 2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
              NIntegrate[\ 
                1/2 \((\ 
                    d\  + \ Sqrt[
                        d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ \ phi[d, \ 
                    th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                  Infinity}])\)^2, \[IndentingNewLine]{th, \(-10\), 10}, \ 
      PlotRange\  \[Rule] \ {0, \ 7}, \ 
      AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
      PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \[IndentingNewLine]\ 
      DefaultFont\  \[Rule] \ {"\<Times\>", 12}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 -2.08167e-017 0.0882906 [
[.02381 -0.0125 -12.1875 -15.5 ]
[.02381 -0.0125 12.1875 0 ]
[.2619 -0.0125 -9.1875 -15.5 ]
[.2619 -0.0125 9.1875 0 ]
[.7381 -0.0125 -5 -15.5 ]
[.7381 -0.0125 5 0 ]
[.97619 -0.0125 -8 -15.5 ]
[.97619 -0.0125 8 0 ]
[1.025 0 0 -7.75 ]
[1.025 0 9.4375 7.75 ]
[.4875 .08829 -10 -7.75 ]
[.4875 .08829 0 7.75 ]
[.4875 .17658 -10 -7.75 ]
[.4875 .17658 0 7.75 ]
[.4875 .26487 -10 -7.75 ]
[.4875 .26487 0 7.75 ]
[.4875 .35316 -10 -7.75 ]
[.4875 .35316 0 7.75 ]
[.4875 .44145 -10 -7.75 ]
[.4875 .44145 0 7.75 ]
[.4875 .52974 -10 -7.75 ]
[.4875 .52974 0 7.75 ]
[.4875 .61803 -10 -7.75 ]
[.4875 .61803 0 7.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -73.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -66 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .08829 m
.50625 .08829 L
s
gsave
.4875 .08829 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .17658 m
.50625 .17658 L
s
gsave
.4875 .17658 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .26487 m
.50625 .26487 L
s
gsave
.4875 .26487 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 .35316 m
.50625 .35316 L
s
gsave
.4875 .35316 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .44145 m
.50625 .44145 L
s
gsave
.4875 .44145 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 .52974 m
.50625 .52974 L
s
gsave
.4875 .52974 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01766 m
.50375 .01766 L
s
.5 .03532 m
.50375 .03532 L
s
.5 .05297 m
.50375 .05297 L
s
.5 .07063 m
.50375 .07063 L
s
.5 .10595 m
.50375 .10595 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .14126 m
.50375 .14126 L
s
.5 .15892 m
.50375 .15892 L
s
.5 .19424 m
.50375 .19424 L
s
.5 .2119 m
.50375 .2119 L
s
.5 .22956 m
.50375 .22956 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .28253 m
.50375 .28253 L
s
.5 .30019 m
.50375 .30019 L
s
.5 .31785 m
.50375 .31785 L
s
.5 .3355 m
.50375 .3355 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .38848 m
.50375 .38848 L
s
.5 .40614 m
.50375 .40614 L
s
.5 .42379 m
.50375 .42379 L
s
.5 .45911 m
.50375 .45911 L
s
.5 .47677 m
.50375 .47677 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .51209 m
.50375 .51209 L
s
.5 .5474 m
.50375 .5474 L
s
.5 .56506 m
.50375 .56506 L
s
.5 .58272 m
.50375 .58272 L
s
.5 .60038 m
.50375 .60038 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .37182 m
.04262 .37434 L
.06244 .37778 L
.08255 .38244 L
.10458 .3894 L
.12415 .39777 L
.14509 .40956 L
.18653 .44266 L
.22646 .48316 L
.24474 .50063 L
.25514 .50899 L
.26022 .51246 L
.26488 .51521 L
.26945 .51747 L
.27443 .51938 L
.27717 .52016 L
.2785 .52047 L
.2797 .52071 L
.28087 .5209 L
.28213 .52107 L
.28282 .52114 L
.28346 .5212 L
.28471 .52127 L
.28593 .52129 L
.28724 .52127 L
.28847 .5212 L
.28959 .5211 L
.29091 .52092 L
.29234 .52067 L
.29494 .52005 L
.29766 .51915 L
.30055 .51793 L
.30574 .51501 L
.31063 .51138 L
.31511 .50729 L
.32522 .49539 L
.33412 .48183 L
.3435 .46457 L
.3816 .36959 L
.42216 .25374 L
.4409 .20765 L
.46121 .16906 L
.4666 .16121 L
.47232 .15411 L
.47761 .14867 L
.48256 .14459 L
.48718 .14169 L
.48978 .14044 L
.49215 .13955 L
.49341 .13917 L
Mistroke
.49474 .13884 L
.49551 .13868 L
.49621 .13856 L
.49692 .13846 L
.49757 .13838 L
.49884 .13829 L
.49951 .13827 L
.50022 .13826 L
.5014 .1383 L
.50271 .13841 L
.50402 .1386 L
.50523 .13883 L
.50656 .13916 L
.50796 .13959 L
.51033 .14049 L
.51294 .14175 L
.51775 .14482 L
.52226 .14854 L
.53233 .1598 L
.54318 .17623 L
.56326 .21714 L
.58438 .27156 L
.62254 .38128 L
.64383 .43682 L
.66315 .47711 L
.67281 .49263 L
.6779 .49946 L
.68327 .50565 L
.68798 .51019 L
.69315 .51426 L
.69785 .51714 L
.70225 .51912 L
.70484 .51999 L
.70724 .52059 L
.7085 .52083 L
.70988 .52103 L
.71057 .52111 L
.71132 .52118 L
.71203 .52123 L
.71268 .52127 L
.71387 .52129 L
.71498 .52128 L
.7162 .52122 L
.7175 .52111 L
.71815 .52104 L
.71887 .52094 L
.72016 .52074 L
.72257 .52023 L
.7248 .51962 L
.72726 .5188 L
Mistroke
.73222 .5167 L
.74112 .51159 L
.76055 .49586 L
.78143 .47505 L
.82268 .43421 L
.84328 .41753 L
.8624 .40497 L
.8809 .39538 L
.90062 .38755 L
.92204 .38125 L
.94222 .37688 L
.95992 .37396 L
.97619 .37182 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005P3oool3000000<0oooo0`00
000c0?ooo`<00000K03oool3000003D0oooo0`0000030?ooo`<000007P3oool001L0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo01/0oooo000=0?ooo`L000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0:03oool7000000D0oooo00<000000?ooo`3o
ool0K03oool00`000000oooo0?ooo`0b0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01/0oooo000G0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo06`0oooo00<00000
0?ooo`3oool0<`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06`3o
ool001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0340oooo0P00
001]0?ooo`800000=P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
6`3oool001H0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000<`3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo03@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00007@3oool001L0oooo00<000000?ooo`3oool00P3oool3000003D0oooo0`00001/0?ooo`<00000
=03oool00`000000oooo0?ooo`020?ooo`<000007P3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo3P3oool200000140oooo003o0?ooo`d0oooo00@000000?ooo`3oool00000403oool00?l0
oooo3@3oool010000000oooo0?ooo`00000@0?ooo`004@3ooood000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`005P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02`3oool5000000l0oooo000F0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0303oool010000000oooo0?ooo`00000?0?ooo`00RP3oool00`000000oooo
0?ooo`200?ooo`040000003oool0oooo000000l0oooo002:0?ooo`800000PP3oool3000000l0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000
U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo00200?ooo`<00000
1`3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo09<0oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool0
0840oooo00<000000?ooo`3oool01P3oool3000009<0oooo00210?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo0020
0?ooo`800000203oool2000009@0oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0
T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00Q`3oool800000940oooo
00250?ooo``00000S`3oool008D0oooo0`0000020?ooo`040000003oool0oooo0?ooo`<00000S`3o
ool008@0oooo0P0000040?ooo`030000003oool0oooo00<0oooo0P00002>0?ooo`00PP3oool30000
00D0oooo00<000000?ooo`3oool0103oool2000008d0oooo00220?ooo`<000001@3oool2000000H0
oooo00<000000?ooo`3oool0R`3oool007l0oooo1@0000060?ooo`030000003oool0oooo00D0oooo
0P00002<0?ooo`00P03oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`3oool01P3o
ool2000008/0oooo00200?ooo`800000203oool00`000000oooo0?ooo`070?ooo`800000RP3oool0
0800oooo00<000000?ooo`0000001`3oool3000000P0oooo00<000000?ooo`3oool0R03oool007l0
oooo0P0000020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0203oool2000008T0
oooo001o0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo08L0oooo001n0?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00T0oooo0P0000280?ooo`00OP3oool2000000<0oooo00<000000?ooo`3oool0103o
ool2000000/0oooo00<000000?ooo`3oool0QP3oool007d0oooo0P000000103oool0000000000000
00070?ooo`030000003oool0oooo00X0oooo0P0000270?ooo`00O@3oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0Q@3oool007`0oooo0P00000<0?oo
o`030000003oool0oooo00/0oooo0P0000260?ooo`00O03oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00`0oooo00<000000?ooo`3oool0Q03oool007/0oooo0P00000=0?ooo`800000
3@3oool2000008D0oooo001k0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool03@3o
ool00`000000oooo0?ooo`230?ooo`00NP3oool2000000h0oooo00<000000?ooo`3oool03@3oool2
000008@0oooo001j0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool03@3oool20000
08@0oooo001i0?ooo`8000003`3oool2000000h0oooo0`0000230?ooo`00N@3oool00`000000oooo
0?ooo`0>0?ooo`030000003oool0oooo00h0oooo0P0000230?ooo`00N@3oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo00h0oooo0`0000220?ooo`00N03oool200000100oooo00<00000
0?ooo`3oool03`3oool200000880oooo001h0?ooo`030000003oool0oooo00l0oooo0P00000@0?oo
o`800000PP3oool007L0oooo0P00000A0?ooo`030000003oool0oooo00l0oooo0`0000210?ooo`00
M`3oool00`000000oooo0?ooo`050?ooo`@000001`3oool00`000000oooo0?ooo`0@0?ooo`800000
P@3oool007H0oooo0P00000;0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0403o
ool300000800oooo001f0?ooo`8000002`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0140oooo0P0000200?ooo`00M@3oool3000000/0oooo00<000000?ooo`3oool0103oool30000
0140oooo0P0000200?ooo`00M@3oool2000000X0oooo0P0000070?ooo`030000003oool0oooo0140
oooo0`00001o0?ooo`00M@3oool2000000/0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0B0?ooo`800000O`3oool007@0oooo0`00000<0?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool04P3oool2000007l0oooo001d0?ooo`8000002@3oool01@000000oooo0?ooo`3o
ool0000000H0oooo0P00000C0?ooo`<00000OP3oool007@0oooo0P00000:0?ooo`<000001`3oool0
0`000000oooo0?ooo`0C0?ooo`800000OP3oool007<0oooo0`00000D0?ooo`030000003oool0oooo
01<0oooo0P00001n0?ooo`00L`3oool2000001D0oooo00<000000?ooo`3oool04`3oool3000007d0
oooo001c0?ooo`8000005@3oool2000001D0oooo0P00001m0?ooo`00LP3oool3000001D0oooo00<0
00000?ooo`3oool0503oool2000007d0oooo001b0?ooo`8000005P3oool00`000000oooo0?ooo`0D
0?ooo`<00000O03oool00780oooo0P00000F0?ooo`030000003oool0oooo01D0oooo0P00001l0?oo
o`00LP3oool2000001H0oooo00<000000?ooo`3oool05@3oool2000007`0oooo001a0?ooo`<00000
5P3oool2000001H0oooo0`00001k0?ooo`00L@3oool2000001L0oooo00<000000?ooo`3oool05P3o
ool2000007/0oooo001a0?ooo`8000005`3oool00`000000oooo0?ooo`0F0?ooo`800000N`3oool0
0700oooo0`00000G0?ooo`030000003oool0oooo01H0oooo0`00001j0?ooo`00L03oool2000001P0
oooo0P00000H0?ooo`800000NP3oool00700oooo0P00000A0?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool05`3oool2000007X0oooo001_0?ooo`<000004@3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo01L0oooo0`00001i0?ooo`00K`3oool2000000h0oooo1P000005
0?ooo`030000003oool0oooo01P0oooo0P00001i0?ooo`00K`3oool2000000h0oooo00D000000?oo
o`3oool0oooo000000060?ooo`<00000603oool2000007T0oooo001^0?ooo`<000003`3oool01000
0000oooo0?ooo`0000060?ooo`030000003oool0oooo01P0oooo0`00001h0?ooo`00KP3oool20000
0140oooo00<000000?ooo`0000001P3oool00`000000oooo0?ooo`0I0?ooo`800000N03oool006h0
oooo0P00000A0?ooo`030000003oool0000000H0oooo00<000000?ooo`3oool06@3oool2000007P0
oooo001]0?ooo`<000004P3oool2000000H0oooo0P00000J0?ooo`<00000M`3oool001D0oooo2`00
001=0?ooo`800000503oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01X0oooo0P00
001=0?ooo`T000008@3oool001D0oooo400000170?ooo`<000006`3oool00`000000oooo0?ooo`0J
0?ooo`800000B03oool>00000240oooo000P0?ooo`P00000A03oool2000001`0oooo00<000000?oo
o`3oool06P3oool3000004@0oooo2000000Z0?ooo`009@3oool600000440oooo0P00000L0?ooo`03
0000003oool0oooo01/0oooo0P0000120?ooo`H00000;P3oool002L0oooo1P00000n0?ooo`<00000
703oool2000001`0oooo0P00000m0?ooo`P00000<@3oool002X0oooo1P00000k0?ooo`8000007@3o
ool00`000000oooo0?ooo`0K0?ooo`<00000>`3oool6000003@0oooo000/0?ooo`H00000>03oool3
000001d0oooo00<000000?ooo`3oool0703oool2000003T0oooo1000000h0?ooo`00;`3oool40000
03L0oooo0P00000N0?ooo`030000003oool0oooo01`0oooo0P00000h0?ooo`@00000>@3oool00340
oooo1000000d0?ooo`<000007P3oool2000001d0oooo0`00000e0?ooo`@00000>`3oool00380oooo
1000000c0?ooo`8000007`3oool00`000000oooo0?ooo`0M0?ooo`800000=03oool4000003`0oooo
000d0?ooo`<00000<@3oool3000001l0oooo00<000000?ooo`3oool07@3oool300000340oooo1000
000n0?ooo`00=@3oool4000002l0oooo0P00000P0?ooo`030000003oool0oooo01h0oooo0P00000`
0?ooo`@00000?`3oool003H0oooo1000000^0?ooo`800000803oool2000001l0oooo0P00000^0?oo
o`@00000@@3oool003P0oooo0`00000/0?ooo`<00000803oool00`000000oooo0?ooo`0N0?ooo`<0
0000;03oool400000480oooo000i0?ooo`<00000:`3oool2000001H0oooo0`0000080?ooo`030000
003oool0oooo01l0oooo0P00000[0?ooo`<00000A03oool003X0oooo1000000X0?ooo`<000006@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01l0oooo0P00000Z0?ooo`<00000A@3o
ool003/0oooo1000000W0?ooo`8000006`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0200oooo00<000000?ooo`3oool09`3oool3000004H0oooo000m0?ooo`<000009@3oool30000
01/0oooo00<000000?ooo`3oool0103oool300000200oooo0P00000W0?ooo`<00000A`3oool003h0
oooo0`00000T0?ooo`800000703oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool0903oool3000004P0oooo000o0?ooo`<000008`3oool2000001/0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0Q0?ooo`800000903oool3000004T0oooo
00100?ooo`<000008@3oool3000001T0oooo0P0000080?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool08@3oool3000004X0oooo00110?ooo`<00000803oool2000001X0oooo00<00000
0?ooo`3oool01`3oool2000002<0oooo0P00000Q0?ooo`<00000B`3oool00480oooo0`00000N0?oo
o`<000006`3oool3000000H0oooo00<000000?ooo`3oool08`3oool2000001l0oooo0`00001<0?oo
o`00@`3oool3000001d0oooo0P00000U0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3o
ool0703oool3000004d0oooo00140?ooo`<000006`3oool3000002D0oooo00<000000?ooo`3oool0
903oool2000001`0oooo0`00001>0?ooo`00A@3oool3000001X0oooo0P00000V0?ooo`8000009P3o
ool00`000000oooo0?ooo`0I0?ooo`<00000C`3oool004H0oooo0`00000I0?ooo`8000009P3oool0
0`000000oooo0?ooo`0U0?ooo`8000006@3oool300000500oooo00170?ooo`<00000603oool00`00
0000oooo0?ooo`0U0?ooo`030000003oool0oooo02H0oooo0P00000G0?ooo`<00000D@3oool004P0
oooo0`00000F0?ooo`8000009`3oool00`000000oooo0?ooo`0W0?ooo`8000005@3oool300000580
oooo00190?ooo`<00000503oool2000002P0oooo00<000000?ooo`3oool0:03oool00`000000oooo
0?ooo`0B0?ooo`<00000D`3oool004X0oooo0`00000B0?ooo`800000:@3oool2000002T0oooo0P00
000B0?ooo`<00000E03oool004/0oooo0`00000@0?ooo`<00000:@3oool00`000000oooo0?ooo`0Y
0?ooo`8000003`3oool4000005D0oooo001<0?ooo`@000003@3oool3000002X0oooo00<000000?oo
o`3oool0:@3oool3000000d0oooo1000001F0?ooo`00C@3oool4000000/0oooo0`00000[0?ooo`03
0000003oool0oooo02X0oooo1000000:0?ooo`<00000F03oool004l0oooo0`0000090?ooo`<00000
;03oool2000002`0oooo100000070?ooo`@00000F@3oool00500oooo100000050?ooo`@000008`3o
ool3000000L0oooo00<000000?ooo`3oool0;@3oool3000000D0oooo1000001J0?ooo`00D@3oool;
000002<0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003oool0oooo02h0oooo2@00
001L0?ooo`00D`3oool7000002D0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003o
ool0oooo02l0oooo1`00001M0?ooo`00O`3oool01@000000oooo0?ooo`3oool0000000H0oooo0`00
002C0?ooo`00O`3oool200000080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2C
0?ooo`00O`3oool010000000oooo0000000000070?ooo`030000003oool0oooo09<0oooo00200?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`2C0?ooo`00PP3oool2000000H0oooo0P00002D0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0
T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0
oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool00880oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`2C0?ooo`00PP3oool00`000000oooo0?ooo`05
0?ooo`<00000T`3oool00880oooo00<000000?ooo`3oool0V`3oool00880oooo00<000000?ooo`3o
ool0V`3oool008<0oooo00<000000?ooo`3oool0VP3oool007l0oooo00D000000?ooo`3oool0oooo
0000002L0?ooo`00P03oool4000009`0oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9695, -0.861873, \
0.086157, 0.0464683}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[""], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(Plot[{2\ Sqrt[2\ k\  - \ 1], \ 
        Sqrt[2\ Log[\((k - 1/2 + 0.01)\)*\ 2^13]]}, {k, 1/2, \ 
        1}, \[IndentingNewLine]\ PlotRange\  \[Rule] \ All, \ 
      AxesLabel\  \[Rule] \ {k, \[Lambda]}, \ 
      PlotStyle\  \[Rule] \ {{Thickness[
              0.01]}, {Dashing[{0.02}]}}, \[IndentingNewLine]\ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
-0.928572 1.90476 0.0146562 0.144156 [
[.02381 .00216 -9.125 -15.75 ]
[.02381 .00216 9.125 0 ]
[.21429 .00216 -9.125 -15.75 ]
[.21429 .00216 9.125 0 ]
[.40476 .00216 -9.125 -15.75 ]
[.40476 .00216 9.125 0 ]
[.59524 .00216 -9.125 -15.75 ]
[.59524 .00216 9.125 0 ]
[.78571 .00216 -9.125 -15.75 ]
[.78571 .00216 9.125 0 ]
[1.025 .01466 0 -7.875 ]
[1.025 .01466 23.9375 7.875 ]
[.96369 .15881 -9.6875 -7.875 ]
[.96369 .15881 0 7.875 ]
[.96369 .30297 -9.6875 -7.875 ]
[.96369 .30297 0 7.875 ]
[.96369 .44712 -9.6875 -7.875 ]
[.96369 .44712 0 7.875 ]
[.96369 .59128 -9.6875 -7.875 ]
[.96369 .59128 0 7.875 ]
[.97619 .64303 -5.09375 0 ]
[.97619 .64303 5.09375 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01466 m
.02381 .02091 L
s
gsave
.02381 .00216 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.21429 .01466 m
.21429 .02091 L
s
gsave
.21429 .00216 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.6) show
1.000 setlinewidth
grestore
.40476 .01466 m
.40476 .02091 L
s
gsave
.40476 .00216 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.7) show
1.000 setlinewidth
grestore
.59524 .01466 m
.59524 .02091 L
s
gsave
.59524 .00216 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.8) show
1.000 setlinewidth
grestore
.78571 .01466 m
.78571 .02091 L
s
gsave
.78571 .00216 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.9) show
1.000 setlinewidth
grestore
.125 Mabswid
.0619 .01466 m
.0619 .01841 L
s
.1 .01466 m
.1 .01841 L
s
.1381 .01466 m
.1381 .01841 L
s
.17619 .01466 m
.17619 .01841 L
s
.25238 .01466 m
.25238 .01841 L
s
.29048 .01466 m
.29048 .01841 L
s
.32857 .01466 m
.32857 .01841 L
s
.36667 .01466 m
.36667 .01841 L
s
.44286 .01466 m
.44286 .01841 L
s
.48095 .01466 m
.48095 .01841 L
s
.51905 .01466 m
.51905 .01841 L
s
.55714 .01466 m
.55714 .01841 L
s
.63333 .01466 m
.63333 .01841 L
s
.67143 .01466 m
.67143 .01841 L
s
.70952 .01466 m
.70952 .01841 L
s
.74762 .01466 m
.74762 .01841 L
s
.82381 .01466 m
.82381 .01841 L
s
.8619 .01466 m
.8619 .01841 L
s
.9 .01466 m
.9 .01841 L
s
.9381 .01466 m
.9381 .01841 L
s
.25 Mabswid
0 .01466 m
1 .01466 L
s
gsave
1.025 .01466 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.75) show
1.000 setlinewidth
grestore
.97619 .15881 m
.98244 .15881 L
s
gsave
.96369 .15881 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.97619 .30297 m
.98244 .30297 L
s
gsave
.96369 .30297 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.97619 .44712 m
.98244 .44712 L
s
gsave
.96369 .44712 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.97619 .59128 m
.98244 .59128 L
s
gsave
.96369 .59128 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.97619 .04349 m
.97994 .04349 L
s
.97619 .07232 m
.97994 .07232 L
s
.97619 .10115 m
.97994 .10115 L
s
.97619 .12998 m
.97994 .12998 L
s
.97619 .18764 m
.97994 .18764 L
s
.97619 .21647 m
.97994 .21647 L
s
.97619 .24531 m
.97994 .24531 L
s
.97619 .27414 m
.97994 .27414 L
s
.97619 .3318 m
.97994 .3318 L
s
.97619 .36063 m
.97994 .36063 L
s
.97619 .38946 m
.97994 .38946 L
s
.97619 .41829 m
.97994 .41829 L
s
.97619 .47595 m
.97994 .47595 L
s
.97619 .50479 m
.97994 .50479 L
s
.97619 .53362 m
.97994 .53362 L
s
.97619 .56245 m
.97994 .56245 L
s
.25 Mabswid
.97619 0 m
.97619 .61803 L
s
gsave
.97619 .64303 -66.0938 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(l) show
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.02499 .02479 L
.02605 .02865 L
.02846 .0348 L
.03279 .04265 L
.03784 .04965 L
.04262 .05517 L
.06244 .07273 L
.08265 .08632 L
.10458 .09862 L
.14545 .11769 L
.1848 .13319 L
.22263 .14639 L
.26292 .15912 L
.30169 .17039 L
.34292 .18154 L
.38262 .19162 L
.42082 .2008 L
.46146 .2101 L
.50059 .21865 L
.54217 .22736 L
.58224 .23543 L
.62079 .24292 L
.6618 .25063 L
.70128 .25782 L
.73925 .26454 L
.77968 .27151 L
.81859 .27803 L
.85995 .2848 L
.89979 .29116 L
.93812 .29715 L
.97619 .30297 L
s
.5 Mabswid
[ .02 ] 0 setdash
.02381 .44257 m
.02846 .45304 L
.03279 .46093 L
.04262 .47472 L
.0522 .4848 L
.06244 .49336 L
.08451 .50722 L
.10458 .51661 L
.14451 .53035 L
.18292 .54004 L
.22379 .54815 L
.26314 .55455 L
.30098 .55978 L
.34126 .56462 L
.38004 .56873 L
.42126 .57262 L
.46097 .576 L
.49916 .57897 L
.53981 .58187 L
.57894 .58445 L
.62052 .587 L
.66059 .58928 L
.69914 .59134 L
.74014 .59341 L
.77963 .59528 L
.8176 .59699 L
.85802 .59872 L
.89693 .60031 L
.93829 .60191 L
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`004@3oool300000080oooo00@0
00000?ooo`3oool0oooo0`00000O0?ooo`<000000P3oool010000000oooo0?ooo`3oool3000001l0
oooo0`0000020?ooo`030000003oool0oooo02@0oooo0`0000020?ooo`040000003oool0oooo0?oo
o`<000007`3oool300000080oooo00@000000?ooo`3oool0oooo0P00001G0?ooo`00403oool20000
00030?ooo`000000oooo00@0oooo00@000000?ooo`3oool000007P3oool2000000030?ooo`000000
oooo00@0oooo0P0000000`3oool000000?ooo`0M0?ooo`80000000<0oooo0000003oool01P3oool0
0`000000oooo0?ooo`0N0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`02
000001d0oooo0P0000000`3oool000000?ooo`040?ooo`040000003oool0oooo000005H0oooo000@
0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000001d0oooo00<00000
0?ooo`3oool00P0000040?ooo`030000003oool0oooo008000007@3oool00`000000oooo0?ooo`02
000000H0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`02000000@0oooo00D00000
0?ooo`3oool0oooo0000000M0?ooo`030000003oool0oooo00800000103oool2000000030?ooo`00
0000000005D0oooo000@0?ooo`030000003oool0oooo00800000203oool00`000000oooo0?ooo`0K
0?ooo`030000003oool0oooo00800000103oool01@000000oooo0?ooo`3oool0000001d0oooo00<0
00000?ooo`3oool00P0000060?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool00P00
00040?ooo`050000003oool0oooo0?ooo`0000007@3oool00`000000oooo0?ooo`02000000L0oooo
0P00001E0?ooo`00403oool01@000000oooo0?ooo`3oool0000000L0oooo0P00000M0?ooo`050000
003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`02000001d0oooo00D000000?ooo`3o
ool0oooo000000060?ooo`030000003oool0oooo01h0oooo00D000000?ooo`3oool0oooo00000004
0?ooo`030000003oool0oooo008000007@3oool01@000000oooo0?ooo`3oool0000000D0oooo1000
001E0?ooo`00403oool01@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3oool00000
7P3oool01@000000oooo0?ooo`3oool0000000@0oooo0P0000000`3oool000000?ooo`0M0?ooo`05
0000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`0M0?ooo`050000003oool0oooo
0?ooo`0000001@3oool3000001h0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003o
ool0oooo00800000E@3oool00100oooo00<000000?ooo`3oool00P0000040?ooo`@000007P3oool0
0`000000oooo0?ooo`02000000@0oooo00<000000?ooo`0000007`3oool00`000000oooo0?ooo`02
000000L0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`02000000@0oooo0P000000
0`3oool000000?ooo`0M0?ooo`030000003oool0oooo00800000103oool01@000000oooo0?ooo`3o
ool0000005D0oooo000@0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo00800000103oool010000000oooo0?ooo`00000N0?ooo`030000003o
ool0oooo00800000103oool01@000000oooo0?ooo`3oool0000001h0oooo00<000000?ooo`3oool0
0P0000040?ooo`030000003oool0oooo008000007@3oool00`000000oooo0?ooo`02000000@0oooo
00<000000?ooo`3oool00P00001E0?ooo`00403oool2000000030?ooo`000000oooo00@0oooo00<0
00000?ooo`3oool07`3oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`0000007P3o
ool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`0000000P00000N0?ooo`80000000<0
oooo0000003oool0103oool2000000030?ooo`000000oooo01d0oooo0P0000000`3oool000000?oo
o`040?ooo`80000000<0oooo0000003oool0E@3oool00140oooo0`0000050?ooo`<00000803oool3
000000H0oooo0`00000O0?ooo`<000001@3oool200000080oooo00<000000?ooo`3oool07@3oool3
000000H0oooo0`00000O0?ooo`<000001P3oool3000005H0oooo003m0?ooo`<000000P3oool00`00
0000oooo0?ooo`070?ooo`<000004@3oool00>h0oooo00<000000?ooo`3oool02`3oool200000003
0?ooo`000000oooo00H0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
00l0oooo003^0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool00P0000060?ooo`05
0000003oool0oooo0?ooo`0000000P3oool200000100oooo003^0?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool00P0000060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool03P3oool00140ooooi00000070?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000
oooo0?ooo`040?ooo`800000403oool001D0oooo0P0000080?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00/0oooo
00D000000?ooo`3oool0oooo000000070?ooo`040000003oool0oooo00000080oooo00<000000?oo
o`3oool03`3oool001D0oooo0`00000Y0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3o
ool0:@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`02000000L0oooo00<000000?ooo`3oool01000000A0?ooo`00
5P3oool200000=H0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`02000000@0oooo
00L000000?ooo`3oool0oooo0000003oool0000001@0oooo000F0?ooo`800000eP3oool00`000000
oooo0?ooo`0;0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0000000200000003
0?ooo`000000oooo01<0oooo000F0?ooo`<00000e@3oool00`000000oooo0?ooo`0<0?ooo`<00000
1@3oool200000080oooo00<000000?ooo`0000000P00000B0?ooo`005`3oool200000=D0oooo00<0
00000?ooo`3oool0;`3oool001P0oooo0P00003D0?ooo`800000<03oool001T0oooo0P00003C0?oo
o`030000003oool0oooo02l0oooo000I0?ooo`<00000dP3oool00`000000oooo0?ooo`0_0?ooo`00
6P3oool300000=40oooo00<000000?ooo`3oool0;`3oool001/0oooo1000003?0?ooo`030000003o
ool0oooo02l0oooo000L0?ooo`@00000cP3oool00`000000oooo0?ooo`0_0?ooo`007P3oool30000
0<d0oooo0P00000`0?ooo`007`3oool400000</0oooo00<000000?ooo`3oool0;`3oool00200oooo
1000003:0?ooo`030000003oool0oooo02l0oooo000R0?ooo`@00000b03oool00`000000oooo0?oo
o`0_0?ooo`008`3oool400000<L0oooo00<000000?ooo`3oool0;`3oool002D0oooo100000350?oo
o`030000003oool0oooo02l0oooo000V0?ooo`D00000``3oool00`000000oooo0?ooo`0_0?ooo`00
:03oool500000<40oooo0P00000`0?ooo`00:P3oool500000;l0oooo00<000000?ooo`3oool0;`3o
ool002`0oooo1@00002m0?ooo`030000003oool0oooo02l0oooo000^0?ooo`D00000^`3oool00`00
0000oooo0?ooo`0_0?ooo`00<03oool600000;P0oooo00<000000?ooo`3oool0;`3oool00380oooo
1`00002e0?ooo`030000003oool0oooo02l0oooo000e0?ooo`L00000/P3oool200000300oooo000h
0?ooo`L00000[`3oool00`000000oooo0?ooo`0_0?ooo`00>`3oool600000:d0oooo00<000000?oo
o`3oool0;`3oool003h0oooo1P00002R0?ooo`8000001P3oool00`000000oooo0?ooo`0_0?ooo`00
@03oool700000:00oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0_0?ooo`00@`3o
ool7000009d0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0_0?ooo`00AP3oool7
000009X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0_0?ooo`00B@3oool80000
09H0oooo00<000000?ooo`3oool0103oool3000002l0oooo001<0?ooo`T00000TP3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo02l0oooo001A0?ooo`P00000SP3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo02l0oooo001E0?ooo`L00000R`3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo02l0oooo001H0?ooo`L00000Q`3oool2000000H0oooo00<00000
0?ooo`3oool0;`3oool005/0oooo200000240?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0;`3oool005h0oooo2@0000270?ooo`800000<03oool006<0oooo2@0000220?ooo`030000
003oool0oooo02l0oooo001W0?ooo`T00000OP3oool00`000000oooo0?ooo`0_0?ooo`00K03oool8
000007X0oooo00<000000?ooo`3oool0;`3oool00700oooo1`00001g0?ooo`030000003oool0oooo
02l0oooo001c0?ooo`L00000M03oool00`000000oooo0?ooo`0_0?ooo`00MP3oool<000006`0oooo
00<000000?ooo`3oool0;`3oool007T0oooo3P00001W0?ooo`800000<03oool00880oooo2P00001R
0?ooo`030000003oool0oooo02l0oooo00270?ooo`X00000G@3oool00`000000oooo0?ooo`0_0?oo
o`00S03oool9000005T0oooo00<000000?ooo`3oool0;`3oool00940oooo2000001E0?ooo`030000
003oool0oooo02l0oooo002E0?ooo`P00000D@3oool00`000000oooo0?ooo`0_0?ooo`00V@3oool9
000004`0oooo0P00000`0?ooo`00W@3oool:000004L0oooo00<000000?ooo`3oool0;`3oool00:80
oooo3P00000n0?ooo`030000003oool0oooo02l0oooo002W0?ooo`d00000>P3oool00`000000oooo
0?ooo`0_0?ooo`00/03oool8000003H0oooo00<000000?ooo`3oool0;`3oool00;@0oooo3P00000/
0?ooo`030000003oool0oooo02l0oooo002h0?ooo`h00000:03oool00`000000oooo0?ooo`0_0?oo
o`00`P3oool8000002@0oooo0P00000`0?ooo`00aP3oool>000001X0oooo00<000000?ooo`3oool0
;`3oool00<X0oooo3`00000E0?ooo`030000003oool0oooo02l0oooo003D0?ooo`T000002P3oool2
000000D0oooo00<000000?ooo`3oool0;`3oool00=T0oooo3`0000000`3oool000000?ooo`030?oo
o`030000003oool0oooo02l0oooo003M0?ooo`d00000103oool00`000000oooo0?ooo`0_0?ooo`00
i@3oool:00000340oooo003V0?ooo`8000000P3oool7000002l0oooo003X0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0;`3oool00>P0oooo0P0000040?ooo`030000003oool0oooo
02l0oooo003U0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`0_0?oo
o`00i@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0;`3oool00>H0oooo
0`0000050?ooo`030000003oool0oooo02l0oooo003^0?ooo`800000<03oool00>h0oooo00<00000
0?ooo`3oool0;`3oool00>h0oooo00<000000?ooo`3oool0;`3oool00>h0oooo00<000000?ooo`3o
ool0;`3oool00>h0oooo00<000000?ooo`3oool0;`3oool00>h0oooo00<000000?ooo`3oool0;`3o
ool00>h0oooo00<000000?ooo`3oool0;`3oool00>h0oooo0P00000`0?ooo`00kP3oool00`000000
oooo0?ooo`0_0?ooo`00kP3oool00`000000oooo0?ooo`0_0?ooo`00kP3oool00`000000oooo0?oo
o`0_0?ooo`00kP3oool00`000000oooo0?ooo`0_0?ooo`00kP3oool00`000000oooo0?ooo`0_0?oo
o`00kP3oool200000300oooo003^0?ooo`030000003oool0oooo02l0oooo003^0?ooo`030000003o
ool0oooo02l0oooo003^0?ooo`030000003oool0oooo02l0oooo003^0?ooo`030000003oool0oooo
02l0oooo003^0?ooo`030000003oool0oooo02l0oooo003^0?ooo`030000003oool0oooo02l0oooo
003^0?ooo`800000<03oool00>h0oooo00<000000?ooo`3oool0;`3oool00>H0oooo0`0000050?oo
o`030000003oool0oooo02l0oooo003U0?ooo`030000003oool0oooo00800000103oool00`000000
oooo0?ooo`0_0?ooo`00i@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3o
ool0;`3oool001H0oooo00<000000?ooo`3oool0d03oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo02l0oooo000F0?ooo`030000003oool0oooo0<l0oooo00<000000?ooo`3oool00`3o
ool3000002l0oooo000G0?ooo`030000003oool0oooo0<d0oooo0P0000050?ooo`030000003oool0
oooo02l0oooo000G0?ooo`030000003oool0oooo0<h0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`0_0?ooo`00603oool00`000000oooo0?ooo`3:0?ooo`030000003oool0oooo0080
0000103oool00`000000oooo0?ooo`0_0?ooo`00i@3oool010000000oooo0?ooo`0000050?ooo`03
0000003oool0oooo02l0oooo003V0?ooo`<000001@3oool00`000000oooo0?ooo`0_0?ooo`00kP3o
ool00`000000oooo0?ooo`0_0?ooo`006`3oool00`000000oooo0?ooo`3@0?ooo`800000<03oool0
01/0oooo00<000000?ooo`3oool0d03oool00`000000oooo0?ooo`0_0?ooo`00703oool00`000000
oooo0?ooo`3?0?ooo`030000003oool0oooo02l0oooo000M0?ooo`800000c`3oool00`000000oooo
0?ooo`0_0?ooo`00kP3oool00`000000oooo0?ooo`0_0?ooo`00kP3oool00`000000oooo0?ooo`0_
0?ooo`008P3oool00`000000oooo0?ooo`390?ooo`800000<03oool002<0oooo0P0000390?ooo`03
0000003oool0oooo02l0oooo000U0?ooo`800000a`3oool00`000000oooo0?ooo`0_0?ooo`00kP3o
ool00`000000oooo0?ooo`0_0?ooo`00:P3oool200000<80oooo00<000000?ooo`3oool0;`3oool0
02`0oooo0`00002o0?ooo`030000003oool0oooo02l0oooo000b0?ooo`800000^P3oool00`000000
oooo0?ooo`0_0?ooo`00=03oool200000;P0oooo0P00000`0?ooo`00=P3oool200000;H0oooo00<0
00000?ooo`3oool0;`3oool003/0oooo0`00002`0?ooo`030000003oool0oooo02l0oooo000n0?oo
o`<000000`3oool300000:L0oooo00<000000?ooo`3oool0;`3oool004L0oooo0`00002T0?ooo`03
0000003oool0oooo02l0oooo001=0?ooo`H00000V`3oool00`000000oooo0?ooo`0_0?ooo`00EP3o
ool3000009D0oooo0P00000`0?ooo`00F@3oool3000000<0oooo0`00002<0?ooo`030000003oool0
oooo02l0oooo001R0?ooo`<000000`3oool600000800oooo00<000000?ooo`3oool0;`3oool00740
oooo1P00001`0?ooo`8000001@3oool00`000000oooo0?ooo`0_0?ooo`00NP3oool6000000<0oooo
0`00001Q0?ooo`8000001@3oool00`000000oooo0?ooo`0_0?ooo`00QP3oool3000000<0oooo1P00
001E0?ooo`8000001@3oool00`000000oooo0?ooo`0_0?ooo`00U@3oool6000000<0oooo1P000011
0?ooo`@000001@3oool00`000000oooo0?ooo`0_0?ooo`00Z03oool5000000@0oooo1@00000_0?oo
o`040000003oool00000000000D0oooo0`00000_0?ooo`00^P3oool5000000@0oooo1@0000040?oo
o`800000603oool3000000D0oooo00<000000?ooo`3oool0;`3oool00<h0oooo0`0000040?ooo`D0
0000103oool5000000<0oooo100000040?ooo`030000003oool0oooo02l0oooo003W0?ooo`800000
00H0oooo00000000000000000?ooo`00000a0?ooo`00i`3oool2000000D0oooo00<000000?ooo`3o
ool0;`3oool00>P0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0_0?ooo`00kP3o
ool00`000000oooo0?ooo`0_0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00
o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00
o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00j`3oool010000000oooo0?ooo`3oool2000002l0oooo003[
0?ooo`040000003oool0oooo00000340oooo003/0?ooo`030000003oool000000340oooo003/0?oo
o`030000003oool000000340oooo003]0?ooo`800000<@3oool00>h0oooo00<000000?ooo`3oool0
;`3oool00>h0oooo00<000000?ooo`3oool0;`3oool00>`0oooo0P00000b0?ooo`00o`3ooolQ0?oo
o`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.447969, -0.568151, \
0.00231344, 0.0305679}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1440}, {0, 783}},
WindowSize->{840, 671},
WindowMargins->{{71, Automatic}, {6, Automatic}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 221, 5, 96, "Input"],
Cell[2000, 60, 356, 5, 22, "Message"],
Cell[2359, 67, 57, 1, 29, "Output"],
Cell[2419, 70, 43, 1, 29, "Output"]
}, Open  ]],
Cell[2477, 74, 90, 1, 30, "Input"],
Cell[2570, 77, 52, 1, 50, "Input"],

Cell[CellGroupData[{
Cell[2647, 82, 132, 3, 43, "Input"],
Cell[2782, 87, 354, 5, 22, "Message"],
Cell[3139, 94, 73, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3249, 100, 339, 6, 70, "Input"],
Cell[3591, 108, 26831, 796, 186, 13680, 629, "GraphicsData", "PostScript", \
"Graphics"],
Cell[30425, 906, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30592, 914, 96, 2, 43, "Input"],
Cell[30691, 918, 41, 1, 29, "Output"]
}, Open  ]],
Cell[30747, 922, 218, 5, 70, "Input"],

Cell[CellGroupData[{
Cell[30990, 931, 739, 15, 150, "Input"],
Cell[31732, 948, 34476, 1140, 186, 19305, 948, "GraphicsData", "PostScript", \
"Graphics"],
Cell[66211, 2090, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[66378, 2098, 173, 4, 50, "Input"],
Cell[66554, 2104, 310, 5, 22, "Message"],
Cell[66867, 2111, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[67034, 2119, 799, 16, 170, "Input"],
Cell[67836, 2137, 39642, 1312, 186, 22202, 1092, "GraphicsData", \
"PostScript", "Graphics"],
Cell[107481, 3451, 130, 3, 29, "Output"]
}, Open  ]],
Cell[107626, 3457, 173, 3, 50, "Input"],

Cell[CellGroupData[{
Cell[107824, 3464, 403, 7, 70, "Input"],
Cell[108230, 3473, 563, 8, 52, "Message"],
Cell[108796, 3483, 411, 7, 37, "Message"]
}, Open  ]],
Cell[109222, 3493, 26, 0, 30, "Input"],
Cell[109251, 3495, 164, 3, 30, "Input"],
Cell[109418, 3500, 52, 1, 50, "Input"],

Cell[CellGroupData[{
Cell[109495, 3505, 104, 2, 43, "Input"],
Cell[109602, 3509, 65, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[109704, 3515, 1196, 23, 190, "Input"],
Cell[110903, 3540, 30428, 967, 186, 16381, 789, "GraphicsData", "PostScript", \
"Graphics"],
Cell[141334, 4509, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[141501, 4517, 113, 2, 43, "Input"],
Cell[141617, 4521, 74, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[141728, 4527, 907, 17, 170, "Input"],
Cell[142638, 4546, 31359, 896, 186, 13973, 677, "GraphicsData", "PostScript", \
"Graphics"],
Cell[174000, 5444, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[174167, 5452, 114, 2, 43, "Input"],
Cell[174284, 5456, 69, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[174390, 5462, 1495, 28, 250, "Input"],
Cell[175888, 5492, 29563, 960, 186, 16289, 792, "GraphicsData", "PostScript", \
"Graphics"],
Cell[205454, 6454, 130, 3, 29, "Output"]
}, Open  ]],
Cell[205599, 6460, 26, 0, 30, "Input"],
Cell[205628, 6462, 26, 0, 30, "Input"],

Cell[CellGroupData[{
Cell[205679, 6466, 428, 8, 90, "Input"],
Cell[206110, 6476, 26940, 824, 186, 14186, 662, "GraphicsData", "PostScript", \
"Graphics"],
Cell[233053, 7302, 130, 3, 29, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

