(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    340298,      10725]*)
(*NotebookOutlinePosition[    340942,      10747]*)
(*  CellTagsIndexPosition[    340898,      10743]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
    StyleBox[\(Exact\ Risk\ Properties\),
      "Title",
      FontSize->36], "\[IndentingNewLine]", 
    StyleBox[\(\(\ \)\(Threshold\)\(\ \)\),
      "Subtitle"], "\[IndentingNewLine]", "Null"}], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(Risk\\)\\\" is similar to existing symbol \\\
\"\\!\\(Disk\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(Exact\ Properties\ Risk\)], "Output"],

Cell[BoxData[
    \(Threshold\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(lambda[sig_, k_] := \((2\ sig)\)\ Sqrt[2\ k\  - \ 1];\)\)], "Input"],

Cell[BoxData[
    \(\[IndentingNewLine]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(Threshold\)\(\ \)\(for\)\(\ \)\(different\)\(\ \)\(k'\) \
\(s\)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(for\\)\\\" is similar to existing symbol \
\\\"\\!\\(For\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{"different", " ", "for", " ", "s", " ", "Threshold", " ", 
      SuperscriptBox["k", "\[Prime]",
        MultilineFunction->None]}]], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[""], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(Plot[lambda[2, k], {k, 1/2, 1}, \ PlotRange\  \[Rule] \ All, \ 
      AxesLabel\  \[Rule] \ {k, \[Lambda]}, \ 
      PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \[IndentingNewLine]\ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 
          12}]\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
-0.928572 1.90476 0.0145949 0.147181 [
[.02381 .00209 -9.125 -15.75 ]
[.02381 .00209 9.125 0 ]
[.21429 .00209 -9.125 -15.75 ]
[.21429 .00209 9.125 0 ]
[.40476 .00209 -9.125 -15.75 ]
[.40476 .00209 9.125 0 ]
[.59524 .00209 -9.125 -15.75 ]
[.59524 .00209 9.125 0 ]
[.78571 .00209 -9.125 -15.75 ]
[.78571 .00209 9.125 0 ]
[1.025 .01459 0 -7.875 ]
[1.025 .01459 10 7.875 ]
[.96369 .16178 -9.6875 -7.875 ]
[.96369 .16178 0 7.875 ]
[.96369 .30896 -9.6875 -7.875 ]
[.96369 .30896 0 7.875 ]
[.96369 .45614 -9.6875 -7.875 ]
[.96369 .45614 0 7.875 ]
[.96369 .60332 -9.6875 -7.875 ]
[.96369 .60332 0 7.875 ]
[.97619 .64303 -5.09375 0 ]
[.97619 .64303 5.09375 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01459 m
.02381 .02084 L
s
gsave
.02381 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.21429 .01459 m
.21429 .02084 L
s
gsave
.21429 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.6) show
1.000 setlinewidth
grestore
.40476 .01459 m
.40476 .02084 L
s
gsave
.40476 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.7) show
1.000 setlinewidth
grestore
.59524 .01459 m
.59524 .02084 L
s
gsave
.59524 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.8) show
1.000 setlinewidth
grestore
.78571 .01459 m
.78571 .02084 L
s
gsave
.78571 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.9) show
1.000 setlinewidth
grestore
.125 Mabswid
.0619 .01459 m
.0619 .01834 L
s
.1 .01459 m
.1 .01834 L
s
.1381 .01459 m
.1381 .01834 L
s
.17619 .01459 m
.17619 .01834 L
s
.25238 .01459 m
.25238 .01834 L
s
.29048 .01459 m
.29048 .01834 L
s
.32857 .01459 m
.32857 .01834 L
s
.36667 .01459 m
.36667 .01834 L
s
.44286 .01459 m
.44286 .01834 L
s
.48095 .01459 m
.48095 .01834 L
s
.51905 .01459 m
.51905 .01834 L
s
.55714 .01459 m
.55714 .01834 L
s
.63333 .01459 m
.63333 .01834 L
s
.67143 .01459 m
.67143 .01834 L
s
.70952 .01459 m
.70952 .01834 L
s
.74762 .01459 m
.74762 .01834 L
s
.82381 .01459 m
.82381 .01834 L
s
.8619 .01459 m
.8619 .01834 L
s
.9 .01459 m
.9 .01834 L
s
.9381 .01459 m
.9381 .01834 L
s
.25 Mabswid
0 .01459 m
1 .01459 L
s
gsave
1.025 .01459 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
.97619 .16178 m
.98244 .16178 L
s
gsave
.96369 .16178 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.97619 .30896 m
.98244 .30896 L
s
gsave
.96369 .30896 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.97619 .45614 m
.98244 .45614 L
s
gsave
.96369 .45614 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.97619 .60332 m
.98244 .60332 L
s
gsave
.96369 .60332 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.97619 .04403 m
.97994 .04403 L
s
.97619 .07347 m
.97994 .07347 L
s
.97619 .1029 m
.97994 .1029 L
s
.97619 .13234 m
.97994 .13234 L
s
.97619 .19121 m
.97994 .19121 L
s
.97619 .22065 m
.97994 .22065 L
s
.97619 .25008 m
.97994 .25008 L
s
.97619 .27952 m
.97994 .27952 L
s
.97619 .33839 m
.97994 .33839 L
s
.97619 .36783 m
.97994 .36783 L
s
.97619 .39727 m
.97994 .39727 L
s
.97619 .4267 m
.97994 .4267 L
s
.97619 .48557 m
.97994 .48557 L
s
.97619 .51501 m
.97994 .51501 L
s
.97619 .54445 m
.97994 .54445 L
s
.97619 .57388 m
.97994 .57388 L
s
.25 Mabswid
.97619 0 m
.97619 .61803 L
s
gsave
.97619 .64303 -66.0938 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(l) show
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.02499 .03528 L
.02605 .04318 L
.02846 .05572 L
.03279 .07175 L
.03784 .08605 L
.04262 .09733 L
.06244 .13317 L
.08265 .16093 L
.10458 .18604 L
.14545 .22499 L
.1848 .25664 L
.22263 .28359 L
.26292 .30958 L
.30169 .3326 L
.34292 .35538 L
.38262 .37596 L
.42082 .3947 L
.46146 .41369 L
.50059 .43114 L
.54217 .44893 L
.58224 .4654 L
.62079 .4807 L
.6618 .49644 L
.70128 .51113 L
.73925 .52486 L
.77968 .53908 L
.81859 .55241 L
.85995 .56622 L
.89979 .57921 L
.93812 .59143 L
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00603oool300000080oooo00@0
00000?ooo`3oool0oooo0`00000O0?ooo`<000000P3oool010000000oooo0?ooo`3oool3000001l0
oooo0`0000020?ooo`030000003oool0oooo02@0oooo0`0000020?ooo`040000003oool0oooo0?oo
o`<000007`3oool300000080oooo00@000000?ooo`3oool0oooo0P00001@0?ooo`005`3oool20000
00030?ooo`000000oooo00@0oooo00@000000?ooo`3oool000007P3oool2000000030?ooo`000000
oooo00@0oooo0P0000000`3oool000000?ooo`0M0?ooo`80000000<0oooo0000003oool01P3oool0
0`000000oooo0?ooo`0N0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`02
000001d0oooo0P0000000`3oool000000?ooo`040?ooo`040000003oool0oooo000004l0oooo000G
0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000001d0oooo00<00000
0?ooo`3oool00P0000040?ooo`030000003oool0oooo008000007@3oool00`000000oooo0?ooo`02
000000H0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`02000000@0oooo00D00000
0?ooo`3oool0oooo0000000M0?ooo`030000003oool0oooo00800000103oool2000000030?ooo`00
0000000004h0oooo000G0?ooo`030000003oool0oooo00800000203oool00`000000oooo0?ooo`0K
0?ooo`030000003oool0oooo00800000103oool01@000000oooo0?ooo`3oool0000001d0oooo00<0
00000?ooo`3oool00P0000060?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool00P00
00040?ooo`050000003oool0oooo0?ooo`0000007@3oool00`000000oooo0?ooo`02000000L0oooo
0P00001>0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000L0oooo0P00000M0?ooo`050000
003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`02000001d0oooo00D000000?ooo`3o
ool0oooo000000060?ooo`030000003oool0oooo01h0oooo00D000000?ooo`3oool0oooo00000004
0?ooo`030000003oool0oooo008000007@3oool01@000000oooo0?ooo`3oool0000000D0oooo1000
001>0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3oool00000
7P3oool01@000000oooo0?ooo`3oool0000000@0oooo0P0000000`3oool000000?ooo`0M0?ooo`05
0000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`0M0?ooo`050000003oool0oooo
0?ooo`0000001@3oool3000001h0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003o
ool0oooo00800000CP3oool001L0oooo00<000000?ooo`3oool00P0000040?ooo`@000007P3oool0
0`000000oooo0?ooo`02000000@0oooo00<000000?ooo`0000007`3oool00`000000oooo0?ooo`02
000000L0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`02000000@0oooo0P000000
0`3oool000000?ooo`0M0?ooo`030000003oool0oooo00800000103oool01@000000oooo0?ooo`3o
ool0000004h0oooo000G0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo00800000103oool010000000oooo0?ooo`00000N0?ooo`030000003o
ool0oooo00800000103oool01@000000oooo0?ooo`3oool0000001h0oooo00<000000?ooo`3oool0
0P0000040?ooo`030000003oool0oooo008000007@3oool00`000000oooo0?ooo`02000000@0oooo
00<000000?ooo`3oool00P00001>0?ooo`005`3oool2000000030?ooo`000000oooo00@0oooo00<0
00000?ooo`3oool07`3oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`0000007P3o
ool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`0000000P00000N0?ooo`80000000<0
oooo0000003oool0103oool2000000030?ooo`000000oooo01d0oooo0P0000000`3oool000000?oo
o`040?ooo`80000000<0oooo0000003oool0CP3oool001P0oooo0`0000050?ooo`<00000803oool3
000000H0oooo0`00000O0?ooo`<000001@3oool200000080oooo00<000000?ooo`3oool07@3oool3
000000H0oooo0`00000O0?ooo`<000001P3oool3000004l0oooo003o0?ooo`@0oooo0P0000000`3o
ool000000?ooo`0H0?ooo`00m@3oool00`000000oooo0?ooo`0;0?ooo`80000000<0oooo0000003o
ool0603oool00?D0oooo00<000000?ooo`3oool02`3oool2000000030?ooo`000000oooo01P0oooo
003e0?ooo`030000003oool0oooo00/0oooo0`00000J0?ooo`00603ooooS000000P0oooo0`00000J
0?ooo`00703oool2000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool02`3oool2000000030?ooo`000000oooo
01P0oooo000L0?ooo`800000:P3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo02T0
oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo00/0
oooo0P0000000`3oool000000000000H0?ooo`00703oool200000=L0oooo00<000000?ooo`3oool0
2`3oool2000001/0oooo000L0?ooo`800000e`3oool00`000000oooo0?ooo`0;0?ooo`8000006`3o
ool001`0oooo0P00003G0?ooo`030000003oool0oooo00/0oooo0P00000K0?ooo`00703oool20000
0=L0oooo00<000000?ooo`3oool0:03oool001d0oooo00<000000?ooo`3oool0e@3oool2000002T0
oooo000M0?ooo`800000eP3oool00`000000oooo0?ooo`0X0?ooo`007P3oool00`000000oooo0?oo
o`3D0?ooo`030000003oool0oooo02P0oooo000N0?ooo`800000e@3oool00`000000oooo0?ooo`0X
0?ooo`007P3oool200000=D0oooo00<000000?ooo`3oool0:03oool001h0oooo0P00003E0?ooo`03
0000003oool0oooo02P0oooo000N0?ooo`<00000e03oool00`000000oooo0?ooo`0X0?ooo`007`3o
ool200000=@0oooo0P00000Y0?ooo`007`3oool200000=@0oooo00<000000?ooo`3oool0:03oool0
01l0oooo0`00003C0?ooo`030000003oool0oooo02P0oooo000P0?ooo`800000d`3oool00`000000
oooo0?ooo`0X0?ooo`00803oool200000=<0oooo00<000000?ooo`3oool0:03oool00240oooo00<0
00000?ooo`3oool0d@3oool00`000000oooo0?ooo`0X0?ooo`008@3oool200000=80oooo0P00000Y
0?ooo`008P3oool200000=40oooo00<000000?ooo`3oool0:03oool002<0oooo00<000000?ooo`3o
ool0c`3oool00`000000oooo0?ooo`0X0?ooo`008`3oool200000=00oooo00<000000?ooo`3oool0
:03oool002@0oooo00<000000?ooo`3oool0cP3oool00`000000oooo0?ooo`0X0?ooo`00903oool2
00000<l0oooo00<000000?ooo`3oool0:03oool002D0oooo0P00003>0?ooo`030000003oool0oooo
02P0oooo000V0?ooo`030000003oool0oooo0<`0oooo0P00000Y0?ooo`009P3oool200000<d0oooo
00<000000?ooo`3oool0:03oool002L0oooo0P00003<0?ooo`030000003oool0oooo02P0oooo000X
0?ooo`030000003oool0oooo0<80oooo0P0000060?ooo`030000003oool0oooo02P0oooo000X0?oo
o`800000a03oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo02P0oooo000Y0?ooo`80
0000``3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo02P0oooo000Z0?ooo`800000
`P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo02P0oooo000Z0?ooo`<00000`@3o
ool00`000000oooo0?ooo`040?ooo`800000:@3oool002/0oooo0P0000310?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0:03oool002`0oooo0P0000300?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool0:03oool002`0oooo0`00002o0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0:03oool002d0oooo0`00002m0?ooo`8000001P3oool00`000000oooo
0?ooo`0X0?ooo`00;P3oool300000;d0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`0X0?ooo`00;`3oool300000<<0oooo0P00000Y0?ooo`00<03oool300000<80oooo00<000000?oo
o`3oool0:03oool00340oooo0`0000310?ooo`030000003oool0oooo02P0oooo000b0?ooo`@00000
_`3oool00`000000oooo0?ooo`0X0?ooo`00<`3oool400000;h0oooo00<000000?ooo`3oool0:03o
ool003D0oooo0`00002m0?ooo`030000003oool0oooo02P0oooo000f0?ooo`<00000_03oool00`00
0000oooo0?ooo`0X0?ooo`00=`3oool300000;/0oooo0P00000Y0?ooo`00>03oool300000;X0oooo
00<000000?ooo`3oool0:03oool003T0oooo1000002h0?ooo`030000003oool0oooo02P0oooo000j
0?ooo`@00000]`3oool00`000000oooo0?ooo`0X0?ooo`00?03oool300000;H0oooo00<000000?oo
o`3oool0:03oool003d0oooo0`00002e0?ooo`030000003oool0oooo02P0oooo000n0?ooo`@00000
/`3oool00`000000oooo0?ooo`0X0?ooo`00?`3oool400000;80oooo0P00000Y0?ooo`00@@3oool3
00000;40oooo00<000000?ooo`3oool0:03oool00480oooo1000002_0?ooo`030000003oool0oooo
02P0oooo00130?ooo`@00000[P3oool00`000000oooo0?ooo`0X0?ooo`00A@3oool300000:d0oooo
00<000000?ooo`3oool0:03oool004H0oooo1000002[0?ooo`030000003oool0oooo02P0oooo0017
0?ooo`@00000ZP3oool2000002T0oooo00190?ooo`<00000Z@3oool00`000000oooo0?ooo`0X0?oo
o`00BP3oool400000:L0oooo00<000000?ooo`3oool0:03oool004/0oooo1000002O0?ooo`800000
1@3oool00`000000oooo0?ooo`0X0?ooo`00C@3oool4000009/0oooo0`0000000`3oool000000?oo
o`030?ooo`030000003oool0oooo02P0oooo001>0?ooo`@00000VP3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo02P0oooo001@0?ooo`@00000V03oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo02P0oooo001A0?ooo`D00000U`3oool2000000H0oooo0P00000Y0?ooo`00
D`3oool5000009L0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0X0?ooo`00E@3o
ool4000009H0oooo0P0000040?ooo`030000003oool0oooo02P0oooo001G0?ooo`@00000T@3oool0
1@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0:03oool005P0oooo1@00002?
0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`0X0?ooo`00FP3oool50000
08h0oooo0`0000050?ooo`030000003oool0oooo02P0oooo001L0?ooo`D00000U03oool00`000000
oooo0?ooo`0X0?ooo`00GP3oool4000009<0oooo0P00000Y0?ooo`00H03oool400000940oooo00<0
00000?ooo`3oool0:03oool00640oooo1@00002?0?ooo`030000003oool0oooo02P0oooo001S0?oo
o`D00000S@3oool00`000000oooo0?ooo`0X0?ooo`00I@3oool5000008/0oooo00<000000?ooo`3o
ool0:03oool006L0oooo1000002:0?ooo`030000003oool0oooo02P0oooo001Y0?ooo`@00000R03o
ool2000002T0oooo001Z0?ooo`D00000QP3oool00`000000oooo0?ooo`0X0?ooo`00K03oool50000
08@0oooo00<000000?ooo`3oool0:03oool006h0oooo1@0000220?ooo`030000003oool0oooo02P0
oooo001`0?ooo`H00000O`3oool00`000000oooo0?ooo`0X0?ooo`00LP3oool6000007d0oooo00<0
00000?ooo`3oool0:03oool007D0oooo1@00001k0?ooo`030000003oool0oooo02P0oooo001g0?oo
o`D00000N@3oool2000002T0oooo001i0?ooo`@00000N03oool00`000000oooo0?ooo`0X0?ooo`00
N`3oool4000007H0oooo00<000000?ooo`3oool0:03oool007`0oooo1@00001d0?ooo`030000003o
ool0oooo02P0oooo001n0?ooo`D00000LP3oool00`000000oooo0?ooo`0X0?ooo`00P03oool50000
0700oooo00<000000?ooo`3oool0:03oool00880oooo1P00001]0?ooo`030000003oool0oooo02P0
oooo00240?ooo`H00000J`3oool2000002T0oooo00270?ooo`D00000J@3oool00`000000oooo0?oo
o`0X0?ooo`00R@3oool6000005h0oooo0`0000050?ooo`030000003oool0oooo02P0oooo002;0?oo
o`H00000F`3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0:03oool008h0
oooo1P00001H0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`0X0?oo
o`00T03oool7000005T0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0X0?ooo`00
T`3oool7000005D0oooo00<000000?ooo`3oool00`3oool2000002T0oooo002F0?ooo`L00000D@3o
ool2000000D0oooo00<000000?ooo`3oool0:03oool009T0oooo1P00001@0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0:03oool009`0oooo1@00001;0?ooo`030000003oool0oooo
00800000103oool00`000000oooo0?ooo`0X0?ooo`00WP3oool5000004T0oooo00@000000?ooo`3o
ool000001@3oool00`000000oooo0?ooo`0X0?ooo`00X03oool5000004P0oooo0`0000050?ooo`03
0000003oool0oooo02P0oooo002R0?ooo`H00000C@3oool00`000000oooo0?ooo`0X0?ooo`00Y03o
ool7000004X0oooo0P00000Y0?ooo`00Z03oool6000004L0oooo00<000000?ooo`3oool0:03oool0
0:/0oooo1P0000140?ooo`030000003oool0oooo02P0oooo002^0?ooo`D00000@P3oool00`000000
oooo0?ooo`0X0?ooo`00/03oool6000003l0oooo00<000000?ooo`3oool0:03oool00;80oooo1P00
000m0?ooo`030000003oool0oooo02P0oooo002e0?ooo`H00000>P3oool00`000000oooo0?ooo`0X
0?ooo`00]`3oool6000003P0oooo0P00000Y0?ooo`00^P3oool6000003D0oooo00<000000?ooo`3o
ool0:03oool00;`0oooo1`00000b0?ooo`030000003oool0oooo02P0oooo002o0?ooo`L00000;`3o
ool00`000000oooo0?ooo`0X0?ooo`00`P3oool7000002`0oooo00<000000?ooo`3oool0:03oool0
0<D0oooo1`00000Y0?ooo`030000003oool0oooo02P0oooo00380?ooo`L000009P3oool2000002T0
oooo003;0?ooo`L000008`3oool00`000000oooo0?ooo`0X0?ooo`00cP3oool700000200oooo00<0
00000?ooo`3oool0:03oool00=40oooo1`00000M0?ooo`030000003oool0oooo02P0oooo003E0?oo
o`H000006P3oool00`000000oooo0?ooo`0X0?ooo`00f03oool7000001H0oooo00<000000?ooo`3o
ool0:03oool00=/0oooo1`00000C0?ooo`030000003oool0oooo02P0oooo003N0?ooo`L00000403o
ool2000002T0oooo003Q0?ooo`L000003@3oool00`000000oooo0?ooo`0X0?ooo`00i03oool60000
00/0oooo00<000000?ooo`3oool0:03oool00>L0oooo1P0000000`3oool00000000000050?ooo`03
0000003oool0oooo02P0oooo003Y0?ooo`L000001@3oool00`000000oooo0?ooo`0X0?ooo`00k03o
ool700000080oooo00<000000?ooo`3oool0:03oool00>`0oooo2P00000Z0?ooo`00k03oool01000
0000oooo0000000000020?ooo`D00000:@3oool00>d0oooo0`0000050?ooo`030000003oool0oooo
02P0oooo003]0?ooo`<000001@3oool00`000000oooo0?ooo`0X0?ooo`00kP3oool2000000D0oooo
00<000000?ooo`3oool0:03oool00>h0oooo0P00000`0?ooo`00k`3oool00`000000oooo0?ooo`0^
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00lP3oool010000000oooo0?oo
o`3oool2000002P0oooo003b0?ooo`040000003oool0oooo000002X0oooo003c0?ooo`030000003o
ool0000002X0oooo003c0?ooo`030000003oool0000002X0oooo003d0?ooo`800000:P3oool00?D0
oooo00<000000?ooo`3oool0:03oool00?D0oooo00<000000?ooo`3oool0:03oool00?<0oooo0P00
000[0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.431812, -0.556585, \
0.00231369, 0.0299429}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(Plot[{2\ Sqrt[2\ k\  - \ 1], \ 
        Sqrt[2\ Log[\((k - 1/2 + 0.01)\)*\ 2^13]]}, {k, 1/2, \ 
        4}, \[IndentingNewLine]\ PlotRange\  \[Rule] \ All, \ 
      AxesLabel\  \[Rule] \ {k, \[Lambda]}, \ 
      PlotStyle\  \[Rule] \ {{Thickness[
              0.01]}, {Dashing[{0.02}]}}, \[IndentingNewLine]\ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\(\[IndentingNewLine]\)
    \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
-0.112245 0.272109 0.0145949 0.111258 [
[.02381 .00209 -9.125 -15.75 ]
[.02381 .00209 9.125 0 ]
[.29592 .00209 -9.125 -15.75 ]
[.29592 .00209 9.125 0 ]
[.43197 .00209 -4.84375 -15.75 ]
[.43197 .00209 4.84375 0 ]
[.56803 .00209 -9.125 -15.75 ]
[.56803 .00209 9.125 0 ]
[.70408 .00209 -4.84375 -15.75 ]
[.70408 .00209 4.84375 0 ]
[.84014 .00209 -9.125 -15.75 ]
[.84014 .00209 9.125 0 ]
[.97619 .00209 -4.84375 -15.75 ]
[.97619 .00209 4.84375 0 ]
[1.025 .01459 0 -7.875 ]
[1.025 .01459 10 7.875 ]
[.14736 .12585 -9.6875 -7.875 ]
[.14736 .12585 0 7.875 ]
[.14736 .23711 -9.6875 -7.875 ]
[.14736 .23711 0 7.875 ]
[.14736 .34837 -9.6875 -7.875 ]
[.14736 .34837 0 7.875 ]
[.14736 .45963 -9.6875 -7.875 ]
[.14736 .45963 0 7.875 ]
[.14736 .57089 -9.6875 -7.875 ]
[.14736 .57089 0 7.875 ]
[.15986 .64303 -5.09375 0 ]
[.15986 .64303 5.09375 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01459 m
.02381 .02084 L
s
gsave
.02381 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.29592 .01459 m
.29592 .02084 L
s
gsave
.29592 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.43197 .01459 m
.43197 .02084 L
s
gsave
.43197 .00209 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.56803 .01459 m
.56803 .02084 L
s
gsave
.56803 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.70408 .01459 m
.70408 .02084 L
s
gsave
.70408 .00209 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.84014 .01459 m
.84014 .02084 L
s
gsave
.84014 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3.5) show
1.000 setlinewidth
grestore
.97619 .01459 m
.97619 .02084 L
s
gsave
.97619 .00209 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.05102 .01459 m
.05102 .01834 L
s
.07823 .01459 m
.07823 .01834 L
s
.10544 .01459 m
.10544 .01834 L
s
.13265 .01459 m
.13265 .01834 L
s
.18707 .01459 m
.18707 .01834 L
s
.21429 .01459 m
.21429 .01834 L
s
.2415 .01459 m
.2415 .01834 L
s
.26871 .01459 m
.26871 .01834 L
s
.32313 .01459 m
.32313 .01834 L
s
.35034 .01459 m
.35034 .01834 L
s
.37755 .01459 m
.37755 .01834 L
s
.40476 .01459 m
.40476 .01834 L
s
.45918 .01459 m
.45918 .01834 L
s
.48639 .01459 m
.48639 .01834 L
s
.51361 .01459 m
.51361 .01834 L
s
.54082 .01459 m
.54082 .01834 L
s
.59524 .01459 m
.59524 .01834 L
s
.62245 .01459 m
.62245 .01834 L
s
.64966 .01459 m
.64966 .01834 L
s
.67687 .01459 m
.67687 .01834 L
s
.73129 .01459 m
.73129 .01834 L
s
.7585 .01459 m
.7585 .01834 L
s
.78571 .01459 m
.78571 .01834 L
s
.81293 .01459 m
.81293 .01834 L
s
.86735 .01459 m
.86735 .01834 L
s
.89456 .01459 m
.89456 .01834 L
s
.92177 .01459 m
.92177 .01834 L
s
.94898 .01459 m
.94898 .01834 L
s
.25 Mabswid
0 .01459 m
1 .01459 L
s
gsave
1.025 .01459 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
.15986 .12585 m
.16611 .12585 L
s
gsave
.14736 .12585 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.15986 .23711 m
.16611 .23711 L
s
gsave
.14736 .23711 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.15986 .34837 m
.16611 .34837 L
s
gsave
.14736 .34837 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.15986 .45963 m
.16611 .45963 L
s
gsave
.14736 .45963 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.15986 .57089 m
.16611 .57089 L
s
gsave
.14736 .57089 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.125 Mabswid
.15986 .03685 m
.16361 .03685 L
s
.15986 .0591 m
.16361 .0591 L
s
.15986 .08135 m
.16361 .08135 L
s
.15986 .1036 m
.16361 .1036 L
s
.15986 .1481 m
.16361 .1481 L
s
.15986 .17036 m
.16361 .17036 L
s
.15986 .19261 m
.16361 .19261 L
s
.15986 .21486 m
.16361 .21486 L
s
.15986 .25936 m
.16361 .25936 L
s
.15986 .28162 m
.16361 .28162 L
s
.15986 .30387 m
.16361 .30387 L
s
.15986 .32612 m
.16361 .32612 L
s
.15986 .37062 m
.16361 .37062 L
s
.15986 .39287 m
.16361 .39287 L
s
.15986 .41513 m
.16361 .41513 L
s
.15986 .43738 m
.16361 .43738 L
s
.15986 .48188 m
.16361 .48188 L
s
.15986 .50413 m
.16361 .50413 L
s
.15986 .52638 m
.16361 .52638 L
s
.15986 .54864 m
.16361 .54864 L
s
.15986 .59314 m
.16361 .59314 L
s
.15986 .61539 m
.16361 .61539 L
s
.25 Mabswid
.15986 0 m
.15986 .61803 L
s
gsave
.15986 .64303 -66.0938 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(l) show
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.02499 .03528 L
.02605 .04318 L
.02846 .05572 L
.03279 .07175 L
.03784 .08605 L
.04262 .09733 L
.06244 .13317 L
.08265 .16093 L
.10458 .18604 L
.14545 .22499 L
.1848 .25664 L
.22263 .28359 L
.26292 .30958 L
.30169 .3326 L
.34292 .35538 L
.38262 .37596 L
.42082 .3947 L
.46146 .41369 L
.50059 .43114 L
.54217 .44893 L
.58224 .4654 L
.62079 .4807 L
.6618 .49644 L
.70128 .51113 L
.73925 .52486 L
.77968 .53908 L
.81859 .55241 L
.85995 .56622 L
.89979 .57921 L
.93812 .59143 L
.97619 .60332 L
s
.5 Mabswid
[ .02 ] 0 setdash
.02381 .34486 m
.02499 .35805 L
.02605 .36668 L
.02729 .37441 L
.02846 .38029 L
.03053 .3886 L
.03279 .39561 L
.0379 .40722 L
.04262 .41494 L
.05224 .42621 L
.06244 .43464 L
.0728 .44118 L
.0825 .44613 L
.10458 .45486 L
.12483 .46092 L
.14335 .46546 L
.18306 .47311 L
.22125 .47879 L
.2619 .4837 L
.30103 .48765 L
.34261 .49126 L
.38268 .4943 L
.42123 .49691 L
.46223 .49941 L
.50172 .50159 L
.53969 .50352 L
.58011 .50542 L
.61902 .50711 L
.66038 .50879 L
.70023 .5103 L
.73856 .51167 L
.77934 .51305 L
.81861 .5143 L
.85636 .51544 L
.89656 .5166 L
.93525 .51767 L
.97619 .51874 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00603oool300000080oooo00@0
00000?ooo`3oool0oooo0`00000b0?ooo`8000000`3oool010000000oooo0?ooo`3oool3000001P0
oooo0P00000H0?ooo`8000000P3oool010000000oooo0?ooo`3oool3000001L0oooo0`00000H0?oo
o`<000000P3oool010000000oooo0?ooo`3oool3000001P0oooo0P00000Y0?ooo`005`3oool20000
00030?ooo`000000oooo00@0oooo00@000000?ooo`3oool00000<`3oool00`000000oooo0?ooo`04
0?ooo`040000003oool0oooo000001H0oooo0`0000000`3oool000000?ooo`0D0?ooo`<0000000<0
oooo0000003oool00`3oool010000000oooo0?ooo`00000F0?ooo`030000003oool0oooo00800000
5P3oool00`000000oooo0?ooo`02000000@0oooo00@000000?ooo`3oool00000603oool2000002T0
oooo000G0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`0200000380oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02000001D0oooo00<000000?ooo`3oool0
5`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo008000005@3oool01@000000oooo
0?ooo`3oool0000001H0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo
008000005`3oool2000002T0oooo000G0?ooo`030000003oool0oooo00800000203oool00`000000
oooo0?ooo`0`0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool04`3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool04`3oool4000002T0
oooo000G0?ooo`050000003oool0oooo0?ooo`0000001`3oool200000380oooo00<000000?ooo`3o
ool01`3oool2000001H0oooo0P00000H0?ooo`8000002@3oool2000001P0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`060?ooo`8000005@3oool010000000oooo00000000000Y0?oo
o`005`3oool01@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3oool00000<`3oool0
0`000000oooo0?ooo`040?ooo`040000003oool0oooo000001T0oooo00<000000?ooo`3oool05`3o
ool00`000000oooo0?ooo`030?ooo`040000003oool0oooo000001P0oooo0P00000I0?ooo`800000
1@3oool010000000oooo0?ooo`00000G0?ooo`<00000:@3oool001L0oooo00<000000?ooo`3oool0
0P0000040?ooo`@00000<`3oool00`000000oooo0?ooo`040?ooo`@000006@3oool2000001P0oooo
0P0000040?ooo`@000006@3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo00<0oooo
1000000G0?ooo`<00000:@3oool001L0oooo00<000000?ooo`3oool00P0000040?ooo`030000003o
ool0oooo03@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0G0?ooo`050000003o
ool0oooo0?ooo`0000005@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3o
ool05`3oool00`000000oooo0?ooo`02000001H0oooo00<000000?ooo`3oool00P0000040?ooo`03
0000003oool0oooo01T0oooo0P00000Y0?ooo`005`3oool2000000030?ooo`000000oooo00@0oooo
00<000000?ooo`3oool0<`3oool2000000H0oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`02000001D0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo01L0oooo
00@000000?ooo`3oool000005`3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo
01T0oooo0P00000Y0?ooo`00603oool3000000D0oooo0`00000d0?ooo`030000003oool0oooo00@0
oooo0`00000H0?ooo`<000005`3oool3000000D0oooo0`00000H0?ooo`<00000603oool3000000D0
oooo0`00000J0?ooo`030000003oool0oooo02L0oooo003o0?ooo`@0oooo0P0000000`3oool00000
0?ooo`0H0?ooo`00?03oool00`000000oooo0?ooo`340?ooo`80000000<0oooo0000003oool0603o
ool003`0oooo00<000000?ooo`3oool0a03oool2000000030?ooo`000000oooo01P0oooo000l0?oo
o`030000003oool0oooo0<@0oooo0`00000J0?ooo`00603ooooS000000P0oooo0`00000J0?ooo`00
703oool2000000D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0;0?ooo`800000
00<0oooo0000003oool0603oool001`0oooo0P00000N0?ooo`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo00/0oooo0P00
00000`3oool000000000000H0?ooo`00703oool2000001h0oooo00<000000?ooo`3oool0a03oool2
000001/0oooo000L0?ooo`8000007P3oool00`000000oooo0?ooo`340?ooo`8000006`3oool001`0
oooo0P00000N0?ooo`800000a@3oool2000001/0oooo000L0?ooo`8000007P3oool00`000000oooo
0?ooo`3Q0?ooo`007@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0>40oooo000M
0?ooo`8000007@3oool00`000000oooo0?ooo`3Q0?ooo`007P3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo0>40oooo000N0?ooo`800000703oool200000>80oooo000N0?ooo`800000
703oool00`000000oooo0?ooo`3Q0?ooo`007P3oool2000001`0oooo00<000000?ooo`3oool0h@3o
ool001h0oooo0`00000K0?ooo`030000003oool0oooo0>40oooo000O0?ooo`8000006`3oool00`00
0000oooo0?ooo`3Q0?ooo`007`3oool2000001/0oooo0P00003R0?ooo`007`3oool3000001X0oooo
00<000000?ooo`3oool0h@3oool00200oooo0P00000J0?ooo`030000003oool0oooo0>40oooo000P
0?ooo`8000006P3oool00`000000oooo0?ooo`3Q0?ooo`008@3oool00`000000oooo0?ooo`0H0?oo
o`030000003oool0oooo0>40oooo000Q0?ooo`8000006@3oool200000>80oooo000R0?ooo`800000
603oool00`000000oooo0?ooo`3Q0?ooo`008`3oool00`000000oooo0?ooo`0=0?ooo`8000001`3o
ool00`000000oooo0?ooo`3Q0?ooo`008`3oool2000000l0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`3Q0?ooo`00903oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool0h@3oool002@0oooo0P00000>0?ooo`030000003oool0oooo00D0
oooo0P00003R0?ooo`009@3oool2000000d0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`3Q0?ooo`009P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0h@3oool002H0oooo0P00000<0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0h@3oool002L0oooo0P00000;0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0h@3oool002P0oooo00<000000?ooo`3oool0203oool2000000L0oooo0P00003R0?ooo`00
:03oool2000000X0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`3Q0?ooo`00:@3o
ool200000140oooo00<000000?ooo`3oool0h@3oool002X0oooo0P00000@0?ooo`030000003oool0
oooo0>40oooo000Z0?ooo`<000003`3oool00`000000oooo0?ooo`3Q0?ooo`00:`3oool2000000l0
oooo0P00003R0?ooo`00;03oool2000000h0oooo00<000000?ooo`3oool0h@3oool002`0oooo0`00
000=0?ooo`030000003oool0oooo0>40oooo000]0?ooo`<00000303oool00`000000oooo0?ooo`3Q
0?ooo`00;P3oool3000000/0oooo00<000000?ooo`3oool0h@3oool002l0oooo0`00000:0?ooo`03
0000003oool0oooo0>40oooo000`0?ooo`<000002@3oool200000>80oooo000a0?ooo`<00000203o
ool00`000000oooo0?ooo`3Q0?ooo`00<P3oool4000000H0oooo00<000000?ooo`3oool0h@3oool0
03<0oooo100000050?ooo`030000003oool0oooo0>40oooo000e0?ooo`<00000103oool00`000000
oooo0?ooo`3Q0?ooo`00=P3oool3000000<0oooo0P00003R0?ooo`00=03oool2000000040?ooo`00
0000000000000080oooo00<000000?ooo`3oool0h@3oool00380oooo0`0000000`3oool000000?oo
o`03000000030?ooo`000000oooo0>80oooo000b0?ooo`030000003oool0oooo00@0oooo1000003S
0?ooo`00<P3oool00`000000oooo0?ooo`050?ooo`@00000hP3oool003<0oooo0P0000070?ooo`<0
0000h@3oool003D0oooo00<000000?ooo`3oool0103oool400000>00oooo000e0?ooo`8000001@3o
ool00`000000oooo0000000300000=h0oooo000b0?ooo`050000003oool0oooo0?ooo`0000001@3o
ool00`000000oooo0?ooo`0400000=d0oooo000b0?ooo`030000003oool0oooo008000001@3oool0
0`000000oooo0?ooo`020?ooo`<00000g03oool003<0oooo0`0000060?ooo`800000103oool40000
0=X0oooo000l0?ooo`030000003oool0oooo00@0oooo1000003I0?ooo`00?03oool00`000000oooo
0?ooo`060?ooo`<00000f03oool003`0oooo00<000000?ooo`3oool01`3oool400000=H0oooo000l
0?ooo`030000003oool0oooo00P0oooo1000003E0?ooo`00?03oool2000000/0oooo0`00003D0?oo
o`00?03oool00`000000oooo0?ooo`0;0?ooo`@00000dP3oool003`0oooo00<000000?ooo`3oool0
303oool400000=40oooo000l0?ooo`030000003oool0oooo00h0oooo1000003?0?ooo`00?03oool0
0`000000oooo0?ooo`0?0?ooo`@00000cP3oool003`0oooo0P00000B0?ooo`@00000c03oool003`0
oooo00<000000?ooo`3oool04P3oool500000<X0oooo000l0?ooo`030000003oool0oooo01@0oooo
1@0000380?ooo`00?03oool00`000000oooo0?ooo`0F0?ooo`@00000a`3oool003`0oooo00<00000
0?ooo`3oool0603oool400000<D0oooo000l0?ooo`8000006P3oool500000<<0oooo000c0?ooo`<0
00001P3oool00`000000oooo0?ooo`0K0?ooo`D00000`@3oool00380oooo00<000000?ooo`3oool0
0P0000050?ooo`030000003oool0oooo01d0oooo1@00002o0?ooo`00<P3oool01@000000oooo0?oo
o`3oool0000000D0oooo00<000000?ooo`3oool07`3oool400000;h0oooo000M0?ooo`030000003o
ool0oooo01H0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0Q0?ooo`@00000_03o
ool001d0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`040?ooo`8000008`3oool5
00000;X0oooo000M0?ooo`030000003oool0oooo01@0oooo0P0000060?ooo`030000003oool0oooo
02@0oooo1@00002h0?ooo`007@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool09P3oool500000;H0oooo000M0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool00P0000050?ooo`030000003oool0oooo02P0oooo1000002e0?ooo`007@3o
ool00`000000oooo0?ooo`0B0?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool0
:P3oool400000;<0oooo000c0?ooo`<000001P3oool2000002`0oooo1@00002a0?ooo`00?03oool0
0`000000oooo0?ooo`0]0?ooo`D00000[`3oool003`0oooo00<000000?ooo`3oool0;`3oool50000
0:d0oooo000N0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0<@3oool600000:X0
oooo000N0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0<`3oool600000:P0oooo
000N0?ooo`030000003oool0oooo01/0oooo0P00000g0?ooo`D00000YP3oool001l0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0h0?ooo`D00000Y03oool00200oooo00<000000?oo
o`3oool06@3oool00`000000oooo0?ooo`0j0?ooo`@00000X`3oool003`0oooo00<000000?ooo`3o
ool0?03oool400000:40oooo000l0?ooo`030000003oool0oooo03d0oooo1@00002O0?ooo`00?03o
ool200000400oooo1@00002M0?ooo`008P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0
oooo0440oooo1@00002K0?ooo`008P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo
04<0oooo1P00002H0?ooo`008`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo04D0
oooo1P00002F0?ooo`00903oool2000001H0oooo00<000000?ooo`3oool0B03oool5000009@0oooo
000l0?ooo`800000B`3oool600000940oooo000d0?ooo`8000001P3oool00`000000oooo0?ooo`1<
0?ooo`H00000S`3oool002T0oooo0`0000080?ooo`8000001P3oool00`000000oooo0?ooo`1?0?oo
o`H00000S03oool002`0oooo0`0000050?ooo`8000001P3oool00`000000oooo0?ooo`1A0?ooo`L0
0000R@3oool00380oooo100000060?ooo`030000003oool0oooo05@0oooo1`0000260?ooo`00<P3o
ool4000000H0oooo0P00001H0?ooo`L00000P`3oool003<0oooo100000050?ooo`030000003oool0
oooo05X0oooo1P0000210?ooo`00<`3oool3000000D0oooo0P00001O0?ooo`D00000O`3oool003@0
oooo0P0000060?ooo`@00000GP3oool5000007d0oooo000d0?ooo`8000001P3oool00`000000oooo
0?ooo`050?ooo`D00000E`3oool5000007/0oooo000e0?ooo`030000003oool0oooo00@0oooo0P00
000?0?ooo`D00000D03oool6000007P0oooo000l0?ooo`030000003oool0oooo01L0oooo1@000019
0?ooo`L00000M@3oool003`0oooo00<000000?ooo`3oool0803oool5000000@0oooo0P00000n0?oo
o`H00000LP3oool003`0oooo00<000000?ooo`3oool0:`3oool3000000@0oooo1@00000e0?ooo`H0
0000K`3oool003`0oooo00<000000?ooo`3oool0>`3oool5000000@0oooo0P00000Y0?ooo`D00000
K@3oool003`0oooo0P0000170?ooo`<00000103oool5000000@0oooo1@00000F0?ooo`H00000JP3o
ool003`0oooo00<000000?ooo`3oool0G`3oool6000000<0oooo1P0000030?ooo`P00000J03oool0
03`0oooo00<000000?ooo`3oool0M03oool<000000<0oooo1P0000030?ooo`<00000DP3oool003`0
oooo00<000000?ooo`3oool0N03oool600000140oooo0`0000030?ooo`H000000`3oool6000000@0
oooo1@0000040?ooo`800000;P3oool003`0oooo00<000000?ooo`3oool0N`3oool600000380oooo
0`00000[0?ooo`00?03oool2000007h0oooo1`00001M0?ooo`00?03oool00`000000oooo0?ooo`20
0?ooo`L00000FP3oool003`0oooo00<000000?ooo`3oool0P`3oool7000005L0oooo000l0?ooo`03
0000003oool0oooo08H0oooo1`00001D0?ooo`00?03oool00`000000oooo0?ooo`290?ooo`L00000
D@3oool003`0oooo0P00002=0?ooo`L00000CP3oool003`0oooo00<000000?ooo`3oool0S`3oool7
000004/0oooo000c0?ooo`<000001P3oool00`000000oooo0?ooo`2B0?ooo`L00000B03oool00380
oooo00@000000?ooo`3oool000001P3oool00`000000oooo0?ooo`2F0?ooo`H00000A@3oool00380
oooo00<000000?ooo`3oool00P0000050?ooo`030000003oool0oooo09T0oooo1`0000110?ooo`00
=P3oool00`000000oooo0?ooo`030?ooo`800000W@3oool7000003h0oooo000e0?ooo`8000001@3o
ool00`000000oooo0?ooo`2O0?ooo`L00000>`3oool00380oooo00@000000?ooo`3oool000001P3o
ool00`000000oooo0?ooo`2R0?ooo`L00000>03oool00380oooo100000060?ooo`030000003oool0
oooo0:D0oooo1P00000f0?ooo`00<P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
0:P0oooo1P00000c0?ooo`00<P3oool00`000000oooo0?ooo`070?ooo`800000Z`3oool700000300
oooo000b0?ooo`<000001`3oool00`000000oooo0?ooo`2]0?ooo`L00000;@3oool003`0oooo00<0
00000?ooo`3oool0/03oool7000002X0oooo000l0?ooo`030000003oool0oooo0;<0oooo1@00000Y
0?ooo`00?03oool00`000000oooo0?ooo`2f0?ooo`030000003oool0oooo02P0oooo000l0?ooo`80
0000hP3oool003`0oooo00<000000?ooo`3oool0h@3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool003T0oooo00@000000?ooo`3oool0oooo
0P00003Q0?ooo`00>@3oool010000000oooo0?ooo`00003S0?ooo`00>P3oool00`000000oooo0000
003S0?ooo`00>P3oool00`000000oooo0000003S0?ooo`00>`3oool200000><0oooo000l0?ooo`03
0000003oool0oooo0>40oooo000l0?ooo`030000003oool0oooo0>40oooo000j0?ooo`800000i03o
ool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.0226757, -0.736295, \
0.0161958, 0.0396108}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[""], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(\ \)\(\(Mode\)\(\ \)\(2\)\(\ \)\)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(2\ Mode\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(\(mode2[d_, sig_, 
          k_] := \((d\  + \ 
              Sign[d]\ \ \ Sqrt[d^2 - 4\ sig^2\ \((2\ k - 1)\)])\)/
          2;\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(kk = 0.2; \ s2\  = \ 1^2; \ 
    Plot[\[IndentingNewLine]Abs[
            th]^\((1 - 
              2\ kk)\)\ Exp[\(-\((\(-1\) - \ 
                    th)\)^2\)/\((2\ s2)\)], \[IndentingNewLine]{th, \ \(-8\), \
\ 8}, \ \ PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \ 
      AxesLabel\  \[Rule] \ {\[Theta], \[Pi] \((\[Theta] | d)\)}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}, \ 
      PlotRange\  \[Rule] \ All]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0595238 0.0147151 0.520906 [
[.05357 .00222 -13.3125 -15.75 ]
[.05357 .00222 13.3125 0 ]
[.20238 .00222 -9.03125 -15.75 ]
[.20238 .00222 9.03125 0 ]
[.35119 .00222 -13.3125 -15.75 ]
[.35119 .00222 13.3125 0 ]
[.64881 .00222 -9.125 -15.75 ]
[.64881 .00222 9.125 0 ]
[.79762 .00222 -4.84375 -15.75 ]
[.79762 .00222 4.84375 0 ]
[.94643 .00222 -9.125 -15.75 ]
[.94643 .00222 9.125 0 ]
[1.025 .01472 0 -7.875 ]
[1.025 .01472 9.4375 7.875 ]
[.4875 .1189 -18.25 -7.875 ]
[.4875 .1189 0 7.875 ]
[.4875 .22308 -18.25 -7.875 ]
[.4875 .22308 0 7.875 ]
[.4875 .32726 -18.25 -7.875 ]
[.4875 .32726 0 7.875 ]
[.4875 .43144 -18.25 -7.875 ]
[.4875 .43144 0 7.875 ]
[.4875 .53562 -9.6875 -7.875 ]
[.4875 .53562 0 7.875 ]
[.5 .64303 -19.5625 0 ]
[.5 .64303 19.5625 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.05357 .01472 m
.05357 .02097 L
s
gsave
.05357 .00222 -74.3125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.20238 .01472 m
.20238 .02097 L
s
gsave
.20238 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.35119 .01472 m
.35119 .02097 L
s
gsave
.35119 .00222 -74.3125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.64881 .01472 m
.64881 .02097 L
s
gsave
.64881 .00222 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.79762 .01472 m
.79762 .02097 L
s
gsave
.79762 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.94643 .01472 m
.94643 .02097 L
s
gsave
.94643 .00222 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7.5) show
1.000 setlinewidth
grestore
.125 Mabswid
.08333 .01472 m
.08333 .01847 L
s
.1131 .01472 m
.1131 .01847 L
s
.14286 .01472 m
.14286 .01847 L
s
.17262 .01472 m
.17262 .01847 L
s
.23214 .01472 m
.23214 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.29167 .01472 m
.29167 .01847 L
s
.32143 .01472 m
.32143 .01847 L
s
.38095 .01472 m
.38095 .01847 L
s
.41071 .01472 m
.41071 .01847 L
s
.44048 .01472 m
.44048 .01847 L
s
.47024 .01472 m
.47024 .01847 L
s
.52976 .01472 m
.52976 .01847 L
s
.55952 .01472 m
.55952 .01847 L
s
.58929 .01472 m
.58929 .01847 L
s
.61905 .01472 m
.61905 .01847 L
s
.67857 .01472 m
.67857 .01847 L
s
.70833 .01472 m
.70833 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.76786 .01472 m
.76786 .01847 L
s
.82738 .01472 m
.82738 .01847 L
s
.85714 .01472 m
.85714 .01847 L
s
.8869 .01472 m
.8869 .01847 L
s
.91667 .01472 m
.91667 .01847 L
s
.02381 .01472 m
.02381 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .1189 m
.50625 .1189 L
s
gsave
.4875 .1189 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
1.000 setlinewidth
grestore
.5 .22308 m
.50625 .22308 L
s
gsave
.4875 .22308 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.4) show
1.000 setlinewidth
grestore
.5 .32726 m
.50625 .32726 L
s
gsave
.4875 .32726 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.6) show
1.000 setlinewidth
grestore
.5 .43144 m
.50625 .43144 L
s
gsave
.4875 .43144 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.8) show
1.000 setlinewidth
grestore
.5 .53562 m
.50625 .53562 L
s
gsave
.4875 .53562 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .04076 m
.50375 .04076 L
s
.5 .06681 m
.50375 .06681 L
s
.5 .09285 m
.50375 .09285 L
s
.5 .14494 m
.50375 .14494 L
s
.5 .17099 m
.50375 .17099 L
s
.5 .19703 m
.50375 .19703 L
s
.5 .24912 m
.50375 .24912 L
s
.5 .27517 m
.50375 .27517 L
s
.5 .30121 m
.50375 .30121 L
s
.5 .3533 m
.50375 .3533 L
s
.5 .37935 m
.50375 .37935 L
s
.5 .40539 m
.50375 .40539 L
s
.5 .45749 m
.50375 .45749 L
s
.5 .48353 m
.50375 .48353 L
s
.5 .50958 m
.50375 .50958 L
s
.5 .56167 m
.50375 .56167 L
s
.5 .58771 m
.50375 .58771 L
s
.5 .61376 m
.50375 .61376 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
gsave
.5 .64303 -80.5625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(p) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
71.563 15.750 moveto
(H) show
75.375 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
83.188 15.750 moveto
(\\310) show
88.313 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
%%BeginResource: font Roman-MISO
%%BeginFont: Roman-MISO
/Roman /Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Roman-MISO
%%IncludeFont: Roman-MISO
/Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
94.313 15.750 moveto
(L) show
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.02605 .01472 L
.02846 .01472 L
.03072 .01472 L
.03279 .01472 L
.03521 .01472 L
.03784 .01472 L
.04032 .01472 L
.04262 .01472 L
.04498 .01472 L
.0472 .01472 L
.04963 .01472 L
.05224 .01472 L
.05497 .01472 L
.05757 .01472 L
.0599 .01472 L
.06244 .01472 L
.0653 .01472 L
.06799 .01472 L
.07041 .01472 L
.07302 .01472 L
.07588 .01472 L
.07889 .01472 L
.08147 .01472 L
.08429 .01472 L
.08694 .01472 L
.08936 .01472 L
.09215 .01472 L
.09479 .01472 L
.09948 .01472 L
.10213 .01472 L
.10458 .01472 L
.10921 .01472 L
.11182 .01472 L
.11421 .01472 L
.11861 .01472 L
.12082 .01472 L
.12324 .01472 L
.1284 .01472 L
.13129 .01472 L
.13392 .01472 L
.13637 .01472 L
.13902 .01472 L
.14385 .01472 L
.1462 .01472 L
.14874 .01472 L
.15331 .01473 L
.1561 .01473 L
.15875 .01474 L
.16372 .01474 L
Mistroke
.16625 .01475 L
.16895 .01476 L
.17379 .01478 L
.17676 .01479 L
.17955 .01481 L
.18476 .01485 L
.18943 .01491 L
.19455 .01499 L
.1999 .01511 L
.20488 .01525 L
.20956 .01544 L
.21381 .01566 L
.21872 .016 L
.22337 .01641 L
.22797 .01693 L
.23305 .01767 L
.23835 .01868 L
.24332 .01991 L
.25219 .02295 L
.25718 .02528 L
.26175 .02791 L
.26651 .03123 L
.27158 .03555 L
.28071 .04578 L
.2863 .05389 L
.29157 .06307 L
.30143 .08481 L
.31117 .11309 L
.32148 .15121 L
.33994 .24123 L
.37788 .47592 L
.38789 .53023 L
.39737 .5704 L
.4026 .58641 L
.40556 .59324 L
.4083 .59805 L
.40941 .59956 L
.4106 .60091 L
.41191 .60205 L
.41314 .6028 L
.41444 .60324 L
.4151 .60332 L
.41582 .6033 L
.41709 .603 L
.41828 .60241 L
.41955 .60142 L
.4209 .6 L
.42332 .59645 L
.42592 .5912 L
.42878 .58372 L
Mistroke
.43391 .56602 L
.43871 .54462 L
.44766 .49342 L
.45729 .42487 L
.47701 .2585 L
.48743 .16481 L
.49315 .11095 L
.49595 .08194 L
.49718 .06776 L
.49784 .05954 L
.49853 .0498 L
.49984 .0238 L
.50106 .04239 L
.50246 .05945 L
.50373 .0709 L
.50511 .08093 L
.50661 .08989 L
.50934 .10253 L
.51181 .11098 L
.51443 .1176 L
.51667 .1217 L
.51794 .12348 L
.51914 .12483 L
.52026 .12584 L
.52148 .12666 L
.52276 .12725 L
.52394 .12756 L
.52506 .12766 L
.52607 .1276 L
.52724 .12736 L
.52834 .12698 L
.52955 .12641 L
.53082 .12564 L
.5331 .12387 L
.53826 .11837 L
.54771 .10474 L
.55785 .08799 L
.57617 .05965 L
.58631 .04709 L
.59736 .03642 L
.60779 .02903 L
.61747 .02413 L
.62256 .02218 L
.62807 .02046 L
.63292 .01925 L
.63804 .01821 L
.64268 .01746 L
.64775 .01681 L
.65203 .01637 L
.65667 .01599 L
Mistroke
.66193 .01565 L
.66691 .01541 L
.67176 .01523 L
.67623 .01511 L
.68106 .015 L
.68639 .01492 L
.69195 .01486 L
.69716 .01481 L
.70212 .01478 L
.70474 .01477 L
.70754 .01476 L
.71265 .01475 L
.7174 .01474 L
.7198 .01473 L
.7224 .01473 L
.72711 .01473 L
.7317 .01472 L
.73592 .01472 L
.74062 .01472 L
.74325 .01472 L
.74565 .01472 L
.74789 .01472 L
.75032 .01472 L
.75474 .01472 L
.75721 .01472 L
.75994 .01472 L
.7626 .01472 L
.76547 .01472 L
.76814 .01472 L
.77059 .01472 L
.77311 .01472 L
.7754 .01472 L
.78013 .01472 L
.78274 .01472 L
.7852 .01472 L
.78957 .01472 L
.79204 .01472 L
.79431 .01472 L
.79662 .01472 L
.7991 .01472 L
.80182 .01472 L
.80437 .01472 L
.80722 .01472 L
.80993 .01472 L
.81236 .01472 L
.81501 .01472 L
.81757 .01472 L
.82034 .01472 L
.82295 .01472 L
.82535 .01472 L
Mistroke
.82752 .01472 L
.8299 .01472 L
.83239 .01472 L
.83471 .01472 L
.83744 .01472 L
.84002 .01472 L
.84233 .01472 L
.84485 .01472 L
.84758 .01472 L
.85048 .01472 L
.85296 .01472 L
.8557 .01472 L
.85805 .01472 L
.86062 .01472 L
.86331 .01472 L
.86581 .01472 L
.86816 .01472 L
.87029 .01472 L
.87275 .01472 L
.87507 .01472 L
.87761 .01472 L
.88029 .01472 L
.88258 .01472 L
.88509 .01472 L
.88779 .01472 L
.8907 .01472 L
.89344 .01472 L
.89594 .01472 L
.89822 .01472 L
.90073 .01472 L
.90336 .01472 L
.90583 .01472 L
.90813 .01472 L
.91024 .01472 L
.91255 .01472 L
.91499 .01472 L
.91747 .01472 L
.92012 .01472 L
.92262 .01472 L
.92489 .01472 L
.92757 .01472 L
.92908 .01472 L
.93047 .01472 L
.93303 .01472 L
.93432 .01472 L
.93574 .01472 L
.93823 .01472 L
.93963 .01472 L
.94094 .01472 L
.94333 .01472 L
Mistroke
.94455 .01472 L
.94588 .01472 L
.94838 .01472 L
.95074 .01472 L
.95304 .01472 L
.95515 .01472 L
.95766 .01472 L
.96 .01472 L
.96256 .01472 L
.964 .01472 L
.96531 .01472 L
.96795 .01472 L
.96944 .01472 L
.97082 .01472 L
.97335 .01472 L
.97462 .01472 L
.97603 .01472 L
.97619 .01472 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`009`3oool010000000oooo0?oo
o`3oool3000001X0oooo0`00000K0?ooo`8000000P3oool010000000oooo0?ooo`3oool3000003D0
oooo0P0000020?ooo`040000003oool0oooo0?ooo`<000006P3oool3000001l0oooo00@000000?oo
o`3oool0oooo0`00000/0?ooo`008`3oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo
000001T0oooo00@000000?ooo`3oool000006@3oool3000000030?ooo`000000oooo00<0oooo00@0
00000?ooo`3oool00000<`3oool3000000030?ooo`000000oooo00<0oooo00@000000?ooo`3oool0
00006@3oool010000000oooo0?ooo`00000K0?ooo`030000003oool0oooo00@0oooo00@000000?oo
o`3oool00000;03oool002<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020000
01P0oooo00<000000?ooo`3oool00P00000H0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool00P00000b0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool00P00000H0?oo
o`030000003oool0oooo008000006P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00800000:`3oool002<0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0J0?ooo`03
0000003oool0oooo01H0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0`0?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0H0?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool0:@3oool001P0oooo1`0000040?ooo`030000
003oool0oooo00L0oooo0P00000@0?ooo`L00000103oool200000100oooo1`0000020?ooo`800000
2@3oool2000003<0oooo0P0000090?ooo`8000006`3oool2000001X0oooo00<000000?ooo`3oool0
1`3oool2000002/0oooo000T0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool00000
6@3oool010000000oooo0?ooo`00000L0?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3o
ool00000=P3oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo000001T0oooo00@00000
0?ooo`3oool00000703oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo000002`0oooo
000T0?ooo`030000003oool0oooo00<0oooo1000000I0?ooo`@00000703oool2000000@0oooo1000
000f0?ooo`800000103oool4000001T0oooo1000000L0?ooo`030000003oool0oooo00<0oooo1000
000/0?ooo`008@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool06P3o
ool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo
0?ooo`0d0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`0J0?ooo`03
0000003oool0oooo01X0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo
02d0oooo000Q0?ooo`030000003oool0000000800000103oool00`000000oooo0?ooo`0J0?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo03@0
oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo00000002000000@0oooo00<000000?ooo`3oool0;@3oool00240oooo
0P0000020?ooo`030000003oool0oooo0080oooo0`00000J0?ooo`<000006`3oool3000000D0oooo
0`00000e0?ooo`<000001@3oool3000001X0oooo0`00000J0?ooo`8000000P3oool00`000000oooo
0?ooo`020?ooo`<00000;@3oool00?l0oooo8@3oool008P0oooo00<000000?ooo`3oool0M`3oool2
000001`0oooo00280?ooo`030000003oool0oooo07H0oooo00@000000?ooo`3oool000006`3oool0
08P0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`1B0?ooo`040000003oool0oooo
000001/0oooo000G0?ooon@000001P3oool01@000000oooo0?ooo`3oool0000001X0oooo000K0?oo
ocH0000000<0oooo0000003oool01@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo
00@0ooooDP00000<0?ooo`D000006P3oool002<0oooo00<000000?ooo`3oool07P3oool00`000000
oooo0?ooo`020?ooo`T00000503oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01D0
oooo3000000P0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool04P3oool010000000
oooo0?ooo`00000J0?ooo`00D03oool4000003<0oooo0P00000F0?ooo`H00000G@3oool010000000
oooo0?ooo`00000J0?ooo`00D@3oool400000380oooo0P00000E0?ooo`<00000HP3oool3000001X0
oooo001C0?ooo`<00000<@3oool2000001@0oooo0`0000200?ooo`00E03oool300000300oooo0`00
000B0?ooo`<00000P@3oool005D0oooo0`00000_0?ooo`<000004@3oool300000880oooo001F0?oo
o`<00000;P3oool300000100oooo0`0000230?ooo`00E`3oool2000002h0oooo0`00000?0?ooo`<0
0000Q03oool005P0oooo0P00000]0?ooo`<000003`3oool2000008D0oooo001I0?ooo`030000003o
ool0oooo02/0oooo0`00000>0?ooo`800000QP3oool005T0oooo0P00000/0?ooo`<000003P3oool0
0`000000oooo0?ooo`250?ooo`00F@3oool2000002/0oooo1000000=0?ooo`800000Q`3oool005T0
oooo0`00000Z0?ooo`@00000303oool2000008P0oooo001J0?ooo`800000:P3oool4000000`0oooo
00<000000?ooo`3oool0Q`3oool005X0oooo0`00000Y0?ooo`D000002P3oool2000008T0oooo001K
0?ooo`800000:@3oool3000000030?ooo`000000oooo00T0oooo00<000000?ooo`3oool0R03oool0
05/0oooo0P00000Y0?ooo`D000002@3oool2000008X0oooo001K0?ooo`<00000:03oool5000000T0
oooo00<000000?ooo`3oool0R@3oool005`0oooo0P00000I0?ooo`<000000P3oool00`000000oooo
0?ooo`020?ooo`8000000`3oool3000000030?ooo`000000oooo00L0oooo0P00002;0?ooo`00G03o
ool2000001P0oooo0P0000000`3oool000000?ooo`040?ooo`<0000000@0oooo0000003oool0oooo
0`0000000`3oool00000000000070?ooo`030000003oool0oooo08X0oooo001L0?ooo`<000005`3o
ool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00`3oool2000000050?ooo`00
0000oooo0?ooo`0000001P3oool2000008`0oooo001M0?ooo`8000005`3oool00`000000oooo0?oo
o`02000000@0oooo00<000000?ooo`3oool00`3oool2000000030?ooo`000000oooo00<00000103o
ool2000008d0oooo001M0?ooo`8000005`3oool01@000000oooo0?ooo`3oool0000000D0oooo0P00
00030?ooo`80000000@0oooo000000000000oooo0P0000030?ooo`800000SP3oool005d0oooo0`00
000F0?ooo`050000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`02000000040?oo
o`000000oooo0?ooo`L00000SP3oool005h0oooo0P00000F0?ooo`030000003oool0oooo00800000
1`3oool2000000050?ooo`00000000000?ooo`0000000P3oool6000008l0oooo001N0?ooo`800000
5P3oool00`000000oooo0?ooo`02000000@0oooo00H000000?ooo`3oool0oooo0000003oool20000
00030?ooo`000000oooo0080oooo0`00002A0?ooo`00GP3oool3000001D0oooo0P0000000`3oool0
00000?ooo`040?ooo`030000003oool0oooo0080000000D0oooo000000000000oooo0000002G0?oo
o`00G`3oool2000001H0oooo0`0000060?ooo`<000000P3oool2000000030?ooo`000000oooo09H0
oooo001O0?ooo`800000903oool2000000030?ooo`000000000009H0oooo001O0?ooo`800000903o
ool2000000030?ooo`000000oooo09H0oooo001P0?ooo`8000008`3oool2000000030?ooo`000000
oooo09H0oooo001P0?ooo`8000008`3oool2000000030?ooo`000000oooo09H0oooo001P0?ooo`80
00008P3oool200000080oooo00<000000?ooo`3oool0U@3oool00600oooo0P00000R0?ooo`800000
0P3oool00`000000oooo0?ooo`2E0?ooo`00H03oool200000280oooo0P0000020?ooo`800000UP3o
ool00640oooo0P00000Q0?ooo`8000000P3oool00`000000oooo0?ooo`2E0?ooo`00H@3oool20000
0240oooo0P0000020?ooo`030000003oool0oooo09D0oooo001Q0?ooo`8000008@3oool200000080
oooo00<000000?ooo`3oool0U@3oool00640oooo0P00000Q0?ooo`8000000P3oool00`000000oooo
0?ooo`2E0?ooo`00H@3oool200000240oooo0P0000020?ooo`030000003oool0oooo09D0oooo001R
0?ooo`800000803oool200000080oooo0P00002F0?ooo`00HP3oool200000200oooo0P0000020?oo
o`030000003oool0oooo09D0oooo001R0?ooo`8000004`3oool300000080oooo00<000000?ooo`3o
ool00P3oool2000000030?ooo`00000000000080oooo00<000000?ooo`3oool0U@3oool00680oooo
0P00000B0?ooo`80000000<0oooo0000003oool01P3oool4000000<0oooo00<000000?ooo`3oool0
U@3oool00680oooo0P00000B0?ooo`030000003oool0oooo008000001P3oool4000000<0oooo00<0
00000?ooo`3oool0U@3oool006<0oooo0P00000A0?ooo`030000003oool0oooo00800000103oool6
000000<0oooo0P00002F0?ooo`00H`3oool200000140oooo00D000000?ooo`3oool0oooo00000004
0?ooo`030000003oool0000000<000000`3oool00`000000oooo0?ooo`2E0?ooo`00H`3oool20000
0140oooo00D000000?ooo`3oool0oooo000000050?ooo`D000000`3oool00`000000oooo0?ooo`2E
0?ooo`00H`3oool200000140oooo00<000000?ooo`3oool00P0000050?ooo`D000000`3oool00`00
0000oooo0?ooo`2E0?ooo`00H`3oool200000140oooo00<000000?ooo`3oool00P0000060?ooo`@0
00000`3oool00`000000oooo0?ooo`2E0?ooo`00H`3oool200000140oooo0P0000000`3oool00000
0?ooo`060?ooo`@000000`3oool00`000000oooo0?ooo`2E0?ooo`00I03oool200000140oooo0`00
00080?ooo`<000000`3oool2000009H0oooo001T0?ooo`8000007@3oool2000000<0oooo00<00000
0?ooo`3oool0U@3oool006@0oooo0P00000L0?ooo`800000103oool00`000000oooo0?ooo`2E0?oo
o`00I03oool2000001`0oooo0P0000040?ooo`030000003oool0oooo09D0oooo001T0?ooo`800000
703oool2000000@0oooo00<000000?ooo`3oool0U@3oool006@0oooo0P00000L0?ooo`800000103o
ool00`000000oooo0?ooo`2E0?ooo`00I@3oool2000001/0oooo0P0000040?ooo`800000UP3oool0
06D0oooo0P00000K0?ooo`800000103oool00`000000oooo0?ooo`2E0?ooo`00I@3oool2000001/0
oooo0P0000040?ooo`030000003oool0oooo09D0oooo001U0?ooo`8000006`3oool2000000@0oooo
00<000000?ooo`3oool0U@3oool006D0oooo0P00000J0?ooo`8000001@3oool00`000000oooo0?oo
o`2E0?ooo`00I@3oool2000001X0oooo0P0000050?ooo`030000003oool0oooo09D0oooo001U0?oo
o`8000006P3oool2000000D0oooo0P00002F0?ooo`00IP3oool2000001T0oooo0P0000050?ooo`03
0000003oool0oooo09D0oooo001V0?ooo`8000003`3oool300000080oooo00@000000?ooo`3oool0
oooo0`0000050?ooo`030000003oool0oooo09D0oooo001V0?ooo`8000003P3oool2000000030?oo
o`000000oooo00@0oooo100000050?ooo`030000003oool0oooo09D0oooo001V0?ooo`8000003P3o
ool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`0000000P0000040?ooo`030000003o
ool0oooo09D0oooo001V0?ooo`8000003P3oool00`000000oooo0?ooo`02000000@0oooo00<00000
0?ooo`0000000P0000040?ooo`030000003oool0oooo09D0oooo001V0?ooo`8000003P3oool01@00
0000oooo0?ooo`3oool0000000@0oooo1@0000040?ooo`800000UP3oool006L0oooo0P00000=0?oo
o`050000003oool0oooo0?ooo`000000103oool4000000D0oooo00<000000?ooo`3oool0U@3oool0
06L0oooo0P00000=0?ooo`030000003oool0oooo00800000103oool3000000H0oooo00<000000?oo
o`3oool0U@3oool006L0oooo0P00000=0?ooo`030000003oool0oooo00800000103oool4000000D0
oooo00<000000?ooo`3oool0U@3oool006L0oooo0P00000=0?ooo`80000000<0oooo0000003oool0
1@3oool3000000D0oooo00<000000?ooo`3oool0U@3oool006L0oooo0P00000>0?ooo`<000001P3o
ool3000000D0oooo00<000000?ooo`3oool0U@3oool006L0oooo0P00000G0?ooo`8000001P3oool2
000009H0oooo001W0?ooo`8000005P3oool2000000L0oooo00<000000?ooo`3oool0U@3oool006P0
oooo0P00000E0?ooo`8000001`3oool00`000000oooo0?ooo`2E0?ooo`00J03oool2000001D0oooo
0P0000070?ooo`030000003oool0oooo09D0oooo001X0?ooo`8000005@3oool2000000L0oooo00<0
00000?ooo`3oool0U@3oool006P0oooo0P00000E0?ooo`8000001`3oool00`000000oooo0?ooo`2E
0?ooo`00J03oool2000001D0oooo0P0000070?ooo`800000UP3oool006P0oooo0P00000E0?ooo`80
00001`3oool00`000000oooo0?ooo`2E0?ooo`00J03oool2000001D0oooo0P0000070?ooo`030000
003oool0oooo09D0oooo001Y0?ooo`8000004`3oool2000000P0oooo00<000000?ooo`3oool0U@3o
ool006T0oooo0P00000C0?ooo`800000203oool00`000000oooo0?ooo`2E0?ooo`00J@3oool20000
01<0oooo0P0000080?ooo`030000003oool0oooo09D0oooo001Y0?ooo`8000004`3oool2000000P0
oooo0P00002F0?ooo`00J@3oool2000001<0oooo0P0000080?ooo`030000003oool0oooo09D0oooo
001Y0?ooo`800000303oool300000080oooo00<000000?ooo`000000100000050?ooo`030000003o
ool0oooo09D0oooo001Z0?ooo`8000002P3oool2000000030?ooo`000000oooo00<0oooo0P000002
0?ooo`800000103oool00`000000oooo0?ooo`2E0?ooo`00JP3oool2000000X0oooo00<000000?oo
o`3oool00P0000020?ooo`<000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
09D0oooo001Z0?ooo`8000002P3oool00`000000oooo0?ooo`0200000080oooo0`0000030?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0U@3oool006X0oooo0P00000:0?ooo`050000
003oool0oooo0?ooo`0000000P3oool300000080oooo0P0000040?ooo`800000UP3oool006X0oooo
0P00000:0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000000040?ooo`00000000000000
00D0oooo00<000000?ooo`3oool0U@3oool006X0oooo0P00000:0?ooo`030000003oool0oooo0080
00000P3oool4000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0U@3oool006X0oooo
0P00000:0?ooo`030000003oool0oooo008000000P3oool300000080oooo0P0000040?ooo`030000
003oool0oooo09D0oooo001[0?ooo`8000002@3oool2000000030?ooo`000000oooo0080oooo1000
00000`3oool000000?ooo`040?ooo`030000003oool0oooo09D0oooo001[0?ooo`8000002P3oool3
000000<0oooo0P000000103oool000000000000000050?ooo`030000003oool0oooo09D0oooo001[
0?ooo`8000003`3oool2000000X0oooo0P00002F0?ooo`00J`3oool2000000l0oooo0P00000:0?oo
o`030000003oool0oooo09D0oooo001[0?ooo`8000003`3oool2000000X0oooo00<000000?ooo`3o
ool0U@3oool006/0oooo0P00000?0?ooo`8000002P3oool00`000000oooo0?ooo`2E0?ooo`00J`3o
ool3000000h0oooo0P00000:0?ooo`030000003oool0oooo09D0oooo001/0?ooo`8000003P3oool2
000000X0oooo00<000000?ooo`3oool0U@3oool006`0oooo0P00000>0?ooo`8000002P3oool20000
09H0oooo001/0?ooo`8000003P3oool2000000X0oooo00<000000?ooo`3oool0U@3oool006`0oooo
0`00000<0?ooo`8000002`3oool00`000000oooo0?ooo`2E0?ooo`00K@3oool2000000`0oooo0P00
000;0?ooo`030000003oool0oooo09D0oooo001]0?ooo`800000303oool2000000/0oooo00<00000
0?ooo`3oool0U@3oool006d0oooo0P00000<0?ooo`8000002`3oool2000009H0oooo001]0?ooo`<0
00002`3oool2000000/0oooo00<000000?ooo`3oool0U@3oool006h0oooo0P00000;0?ooo`800000
0P3oool2000000L0oooo00<000000?ooo`3oool0U@3oool006h0oooo0P00000:0?ooo`800000103o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09D0oooo001^0?ooo`8000002P3oool2
000000@0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2E0?ooo`00KP3oool30000
00T0oooo0P0000040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0U@3oool006l0
oooo0P0000090?ooo`800000103oool00`000000oooo0?ooo`050?ooo`800000UP3oool006l0oooo
0P0000090?ooo`800000103oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09D0oooo
001_0?ooo`800000203oool2000000D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`2E0?ooo`00K`3oool2000000P0oooo0P0000050?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0U@3oool006l0oooo0`0000070?ooo`800000103oool2000000L0oooo00<000000?oo
o`3oool0U@3oool00700oooo0P0000070?ooo`8000001@3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo09D0oooo001`0?ooo`8000001`3oool2000000d0oooo0P00002F0?ooo`00L03o
ool2000000H0oooo0P00000>0?ooo`030000003oool0oooo09D0oooo001`0?ooo`<000001@3oool2
000000h0oooo00<000000?ooo`3oool0U@3oool00740oooo0P0000050?ooo`8000003P3oool00`00
0000oooo0?ooo`2E0?ooo`00L@3oool2000000D0oooo0P00000>0?ooo`030000003oool0oooo09D0
oooo001a0?ooo`800000103oool3000000h0oooo00<000000?ooo`3oool0U@3oool00740oooo0`00
00030?ooo`8000003`3oool2000009H0oooo001b0?ooo`8000000`3oool00`000000oooo0?ooo`0>
0?ooo`030000003oool0oooo09D0oooo001b0?ooo`8000000P3oool200000100oooo00<000000?oo
o`3oool0U@3oool00780oooo1P00000@0?ooo`030000003oool0oooo09D0oooo001b0?ooo`D00000
4@3oool00`000000oooo0?ooo`2E0?ooo`00L`3oool300000180oooo00<000000?ooo`3oool0U@3o
ool008P0oooo0P00002F0?ooo`00R03oool00`000000oooo0?ooo`2E0?ooo`00o`3ooolQ0?ooo`00
o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00
o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00PP3oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool0Q`3oool00840oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo08H0oooo001f0?ooo`030000003oool0oooo0080
00001@3oool010000000oooo0?ooo`3oool2000000H0oooo00<000000?ooo`3oool00`3oool40000
0080oooo00<000000?ooo`3oool0Q@3oool007L0oooo00<000000?ooo`0000001P3oool010000000
oooo0?ooo`0000020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool01@00
0000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0Q@3oool007L0oooo00<000000?oo
o`0000001P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool00P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0Q@3o
ool007P0oooo00<000000?ooo`0000001@3oool010000000oooo0?ooo`0000030?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool000000080oooo
00<000000?ooo`3oool0Q@3oool007H0oooo00D000000?ooo`000000oooo000000050?ooo`030000
003oool0oooo00D00000103oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`00
00000P3oool00`000000oooo0?ooo`250?ooo`00M`3oool5000000@0oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`0200000080oooo00<000000?ooo`3oool0Q@3oool00800oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool200000005
0?ooo`000000oooo0?ooo`000000Q`3oool00840oooo00@000000?ooo`3oool0oooo0`0000040?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`000000R03oool00880oooo00<000000?ooo`3o
ool0403oool2000008T0oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-10.1057, -0.157216, \
0.074023, 0.00845859}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
        False,
        Editable->False], "\[IndentingNewLine]"}]], "Input"],

Cell[BoxData[
    RowBox[{\(Syntax::"noinfo"\), \(\(:\)\(\ \)\), "\<\"Input expression \
contains insufficient information to interpret result. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Syntax::noinfo\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(kk = \(-0.75\); \ s2\  = \ 2^2; \ 
    Plot[\[IndentingNewLine]{Abs[
              th]^\((1 - 
                2\ kk)\)\ Exp[\(-\((\(-2\)\  - \ 
                      th)\)^2\)/\((2\ s2)\)], \[IndentingNewLine]Abs[
              th]^\((1 - 
                2\ kk)\)\ Exp[\(-\((\(-3\)\  - \ 
                      th)\)^2\)/\((2\ s2)\)], \[IndentingNewLine]Abs[
              th]^\((1 - 
                2\ kk)\)\ Exp[\(-\((\(-4\)\  - \ 
                      th)\)^2\)/\((2\ s2)\)]\[IndentingNewLine]}, \ {th, \ \
\(-8\), \ 3}, \ \ PlotStyle\  \[Rule] \ {{Thickness[
              0.01]}}, \ \ AxesLabel\  \[Rule] \ {\[Theta], \[Pi] \((\[Theta] \
| d)\)}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\(\[IndentingNewLine]\)
    \)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.71645 0.0865801 0.0147151 0.0108868 [
[.02381 .00222 -9.03125 -15.75 ]
[.02381 .00222 9.03125 0 ]
[.19697 .00222 -9.03125 -15.75 ]
[.19697 .00222 9.03125 0 ]
[.37013 .00222 -9.03125 -15.75 ]
[.37013 .00222 9.03125 0 ]
[.54329 .00222 -9.03125 -15.75 ]
[.54329 .00222 9.03125 0 ]
[.88961 .00222 -4.84375 -15.75 ]
[.88961 .00222 4.84375 0 ]
[1.025 .01472 0 -7.875 ]
[1.025 .01472 9.4375 7.875 ]
[.70395 .12358 -15.375 -7.875 ]
[.70395 .12358 0 7.875 ]
[.70395 .23245 -15.375 -7.875 ]
[.70395 .23245 0 7.875 ]
[.70395 .34132 -15.375 -7.875 ]
[.70395 .34132 0 7.875 ]
[.70395 .45019 -15.375 -7.875 ]
[.70395 .45019 0 7.875 ]
[.70395 .55906 -15.375 -7.875 ]
[.70395 .55906 0 7.875 ]
[.71645 .64303 -19.5625 0 ]
[.71645 .64303 19.5625 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01472 m
.02381 .02097 L
s
gsave
.02381 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.19697 .01472 m
.19697 .02097 L
s
gsave
.19697 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.37013 .01472 m
.37013 .02097 L
s
gsave
.37013 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.54329 .01472 m
.54329 .02097 L
s
gsave
.54329 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.88961 .01472 m
.88961 .02097 L
s
gsave
.88961 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.125 Mabswid
.0671 .01472 m
.0671 .01847 L
s
.11039 .01472 m
.11039 .01847 L
s
.15368 .01472 m
.15368 .01847 L
s
.24026 .01472 m
.24026 .01847 L
s
.28355 .01472 m
.28355 .01847 L
s
.32684 .01472 m
.32684 .01847 L
s
.41342 .01472 m
.41342 .01847 L
s
.45671 .01472 m
.45671 .01847 L
s
.5 .01472 m
.5 .01847 L
s
.58658 .01472 m
.58658 .01847 L
s
.62987 .01472 m
.62987 .01847 L
s
.67316 .01472 m
.67316 .01847 L
s
.75974 .01472 m
.75974 .01847 L
s
.80303 .01472 m
.80303 .01847 L
s
.84632 .01472 m
.84632 .01847 L
s
.9329 .01472 m
.9329 .01847 L
s
.97619 .01472 m
.97619 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.71645 .12358 m
.7227 .12358 L
s
gsave
.70395 .12358 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.71645 .23245 m
.7227 .23245 L
s
gsave
.70395 .23245 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
1.000 setlinewidth
grestore
.71645 .34132 m
.7227 .34132 L
s
gsave
.70395 .34132 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(30) show
1.000 setlinewidth
grestore
.71645 .45019 m
.7227 .45019 L
s
gsave
.70395 .45019 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(40) show
1.000 setlinewidth
grestore
.71645 .55906 m
.7227 .55906 L
s
gsave
.70395 .55906 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(50) show
1.000 setlinewidth
grestore
.125 Mabswid
.71645 .03649 m
.7202 .03649 L
s
.71645 .05826 m
.7202 .05826 L
s
.71645 .08004 m
.7202 .08004 L
s
.71645 .10181 m
.7202 .10181 L
s
.71645 .14536 m
.7202 .14536 L
s
.71645 .16713 m
.7202 .16713 L
s
.71645 .1889 m
.7202 .1889 L
s
.71645 .21068 m
.7202 .21068 L
s
.71645 .25423 m
.7202 .25423 L
s
.71645 .276 m
.7202 .276 L
s
.71645 .29777 m
.7202 .29777 L
s
.71645 .31955 m
.7202 .31955 L
s
.71645 .36309 m
.7202 .36309 L
s
.71645 .38487 m
.7202 .38487 L
s
.71645 .40664 m
.7202 .40664 L
s
.71645 .42842 m
.7202 .42842 L
s
.71645 .47196 m
.7202 .47196 L
s
.71645 .49374 m
.7202 .49374 L
s
.71645 .51551 m
.7202 .51551 L
s
.71645 .53728 m
.7202 .53728 L
s
.71645 .58083 m
.7202 .58083 L
s
.71645 .6026 m
.7202 .6026 L
s
.25 Mabswid
.71645 0 m
.71645 .61803 L
s
gsave
.71645 .64303 -80.5625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(p) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
71.563 15.750 moveto
(H) show
75.375 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
83.188 15.750 moveto
(\\310) show
88.313 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
%%BeginResource: font Roman-MISO
%%BeginFont: Roman-MISO
/Roman /Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Roman-MISO
%%IncludeFont: Roman-MISO
/Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
%%IncludeResource: font Mathematica2
%%IncludeFont: Mathematica2
/Mathematica2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
94.313 15.750 moveto
(L) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .03661 m
.04262 .04286 L
.06244 .05085 L
.10458 .07308 L
.14264 .09939 L
.18314 .1326 L
.22214 .16657 L
.26358 .19951 L
.28435 .21275 L
.29347 .21757 L
.30351 .22206 L
.31314 .22551 L
.32216 .22791 L
.32713 .22888 L
.33168 .22953 L
.33419 .2298 L
.33552 .22992 L
.33693 .23002 L
.33829 .23009 L
.33952 .23014 L
.34076 .23018 L
.34193 .2302 L
.34309 .2302 L
.34433 .23019 L
.34551 .23016 L
.34658 .23012 L
.34784 .23006 L
.34921 .22997 L
.35169 .22975 L
.35429 .22946 L
.35705 .22906 L
.36201 .22813 L
.37079 .22582 L
.38048 .22228 L
.39982 .21226 L
.42068 .19747 L
.46182 .15928 L
.50145 .11747 L
.53955 .07966 L
.5608 .06165 L
.58011 .04783 L
.60043 .03615 L
.61916 .02795 L
.63834 .02195 L
.64845 .01967 L
.65914 .01782 L
.66858 .01662 L
.67388 .0161 L
.67872 .01572 L
.68321 .01543 L
Mistroke
.68811 .01519 L
.69274 .01501 L
.69703 .01489 L
.69968 .01483 L
.70212 .01479 L
.7048 .01476 L
.70615 .01475 L
.70762 .01474 L
.70893 .01473 L
.71012 .01473 L
.71077 .01472 L
.71149 .01472 L
.71278 .01472 L
.71399 .01472 L
.71528 .01472 L
.71638 .01472 L
.71759 .01472 L
.71877 .01472 L
.72001 .01472 L
.72106 .01472 L
.72222 .01472 L
.72347 .01473 L
.7248 .01473 L
.7272 .01475 L
.72963 .01477 L
.73192 .0148 L
.73621 .01486 L
.74086 .01495 L
.74596 .01509 L
.75626 .01545 L
.76581 .01589 L
.77473 .01637 L
.81361 .01901 L
.83339 .02039 L
.85493 .02169 L
.86495 .02219 L
.87561 .02262 L
.8847 .02292 L
.89475 .02316 L
.89965 .02325 L
.90233 .02328 L
.90482 .02331 L
.90714 .02333 L
.90924 .02335 L
.91157 .02336 L
.91286 .02337 L
.91407 .02337 L
.91527 .02337 L
.91596 .02337 L
.9166 .02337 L
Mistroke
.91789 .02337 L
.91861 .02337 L
.91927 .02337 L
.92045 .02337 L
.92173 .02337 L
.92294 .02336 L
.92407 .02335 L
.92683 .02334 L
.92932 .02331 L
.93492 .02325 L
.9398 .02317 L
.94495 .02308 L
.95418 .02286 L
.975 .02221 L
.97619 .02217 L
Mfstroke
.02381 .1013 m
.06244 .14253 L
.10458 .19754 L
.14415 .25456 L
.18221 .30781 L
.20342 .33394 L
.22272 .354 L
.23233 .36236 L
.24276 .37001 L
.25261 .37579 L
.26171 .3798 L
.26637 .38133 L
.26894 .38202 L
.27138 .38258 L
.27364 .383 L
.27611 .38337 L
.27719 .3835 L
.27835 .38361 L
.27936 .38369 L
.28044 .38376 L
.2811 .38379 L
.28183 .38382 L
.28311 .38384 L
.28383 .38384 L
.28461 .38384 L
.28534 .38382 L
.28601 .38379 L
.2873 .38372 L
.28803 .38367 L
.2887 .38362 L
.29125 .38333 L
.29351 .38299 L
.29601 .3825 L
.30106 .38119 L
.30598 .37949 L
.31115 .37725 L
.32041 .37213 L
.33037 .36503 L
.34126 .35548 L
.38182 .30588 L
.42087 .24419 L
.46237 .17525 L
.50235 .11583 L
.54082 .07142 L
.56069 .05418 L
.58173 .04005 L
.60131 .03038 L
.61962 .02397 L
.63003 .02128 L
.63991 .01929 L
Mistroke
.64878 .01789 L
.65845 .01674 L
.66378 .01625 L
.66879 .01587 L
.67335 .01559 L
.67816 .01534 L
.68342 .01513 L
.68825 .01498 L
.69344 .01487 L
.69639 .01482 L
.69914 .01479 L
.70175 .01476 L
.70417 .01474 L
.70681 .01473 L
.70815 .01473 L
.70962 .01472 L
.71091 .01472 L
.71209 .01472 L
.71338 .01472 L
.71403 .01472 L
.71474 .01472 L
.71594 .01472 L
.71723 .01472 L
.71844 .01472 L
.71954 .01472 L
.7207 .01472 L
.72193 .01472 L
.72297 .01472 L
.72413 .01472 L
.72669 .01473 L
.72909 .01474 L
.73344 .01477 L
.7381 .01481 L
.74338 .01486 L
.74826 .01493 L
.75932 .01512 L
.77943 .01558 L
.79966 .0161 L
.81867 .01657 L
.83703 .01695 L
.84705 .01711 L
.85639 .01723 L
.86601 .01733 L
.8711 .01736 L
.87371 .01738 L
.87654 .01739 L
.87913 .0174 L
.88152 .01741 L
.88381 .01742 L
.88496 .01742 L
Mistroke
.88623 .01742 L
.88738 .01742 L
.88842 .01742 L
.88963 .01742 L
.89078 .01742 L
.89184 .01742 L
.89282 .01742 L
.89389 .01742 L
.89504 .01742 L
.89765 .01741 L
.9004 .0174 L
.90534 .01738 L
.91064 .01736 L
.91647 .01732 L
.93664 .01713 L
.97619 .0166 L
Mfstroke
.02381 .28142 m
.06244 .36685 L
.10458 .4607 L
.12507 .50236 L
.14415 .53662 L
.16371 .56564 L
.18221 .58613 L
.192 .59391 L
.19752 .5973 L
.20262 .59977 L
.20692 .60136 L
.20936 .60205 L
.21164 .60256 L
.21287 .60279 L
.21405 .60296 L
.21511 .60309 L
.21625 .6032 L
.21748 .60327 L
.21862 .60331 L
.21931 .60332 L
.21997 .60331 L
.2212 .60327 L
.22236 .6032 L
.22361 .60309 L
.22478 .60294 L
.22586 .60277 L
.22848 .60225 L
.23096 .60159 L
.2359 .5998 L
.24128 .59715 L
.25087 .5906 L
.25975 .58252 L
.27842 .55948 L
.29902 .52545 L
.33922 .43929 L
.37791 .34353 L
.41905 .24348 L
.45867 .16083 L
.49678 .10015 L
.51639 .07656 L
.53734 .05675 L
.55869 .04169 L
.56848 .03629 L
.57884 .03148 L
.58837 .02781 L
.59885 .0245 L
.60832 .02208 L
.61731 .02023 L
.62747 .01858 L
.63675 .01742 L
Mistroke
.64675 .01648 L
.65236 .01607 L
.65765 .01576 L
.66262 .01551 L
.66799 .0153 L
.67246 .01515 L
.67736 .01502 L
.68268 .01492 L
.68539 .01488 L
.68829 .01484 L
.69102 .01481 L
.69349 .01478 L
.6958 .01477 L
.69834 .01475 L
.70083 .01474 L
.70317 .01473 L
.70563 .01472 L
.70701 .01472 L
.70828 .01472 L
.70932 .01472 L
.71042 .01472 L
.71163 .01472 L
.71276 .01472 L
.71403 .01472 L
.71523 .01472 L
.7163 .01472 L
.71747 .01472 L
.71876 .01472 L
.71997 .01472 L
.72067 .01472 L
.7213 .01472 L
.72272 .01472 L
.72409 .01472 L
.72558 .01472 L
.72828 .01472 L
.73079 .01473 L
.73345 .01474 L
.73824 .01475 L
.7476 .01479 L
.75769 .01485 L
.77596 .01499 L
.79558 .01514 L
.80597 .01521 L
.81707 .01528 L
.8278 .01534 L
.83757 .01537 L
.84228 .01539 L
.84738 .0154 L
.85221 .01541 L
.85666 .01542 L
Mistroke
.8591 .01542 L
.86132 .01542 L
.86255 .01542 L
.8632 .01542 L
.86389 .01542 L
.86516 .01542 L
.86634 .01542 L
.86751 .01542 L
.86879 .01542 L
.86999 .01542 L
.87109 .01542 L
.87209 .01542 L
.87319 .01542 L
.8754 .01542 L
.87809 .01542 L
.88055 .01541 L
.88607 .01541 L
.89603 .01539 L
.90595 .01536 L
.91513 .01533 L
.93589 .01525 L
.97518 .01509 L
.97619 .01509 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{44, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`008@3oool3000002@0oooo0`00
000U0?ooo`8000009@3oool2000004T0oooo0P00000l0?ooo`00803oool00`000000oooo0?ooo`02
00000280oooo0P0000000`3oool000000?ooo`0T0?ooo`8000008`3oool3000000030?ooo`000000
oooo04D0oooo0`0000000`3oool000000?ooo`0j0?ooo`00803oool01@000000oooo0?ooo`3oool0
00000280oooo00<000000?ooo`3oool00P00000T0?ooo`8000008`3oool00`000000oooo0?ooo`18
0?ooo`030000003oool0oooo03d0oooo000P0?ooo`050000003oool0oooo0?ooo`0000008P3oool0
1@000000oooo0?ooo`3oool000000280oooo1000000S0?ooo`030000003oool0oooo04P0oooo00<0
00000?ooo`3oool0?@3oool001L0oooo1`0000020?ooo`030000003oool0oooo008000006P3oool7
000000040?ooo`000000oooo0?ooo`8000006P3oool7000000030?ooo`000000oooo008000006`3o
ool700000080oooo0P0000190?ooo`800000?@3oool00240oooo0`00000S0?ooo`80000000<0oooo
0000003oool08`3oool3000002H0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`0j
0?ooo`00803oool2000000030?ooo`000000oooo0280oooo00<000000?ooo`0000009@3oool30000
02H0oooo0P0000190?ooo`800000>`3oool00200oooo00<000000?ooo`3oool00P00000R0?ooo`04
0000003oool0oooo000002D0oooo0P00000S0?ooo`050000003oool0oooo0?ooo`000000AP3oool0
1@000000oooo0?ooo`3oool0000003/0oooo000P0?ooo`80000000<0oooo0000003oool08`3oool0
0`000000oooo0000000U0?ooo`8000008`3oool00`000000oooo0?ooo`02000004H0oooo00<00000
0?ooo`3oool00P00000k0?ooo`008@3oool3000002@0oooo0`00000V0?ooo`030000003oool0oooo
0280oooo0`0000180?ooo`<00000?03oool00?l0oooo8@3oool00;X0oooo00<000000?ooo`3oool0
AP3oool2000001/0oooo002j0?ooo`030000003oool0oooo04D0oooo00@000000?ooo`3oool00000
6P3oool00;X0oooo00<000000?ooo`3oool0A@3oool010000000oooo0?ooo`00000J0?ooo`00603o
oooT000000H0oooo00D000000?ooo`3oool0oooo0000000I0?ooo`007@3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo0080ooooE000000<0?ooo`D000006@3oool001d0oooo00<00000
0?ooo`3oool0903oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo02@0oooo00<00000
0?ooo`3oool01`3ooolD000000T0oooo00<000000?ooo`3oool02`3oool^000000d0oooo00@00000
0?ooo`3oool000006@3oool009/0oooo3P00000A0?ooo`030000003oool0oooo01d0oooo7000000=
0?ooo`040000003oool0oooo000001T0oooo000M0?ooo`030000003oool0oooo07T0oooo3000000E
0?ooo`030000003oool0oooo04L0oooo0`00000I0?ooo`00703oool4000007L0oooo3000000G0?oo
o`800000I03oool001d0oooo1@00001d0?ooo`/000006@3oool00`000000oooo0?ooo`1S0?ooo`00
7`3oool7000006h0oooo100000000`3oool0000000000004000001/0oooo00<000000?ooo`3oool0
H`3oool00240oooo2000001Z0?ooo`/00000703oool00`000000oooo0?ooo`1S0?ooo`009P3oool5
000006L0oooo0`0000000`3oool0000000000004000001h0oooo00<000000?ooo`3oool0H`3oool0
02P0oooo1@00001T0?ooo`<0000000<0oooo0000000000001000000O0?ooo`800000I03oool002X0
oooo1@00001P0?ooo`@0000000<0oooo0000000000000`00000Q0?ooo`030000003oool0oooo06<0
oooo000/0?ooo`D00000G@3oool4000000030?ooo`000000000000<000008P3oool00`000000oooo
0?ooo`1S0?ooo`00;P3oool4000005/0oooo0`0000020?ooo`D000008`3oool00`000000oooo0?oo
o`1S0?ooo`00<03oool4000005T0oooo0P0000020?ooo`@000009@3oool00`000000oooo0?ooo`1S
0?ooo`00<@3oool4000005L0oooo0P0000020?ooo`@000009P3oool2000006@0oooo000c0?ooo`<0
0000E@3oool200000080oooo1000000W0?ooo`030000003oool0oooo06<0oooo000d0?ooo`@00000
D`3oool00`000000oooo0?ooo`04000002P0oooo00<000000?ooo`3oool0H`3oool003D0oooo1000
001A0?ooo`8000000P3oool3000002T0oooo00<000000?ooo`3oool0H`3oool001d0oooo00<00000
0?ooo`3oool05`3oool3000004l0oooo0P0000020?ooo`<00000:P3oool00`000000oooo0?ooo`1S
0?ooo`00703oool3000001T0oooo0`00001>0?ooo`030000003oool0oooo00<00000:`3oool20000
06@0oooo000M0?ooo`<000006@3oool3000004`0oooo0P000000103oool0000000000000000N0?oo
o`800000103oool3000000D0oooo00<000000?ooo`3oool0H`3oool001h0oooo0`00000I0?ooo`<0
0000BP3oool2000000040?ooo`000000000000000200oooo00@000000?ooo`3oool0oooo0P000000
0`3oool000000?ooo`040?ooo`030000003oool0oooo06<0oooo000O0?ooo`<000006@3oool40000
04P0oooo00<000000?ooo`0000000P00000Q0?ooo`050000003oool0oooo0?ooo`0000000P3oool2
000000@0oooo00<000000?ooo`3oool0H`3oool00200oooo0`00000I0?ooo`@00000AP3oool50000
0280oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103oool00`000000oooo0?ooo`1S
0?ooo`008@3oool3000001X0oooo0`0000140?ooo`D000008`3oool01@000000oooo0?ooo`3oool0
000000<0oooo00<000000?ooo`3oool00P3oool3000006<0oooo000R0?ooo`<000006P3oool30000
0480oooo1@00000T0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo06<0oooo000S0?ooo`<000006P3oool300000440oooo1@00000T0?oo
o`050000003oool0oooo0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3oool0H`3oool0
02@0oooo0`00000J0?ooo`<00000?`3oool5000002D0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`800000103oool00`000000oooo0?ooo`1S0?ooo`009@3oool2000001/0oooo0`00000m0?oo
o`D000009@3oool2000000<0oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo
06<0oooo000V0?ooo`8000006`3oool3000003`0oooo1@00000V0?ooo`030000003oool0oooo0080
oooo0`0000050?ooo`800000I03oool002L0oooo0P00000K0?ooo`@00000>@3oool5000003@0oooo
00<000000?ooo`3oool0H`3oool002P0oooo0P00000K0?ooo`@00000=`3oool6000003@0oooo00<0
00000?ooo`3oool0H`3oool002T0oooo00<000000?ooo`3oool06`3oool3000003H0oooo1@00000e
0?ooo`030000003oool0oooo06<0oooo000Y0?ooo`8000007@3oool3000003@0oooo0`0000000`3o
ool000000?ooo`0e0?ooo`030000003oool0oooo06<0oooo000Z0?ooo`8000007@3oool300000380
oooo0`0000000`3oool000000000000f0?ooo`800000I03oool002/0oooo0P00000M0?ooo`@00000
;`3oool3000000030?ooo`000000000003L0oooo00<000000?ooo`3oool0H`3oool002`0oooo0P00
000M0?ooo`@00000;03oool400000080oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?oo
o`1S0?ooo`00;@3oool00`000000oooo0?ooo`0M0?ooo`@00000:@3oool5000000030?ooo`000000
000003P0oooo00<000000?ooo`3oool0H`3oool002d0oooo0P00000O0?ooo`@000009`3oool30000
00030?ooo`000000oooo00800000>@3oool00`000000oooo0?ooo`1S0?ooo`00;P3oool200000200
oooo1000000T0?ooo`<0000000D0oooo000000000000oooo0000000j0?ooo`800000I03oool002l0
oooo0P00000P0?ooo`@000008P3oool300000080oooo00@000000?ooo`0000000000>P3oool00`00
0000oooo0?ooo`1S0?ooo`00<03oool00`000000oooo0?ooo`0P0?ooo`<00000803oool300000080
oooo1000000k0?ooo`030000003oool0oooo06<0oooo000`0?ooo`8000008P3oool4000001`0oooo
100000030?ooo`030000003oool0000003`0oooo00<000000?ooo`3oool0H`3oool00340oooo0P00
000R0?ooo`@000006P3oool4000000@0oooo0`00000l0?ooo`030000003oool0oooo06<0oooo000b
0?ooo`030000003oool0oooo0280oooo1000000E0?ooo`D000001@3oool3000003d0oooo0P00001T
0?ooo`00<P3oool2000002@0oooo1P00000@0?ooo`H000001P3oool200000340oooo0P0000030?oo
o`<000001@3oool00`000000oooo0?ooo`1S0?ooo`00<`3oool00`000000oooo0?ooo`0T0?ooo`H0
0000303oool5000000P0oooo0`00000_0?ooo`<0000000<0oooo0000003oool00P0000000`3oool0
00000?ooo`040?ooo`030000003oool0oooo06<0oooo000c0?ooo`800000:03oool5000000P0oooo
1@00000:0?ooo`800000<03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00800000
103oool00`000000oooo0?ooo`1S0?ooo`00=03oool2000002T0oooo3P00000;0?ooo`800000<@3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00800000103oool00`000000oooo0?oo
o`1S0?ooo`00=@3oool00`000000oooo0?ooo`0Y0?ooo`X000003@3oool200000380oooo0P000003
0?ooo`050000003oool0oooo0?ooo`000000103oool3000006<0oooo000e0?ooo`800000@03oool2
000003D0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo06<0oooo000f0?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0=03oool2
000000040?ooo`000000oooo0?ooo`800000103oool00`000000oooo0?ooo`1S0?ooo`00=P3oool2
000003h0oooo0P00000c0?ooo`070000003oool0oooo0?ooo`000000oooo000000020?ooo`800000
103oool00`000000oooo0?ooo`1S0?ooo`00=`3oool2000003`0oooo0`00000c0?ooo`030000003o
ool0oooo0080000000D0oooo000000000000oooo000000050?ooo`030000003oool0oooo06<0oooo
000h0?ooo`030000003oool0oooo03X0oooo0`00000d0?ooo`<000000`3oool3000000D0oooo0P00
001T0?ooo`00>03oool2000003X0oooo0`0000130?ooo`030000003oool0oooo06<0oooo000i0?oo
o`800000>03oool4000004<0oooo00<000000?ooo`3oool0H`3oool003X0oooo0P00000g0?ooo`<0
0000A03oool00`000000oooo0?ooo`1S0?ooo`00>`3oool00`000000oooo0?ooo`0d0?ooo`@00000
A03oool2000006@0oooo000M0?ooo`030000003oool0oooo01/0oooo0P00000e0?ooo`@00000A03o
ool00`000000oooo0?ooo`1S0?ooo`007@3oool00`000000oooo0?ooo`0L0?ooo`800000<`3oool4
000004D0oooo00<000000?ooo`3oool0H`3oool001d0oooo0P00000N0?ooo`800000<@3oool50000
04D0oooo00<000000?ooo`3oool0H`3oool001h0oooo00<000000?ooo`3oool07@3oool00`000000
oooo0?ooo`0_0?ooo`040000003oool00000000004H0oooo00<000000?ooo`3oool0H`3oool001h0
oooo0P00000N0?ooo`800000;`3oool2000000030?ooo`000000000004H0oooo0P00001T0?ooo`00
7`3oool00`000000oooo0?ooo`0M0?ooo`800000;@3oool2000000040?ooo`0000000000000004H0
oooo00<000000?ooo`3oool0H`3oool001l0oooo0P00000O0?ooo`800000:`3oool200000080oooo
0P0000170?ooo`030000003oool0oooo06<0oooo000P0?ooo`030000003oool0oooo01h0oooo0P00
000Y0?ooo`<0000000@0oooo0000000000000000A`3oool00`000000oooo0?ooo`1S0?ooo`00803o
ool2000001l0oooo0`00000X0?ooo`8000000P3oool2000004P0oooo00<000000?ooo`3oool0H`3o
ool00240oooo00<000000?ooo`3oool07P3oool2000002L0oooo0P0000030?ooo`800000B03oool2
000006@0oooo000Q0?ooo`030000003oool0oooo01l0oooo0P00000U0?ooo`<000000P3oool30000
03X0oooo0`0000030?ooo`<000001@3oool00`000000oooo0?ooo`1S0?ooo`008@3oool200000240
oooo0P00000S0?ooo`<000000`3oool2000003X0oooo00<000000?ooo`3oool00P0000001@3oool0
00000000003oool0000000D0oooo00<000000?ooo`3oool0H`3oool00280oooo00<000000?ooo`3o
ool07`3oool300000240oooo0`0000030?ooo`<00000>P3oool01`000000oooo0?ooo`3oool00000
0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3oool0H`3oool00280oooo0P00000Q0?oo
o`<000007`3oool3000000@0oooo0P00000o0?ooo`030000003oool000000080oooo0P0000040?oo
o`030000003oool0oooo06<0oooo000S0?ooo`030000003oool0oooo0200oooo0`00000N0?ooo`80
00001@3oool2000003h0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`020?oo
o`<00000H`3oool002<0oooo0P00000R0?ooo`<00000703oool2000000D0oooo0`00000m0?ooo`80
00000P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0H`3oool002@0
oooo00<000000?ooo`3oool08@3oool3000001X0oooo0`0000050?ooo`800000?`3oool010000000
oooo0?ooo`0000020?ooo`800000103oool00`000000oooo0?ooo`1S0?ooo`00903oool2000002<0
oooo0`00000I0?ooo`8000001@3oool3000003`0oooo00<000000?ooo`3oool00P000000103oool0
00000?ooo`3oool2000000@0oooo00<000000?ooo`3oool0H`3oool002D0oooo00<000000?ooo`3o
ool08P3oool4000001H0oooo0P0000060?ooo`800000?@3oool010000000oooo0?ooo`0000020?oo
o`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`1S0?ooo`009@3oool2000002@0
oooo1000000D0?ooo`8000001`3oool2000003h0oooo0`0000030?ooo`<000001@3oool2000006@0
oooo000V0?ooo`030000003oool0oooo02@0oooo0`00000A0?ooo`<000001`3oool3000004`0oooo
00<000000?ooo`3oool0H`3oool002H0oooo0P00000V0?ooo`@00000303oool6000000L0oooo0P00
001=0?ooo`030000003oool0oooo06<0oooo000W0?ooo`030000003oool0oooo02D0oooo1@000009
0?ooo`D00000203oool3000004d0oooo00<000000?ooo`3oool0H`3oool002L0oooo0P00000X0?oo
o`D000001@3oool4000000/0oooo0P00001>0?ooo`030000003oool0oooo06<0oooo000X0?ooo`03
0000003oool0oooo02P0oooo2`00000<0?ooo`800000CP3oool2000006@0oooo000X0?ooo`800000
:`3oool7000000d0oooo0`00001>0?ooo`030000003oool0oooo06<0oooo000Y0?ooo`030000003o
ool0oooo03d0oooo0P00001?0?ooo`030000003oool0oooo06<0oooo000Y0?ooo`800000?@3oool3
000004l0oooo00<000000?ooo`3oool0H`3oool002X0oooo00<000000?ooo`3oool0>`3oool20000
0500oooo00<000000?ooo`3oool0H`3oool002X0oooo0P00000l0?ooo`800000D03oool2000006@0
oooo000[0?ooo`030000003oool0oooo03T0oooo0`00001@0?ooo`030000003oool0oooo06<0oooo
000[0?ooo`030000003oool0oooo03T0oooo0P00001A0?ooo`030000003oool0oooo06<0oooo000[
0?ooo`800000>@3oool300000540oooo00<000000?ooo`3oool0H`3oool002`0oooo00<000000?oo
o`3oool0=`3oool200000580oooo00<000000?ooo`3oool0H`3oool002`0oooo0P00000h0?ooo`80
0000DP3oool2000006@0oooo000]0?ooo`030000003oool0oooo03D0oooo0P0000160?ooo`800000
0`3oool3000000D0oooo00<000000?ooo`3oool0H`3oool002d0oooo0P00000f0?ooo`800000AP3o
ool200000080oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo06<0oooo000^
0?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool0A@3oool200000080oooo00<00000
0?ooo`3oool00P0000040?ooo`030000003oool0oooo06<0oooo000^0?ooo`800000=03oool20000
04D0oooo100000020?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`1S0?oo
o`00;`3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo04@0oooo00@000000?ooo`00
000000000P3oool01@000000oooo0?ooo`3oool0000000@0oooo0`00001S0?ooo`00;`3oool20000
0380oooo0P0000170?ooo`<000000P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<00000
0?ooo`3oool0H`3oool00300oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`160?oo
o`<000000P3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0H`3oool00300
oooo0P00000`0?ooo`800000B@3oool200000080oooo00<000000?ooo`3oool00P0000040?ooo`03
0000003oool0oooo06<0oooo000`0?ooo`800000<03oool00`000000oooo0?ooo`180?ooo`800000
0P3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0H`3oool00300oooo0`00
000^0?ooo`800000B`3oool010000000oooo0?ooo`3oool3000000D0oooo0P00001T0?ooo`00<@3o
ool2000002h0oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`1S0?ooo`00<@3oool3
000002`0oooo0P00001H0?ooo`030000003oool0oooo06<0oooo000b0?ooo`800000;03oool00`00
0000oooo0?ooo`1G0?ooo`030000003oool0oooo06<0oooo000b0?ooo`800000;03oool00`000000
oooo0?ooo`1G0?ooo`030000003oool0oooo06<0oooo000c0?ooo`800000:P3oool2000005T0oooo
0P00001T0?ooo`00<`3oool2000002X0oooo00<000000?ooo`3oool0F03oool00`000000oooo0?oo
o`1S0?ooo`00=03oool00`000000oooo0?ooo`0W0?ooo`800000FP3oool00`000000oooo0?ooo`1S
0?ooo`00=03oool2000002P0oooo00<000000?ooo`3oool0F@3oool00`000000oooo0?ooo`1S0?oo
o`00=@3oool00`000000oooo0?ooo`0U0?ooo`800000F`3oool00`000000oooo0?ooo`1S0?ooo`00
=@3oool2000002H0oooo00<000000?ooo`3oool0FP3oool2000006@0oooo000f0?ooo`030000003o
ool0oooo02<0oooo0P00001L0?ooo`030000003oool0oooo06<0oooo000f0?ooo`800000903oool0
0`000000oooo0?ooo`1K0?ooo`030000003oool0oooo06<0oooo000g0?ooo`030000003oool0oooo
0240oooo0P00001M0?ooo`030000003oool0oooo06<0oooo000g0?ooo`8000008@3oool2000005h0
oooo00<000000?ooo`3oool0H`3oool003P0oooo0P00000P0?ooo`030000003oool0oooo05d0oooo
0P00001T0?ooo`00>03oool3000001h0oooo0P00001A0?ooo`<000000`3oool3000000D0oooo00<0
00000?ooo`3oool0H`3oool003T0oooo0P00000N0?ooo`030000003oool0oooo04l0oooo00@00000
0?ooo`3oool000000P3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0H`3o
ool003X0oooo0P00000L0?ooo`800000D@3oool00`000000oooo0?ooo`02000000040?ooo`000000
oooo0?ooo`800000103oool00`000000oooo0?ooo`1S0?ooo`00>P3oool3000001X0oooo0P00001F
0?ooo`030000003oool000000080oooo0P0000040?ooo`030000003oool0oooo06<0oooo000k0?oo
o`<00000603oool2000005H0oooo0P0000000`3oool000000?ooo`020?ooo`030000003oool0oooo
0080oooo0`00001S0?ooo`00?03oool3000001H0oooo0`00001C0?ooo`040000003oool0oooo0000
0080oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo06<0oooo000m0?oo
o`<000005@3oool2000005@0oooo100000020?ooo`030000003oool0oooo00800000103oool00`00
0000oooo0?ooo`1S0?ooo`00?P3oool2000001@0oooo0P00001E0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo06<0oooo000o0?ooo`800000
4P3oool3000005D0oooo00<000000?ooo`3oool00`3oool2000000030?ooo`000000oooo00@0oooo
00<000000?ooo`3oool0H`3oool003l0oooo0`00000@0?ooo`<00000EP3oool3000000@0oooo0`00
00050?ooo`800000I03oool00400oooo0`00000>0?ooo`<00000IP3oool00`000000oooo0?ooo`1S
0?ooo`00@@3oool3000000/0oooo1000001W0?ooo`030000003oool0oooo06<0oooo00120?ooo`D0
00001P3oool5000006P0oooo00<000000?ooo`3oool0H`3oool004<0oooo1P0000020?ooo`D00000
JP3oool00`000000oooo0?ooo`1S0?ooo`00AP3oool8000006`0oooo0P00001T0?ooo`00B03oool4
000006h0oooo00<000000?ooo`3oool0H`3oool00;X0oooo00<000000?ooo`3oool0H`3oool00;X0
oooo00<000000?ooo`3oool0H`3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0;@0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
05D0oooo002c0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`1D0?ooo`00Z@3oool00`000000oooo0?ooo`02000000@0oooo00@000000?ooo`3oool0
oooo0P0000060?ooo`030000003oool0oooo00<0oooo100000020?ooo`030000003oool0oooo05<0
oooo002Z0?ooo`030000003oool0000000D0oooo00@000000?ooo`3oool000000P3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00D000000?ooo`3oool0oooo000000020?oo
o`030000003oool0oooo05<0oooo002Z0?ooo`030000003oool0000000D0oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo00D000000?oo
o`3oool0oooo000000020?ooo`030000003oool0oooo05<0oooo002[0?ooo`030000003oool00000
00@0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo0080oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo05<0oooo002Y
0?ooo`050000003oool000000?ooo`000000103oool00`000000oooo0?ooo`05000000@0oooo00<0
00000?ooo`3oool00P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
D`3oool00:X0oooo1@0000030?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P0000020?ooo`030000
003oool0oooo05<0oooo002b0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00<0oooo0P0000001@3oool000000?ooo`3oool0000005D0
oooo002c0?ooo`040000003oool0oooo0?ooo`<00000103oool00`000000oooo0?ooo`060?ooo`03
0000003oool0000005H0oooo002d0?ooo`030000003oool0oooo0100oooo0P00001G0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-9.51061, -7.5224, \
0.0508908, 0.404722}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(LPMRule[d_, sig_, k_] := 
      If[\((Abs[d] \[GreaterEqual] lambda[sig, k])\), mode2[d, sig, k], 
        0]\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[{d, \ LPMRule[d, 2, 0.75]}, {d, \(-5\), 5}, \ 
      PlotStyle\  \[Rule] \ {{Dashing[{0.02}]}, {Thickness[0.01]}}, \ 
      AspectRatio\  \[Rule] \ 
        Automatic, \[IndentingNewLine]PlotRange\  \[Rule] \ All, \ 
      AxesLabel\  \[Rule] \ {d, \ None}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0952381 0.5 0.0952381 [
[.11905 .4875 -9.03125 -15.75 ]
[.11905 .4875 9.03125 0 ]
[.30952 .4875 -9.03125 -15.75 ]
[.30952 .4875 9.03125 0 ]
[.69048 .4875 -4.84375 -15.75 ]
[.69048 .4875 4.84375 0 ]
[.88095 .4875 -4.84375 -15.75 ]
[.88095 .4875 4.84375 0 ]
[1.025 .5 0 -7.875 ]
[1.025 .5 10 7.875 ]
[.4875 .11905 -18.0625 -7.875 ]
[.4875 .11905 0 7.875 ]
[.4875 .30952 -18.0625 -7.875 ]
[.4875 .30952 0 7.875 ]
[.4875 .69048 -9.6875 -7.875 ]
[.4875 .69048 0 7.875 ]
[.4875 .88095 -9.6875 -7.875 ]
[.4875 .88095 0 7.875 ]
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11905 .5 m
.11905 .50625 L
s
gsave
.11905 .4875 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.30952 .5 m
.30952 .50625 L
s
gsave
.30952 .4875 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.69048 .5 m
.69048 .50625 L
s
gsave
.69048 .4875 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.88095 .5 m
.88095 .50625 L
s
gsave
.88095 .4875 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.16667 .5 m
.16667 .50375 L
s
.21429 .5 m
.21429 .50375 L
s
.2619 .5 m
.2619 .50375 L
s
.35714 .5 m
.35714 .50375 L
s
.40476 .5 m
.40476 .50375 L
s
.45238 .5 m
.45238 .50375 L
s
.54762 .5 m
.54762 .50375 L
s
.59524 .5 m
.59524 .50375 L
s
.64286 .5 m
.64286 .50375 L
s
.7381 .5 m
.7381 .50375 L
s
.78571 .5 m
.78571 .50375 L
s
.83333 .5 m
.83333 .50375 L
s
.07143 .5 m
.07143 .50375 L
s
.02381 .5 m
.02381 .50375 L
s
.92857 .5 m
.92857 .50375 L
s
.97619 .5 m
.97619 .50375 L
s
.25 Mabswid
0 .5 m
1 .5 L
s
gsave
1.025 .5 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 .11905 m
.50625 .11905 L
s
gsave
.4875 .11905 -79.0625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .30952 m
.50625 .30952 L
s
gsave
.4875 .30952 -79.0625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .69048 m
.50625 .69048 L
s
gsave
.4875 .69048 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .88095 m
.50625 .88095 L
s
gsave
.4875 .88095 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .16667 m
.50375 .16667 L
s
.5 .21429 m
.50375 .21429 L
s
.5 .2619 m
.50375 .2619 L
s
.5 .35714 m
.50375 .35714 L
s
.5 .40476 m
.50375 .40476 L
s
.5 .45238 m
.50375 .45238 L
s
.5 .54762 m
.50375 .54762 L
s
.5 .59524 m
.50375 .59524 L
s
.5 .64286 m
.50375 .64286 L
s
.5 .7381 m
.50375 .7381 L
s
.5 .78571 m
.50375 .78571 L
s
.5 .83333 m
.50375 .83333 L
s
.5 .07143 m
.50375 .07143 L
s
.5 .02381 m
.50375 .02381 L
s
.5 .92857 m
.50375 .92857 L
s
.5 .97619 m
.50375 .97619 L
s
.25 Mabswid
.5 0 m
.5 1 L
s
.5 Mabswid
[ .02 ] 0 setdash
.02381 .02381 m
.06244 .06244 L
.10458 .10458 L
.14415 .14415 L
.18221 .18221 L
.22272 .22272 L
.26171 .26171 L
.30316 .30316 L
.34309 .34309 L
.3815 .3815 L
.42237 .42237 L
.46172 .46172 L
.49955 .49955 L
.53984 .53984 L
.57861 .57861 L
.61984 .61984 L
.65954 .65954 L
.69774 .69774 L
.73838 .73838 L
.77751 .77751 L
.81909 .81909 L
.85916 .85916 L
.89771 .89771 L
.93871 .93871 L
.97619 .97619 L
s
.01 w
[ ] 0 setdash
.02381 .06557 m
.06244 .10882 L
.10458 .15755 L
.14415 .20582 L
.18221 .2568 L
.20342 .28966 L
.21345 .30787 L
.22272 .32848 L
.22513 .33521 L
.22738 .34273 L
.22852 .34737 L
.22974 .35391 L
.23043 .36008 L
.23109 .5 L
.23233 .5 L
.23358 .5 L
.23428 .5 L
.23492 .5 L
.23615 .5 L
.23732 .5 L
.23798 .5 L
.23868 .5 L
.23993 .5 L
.24063 .5 L
.24128 .5 L
.242 .5 L
.24276 .5 L
.24403 .5 L
.2452 .5 L
.24649 .5 L
.24713 .5 L
.24785 .5 L
.24905 .5 L
.25034 .5 L
.25156 .5 L
.25267 .5 L
.25376 .5 L
.25478 .5 L
.25589 .5 L
.25707 .5 L
.25832 .5 L
.2595 .5 L
.26056 .5 L
.26171 .5 L
.26294 .5 L
.26407 .5 L
.26537 .5 L
.2666 .5 L
.26774 .5 L
.26879 .5 L
Mistroke
.26994 .5 L
.27117 .5 L
.27188 .5 L
.27253 .5 L
.27324 .5 L
.27399 .5 L
.27525 .5 L
.27597 .5 L
.27664 .5 L
.27789 .5 L
.27903 .5 L
.28034 .5 L
.28159 .5 L
.2828 .5 L
.28348 .5 L
.28413 .5 L
.28543 .5 L
.28616 .5 L
.28683 .5 L
.28796 .5 L
.28919 .5 L
.29048 .5 L
.29167 .5 L
.29236 .5 L
.2931 .5 L
.2938 .5 L
.29445 .5 L
.29568 .5 L
.29697 .5 L
.29764 .5 L
.29837 .5 L
.29967 .5 L
.30046 .5 L
.30122 .5 L
.30189 .5 L
.30263 .5 L
.30384 .5 L
.30496 .5 L
.30618 .5 L
.30747 .5 L
.30859 .5 L
.30964 .5 L
.31078 .5 L
.31201 .5 L
.31271 .5 L
.31335 .5 L
.31406 .5 L
.3148 .5 L
.31606 .5 L
.31677 .5 L
Mistroke
.31744 .5 L
.31868 .5 L
.31982 .5 L
.32113 .5 L
.32238 .5 L
.32306 .5 L
.3237 .5 L
.3249 .5 L
.32619 .5 L
.32692 .5 L
.32759 .5 L
.32871 .5 L
.32994 .5 L
.33122 .5 L
.33242 .5 L
.3331 .5 L
.33384 .5 L
.33454 .5 L
.33519 .5 L
.33641 .5 L
.33771 .5 L
.33838 .5 L
.3391 .5 L
.34041 .5 L
.34116 .5 L
.34196 .5 L
.34264 .5 L
.34338 .5 L
.3447 .5 L
.34592 .5 L
.34656 .5 L
.34726 .5 L
.34799 .5 L
.34867 .5 L
.34993 .5 L
.35108 .5 L
.35171 .5 L
.3524 .5 L
.35366 .5 L
.3549 .5 L
.35601 .5 L
.3573 .5 L
.35851 .5 L
.35964 .5 L
.36067 .5 L
.36181 .5 L
.363 .5 L
.36431 .5 L
.3655 .5 L
.36616 .5 L
Mistroke
.36688 .5 L
.36818 .5 L
.3694 .5 L
.37069 .5 L
.37179 .5 L
.373 .5 L
.37373 .5 L
.37443 .5 L
.37573 .5 L
.37645 .5 L
.37713 .5 L
.37787 .5 L
.37866 .5 L
.37935 .5 L
.38009 .5 L
.38079 .5 L
.38144 .5 L
.38266 .5 L
.38396 .5 L
.38518 .5 L
.38587 .5 L
.3865 .5 L
.38767 .5 L
.38891 .5 L
.39002 .5 L
.39106 .5 L
.3922 .5 L
.39343 .5 L
.39466 .5 L
.39536 .5 L
.39601 .5 L
.39733 .5 L
.39806 .5 L
.39873 .5 L
.39993 .5 L
.40123 .5 L
.40246 .5 L
.40359 .5 L
.40464 .5 L
.40578 .5 L
.40685 .5 L
.40783 .5 L
.40897 .5 L
.41022 .5 L
.4114 .5 L
.41249 .5 L
.41372 .5 L
.41489 .5 L
.41593 .5 L
.41706 .5 L
Mistroke
.41829 .5 L
.41959 .5 L
.4207 .5 L
.42192 .5 L
.42323 .5 L
.42444 .5 L
.42507 .5 L
.42576 .5 L
.42649 .5 L
.42717 .5 L
.42842 .5 L
.42957 .5 L
.43082 .5 L
.43214 .5 L
.43326 .5 L
.43445 .5 L
.43557 .5 L
.43659 .5 L
.4378 .5 L
.4391 .5 L
.44033 .5 L
.44146 .5 L
.44267 .5 L
.44396 .5 L
.44519 .5 L
.4463 .5 L
.44761 .5 L
.44835 .5 L
.44904 .5 L
.45029 .5 L
.45093 .5 L
.45163 .5 L
.4523 .5 L
.45302 .5 L
.45429 .5 L
.45501 .5 L
.45567 .5 L
.45639 .5 L
.45717 .5 L
.45784 .5 L
.45857 .5 L
.45926 .5 L
.4599 .5 L
.46111 .5 L
.46238 .5 L
.46359 .5 L
.4649 .5 L
.46615 .5 L
.4673 .5 L
.46844 .5 L
Mistroke
.46948 .5 L
.47067 .5 L
.4718 .5 L
.47303 .5 L
.47433 .5 L
.47544 .5 L
.47666 .5 L
.47798 .5 L
.47871 .5 L
.47938 .5 L
.48069 .5 L
.48192 .5 L
.48297 .5 L
.48413 .5 L
.48534 .5 L
.48648 .5 L
.48754 .5 L
.48851 .5 L
.48957 .5 L
.49069 .5 L
.49183 .5 L
.49305 .5 L
.4942 .5 L
.49524 .5 L
.49647 .5 L
.49717 .5 L
.49781 .5 L
.49898 .5 L
.50023 .5 L
.50144 .5 L
.50276 .5 L
.504 .5 L
.50516 .5 L
.5063 .5 L
.50734 .5 L
.50854 .5 L
.50967 .5 L
.5109 .5 L
.51221 .5 L
.51332 .5 L
.51454 .5 L
.51586 .5 L
.51659 .5 L
.51727 .5 L
.51857 .5 L
.51981 .5 L
.52086 .5 L
.52202 .5 L
.52323 .5 L
.52437 .5 L
Mistroke
.52543 .5 L
.5264 .5 L
.52752 .5 L
.52858 .5 L
.52973 .5 L
.53095 .5 L
.5321 .5 L
.53314 .5 L
.53437 .5 L
.53507 .5 L
.5357 .5 L
.53688 .5 L
.53812 .5 L
.53934 .5 L
.54002 .5 L
.54066 .5 L
.54183 .5 L
.54307 .5 L
.54418 .5 L
.54522 .5 L
.54636 .5 L
.54759 .5 L
.54882 .5 L
.54952 .5 L
.55016 .5 L
.55148 .5 L
.55221 .5 L
.55288 .5 L
.55408 .5 L
.55538 .5 L
.55661 .5 L
.55774 .5 L
.55879 .5 L
.55993 .5 L
.561 .5 L
.56198 .5 L
.56312 .5 L
.56437 .5 L
.56555 .5 L
.56664 .5 L
.56787 .5 L
.56903 .5 L
.57008 .5 L
.5712 .5 L
.57244 .5 L
.57374 .5 L
.57485 .5 L
.57607 .5 L
.57737 .5 L
.57858 .5 L
Mistroke
.57921 .5 L
.57991 .5 L
.58064 .5 L
.58132 .5 L
.58257 .5 L
.58371 .5 L
.58497 .5 L
.58629 .5 L
.5874 .5 L
.58859 .5 L
.58972 .5 L
.59074 .5 L
.59194 .5 L
.59324 .5 L
.59447 .5 L
.5956 .5 L
.5968 .5 L
.5981 .5 L
.59932 .5 L
.60044 .5 L
.60175 .5 L
.60249 .5 L
.60317 .5 L
.60443 .5 L
.60513 .5 L
.60576 .5 L
.60644 .5 L
.60715 .5 L
.60843 .5 L
.60914 .5 L
.6098 .5 L
.61053 .5 L
.61131 .5 L
.61198 .5 L
.61271 .5 L
.6134 .5 L
.61404 .5 L
.61524 .5 L
.61652 .5 L
.61772 .5 L
.61904 .5 L
.62028 .5 L
.62143 .5 L
.62257 .5 L
.62361 .5 L
.6248 .5 L
.62593 .5 L
.62716 .5 L
.62846 .5 L
.62957 .5 L
Mistroke
.63079 .5 L
.6321 .5 L
.63284 .5 L
.63351 .5 L
.63481 .5 L
.63605 .5 L
.6371 .5 L
.63826 .5 L
.63947 .5 L
.6406 .5 L
.64166 .5 L
.64263 .5 L
.64369 .5 L
.64481 .5 L
.64596 .5 L
.64717 .5 L
.64832 .5 L
.64937 .5 L
.6506 .5 L
.65129 .5 L
.65193 .5 L
.65311 .5 L
.65435 .5 L
.65556 .5 L
.65688 .5 L
.65812 .5 L
.65928 .5 L
.66042 .5 L
.66146 .5 L
.66266 .5 L
.66378 .5 L
.66502 .5 L
.66632 .5 L
.66744 .5 L
.66866 .5 L
.66997 .5 L
.67071 .5 L
.67138 .5 L
.67269 .5 L
.67392 .5 L
.67497 .5 L
.67613 .5 L
.67735 .5 L
.67848 .5 L
.67954 .5 L
.68051 .5 L
.68158 .5 L
.6827 .5 L
.68384 .5 L
.68506 .5 L
Mistroke
.68621 .5 L
.68725 .5 L
.68848 .5 L
.68918 .5 L
.68982 .5 L
.69099 .5 L
.69223 .5 L
.69345 .5 L
.69413 .5 L
.69477 .5 L
.69594 .5 L
.69718 .5 L
.69828 .5 L
.69932 .5 L
.70046 .5 L
.70169 .5 L
.70292 .5 L
.70362 .5 L
.70427 .5 L
.70558 .5 L
.70632 .5 L
.70698 .5 L
.70818 .5 L
.70948 .5 L
.71071 .5 L
.71184 .5 L
.7129 .5 L
.71403 .5 L
.7151 .5 L
.71608 .5 L
.71722 .5 L
.71847 .5 L
.71965 .5 L
.72074 .5 L
.72197 .5 L
.72313 .5 L
.72418 .5 L
.7253 .5 L
.72654 .5 L
.72784 .5 L
.72895 .5 L
.73017 .5 L
.73147 .5 L
.73268 .5 L
.73331 .5 L
.73401 .5 L
.73473 .5 L
.73541 .5 L
.73666 .5 L
.7378 .5 L
Mistroke
.73906 .5 L
.74038 .5 L
.74149 .5 L
.74268 .5 L
.74381 .5 L
.74483 .5 L
.74603 .5 L
.74733 .5 L
.74856 .5 L
.74969 .5 L
.75089 .5 L
.75219 .5 L
.75341 .5 L
.75453 .5 L
.75584 .5 L
.75657 .5 L
.75726 .5 L
.75851 .5 L
.75922 .5 L
.75985 .5 L
.76053 .5 L
.76124 .5 L
.76252 .5 L
.76323 .5 L
.76389 .5 L
.76462 .5 L
.76539 .5 L
.76607 .5 L
.7668 .5 L
.76749 .5 L
.76812 .5 L
.76933 .5 L
.77061 .6482 L
.77181 .65406 L
.77312 .65911 L
.77552 .66668 L
.78001 .67822 L
.79013 .69894 L
.80842 .72932 L
.84905 .78552 L
.88817 .83382 L
.92973 .88228 L
.96978 .92733 L
.97619 .93443 L
Mfstroke
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00Q`3oool00`000000oooo0?oo
o`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3o
ool00`000000oooo0?ooo`2F0?ooo`001P3oool00`000000oooo0?ooo`1n0?ooo`800000U`3oool0
00L0oooo00<000000?ooo`3oool0O@3oool00`000000oooo0?ooo`2F0?ooo`00203oool00`000000
oooo0?ooo`1l0?ooo`030000003oool0oooo09H0oooo00090?ooo`030000003oool0oooo07/0oooo
00<000000?ooo`3oool0UP3oool000X0oooo00<000000?ooo`3oool0NP3oool00`000000oooo0?oo
o`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`2F0?ooo`003P3oool00`000000oooo0?ooo`1f0?ooo`030000
003oool0oooo09H0oooo000?0?ooo`030000003oool0oooo07D0oooo00<000000?ooo`3oool0UP3o
ool000l0oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?ooo`2F0?ooo`001P3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo07@0oooo00<000000?ooo`3oool0UP3oool000D0
oooo0`0000090?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0UP3oool000H0oooo
0`00001n0?ooo`800000U`3oool000L0oooo0`00001m0?ooo`030000003oool0oooo09H0oooo0008
0?ooo`<00000O03oool00`000000oooo0?ooo`2F0?ooo`002@3oool3000000T0oooo00<000000?oo
o`3oool0K`3oool00`000000oooo0?ooo`2F0?ooo`002P3oool2000000X0oooo00<000000?ooo`3o
ool0KP3oool00`000000oooo0?ooo`2F0?ooo`002`3oool2000000X0oooo0P00001^0?ooo`030000
003oool0oooo09H0oooo000;0?ooo`<000002`3oool00`000000oooo0?ooo`1[0?ooo`030000003o
ool0oooo09H0oooo000<0?ooo`<00000N03oool00`000000oooo0?ooo`2F0?ooo`003@3oool30000
07L0oooo00<000000?ooo`3oool0UP3oool000h0oooo0`00001^0?ooo`8000001P3oool00`000000
oooo0?ooo`2F0?ooo`003`3oool3000000/0oooo00<000000?ooo`3oool0G`3oool2000000H0oooo
00<000000?ooo`3oool0UP3oool00100oooo0`00000;0?ooo`030000003oool0oooo05h0oooo0P00
00060?ooo`030000003oool0oooo09H0oooo000A0?ooo`<000002`3oool00`000000oooo0?ooo`1K
0?ooo`@000001P3oool00`000000oooo0?ooo`2F0?ooo`004P3oool3000000/0oooo00<000000?oo
o`3oool0D@3oool700000080oooo00@000000?ooo`00000000001P3oool2000009L0oooo000C0?oo
o`<000002`3oool00`000000oooo0?ooo`1J0?ooo`<000001P3oool00`000000oooo0?ooo`2F0?oo
o`00503oool3000006L0oooo0`0000060?ooo`030000003oool0oooo09H0oooo000E0?ooo`800000
J03oool2000000H0oooo00<000000?ooo`3oool0UP3oool001H0oooo0P00001W0?ooo`8000001P3o
ool00`000000oooo0?ooo`2F0?ooo`005P3oool3000000/0oooo00<000000?ooo`3oool0F@3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo09H0oooo000G0?ooo`<000002`3oool00`00
0000oooo0?ooo`1O0?ooo`030000003oool0oooo09H0oooo000H0?ooo`<000002`3oool00`000000
oooo0?ooo`1N0?ooo`030000003oool0oooo09H0oooo000I0?ooo`<000002`3oool00`000000oooo
0?ooo`1M0?ooo`030000003oool0oooo09H0oooo000J0?ooo`<000002`3oool00`000000oooo0?oo
o`1L0?ooo`030000003oool0oooo09H0oooo000K0?ooo`800000JP3oool00`000000oooo0?ooo`2F
0?ooo`00703oool2000006T0oooo00<000000?ooo`3oool0UP3oool001d0oooo0P00001X0?ooo`03
0000003oool0oooo09H0oooo000N0?ooo`800000303oool00`000000oooo0?ooo`1H0?ooo`800000
U`3oool001l0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`1G0?ooo`030000003o
ool0oooo09H0oooo000O0?ooo`8000003@3oool2000005L0oooo00<000000?ooo`3oool0UP3oool0
0200oooo0P00000>0?ooo`030000003oool0oooo05@0oooo00<000000?ooo`3oool0UP3oool00240
oooo0P00001T0?ooo`030000003oool0oooo09H0oooo000R0?ooo`800000H`3oool00`000000oooo
0?ooo`2F0?ooo`008`3oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo09H0oooo000S
0?ooo`8000003`3oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo09H0oooo000T0?oo
o`8000003`3oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo09H0oooo000U0?ooo`80
00003`3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo09H0oooo000V0?ooo`800000
3`3oool00`000000oooo0?ooo`1=0?ooo`030000003oool0oooo09H0oooo000V0?ooo`<000003`3o
ool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo09H0oooo000W0?ooo`800000GP3oool0
0`000000oooo0?ooo`2F0?ooo`00:03oool2000005d0oooo0P00002G0?ooo`00:03oool3000005`0
oooo00<000000?ooo`3oool0UP3oool002T0oooo0`00000?0?ooo`800000BP3oool00`000000oooo
0?ooo`2F0?ooo`00:P3oool200000140oooo00<000000?ooo`3oool0A`3oool00`000000oooo0?oo
o`2F0?ooo`00:`3oool200000100oooo00<000000?ooo`3oool0A`3oool00`000000oooo0?ooo`2F
0?ooo`00:`3oool300000100oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`2F0?oo
o`00;03oool300000100oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`2F0?ooo`00
;@3oool3000005L0oooo00<000000?ooo`3oool0UP3oool002h0oooo0P00001G0?ooo`030000003o
ool0oooo09H0oooo000_0?ooo`8000004P3oool00`000000oooo0?ooo`110?ooo`030000003oool0
oooo09H0oooo000_0?ooo`<000004P3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo
09H0oooo000`0?ooo`8000004P3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo09H0
oooo000a0?ooo`8000004P3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo09H0oooo
000b0?ooo`030000003oool0oooo0140oooo0P00000o0?ooo`800000U`3oool00380oooo0P00001C
0?ooo`030000003oool0oooo09H0oooo000c0?ooo`030000003oool0oooo0540oooo00<000000?oo
o`3oool0UP3oool003<0oooo0P00001B0?ooo`030000003oool0oooo09H0oooo000d0?ooo`800000
5@3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo09H0oooo000e0?ooo`030000003o
ool0oooo01@0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`2F0?ooo`00=@3oool2
000001H0oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`2F0?ooo`00=P3oool00`00
0000oooo0?ooo`0E0?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0UP3oool003H0
oooo0P00000G0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0UP3oool003L0oooo
00<000000?ooo`3oool0A@3oool2000000H0oooo00<000000?ooo`3oool0UP3oool003L0oooo0P00
00140?ooo`<0000000<0oooo0000003oool0103oool00`000000oooo0?ooo`2F0?ooo`00>03oool2
000004<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2F0?ooo`00>@3oool00`00
0000oooo0?ooo`0F0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`2F0?ooo`00>@3oool2000001P0oooo00<000000?ooo`3oool07P3oool7000000<0
oooo0P0000070?ooo`800000U`3oool003X0oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`0Y0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0UP3oool003X0oooo0P00
000I0?ooo`030000003oool0oooo02P0oooo0P0000050?ooo`030000003oool0oooo09H0oooo000k
0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0903oool01@000000oooo0?ooo`3o
ool0000000D0oooo00<000000?ooo`3oool0UP3oool003/0oooo0P0000100?ooo`030000003oool0
oooo008000001@3oool00`000000oooo0?ooo`2F0?ooo`00?03oool00`000000oooo0?ooo`0o0?oo
o`<000001P3oool00`000000oooo0?ooo`2F0?ooo`00?03oool00`000000oooo0?ooo`0K0?ooo`03
0000003oool0oooo02X0oooo00<000000?ooo`3oool0UP3oool003`0oooo0P00000M0?ooo`030000
003oool0oooo02T0oooo00<000000?ooo`3oool0UP3oool003d0oooo00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo09H0oooo000l0?ooo`8000007P3oool0
0`000000oooo0?ooo`0X0?ooo`030000003oool0oooo09H0oooo000m0?ooo`030000003oool0oooo
01d0oooo0P00000X0?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000B03oool00`000000
oooo0?ooo`2F0?ooo`00?P3oool00`000000oooo0?ooo`160?ooo`800000U`3oool003d0oooo0P00
00180?ooo`030000003oool0oooo09H0oooo000m0?ooo`8000008`3oool00`000000oooo0?ooo`0R
0?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000903oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo09H0oooo000m0?ooo`800000903oool00`000000oooo0?ooo`0Q0?ooo`03
0000003oool0oooo09H0oooo000m0?ooo`8000009@3oool00`000000oooo0?ooo`0P0?ooo`030000
003oool0oooo09H0oooo000m0?ooo`8000009P3oool00`000000oooo0?ooo`0O0?ooo`030000003o
ool0oooo09H0oooo000m0?ooo`800000B03oool00`000000oooo0?ooo`2F0?ooo`00?@3oool20000
04P0oooo00<000000?ooo`3oool0UP3oool003d0oooo0P0000180?ooo`030000003oool0oooo09H0
oooo000m0?ooo`800000:P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo09H0oooo
000m0?ooo`800000:`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo09H0oooo000m
0?ooo`800000;03oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo09H0oooo000m0?oo
o`800000;@3oool00`000000oooo0?ooo`0H0?ooo`800000U`3oool003d0oooo0P00000^0?ooo`03
0000003oool0oooo01L0oooo00<000000?ooo`3oool0UP3oool003d0oooo0P0000180?ooo`030000
003oool0oooo09H0oooo000m0?ooo`800000B03oool00`000000oooo0?ooo`2F0?ooo`00?@3oool2
00000380oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`2F0?ooo`00?@3oool20000
03<0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`2F0?ooo`00?@3oool2000003@0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`2F0?ooo`00?@3oool2000003D0oooo
00<000000?ooo`3oool0403oool00`000000oooo0?ooo`2F0?ooo`00?@3oool2000003H0oooo00<0
00000?ooo`3oool03`3oool00`000000oooo0?ooo`2F0?ooo`00?@3oool2000004P0oooo00<00000
0?ooo`3oool0UP3oool003d0oooo0P0000180?ooo`030000003oool0oooo09H0oooo000T0?ooo`80
00005`3oool2000001P0oooo0P00000^0?ooo`030000003oool0oooo0300oooo0P00000b0?ooo`80
0000<03oool002@0oooo0P00000G0?ooo`8000005P3oool3000000030?ooo`000000oooo01h0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0^0?ooo`<0000000<0oooo0000003oool0
<03oool200000300oooo000T0?ooo`8000005`3oool2000001H0oooo00<000000?ooo`3oool08P3o
ool00`000000oooo0?ooo`0:0?ooo`800000;`3oool00`000000oooo0?ooo`0c0?ooo`800000<03o
ool00280oooo1000000G0?ooo`8000005P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0
oooo00X0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0a0?ooo`@00000<03oool0
01X0oooo1`0000000`3oool000000?ooo`02000001L0oooo0P00000>0?ooo`L000000P3oool20000
02<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0_0?ooo`800000<@3oool01000
0000oooo00000000000`0?ooo`008`3oool3000001L0oooo0P00000I0?ooo`030000003oool0oooo
0240oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo
02l0oooo0`00000`0?ooo`008`3oool3000001L0oooo0P00000I0?ooo`800000;@3oool00`000000
oooo0?ooo`0a0?ooo`800000<03oool300000300oooo000T0?ooo`8000005`3oool2000001H0oooo
00D000000?ooo`3oool0oooo0000000]0?ooo`030000003oool0oooo02h0oooo00D000000?ooo`3o
ool0oooo0000000a0?ooo`800000<03oool002@0oooo0P00000G0?ooo`8000005P3oool00`000000
oooo0?ooo`02000002d0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0200000340
oooo0P00000`0?ooo`009@3oool00`000000oooo0?ooo`0E0?ooo`8000005`3oool3000002L0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0_0?ooo`<00000<`3oool00`000000oooo
0?ooo`0^0?ooo`00?@3oool200000480oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`2F0?ooo`00?@3oool2000004<0oooo0P0000030?ooo`030000003oool0oooo08l0oooo0`000004
0?ooo`00?@3oool2000004D0oooo00@000000?ooo`3oool00000T03oool2000000030?ooo`000000
000000<0oooo000m0?ooo`800000B03oool00`000000oooo0?ooo`2>0?ooo`030000003oool0oooo
008000000`3oool003d0oooo0P0000180?ooo`030000003oool0oooo08h0oooo00<000000?ooo`3o
ool00P0000030?ooo`00o`00000@000000T0oooo00<000000?ooo`3oool00P0000030?ooo`001P3o
ool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3o
ool00`000000oooo0?ooo`090?ooo`040000003oool0oooo0?oooi@000000`3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo00h0oooo0P0000000`3oool00000000000030?ooo`00803o
ool00`000000oooo0?ooo`0`0?ooo`030000003oool0oooo0340oooo00<000000?ooo`000000<03o
ool00`000000oooo0?ooo`0B0?ooo`8000007@3oool00`000000oooo0?ooo`0X0?ooo`@000000`3o
ool008L0oooo00@000000?ooo`3oool00000A03oool2000004X0oooo0P0000030?ooo`00Q`3oool0
1@000000oooo0?ooo`3oool0000004<0oooo0P00001:0?ooo`8000000`3oool008L0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`100?ooo`800000B@3oool3000000<0oooo00270?oo
o`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`150?ooo`80
0000C`3oool008L0oooo00<000000?ooo`3oool0A@3oool2000004l0oooo00270?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0?@3oool2000004l0oooo00270?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool0?03oool2000004l0oooo00270?ooo`030000003oool0oooo
00L0oooo00<000000?ooo`3oool0>`3oool2000004l0oooo00270?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool0>P3oool2000004l0oooo00270?ooo`8000002P3oool00`000000oooo
0?ooo`0i0?ooo`800000C`3oool008L0oooo00<000000?ooo`3oool0A@3oool2000004l0oooo0027
0?ooo`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`150?oo
o`800000C`3oool008L0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0e0?ooo`80
0000C`3oool008L0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0d0?ooo`800000
C`3oool008L0oooo00<000000?ooo`3oool03`3oool2000003@0oooo0P00001?0?ooo`00Q`3oool0
0`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0340oooo0P00001?0?ooo`00Q`3oool00`00
0000oooo0?ooo`150?ooo`800000C`3oool008L0oooo00<000000?ooo`3oool0A@3oool2000004l0
oooo00270?ooo`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?oo
o`0E0?ooo`030000003oool0oooo02d0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0F
0?ooo`030000003oool0oooo02`0oooo0P00001?0?ooo`00Q`3oool2000001P0oooo00<000000?oo
o`3oool0:`3oool2000004l0oooo00270?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3o
ool0:P3oool2000004l0oooo00270?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0
:@3oool2000004l0oooo00270?ooo`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3oool0
0`000000oooo0?ooo`150?ooo`800000C`3oool008L0oooo00<000000?ooo`3oool0A@3oool20000
04l0oooo00270?ooo`030000003oool0oooo01`0oooo0P00000W0?ooo`800000C`3oool008L0oooo
00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0T0?ooo`800000C`3oool008L0oooo00<0
00000?ooo`3oool07P3oool00`000000oooo0?ooo`0T0?ooo`800000C`3oool008L0oooo00<00000
0?ooo`3oool07`3oool00`000000oooo0?ooo`0S0?ooo`800000C`3oool008L0oooo00<000000?oo
o`3oool0803oool00`000000oooo0?ooo`0R0?ooo`800000C`3oool008L0oooo00<000000?ooo`3o
ool0A@3oool2000004l0oooo00270?ooo`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3o
ool2000004H0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0
oooo01h0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo
01d0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0V0?ooo`8000007@3oool2000004l0
oooo00270?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`1=0?ooo`00Q`3oool00`000000oooo0?ooo`160?ooo`800000CP3oool008L0oooo00<00000
0?ooo`3oool0A`3oool00`000000oooo0?ooo`1<0?ooo`00Q`3oool00`000000oooo0?ooo`170?oo
o`800000C@3oool008L0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0H0?ooo`80
0000C@3oool007l0oooo0P0000060?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool0
603oool00`000000oooo0?ooo`1;0?ooo`00O@3oool3000000030?ooo`000000oooo00@0oooo00<0
00000?ooo`3oool0;P3oool00`000000oooo0?ooo`0G0?ooo`800000C03oool007d0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool0BP3oool007d0oooo00<000000?ooo`3oool01`3oool200000340oooo00<000000?oo
o`3oool05P3oool2000004/0oooo001n0?ooo`8000001`3oool00`000000oooo0?ooo`1:0?ooo`03
0000003oool0oooo04T0oooo00200?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
BP3oool2000004X0oooo00200?ooo`8000001@3oool00`000000oooo0?ooo`1;0?ooo`030000003o
ool0oooo04P0oooo001m0?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?oo
o`0c0?ooo`030000003oool0oooo01D0oooo0P0000190?ooo`00O@3oool00`000000oooo0?ooo`02
000000D0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`0E0?ooo`800000B03oool0
07h0oooo0`0000060?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`160?ooo`00Q`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo01@0
oooo0P0000170?ooo`00Q`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo01@0oooo
00<000000?ooo`3oool0A@3oool008L0oooo00<000000?ooo`3oool0CP3oool2000004H0oooo0027
0?ooo`030000003oool0oooo04l0oooo0P0000150?ooo`00Q`3oool00`000000oooo0?ooo`0k0?oo
o`030000003oool0oooo0180oooo00<000000?ooo`3oool0@`3oool008L0oooo00<000000?ooo`3o
ool0?03oool00`000000oooo0?ooo`0A0?ooo`800000A03oool008L0oooo0P00000n0?ooo`030000
003oool0oooo0140oooo0P0000130?ooo`00Q`3oool00`000000oooo0?ooo`0n0?ooo`030000003o
ool0oooo0140oooo0P0000120?ooo`00Q`3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0
oooo0140oooo00<000000?ooo`3oool0@03oool008L0oooo00<000000?ooo`3oool0D`3oool20000
0440oooo00270?ooo`030000003oool0oooo05@0oooo0P0000100?ooo`00Q`3oool00`000000oooo
0?ooo`1E0?ooo`030000003oool0oooo03h0oooo00270?ooo`030000003oool0oooo04<0oooo00<0
00000?ooo`3oool03`3oool2000003l0oooo00270?ooo`030000003oool0oooo04@0oooo00<00000
0?ooo`3oool03`3oool2000003h0oooo00270?ooo`030000003oool0oooo04@0oooo00<000000?oo
o`3oool0403oool2000003d0oooo00270?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3o
ool0403oool00`000000oooo0?ooo`0k0?ooo`00Q`3oool00`000000oooo0?ooo`160?ooo`030000
003oool0oooo00l0oooo0P00000l0?ooo`00Q`3oool00`000000oooo0?ooo`1I0?ooo`800000>`3o
ool008L0oooo00<000000?ooo`3oool0FP3oool2000003X0oooo00270?ooo`800000G03oool20000
03T0oooo00270?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool03P3oool3000003P0
oooo00270?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool03P3oool3000003L0oooo
00270?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool03P3oool2000003L0oooo0027
0?ooo`030000003oool0oooo04d0oooo00<000000?ooo`3oool03P3oool2000003H0oooo00270?oo
o`030000003oool0oooo04h0oooo00<000000?ooo`3oool03@3oool3000003D0oooo00270?ooo`03
0000003oool0oooo05l0oooo0`00000d0?ooo`00Q`3oool00`000000oooo0?ooo`1P0?ooo`<00000
<`3oool008L0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`0<0?ooo`<00000<P3o
ool008L0oooo00<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`0<0?ooo`800000<P3oool0
08L0oooo00<000000?ooo`3oool0E03oool00`000000oooo0?ooo`0<0?ooo`800000<@3oool008L0
oooo00<000000?ooo`3oool0E@3oool00`000000oooo0?ooo`0;0?ooo`<00000<03oool008L0oooo
00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0;0?ooo`<00000;`3oool008L0oooo0P00
001V0?ooo`<00000;P3oool008L0oooo00<000000?ooo`3oool0IP3oool3000002d0oooo00270?oo
o`030000003oool0oooo06L0oooo0`00000/0?ooo`00Q`3oool00`000000oooo0?ooo`1J0?ooo`03
0000003oool0oooo00/0oooo0P00000/0?ooo`00Q`3oool00`000000oooo0?ooo`1K0?ooo`030000
003oool0oooo00/0oooo0P00000[0?ooo`00Q`3oool00`000000oooo0?ooo`1K0?ooo`030000003o
ool0oooo00/0oooo0`00000Z0?ooo`00Q`3oool00`000000oooo0?ooo`1L0?ooo`030000003oool0
oooo00/0oooo0`00000Y0?ooo`00Q`3oool00`000000oooo0?ooo`1M0?ooo`030000003oool0oooo
00/0oooo0`00000X0?ooo`00Q`3oool00`000000oooo0?ooo`1/0?ooo`<000009`3oool007l0oooo
0P0000060?ooo`030000003oool0oooo06d0oooo0P00000W0?ooo`00O`3oool2000000H0oooo00<0
00000?ooo`3oool0KP3oool2000002H0oooo001o0?ooo`8000001P3oool00`000000oooo0?ooo`1Q
0?ooo`030000003oool0oooo00X0oooo0`00000U0?ooo`00O@3oool4000000H0oooo00<000000?oo
o`3oool0HP3oool00`000000oooo0?ooo`0:0?ooo`<00000903oool007d0oooo00@000000?ooo`00
000000001P3oool2000006@0oooo0P00000;0?ooo`<000008`3oool007h0oooo0`0000060?ooo`03
0000003oool0oooo06D0oooo00<000000?ooo`3oool02@3oool300000280oooo001n0?ooo`<00000
1P3oool00`000000oooo0?ooo`1b0?ooo`<000008@3oool007l0oooo0P0000060?ooo`030000003o
ool0oooo07<0oooo0`00000P0?ooo`00O`3oool2000000H0oooo00<000000?ooo`3oool0M03oool3
000001l0oooo00200?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0J@3oool00`00
0000oooo0?ooo`090?ooo`8000007`3oool008L0oooo00<000000?ooo`3oool0JP3oool00`000000
oooo0?ooo`090?ooo`8000007P3oool008L0oooo00<000000?ooo`3oool0J`3oool00`000000oooo
0?ooo`080?ooo`<000007@3oool008L0oooo00<000000?ooo`3oool0K03oool00`000000oooo0?oo
o`080?ooo`<00000703oool008L0oooo00<000000?ooo`3oool0K@3oool00`000000oooo0?ooo`08
0?ooo`<000006`3oool008L0oooo00<000000?ooo`3oool0N@3oool3000001X0oooo00270?ooo`03
0000003oool0oooo07X0oooo0`00000I0?ooo`00Q`3oool00`000000oooo0?ooo`1k0?ooo`800000
6@3oool008L0oooo0P00001b0?ooo`030000003oool0oooo00P0oooo0P00000H0?ooo`00Q`3oool0
0`000000oooo0?ooo`1b0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool05P3oool0
08L0oooo00<000000?ooo`3oool0LP3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
01H0oooo00270?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0803oool008L0oooo
00<000000?ooo`3oool0M03oool00`000000oooo0?ooo`0O0?ooo`00Q`3oool00`000000oooo0?oo
o`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`1h0?ooo`030000003oool0oooo01/0oooo00270?ooo`030000
003oool0oooo07T0oooo00<000000?ooo`3oool06P3oool008L0oooo00<000000?ooo`3oool0NP3o
ool2000001X0oooo00270?ooo`030000003oool0oooo07`0oooo00<000000?ooo`3oool05`3oool0
08L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00002G0?ooo`00Q`3oool00`000000oooo
0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F
0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00
Q`3oool00`000000oooo0?ooo`2F0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-5.25005, -5.57557, 0.0388542, \
0.0388542}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[
    \(\(phi[\ d_, \ th_, \ s2_] := \ 
        1/Sqrt[2\ Pi\ s2]\ \ Exp[\ \(-\ \((d\  - \ 
                      th)\)^2\)/\((2\ s2)\)];\)\)], "Input"],

Cell[BoxData[
    \(\[IndentingNewLine]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(Here\ is\ the\ Exact\ Risk\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(Exact\ Here\ is\ Risk\ the ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ sig\  = \ 2, \ 
      k\  = \ 3/
          4\ *) \)\(\[IndentingNewLine]\)\(Plot[\[IndentingNewLine]NIntegrate[\
\ \ \((th\  - 1/2 \((\ 
                      d\  - \ Sqrt[
                          d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ phi[
              d, \ th, \ 
              2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                2\ 3/4\  - 
                  1]}]\  + \[IndentingNewLine]NIntegrate[\ \ th^2\ phi[d, \ 
              th, \ 2^2], {d, \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                2\ 3/4\  - 1], \ \((2\ \ 2)\)\ \ Sqrt[
                2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
        NIntegrate[\ \ \((th\  - 
                  1/2 \((\ 
                      d\  + \ Sqrt[
                          d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ phi[
              d, \ th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
            Infinity}], \[IndentingNewLine]{th, \(-10\), 10}\ , 
      PlotRange\  \[Rule] \ {0, \ 7}, \[IndentingNewLine]\ 
      PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \ 
      AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 -2.08167e-017 0.0882906 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .08829 -9.6875 -7.875 ]
[.4875 .08829 0 7.875 ]
[.4875 .17658 -9.6875 -7.875 ]
[.4875 .17658 0 7.875 ]
[.4875 .26487 -9.6875 -7.875 ]
[.4875 .26487 0 7.875 ]
[.4875 .35316 -9.6875 -7.875 ]
[.4875 .35316 0 7.875 ]
[.4875 .44145 -9.6875 -7.875 ]
[.4875 .44145 0 7.875 ]
[.4875 .52974 -9.6875 -7.875 ]
[.4875 .52974 0 7.875 ]
[.4875 .61803 -9.6875 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .08829 m
.50625 .08829 L
s
gsave
.4875 .08829 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .17658 m
.50625 .17658 L
s
gsave
.4875 .17658 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .26487 m
.50625 .26487 L
s
gsave
.4875 .26487 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 .35316 m
.50625 .35316 L
s
gsave
.4875 .35316 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .44145 m
.50625 .44145 L
s
gsave
.4875 .44145 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 .52974 m
.50625 .52974 L
s
gsave
.4875 .52974 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01766 m
.50375 .01766 L
s
.5 .03532 m
.50375 .03532 L
s
.5 .05297 m
.50375 .05297 L
s
.5 .07063 m
.50375 .07063 L
s
.5 .10595 m
.50375 .10595 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .14126 m
.50375 .14126 L
s
.5 .15892 m
.50375 .15892 L
s
.5 .19424 m
.50375 .19424 L
s
.5 .2119 m
.50375 .2119 L
s
.5 .22956 m
.50375 .22956 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .28253 m
.50375 .28253 L
s
.5 .30019 m
.50375 .30019 L
s
.5 .31785 m
.50375 .31785 L
s
.5 .3355 m
.50375 .3355 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .38848 m
.50375 .38848 L
s
.5 .40614 m
.50375 .40614 L
s
.5 .42379 m
.50375 .42379 L
s
.5 .45911 m
.50375 .45911 L
s
.5 .47677 m
.50375 .47677 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .51209 m
.50375 .51209 L
s
.5 .5474 m
.50375 .5474 L
s
.5 .56506 m
.50375 .56506 L
s
.5 .58272 m
.50375 .58272 L
s
.5 .60038 m
.50375 .60038 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .37592 m
.04262 .37886 L
.06244 .38284 L
.08255 .38817 L
.10458 .39609 L
.12415 .40557 L
.14509 .41895 L
.16639 .43659 L
.18653 .4572 L
.22495 .50484 L
.24439 .52998 L
.25471 .54236 L
.26581 .55417 L
.27642 .56336 L
.28146 .56683 L
.28613 .56944 L
.2908 .57143 L
.29326 .5722 L
.29452 .57252 L
.29589 .57281 L
.29719 .57303 L
.29839 .57318 L
.29954 .57327 L
.30075 .57332 L
.30184 .57332 L
.30286 .57328 L
.30397 .5732 L
.30517 .57305 L
.30638 .57285 L
.30773 .57257 L
.31045 .57177 L
.31297 .57077 L
.31534 .5696 L
.32066 .56613 L
.32641 .56104 L
.3369 .54804 L
.34653 .53188 L
.36545 .48879 L
.38615 .42704 L
.42671 .2857 L
.44545 .22553 L
.45531 .19843 L
.46576 .1744 L
.47105 .16434 L
.47686 .15505 L
.48221 .14824 L
.4871 .14353 L
.48968 .14164 L
.49212 .14023 L
.49337 .13966 L
Mistroke
.4947 .13915 L
.49547 .13891 L
.49616 .13873 L
.49682 .13858 L
.49751 .13846 L
.49877 .13831 L
.49993 .13826 L
.50117 .1383 L
.50188 .13837 L
.50253 .13846 L
.50373 .1387 L
.50481 .139 L
.50725 .13993 L
.50955 .14116 L
.51208 .14289 L
.51719 .1476 L
.52193 .15337 L
.52638 .15999 L
.53638 .17889 L
.54715 .20483 L
.58834 .33861 L
.60891 .41062 L
.62802 .47075 L
.64648 .51766 L
.65681 .53794 L
.66618 .55236 L
.67105 .55832 L
.67619 .56351 L
.68058 .56705 L
.6854 .56999 L
.68812 .57123 L
.69059 .57211 L
.69196 .57249 L
.69345 .57282 L
.69414 .57295 L
.69486 .57306 L
.69616 .57321 L
.69735 .57329 L
.69863 .57333 L
.69983 .5733 L
.70094 .57324 L
.70217 .57311 L
.70286 .57302 L
.70351 .57292 L
.70622 .57234 L
.70884 .57155 L
.71125 .57063 L
.71672 .56792 L
.72665 .56095 L
.74523 .54242 L
Mistroke
.7846 .49236 L
.82245 .44754 L
.84351 .42786 L
.86276 .4135 L
.88265 .40198 L
.90155 .39362 L
.92137 .387 L
.93977 .38234 L
.95887 .3786 L
.97619 .37592 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005`3oool2000000@0oooo0`00
000d0?ooo`<00000K03oool3000003@0oooo0P0000040?ooo`<000007@3oool001P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0b0?ooo`040000003oool0oooo000006/0oooo
00@000000?ooo`3oool00000=@3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01`0oooo000H0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?oo
o`3oool00P00001Z0?ooo`030000003oool0oooo00800000=03oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000L0?ooo`00603oool01@000000oooo0?ooo`3oool000000080oooo0P00000f
0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0<P3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000L0?ooo`003P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02L0oooo1`0000050?ooo`800000K@3oool2000003@0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01X0oooo000H0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0`0?ooo`040000003oool0oooo000006/0
oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool06P3oool001P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000<P3oool4
000006/0oooo1000000e0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo000H
0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0f0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo
000G0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0e0?ooo`8000000`3oool2000000030?ooo`000000oooo01`0oooo000H
0?ooo`030000003oool0oooo0080oooo0`00000c0?ooo`<00000K03oool3000003H0oooo00<00000
0?ooo`3oool00P3oool3000001d0oooo003o0?ooob40oooo003o0?ooo`h0oooo0P00000A0?ooo`00
o`3oool=0?ooo`040000003oool0oooo00000100oooo003o0?ooo`d0oooo00@000000?ooo`3oool0
0000403oool00140oooom00000070?ooo`050000003oool0oooo0?ooo`0000003`3oool001L0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00/0oooo
1@00000?0?ooo`005`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00`0oooo00@0
00000?ooo`3oool000003`3oool008X0oooo00<000000?ooo`3oool0P03oool010000000oooo0?oo
o`00000?0?ooo`00RP3oool00`000000oooo0?ooo`210?ooo`<000003`3oool008X0oooo0P00002D
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0
oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<00000
0?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3o
ool0T`3oool00880oooo0P0000060?ooo`800000U03oool008<0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`2C0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo09<0oooo00230?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008<0
oooo00<000000?ooo`3oool0103oool3000009<0oooo00230?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool0T`3oool008<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`2C0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo00220?oo
o`8000001P3oool2000009@0oooo00230?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3o
ool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000
oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00Q`3oool700000980oooo0026
0?ooo`T00000T@3oool008H0oooo0`000000103oool000000?ooo`3oool300000900oooo00250?oo
o`8000000`3oool010000000oooo0?ooo`3oool3000008l0oooo00240?ooo`800000103oool00`00
0000oooo0?ooo`020?ooo`<00000SP3oool008<0oooo0`0000040?ooo`800000103oool3000008d0
oooo00210?ooo`D00000103oool00`000000oooo0?ooo`040?ooo`800000S@3oool00840oooo0`00
00060?ooo`030000003oool0oooo00@0oooo0P00002=0?ooo`00P@3oool3000000H0oooo00<00000
0?ooo`3oool01@3oool2000008`0oooo00220?ooo`8000001P3oool3000000D0oooo0P00002<0?oo
o`00P@3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`2:0?ooo`00P@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0
1P3oool2000008/0oooo00200?ooo`8000000`3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool0R@3oool00800oooo0P0000020?ooo`800000103oool0
0`000000oooo0?ooo`070?ooo`800000RP3oool007l0oooo0P000000103oool00000000000000005
0?ooo`8000002@3oool00`000000oooo0?ooo`280?ooo`00O`3oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo00P0oooo0P0000290?ooo`00OP3oool2000000X0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`270?ooo`00OP3oool2000000X0oooo00<000000?ooo`3oool0
2@3oool2000008P0oooo001m0?ooo`<000002P3oool2000000X0oooo0P0000280?ooo`00O@3oool2
000000/0oooo00<000000?ooo`3oool02@3oool3000008L0oooo001m0?ooo`8000002`3oool00`00
0000oooo0?ooo`0:0?ooo`800000Q`3oool007`0oooo0`00000;0?ooo`030000003oool0oooo00X0
oooo0P0000270?ooo`00O03oool2000000`0oooo0P00000;0?ooo`800000Q`3oool007`0oooo0P00
000<0?ooo`030000003oool0oooo00X0oooo0`0000260?ooo`00N`3oool3000000`0oooo00<00000
0?ooo`3oool02`3oool2000008H0oooo001k0?ooo`8000003@3oool00`000000oooo0?ooo`0;0?oo
o`800000QP3oool007/0oooo0P00000=0?ooo`800000303oool3000008D0oooo001j0?ooo`<00000
1@3oool3000000D0oooo00<000000?ooo`3oool0303oool2000008D0oooo001j0?ooo`8000001@3o
ool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0303oool2000008D0oooo001j
0?ooo`8000001@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0303o
ool3000008@0oooo001i0?ooo`<000002@3oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo00d0oooo0P0000240?ooo`00N@3oool2000000T0oooo00<000000?ooo`3oool00`3oool30000
00d0oooo0P0000240?ooo`00N@3oool2000000P0oooo0P0000050?ooo`030000003oool0oooo00d0
oooo0P0000240?ooo`00N03oool3000000T0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`0=0?ooo`<00000P`3oool007P0oooo0P0000070?ooo`030000003oool0oooo00800000103o
ool00`000000oooo0?ooo`0>0?ooo`800000P`3oool007P0oooo0P0000070?ooo`040000003oool0
oooo000000D0oooo0P00000?0?ooo`800000P`3oool007L0oooo0`0000080?ooo`<000001@3oool0
0`000000oooo0?ooo`0>0?ooo`<00000PP3oool007L0oooo0P00000A0?ooo`030000003oool0oooo
00l0oooo0P0000220?ooo`00M`3oool200000140oooo00<000000?ooo`3oool03`3oool200000880
oooo001g0?ooo`8000004@3oool200000100oooo0`0000210?ooo`00MP3oool300000140oooo00<0
00000?ooo`3oool0403oool200000840oooo001f0?ooo`8000004P3oool00`000000oooo0?ooo`0@
0?ooo`800000P@3oool007H0oooo0P00000B0?ooo`030000003oool0oooo0100oooo0`0000200?oo
o`00MP3oool200000180oooo00<000000?ooo`3oool04@3oool200000800oooo001e0?ooo`<00000
4P3oool200000180oooo0P0000200?ooo`00M@3oool2000001<0oooo00<000000?ooo`3oool04@3o
ool200000800oooo001e0?ooo`8000004`3oool00`000000oooo0?ooo`0A0?ooo`<00000O`3oool0
07@0oooo0`00000C0?ooo`030000003oool0oooo0180oooo0P00001o0?ooo`00M03oool2000000d0
oooo0P0000050?ooo`8000004`3oool2000007l0oooo001d0?ooo`8000003@3oool2000000D0oooo
00<000000?ooo`3oool04P3oool3000007h0oooo001d0?ooo`8000003@3oool2000000D0oooo00<0
00000?ooo`3oool04`3oool2000007h0oooo001c0?ooo`<000002`3oool4000000D0oooo00<00000
0?ooo`3oool04`3oool2000007h0oooo001c0?ooo`800000303oool010000000oooo000000000005
0?ooo`<000004`3oool3000007d0oooo001c0?ooo`8000003@3oool3000000D0oooo00<000000?oo
o`3oool0503oool2000007d0oooo001c0?ooo`8000003@3oool3000000D0oooo00<000000?ooo`3o
ool0503oool2000007d0oooo001b0?ooo`<000003P3oool2000000D0oooo00<000000?ooo`3oool0
503oool2000007d0oooo001b0?ooo`8000003`3oool2000000D0oooo00<000000?ooo`3oool0503o
ool3000007`0oooo001b0?ooo`800000403oool00`000000oooo0?ooo`030?ooo`8000005P3oool2
000007`0oooo000F0?ooo`X00000DP3oool2000001H0oooo00<000000?ooo`3oool05@3oool20000
0540oooo2P00000Q0?ooo`005P3oool=000004h0oooo0`00000F0?ooo`030000003oool0oooo01D0
oooo0`00001<0?ooo`h000008@3oool00200oooo1P00001;0?ooo`8000005`3oool00`000000oooo
0?ooo`0F0?ooo`800000B@3oool7000002/0oooo000R0?ooo`H00000B@3oool2000001L0oooo0P00
000G0?ooo`800000A`3oool6000002h0oooo000U0?ooo`H00000A@3oool3000001L0oooo00<00000
0?ooo`3oool05P3oool2000004@0oooo1P00000a0?ooo`009`3oool6000004<0oooo0P00000H0?oo
o`030000003oool0oooo01H0oooo0`0000110?ooo`H00000<`3oool002X0oooo1P0000100?ooo`80
0000603oool00`000000oooo0?ooo`0G0?ooo`800000?`3oool5000003H0oooo000/0?ooo`H00000
?P3oool2000001P0oooo0P00000H0?ooo`800000?P3oool4000003P0oooo000_0?ooo`@00000?03o
ool3000001P0oooo00<000000?ooo`3oool05`3oool3000003/0oooo1000000j0?ooo`00<@3oool4
000003X0oooo0P00000I0?ooo`030000003oool0oooo01P0oooo0P00000j0?ooo`@00000>`3oool0
0380oooo1000000i0?ooo`8000006@3oool00`000000oooo0?ooo`0H0?ooo`800000>03oool40000
03d0oooo000d0?ooo`<00000>03oool2000001T0oooo0P00000I0?ooo`800000=`3oool4000003h0
oooo000e0?ooo`<00000=P3oool300000140oooo0`0000050?ooo`030000003oool0oooo01P0oooo
0`00000e0?ooo`<00000@03oool003H0oooo0`00000e0?ooo`8000004@3oool010000000oooo0?oo
o`0000050?ooo`030000003oool0oooo01T0oooo0P00000d0?ooo`<00000@@3oool003L0oooo0`00
000d0?ooo`8000004@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool06@3o
ool2000003<0oooo0`0000120?ooo`00>03oool300000380oooo0`00000E0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool06@3oool200000380oooo0`0000130?ooo`00>@3oool30000
0340oooo0P00000E0?ooo`800000103oool3000001T0oooo0`00000`0?ooo`<00000A03oool003X0
oooo0`00000`0?ooo`8000004P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo
01X0oooo0P00000_0?ooo`<00000A@3oool003/0oooo0`00000^0?ooo`<000004P3oool4000000D0
oooo00<000000?ooo`3oool06P3oool2000002h0oooo0`0000160?ooo`00?03oool3000002d0oooo
0P00000C0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool06P3oool3000002`0oooo
0`0000170?ooo`00?@3oool3000002`0oooo0P00000C0?ooo`030000003oool0oooo00H0oooo0P00
000L0?ooo`800000:`3oool3000004P0oooo000n0?ooo`<00000:P3oool3000001<0oooo0`000006
0?ooo`030000003oool0oooo01/0oooo0P00000Z0?ooo`<00000B@3oool003l0oooo0P00000Z0?oo
o`8000007@3oool00`000000oooo0?ooo`0K0?ooo`800000:P3oool2000004X0oooo00100?ooo`80
0000:@3oool2000001d0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0W0?ooo`80
0000B`3oool00400oooo0`00000W0?ooo`<000007@3oool2000001d0oooo0P00000W0?ooo`<00000
B`3oool00440oooo0`00000V0?ooo`8000007P3oool00`000000oooo0?ooo`0M0?ooo`030000003o
ool0oooo02@0oooo0`00001<0?ooo`00@P3oool3000002D0oooo0P00000N0?ooo`030000003oool0
oooo01d0oooo0P00000T0?ooo`<00000C@3oool004<0oooo0`00000T0?ooo`030000003oool0oooo
01d0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0Q0?ooo`<00000CP3oool004@0
oooo0P00000S0?ooo`8000007`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo0240
oooo0P00001?0?ooo`00A@3oool200000280oooo00<000000?ooo`3oool07P3oool2000001l0oooo
0P00000Q0?ooo`800000D03oool004D0oooo0`00000P0?ooo`800000803oool00`000000oooo0?oo
o`0O0?ooo`030000003oool0oooo01h0oooo0P00001A0?ooo`00AP3oool3000001l0oooo00<00000
0?ooo`3oool07`3oool00`000000oooo0?ooo`0O0?ooo`8000007P3oool200000580oooo00170?oo
o`<000007@3oool200000240oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0L0?oo
o`030000003oool0oooo0540oooo00180?ooo`8000007@3oool00`000000oooo0?ooo`0H0?ooo`<0
00001@3oool200000240oooo0P00000L0?ooo`800000D`3oool004T0oooo0P00000L0?ooo`030000
003oool0oooo01L0oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool06@3oool2000005@0oooo00190?ooo`<000006P3oool2000001T0oooo00<0
00000?ooo`3oool00P0000040?ooo`030000003oool0oooo0240oooo0P00000I0?ooo`800000E@3o
ool004X0oooo0`00000I0?ooo`030000003oool0oooo01P0oooo00D000000?ooo`3oool0oooo0000
00040?ooo`030000003oool0oooo0240oooo0`00000H0?ooo`030000003oool0oooo05@0oooo001;
0?ooo`<000005`3oool2000001X0oooo00<000000?ooo`3oool00P0000040?ooo`<000008@3oool3
000001L0oooo0P00001F0?ooo`00C03oool3000001H0oooo00<000000?ooo`3oool06@3oool20000
00030?ooo`000000oooo00@0oooo00<000000?ooo`3oool08P3oool2000001H0oooo0P00001G0?oo
o`00C@3oool3000001@0oooo0P00000K0?ooo`030000003oool0000000H0oooo00<000000?ooo`3o
ool08`3oool00`000000oooo0?ooo`0C0?ooo`800000F03oool004h0oooo0P00000D0?ooo`030000
003oool0oooo01X0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`0S0?ooo`80
00004`3oool3000005P0oooo001?0?ooo`8000004P3oool2000001d0oooo00<000000?ooo`000000
1@3oool2000002D0oooo00<000000?ooo`3oool0403oool3000005T0oooo001@0?ooo`800000403o
ool2000001h0oooo0`0000050?ooo`030000003oool0oooo02D0oooo0P00000?0?ooo`<00000FP3o
ool00540oooo0P00000>0?ooo`<000009P3oool00`000000oooo0?ooo`0V0?ooo`8000003@3oool3
000005/0oooo001A0?ooo`@000002`3oool3000002L0oooo00<000000?ooo`3oool09P3oool30000
00/0oooo0`00001L0?ooo`00DP3oool4000000T0oooo0`00000X0?ooo`030000003oool0oooo02L0
oooo0`0000080?ooo`@00000G@3oool005@0oooo0`0000060?ooo`@00000:@3oool2000002T0oooo
0`0000060?ooo`@00000GP3oool005D0oooo100000020?ooo`D00000:P3oool00`000000oooo0?oo
o`0Y0?ooo`@000000P3oool400000600oooo001F0?ooo`P00000;03oool00`000000oooo0?ooo`0Z
0?ooo`P00000H@3oool005L0oooo1P00000]0?ooo`030000003oool0oooo02/0oooo1@00001S0?oo
o`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003o
ool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0
oooo00<000000?ooo`3oool0T`3oool008<0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`2C0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo0023
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008<0oooo00<000000?oo
o`3oool0103oool3000009<0oooo00240?ooo`030000003oool0oooo09T0oooo00240?ooo`030000
003oool0oooo09T0oooo00210?ooo`050000003oool0oooo0?ooo`000000VP3oool00840oooo00<0
00000?ooo`0000000P00002J0?ooo`00P@3oool200000080oooo00<000000?ooo`3oool0V03oool0
0?l0oooo8@3oool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9865, -0.87528, \
0.0863677, 0.046582}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(Here\ is\ the\ Exact\ Bias\ Squared\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(Bias\ Exact\ Here\ is\ Squared\ the ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ sig\  = \ 2, \ 
      k\  = \ 3/
          4\ *) \)\(\[IndentingNewLine]\)\(Plot[\[IndentingNewLine]\((th\ \  \
- \ NIntegrate[\ \ 1/2 \((\ 
                  d\  - \ Sqrt[d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ phi[
                  d, \ th, \ 
                  2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                    2\ 3/4\  - 1]}]\  - \[IndentingNewLine]\ 
            NIntegrate[\ 
              1/2 \((\ d\  + \ 
                    Sqrt[d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ \ phi[d, \ 
                  th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                Infinity}])\)^2, \[IndentingNewLine]{th, \(-10\), 10}, \ 
      PlotRange\  \[Rule] \ {0, \ 1}, \ 
      AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
      PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \ 
      DefaultFont\  \[Rule] \ {"\<Times\>", 12}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.618034 [
[.02381 -0.0125 -12.1875 -15.5 ]
[.02381 -0.0125 12.1875 0 ]
[.2619 -0.0125 -9.1875 -15.5 ]
[.2619 -0.0125 9.1875 0 ]
[.7381 -0.0125 -5 -15.5 ]
[.7381 -0.0125 5 0 ]
[.97619 -0.0125 -8 -15.5 ]
[.97619 -0.0125 8 0 ]
[1.025 0 0 -7.75 ]
[1.025 0 9.4375 7.75 ]
[.4875 .12361 -19 -7.75 ]
[.4875 .12361 0 7.75 ]
[.4875 .24721 -19 -7.75 ]
[.4875 .24721 0 7.75 ]
[.4875 .37082 -19 -7.75 ]
[.4875 .37082 0 7.75 ]
[.4875 .49443 -19 -7.75 ]
[.4875 .49443 0 7.75 ]
[.4875 .61803 -10 -7.75 ]
[.4875 .61803 0 7.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -73.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -66 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .12361 m
.50625 .12361 L
s
gsave
.4875 .12361 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
1.000 setlinewidth
grestore
.5 .24721 m
.50625 .24721 L
s
gsave
.4875 .24721 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.4) show
1.000 setlinewidth
grestore
.5 .37082 m
.50625 .37082 L
s
gsave
.4875 .37082 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.6) show
1.000 setlinewidth
grestore
.5 .49443 m
.50625 .49443 L
s
gsave
.4875 .49443 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.8) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .0309 m
.50375 .0309 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .15451 m
.50375 .15451 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .30902 m
.50375 .30902 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .46353 m
.50375 .46353 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .58713 m
.50375 .58713 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .02867 m
.04262 .03164 L
.06244 .03541 L
.08255 .04014 L
.10458 .04681 L
.12415 .05461 L
.14509 .06577 L
.16639 .0814 L
.18653 .10176 L
.20651 .12918 L
.22495 .16257 L
.24367 .20572 L
.2643 .26444 L
.30459 .40171 L
.32312 .46171 L
.33292 .48803 L
.34336 .50965 L
.34632 .5143 L
.34911 .51802 L
.35182 .52099 L
.35432 .52312 L
.35669 .52461 L
.35789 .52515 L
.35921 .52557 L
.36053 .52583 L
.36127 .52589 L
.36194 .52591 L
.36325 .52579 L
.36449 .52552 L
.36564 .52511 L
.36692 .52451 L
.36824 .52369 L
.36949 .52274 L
.37172 .52063 L
.37412 .51773 L
.37958 .50875 L
.38458 .49756 L
.39439 .46764 L
.40351 .43085 L
.42421 .32205 L
.44294 .2088 L
.46325 .09603 L
.46865 .07131 L
.47436 .04855 L
.47965 .03099 L
.4846 .01792 L
.48922 .00883 L
.49182 .0051 L
.49419 .00257 L
.49554 .00152 L
Mistroke
.49678 .00079 L
.4975 .00048 L
.49815 .00026 L
.4989 9e-005 L
.49961 1e-005 L
.5009 6e-005 L
.50208 .00033 L
.50338 .00087 L
.50403 .00124 L
.50475 .00172 L
.50727 .00403 L
.50869 .00576 L
.51001 .00762 L
.51498 .01697 L
.5195 .02851 L
.5243 .04375 L
.53425 .08424 L
.54523 .14007 L
.56624 .26469 L
.58548 .37656 L
.59527 .42531 L
.60437 .46309 L
.61385 .49349 L
.61887 .50558 L
.62147 .51073 L
.62422 .51535 L
.62677 .51888 L
.62957 .52191 L
.6308 .52297 L
.63211 .52392 L
.63335 .52465 L
.63449 .52517 L
.63518 .52542 L
.63592 .52562 L
.63666 .52578 L
.63747 .52588 L
.63818 .52591 L
.63893 .52588 L
.63965 .52581 L
.6403 .52569 L
.64154 .52535 L
.64224 .52509 L
.64289 .52481 L
.64419 .52412 L
.64561 .52318 L
.64823 .52093 L
.65071 .51824 L
.65535 .51176 L
.66577 .49115 L
.67522 .4665 L
Mistroke
.68562 .43462 L
.70666 .36236 L
.72771 .29002 L
.74697 .23096 L
.76709 .17974 L
.78576 .14215 L
.80476 .11272 L
.82549 .08885 L
.84602 .07167 L
.86464 .06016 L
.8839 .05115 L
.90472 .04377 L
.92468 .03831 L
.94574 .03376 L
.97619 .02867 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005P3oool3000000<0oooo0`00
000c0?ooo`<00000K03oool3000003D0oooo0`0000030?ooo`<000007P3oool001L0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo01/0oooo000=0?ooo`L000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0:03oool7000000D0oooo00<000000?ooo`3o
ool0K03oool00`000000oooo0?ooo`0b0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01/0oooo000G0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo06`0oooo00<00000
0?ooo`3oool0<`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06`3o
ool001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0340oooo0P00
001]0?ooo`800000=P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
6`3oool001H0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000<`3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo03@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00007@3oool001L0oooo00<000000?ooo`3oool00P3oool3000003D0oooo0`00001/0?ooo`<00000
=03oool00`000000oooo0?ooo`020?ooo`<000007P3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo3P3oool200000140oooo003o0?ooo`d0oooo00@000000?ooo`3oool00000403oool00?l0
oooo3@3oool010000000oooo0?ooo`00000@0?ooo`004@3ooood000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`005P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`L00000203oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`0;0?ooo`D000003`3oool001H0oooo00<000000?ooo`3oool0=`3oool00`000000oooo
0?ooo`0d0?ooo`@0000000<0oooo000000000000=P3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo00`0oooo00@000000?ooo`3oool000003`3oool008L0oooo0P000000103oool00000
0?ooo`3oool2000007h0oooo00@000000?ooo`3oool000003`3oool008L0oooo00@000000?ooo`3o
ool000000`3oool00`000000oooo0?ooo`1m0?ooo`<000003`3oool008H0oooo0P0000020?ooo`04
0000003oool0oooo0?ooo`800000T03oool001D0oooo00<000000?ooo`3oool0KP3oool01@000000
oooo0?ooo`3oool0000000<0oooo0P00002@0?ooo`005@3oool6000006X0oooo0P0000030?ooo`04
0000003oool0oooo0?ooo`<00000IP3oool800000240oooo000F0?ooo`X00000I@3oool00`000000
oooo0?ooo`020?ooo`8000000`3oool200000640oooo3@00000Q0?ooo`006`3oool:000005l0oooo
0P0000040?ooo`030000003oool0oooo0080oooo0P00001N0?ooo`P00000:@3oool00200oooo2000
001L0?ooo`800000103oool00`000000oooo0?ooo`020?ooo`800000G03oool6000002d0oooo000U
0?ooo`H00000F@3oool2000000@0oooo00<000000?ooo`3oool00P3oool3000005P0oooo1P00000`
0?ooo`009`3oool8000005@0oooo0`0000040?ooo`030000003oool0oooo00<0oooo0P00001F0?oo
o`H00000<P3oool002X0oooo2000001A0?ooo`8000001@3oool00`000000oooo0?ooo`030?ooo`80
0000D`3oool6000003D0oooo000_0?ooo`@00000D03oool2000000D0oooo00<000000?ooo`3oool0
0`3oool300000500oooo1P00000g0?ooo`00<@3oool4000004h0oooo0P0000050?ooo`8000001@3o
ool2000004l0oooo1000000j0?ooo`00<P3oool4000004d0oooo0P0000050?ooo`030000003oool0
oooo00@0oooo0P00001=0?ooo`@00000?03oool003@0oooo0`00001;0?ooo`8000001P3oool00`00
0000oooo0?ooo`040?ooo`800000C03oool4000003d0oooo000e0?ooo`@00000B@3oool2000000H0
oooo00<000000?ooo`3oool0103oool3000004X0oooo0`00000o0?ooo`00=P3oool4000004P0oooo
0P0000060?ooo`030000003oool0oooo00D0oooo0P0000180?ooo`@00000@03oool003P0oooo0`00
00160?ooo`<000001P3oool00`000000oooo0?ooo`050?ooo`800000A`3oool400000440oooo000i
0?ooo`<00000A@3oool2000000L0oooo00<000000?ooo`3oool01@3oool2000004H0oooo0`000013
0?ooo`00>P3oool3000004@0oooo0P0000070?ooo`030000003oool0oooo00H0oooo0P0000140?oo
o`<00000A03oool003/0oooo0`0000130?ooo`8000001`3oool2000000L0oooo0P0000130?ooo`<0
0000A@3oool003`0oooo0`0000110?ooo`<000001`3oool00`000000oooo0?ooo`060?ooo`800000
@P3oool3000004H0oooo000m0?ooo`800000@@3oool2000000P0oooo00<000000?ooo`3oool01P3o
ool200000480oooo0P0000170?ooo`00?P3oool200000400oooo0P0000080?ooo`030000003oool0
oooo00H0oooo0P0000110?ooo`800000B03oool003l0oooo0P00000f0?ooo`<000000`3oool00`00
0000oooo00000004000000H0oooo00<000000?ooo`3oool01P3oool200000400oooo0`0000180?oo
o`00@03oool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000001@3oool20000
00030?ooo`000000oooo00D0oooo00<000000?ooo`3oool01`3oool2000003l0oooo0P0000190?oo
o`00@03oool2000003@0oooo00D000000?ooo`3oool0oooo000000050?ooo`800000203oool00`00
0000oooo0?ooo`070?ooo`800000?P3oool2000004X0oooo00110?ooo`800000<`3oool01@000000
oooo0?ooo`3oool0000000D0oooo0`0000070?ooo`<000001`3oool2000003d0oooo0P00001;0?oo
o`00@P3oool200000380oooo00D000000?ooo`3oool0oooo000000040?ooo`8000000P3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00L0oooo0P00000l0?ooo`800000C03oool004<0
oooo00<000000?ooo`3oool0<03oool01@000000oooo0?ooo`3oool0000000@0oooo0P0000020?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool01`3oool2000003`0oooo00<000000?oo
o`3oool0B`3oool004<0oooo0P00000a0?ooo`050000003oool0oooo0?ooo`000000103oool20000
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`070?ooo`800000>`3oool20000
04d0oooo00140?ooo`030000003oool0oooo02l0oooo00D000000?ooo`3oool0oooo000000040?oo
o`8000000P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00L0oooo0P00000j0?oo
o`800000CP3oool004@0oooo0P00000a0?ooo`<000001@3oool4000000L0oooo00<000000?ooo`3o
ool0203oool2000003T0oooo00<000000?ooo`3oool0C@3oool004D0oooo00<000000?ooo`3oool0
=`3oool2000000T0oooo00<000000?ooo`3oool0203oool2000003P0oooo0P00001?0?ooo`00A@3o
ool2000003P0oooo0P0000090?ooo`030000003oool0oooo00P0oooo0P00000h0?ooo`030000003o
ool0oooo04h0oooo00160?ooo`030000003oool0oooo03D0oooo0P00000:0?ooo`8000002@3oool2
000003L0oooo0P00001@0?ooo`00AP3oool2000003H0oooo0P00000:0?ooo`030000003oool0oooo
00P0oooo0P00000g0?ooo`030000003oool0oooo04l0oooo00170?ooo`030000003oool0oooo03@0
oooo0P00000:0?ooo`030000003oool0oooo00T0oooo0P00000f0?ooo`030000003oool0oooo04l0
oooo00170?ooo`800000=@3oool2000000X0oooo00<000000?ooo`3oool02@3oool2000003D0oooo
0P00001A0?ooo`00B03oool00`000000oooo0?ooo`0c0?ooo`8000002P3oool00`000000oooo0?oo
o`090?ooo`800000=@3oool00`000000oooo0?ooo`1@0?ooo`00B03oool2000003@0oooo0P00000:
0?ooo`030000003oool0oooo00T0oooo0P00000d0?ooo`800000DP3oool004T0oooo00<000000?oo
o`3oool0<P3oool2000000X0oooo00<000000?ooo`3oool02@3oool2000003<0oooo0P00001C0?oo
o`00B@3oool200000380oooo0P00000;0?ooo`8000002`3oool200000380oooo0P00001C0?ooo`00
BP3oool00`000000oooo0?ooo`0`0?ooo`8000002`3oool00`000000oooo0?ooo`0:0?ooo`800000
<@3oool3000005<0oooo001:0?ooo`800000<@3oool2000000/0oooo00<000000?ooo`3oool02P3o
ool200000340oooo0P00001D0?ooo`00B`3oool00`000000oooo0?ooo`0_0?ooo`8000002`3oool0
0`000000oooo0?ooo`0:0?ooo`800000<@3oool2000005@0oooo001;0?ooo`800000<03oool20000
00/0oooo00<000000?ooo`3oool02P3oool200000300oooo0`00001D0?ooo`00C03oool00`000000
oooo0?ooo`0^0?ooo`8000002`3oool00`000000oooo0?ooo`0;0?ooo`800000;`3oool2000005D0
oooo001<0?ooo`800000;P3oool2000000`0oooo00<000000?ooo`3oool02`3oool2000002h0oooo
0`00001E0?ooo`00C03oool2000002h0oooo0P00000<0?ooo`030000003oool0oooo00/0oooo0P00
000^0?ooo`800000EP3oool004`0oooo0`00000]0?ooo`800000303oool2000000`0oooo0P00000^
0?ooo`800000EP3oool004d0oooo0P00000]0?ooo`800000303oool00`000000oooo0?ooo`0;0?oo
o`800000;@3oool3000005H0oooo001=0?ooo`800000;@3oool2000000`0oooo00<000000?ooo`3o
ool0303oool2000002`0oooo0P00001G0?ooo`00C@3oool3000002`0oooo0P00000<0?ooo`030000
003oool0oooo00`0oooo0P00000[0?ooo`<00000E`3oool004h0oooo0P00000W0?ooo`<0000000@0
oooo00000000000000001@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00`0oooo
0P00000[0?ooo`800000F03oool004h0oooo0P00000V0?ooo`040000003oool0oooo0?ooo`<00000
1P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00`0oooo0P00000[0?ooo`800000
F03oool004h0oooo0`00000U0?ooo`040000003oool0oooo0?ooo`<000000P3oool6000000D0oooo
00<000000?ooo`3oool0303oool2000002X0oooo0`00001H0?ooo`00C`3oool2000002D0oooo00@0
00000?ooo`3oool0oooo0`0000020?ooo`050000003oool0oooo0?ooo`0000001P3oool3000000d0
oooo0P00000Y0?ooo`800000F@3oool004l0oooo0P00000U0?ooo`040000003oool0oooo0?ooo`<0
00000`3oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo00d0oooo0P00000Y0?oo
o`800000F@3oool004l0oooo0`00000T0?ooo`040000003oool0oooo0?ooo`<00000103oool00`00
0000oooo000000060?ooo`030000003oool0oooo00d0oooo0P00000X0?ooo`<00000F@3oool00500
oooo0P00000T0?ooo`040000003oool0oooo0?ooo`8000001@3oool00`000000oooo000000060?oo
o`030000003oool0oooo00d0oooo0P00000X0?ooo`800000FP3oool00500oooo0P00000T0?ooo`04
0000003oool0oooo0?ooo`8000001P3oool2000000H0oooo00<000000?ooo`3oool03@3oool20000
02P0oooo0P00001J0?ooo`00D03oool3000002@0oooo1@0000070?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool03@3oool2000002L0oooo0`00001J0?ooo`00D@3oool2000002L0oooo
0P00000>0?ooo`030000003oool0oooo00h0oooo0P00000V0?ooo`800000F`3oool00540oooo0P00
000W0?ooo`8000003P3oool00`000000oooo0?ooo`0>0?ooo`8000009P3oool2000005/0oooo001A
0?ooo`<000009@3oool2000000l0oooo0P00000?0?ooo`8000009@3oool3000005/0oooo001B0?oo
o`8000009@3oool2000000l0oooo00<000000?ooo`3oool03P3oool2000002D0oooo0P00001L0?oo
o`00DP3oool2000002D0oooo0P00000?0?ooo`030000003oool0oooo00h0oooo0P00000U0?ooo`80
0000G03oool00580oooo0P00000U0?ooo`8000003`3oool00`000000oooo0?ooo`0>0?ooo`800000
903oool3000005`0oooo001B0?ooo`<00000903oool2000000l0oooo00<000000?ooo`3oool03`3o
ool2000002<0oooo0P00001M0?ooo`00D`3oool2000002@0oooo0P00000?0?ooo`030000003oool0
oooo00l0oooo0P00000S0?ooo`800000G@3oool005<0oooo0P00000S0?ooo`800000403oool00`00
0000oooo0?ooo`0?0?ooo`8000008P3oool3000005d0oooo001C0?ooo`<000008P3oool200000100
oooo0P00000@0?ooo`8000008P3oool2000005h0oooo001D0?ooo`8000008P3oool200000100oooo
00<000000?ooo`3oool03`3oool200000280oooo0P00001N0?ooo`00E03oool200000280oooo0P00
000@0?ooo`030000003oool0oooo00l0oooo0P00000R0?ooo`800000GP3oool005@0oooo0`00000Q
0?ooo`800000403oool00`000000oooo0?ooo`0?0?ooo`8000008@3oool3000005h0oooo001E0?oo
o`800000803oool200000140oooo00<000000?ooo`3oool0403oool200000200oooo0P00001O0?oo
o`00E@3oool200000200oooo0P00000A0?ooo`030000003oool0oooo0100oooo0P00000P0?ooo`80
0000G`3oool005D0oooo0P00000P0?ooo`8000004@3oool00`000000oooo0?ooo`0@0?ooo`800000
7`3oool3000005l0oooo001E0?ooo`<000007`3oool200000140oooo00<000000?ooo`3oool0403o
ool2000001l0oooo0P00001P0?ooo`00EP3oool2000001l0oooo0P00000A0?ooo`8000004@3oool2
000001l0oooo0P00001P0?ooo`00EP3oool2000001l0oooo0P00000A0?ooo`030000003oool0oooo
0100oooo0P00000O0?ooo`800000H03oool005H0oooo0`00000M0?ooo`8000004P3oool00`000000
oooo0?ooo`0@0?ooo`8000007P3oool300000600oooo001G0?ooo`8000007@3oool200000180oooo
00<000000?ooo`3oool04@3oool2000001d0oooo0P00001Q0?ooo`00E`3oool2000001d0oooo1000
00030?ooo`030000003oool0oooo00<000001`3oool00`000000oooo0?ooo`0A0?ooo`8000007@3o
ool200000640oooo001G0?ooo`<00000703oool200000080oooo00<000000?ooo`3oool00P3oool0
1@000000oooo0?ooo`3oool0000000H0oooo00<000000?ooo`3oool04@3oool2000001`0oooo0`00
001Q0?ooo`00F03oool2000001`0oooo0P0000020?ooo`030000003oool0oooo0080oooo00D00000
0?ooo`3oool0oooo000000060?ooo`030000003oool0oooo0140oooo0P00000L0?ooo`800000HP3o
ool005P0oooo0P00000K0?ooo`8000000`3oool00`000000oooo0?ooo`020?ooo`050000003oool0
oooo0?ooo`0000001P3oool300000140oooo0P00000L0?ooo`800000HP3oool005P0oooo0`00000J
0?ooo`8000000`3oool00`000000oooo0?ooo`020?ooo`8000000P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo0140oooo0P00000L0?ooo`800000HP3oool005T0oooo0P00000J0?oo
o`8000000`3oool00`000000oooo0?ooo`020?ooo`040000003oool00000000000L0oooo00<00000
0?ooo`3oool04@3oool3000001X0oooo0`00001R0?ooo`00F@3oool2000001X0oooo0P0000030?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0B0?oo
o`8000006P3oool2000006<0oooo001I0?ooo`8000006P3oool2000000<0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0180oooo0P00000J0?ooo`80
0000H`3oool005T0oooo0`00000H0?ooo`80000000@0oooo0000000000000000203oool2000000H0
oooo00<000000?ooo`3oool04P3oool2000001T0oooo0`00001S0?ooo`00FP3oool2000001P0oooo
0P00000D0?ooo`030000003oool0oooo0180oooo0`00000H0?ooo`800000I03oool005X0oooo0P00
000H0?ooo`800000503oool00`000000oooo0?ooo`0C0?ooo`800000603oool2000006@0oooo001J
0?ooo`<000005`3oool2000001@0oooo0P00000D0?ooo`800000603oool2000006@0oooo001K0?oo
o`8000005`3oool2000001@0oooo00<000000?ooo`3oool04`3oool2000001L0oooo0`00001T0?oo
o`00F`3oool2000001H0oooo0P00000E0?ooo`030000003oool0oooo01<0oooo0`00000F0?ooo`80
0000I@3oool005/0oooo0P00000F0?ooo`8000005@3oool00`000000oooo0?ooo`0D0?ooo`800000
5P3oool2000006D0oooo001K0?ooo`<000005@3oool2000001D0oooo00<000000?ooo`3oool0503o
ool2000001D0oooo0`00001U0?ooo`00G03oool2000001D0oooo0P00000E0?ooo`030000003oool0
oooo01@0oooo0P00000E0?ooo`800000IP3oool005`0oooo0P00000E0?ooo`8000005@3oool00`00
0000oooo0?ooo`0D0?ooo`<00000503oool2000006H0oooo001L0?ooo`800000503oool2000001H0
oooo00<000000?ooo`3oool05@3oool2000001@0oooo0P00001V0?ooo`00G03oool3000001<0oooo
0P00000F0?ooo`8000005P3oool2000001<0oooo0`00001V0?ooo`00G@3oool2000001<0oooo0P00
000F0?ooo`030000003oool0oooo01D0oooo0P00000C0?ooo`800000I`3oool005d0oooo0P00000C
0?ooo`8000005P3oool00`000000oooo0?ooo`0E0?ooo`8000004`3oool2000006L0oooo001M0?oo
o`<000004@3oool3000001H0oooo00<000000?ooo`3oool05@3oool300000140oooo0`00001W0?oo
o`00GP3oool200000140oooo0P00000G0?ooo`030000003oool0oooo01H0oooo0P00000A0?ooo`80
0000J03oool005h0oooo0P00000A0?ooo`8000005`3oool00`000000oooo0?ooo`0F0?ooo`800000
403oool3000006P0oooo001N0?ooo`8000004@3oool2000001L0oooo00<000000?ooo`3oool05P3o
ool200000100oooo0P00001Y0?ooo`00G`3oool00`000000oooo0?ooo`0?0?ooo`8000005`3oool2
000001L0oooo0`00000?0?ooo`800000J@3oool005l0oooo0P00000?0?ooo`<000005`3oool00`00
0000oooo0?ooo`0G0?ooo`8000003P3oool3000006T0oooo001P0?ooo`030000003oool0oooo00d0
oooo0P00000H0?ooo`030000003oool0oooo01L0oooo0P00000>0?ooo`800000JP3oool00600oooo
0P00000=0?ooo`<00000603oool00`000000oooo0?ooo`0G0?ooo`8000003P3oool2000006X0oooo
001Q0?ooo`030000003oool0oooo00/0oooo0P00000I0?ooo`030000003oool0oooo01L0oooo0`00
000<0?ooo`<00000JP3oool00640oooo0P00000<0?ooo`8000001P3oool3000000<0oooo00<00000
0?ooo`3oool00`0000070?ooo`030000003oool0oooo01P0oooo0P00000<0?ooo`800000J`3oool0
0680oooo00<000000?ooo`3oool02@3oool3000000D0oooo00D000000?ooo`3oool0oooo00000004
0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`0H0?ooo`800000303o
ool2000006/0oooo001R0?ooo`8000002P3oool2000000H0oooo00D000000?ooo`3oool0oooo0000
00040?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`0H0?ooo`<00000
2`3oool00`000000oooo0?ooo`1Z0?ooo`00HP3oool2000000T0oooo0`0000060?ooo`050000003o
ool0oooo0?ooo`0000001@3oool00`000000oooo000000070?ooo`<000006@3oool2000000X0oooo
0P00001/0?ooo`00HP3oool3000000P0oooo0P0000070?ooo`050000003oool0oooo0?ooo`000000
1P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo01T0oooo0P0000090?ooo`800000
K@3oool006<0oooo0P0000080?ooo`8000001`3oool01@000000oooo0?ooo`3oool0000000D0oooo
00<000000?ooo`0000001`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool0K03oool006<0oooo0`0000070?ooo`030000003oool0oooo00H0oooo00D0
00000?ooo`3oool0oooo000000040?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000
oooo0?ooo`0J0?ooo`8000001`3oool2000006h0oooo001T0?ooo`<000001@3oool2000000P0oooo
00D000000?ooo`3oool0oooo000000040?ooo`050000003oool0oooo0?ooo`0000001P3oool00`00
0000oooo0?ooo`0K0?ooo`8000001@3oool2000006l0oooo001U0?ooo`800000103oool2000000X0
oooo0`0000060?ooo`<000001`3oool00`000000oooo0?ooo`0K0?ooo`800000103oool3000006l0
oooo001U0?ooo`<000000P3oool3000001d0oooo00<000000?ooo`3oool06`3oool3000000<0oooo
0P00001`0?ooo`00IP3oool6000001h0oooo0P00000L0?ooo`P00000L03oool006L0oooo1@00000N
0?ooo`030000003oool0oooo01`0oooo1P00001a0?ooo`00RP3oool00`000000oooo0?ooo`2C0?oo
o`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000
003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo
00<000000?ooo`3oool0T`3oool00800oooo0`0000070?ooo`030000003oool0oooo09<0oooo0021
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`<0
0000T`3oool00840oooo00<000000?ooo`3oool0W03oool00840oooo00<000000?ooo`3oool0W03o
ool00840oooo00<000000?ooo`3oool0W03oool00800oooo0P00002N0?ooo`00P@3oool00`000000
oooo0?ooo`2L0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9695, -0.123125, \
0.086157, 0.00663834}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(\ \)\(Here\ is\ the\ Exact\ Variance\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(Exact\ Here\ is\ the\ Variance ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ sig\  = \ 2, \ 
      k\  = \ 3/4\ *) \)\(\[IndentingNewLine]\)\(Plot[\[IndentingNewLine]\ 
      NIntegrate[\ \ \((1/2 \((\ 
                    d\  - \ Sqrt[
                        d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ \ phi[
              d, \ th, \ 
              2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
        NIntegrate[\ \((\ 
                1/2 \((\ 
                    d\  + \ Sqrt[
                        d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ \ phi[
              d, \ th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
            Infinity}] - \ \((NIntegrate[\ \ 1/2 \((\ 
                    d\  - \ Sqrt[
                        d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ phi[d, \ 
                    th, \ 2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
              NIntegrate[\ 
                1/2 \((\ 
                    d\  + \ Sqrt[
                        d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ \ phi[d, \ 
                    th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                  Infinity}])\)^2, \[IndentingNewLine]{th, \(-10\), 10}, \ 
      PlotRange\  \[Rule] \ {0, \ 7}, \ 
      AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
      PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \[IndentingNewLine]\ 
      DefaultFont\  \[Rule] \ {"\<Times\>", 12}]\)\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 -2.08167e-017 0.0882906 [
[.02381 -0.0125 -12.1875 -15.5 ]
[.02381 -0.0125 12.1875 0 ]
[.2619 -0.0125 -9.1875 -15.5 ]
[.2619 -0.0125 9.1875 0 ]
[.7381 -0.0125 -5 -15.5 ]
[.7381 -0.0125 5 0 ]
[.97619 -0.0125 -8 -15.5 ]
[.97619 -0.0125 8 0 ]
[1.025 0 0 -7.75 ]
[1.025 0 9.4375 7.75 ]
[.4875 .08829 -10 -7.75 ]
[.4875 .08829 0 7.75 ]
[.4875 .17658 -10 -7.75 ]
[.4875 .17658 0 7.75 ]
[.4875 .26487 -10 -7.75 ]
[.4875 .26487 0 7.75 ]
[.4875 .35316 -10 -7.75 ]
[.4875 .35316 0 7.75 ]
[.4875 .44145 -10 -7.75 ]
[.4875 .44145 0 7.75 ]
[.4875 .52974 -10 -7.75 ]
[.4875 .52974 0 7.75 ]
[.4875 .61803 -10 -7.75 ]
[.4875 .61803 0 7.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -73.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -66 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .08829 m
.50625 .08829 L
s
gsave
.4875 .08829 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .17658 m
.50625 .17658 L
s
gsave
.4875 .17658 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .26487 m
.50625 .26487 L
s
gsave
.4875 .26487 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 .35316 m
.50625 .35316 L
s
gsave
.4875 .35316 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .44145 m
.50625 .44145 L
s
gsave
.4875 .44145 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 .52974 m
.50625 .52974 L
s
gsave
.4875 .52974 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01766 m
.50375 .01766 L
s
.5 .03532 m
.50375 .03532 L
s
.5 .05297 m
.50375 .05297 L
s
.5 .07063 m
.50375 .07063 L
s
.5 .10595 m
.50375 .10595 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .14126 m
.50375 .14126 L
s
.5 .15892 m
.50375 .15892 L
s
.5 .19424 m
.50375 .19424 L
s
.5 .2119 m
.50375 .2119 L
s
.5 .22956 m
.50375 .22956 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .28253 m
.50375 .28253 L
s
.5 .30019 m
.50375 .30019 L
s
.5 .31785 m
.50375 .31785 L
s
.5 .3355 m
.50375 .3355 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .38848 m
.50375 .38848 L
s
.5 .40614 m
.50375 .40614 L
s
.5 .42379 m
.50375 .42379 L
s
.5 .45911 m
.50375 .45911 L
s
.5 .47677 m
.50375 .47677 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .51209 m
.50375 .51209 L
s
.5 .5474 m
.50375 .5474 L
s
.5 .56506 m
.50375 .56506 L
s
.5 .58272 m
.50375 .58272 L
s
.5 .60038 m
.50375 .60038 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .37182 m
.04262 .37434 L
.06244 .37778 L
.08255 .38244 L
.10458 .3894 L
.12415 .39777 L
.14509 .40956 L
.18653 .44266 L
.22646 .48316 L
.24474 .50063 L
.25514 .50899 L
.26022 .51246 L
.26488 .51521 L
.26945 .51747 L
.27443 .51938 L
.27717 .52016 L
.2785 .52047 L
.2797 .52071 L
.28087 .5209 L
.28213 .52107 L
.28282 .52114 L
.28346 .5212 L
.28471 .52127 L
.28593 .52129 L
.28724 .52127 L
.28847 .5212 L
.28959 .5211 L
.29091 .52092 L
.29234 .52067 L
.29494 .52005 L
.29766 .51915 L
.30055 .51793 L
.30574 .51501 L
.31063 .51138 L
.31511 .50729 L
.32522 .49539 L
.33412 .48183 L
.3435 .46457 L
.3816 .36959 L
.42216 .25374 L
.4409 .20765 L
.46121 .16906 L
.4666 .16121 L
.47232 .15411 L
.47761 .14867 L
.48256 .14459 L
.48718 .14169 L
.48978 .14044 L
.49215 .13955 L
.49341 .13917 L
Mistroke
.49474 .13884 L
.49551 .13868 L
.49621 .13856 L
.49692 .13846 L
.49757 .13838 L
.49884 .13829 L
.49951 .13827 L
.50022 .13826 L
.5014 .1383 L
.50271 .13841 L
.50402 .1386 L
.50523 .13883 L
.50656 .13916 L
.50796 .13959 L
.51033 .14049 L
.51294 .14175 L
.51775 .14482 L
.52226 .14854 L
.53233 .1598 L
.54318 .17623 L
.56326 .21714 L
.58438 .27156 L
.62254 .38128 L
.64383 .43682 L
.66315 .47711 L
.67281 .49263 L
.6779 .49946 L
.68327 .50565 L
.68798 .51019 L
.69315 .51426 L
.69785 .51714 L
.70225 .51912 L
.70484 .51999 L
.70724 .52059 L
.7085 .52083 L
.70988 .52103 L
.71057 .52111 L
.71132 .52118 L
.71203 .52123 L
.71268 .52127 L
.71387 .52129 L
.71498 .52128 L
.7162 .52122 L
.7175 .52111 L
.71815 .52104 L
.71887 .52094 L
.72016 .52074 L
.72257 .52023 L
.7248 .51962 L
.72726 .5188 L
Mistroke
.73222 .5167 L
.74112 .51159 L
.76055 .49586 L
.78143 .47505 L
.82268 .43421 L
.84328 .41753 L
.8624 .40497 L
.8809 .39538 L
.90062 .38755 L
.92204 .38125 L
.94222 .37688 L
.95992 .37396 L
.97619 .37182 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{44, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005P3oool3000000<0oooo0`00
000c0?ooo`<00000K03oool3000003D0oooo0`0000030?ooo`<000007P3oool001L0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo01/0oooo000=0?ooo`L000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0:03oool7000000D0oooo00<000000?ooo`3o
ool0K03oool00`000000oooo0?ooo`0b0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01/0oooo000G0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo06`0oooo00<00000
0?ooo`3oool0<`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06`3o
ool001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0340oooo0P00
001]0?ooo`800000=P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
6`3oool001H0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000<`3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo03@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00007@3oool001L0oooo00<000000?ooo`3oool00P3oool3000003D0oooo0`00001/0?ooo`<00000
=03oool00`000000oooo0?ooo`020?ooo`<000007P3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo3P3oool200000140oooo003o0?ooo`d0oooo00@000000?ooo`3oool00000403oool00?l0
oooo3@3oool010000000oooo0?ooo`00000@0?ooo`004@3ooood000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`005P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02`3oool5000000l0oooo000F0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0303oool010000000oooo0?ooo`00000?0?ooo`00RP3oool00`000000oooo
0?ooo`200?ooo`040000003oool0oooo000000l0oooo002:0?ooo`800000PP3oool3000000l0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000
U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo00200?ooo`<00000
1`3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo09<0oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool0
0840oooo00<000000?ooo`3oool01P3oool3000009<0oooo00210?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo0020
0?ooo`800000203oool2000009@0oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0
T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00Q`3oool800000940oooo
00250?ooo``00000S`3oool008D0oooo0`0000020?ooo`040000003oool0oooo0?ooo`<00000S`3o
ool008@0oooo0P0000040?ooo`030000003oool0oooo00<0oooo0P00002>0?ooo`00PP3oool30000
00D0oooo00<000000?ooo`3oool0103oool2000008d0oooo00220?ooo`<000001@3oool2000000H0
oooo00<000000?ooo`3oool0R`3oool007l0oooo1@0000060?ooo`030000003oool0oooo00D0oooo
0P00002<0?ooo`00P03oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`3oool01P3o
ool2000008/0oooo00200?ooo`800000203oool00`000000oooo0?ooo`070?ooo`800000RP3oool0
0800oooo00<000000?ooo`0000001`3oool3000000P0oooo00<000000?ooo`3oool0R03oool007l0
oooo0P0000020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0203oool2000008T0
oooo001o0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo08L0oooo001n0?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00T0oooo0P0000280?ooo`00OP3oool2000000<0oooo00<000000?ooo`3oool0103o
ool2000000/0oooo00<000000?ooo`3oool0QP3oool007d0oooo0P000000103oool0000000000000
00070?ooo`030000003oool0oooo00X0oooo0P0000270?ooo`00O@3oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0Q@3oool007`0oooo0P00000<0?oo
o`030000003oool0oooo00/0oooo0P0000260?ooo`00O03oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0oooo00`0oooo00<000000?ooo`3oool0Q03oool007/0oooo0P00000=0?ooo`800000
3@3oool2000008D0oooo001k0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool03@3o
ool00`000000oooo0?ooo`230?ooo`00NP3oool2000000h0oooo00<000000?ooo`3oool03@3oool2
000008@0oooo001j0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool03@3oool20000
08@0oooo001i0?ooo`8000003`3oool2000000h0oooo0`0000230?ooo`00N@3oool00`000000oooo
0?ooo`0>0?ooo`030000003oool0oooo00h0oooo0P0000230?ooo`00N@3oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo00h0oooo0`0000220?ooo`00N03oool200000100oooo00<00000
0?ooo`3oool03`3oool200000880oooo001h0?ooo`030000003oool0oooo00l0oooo0P00000@0?oo
o`800000PP3oool007L0oooo0P00000A0?ooo`030000003oool0oooo00l0oooo0`0000210?ooo`00
M`3oool00`000000oooo0?ooo`050?ooo`@000001`3oool00`000000oooo0?ooo`0@0?ooo`800000
P@3oool007H0oooo0P00000;0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0403o
ool300000800oooo001f0?ooo`8000002`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0140oooo0P0000200?ooo`00M@3oool3000000/0oooo00<000000?ooo`3oool0103oool30000
0140oooo0P0000200?ooo`00M@3oool2000000X0oooo0P0000070?ooo`030000003oool0oooo0140
oooo0`00001o0?ooo`00M@3oool2000000/0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`0B0?ooo`800000O`3oool007@0oooo0`00000<0?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool04P3oool2000007l0oooo001d0?ooo`8000002@3oool01@000000oooo0?ooo`3o
ool0000000H0oooo0P00000C0?ooo`<00000OP3oool007@0oooo0P00000:0?ooo`<000001`3oool0
0`000000oooo0?ooo`0C0?ooo`800000OP3oool007<0oooo0`00000D0?ooo`030000003oool0oooo
01<0oooo0P00001n0?ooo`00L`3oool2000001D0oooo00<000000?ooo`3oool04`3oool3000007d0
oooo001c0?ooo`8000005@3oool2000001D0oooo0P00001m0?ooo`00LP3oool3000001D0oooo00<0
00000?ooo`3oool0503oool2000007d0oooo001b0?ooo`8000005P3oool00`000000oooo0?ooo`0D
0?ooo`<00000O03oool00780oooo0P00000F0?ooo`030000003oool0oooo01D0oooo0P00001l0?oo
o`00LP3oool2000001H0oooo00<000000?ooo`3oool05@3oool2000007`0oooo001a0?ooo`<00000
5P3oool2000001H0oooo0`00001k0?ooo`00L@3oool2000001L0oooo00<000000?ooo`3oool05P3o
ool2000007/0oooo001a0?ooo`8000005`3oool00`000000oooo0?ooo`0F0?ooo`800000N`3oool0
0700oooo0`00000G0?ooo`030000003oool0oooo01H0oooo0`00001j0?ooo`00L03oool2000001P0
oooo0P00000H0?ooo`800000NP3oool00700oooo0P00000A0?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool05`3oool2000007X0oooo001_0?ooo`<000004@3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo01L0oooo0`00001i0?ooo`00K`3oool2000000h0oooo1P000005
0?ooo`030000003oool0oooo01P0oooo0P00001i0?ooo`00K`3oool2000000h0oooo00D000000?oo
o`3oool0oooo000000060?ooo`<00000603oool2000007T0oooo001^0?ooo`<000003`3oool01000
0000oooo0?ooo`0000060?ooo`030000003oool0oooo01P0oooo0`00001h0?ooo`00KP3oool20000
0140oooo00<000000?ooo`0000001P3oool00`000000oooo0?ooo`0I0?ooo`800000N03oool006h0
oooo0P00000A0?ooo`030000003oool0000000H0oooo00<000000?ooo`3oool06@3oool2000007P0
oooo001]0?ooo`<000004P3oool2000000H0oooo0P00000J0?ooo`<00000M`3oool001D0oooo2`00
001=0?ooo`800000503oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01X0oooo0P00
001=0?ooo`T000008@3oool001D0oooo400000170?ooo`<000006`3oool00`000000oooo0?ooo`0J
0?ooo`800000B03oool>00000240oooo000P0?ooo`P00000A03oool2000001`0oooo00<000000?oo
o`3oool06P3oool3000004@0oooo2000000Z0?ooo`009@3oool600000440oooo0P00000L0?ooo`03
0000003oool0oooo01/0oooo0P0000120?ooo`H00000;P3oool002L0oooo1P00000n0?ooo`<00000
703oool2000001`0oooo0P00000m0?ooo`P00000<@3oool002X0oooo1P00000k0?ooo`8000007@3o
ool00`000000oooo0?ooo`0K0?ooo`<00000>`3oool6000003@0oooo000/0?ooo`H00000>03oool3
000001d0oooo00<000000?ooo`3oool0703oool2000003T0oooo1000000h0?ooo`00;`3oool40000
03L0oooo0P00000N0?ooo`030000003oool0oooo01`0oooo0P00000h0?ooo`@00000>@3oool00340
oooo1000000d0?ooo`<000007P3oool2000001d0oooo0`00000e0?ooo`@00000>`3oool00380oooo
1000000c0?ooo`8000007`3oool00`000000oooo0?ooo`0M0?ooo`800000=03oool4000003`0oooo
000d0?ooo`<00000<@3oool3000001l0oooo00<000000?ooo`3oool07@3oool300000340oooo1000
000n0?ooo`00=@3oool4000002l0oooo0P00000P0?ooo`030000003oool0oooo01h0oooo0P00000`
0?ooo`@00000?`3oool003H0oooo1000000^0?ooo`800000803oool2000001l0oooo0P00000^0?oo
o`@00000@@3oool003P0oooo0`00000/0?ooo`<00000803oool00`000000oooo0?ooo`0N0?ooo`<0
0000;03oool400000480oooo000i0?ooo`<00000:`3oool2000001H0oooo0`0000080?ooo`030000
003oool0oooo01l0oooo0P00000[0?ooo`<00000A03oool003X0oooo1000000X0?ooo`<000006@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01l0oooo0P00000Z0?ooo`<00000A@3o
ool003/0oooo1000000W0?ooo`8000006`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0200oooo00<000000?ooo`3oool09`3oool3000004H0oooo000m0?ooo`<000009@3oool30000
01/0oooo00<000000?ooo`3oool0103oool300000200oooo0P00000W0?ooo`<00000A`3oool003h0
oooo0`00000T0?ooo`800000703oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool0903oool3000004P0oooo000o0?ooo`<000008`3oool2000001/0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0Q0?ooo`800000903oool3000004T0oooo
00100?ooo`<000008@3oool3000001T0oooo0P0000080?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool08@3oool3000004X0oooo00110?ooo`<00000803oool2000001X0oooo00<00000
0?ooo`3oool01`3oool2000002<0oooo0P00000Q0?ooo`<00000B`3oool00480oooo0`00000N0?oo
o`<000006`3oool3000000H0oooo00<000000?ooo`3oool08`3oool2000001l0oooo0`00001<0?oo
o`00@`3oool3000001d0oooo0P00000U0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3o
ool0703oool3000004d0oooo00140?ooo`<000006`3oool3000002D0oooo00<000000?ooo`3oool0
903oool2000001`0oooo0`00001>0?ooo`00A@3oool3000001X0oooo0P00000V0?ooo`8000009P3o
ool00`000000oooo0?ooo`0I0?ooo`<00000C`3oool004H0oooo0`00000I0?ooo`8000009P3oool0
0`000000oooo0?ooo`0U0?ooo`8000006@3oool300000500oooo00170?ooo`<00000603oool00`00
0000oooo0?ooo`0U0?ooo`030000003oool0oooo02H0oooo0P00000G0?ooo`<00000D@3oool004P0
oooo0`00000F0?ooo`8000009`3oool00`000000oooo0?ooo`0W0?ooo`8000005@3oool300000580
oooo00190?ooo`<00000503oool2000002P0oooo00<000000?ooo`3oool0:03oool00`000000oooo
0?ooo`0B0?ooo`<00000D`3oool004X0oooo0`00000B0?ooo`800000:@3oool2000002T0oooo0P00
000B0?ooo`<00000E03oool004/0oooo0`00000@0?ooo`<00000:@3oool00`000000oooo0?ooo`0Y
0?ooo`8000003`3oool4000005D0oooo001<0?ooo`@000003@3oool3000002X0oooo00<000000?oo
o`3oool0:@3oool3000000d0oooo1000001F0?ooo`00C@3oool4000000/0oooo0`00000[0?ooo`03
0000003oool0oooo02X0oooo1000000:0?ooo`<00000F03oool004l0oooo0`0000090?ooo`<00000
;03oool2000002`0oooo100000070?ooo`@00000F@3oool00500oooo100000050?ooo`@000008`3o
ool3000000L0oooo00<000000?ooo`3oool0;@3oool3000000D0oooo1000001J0?ooo`00D@3oool;
000002<0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003oool0oooo02h0oooo2@00
001L0?ooo`00D`3oool7000002D0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003o
ool0oooo02l0oooo1`00001M0?ooo`00O`3oool01@000000oooo0?ooo`3oool0000000H0oooo0`00
002C0?ooo`00O`3oool200000080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2C
0?ooo`00O`3oool010000000oooo0000000000070?ooo`030000003oool0oooo09<0oooo00200?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`2C0?ooo`00PP3oool2000000H0oooo0P00002D0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0
T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0
oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool00880oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`2C0?ooo`00PP3oool00`000000oooo0?ooo`05
0?ooo`<00000T`3oool00880oooo00<000000?ooo`3oool0V`3oool00880oooo00<000000?ooo`3o
ool0V`3oool008<0oooo00<000000?ooo`3oool0VP3oool007l0oooo00D000000?ooo`3oool0oooo
0000002L0?ooo`00P03oool4000009`0oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9695, -0.861873, \
0.086157, 0.0464683}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[""], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(Plot[{2\ Sqrt[2\ k\  - \ 1], \ 
        Sqrt[2\ Log[\((k - 1/2 + 0.01)\)*\ 2^13]]}, {k, 1/2, \ 
        4}, \[IndentingNewLine]\ PlotRange\  \[Rule] \ All, \ 
      AxesLabel\  \[Rule] \ {k, \[Lambda]}, \ 
      PlotStyle\  \[Rule] \ {{Thickness[
              0.01]}, {Dashing[{0.02}]}}, \[IndentingNewLine]\ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
-0.112245 0.272109 0.0145949 0.111258 [
[.02381 .00209 -9.125 -15.75 ]
[.02381 .00209 9.125 0 ]
[.29592 .00209 -9.125 -15.75 ]
[.29592 .00209 9.125 0 ]
[.43197 .00209 -4.84375 -15.75 ]
[.43197 .00209 4.84375 0 ]
[.56803 .00209 -9.125 -15.75 ]
[.56803 .00209 9.125 0 ]
[.70408 .00209 -4.84375 -15.75 ]
[.70408 .00209 4.84375 0 ]
[.84014 .00209 -9.125 -15.75 ]
[.84014 .00209 9.125 0 ]
[.97619 .00209 -4.84375 -15.75 ]
[.97619 .00209 4.84375 0 ]
[1.025 .01459 0 -7.875 ]
[1.025 .01459 10 7.875 ]
[.14736 .12585 -9.6875 -7.875 ]
[.14736 .12585 0 7.875 ]
[.14736 .23711 -9.6875 -7.875 ]
[.14736 .23711 0 7.875 ]
[.14736 .34837 -9.6875 -7.875 ]
[.14736 .34837 0 7.875 ]
[.14736 .45963 -9.6875 -7.875 ]
[.14736 .45963 0 7.875 ]
[.14736 .57089 -9.6875 -7.875 ]
[.14736 .57089 0 7.875 ]
[.15986 .64303 -5.09375 0 ]
[.15986 .64303 5.09375 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01459 m
.02381 .02084 L
s
gsave
.02381 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.29592 .01459 m
.29592 .02084 L
s
gsave
.29592 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.43197 .01459 m
.43197 .02084 L
s
gsave
.43197 .00209 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.56803 .01459 m
.56803 .02084 L
s
gsave
.56803 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.70408 .01459 m
.70408 .02084 L
s
gsave
.70408 .00209 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.84014 .01459 m
.84014 .02084 L
s
gsave
.84014 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3.5) show
1.000 setlinewidth
grestore
.97619 .01459 m
.97619 .02084 L
s
gsave
.97619 .00209 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.05102 .01459 m
.05102 .01834 L
s
.07823 .01459 m
.07823 .01834 L
s
.10544 .01459 m
.10544 .01834 L
s
.13265 .01459 m
.13265 .01834 L
s
.18707 .01459 m
.18707 .01834 L
s
.21429 .01459 m
.21429 .01834 L
s
.2415 .01459 m
.2415 .01834 L
s
.26871 .01459 m
.26871 .01834 L
s
.32313 .01459 m
.32313 .01834 L
s
.35034 .01459 m
.35034 .01834 L
s
.37755 .01459 m
.37755 .01834 L
s
.40476 .01459 m
.40476 .01834 L
s
.45918 .01459 m
.45918 .01834 L
s
.48639 .01459 m
.48639 .01834 L
s
.51361 .01459 m
.51361 .01834 L
s
.54082 .01459 m
.54082 .01834 L
s
.59524 .01459 m
.59524 .01834 L
s
.62245 .01459 m
.62245 .01834 L
s
.64966 .01459 m
.64966 .01834 L
s
.67687 .01459 m
.67687 .01834 L
s
.73129 .01459 m
.73129 .01834 L
s
.7585 .01459 m
.7585 .01834 L
s
.78571 .01459 m
.78571 .01834 L
s
.81293 .01459 m
.81293 .01834 L
s
.86735 .01459 m
.86735 .01834 L
s
.89456 .01459 m
.89456 .01834 L
s
.92177 .01459 m
.92177 .01834 L
s
.94898 .01459 m
.94898 .01834 L
s
.25 Mabswid
0 .01459 m
1 .01459 L
s
gsave
1.025 .01459 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
.15986 .12585 m
.16611 .12585 L
s
gsave
.14736 .12585 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.15986 .23711 m
.16611 .23711 L
s
gsave
.14736 .23711 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.15986 .34837 m
.16611 .34837 L
s
gsave
.14736 .34837 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.15986 .45963 m
.16611 .45963 L
s
gsave
.14736 .45963 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.15986 .57089 m
.16611 .57089 L
s
gsave
.14736 .57089 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.125 Mabswid
.15986 .03685 m
.16361 .03685 L
s
.15986 .0591 m
.16361 .0591 L
s
.15986 .08135 m
.16361 .08135 L
s
.15986 .1036 m
.16361 .1036 L
s
.15986 .1481 m
.16361 .1481 L
s
.15986 .17036 m
.16361 .17036 L
s
.15986 .19261 m
.16361 .19261 L
s
.15986 .21486 m
.16361 .21486 L
s
.15986 .25936 m
.16361 .25936 L
s
.15986 .28162 m
.16361 .28162 L
s
.15986 .30387 m
.16361 .30387 L
s
.15986 .32612 m
.16361 .32612 L
s
.15986 .37062 m
.16361 .37062 L
s
.15986 .39287 m
.16361 .39287 L
s
.15986 .41513 m
.16361 .41513 L
s
.15986 .43738 m
.16361 .43738 L
s
.15986 .48188 m
.16361 .48188 L
s
.15986 .50413 m
.16361 .50413 L
s
.15986 .52638 m
.16361 .52638 L
s
.15986 .54864 m
.16361 .54864 L
s
.15986 .59314 m
.16361 .59314 L
s
.15986 .61539 m
.16361 .61539 L
s
.25 Mabswid
.15986 0 m
.15986 .61803 L
s
gsave
.15986 .64303 -66.0938 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(l) show
1.000 setlinewidth
grestore
.01 w
.02381 .01472 m
.02499 .03528 L
.02605 .04318 L
.02846 .05572 L
.03279 .07175 L
.03784 .08605 L
.04262 .09733 L
.06244 .13317 L
.08265 .16093 L
.10458 .18604 L
.14545 .22499 L
.1848 .25664 L
.22263 .28359 L
.26292 .30958 L
.30169 .3326 L
.34292 .35538 L
.38262 .37596 L
.42082 .3947 L
.46146 .41369 L
.50059 .43114 L
.54217 .44893 L
.58224 .4654 L
.62079 .4807 L
.6618 .49644 L
.70128 .51113 L
.73925 .52486 L
.77968 .53908 L
.81859 .55241 L
.85995 .56622 L
.89979 .57921 L
.93812 .59143 L
.97619 .60332 L
s
.5 Mabswid
[ .02 ] 0 setdash
.02381 .34486 m
.02499 .35805 L
.02605 .36668 L
.02729 .37441 L
.02846 .38029 L
.03053 .3886 L
.03279 .39561 L
.0379 .40722 L
.04262 .41494 L
.05224 .42621 L
.06244 .43464 L
.0728 .44118 L
.0825 .44613 L
.10458 .45486 L
.12483 .46092 L
.14335 .46546 L
.18306 .47311 L
.22125 .47879 L
.2619 .4837 L
.30103 .48765 L
.34261 .49126 L
.38268 .4943 L
.42123 .49691 L
.46223 .49941 L
.50172 .50159 L
.53969 .50352 L
.58011 .50542 L
.61902 .50711 L
.66038 .50879 L
.70023 .5103 L
.73856 .51167 L
.77934 .51305 L
.81861 .5143 L
.85636 .51544 L
.89656 .5166 L
.93525 .51767 L
.97619 .51874 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00603oool300000080oooo00@0
00000?ooo`3oool0oooo0`00000b0?ooo`8000000`3oool010000000oooo0?ooo`3oool3000001P0
oooo0P00000H0?ooo`8000000P3oool010000000oooo0?ooo`3oool3000001L0oooo0`00000H0?oo
o`<000000P3oool010000000oooo0?ooo`3oool3000001P0oooo0P00000Y0?ooo`005`3oool20000
00030?ooo`000000oooo00@0oooo00@000000?ooo`3oool00000<`3oool00`000000oooo0?ooo`04
0?ooo`040000003oool0oooo000001H0oooo0`0000000`3oool000000?ooo`0D0?ooo`<0000000<0
oooo0000003oool00`3oool010000000oooo0?ooo`00000F0?ooo`030000003oool0oooo00800000
5P3oool00`000000oooo0?ooo`02000000@0oooo00@000000?ooo`3oool00000603oool2000002T0
oooo000G0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`0200000380oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02000001D0oooo00<000000?ooo`3oool0
5`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo008000005@3oool01@000000oooo
0?ooo`3oool0000001H0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo
008000005`3oool2000002T0oooo000G0?ooo`030000003oool0oooo00800000203oool00`000000
oooo0?ooo`0`0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool04`3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`0H0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool04`3oool4000002T0
oooo000G0?ooo`050000003oool0oooo0?ooo`0000001`3oool200000380oooo00<000000?ooo`3o
ool01`3oool2000001H0oooo0P00000H0?ooo`8000002@3oool2000001P0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`060?ooo`8000005@3oool010000000oooo00000000000Y0?oo
o`005`3oool01@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3oool00000<`3oool0
0`000000oooo0?ooo`040?ooo`040000003oool0oooo000001T0oooo00<000000?ooo`3oool05`3o
ool00`000000oooo0?ooo`030?ooo`040000003oool0oooo000001P0oooo0P00000I0?ooo`800000
1@3oool010000000oooo0?ooo`00000G0?ooo`<00000:@3oool001L0oooo00<000000?ooo`3oool0
0P0000040?ooo`@00000<`3oool00`000000oooo0?ooo`040?ooo`@000006@3oool2000001P0oooo
0P0000040?ooo`@000006@3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo00<0oooo
1000000G0?ooo`<00000:@3oool001L0oooo00<000000?ooo`3oool00P0000040?ooo`030000003o
ool0oooo03@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0G0?ooo`050000003o
ool0oooo0?ooo`0000005@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3o
ool05`3oool00`000000oooo0?ooo`02000001H0oooo00<000000?ooo`3oool00P0000040?ooo`03
0000003oool0oooo01T0oooo0P00000Y0?ooo`005`3oool2000000030?ooo`000000oooo00@0oooo
00<000000?ooo`3oool0<`3oool2000000H0oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`02000001D0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo01L0oooo
00@000000?ooo`3oool000005`3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo
01T0oooo0P00000Y0?ooo`00603oool3000000D0oooo0`00000d0?ooo`030000003oool0oooo00@0
oooo0`00000H0?ooo`<000005`3oool3000000D0oooo0`00000H0?ooo`<00000603oool3000000D0
oooo0`00000J0?ooo`030000003oool0oooo02L0oooo003o0?ooo`@0oooo0P0000000`3oool00000
0?ooo`0H0?ooo`00?03oool00`000000oooo0?ooo`340?ooo`80000000<0oooo0000003oool0603o
ool003`0oooo00<000000?ooo`3oool0a03oool2000000030?ooo`000000oooo01P0oooo000l0?oo
o`030000003oool0oooo0<@0oooo0`00000J0?ooo`00603ooooS000000P0oooo0`00000J0?ooo`00
703oool2000000D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0;0?ooo`800000
00<0oooo0000003oool0603oool001`0oooo0P00000N0?ooo`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0703oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo00/0oooo0P00
00000`3oool000000000000H0?ooo`00703oool2000001h0oooo00<000000?ooo`3oool0a03oool2
000001/0oooo000L0?ooo`8000007P3oool00`000000oooo0?ooo`340?ooo`8000006`3oool001`0
oooo0P00000N0?ooo`800000a@3oool2000001/0oooo000L0?ooo`8000007P3oool00`000000oooo
0?ooo`3Q0?ooo`007@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo0>40oooo000M
0?ooo`8000007@3oool00`000000oooo0?ooo`3Q0?ooo`007P3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo0>40oooo000N0?ooo`800000703oool200000>80oooo000N0?ooo`800000
703oool00`000000oooo0?ooo`3Q0?ooo`007P3oool2000001`0oooo00<000000?ooo`3oool0h@3o
ool001h0oooo0`00000K0?ooo`030000003oool0oooo0>40oooo000O0?ooo`8000006`3oool00`00
0000oooo0?ooo`3Q0?ooo`007`3oool2000001/0oooo0P00003R0?ooo`007`3oool3000001X0oooo
00<000000?ooo`3oool0h@3oool00200oooo0P00000J0?ooo`030000003oool0oooo0>40oooo000P
0?ooo`8000006P3oool00`000000oooo0?ooo`3Q0?ooo`008@3oool00`000000oooo0?ooo`0H0?oo
o`030000003oool0oooo0>40oooo000Q0?ooo`8000006@3oool200000>80oooo000R0?ooo`800000
603oool00`000000oooo0?ooo`3Q0?ooo`008`3oool00`000000oooo0?ooo`0=0?ooo`8000001`3o
ool00`000000oooo0?ooo`3Q0?ooo`008`3oool2000000l0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`3Q0?ooo`00903oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool0h@3oool002@0oooo0P00000>0?ooo`030000003oool0oooo00D0
oooo0P00003R0?ooo`009@3oool2000000d0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`3Q0?ooo`009P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00D0oooo00<0
00000?ooo`3oool0h@3oool002H0oooo0P00000<0?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0h@3oool002L0oooo0P00000;0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0h@3oool002P0oooo00<000000?ooo`3oool0203oool2000000L0oooo0P00003R0?ooo`00
:03oool2000000X0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`3Q0?ooo`00:@3o
ool200000140oooo00<000000?ooo`3oool0h@3oool002X0oooo0P00000@0?ooo`030000003oool0
oooo0>40oooo000Z0?ooo`<000003`3oool00`000000oooo0?ooo`3Q0?ooo`00:`3oool2000000l0
oooo0P00003R0?ooo`00;03oool2000000h0oooo00<000000?ooo`3oool0h@3oool002`0oooo0`00
000=0?ooo`030000003oool0oooo0>40oooo000]0?ooo`<00000303oool00`000000oooo0?ooo`3Q
0?ooo`00;P3oool3000000/0oooo00<000000?ooo`3oool0h@3oool002l0oooo0`00000:0?ooo`03
0000003oool0oooo0>40oooo000`0?ooo`<000002@3oool200000>80oooo000a0?ooo`<00000203o
ool00`000000oooo0?ooo`3Q0?ooo`00<P3oool4000000H0oooo00<000000?ooo`3oool0h@3oool0
03<0oooo100000050?ooo`030000003oool0oooo0>40oooo000e0?ooo`<00000103oool00`000000
oooo0?ooo`3Q0?ooo`00=P3oool3000000<0oooo0P00003R0?ooo`00=03oool2000000040?ooo`00
0000000000000080oooo00<000000?ooo`3oool0h@3oool00380oooo0`0000000`3oool000000?oo
o`03000000030?ooo`000000oooo0>80oooo000b0?ooo`030000003oool0oooo00@0oooo1000003S
0?ooo`00<P3oool00`000000oooo0?ooo`050?ooo`@00000hP3oool003<0oooo0P0000070?ooo`<0
0000h@3oool003D0oooo00<000000?ooo`3oool0103oool400000>00oooo000e0?ooo`8000001@3o
ool00`000000oooo0000000300000=h0oooo000b0?ooo`050000003oool0oooo0?ooo`0000001@3o
ool00`000000oooo0?ooo`0400000=d0oooo000b0?ooo`030000003oool0oooo008000001@3oool0
0`000000oooo0?ooo`020?ooo`<00000g03oool003<0oooo0`0000060?ooo`800000103oool40000
0=X0oooo000l0?ooo`030000003oool0oooo00@0oooo1000003I0?ooo`00?03oool00`000000oooo
0?ooo`060?ooo`<00000f03oool003`0oooo00<000000?ooo`3oool01`3oool400000=H0oooo000l
0?ooo`030000003oool0oooo00P0oooo1000003E0?ooo`00?03oool2000000/0oooo0`00003D0?oo
o`00?03oool00`000000oooo0?ooo`0;0?ooo`@00000dP3oool003`0oooo00<000000?ooo`3oool0
303oool400000=40oooo000l0?ooo`030000003oool0oooo00h0oooo1000003?0?ooo`00?03oool0
0`000000oooo0?ooo`0?0?ooo`@00000cP3oool003`0oooo0P00000B0?ooo`@00000c03oool003`0
oooo00<000000?ooo`3oool04P3oool500000<X0oooo000l0?ooo`030000003oool0oooo01@0oooo
1@0000380?ooo`00?03oool00`000000oooo0?ooo`0F0?ooo`@00000a`3oool003`0oooo00<00000
0?ooo`3oool0603oool400000<D0oooo000l0?ooo`8000006P3oool500000<<0oooo000c0?ooo`<0
00001P3oool00`000000oooo0?ooo`0K0?ooo`D00000`@3oool00380oooo00<000000?ooo`3oool0
0P0000050?ooo`030000003oool0oooo01d0oooo1@00002o0?ooo`00<P3oool01@000000oooo0?oo
o`3oool0000000D0oooo00<000000?ooo`3oool07`3oool400000;h0oooo000M0?ooo`030000003o
ool0oooo01H0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0Q0?ooo`@00000_03o
ool001d0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`040?ooo`8000008`3oool5
00000;X0oooo000M0?ooo`030000003oool0oooo01@0oooo0P0000060?ooo`030000003oool0oooo
02@0oooo1@00002h0?ooo`007@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool09P3oool500000;H0oooo000M0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool00P0000050?ooo`030000003oool0oooo02P0oooo1000002e0?ooo`007@3o
ool00`000000oooo0?ooo`0B0?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool0
:P3oool400000;<0oooo000c0?ooo`<000001P3oool2000002`0oooo1@00002a0?ooo`00?03oool0
0`000000oooo0?ooo`0]0?ooo`D00000[`3oool003`0oooo00<000000?ooo`3oool0;`3oool50000
0:d0oooo000N0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0<@3oool600000:X0
oooo000N0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0<`3oool600000:P0oooo
000N0?ooo`030000003oool0oooo01/0oooo0P00000g0?ooo`D00000YP3oool001l0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0h0?ooo`D00000Y03oool00200oooo00<000000?oo
o`3oool06@3oool00`000000oooo0?ooo`0j0?ooo`@00000X`3oool003`0oooo00<000000?ooo`3o
ool0?03oool400000:40oooo000l0?ooo`030000003oool0oooo03d0oooo1@00002O0?ooo`00?03o
ool200000400oooo1@00002M0?ooo`008P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0
oooo0440oooo1@00002K0?ooo`008P3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo
04<0oooo1P00002H0?ooo`008`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo04D0
oooo1P00002F0?ooo`00903oool2000001H0oooo00<000000?ooo`3oool0B03oool5000009@0oooo
000l0?ooo`800000B`3oool600000940oooo000d0?ooo`8000001P3oool00`000000oooo0?ooo`1<
0?ooo`H00000S`3oool002T0oooo0`0000080?ooo`8000001P3oool00`000000oooo0?ooo`1?0?oo
o`H00000S03oool002`0oooo0`0000050?ooo`8000001P3oool00`000000oooo0?ooo`1A0?ooo`L0
0000R@3oool00380oooo100000060?ooo`030000003oool0oooo05@0oooo1`0000260?ooo`00<P3o
ool4000000H0oooo0P00001H0?ooo`L00000P`3oool003<0oooo100000050?ooo`030000003oool0
oooo05X0oooo1P0000210?ooo`00<`3oool3000000D0oooo0P00001O0?ooo`D00000O`3oool003@0
oooo0P0000060?ooo`@00000GP3oool5000007d0oooo000d0?ooo`8000001P3oool00`000000oooo
0?ooo`050?ooo`D00000E`3oool5000007/0oooo000e0?ooo`030000003oool0oooo00@0oooo0P00
000?0?ooo`D00000D03oool6000007P0oooo000l0?ooo`030000003oool0oooo01L0oooo1@000019
0?ooo`L00000M@3oool003`0oooo00<000000?ooo`3oool0803oool5000000@0oooo0P00000n0?oo
o`H00000LP3oool003`0oooo00<000000?ooo`3oool0:`3oool3000000@0oooo1@00000e0?ooo`H0
0000K`3oool003`0oooo00<000000?ooo`3oool0>`3oool5000000@0oooo0P00000Y0?ooo`D00000
K@3oool003`0oooo0P0000170?ooo`<00000103oool5000000@0oooo1@00000F0?ooo`H00000JP3o
ool003`0oooo00<000000?ooo`3oool0G`3oool6000000<0oooo1P0000030?ooo`P00000J03oool0
03`0oooo00<000000?ooo`3oool0M03oool<000000<0oooo1P0000030?ooo`<00000DP3oool003`0
oooo00<000000?ooo`3oool0N03oool600000140oooo0`0000030?ooo`H000000`3oool6000000@0
oooo1@0000040?ooo`800000;P3oool003`0oooo00<000000?ooo`3oool0N`3oool600000380oooo
0`00000[0?ooo`00?03oool2000007h0oooo1`00001M0?ooo`00?03oool00`000000oooo0?ooo`20
0?ooo`L00000FP3oool003`0oooo00<000000?ooo`3oool0P`3oool7000005L0oooo000l0?ooo`03
0000003oool0oooo08H0oooo1`00001D0?ooo`00?03oool00`000000oooo0?ooo`290?ooo`L00000
D@3oool003`0oooo0P00002=0?ooo`L00000CP3oool003`0oooo00<000000?ooo`3oool0S`3oool7
000004/0oooo000c0?ooo`<000001P3oool00`000000oooo0?ooo`2B0?ooo`L00000B03oool00380
oooo00@000000?ooo`3oool000001P3oool00`000000oooo0?ooo`2F0?ooo`H00000A@3oool00380
oooo00<000000?ooo`3oool00P0000050?ooo`030000003oool0oooo09T0oooo1`0000110?ooo`00
=P3oool00`000000oooo0?ooo`030?ooo`800000W@3oool7000003h0oooo000e0?ooo`8000001@3o
ool00`000000oooo0?ooo`2O0?ooo`L00000>`3oool00380oooo00@000000?ooo`3oool000001P3o
ool00`000000oooo0?ooo`2R0?ooo`L00000>03oool00380oooo100000060?ooo`030000003oool0
oooo0:D0oooo1P00000f0?ooo`00<P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
0:P0oooo1P00000c0?ooo`00<P3oool00`000000oooo0?ooo`070?ooo`800000Z`3oool700000300
oooo000b0?ooo`<000001`3oool00`000000oooo0?ooo`2]0?ooo`L00000;@3oool003`0oooo00<0
00000?ooo`3oool0/03oool7000002X0oooo000l0?ooo`030000003oool0oooo0;<0oooo1@00000Y
0?ooo`00?03oool00`000000oooo0?ooo`2f0?ooo`030000003oool0oooo02P0oooo000l0?ooo`80
0000hP3oool003`0oooo00<000000?ooo`3oool0h@3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool003T0oooo00@000000?ooo`3oool0oooo
0P00003Q0?ooo`00>@3oool010000000oooo0?ooo`00003S0?ooo`00>P3oool00`000000oooo0000
003S0?ooo`00>P3oool00`000000oooo0000003S0?ooo`00>`3oool200000><0oooo000l0?ooo`03
0000003oool0oooo0>40oooo000l0?ooo`030000003oool0oooo0>40oooo000j0?ooo`800000i03o
ool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.0226757, -0.736295, \
0.0161958, 0.0396108}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[Gamma[x], {x, \(-3\), 5}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.380952 0.119048 0.311032 0.0131774 [
[.14286 .29853 -6 -9 ]
[.14286 .29853 6 0 ]
[.61905 .29853 -3 -9 ]
[.61905 .29853 3 0 ]
[.85714 .29853 -3 -9 ]
[.85714 .29853 3 0 ]
[.36845 .04748 -18 -4.5 ]
[.36845 .04748 0 4.5 ]
[.36845 .17926 -18 -4.5 ]
[.36845 .17926 0 4.5 ]
[.36845 .44281 -12 -4.5 ]
[.36845 .44281 0 4.5 ]
[.36845 .57458 -12 -4.5 ]
[.36845 .57458 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.14286 .31103 m
.14286 .31728 L
s
[(-2)] .14286 .29853 0 1 Mshowa
.61905 .31103 m
.61905 .31728 L
s
[(2)] .61905 .29853 0 1 Mshowa
.85714 .31103 m
.85714 .31728 L
s
[(4)] .85714 .29853 0 1 Mshowa
.125 Mabswid
.20238 .31103 m
.20238 .31478 L
s
.2619 .31103 m
.2619 .31478 L
s
.32143 .31103 m
.32143 .31478 L
s
.44048 .31103 m
.44048 .31478 L
s
.5 .31103 m
.5 .31478 L
s
.55952 .31103 m
.55952 .31478 L
s
.67857 .31103 m
.67857 .31478 L
s
.7381 .31103 m
.7381 .31478 L
s
.79762 .31103 m
.79762 .31478 L
s
.08333 .31103 m
.08333 .31478 L
s
.02381 .31103 m
.02381 .31478 L
s
.91667 .31103 m
.91667 .31478 L
s
.97619 .31103 m
.97619 .31478 L
s
.25 Mabswid
0 .31103 m
1 .31103 L
s
.38095 .04748 m
.3872 .04748 L
s
[(-20)] .36845 .04748 1 0 Mshowa
.38095 .17926 m
.3872 .17926 L
s
[(-10)] .36845 .17926 1 0 Mshowa
.38095 .44281 m
.3872 .44281 L
s
[(10)] .36845 .44281 1 0 Mshowa
.38095 .57458 m
.3872 .57458 L
s
[(20)] .36845 .57458 1 0 Mshowa
.125 Mabswid
.38095 .07384 m
.3847 .07384 L
s
.38095 .10019 m
.3847 .10019 L
s
.38095 .12655 m
.3847 .12655 L
s
.38095 .1529 m
.3847 .1529 L
s
.38095 .20561 m
.3847 .20561 L
s
.38095 .23197 m
.3847 .23197 L
s
.38095 .25832 m
.3847 .25832 L
s
.38095 .28468 m
.3847 .28468 L
s
.38095 .33739 m
.3847 .33739 L
s
.38095 .36374 m
.3847 .36374 L
s
.38095 .3901 m
.3847 .3901 L
s
.38095 .41645 m
.3847 .41645 L
s
.38095 .46916 m
.3847 .46916 L
s
.38095 .49552 m
.3847 .49552 L
s
.38095 .52187 m
.3847 .52187 L
s
.38095 .54823 m
.3847 .54823 L
s
.38095 .02113 m
.3847 .02113 L
s
.38095 .60094 m
.3847 .60094 L
s
.25 Mabswid
.38095 0 m
.38095 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02499 0 m
.02499 .08583 L
.02605 .19173 L
.02729 .23299 L
.02846 .2518 L
.02954 .26236 L
.03053 .26908 L
.03163 .27447 L
.03279 .27873 L
.03395 .28202 L
.0352 .28479 L
.03746 .28847 L
.03884 .29015 L
.04016 .29148 L
.04262 .29343 L
.045 .29484 L
.04753 .29599 L
.04993 .29684 L
.0521 .29745 L
.05466 .29802 L
.05743 .29849 L
.06004 .29882 L
.06244 .29904 L
.06372 .29913 L
.06488 .2992 L
.06553 .29923 L
.06622 .29926 L
.0675 .2993 L
.06868 .29932 L
.06995 .29933 L
.07102 .29932 L
.07221 .29931 L
.07289 .2993 L
.0736 .29928 L
.07487 .29923 L
.07624 .29917 L
.07774 .29908 L
.08043 .29887 L
.08293 .29862 L
.08575 .29827 L
.08842 .29786 L
.0934 .29688 L
.09876 .29542 L
.10458 .29322 L
.10947 .29063 L
.11404 .28728 L
.11667 .28477 L
.11906 .28195 L
.12183 .27785 L
.12446 .27276 L
Mistroke
.12699 .26618 L
.12837 .26157 L
.12968 .25632 L
.1309 .25035 L
.13222 .24232 L
.13342 .23306 L
.13452 .22217 L
.13584 .2046 L
.13707 .18097 L
.13778 .1622 L
.13842 .13989 L
.13916 .10447 L
.13986 .05475 L
Mfstroke
.13986 .05475 m
.14035 0 L
s
.14294 0 m
.14304 .61803 L
s
.14548 .61803 m
.1455 .61434 L
.14676 .51848 L
.14791 .47303 L
.14923 .44094 L
.15047 .42094 L
.15163 .4075 L
.15269 .39796 L
.15509 .38259 L
.15635 .37679 L
.15752 .37229 L
.16019 .36441 L
.16279 .35887 L
.16558 .35445 L
.16829 .35119 L
.17124 .34847 L
.17403 .34649 L
.17662 .34505 L
.17913 .34393 L
.1815 .34311 L
.18397 .34244 L
.18528 .34216 L
.18669 .34191 L
.18796 .34173 L
.18912 .34159 L
.19028 .34149 L
.19138 .34143 L
.19266 .34138 L
.19384 .34137 L
.19513 .3414 L
.19579 .34142 L
.19651 .34146 L
.19785 .34156 L
.19908 .34168 L
.20185 .34208 L
.20441 .34259 L
.20685 .34322 L
.21144 .3448 L
.21569 .3468 L
.22037 .34975 L
.22535 .35402 L
.22795 .35688 L
.23071 .36051 L
.23564 .36918 L
.23839 .37573 L
.24095 .38349 L
.24376 .39467 L
.24533 .4026 L
.24677 .41143 L
.24937 .43252 L
Mistroke
.25074 .44767 L
.25219 .4685 L
.25345 .49239 L
.25464 .52238 L
.25593 .56902 L
.25666 .60541 L
Mfstroke
.25666 .60541 m
.25685 .61803 L
s
.26084 .61803 m
.26089 0 L
s
.26708 0 m
.2682 .05537 L
.26939 .09478 L
.27046 .12077 L
.27163 .14253 L
.27289 .16087 L
.27424 .17621 L
.27665 .19664 L
.27911 .21137 L
.28141 .22173 L
.28573 .23544 L
.28824 .24122 L
.2909 .24611 L
.29565 .25264 L
.2983 .25537 L
.30077 .25746 L
.30368 .25948 L
.30637 .26097 L
.30876 .26203 L
.3114 .26294 L
.31405 .26361 L
.3155 .26388 L
.31686 .26408 L
.31814 .26421 L
.31935 .26429 L
.32045 .26432 L
.32164 .26432 L
.32293 .26426 L
.32365 .26421 L
.3243 .26416 L
.32558 .264 L
.32678 .26382 L
.32904 .26334 L
.33142 .26266 L
.3357 .26093 L
.33808 .25965 L
.3403 .25821 L
.34292 .25617 L
.34535 .2539 L
.35035 .24772 L
.35299 .24338 L
.3558 .23762 L
.35806 .23184 L
.3605 .22405 L
.36318 .2129 L
.36569 .19871 L
.36794 .18124 L
.36922 .16829 L
.37041 .1534 L
.37166 .13342 L
Mistroke
.37281 .10987 L
.37413 .07282 L
.37537 .02168 L
Mfstroke
.37537 .02168 m
.37572 0 L
s
.38181 0 m
.38188 .61803 L
s
.38601 .61803 m
.38675 .5744 L
.38785 .53171 L
.38903 .49858 L
.39031 .47194 L
.39168 .4508 L
.39285 .43644 L
.39411 .42394 L
.39637 .40668 L
.39848 .39464 L
.40098 .38366 L
.40326 .37584 L
.40837 .36314 L
.41125 .35792 L
.41391 .35392 L
.41881 .34812 L
.424 .34347 L
.43339 .33753 L
.43866 .33511 L
.4435 .33329 L
.45241 .33065 L
.46179 .32859 L
.47135 .32702 L
.48156 .32575 L
.49119 .32485 L
.49994 .32421 L
.50994 .32366 L
.51915 .32328 L
.52926 .32299 L
.53436 .32288 L
.53704 .32284 L
.53996 .3228 L
.54267 .32276 L
.54518 .32274 L
.54758 .32272 L
.5488 .32272 L
.55014 .32271 L
.55134 .32271 L
.55244 .3227 L
.55365 .3227 L
.55493 .3227 L
.55604 .3227 L
.55708 .3227 L
.55822 .32271 L
.55943 .32271 L
.56084 .32272 L
.56213 .32272 L
.56506 .32274 L
.56764 .32276 L
.57038 .32279 L
Mistroke
.57512 .32286 L
.58034 .32295 L
.59048 .32317 L
.59975 .32344 L
.62063 .32428 L
.63962 .32534 L
.66035 .32685 L
.68003 .3287 L
.701 .3312 L
.72242 .33445 L
.74259 .33833 L
.78115 .34875 L
.80109 .35626 L
.82216 .36639 L
.8418 .37844 L
.86014 .39264 L
.8805 .41273 L
.89906 .43619 L
.91815 .46698 L
.93891 .51057 L
.95699 .5598 L
Mfstroke
.95699 .5598 m
.97356 .61803 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oK@3oool0
0`000000oooo0?ooo`2`0?ooo`001`3oool00`000000oooo0?ooo`0N0?ooo`8000008@3oool20000
01h0oooo00<000000?ooo`000000/P3oool000L0oooo00<000000?ooo`3oool07P3oool200000240
oooo0P00000N0?ooo`030000003oool000000;80oooo00070?ooo`030000003oool0oooo01h0oooo
0P00000Q0?ooo`8000007P3oool00`000000oooo0000002b0?ooo`001`3oool00`000000oooo0?oo
o`0N0?ooo`8000008@3oool2000001h0oooo00<000000?ooo`000000/P3oool000L0oooo00<00000
0?ooo`3oool07P3oool200000240oooo0P00000N0?ooo`030000003oool000000;80oooo00070?oo
o`030000003oool0oooo01h0oooo0P00000Q0?ooo`8000007P3oool010000000oooo00000000002a
0?ooo`001`3oool00`000000oooo0?ooo`0N0?ooo`8000008@3oool2000001h0oooo00<000000?oo
o`000000/P3oool000L0oooo00<000000?ooo`3oool07P3oool200000240oooo00<000000?ooo`00
00007@3oool00`000000oooo0000002b0?ooo`001`3oool00`000000oooo0?ooo`0N0?ooo`800000
8@3oool00`000000oooo0000000M0?ooo`030000003oool000000;80oooo00070?ooo`030000003o
ool0oooo01h0oooo0P00000Q0?ooo`030000003oool0000001d0oooo00<000000?ooo`000000/P3o
ool000L0oooo00<000000?ooo`3oool07P3oool200000240oooo00<000000?ooo`000000403oool4
000000<0oooo0P0000040?ooo`030000003oool000000;80oooo00070?ooo`030000003oool0oooo
01h0oooo0P00000Q0?ooo`030000003oool000000100oooo00<000000?ooo`3oool00`3oool01000
0000oooo0?ooo`0000030?ooo`030000003oool000000;80oooo00070?ooo`030000003oool0oooo
01h0oooo0P00000Q0?ooo`030000003oool000000140oooo00<000000?ooo`3oool00P3oool01000
0000oooo0?ooo`0000030?ooo`030000003oool0000000800000/03oool000L0oooo00<000000?oo
o`3oool07P3oool200000240oooo00<000000?ooo`0000002P3oool4000000@0oooo00D000000?oo
o`3oool0oooo000000020?ooo`070000003oool0oooo0?ooo`000000oooo0000002b0?ooo`001`3o
ool00`000000oooo0?ooo`0N0?ooo`8000008@3oool00`000000oooo0000000@0?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000`3oool00`000000oooo0000002b0?ooo`00
1`3oool00`000000oooo0?ooo`0N0?ooo`8000008@3oool00`000000oooo0000000A0?ooo`800000
103oool2000000@0oooo00<000000?ooo`000000/P3oool000L0oooo00<000000?ooo`3oool07P3o
ool200000240oooo00<000000?ooo`0000007@3oool00`000000oooo0000002b0?ooo`001`3oool0
0`000000oooo0?ooo`0N0?ooo`8000008@3oool00`000000oooo0000000M0?ooo`030000003oool0
00000;80oooo00070?ooo`030000003oool0oooo01h0oooo0P00000Q0?ooo`030000003oool00000
01d0oooo00<000000?ooo`000000/P3oool000L0oooo00<000000?ooo`3oool07P3oool200000240
oooo00<000000?ooo`0000007@3oool00`000000oooo0000002b0?ooo`001`3oool00`000000oooo
0?ooo`0N0?ooo`8000008@3oool00`000000oooo0000000M0?ooo`040000003oool0000000000;40
oooo00070?ooo`030000003oool0oooo01h0oooo0P00000Q0?ooo`030000003oool0000001d0oooo
00<000000?ooo`000000/P3oool000L0oooo00<000000?ooo`3oool07P3oool200000240oooo00<0
00000?ooo`0000007@3oool00`000000oooo0000002b0?ooo`001`3oool00`000000oooo0?ooo`0N
0?ooo`8000008@3oool00`000000oooo0000000M0?ooo`030000003oool000000;80oooo00070?oo
o`030000003oool0oooo01h0oooo0P00000Q0?ooo`030000003oool0000001d0oooo00<000000?oo
o`000000/P3oool000L0oooo00<000000?ooo`3oool07P3oool200000240oooo00<000000?ooo`00
00007@3oool00`000000oooo0000002b0?ooo`001`3oool00`000000oooo0?ooo`0N0?ooo`800000
8@3oool00`000000oooo0000000M0?ooo`030000003oool000000;80oooo00070?ooo`030000003o
ool0oooo01h0oooo0P00000Q0?ooo`030000003oool0000001d0oooo00@000000?ooo`0000000000
/@3oool000L0oooo00<000000?ooo`3oool07P3oool200000240oooo00<000000?ooo`0000007@3o
ool00`000000oooo0000002b0?ooo`001`3oool00`000000oooo0?ooo`0N0?ooo`8000008@3oool0
0`000000oooo0000000M0?ooo`030000003oool000000;80oooo00070?ooo`030000003oool0oooo
01h0oooo0P00000Q0?ooo`030000003oool0000001d0oooo00<000000?ooo`000000/P3oool000L0
oooo00<000000?ooo`3oool07P3oool200000240oooo00<000000?ooo`0000007@3oool00`000000
oooo0000002b0?ooo`001`3oool00`000000oooo0?ooo`0N0?ooo`8000008@3oool00`000000oooo
0000000M0?ooo`030000003oool000000;80oooo00070?ooo`030000003oool0oooo01h0oooo0P00
000Q0?ooo`030000003oool0000001d0oooo00<000000?ooo`000000/P3oool000L0oooo00<00000
0?ooo`3oool07@3oool00`000000oooo0000000Q0?ooo`030000003oool0000001`0oooo00@00000
0?ooo`3oool00000/P3oool000L0oooo00<000000?ooo`3oool07@3oool00`000000oooo0000000Q
0?ooo`030000003oool0000001`0oooo00<000000?ooo`3oool00P00002a0?ooo`001`3oool00`00
0000oooo0?ooo`0M0?ooo`030000003oool000000240oooo00<000000?ooo`000000703oool01000
0000oooo0?ooo`00002b0?ooo`001`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool00000
0240oooo00@000000?ooo`3oool000006`3oool010000000oooo0?ooo`00002b0?ooo`001`3oool0
0`000000oooo0?ooo`0M0?ooo`030000003oool000000240oooo00@000000?ooo`3oool000006`3o
ool010000000oooo0?ooo`00002b0?ooo`001`3oool00`000000oooo0?ooo`0M0?ooo`030000003o
ool000000240oooo00@000000?ooo`3oool000006`3oool010000000oooo0?ooo`00002b0?ooo`00
1`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool000000240oooo00@000000?ooo`3oool0
00006`3oool010000000oooo0?ooo`00002b0?ooo`001`3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool000000240oooo00@000000?ooo`3oool000006`3oool010000000oooo0?ooo`00002b
0?ooo`001`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool000000240oooo00@000000?oo
o`3oool000006`3oool00`000000oooo0?ooo`0200000;40oooo00070?ooo`030000003oool0oooo
01d0oooo00<000000?ooo`0000008@3oool010000000oooo0?ooo`00000K0?ooo`040000003oool0
oooo00000;80oooo00070?ooo`030000003oool0oooo01d0oooo00<000000?ooo`0000008@3oool0
10000000oooo0?ooo`00000K0?ooo`040000003oool0oooo00000;80oooo00070?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`0000008@3oool010000000oooo0?ooo`00000K0?ooo`040000
003oool0oooo00000;80oooo00070?ooo`030000003oool0oooo01d0oooo00<000000?ooo`000000
8@3oool010000000oooo0?ooo`00000K0?ooo`040000003oool0oooo00000;80oooo00070?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`0000008@3oool010000000oooo0?ooo`00000K0?oo
o`040000003oool0oooo00000;80oooo00070?ooo`030000003oool0oooo01d0oooo00<000000?oo
o`0000008@3oool010000000oooo0?ooo`00000?0?ooo`D000000P3oool2000000<0oooo00@00000
0?ooo`3oool00000/P3oool000L0oooo00<000000?ooo`3oool07@3oool00`000000oooo0000000Q
0?ooo`040000003oool0oooo00000140oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0000000<0oooo00<000000?ooo`3oool0/03oool000L0oooo00<000000?ooo`3oool07@3o
ool00`000000oooo0000000Q0?ooo`040000003oool0oooo00000140oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0000000<0oooo0`00002`0?ooo`001`3oool00`000000oooo
0?ooo`0M0?ooo`030000003oool000000240oooo00@000000?ooo`3oool000002@3oool4000000@0
oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0000000<0oooo00<000000?oo
o`3oool0/03oool000L0oooo00<000000?ooo`3oool07@3oool00`000000oooo0000000Q0?ooo`04
0000003oool0oooo00000140oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0
000000<0oooo00<000000?ooo`3oool0/03oool000L0oooo00<000000?ooo`3oool07@3oool00`00
0000oooo0000000Q0?ooo`050000003oool0oooo0?ooo`0000003`3oool2000000@0oooo0P000002
0?ooo`050000003oool0oooo0?ooo`000000/P3oool000L0oooo00<000000?ooo`3oool07@3oool0
0`000000oooo0000000Q0?ooo`050000003oool0oooo0?ooo`0000006@3oool01@000000oooo0?oo
o`3oool000000;80oooo00070?ooo`030000003oool0oooo01d0oooo00<000000?ooo`0000008@3o
ool01@000000oooo0?ooo`3oool0000001T0oooo00D000000?ooo`3oool0oooo0000002b0?ooo`00
1`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool000000240oooo00D000000?ooo`3oool0
oooo0000000I0?ooo`050000003oool0oooo0?ooo`000000/P3oool000L0oooo00<000000?ooo`3o
ool07@3oool00`000000oooo0000000Q0?ooo`050000003oool0oooo0?ooo`0000006@3oool01000
0000oooo0?ooo`3oool200000;40oooo00070?ooo`030000003oool0oooo01d0oooo00<000000?oo
o`0000008@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01D0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`2`0?ooo`001`3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool000000240oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0/03oool000P0oooo00<000000?ooo`3oool0
6`3oool010000000oooo0?ooo`00000Q0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0;00oooo00080?ooo`030000
003oool0oooo01/0oooo00@000000?ooo`3oool000008@3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2`0?ooo`00
203oool00`000000oooo0?ooo`0K0?ooo`040000003oool0oooo00000240oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool0/03oool000P0oooo00<000000?ooo`3oool06`3oool010000000oooo0?ooo`00000Q0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo0;00oooo00080?ooo`030000003oool0oooo01/0oooo00@000000?ooo`3oool0
00008@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0180oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`2`0?ooo`00203oool00`000000oooo0?ooo`0K0?ooo`040000
003oool0oooo00000240oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0B0?ooo`03
0000003oool0oooo00@0oooo0P00002a0?ooo`00203oool00`000000oooo0?ooo`0K0?ooo`040000
003oool0oooo00000240oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool0/03oool000P0oooo00<000000?ooo`3oool0
6`3oool010000000oooo0?ooo`00000Q0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool04@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0;00oooo00080?ooo`030000
003oool0oooo01/0oooo00@000000?ooo`3oool000008@3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2`0?ooo`00
203oool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000008@3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`2`0?ooo`00203oool00`000000oooo0?ooo`0J0?ooo`050000003oool0oooo0?ooo`00
00008@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0?ooo`2`0?ooo`00203oool00`000000oooo0?ooo`0J0?ooo`050000
003oool0oooo0?ooo`0000008@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00`0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2`0?ooo`00203oool00`000000oooo
0?ooo`0J0?ooo`050000003oool0oooo0?ooo`0000008@3oool00`000000oooo0?ooo`070?ooo`80
00002P3oool2000000X0oooo00<000000?ooo`3oool0/03oool000P0oooo00<000000?ooo`3oool0
6P3oool01@000000oooo0?ooo`3oool000000240oooo00<000000?ooo`3oool02@3oool2000000L0
oooo0P00000;0?ooo`800000/@3oool000P0oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool02P3oool8000000d0oooo
00<000000?ooo`3oool0/03oool000P0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?oo
o`2`0?ooo`002@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00<0oooo1@00000M
0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0?`3oool400000480oooo0`00000X
0?ooo`002@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00<0oooo0P00000P0?oo
o`030000003oool0oooo01l0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`140?oo
o`030000003oool0oooo02L0oooo00090?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0000000O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3o
ool0@03oool00`000000oooo0?ooo`100?ooo`D00000:03oool000X0oooo00<000000?ooo`3oool0
5@3oool00`000000oooo00000003000000050?ooo`000000oooo0?ooo`0000007P3oool00`000000
oooo0?ooo`0O0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0?`3oool010000000
oooo0?ooo`00000Y0?ooo`002P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00D0
oooo0P0000020?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool07`3oool200000400
oooo00@000000?ooo`3oool00000@@3oool00`000000oooo0000000Y0?ooo`002`3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo00D0oooo00@000000?ooo`00000000007P3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo0400oooo0P0000130?ooo`800000:@3oool000/0
oooo00<000000?ooo`3oool04@3oool2000000P0oooo00<000000?ooo`3oool07`3oool00`000000
oooo0?ooo`0O0?ooo`030000003oool0oooo0;00oooo000<0?ooo`8000003P3oool3000000X0oooo
00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0;00oooo
000>0?ooo`h000003@3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<0
00000?ooo`3oool0/03oool002T0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo0;00oooo000Y0?ooo`030000003oool0oooo01l0oooo00<000000?oo
o`3oool07`3oool00`000000oooo0?ooo`2`0?ooo`00:@3oool00`000000oooo0?ooo`0O0?ooo`03
0000003oool0oooo01l0oooo00<000000?ooo`3oool0/03oool00?l00000800000010?ooo`001`3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03P3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00H0oooo000Y0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`2`0?ooo`00:@3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool07P3ooolW0000
06/0oooo000Y0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool07`3oool00`000000
oooo0?ooo`0F0?ooo`P000009`3oool;00000600oooo000Y0?ooo`030000003oool0oooo01l0oooo
00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0A0?ooo`D00000>P3oool<000005@0oooo
000Y0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?oo
o`0?0?ooo`800000B`3oool6000004h0oooo000Y0?ooo`030000003oool0oooo01l0oooo00<00000
0?ooo`3oool07`3oool2000000d0oooo0`00001C0?ooo`@00000BP3oool002T0oooo00<000000?oo
o`3oool02@3oool600000100oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0:0?oo
o`800000FP3oool4000004H0oooo000Y0?ooo`030000003oool0oooo00H0oooo100000040?ooo`<0
00003P3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0GP3oool400000480oooo000Y0?ooo`030000003oool0oooo00D0oooo0P00000:0?ooo`800000
303oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0
H`3oool200000400oooo000Y0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0303o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`1V0?ooo`800000?P3oool002T0oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool07`3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo06T0oooo0P00000l0?ooo`00:@3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0J`3oool30000
03T0oooo000Y0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`1_0?ooo`<00000=P3oool002T0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`0A0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool07`3oool2000000H0oooo
00<000000?ooo`3oool0LP3oool2000003@0oooo000Y0?ooo`050000003oool0oooo0?ooo`000000
5@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`1e0?ooo`800000<P3oool002T0oooo00D000000?ooo`3oool0oooo
0000000E0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool07`3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo07L0oooo00<000000?ooo`3oool0;`3oool002T0oooo00D0
00000?ooo`3oool0oooo0000000F0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo07T0oooo0P00000_0?ooo`00:@3o
ool010000000oooo0?ooo`00000G0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo07/0oooo00<000000?ooo`3oool0
;03oool002T0oooo00@000000?ooo`3oool00000603oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo01l0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1l0?ooo`030000
003oool0oooo02/0oooo000Y0?ooo`040000003oool0oooo000001P0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
O@3oool2000002/0oooo000Y0?ooo`040000003oool0oooo000001P0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0O0?ooo`8000000`3oool00`000000oooo0?ooo`200?ooo`030000
003oool0oooo02P0oooo000Y0?ooo`040000003oool0oooo000001T0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
P@3oool00`000000oooo0?ooo`0W0?ooo`00:@3oool010000000oooo0?ooo`00000I0?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo0880oooo00<000000?ooo`3oool09P3oool002T0oooo00@000000?ooo`3oool00000
6@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`230?ooo`030000003oool0oooo02D0oooo000Y0?ooo`030000003o
ool0000001X0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0O0?ooo`050000003o
ool0oooo0?ooo`000000Q`3oool00`000000oooo0?ooo`0T0?ooo`00:@3oool00`000000oooo0000
000J0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool07`3oool01@000000oooo0?oo
o`3oool0000008P0oooo00<000000?ooo`3oool08`3oool002T0oooo00<000000?ooo`0000006`3o
ool01@000000oooo0?ooo`3oool000000240oooo00D000000?ooo`3oool0oooo000000290?ooo`03
0000003oool0oooo0280oooo000Y0?ooo`030000003oool0000001/0oooo00D000000?ooo`3oool0
oooo0000000Q0?ooo`050000003oool0oooo0?ooo`000000RP3oool00`000000oooo0?ooo`0Q0?oo
o`00:@3oool00`000000oooo0000000K0?ooo`050000003oool0oooo0?ooo`0000008@3oool20000
0080oooo00<000000?ooo`3oool0R@3oool00`000000oooo0?ooo`0P0?ooo`00:@3oool00`000000
oooo0000000K0?ooo`050000003oool0oooo0?ooo`0000008@3oool01@000000oooo0?ooo`3oool0
000008`0oooo00<000000?ooo`3oool07`3oool002T0oooo00<000000?ooo`0000006`3oool01@00
0000oooo0?ooo`3oool000000240oooo00D000000?ooo`3oool0oooo0000002<0?ooo`030000003o
ool0oooo01l0oooo000Y0?ooo`030000003oool0000001/0oooo00D000000?ooo`3oool0oooo0000
000Q0?ooo`050000003oool0oooo0?ooo`000000S@3oool00`000000oooo0?ooo`0N0?ooo`00:@3o
ool00`000000oooo0000000K0?ooo`050000003oool0oooo0?ooo`0000008@3oool010000000oooo
0?ooo`00002?0?ooo`030000003oool0oooo01d0oooo000Y0?ooo`030000003oool0000001/0oooo
00D000000?ooo`3oool0oooo0000000B0?ooo`D000000P3oool2000000H0oooo00@000000?ooo`3o
ool00000T03oool00`000000oooo0?ooo`0L0?ooo`00:@3oool00`000000oooo0000000K0?ooo`05
0000003oool0oooo0?ooo`000000503oool01@000000oooo0?ooo`3oool000000080oooo00<00000
0?ooo`3oool00`3oool010000000oooo0?ooo`00002A0?ooo`030000003oool0oooo01/0oooo000Y
0?ooo`030000003oool0000001`0oooo00@000000?ooo`3oool00000503oool01@000000oooo0?oo
o`3oool000000080oooo00<000000?ooo`3oool00`3oool400000940oooo00<000000?ooo`3oool0
6`3oool002T0oooo00<000000?ooo`000000703oool010000000oooo0?ooo`00000D0?ooo`050000
003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo0000
0980oooo00<000000?ooo`3oool06P3oool002T0oooo00<000000?ooo`000000703oool010000000
oooo0?ooo`00000D0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`03
0?ooo`040000003oool0oooo000009<0oooo00<000000?ooo`3oool06@3oool002T0oooo00<00000
0?ooo`000000703oool010000000oooo0?ooo`00000C0?ooo`800000103oool2000000H0oooo00@0
00000?ooo`3oool00000T`3oool00`000000oooo0?ooo`0I0?ooo`00:@3oool00`000000oooo0000
000L0?ooo`040000003oool0oooo00000240oooo00@000000?ooo`3oool00000U03oool00`000000
oooo0?ooo`0H0?ooo`00:@3oool2000001d0oooo00@000000?ooo`3oool000008@3oool010000000
oooo0?ooo`00002E0?ooo`030000003oool0oooo01L0oooo000Y0?ooo`8000007@3oool010000000
oooo0?ooo`00000Q0?ooo`040000003oool0oooo000009D0oooo00<000000?ooo`3oool05`3oool0
02T0oooo0P00000M0?ooo`040000003oool0oooo00000240oooo00@000000?ooo`3oool00000UP3o
ool00`000000oooo0?ooo`0F0?ooo`00:@3oool2000001d0oooo00@000000?ooo`3oool000008@3o
ool2000000030?ooo`000000oooo09D0oooo00<000000?ooo`3oool05P3oool002T0oooo0P00000M
0?ooo`040000003oool0oooo00000240oooo00@000000?ooo`3oool00000U`3oool00`000000oooo
0?ooo`0E0?ooo`00:@3oool2000001d0oooo00@000000?ooo`3oool000008@3oool010000000oooo
0?ooo`00002G0?ooo`030000003oool0oooo01D0oooo000Y0?ooo`8000007@3oool010000000oooo
0?ooo`00000Q0?ooo`040000003oool0oooo000009P0oooo00<000000?ooo`3oool0503oool002T0
oooo0P00000M0?ooo`040000003oool0oooo00000240oooo00@000000?ooo`3oool00000V03oool0
0`000000oooo0?ooo`0D0?ooo`00:@3oool2000001d0oooo00@000000?ooo`3oool000008@3oool0
0`000000oooo0000002J0?ooo`030000003oool0oooo01<0oooo000Y0?ooo`8000007@3oool01000
0000oooo0?ooo`00000Q0?ooo`030000003oool0000009X0oooo00<000000?ooo`3oool04`3oool0
02T0oooo0P00000M0?ooo`040000003oool0oooo00000240oooo0`00002K0?ooo`030000003oool0
oooo0180oooo000Y0?ooo`8000007@3oool010000000oooo0?ooo`00000Q0?ooo`030000003oool0
000009/0oooo00<000000?ooo`3oool04P3oool002T0oooo0P00000M0?ooo`040000003oool0oooo
00000240oooo00<000000?ooo`000000W03oool00`000000oooo0?ooo`0A0?ooo`00:@3oool20000
01d0oooo00@000000?ooo`3oool000008@3oool00`000000oooo0000002L0?ooo`030000003oool0
oooo0140oooo000Y0?ooo`8000007@3oool010000000oooo0?ooo`00000Q0?ooo`030000003oool0
000009d0oooo00<000000?ooo`3oool0403oool002T0oooo0P00000N0?ooo`030000003oool00000
0240oooo00<000000?ooo`000000W@3oool00`000000oooo0?ooo`0@0?ooo`00:@3oool2000001h0
oooo00<000000?ooo`0000008@3oool00`000000oooo0000002M0?ooo`030000003oool0oooo0100
oooo000Y0?ooo`8000007P3oool00`000000oooo0000000Q0?ooo`030000003oool0000009h0oooo
00<000000?ooo`3oool03`3oool002T0oooo0P00000N0?ooo`030000003oool000000240oooo0`00
002N0?ooo`030000003oool0oooo00l0oooo000Y0?ooo`8000007P3oool00`000000oooo0000000Q
0?ooo`030000003oool0000009h0oooo00<000000?ooo`3oool03`3oool002T0oooo0P00000N0?oo
o`030000003oool000000240oooo00<000000?ooo`000000W`3oool00`000000oooo0?ooo`0>0?oo
o`00:@3oool2000001h0oooo00<000000?ooo`0000008@3oool00`000000oooo0000002O0?ooo`03
0000003oool0oooo00h0oooo000Y0?ooo`8000007P3oool00`000000oooo0000000Q0?ooo`030000
003oool0000009l0oooo00<000000?ooo`3oool03P3oool002T0oooo0P00000N0?ooo`030000003o
ool000000240oooo00<000000?ooo`000000X03oool00`000000oooo0?ooo`0=0?ooo`00:@3oool2
000001h0oooo00<000000?ooo`0000008@3oool00`000000oooo0000002P0?ooo`030000003oool0
oooo00d0oooo000Y0?ooo`8000007P3oool00`000000oooo0000000Q0?ooo`030000003oool00000
0:40oooo00<000000?ooo`3oool0303oool002T0oooo0P00000N0?ooo`030000003oool000000240
oooo0`00002Q0?ooo`030000003oool0oooo00`0oooo000Y0?ooo`8000007P3oool00`000000oooo
0000000Q0?ooo`030000003oool000000:40oooo00<000000?ooo`3oool0303oool002T0oooo0P00
000N0?ooo`030000003oool000000240oooo00<000000?ooo`000000XP3oool00`000000oooo0?oo
o`0;0?ooo`00:@3oool2000001h0oooo00<000000?ooo`0000008@3oool00`000000oooo0000002R
0?ooo`030000003oool0oooo00/0oooo000Y0?ooo`8000007P3oool00`000000oooo0000000Q0?oo
o`030000003oool000000:80oooo00<000000?ooo`3oool02`3oool002T0oooo0P00000N0?ooo`03
0000003oool000000180oooo100000030?ooo`8000001P3oool00`000000oooo0000002S0?ooo`03
0000003oool0oooo00X0oooo000Y0?ooo`8000007P3oool00`000000oooo0000000B0?ooo`030000
003oool0oooo00<0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0000002S0?ooo`03
0000003oool0oooo00X0oooo000Y0?ooo`8000007P3oool00`000000oooo0000000C0?ooo`030000
003oool0oooo0080oooo00@000000?ooo`3oool000001@3oool300000:<0oooo00<000000?ooo`3o
ool02P3oool002T0oooo0P00000N0?ooo`030000003oool0000001@0oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`000000Y03oool00`000000
oooo0?ooo`090?ooo`00:@3oool2000001h0oooo00<000000?ooo`0000004P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`000000Y03oool00`00
0000oooo0?ooo`090?ooo`00:@3oool2000001h0oooo00<000000?ooo`0000004`3oool2000000@0
oooo0P0000060?ooo`030000003oool000000:@0oooo00<000000?ooo`3oool02@3oool002T0oooo
0P00000N0?ooo`030000003oool000000240oooo00<000000?ooo`000000Y03oool00`000000oooo
0?ooo`090?ooo`00:@3oool2000001h0oooo00<000000?ooo`0000008@3oool00`000000oooo0000
002U0?ooo`030000003oool0oooo00P0oooo000Y0?ooo`8000007P3oool00`000000oooo0000000Q
0?ooo`800000YP3oool00`000000oooo0?ooo`080?ooo`00:@3oool2000001h0oooo00<000000?oo
o`0000008@3oool200000:H0oooo00<000000?ooo`3oool0203oool002T0oooo0P00000N0?ooo`03
0000003oool000000240oooo0P00002W0?ooo`030000003oool0oooo00L0oooo000Y0?ooo`800000
7P3oool00`000000oooo0000000Q0?ooo`800000Y`3oool00`000000oooo0?ooo`070?ooo`00:@3o
ool2000001h0oooo00<000000?ooo`0000008@3oool200000:L0oooo00<000000?ooo`3oool01`3o
ool002T0oooo0P00000N0?ooo`030000003oool000000240oooo0P00002X0?ooo`030000003oool0
oooo00H0oooo000Y0?ooo`8000007P3oool00`000000oooo0000000Q0?ooo`800000Z03oool00`00
0000oooo0?ooo`060?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-3.2104, -23.6037, \
0.0293408, 0.265072}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1440}, {0, 783}},
WindowSize->{840, 671},
WindowMargins->{{71, Automatic}, {6, Automatic}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 221, 5, 96, "Input"],
Cell[2000, 60, 356, 5, 22, "Message"],
Cell[2359, 67, 57, 1, 29, "Output"],
Cell[2419, 70, 43, 1, 29, "Output"]
}, Open  ]],
Cell[2477, 74, 90, 1, 30, "Input"],
Cell[2570, 77, 52, 1, 50, "Input"],

Cell[CellGroupData[{
Cell[2647, 82, 132, 3, 43, "Input"],
Cell[2782, 87, 354, 5, 22, "Message"],
Cell[3139, 94, 169, 3, 29, "Output"]
}, Open  ]],
Cell[3323, 100, 26, 0, 30, "Input"],
Cell[3352, 102, 26, 0, 30, "Input"],

Cell[CellGroupData[{
Cell[3403, 106, 333, 6, 90, "Input"],
Cell[3739, 114, 26207, 788, 186, 13672, 629, "GraphicsData", "PostScript", \
"Graphics"],
Cell[29949, 904, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30116, 912, 455, 8, 110, "Input"],
Cell[30574, 922, 31215, 998, 186, 17793, 828, "GraphicsData", "PostScript", \
"Graphics"],
Cell[61792, 1922, 130, 3, 29, "Output"]
}, Open  ]],
Cell[61937, 1928, 26, 0, 30, "Input"],
Cell[61966, 1930, 26, 0, 30, "Input"],

Cell[CellGroupData[{
Cell[62017, 1934, 96, 2, 43, "Input"],
Cell[62116, 1938, 41, 1, 29, "Output"]
}, Open  ]],
Cell[62172, 1942, 218, 5, 70, "Input"],

Cell[CellGroupData[{
Cell[62415, 1951, 490, 10, 110, "Input"],
Cell[62908, 1963, 37528, 1250, 186, 21673, 1050, "GraphicsData", \
"PostScript", "Graphics"],
Cell[100439, 3215, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[100606, 3223, 173, 4, 50, "Input"],
Cell[100782, 3229, 310, 5, 22, "Message"],
Cell[101095, 3236, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[101262, 3244, 803, 16, 170, "Input"],
Cell[102068, 3262, 39642, 1312, 186, 22202, 1092, "GraphicsData", \
"PostScript", "Graphics"],
Cell[141713, 4576, 130, 3, 29, "Output"]
}, Open  ]],
Cell[141858, 4582, 173, 3, 50, "Input"],

Cell[CellGroupData[{
Cell[142056, 4589, 347, 6, 70, "Input"],
Cell[142406, 4597, 38606, 1360, 296, 18442, 1106, "GraphicsData", \
"PostScript", "Graphics"],
Cell[181015, 5959, 130, 3, 29, "Output"]
}, Open  ]],
Cell[181160, 5965, 26, 0, 30, "Input"],
Cell[181189, 5967, 164, 3, 30, "Input"],
Cell[181356, 5972, 52, 1, 50, "Input"],

Cell[CellGroupData[{
Cell[181433, 5977, 104, 2, 43, "Input"],
Cell[181540, 5981, 65, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[181642, 5987, 1196, 23, 190, "Input"],
Cell[182841, 6012, 30428, 967, 186, 16381, 789, "GraphicsData", "PostScript", \
"Graphics"],
Cell[213272, 6981, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[213439, 6989, 113, 2, 43, "Input"],
Cell[213555, 6993, 74, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[213666, 6999, 907, 17, 170, "Input"],
Cell[214576, 7018, 31359, 896, 186, 13973, 677, "GraphicsData", "PostScript", \
"Graphics"],
Cell[245938, 7916, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[246105, 7924, 114, 2, 43, "Input"],
Cell[246222, 7928, 69, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[246328, 7934, 1495, 28, 250, "Input"],
Cell[247826, 7964, 29563, 960, 186, 16289, 792, "GraphicsData", "PostScript", \
"Graphics"],
Cell[277392, 8926, 130, 3, 29, "Output"]
}, Open  ]],
Cell[277537, 8932, 26, 0, 30, "Input"],
Cell[277566, 8934, 26, 0, 30, "Input"],

Cell[CellGroupData[{
Cell[277617, 8938, 428, 8, 90, "Input"],
Cell[278048, 8948, 31215, 998, 186, 17793, 828, "GraphicsData", "PostScript", \
"Graphics"],
Cell[309266, 9948, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[309433, 9956, 63, 1, 30, "Input"],
Cell[309499, 9959, 30650, 758, 186, 6653, 457, "GraphicsData", "PostScript", \
"Graphics"],
Cell[340152, 10719, 130, 3, 29, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

