(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    636885,      19815]*)
(*NotebookOutlinePosition[    637788,      19845]*)
(*  CellTagsIndexPosition[    637697,      19839]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
    StyleBox[\(Exact\ Risk\ Properties\),
      "Title",
      FontSize->36], "\[IndentingNewLine]", 
    StyleBox[\(\(\ \)\(Threshold\)\(\ \)\),
      "Subtitle"], "\[IndentingNewLine]", "Null"}], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(Risk\\)\\\" is similar to existing symbol \\\
\"\\!\\(Disk\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    \(Exact\ Properties\ Risk\)], "Output"],

Cell[BoxData[
    \(Threshold\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(lambda[sig_, k_] := \((2\ sig)\)\ Sqrt[2\ k\  - \ 1];\)\)], "Input"],

Cell[BoxData[
    \(\[IndentingNewLine]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(Threshold\)\(\ \)\(for\)\(\ \)\(different\)\(\ \)\(k'\) \
\(s\)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(for\\)\\\" is similar to existing symbol \
\\\"\\!\\(For\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{"different", " ", "for", " ", "s", " ", "Threshold", " ", 
      SuperscriptBox["k", "\[Prime]",
        MultilineFunction->None]}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      StyleBox["\[IndentingNewLine]",
        "Subtitle"], \(Plot[lambda[2, k], {k, 1/2, 1}, \ 
        PlotRange\  \[Rule] \ All, \ AxesLabel\  \[Rule] \ {k, \[Lambda]}, \ 
        DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
-0.928572 1.90476 0.0145949 0.147181 [
[.02381 .00209 -9.125 -15.75 ]
[.02381 .00209 9.125 0 ]
[.21429 .00209 -9.125 -15.75 ]
[.21429 .00209 9.125 0 ]
[.40476 .00209 -9.125 -15.75 ]
[.40476 .00209 9.125 0 ]
[.59524 .00209 -9.125 -15.75 ]
[.59524 .00209 9.125 0 ]
[.78571 .00209 -9.125 -15.75 ]
[.78571 .00209 9.125 0 ]
[1.025 .01459 0 -7.875 ]
[1.025 .01459 10 7.875 ]
[.96369 .16178 -9.6875 -7.875 ]
[.96369 .16178 0 7.875 ]
[.96369 .30896 -9.6875 -7.875 ]
[.96369 .30896 0 7.875 ]
[.96369 .45614 -9.6875 -7.875 ]
[.96369 .45614 0 7.875 ]
[.96369 .60332 -9.6875 -7.875 ]
[.96369 .60332 0 7.875 ]
[.97619 .64303 -5.09375 0 ]
[.97619 .64303 5.09375 15.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01459 m
.02381 .02084 L
s
gsave
.02381 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.21429 .01459 m
.21429 .02084 L
s
gsave
.21429 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.6) show
1.000 setlinewidth
grestore
.40476 .01459 m
.40476 .02084 L
s
gsave
.40476 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.7) show
1.000 setlinewidth
grestore
.59524 .01459 m
.59524 .02084 L
s
gsave
.59524 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.8) show
1.000 setlinewidth
grestore
.78571 .01459 m
.78571 .02084 L
s
gsave
.78571 .00209 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.9) show
1.000 setlinewidth
grestore
.125 Mabswid
.0619 .01459 m
.0619 .01834 L
s
.1 .01459 m
.1 .01834 L
s
.1381 .01459 m
.1381 .01834 L
s
.17619 .01459 m
.17619 .01834 L
s
.25238 .01459 m
.25238 .01834 L
s
.29048 .01459 m
.29048 .01834 L
s
.32857 .01459 m
.32857 .01834 L
s
.36667 .01459 m
.36667 .01834 L
s
.44286 .01459 m
.44286 .01834 L
s
.48095 .01459 m
.48095 .01834 L
s
.51905 .01459 m
.51905 .01834 L
s
.55714 .01459 m
.55714 .01834 L
s
.63333 .01459 m
.63333 .01834 L
s
.67143 .01459 m
.67143 .01834 L
s
.70952 .01459 m
.70952 .01834 L
s
.74762 .01459 m
.74762 .01834 L
s
.82381 .01459 m
.82381 .01834 L
s
.8619 .01459 m
.8619 .01834 L
s
.9 .01459 m
.9 .01834 L
s
.9381 .01459 m
.9381 .01834 L
s
.25 Mabswid
0 .01459 m
1 .01459 L
s
gsave
1.025 .01459 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(k) show
1.000 setlinewidth
grestore
.97619 .16178 m
.98244 .16178 L
s
gsave
.96369 .16178 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.97619 .30896 m
.98244 .30896 L
s
gsave
.96369 .30896 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.97619 .45614 m
.98244 .45614 L
s
gsave
.96369 .45614 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.97619 .60332 m
.98244 .60332 L
s
gsave
.96369 .60332 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.97619 .04403 m
.97994 .04403 L
s
.97619 .07347 m
.97994 .07347 L
s
.97619 .1029 m
.97994 .1029 L
s
.97619 .13234 m
.97994 .13234 L
s
.97619 .19121 m
.97994 .19121 L
s
.97619 .22065 m
.97994 .22065 L
s
.97619 .25008 m
.97994 .25008 L
s
.97619 .27952 m
.97994 .27952 L
s
.97619 .33839 m
.97994 .33839 L
s
.97619 .36783 m
.97994 .36783 L
s
.97619 .39727 m
.97994 .39727 L
s
.97619 .4267 m
.97994 .4267 L
s
.97619 .48557 m
.97994 .48557 L
s
.97619 .51501 m
.97994 .51501 L
s
.97619 .54445 m
.97994 .54445 L
s
.97619 .57388 m
.97994 .57388 L
s
.25 Mabswid
.97619 0 m
.97619 .61803 L
s
gsave
.97619 .64303 -66.0938 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(l) show
1.000 setlinewidth
grestore
.5 Mabswid
.02381 .01472 m
.02499 .03528 L
.02605 .04318 L
.02846 .05572 L
.03279 .07175 L
.03784 .08605 L
.04262 .09733 L
.06244 .13317 L
.08265 .16093 L
.10458 .18604 L
.14545 .22499 L
.1848 .25664 L
.22263 .28359 L
.26292 .30958 L
.30169 .3326 L
.34292 .35538 L
.38262 .37596 L
.42082 .3947 L
.46146 .41369 L
.50059 .43114 L
.54217 .44893 L
.58224 .4654 L
.62079 .4807 L
.6618 .49644 L
.70128 .51113 L
.73925 .52486 L
.77968 .53908 L
.81859 .55241 L
.85995 .56622 L
.89979 .57921 L
.93812 .59143 L
.97619 .60332 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00603oool300000080oooo00@0
00000?ooo`3oool0oooo0`00000O0?ooo`<000000P3oool010000000oooo0?ooo`3oool3000001l0
oooo0`0000020?ooo`030000003oool0oooo02@0oooo0`0000020?ooo`040000003oool0oooo0?oo
o`<000007`3oool300000080oooo00@000000?ooo`3oool0oooo0P00001@0?ooo`005`3oool20000
00030?ooo`000000oooo00@0oooo00@000000?ooo`3oool000007P3oool2000000030?ooo`000000
oooo00@0oooo0P0000000`3oool000000?ooo`0M0?ooo`80000000<0oooo0000003oool01P3oool0
0`000000oooo0?ooo`0N0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`02
000001d0oooo0P0000000`3oool000000?ooo`040?ooo`040000003oool0oooo000004l0oooo000G
0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000001d0oooo00<00000
0?ooo`3oool00P0000040?ooo`030000003oool0oooo008000007@3oool00`000000oooo0?ooo`02
000000H0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`02000000@0oooo00D00000
0?ooo`3oool0oooo0000000M0?ooo`030000003oool0oooo00800000103oool2000000030?ooo`00
0000000004h0oooo000G0?ooo`030000003oool0oooo00800000203oool00`000000oooo0?ooo`0K
0?ooo`030000003oool0oooo00800000103oool01@000000oooo0?ooo`3oool0000001d0oooo00<0
00000?ooo`3oool00P0000060?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool00P00
00040?ooo`050000003oool0oooo0?ooo`0000007@3oool00`000000oooo0?ooo`02000000L0oooo
0P00001>0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000L0oooo0P00000M0?ooo`050000
003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`02000001d0oooo00D000000?ooo`3o
ool0oooo000000060?ooo`030000003oool0oooo01h0oooo00D000000?ooo`3oool0oooo00000004
0?ooo`030000003oool0oooo008000007@3oool01@000000oooo0?ooo`3oool0000000D0oooo1000
001>0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3oool00000
7P3oool01@000000oooo0?ooo`3oool0000000@0oooo0P0000000`3oool000000?ooo`0M0?ooo`05
0000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`0M0?ooo`050000003oool0oooo
0?ooo`0000001@3oool3000001h0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003o
ool0oooo00800000CP3oool001L0oooo00<000000?ooo`3oool00P0000040?ooo`@000007P3oool0
0`000000oooo0?ooo`02000000@0oooo00<000000?ooo`0000007`3oool00`000000oooo0?ooo`02
000000L0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`02000000@0oooo0P000000
0`3oool000000?ooo`0M0?ooo`030000003oool0oooo00800000103oool01@000000oooo0?ooo`3o
ool0000004h0oooo000G0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo00800000103oool010000000oooo0?ooo`00000N0?ooo`030000003o
ool0oooo00800000103oool01@000000oooo0?ooo`3oool0000001h0oooo00<000000?ooo`3oool0
0P0000040?ooo`030000003oool0oooo008000007@3oool00`000000oooo0?ooo`02000000@0oooo
00<000000?ooo`3oool00P00001>0?ooo`005`3oool2000000030?ooo`000000oooo00@0oooo00<0
00000?ooo`3oool07`3oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`0000007P3o
ool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`0000000P00000N0?ooo`80000000<0
oooo0000003oool0103oool2000000030?ooo`000000oooo01d0oooo0P0000000`3oool000000?oo
o`040?ooo`80000000<0oooo0000003oool0CP3oool001P0oooo0`0000050?ooo`<00000803oool3
000000H0oooo0`00000O0?ooo`<000001@3oool200000080oooo00<000000?ooo`3oool07@3oool3
000000H0oooo0`00000O0?ooo`<000001P3oool3000004l0oooo003o0?ooo`@0oooo0P0000000`3o
ool000000?ooo`0H0?ooo`00m@3oool00`000000oooo0?ooo`0;0?ooo`80000000<0oooo0000003o
ool0603oool00?D0oooo00<000000?ooo`3oool02`3oool2000000030?ooo`000000oooo01P0oooo
003e0?ooo`030000003oool0oooo00/0oooo0`00000J0?ooo`00603ooooS000000P0oooo0`00000J
0?ooo`007@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00/0oooo0P0000000`3o
ool000000?ooo`0H0?ooo`007@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo02P0
oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo02P0
oooo00<000000?ooo`3oool02`3oool2000000030?ooo`000000000001P0oooo000M0?ooo`030000
003oool0oooo0=D0oooo00<000000?ooo`3oool02`3oool2000001/0oooo000M0?ooo`030000003o
ool0oooo0=D0oooo00<000000?ooo`3oool02`3oool2000001/0oooo000M0?ooo`030000003oool0
oooo0=D0oooo00<000000?ooo`3oool02`3oool2000001/0oooo000M0?ooo`030000003oool0oooo
0=D0oooo00<000000?ooo`3oool0:03oool001d0oooo00<000000?ooo`3oool0e@3oool2000002T0
oooo000M0?ooo`030000003oool0oooo0=D0oooo00<000000?ooo`3oool0:03oool001h0oooo00<0
00000?ooo`3oool0e03oool00`000000oooo0?ooo`0X0?ooo`007P3oool00`000000oooo0?ooo`3D
0?ooo`030000003oool0oooo02P0oooo000N0?ooo`030000003oool0oooo0=@0oooo00<000000?oo
o`3oool0:03oool001l0oooo00<000000?ooo`3oool0d`3oool00`000000oooo0?ooo`0X0?ooo`00
7`3oool00`000000oooo0?ooo`3C0?ooo`030000003oool0oooo02P0oooo000O0?ooo`030000003o
ool0oooo0=<0oooo0P00000Y0?ooo`00803oool00`000000oooo0?ooo`3B0?ooo`030000003oool0
oooo02P0oooo000P0?ooo`030000003oool0oooo0=80oooo00<000000?ooo`3oool0:03oool00200
oooo00<000000?ooo`3oool0dP3oool00`000000oooo0?ooo`0X0?ooo`008@3oool00`000000oooo
0?ooo`3A0?ooo`030000003oool0oooo02P0oooo000Q0?ooo`030000003oool0oooo0=40oooo00<0
00000?ooo`3oool0:03oool00280oooo00<000000?ooo`3oool0d03oool2000002T0oooo000R0?oo
o`030000003oool0oooo0=00oooo00<000000?ooo`3oool0:03oool002<0oooo00<000000?ooo`3o
ool0c`3oool00`000000oooo0?ooo`0X0?ooo`008`3oool00`000000oooo0?ooo`3?0?ooo`030000
003oool0oooo02P0oooo000T0?ooo`030000003oool0oooo0<h0oooo00<000000?ooo`3oool0:03o
ool002D0oooo00<000000?ooo`3oool0c@3oool00`000000oooo0?ooo`0X0?ooo`009@3oool00`00
0000oooo0?ooo`3=0?ooo`030000003oool0oooo02P0oooo000V0?ooo`030000003oool0oooo0<`0
oooo0P00000Y0?ooo`009`3oool00`000000oooo0?ooo`3;0?ooo`030000003oool0oooo02P0oooo
000W0?ooo`030000003oool0oooo0</0oooo00<000000?ooo`3oool0:03oool002P0oooo00<00000
0?ooo`3oool0`P3oool2000000H0oooo00<000000?ooo`3oool0:03oool002T0oooo00<000000?oo
o`3oool0`P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo02P0oooo000Y0?ooo`03
0000003oool0oooo0<80oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0X0?ooo`00
:P3oool00`000000oooo0?ooo`310?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
:03oool002/0oooo00<000000?ooo`3oool0`03oool00`000000oooo0?ooo`040?ooo`800000:@3o
ool002`0oooo00<000000?ooo`3oool0_`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo02P0oooo000/0?ooo`030000003oool0oooo0;l0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`0X0?ooo`00;@3oool00`000000oooo0?ooo`2n0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0:03oool002h0oooo00<000000?ooo`3oool0_03oool2000000H0oooo
00<000000?ooo`3oool0:03oool002l0oooo00<000000?ooo`3oool0_03oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo02P0oooo000`0?ooo`030000003oool0oooo0<80oooo0P00000Y
0?ooo`00<@3oool00`000000oooo0?ooo`310?ooo`030000003oool0oooo02P0oooo000b0?ooo`03
0000003oool0oooo0<00oooo00<000000?ooo`3oool0:03oool003<0oooo00<000000?ooo`3oool0
_`3oool00`000000oooo0?ooo`0X0?ooo`00=03oool200000;l0oooo00<000000?ooo`3oool0:03o
ool003H0oooo00<000000?ooo`3oool0_03oool00`000000oooo0?ooo`0X0?ooo`00=`3oool00`00
0000oooo0?ooo`2k0?ooo`030000003oool0oooo02P0oooo000h0?ooo`030000003oool0oooo0;X0
oooo0P00000Y0?ooo`00>@3oool00`000000oooo0?ooo`2i0?ooo`030000003oool0oooo02P0oooo
000j0?ooo`030000003oool0oooo0;P0oooo00<000000?ooo`3oool0:03oool003/0oooo0P00002h
0?ooo`030000003oool0oooo02P0oooo000m0?ooo`030000003oool0oooo0;D0oooo00<000000?oo
o`3oool0:03oool003h0oooo00<000000?ooo`3oool0]03oool00`000000oooo0?ooo`0X0?ooo`00
?`3oool200000;@0oooo00<000000?ooo`3oool0:03oool00440oooo00<000000?ooo`3oool0/@3o
ool2000002T0oooo00120?ooo`030000003oool0oooo0;00oooo00<000000?ooo`3oool0:03oool0
04<0oooo00<000000?ooo`3oool0[`3oool00`000000oooo0?ooo`0X0?ooo`00A03oool200000:l0
oooo00<000000?ooo`3oool0:03oool004H0oooo00<000000?ooo`3oool0[03oool00`000000oooo
0?ooo`0X0?ooo`00A`3oool00`000000oooo0?ooo`2[0?ooo`030000003oool0oooo02P0oooo0018
0?ooo`800000Z`3oool2000002T0oooo001:0?ooo`030000003oool0oooo0:P0oooo00<000000?oo
o`3oool0:03oool004/0oooo0P00002X0?ooo`030000003oool0oooo02P0oooo001=0?ooo`030000
003oool0oooo09h0oooo0P0000050?ooo`030000003oool0oooo02P0oooo001>0?ooo`800000W03o
ool3000000030?ooo`000000oooo00<0oooo00<000000?ooo`3oool0:03oool00500oooo00<00000
0?ooo`3oool0V@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo02P0oooo001A0?oo
o`800000V@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo02P0oooo001C0?ooo`03
0000003oool0oooo09L0oooo0P0000060?ooo`800000:@3oool005@0oooo0P00002I0?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0:03oool005H0oooo0P00002G0?ooo`800000103o
ool00`000000oooo0?ooo`0X0?ooo`00F03oool200000980oooo00D000000?ooo`3oool0oooo0000
00040?ooo`030000003oool0oooo02P0oooo001J0?ooo`800000T03oool00`000000oooo0?ooo`02
000000@0oooo00<000000?ooo`3oool0:03oool005`0oooo00<000000?ooo`3oool0SP3oool30000
00D0oooo00<000000?ooo`3oool0:03oool005d0oooo0P00002F0?ooo`030000003oool0oooo02P0
oooo001O0?ooo`800000U03oool2000002T0oooo001Q0?ooo`800000TP3oool00`000000oooo0?oo
o`0X0?ooo`00H`3oool200000900oooo00<000000?ooo`3oool0:03oool006D0oooo00<000000?oo
o`3oool0S@3oool00`000000oooo0?ooo`0X0?ooo`00IP3oool2000008d0oooo00<000000?ooo`3o
ool0:03oool006P0oooo0P00002;0?ooo`030000003oool0oooo02P0oooo001Z0?ooo`800000R@3o
ool2000002T0oooo001/0?ooo`800000Q`3oool00`000000oooo0?ooo`0X0?ooo`00KP3oool20000
08D0oooo00<000000?ooo`3oool0:03oool00700oooo0P0000230?ooo`030000003oool0oooo02P0
oooo001b0?ooo`800000P@3oool00`000000oooo0?ooo`0X0?ooo`00M03oool2000007l0oooo00<0
00000?ooo`3oool0:03oool007H0oooo0P00001m0?ooo`030000003oool0oooo02P0oooo001h0?oo
o`800000N`3oool2000002T0oooo001j0?ooo`800000N@3oool00`000000oooo0?ooo`0X0?ooo`00
O03oool2000007L0oooo00<000000?ooo`3oool0:03oool007h0oooo0P00001e0?ooo`030000003o
ool0oooo02P0oooo00200?ooo`800000L`3oool00`000000oooo0?ooo`0X0?ooo`00PP3oool20000
0740oooo00<000000?ooo`3oool0:03oool008@0oooo0P00001_0?ooo`030000003oool0oooo02P0
oooo00260?ooo`800000K@3oool2000002T0oooo00280?ooo`<00000JP3oool00`000000oooo0?oo
o`0X0?ooo`00R`3oool200000600oooo0`0000050?ooo`030000003oool0oooo02P0oooo002=0?oo
o`<00000G03oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0:03oool00900
oooo0P00001J0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`0X0?oo
o`00TP3oool3000005/0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0X0?ooo`00
U@3oool3000005L0oooo00<000000?ooo`3oool00`3oool2000002T0oooo002H0?ooo`<00000D`3o
ool2000000D0oooo00<000000?ooo`3oool0:03oool009/0oooo0P00001B0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0:03oool009d0oooo0P00001=0?ooo`030000003oool0oooo
00800000103oool00`000000oooo0?ooo`0X0?ooo`00W`3oool2000004/0oooo00@000000?ooo`3o
ool000001@3oool00`000000oooo0?ooo`0X0?ooo`00X@3oool2000004X0oooo0`0000050?ooo`03
0000003oool0oooo02P0oooo002S0?ooo`<00000C`3oool00`000000oooo0?ooo`0X0?ooo`00YP3o
ool3000004`0oooo0P00000Y0?ooo`00Z@3oool4000004P0oooo00<000000?ooo`3oool0:03oool0
0:d0oooo0`0000150?ooo`030000003oool0oooo02P0oooo002`0?ooo`800000@`3oool00`000000
oooo0?ooo`0X0?ooo`00/P3oool200000440oooo00<000000?ooo`3oool0:03oool00;@0oooo0P00
000o0?ooo`030000003oool0oooo02P0oooo002f0?ooo`<00000?03oool00`000000oooo0?ooo`0X
0?ooo`00^@3oool2000003X0oooo0P00000Y0?ooo`00^`3oool3000003L0oooo00<000000?ooo`3o
ool0:03oool00;h0oooo0`00000d0?ooo`030000003oool0oooo02P0oooo00310?ooo`<00000<@3o
ool00`000000oooo0?ooo`0X0?ooo`00a03oool3000002h0oooo00<000000?ooo`3oool0:03oool0
0<L0oooo0`00000[0?ooo`030000003oool0oooo02P0oooo003:0?ooo`<00000:03oool2000002T0
oooo003=0?ooo`<000009@3oool00`000000oooo0?ooo`0X0?ooo`00d03oool300000280oooo00<0
00000?ooo`3oool0:03oool00=<0oooo0`00000O0?ooo`030000003oool0oooo02P0oooo003F0?oo
o`@000006`3oool00`000000oooo0?ooo`0X0?ooo`00fP3oool3000001P0oooo00<000000?ooo`3o
ool0:03oool00=d0oooo0`00000E0?ooo`030000003oool0oooo02P0oooo003P0?ooo`<000004P3o
ool2000002T0oooo003S0?ooo`<000003`3oool00`000000oooo0?ooo`0X0?ooo`00iP3oool20000
00d0oooo00<000000?ooo`3oool0:03oool00>P0oooo0`0000030?ooo`8000001@3oool00`000000
oooo0?ooo`0X0?ooo`00j`3oool5000000D0oooo00<000000?ooo`3oool0:03oool00>h0oooo0`00
00040?ooo`030000003oool0oooo02P0oooo003/0?ooo`@0000000H0oooo00000000000000000?oo
o`00000Z0?ooo`00k03oool010000000oooo0000000000040?ooo`<00000:@3oool00>d0oooo0`00
00050?ooo`030000003oool0oooo02P0oooo003]0?ooo`<000001@3oool00`000000oooo0?ooo`0X
0?ooo`00kP3oool2000000D0oooo00<000000?ooo`3oool0:03oool00>h0oooo0P00000`0?ooo`00
k`3oool00`000000oooo0?ooo`0^0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00lP3oool010000000oooo0?ooo`3oool2000002P0oooo003b0?ooo`040000003oool0oooo0000
02X0oooo003c0?ooo`030000003oool0000002X0oooo003c0?ooo`030000003oool0000002X0oooo
003d0?ooo`800000:P3oool00?D0oooo00<000000?ooo`3oool0:03oool00?D0oooo00<000000?oo
o`3oool0:03oool00?<0oooo0P00000[0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.431812, -0.556585, \
0.00231369, 0.0299429}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(\ \)\(\(Mode\)\(\ \)\(2\)\(\ \)\)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(2\ Mode\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(mode2[d_, sig_, 
          k_] := \((d\  + \ 
              Sign[d]\ \ \ Sqrt[d^2 - 4\ sig^2\ \((2\ k - 1)\)])\)/
          2;\)\)], "Input"],

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(LPMRule[d_, sig_, k_] := 
      If[\((Abs[d] \[GreaterEqual] lambda[sig, k])\), mode2[d, sig, k], 
        0]\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[{d, \ LPMRule[d, 2, 0.75]}, {d, \(-5\), 5}, \ 
      PlotStyle\  \[Rule] \ {{Dashing[{0.02}]}, {Thickness[0.01]}}, \ 
      AspectRatio\  \[Rule] \ 
        Automatic, \[IndentingNewLine]PlotRange\  \[Rule] \ All, \ 
      AxesLabel\  \[Rule] \ {\[Lambda], \ None}, \ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0952381 0.5 0.0952381 [
[.11905 .4875 -9.03125 -15.75 ]
[.11905 .4875 9.03125 0 ]
[.30952 .4875 -9.03125 -15.75 ]
[.30952 .4875 9.03125 0 ]
[.69048 .4875 -4.84375 -15.75 ]
[.69048 .4875 4.84375 0 ]
[.88095 .4875 -4.84375 -15.75 ]
[.88095 .4875 4.84375 0 ]
[1.025 .5 0 -7.875 ]
[1.025 .5 10.1875 7.875 ]
[.4875 .11905 -18.0625 -7.875 ]
[.4875 .11905 0 7.875 ]
[.4875 .30952 -18.0625 -7.875 ]
[.4875 .30952 0 7.875 ]
[.4875 .69048 -9.6875 -7.875 ]
[.4875 .69048 0 7.875 ]
[.4875 .88095 -9.6875 -7.875 ]
[.4875 .88095 0 7.875 ]
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11905 .5 m
.11905 .50625 L
s
gsave
.11905 .4875 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.30952 .5 m
.30952 .50625 L
s
gsave
.30952 .4875 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.69048 .5 m
.69048 .50625 L
s
gsave
.69048 .4875 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.88095 .5 m
.88095 .50625 L
s
gsave
.88095 .4875 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.16667 .5 m
.16667 .50375 L
s
.21429 .5 m
.21429 .50375 L
s
.2619 .5 m
.2619 .50375 L
s
.35714 .5 m
.35714 .50375 L
s
.40476 .5 m
.40476 .50375 L
s
.45238 .5 m
.45238 .50375 L
s
.54762 .5 m
.54762 .50375 L
s
.59524 .5 m
.59524 .50375 L
s
.64286 .5 m
.64286 .50375 L
s
.7381 .5 m
.7381 .50375 L
s
.78571 .5 m
.78571 .50375 L
s
.83333 .5 m
.83333 .50375 L
s
.07143 .5 m
.07143 .50375 L
s
.02381 .5 m
.02381 .50375 L
s
.92857 .5 m
.92857 .50375 L
s
.97619 .5 m
.97619 .50375 L
s
.25 Mabswid
0 .5 m
1 .5 L
s
gsave
1.025 .5 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(l) show
1.000 setlinewidth
grestore
.5 .11905 m
.50625 .11905 L
s
gsave
.4875 .11905 -79.0625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .30952 m
.50625 .30952 L
s
gsave
.4875 .30952 -79.0625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .69048 m
.50625 .69048 L
s
gsave
.4875 .69048 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .88095 m
.50625 .88095 L
s
gsave
.4875 .88095 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .16667 m
.50375 .16667 L
s
.5 .21429 m
.50375 .21429 L
s
.5 .2619 m
.50375 .2619 L
s
.5 .35714 m
.50375 .35714 L
s
.5 .40476 m
.50375 .40476 L
s
.5 .45238 m
.50375 .45238 L
s
.5 .54762 m
.50375 .54762 L
s
.5 .59524 m
.50375 .59524 L
s
.5 .64286 m
.50375 .64286 L
s
.5 .7381 m
.50375 .7381 L
s
.5 .78571 m
.50375 .78571 L
s
.5 .83333 m
.50375 .83333 L
s
.5 .07143 m
.50375 .07143 L
s
.5 .02381 m
.50375 .02381 L
s
.5 .92857 m
.50375 .92857 L
s
.5 .97619 m
.50375 .97619 L
s
.25 Mabswid
.5 0 m
.5 1 L
s
.5 Mabswid
[ .02 ] 0 setdash
.02381 .02381 m
.06244 .06244 L
.10458 .10458 L
.14415 .14415 L
.18221 .18221 L
.22272 .22272 L
.26171 .26171 L
.30316 .30316 L
.34309 .34309 L
.3815 .3815 L
.42237 .42237 L
.46172 .46172 L
.49955 .49955 L
.53984 .53984 L
.57861 .57861 L
.61984 .61984 L
.65954 .65954 L
.69774 .69774 L
.73838 .73838 L
.77751 .77751 L
.81909 .81909 L
.85916 .85916 L
.89771 .89771 L
.93871 .93871 L
.97619 .97619 L
s
.01 w
[ ] 0 setdash
.02381 .06557 m
.06244 .10882 L
.10458 .15755 L
.14415 .20582 L
.18221 .2568 L
.20342 .28966 L
.21345 .30787 L
.22272 .32848 L
.22513 .33521 L
.22738 .34273 L
.22852 .34737 L
.22974 .35391 L
.23043 .36008 L
.23109 .5 L
.23233 .5 L
.23358 .5 L
.23428 .5 L
.23492 .5 L
.23615 .5 L
.23732 .5 L
.23798 .5 L
.23868 .5 L
.23993 .5 L
.24063 .5 L
.24128 .5 L
.242 .5 L
.24276 .5 L
.24403 .5 L
.2452 .5 L
.24649 .5 L
.24713 .5 L
.24785 .5 L
.24905 .5 L
.25034 .5 L
.25156 .5 L
.25267 .5 L
.25376 .5 L
.25478 .5 L
.25589 .5 L
.25707 .5 L
.25832 .5 L
.2595 .5 L
.26056 .5 L
.26171 .5 L
.26294 .5 L
.26407 .5 L
.26537 .5 L
.2666 .5 L
.26774 .5 L
.26879 .5 L
Mistroke
.26994 .5 L
.27117 .5 L
.27188 .5 L
.27253 .5 L
.27324 .5 L
.27399 .5 L
.27525 .5 L
.27597 .5 L
.27664 .5 L
.27789 .5 L
.27903 .5 L
.28034 .5 L
.28159 .5 L
.2828 .5 L
.28348 .5 L
.28413 .5 L
.28543 .5 L
.28616 .5 L
.28683 .5 L
.28796 .5 L
.28919 .5 L
.29048 .5 L
.29167 .5 L
.29236 .5 L
.2931 .5 L
.2938 .5 L
.29445 .5 L
.29568 .5 L
.29697 .5 L
.29764 .5 L
.29837 .5 L
.29967 .5 L
.30046 .5 L
.30122 .5 L
.30189 .5 L
.30263 .5 L
.30384 .5 L
.30496 .5 L
.30618 .5 L
.30747 .5 L
.30859 .5 L
.30964 .5 L
.31078 .5 L
.31201 .5 L
.31271 .5 L
.31335 .5 L
.31406 .5 L
.3148 .5 L
.31606 .5 L
.31677 .5 L
Mistroke
.31744 .5 L
.31868 .5 L
.31982 .5 L
.32113 .5 L
.32238 .5 L
.32306 .5 L
.3237 .5 L
.3249 .5 L
.32619 .5 L
.32692 .5 L
.32759 .5 L
.32871 .5 L
.32994 .5 L
.33122 .5 L
.33242 .5 L
.3331 .5 L
.33384 .5 L
.33454 .5 L
.33519 .5 L
.33641 .5 L
.33771 .5 L
.33838 .5 L
.3391 .5 L
.34041 .5 L
.34116 .5 L
.34196 .5 L
.34264 .5 L
.34338 .5 L
.3447 .5 L
.34592 .5 L
.34656 .5 L
.34726 .5 L
.34799 .5 L
.34867 .5 L
.34993 .5 L
.35108 .5 L
.35171 .5 L
.3524 .5 L
.35366 .5 L
.3549 .5 L
.35601 .5 L
.3573 .5 L
.35851 .5 L
.35964 .5 L
.36067 .5 L
.36181 .5 L
.363 .5 L
.36431 .5 L
.3655 .5 L
.36616 .5 L
Mistroke
.36688 .5 L
.36818 .5 L
.3694 .5 L
.37069 .5 L
.37179 .5 L
.373 .5 L
.37373 .5 L
.37443 .5 L
.37573 .5 L
.37645 .5 L
.37713 .5 L
.37787 .5 L
.37866 .5 L
.37935 .5 L
.38009 .5 L
.38079 .5 L
.38144 .5 L
.38266 .5 L
.38396 .5 L
.38518 .5 L
.38587 .5 L
.3865 .5 L
.38767 .5 L
.38891 .5 L
.39002 .5 L
.39106 .5 L
.3922 .5 L
.39343 .5 L
.39466 .5 L
.39536 .5 L
.39601 .5 L
.39733 .5 L
.39806 .5 L
.39873 .5 L
.39993 .5 L
.40123 .5 L
.40246 .5 L
.40359 .5 L
.40464 .5 L
.40578 .5 L
.40685 .5 L
.40783 .5 L
.40897 .5 L
.41022 .5 L
.4114 .5 L
.41249 .5 L
.41372 .5 L
.41489 .5 L
.41593 .5 L
.41706 .5 L
Mistroke
.41829 .5 L
.41959 .5 L
.4207 .5 L
.42192 .5 L
.42323 .5 L
.42444 .5 L
.42507 .5 L
.42576 .5 L
.42649 .5 L
.42717 .5 L
.42842 .5 L
.42957 .5 L
.43082 .5 L
.43214 .5 L
.43326 .5 L
.43445 .5 L
.43557 .5 L
.43659 .5 L
.4378 .5 L
.4391 .5 L
.44033 .5 L
.44146 .5 L
.44267 .5 L
.44396 .5 L
.44519 .5 L
.4463 .5 L
.44761 .5 L
.44835 .5 L
.44904 .5 L
.45029 .5 L
.45093 .5 L
.45163 .5 L
.4523 .5 L
.45302 .5 L
.45429 .5 L
.45501 .5 L
.45567 .5 L
.45639 .5 L
.45717 .5 L
.45784 .5 L
.45857 .5 L
.45926 .5 L
.4599 .5 L
.46111 .5 L
.46238 .5 L
.46359 .5 L
.4649 .5 L
.46615 .5 L
.4673 .5 L
.46844 .5 L
Mistroke
.46948 .5 L
.47067 .5 L
.4718 .5 L
.47303 .5 L
.47433 .5 L
.47544 .5 L
.47666 .5 L
.47798 .5 L
.47871 .5 L
.47938 .5 L
.48069 .5 L
.48192 .5 L
.48297 .5 L
.48413 .5 L
.48534 .5 L
.48648 .5 L
.48754 .5 L
.48851 .5 L
.48957 .5 L
.49069 .5 L
.49183 .5 L
.49305 .5 L
.4942 .5 L
.49524 .5 L
.49647 .5 L
.49717 .5 L
.49781 .5 L
.49898 .5 L
.50023 .5 L
.50144 .5 L
.50276 .5 L
.504 .5 L
.50516 .5 L
.5063 .5 L
.50734 .5 L
.50854 .5 L
.50967 .5 L
.5109 .5 L
.51221 .5 L
.51332 .5 L
.51454 .5 L
.51586 .5 L
.51659 .5 L
.51727 .5 L
.51857 .5 L
.51981 .5 L
.52086 .5 L
.52202 .5 L
.52323 .5 L
.52437 .5 L
Mistroke
.52543 .5 L
.5264 .5 L
.52752 .5 L
.52858 .5 L
.52973 .5 L
.53095 .5 L
.5321 .5 L
.53314 .5 L
.53437 .5 L
.53507 .5 L
.5357 .5 L
.53688 .5 L
.53812 .5 L
.53934 .5 L
.54002 .5 L
.54066 .5 L
.54183 .5 L
.54307 .5 L
.54418 .5 L
.54522 .5 L
.54636 .5 L
.54759 .5 L
.54882 .5 L
.54952 .5 L
.55016 .5 L
.55148 .5 L
.55221 .5 L
.55288 .5 L
.55408 .5 L
.55538 .5 L
.55661 .5 L
.55774 .5 L
.55879 .5 L
.55993 .5 L
.561 .5 L
.56198 .5 L
.56312 .5 L
.56437 .5 L
.56555 .5 L
.56664 .5 L
.56787 .5 L
.56903 .5 L
.57008 .5 L
.5712 .5 L
.57244 .5 L
.57374 .5 L
.57485 .5 L
.57607 .5 L
.57737 .5 L
.57858 .5 L
Mistroke
.57921 .5 L
.57991 .5 L
.58064 .5 L
.58132 .5 L
.58257 .5 L
.58371 .5 L
.58497 .5 L
.58629 .5 L
.5874 .5 L
.58859 .5 L
.58972 .5 L
.59074 .5 L
.59194 .5 L
.59324 .5 L
.59447 .5 L
.5956 .5 L
.5968 .5 L
.5981 .5 L
.59932 .5 L
.60044 .5 L
.60175 .5 L
.60249 .5 L
.60317 .5 L
.60443 .5 L
.60513 .5 L
.60576 .5 L
.60644 .5 L
.60715 .5 L
.60843 .5 L
.60914 .5 L
.6098 .5 L
.61053 .5 L
.61131 .5 L
.61198 .5 L
.61271 .5 L
.6134 .5 L
.61404 .5 L
.61524 .5 L
.61652 .5 L
.61772 .5 L
.61904 .5 L
.62028 .5 L
.62143 .5 L
.62257 .5 L
.62361 .5 L
.6248 .5 L
.62593 .5 L
.62716 .5 L
.62846 .5 L
.62957 .5 L
Mistroke
.63079 .5 L
.6321 .5 L
.63284 .5 L
.63351 .5 L
.63481 .5 L
.63605 .5 L
.6371 .5 L
.63826 .5 L
.63947 .5 L
.6406 .5 L
.64166 .5 L
.64263 .5 L
.64369 .5 L
.64481 .5 L
.64596 .5 L
.64717 .5 L
.64832 .5 L
.64937 .5 L
.6506 .5 L
.65129 .5 L
.65193 .5 L
.65311 .5 L
.65435 .5 L
.65556 .5 L
.65688 .5 L
.65812 .5 L
.65928 .5 L
.66042 .5 L
.66146 .5 L
.66266 .5 L
.66378 .5 L
.66502 .5 L
.66632 .5 L
.66744 .5 L
.66866 .5 L
.66997 .5 L
.67071 .5 L
.67138 .5 L
.67269 .5 L
.67392 .5 L
.67497 .5 L
.67613 .5 L
.67735 .5 L
.67848 .5 L
.67954 .5 L
.68051 .5 L
.68158 .5 L
.6827 .5 L
.68384 .5 L
.68506 .5 L
Mistroke
.68621 .5 L
.68725 .5 L
.68848 .5 L
.68918 .5 L
.68982 .5 L
.69099 .5 L
.69223 .5 L
.69345 .5 L
.69413 .5 L
.69477 .5 L
.69594 .5 L
.69718 .5 L
.69828 .5 L
.69932 .5 L
.70046 .5 L
.70169 .5 L
.70292 .5 L
.70362 .5 L
.70427 .5 L
.70558 .5 L
.70632 .5 L
.70698 .5 L
.70818 .5 L
.70948 .5 L
.71071 .5 L
.71184 .5 L
.7129 .5 L
.71403 .5 L
.7151 .5 L
.71608 .5 L
.71722 .5 L
.71847 .5 L
.71965 .5 L
.72074 .5 L
.72197 .5 L
.72313 .5 L
.72418 .5 L
.7253 .5 L
.72654 .5 L
.72784 .5 L
.72895 .5 L
.73017 .5 L
.73147 .5 L
.73268 .5 L
.73331 .5 L
.73401 .5 L
.73473 .5 L
.73541 .5 L
.73666 .5 L
.7378 .5 L
Mistroke
.73906 .5 L
.74038 .5 L
.74149 .5 L
.74268 .5 L
.74381 .5 L
.74483 .5 L
.74603 .5 L
.74733 .5 L
.74856 .5 L
.74969 .5 L
.75089 .5 L
.75219 .5 L
.75341 .5 L
.75453 .5 L
.75584 .5 L
.75657 .5 L
.75726 .5 L
.75851 .5 L
.75922 .5 L
.75985 .5 L
.76053 .5 L
.76124 .5 L
.76252 .5 L
.76323 .5 L
.76389 .5 L
.76462 .5 L
.76539 .5 L
.76607 .5 L
.7668 .5 L
.76749 .5 L
.76812 .5 L
.76933 .5 L
.77061 .6482 L
.77181 .65406 L
.77312 .65911 L
.77552 .66668 L
.78001 .67822 L
.79013 .69894 L
.80842 .72932 L
.84905 .78552 L
.88817 .83382 L
.92973 .88228 L
.96978 .92733 L
.97619 .93443 L
Mfstroke
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00Q`3oool00`000000oooo0?oo
o`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3o
ool00`000000oooo0?ooo`2F0?ooo`001P3oool00`000000oooo0?ooo`1n0?ooo`800000U`3oool0
00L0oooo00<000000?ooo`3oool0O@3oool00`000000oooo0?ooo`2F0?ooo`00203oool00`000000
oooo0?ooo`1l0?ooo`030000003oool0oooo09H0oooo00090?ooo`030000003oool0oooo07/0oooo
00<000000?ooo`3oool0UP3oool000X0oooo00<000000?ooo`3oool0NP3oool00`000000oooo0?oo
o`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`2F0?ooo`003P3oool00`000000oooo0?ooo`1f0?ooo`030000
003oool0oooo09H0oooo000?0?ooo`030000003oool0oooo07D0oooo00<000000?ooo`3oool0UP3o
ool000l0oooo00<000000?ooo`3oool0M@3oool00`000000oooo0?ooo`2F0?ooo`001P3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo07@0oooo00<000000?ooo`3oool0UP3oool000D0
oooo0`0000090?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0UP3oool000H0oooo
0`00001n0?ooo`800000U`3oool000L0oooo0`00001m0?ooo`030000003oool0oooo09H0oooo0008
0?ooo`<00000O03oool00`000000oooo0?ooo`2F0?ooo`002@3oool3000000T0oooo00<000000?oo
o`3oool0K`3oool00`000000oooo0?ooo`2F0?ooo`002P3oool2000000X0oooo00<000000?ooo`3o
ool0KP3oool00`000000oooo0?ooo`2F0?ooo`002`3oool2000000X0oooo00<000000?ooo`3oool0
K@3oool00`000000oooo0?ooo`2F0?ooo`002`3oool3000000X0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`2F0?ooo`00303oool3000000X0oooo00<000000?ooo`3oool0J`3oool0
0`000000oooo0?ooo`2F0?ooo`003@3oool3000007L0oooo00<000000?ooo`3oool0UP3oool000h0
oooo0`00001]0?ooo`8000001`3oool00`000000oooo0?ooo`2F0?ooo`003`3oool3000000/0oooo
00<000000?ooo`3oool0GP3oool2000000L0oooo00<000000?ooo`3oool0UP3oool00100oooo0`00
000;0?ooo`030000003oool0oooo05d0oooo0P0000070?ooo`030000003oool0oooo09H0oooo000A
0?ooo`<000002`3oool00`000000oooo0?ooo`1J0?ooo`@000001`3oool00`000000oooo0?ooo`2F
0?ooo`004P3oool2000000`0oooo00<000000?ooo`3oool0D@3oool7000000030?ooo`000000oooo
008000001`3oool2000009L0oooo000C0?ooo`800000303oool00`000000oooo0?ooo`1I0?ooo`<0
00001`3oool00`000000oooo0?ooo`2F0?ooo`004`3oool3000006L0oooo0`0000070?ooo`030000
003oool0oooo09H0oooo000D0?ooo`<00000I`3oool2000000L0oooo00<000000?ooo`3oool0UP3o
ool001D0oooo0`00001V0?ooo`8000001`3oool00`000000oooo0?ooo`2F0?ooo`005P3oool30000
00/0oooo00<000000?ooo`3oool0F03oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
09H0oooo000G0?ooo`<000002`3oool00`000000oooo0?ooo`1O0?ooo`030000003oool0oooo09H0
oooo000H0?ooo`800000303oool00`000000oooo0?ooo`1N0?ooo`030000003oool0oooo09H0oooo
000I0?ooo`800000303oool00`000000oooo0?ooo`1M0?ooo`030000003oool0oooo09H0oooo000I
0?ooo`<00000303oool00`000000oooo0?ooo`1L0?ooo`030000003oool0oooo09H0oooo000J0?oo
o`<00000JP3oool00`000000oooo0?ooo`2F0?ooo`006`3oool2000006X0oooo00<000000?ooo`3o
ool0UP3oool001`0oooo0P00001Y0?ooo`030000003oool0oooo09H0oooo000M0?ooo`8000003@3o
ool00`000000oooo0?ooo`1H0?ooo`800000U`3oool001h0oooo0P00000=0?ooo`030000003oool0
oooo05L0oooo00<000000?ooo`3oool0UP3oool001l0oooo00<000000?ooo`3oool0303oool20000
05L0oooo00<000000?ooo`3oool0UP3oool001l0oooo0P00000?0?ooo`030000003oool0oooo05@0
oooo00<000000?ooo`3oool0UP3oool00200oooo0P00001U0?ooo`030000003oool0oooo09H0oooo
000Q0?ooo`800000I03oool00`000000oooo0?ooo`2F0?ooo`008P3oool2000006<0oooo00<00000
0?ooo`3oool0UP3oool002<0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`1@0?oo
o`030000003oool0oooo09H0oooo000S0?ooo`800000403oool00`000000oooo0?ooo`1?0?ooo`03
0000003oool0oooo09H0oooo000T0?ooo`800000403oool00`000000oooo0?ooo`1>0?ooo`030000
003oool0oooo09H0oooo000U0?ooo`800000403oool00`000000oooo0?ooo`1=0?ooo`030000003o
ool0oooo09H0oooo000V0?ooo`800000403oool00`000000oooo0?ooo`1<0?ooo`030000003oool0
oooo09H0oooo000V0?ooo`<00000GP3oool00`000000oooo0?ooo`2F0?ooo`009`3oool3000005d0
oooo0P00002G0?ooo`00:03oool2000005d0oooo00<000000?ooo`3oool0UP3oool002T0oooo0P00
000@0?ooo`800000BP3oool00`000000oooo0?ooo`2F0?ooo`00:@3oool300000140oooo00<00000
0?ooo`3oool0A`3oool00`000000oooo0?ooo`2F0?ooo`00:P3oool300000100oooo00<000000?oo
o`3oool0A`3oool00`000000oooo0?ooo`2F0?ooo`00:`3oool300000100oooo00<000000?ooo`3o
ool0AP3oool00`000000oooo0?ooo`2F0?ooo`00;03oool300000100oooo00<000000?ooo`3oool0
A@3oool00`000000oooo0?ooo`2F0?ooo`00;@3oool2000005P0oooo00<000000?ooo`3oool0UP3o
ool002h0oooo0P00001G0?ooo`030000003oool0oooo09H0oooo000^0?ooo`<00000EP3oool00`00
0000oooo0?ooo`2F0?ooo`00;`3oool300000140oooo00<000000?ooo`3oool0@@3oool00`000000
oooo0?ooo`2F0?ooo`00<03oool200000180oooo00<000000?ooo`3oool0@03oool00`000000oooo
0?ooo`2F0?ooo`00<@3oool200000180oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?oo
o`2F0?ooo`00<P3oool00`000000oooo0?ooo`0A0?ooo`800000?`3oool2000009L0oooo000b0?oo
o`800000D`3oool00`000000oooo0?ooo`2F0?ooo`00<`3oool00`000000oooo0?ooo`1A0?ooo`03
0000003oool0oooo09H0oooo000c0?ooo`800000DP3oool00`000000oooo0?ooo`2F0?ooo`00=03o
ool2000001D0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`2F0?ooo`00=@3oool0
0`000000oooo0?ooo`0D0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0UP3oool0
03D0oooo0P00000E0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0UP3oool003H0
oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo09H0
oooo000f0?ooo`8000005P3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo09H0oooo
000g0?ooo`030000003oool0oooo04@0oooo0P0000070?ooo`030000003oool0oooo09H0oooo000g
0?ooo`800000@`3oool3000000030?ooo`000000oooo00D0oooo00<000000?ooo`3oool0UP3oool0
03P0oooo0P0000120?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0UP3oool003T0
oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool0UP3oool003T0oooo0P00000H0?ooo`030000003oool0oooo01h0oooo
1`0000020?ooo`800000203oool2000009L0oooo000j0?ooo`030000003oool0oooo01L0oooo00<0
00000?ooo`3oool0:03oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09H0oooo000j
0?ooo`8000006@3oool00`000000oooo0?ooo`0W0?ooo`8000001P3oool00`000000oooo0?ooo`2F
0?ooo`00>`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo02<0oooo00D000000?oo
o`3oool0oooo000000060?ooo`030000003oool0oooo09H0oooo000k0?ooo`800000?`3oool00`00
0000oooo0?ooo`02000000H0oooo00<000000?ooo`3oool0UP3oool003`0oooo00<000000?ooo`3o
ool0?P3oool3000000L0oooo00<000000?ooo`3oool0UP3oool003/0oooo0`00000L0?ooo`030000
003oool0oooo02X0oooo00<000000?ooo`3oool0UP3oool003`0oooo0P00000M0?ooo`030000003o
ool0oooo02T0oooo00<000000?ooo`3oool0UP3oool003`0oooo0P00000M0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool0UP3oool003`0oooo0P00000N0?ooo`030000003oool0oooo
02P0oooo00<000000?ooo`3oool0UP3oool003d0oooo00<000000?ooo`3oool07@3oool2000002P0
oooo00<000000?ooo`3oool0UP3oool003d0oooo0P0000180?ooo`030000003oool0oooo09H0oooo
000n0?ooo`030000003oool0oooo04H0oooo0P00002G0?ooo`00?@3oool2000004P0oooo00<00000
0?ooo`3oool0UP3oool003d0oooo0P00000S0?ooo`030000003oool0oooo0280oooo00<000000?oo
o`3oool0UP3oool003d0oooo0P00000T0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0UP3oool003d0oooo0P00000T0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
UP3oool003d0oooo0P00000U0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0UP3o
ool003d0oooo0P00000V0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0UP3oool0
03d0oooo0P0000180?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000B03oool00`000000
oooo0?ooo`2F0?ooo`00?@3oool2000004P0oooo00<000000?ooo`3oool0UP3oool003d0oooo0P00
000Z0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0UP3oool003d0oooo0P00000[
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0UP3oool003d0oooo0P00000/0?oo
o`030000003oool0oooo01T0oooo00<000000?ooo`3oool0UP3oool003d0oooo0P00000]0?ooo`03
0000003oool0oooo01P0oooo0P00002G0?ooo`00?@3oool2000002h0oooo00<000000?ooo`3oool0
5`3oool00`000000oooo0?ooo`2F0?ooo`00?@3oool2000004P0oooo00<000000?ooo`3oool0UP3o
ool003d0oooo0P0000180?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000<P3oool00`00
0000oooo0?ooo`0C0?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000<`3oool00`000000
oooo0?ooo`0B0?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000=03oool00`000000oooo
0?ooo`0A0?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000=@3oool00`000000oooo0?oo
o`0@0?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000=P3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo09H0oooo000m0?ooo`800000B03oool00`000000oooo0?ooo`2F0?oo
o`00?@3oool2000004P0oooo00<000000?ooo`3oool0UP3oool002@0oooo0P00000G0?ooo`800000
603oool2000002h0oooo00<000000?ooo`3oool0<03oool200000380oooo0P00000`0?ooo`00903o
ool2000001L0oooo0P00000F0?ooo`<0000000<0oooo0000003oool07@3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo02h0oooo0`0000000`3oool000000?ooo`0`0?ooo`800000<03o
ool002@0oooo0P00000G0?ooo`8000005P3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0
oooo00/0oooo0P00000_0?ooo`030000003oool0oooo03<0oooo0P00000`0?ooo`008P3oool40000
01L0oooo0P00000F0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`0^0?ooo`030000003oool0oooo0340oooo1000000`0?ooo`006P3oool700000003
0?ooo`000000oooo008000005`3oool2000000h0oooo1`0000020?ooo`8000008`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo02l0oooo0P00000a0?ooo`040000003oool000000000
0300oooo000S0?ooo`<000005`3oool2000001T0oooo00<000000?ooo`3oool08@3oool00`000000
oooo0?ooo`080?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0;`3oool300000300
oooo000S0?ooo`<000005`3oool2000001T0oooo0P00000]0?ooo`030000003oool0oooo0340oooo
0P00000`0?ooo`<00000<03oool002@0oooo0P00000G0?ooo`8000005P3oool01@000000oooo0?oo
o`3oool0000002d0oooo00<000000?ooo`3oool0;P3oool01@000000oooo0?ooo`3oool000000340
oooo0P00000`0?ooo`00903oool2000001L0oooo0P00000F0?ooo`030000003oool0oooo00800000
;@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo00800000<@3oool200000300oooo
000U0?ooo`030000003oool0oooo01D0oooo0P00000G0?ooo`<000009`3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo02l0oooo0`00000c0?ooo`030000003oool0oooo02h0oooo000m
0?ooo`800000@P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo09H0oooo000m0?oo
o`800000@`3oool2000000<0oooo00<000000?ooo`3oool0UP3oool003d0oooo0P0000150?ooo`04
0000003oool0oooo000008h0oooo00@000000?ooo`3oool0oooo0P0000040?ooo`00?@3oool20000
04P0oooo00<000000?ooo`3oool0S03oool010000000oooo0?ooo`0000060?ooo`00?@3oool20000
04P0oooo00<000000?ooo`3oool0S@3oool00`000000oooo000000060?ooo`00o`00000@000000P0
oooo00<000000?ooo`0000001P3oool000H0oooo00<000000?ooo`3oool02P3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool010000000oooo
0?ooo`3ooonD000000<0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0>0?ooo`80
00001P3oool00200oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0a0?ooo`030000
003oool000000300oooo00<000000?ooo`3oool04P3oool2000001`0oooo00<000000?ooo`3oool0
:@3oool00`000000oooo0?ooo`040?ooo`00Q`3oool010000000oooo0?ooo`0000140?ooo`800000
B03oool00`000000oooo0?ooo`040?ooo`00Q`3oool01@000000oooo0?ooo`3oool0000004<0oooo
0P0000160?ooo`8000001`3oool008L0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`100?ooo`800000C`3oool008L0oooo00<000000?ooo`3oool0A@3oool2000004l0oooo00270?oo
o`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`150?ooo`80
0000C`3oool008L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0m0?ooo`800000
C`3oool008L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0l0?ooo`800000C`3o
ool008L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0k0?ooo`800000C`3oool0
08L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0j0?ooo`800000C`3oool008L0
oooo0P00000:0?ooo`030000003oool0oooo03T0oooo0P00001?0?ooo`00Q`3oool00`000000oooo
0?ooo`150?ooo`800000C`3oool008L0oooo00<000000?ooo`3oool0A@3oool2000004l0oooo0027
0?ooo`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo03D0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0>0?ooo`03
0000003oool0oooo03@0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0?0?ooo`800000
=03oool2000004l0oooo00270?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0<@3o
ool2000004l0oooo00270?ooo`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3oool00`00
0000oooo0?ooo`150?ooo`800000C`3oool008L0oooo00<000000?ooo`3oool0A@3oool2000004l0
oooo00270?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0;@3oool2000004l0oooo
00270?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0;03oool2000004l0oooo0027
0?ooo`8000005`3oool00`000000oooo0?ooo`0/0?ooo`800000C`3oool008L0oooo00<000000?oo
o`3oool05`3oool00`000000oooo0?ooo`0[0?ooo`800000C`3oool008L0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`0Z0?ooo`800000C`3oool008L0oooo00<000000?ooo`3oool0
A@3oool2000004l0oooo00270?ooo`030000003oool0oooo04D0oooo0P00001?0?ooo`00Q`3oool0
0`000000oooo0?ooo`150?ooo`800000C`3oool008L0oooo00<000000?ooo`3oool0703oool20000
02L0oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02@0
oooo0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02@0oooo
0P00001?0?ooo`00Q`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo02<0oooo0P00
001?0?ooo`00Q`3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0280oooo0P00001?
0?ooo`00Q`3oool00`000000oooo0?ooo`150?ooo`800000C`3oool008L0oooo00<000000?ooo`3o
ool0A@3oool2000004l0oooo00270?ooo`8000009@3oool00`000000oooo0?ooo`0N0?ooo`800000
C`3oool008L0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0M0?ooo`800000C`3o
ool008L0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0L0?ooo`800000C`3oool0
08L0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0K0?ooo`800000C`3oool008L0
oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo04d0
oooo00270?ooo`030000003oool0oooo04H0oooo0P00001>0?ooo`00Q`3oool00`000000oooo0?oo
o`170?ooo`030000003oool0oooo04`0oooo00270?ooo`030000003oool0oooo04L0oooo0P00001=
0?ooo`00Q`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo01P0oooo0P00001=0?oo
o`00OP3oool2000000L0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0H0?ooo`03
0000003oool0oooo04/0oooo001l0?ooo`<0000000<0oooo0000003oool01@3oool00`000000oooo
0?ooo`0]0?ooo`030000003oool0oooo01P0oooo0P00001<0?ooo`00O03oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0603oool00`000000oooo0?oo
o`1:0?ooo`00O03oool00`000000oooo0?ooo`080?ooo`800000<03oool00`000000oooo0?ooo`0G
0?ooo`800000B`3oool007d0oooo0P0000080?ooo`030000003oool0oooo04X0oooo00<000000?oo
o`3oool0B@3oool007l0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1:0?ooo`80
0000BP3oool007l0oooo0P0000060?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0
B03oool007`0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003oool0oooo03<0oooo
00<000000?ooo`3oool05@3oool2000004T0oooo001l0?ooo`030000003oool0oooo008000001P3o
ool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo01D0oooo0P0000180?ooo`00O@3oool3
000000L0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0
oooo04H0oooo00270?ooo`030000003oool0oooo03H0oooo00<000000?ooo`3oool0503oool20000
04L0oooo00270?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0503oool00`000000
oooo0?ooo`150?ooo`00Q`3oool00`000000oooo0?ooo`1>0?ooo`800000AP3oool008L0oooo00<0
00000?ooo`3oool0C`3oool2000004D0oooo00270?ooo`030000003oool0oooo03/0oooo00<00000
0?ooo`3oool04P3oool00`000000oooo0?ooo`130?ooo`00Q`3oool00`000000oooo0?ooo`0l0?oo
o`030000003oool0oooo0140oooo0P0000140?ooo`00Q`3oool2000003h0oooo00<000000?ooo`3o
ool04@3oool2000004<0oooo00270?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0
4@3oool200000480oooo00270?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`100?ooo`00Q`3oool00`000000oooo0?ooo`1C0?ooo`800000@@3oool0
08L0oooo00<000000?ooo`3oool0E03oool200000400oooo00270?ooo`030000003oool0oooo05D0
oooo00<000000?ooo`3oool0?P3oool008L0oooo00<000000?ooo`3oool0@P3oool00`000000oooo
0?ooo`0@0?ooo`800000?`3oool008L0oooo00<000000?ooo`3oool0@`3oool00`000000oooo0?oo
o`0@0?ooo`800000?P3oool008L0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0@
0?ooo`800000?@3oool008L0oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`0@0?oo
o`030000003oool0oooo03/0oooo00270?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3o
ool03`3oool2000003`0oooo00270?ooo`030000003oool0oooo05T0oooo0P00000k0?ooo`00Q`3o
ool00`000000oooo0?ooo`1J0?ooo`800000>P3oool008L0oooo0P00001L0?ooo`030000003oool0
oooo03P0oooo00270?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool03P3oool20000
03T0oooo00270?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool03P3oool2000003P0
oooo00270?ooo`030000003oool0oooo04`0oooo0P00000?0?ooo`800000=`3oool008L0oooo00<0
00000?ooo`3oool0CP3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo03D0oooo0027
0?ooo`030000003oool0oooo05h0oooo0P00000f0?ooo`00Q`3oool00`000000oooo0?ooo`1O0?oo
o`800000=@3oool008L0oooo00<000000?ooo`3oool0H03oool2000003@0oooo00270?ooo`030000
003oool0oooo0580oooo00<000000?ooo`3oool0303oool2000003<0oooo00270?ooo`030000003o
ool0oooo05<0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0a0?ooo`00Q`3oool0
0`000000oooo0?ooo`1D0?ooo`030000003oool0oooo00/0oooo0P00000b0?ooo`00Q`3oool00`00
0000oooo0?ooo`1E0?ooo`030000003oool0oooo00/0oooo0P00000a0?ooo`00Q`3oool00`000000
oooo0?ooo`1F0?ooo`030000003oool0oooo00/0oooo0P00000`0?ooo`00Q`3oool2000006H0oooo
0P00000_0?ooo`00Q`3oool00`000000oooo0?ooo`1U0?ooo`<00000;P3oool008L0oooo00<00000
0?ooo`3oool0IP3oool3000002d0oooo00270?ooo`030000003oool0oooo05T0oooo00<000000?oo
o`3oool02`3oool3000002`0oooo00270?ooo`030000003oool0oooo05X0oooo00<000000?ooo`3o
ool02`3oool3000002/0oooo00270?ooo`030000003oool0oooo05/0oooo00<000000?ooo`3oool0
2`3oool3000002X0oooo00270?ooo`030000003oool0oooo05`0oooo00<000000?ooo`3oool02`3o
ool2000002X0oooo00270?ooo`030000003oool0oooo05d0oooo00<000000?ooo`3oool02`3oool2
000002T0oooo00270?ooo`030000003oool0oooo06/0oooo0`00000X0?ooo`00OP3oool2000000L0
oooo00<000000?ooo`3oool0K03oool3000002L0oooo001n0?ooo`8000001`3oool00`000000oooo
0?ooo`1]0?ooo`<000009P3oool007h0oooo0P0000070?ooo`030000003oool0oooo0640oooo00<0
00000?ooo`3oool02P3oool3000002D0oooo001l0?ooo`@000001`3oool00`000000oooo0?ooo`1R
0?ooo`030000003oool0oooo00X0oooo0`00000T0?ooo`00O03oool010000000oooo000000000007
0?ooo`800000I03oool2000000/0oooo0`00000S0?ooo`00O@3oool3000000L0oooo00<000000?oo
o`3oool0I@3oool00`000000oooo0?ooo`090?ooo`<000008P3oool007d0oooo0`0000070?ooo`03
0000003oool0oooo0780oooo0P00000R0?ooo`00OP3oool2000000L0oooo00<000000?ooo`3oool0
L`3oool200000240oooo001n0?ooo`8000001`3oool00`000000oooo0?ooo`1c0?ooo`<00000803o
ool007l0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1Y0?ooo`030000003oool0
oooo00P0oooo0`00000O0?ooo`00Q`3oool00`000000oooo0?ooo`1Z0?ooo`030000003oool0oooo
00P0oooo0`00000N0?ooo`00Q`3oool00`000000oooo0?ooo`1Z0?ooo`030000003oool0oooo00T0
oooo0`00000M0?ooo`00Q`3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0oooo00T0oooo
0P00000M0?ooo`00Q`3oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo00T0oooo0P00
000L0?ooo`00Q`3oool00`000000oooo0?ooo`1h0?ooo`<000006`3oool008L0oooo00<000000?oo
o`3oool0N@3oool3000001X0oooo00270?ooo`030000003oool0oooo07X0oooo0`00000I0?ooo`00
Q`3oool200000740oooo00<000000?ooo`3oool0203oool3000001P0oooo00270?ooo`030000003o
ool0oooo0740oooo0P0000090?ooo`<000005`3oool008L0oooo00<000000?ooo`3oool0L`3oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo01H0oooo00270?ooo`030000003oool0oooo
07<0oooo00<000000?ooo`3oool0803oool008L0oooo00<000000?ooo`3oool0M03oool00`000000
oooo0?ooo`0O0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?oo
o`2F0?ooo`00Q`3oool00`000000oooo0?ooo`1h0?ooo`030000003oool0oooo01/0oooo00270?oo
o`030000003oool0oooo07T0oooo00<000000?ooo`3oool06P3oool008L0oooo00<000000?ooo`3o
ool0NP3oool00`000000oooo0?ooo`0I0?ooo`00Q`3oool00`000000oooo0?ooo`1k0?ooo`030000
003oool0oooo01P0oooo00270?ooo`030000003oool0oooo07`0oooo00<000000?ooo`3oool05`3o
ool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00002G0?ooo`00Q`3oool00`000000
oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?oo
o`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-5.25005, -5.57935, 0.0388805, \
0.0388805}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[
    \(\(phi[\ d_, \ th_, \ s2_] := \ 
        1/Sqrt[2\ Pi\ s2]\ \ Exp[\ \(-\ \((d\  - \ 
                      th)\)^2\)/\((2\ s2)\)];\)\)], "Input"],

Cell[BoxData[
    \(\[IndentingNewLine]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(Here\ is\ the\ Exact\ Risk\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(Exact\ Here\ is\ Risk\ the ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\( (*\ sig\  = \ 2, \ k\  = \ 3/4\ *) \), "\[IndentingNewLine]", 
      RowBox[{\(pl1 = \ 
          Plot[\[IndentingNewLine]NIntegrate[\ \ \((th\  - 
                        1/2 \((\ 
                            d\  - \ 
                              Sqrt[d^2\  - \ 
                                  4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ phi[
                    d, \ th, \ 
                    2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                      2\ 3/4\  - 
                        1]}]\  + \[IndentingNewLine]NIntegrate[\ \ th^2\ phi[
                    d, \ th, \ 
                    2^2], {d, \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                      2\ 3/4\  - 1], \ \((2\ \ 2)\)\ \ Sqrt[
                      2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
              NIntegrate[\ \ \((th\  - 
                        1/2 \((\ 
                            d\  + \ 
                              Sqrt[d^2\  - 
                                  4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ phi[
                    d, \ th, \ 
                    2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                  Infinity}], \[IndentingNewLine]{th, \(-10\), 10}\ , 
            PlotRange\  \[Rule] \ {0, \ 9}, \ 
            AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
            DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\), "\n", 
        "\[IndentingNewLine]", "\n", "\n", 
        StyleBox[\( (*\ sig\  = \ 2, \ k\  = \ 0.6\ *) \),
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox[\(pl2 = \ 
              Plot[\[IndentingNewLine]NIntegrate[\ \ \((th\  - 
                            1/2 \((\ 
                                d\  - \ 
                                  Sqrt[d^2\  - \ 
                                      4\ \ 2^2\ \((2\ 0.6\  - 
                                        1)\)])\))\)^2\ phi[d, \ th, \ 
                        2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[
                          2\ 0.6\  - 
                            1]}]\  + \[IndentingNewLine]NIntegrate[\ \ th^2\ \
phi[d, \ th, \ 2^2], {d, \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                          2\ 0.6\  - 1], \ \((2\ \ 2)\)\ \ Sqrt[
                          2\ 0.6\  - 1]}]\  + \[IndentingNewLine]\ 
                  NIntegrate[\ \ \((th\  - 
                            1/2 \((\ 
                                d\  + \ 
                                  Sqrt[d^2\  - 
                                      4\ \ 2^2\ \((2\ 0.6 - 
                                        1)\)])\))\)^2\ phi[d, \ th, \ 
                        2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 0.6\  - 1], \ 
                      Infinity}], \[IndentingNewLine]{th, \(-10\), 10}\ , 
                PlotRange\  \[Rule] \ {0, \ 9}, \ 
                AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
                DefaultFont\  \[Rule] \ {"\<Roman\>", 
                    12}, \[IndentingNewLine]PlotStyle \[Rule] {GrayLevel[0], 
                    Dashing[{ .01}]}];\),
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox[\( (*\ sig\  = \ 2, \ k\  = \ 0.9\ *) \),
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox[\(pl3 = \ 
              Plot[\[IndentingNewLine]NIntegrate[\ \ \((th\  - 
                            1/2 \((\ 
                                d\  - \ 
                                  Sqrt[d^2\  - \ 
                                      4\ \ 2^2\ \((2\ 0.9 - 
                                        1)\)])\))\)^2\ phi[d, \ th, \ 
                        2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[
                          2\ 0.9\  - 
                            1]}]\  + \[IndentingNewLine]NIntegrate[\ \ th^2\ \
phi[d, \ th, \ 2^2], {d, \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                          2\ 0.9\  - 1], \ \((2\ \ 2)\)\ \ Sqrt[
                          2\ 0.9\  - 1]}]\  + \[IndentingNewLine]\ 
                  NIntegrate[\ \ \((th\  - 
                            1/2 \((\ 
                                d\  + \ 
                                  Sqrt[d^2\  - 
                                      4\ \ 2^2\ \((2\ 0.9 - 
                                        1)\)])\))\)^2\ phi[d, \ th, \ 
                        2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 0.9\  - 1], \ 
                      Infinity}], \[IndentingNewLine]{th, \(-10\), 10}\ , 
                PlotRange\  \[Rule] \ {0, \ 9}, \ 
                AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
                DefaultFont\  \[Rule] \ {"\<Roman\>", 
                    12}, \[IndentingNewLine]PlotStyle \[Rule] {GrayLevel[0], 
                    Dashing[{ .03}]}];\),
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox[\(Show[pl1, \ pl2, \ pl3]\),
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"]}]}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 -2.08167e-017 0.0686704 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .13734 -9.6875 -7.875 ]
[.4875 .13734 0 7.875 ]
[.4875 .27468 -9.6875 -7.875 ]
[.4875 .27468 0 7.875 ]
[.4875 .41202 -9.6875 -7.875 ]
[.4875 .41202 0 7.875 ]
[.4875 .54936 -9.6875 -7.875 ]
[.4875 .54936 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .13734 m
.50625 .13734 L
s
gsave
.4875 .13734 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .27468 m
.50625 .27468 L
s
gsave
.4875 .27468 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .41202 m
.50625 .41202 L
s
gsave
.4875 .41202 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .54936 m
.50625 .54936 L
s
gsave
.4875 .54936 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .03434 m
.50375 .03434 L
s
.5 .06867 m
.50375 .06867 L
s
.5 .10301 m
.50375 .10301 L
s
.5 .17168 m
.50375 .17168 L
s
.5 .20601 m
.50375 .20601 L
s
.5 .24035 m
.50375 .24035 L
s
.5 .30902 m
.50375 .30902 L
s
.5 .34335 m
.50375 .34335 L
s
.5 .37769 m
.50375 .37769 L
s
.5 .44636 m
.50375 .44636 L
s
.5 .48069 m
.50375 .48069 L
s
.5 .51503 m
.50375 .51503 L
s
.5 .5837 m
.50375 .5837 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .29238 m
.04262 .29467 L
.06244 .29776 L
.08255 .30191 L
.10458 .30807 L
.12415 .31545 L
.14509 .32585 L
.16639 .33957 L
.18653 .3556 L
.22495 .39265 L
.24439 .41221 L
.25471 .42183 L
.26581 .43102 L
.27642 .43817 L
.28146 .44087 L
.28613 .4429 L
.2908 .44444 L
.29326 .44505 L
.29452 .4453 L
.29589 .44552 L
.29719 .44569 L
.29839 .4458 L
.29954 .44588 L
.30075 .44592 L
.30184 .44592 L
.30286 .44589 L
.30397 .44582 L
.30517 .44571 L
.30638 .44555 L
.30773 .44533 L
.31045 .44471 L
.31297 .44393 L
.31534 .44302 L
.32066 .44032 L
.32641 .43636 L
.3369 .42625 L
.34653 .41369 L
.36545 .38017 L
.38615 .33214 L
.42671 .22221 L
.44545 .17541 L
.45531 .15433 L
.46576 .13564 L
.47105 .12782 L
.47686 .1206 L
.48221 .1153 L
.4871 .11164 L
.48968 .11017 L
.49212 .10907 L
.49337 .10862 L
Mistroke
.4947 .10823 L
.49547 .10804 L
.49616 .1079 L
.49682 .10779 L
.49751 .10769 L
.49877 .10757 L
.49993 .10754 L
.50117 .10757 L
.50188 .10762 L
.50253 .10769 L
.50373 .10788 L
.50481 .10811 L
.50725 .10884 L
.50955 .10979 L
.51208 .11113 L
.51719 .1148 L
.52193 .11929 L
.52638 .12444 L
.53638 .13913 L
.54715 .15931 L
.58834 .26337 L
.60891 .31937 L
.62802 .36614 L
.64648 .40262 L
.65681 .4184 L
.66618 .42961 L
.67105 .43425 L
.67619 .43829 L
.68058 .44104 L
.6854 .44333 L
.68812 .44429 L
.69059 .44497 L
.69196 .44527 L
.69345 .44553 L
.69414 .44562 L
.69486 .44571 L
.69616 .44583 L
.69735 .4459 L
.69863 .44592 L
.69983 .4459 L
.70094 .44585 L
.70217 .44576 L
.70286 .44568 L
.70351 .4456 L
.70622 .44515 L
.70884 .44454 L
.71125 .44383 L
.71672 .44171 L
.72665 .43629 L
.74523 .42188 L
Mistroke
.7846 .38295 L
.82245 .34808 L
.84351 .33278 L
.86276 .32161 L
.88265 .31265 L
.90155 .30615 L
.92137 .301 L
.93977 .29738 L
.95887 .29447 L
.97619 .29238 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`004@3oool2000000@0oooo0`00
000f0?ooo`<00000L`3oool3000003L0oooo0P0000040?ooo`<000005`3oool00180oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0d0?ooo`040000003oool0oooo00000780oooo
00@000000?ooo`3oool00000>03oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01H0oooo000B0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000003@0oooo00<000000?oo
o`3oool00P00001a0?ooo`030000003oool0oooo00800000=`3oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000F0?ooo`004P3oool01@000000oooo0?ooo`3oool000000080oooo0P00000h
0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0=@3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000F0?ooo`001`3oool7000000@0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02X0oooo1`0000040?ooo`800000M03oool2000003L0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01@0oooo000B0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0b0?ooo`040000003oool0oooo00000780
oooo00@000000?ooo`3oool00000>03oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0503oool00180oooo00D000000?ooo`3oool0oooo000000020?ooo`800000=03oool4
00000780oooo1000000h0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001H0oooo000B
0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000003@0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0i0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001H0oooo
000A0?ooo`8000000`3oool2000000030?ooo`000000oooo03@0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0h0?ooo`8000000`3oool2000000030?ooo`000000oooo01H0oooo000B
0?ooo`030000003oool0oooo0080oooo0`00000e0?ooo`<00000L`3oool3000003T0oooo00<00000
0?ooo`3oool00P3oool3000001L0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?oooa@0oooo
0P00000;0?ooo`00o`3ooolC0?ooo`040000003oool0oooo000000X0oooo003o0?oooa<0oooo00@0
00000?ooo`3oool000002P3oool000X0ooooo`000002000000L0oooo00D000000?ooo`3oool0oooo
000000090?ooo`00403oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo03X0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00/0oooo1@00
00090?ooo`00RP3oool00`000000oooo0?ooo`260?ooo`040000003oool0oooo000000T0oooo002:
0?ooo`030000003oool0oooo08H0oooo00@000000?ooo`3oool000002@3oool008X0oooo00<00000
0?ooo`3oool0Q`3oool3000000T0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`03
0000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03o
ool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0
oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?oo
o`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo00280?ooo`D00000
T`3oool008L0oooo00D000000?ooo`3oool000000?ooo`0200000980oooo00250?ooo`8000000`3o
ool01@000000oooo0?ooo`3oool000000940oooo00240?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool00P3oool2000008l0oooo00220?ooo`8000001P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo08`0oooo00200?ooo`D000001@3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo08`0oooo00200?ooo`030000003oool0000000L0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`2;0?ooo`00P03oool2000000P0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`2;0?ooo`00P@3oool2000000L0oooo0`0000060?ooo`030000003o
ool0oooo08X0oooo00200?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`290?ooo`00P03oool00`000000oooo0?ooo`02000000D0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`290?ooo`00O`3oool2000000<0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo08P0oooo001o0?ooo`80
00000P3oool2000000D0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`280?ooo`00
OP3oool00`000000oooo0?ooo`03000000H0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`270?ooo`00OP3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool0Q`3oool007d0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo08H0oooo001m0?ooo`030000003oool0oooo00X0oooo0P00000;0?oo
o`030000003oool0oooo08H0oooo001l0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`250?ooo`00O03oool00`000000oooo0?ooo`0;0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool0Q@3oool007/0oooo00<000000?ooo`3oool0303o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo08D0oooo001k0?ooo`030000003oool0
oooo00`0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`240?ooo`00NP3oool00`00
0000oooo0?ooo`0=0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0Q03oool007X0
oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo08<0
oooo001i0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool03@3oool00`000000oooo
0?ooo`230?ooo`00N@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00d0oooo00<0
00000?ooo`3oool0P`3oool007T0oooo00<000000?ooo`3oool03P3oool2000000l0oooo00<00000
0?ooo`3oool0PP3oool007P0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo0880oooo001h0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool03`3oool00`000000oooo0?ooo`210?ooo`00M`3oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool0P@3oool007L0oooo00<000000?ooo`3oool0403o
ool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0800oooo001g0?ooo`030000003oool0
oooo0100oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`200?ooo`00MP3oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0P03oool007H0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo07l0
oooo001f0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`1o0?ooo`00M@3oool00`000000oooo0?ooo`0B0?ooo`8000004`3oool00`000000oooo0?oo
o`1n0?ooo`00M@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<00000
0?ooo`3oool0OP3oool007@0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0B0?oo
o`030000003oool0oooo07h0oooo001d0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`1m0?ooo`00M03oool00`000000oooo0?ooo`0C0?ooo`030000
003oool0oooo01<0oooo00<000000?ooo`3oool0O@3oool007<0oooo00<000000?ooo`3oool0303o
ool2000000H0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1l0?ooo`00L`3oool0
0`000000oooo0?ooo`0<0?ooo`8000001P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo07`0oooo001c0?ooo`030000003oool0oooo00`0oooo0P0000060?ooo`030000003oool0oooo
01@0oooo00<000000?ooo`3oool0O03oool00780oooo00<000000?ooo`3oool02`3oool4000000H0
oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1k0?ooo`00LP3oool00`000000oooo
0?ooo`0;0?ooo`040000003oool00000000000H0oooo0`00000E0?ooo`030000003oool0oooo07/0
oooo001b0?ooo`030000003oool0oooo00`0oooo0`0000060?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool0N`3oool00740oooo00<000000?ooo`3oool03@3oool3000000H0oooo00<0
00000?ooo`3oool05P3oool00`000000oooo0?ooo`1j0?ooo`00L@3oool00`000000oooo0?ooo`0>
0?ooo`8000001P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo07X0oooo000@0?oo
o`<00000GP3oool00`000000oooo0?ooo`0>0?ooo`8000001P3oool00`000000oooo0?ooo`0F0?oo
o`030000003oool0oooo05`0oooo0`00000K0?ooo`004`3oool5000005P0oooo00<000000?ooo`3o
ool0403oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0EP3oool5000001h0oooo000H0?ooo`D00000D`3oool00`000000oooo0?ooo`0G0?ooo`030000
003oool0oooo01L0oooo00<000000?ooo`3oool0CP3oool8000002<0oooo000M0?ooo`D00000C@3o
ool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0B`3o
ool2000002/0oooo000R0?ooo`D00000B03oool00`000000oooo0?ooo`0H0?ooo`030000003oool0
oooo01P0oooo00<000000?ooo`3oool0A`3oool4000002d0oooo000W0?ooo`800000AP3oool00`00
0000oooo0?ooo`0H0?ooo`8000006@3oool00`000000oooo0?ooo`140?ooo`<00000<@3oool002T0
oooo0P0000130?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool06@3oool00`000000
oooo0?ooo`110?ooo`800000=03oool002/0oooo0P0000110?ooo`030000003oool0oooo01T0oooo
00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0o0?ooo`800000=P3oool002d0oooo0P00
000o0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`0n0?ooo`030000003oool0oooo03H0oooo000_0?ooo`030000003oool0oooo03/0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo03/0oooo0P00000i
0?ooo`00<03oool2000003/0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0J0?oo
o`030000003oool0oooo03T0oooo0P00000k0?ooo`00<P3oool2000003T0oooo00<000000?ooo`3o
ool06P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3o
ool0>`3oool003@0oooo0P00000f0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`0e0?ooo`800000?P3oool003H0oooo00<000000?ooo`3oool0<`3o
ool00`000000oooo0?ooo`0K0?ooo`800000703oool00`000000oooo0?ooo`0c0?ooo`800000@03o
ool003L0oooo0P00000b0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0703oool0
0`000000oooo0?ooo`0`0?ooo`800000@P3oool003T0oooo00<000000?ooo`3oool0;`3oool00`00
0000oooo0?ooo`0L0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0;`3oool00`00
0000oooo0?ooo`120?ooo`00>P3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo01`0
oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo04<0
oooo000k0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool07@3oool00`000000oooo
0?ooo`0M0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0A03oool003`0oooo00<0
00000?ooo`3oool0:`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo01h0oooo00<0
00000?ooo`3oool0:P3oool00`000000oooo0?ooo`150?ooo`00?@3oool00`000000oooo0?ooo`0Z
0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0Y
0?ooo`030000003oool0oooo04H0oooo000n0?ooo`030000003oool0oooo02P0oooo00<000000?oo
o`3oool07P3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02P0oooo00<000000?oo
o`3oool0A`3oool003l0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0N0?ooo`03
0000003oool0oooo01l0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`180?ooo`00
@03oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo01l0oooo0P00000P0?ooo`030000
003oool0oooo02D0oooo00<000000?ooo`3oool0B@3oool00440oooo00<000000?ooo`3oool0903o
ool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool08`3o
ool00`000000oooo0?ooo`1:0?ooo`00@P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0
oooo0200oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0R0?ooo`030000003oool0
oooo04/0oooo00130?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0803oool00`00
0000oooo0?ooo`0Q0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0C03oool004@0
oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240
oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1=0?ooo`00A@3oool00`000000oooo
0?ooo`0M0?ooo`030000003oool0oooo01T0oooo0`0000060?ooo`030000003oool0oooo0280oooo
00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1>0?ooo`00AP3oool00`000000oooo0?oo
o`0L0?ooo`030000003oool0oooo01P0oooo0P0000000`3oool000000?ooo`050?ooo`030000003o
ool0oooo0280oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`1?0?ooo`00A`3oool0
0`000000oooo0?ooo`0J0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool00P000005
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`1@
0?ooo`00B03oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01T0oooo00D000000?oo
o`3oool0oooo000000050?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool06@3oool0
0`000000oooo0?ooo`1A0?ooo`00B@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo
01X0oooo00<000000?ooo`3oool00P0000050?ooo`<00000903oool00`000000oooo0?ooo`0G0?oo
o`030000003oool0oooo0580oooo001:0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool06`3oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`3oool09@3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0oooo05<0oooo001;0?ooo`030000003oool0oooo01<0oooo
00<000000?ooo`3oool0703oool00`000000oooo000000070?ooo`030000003oool0oooo02H0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`1D0?ooo`00C03oool00`000000oooo0?oo
o`0A0?ooo`030000003oool0oooo01d0oooo00@000000?ooo`3oool000001P3oool00`000000oooo
0?ooo`0V0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0E@3oool004d0oooo00<0
00000?ooo`3oool03`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0000000H0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`0?0?ooo`800000F03oool004h0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`0O0?ooo`<000001P3oool00`000000oooo0?ooo`0X
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0F03oool004l0oooo0P00000=0?oo
o`030000003oool0oooo02T0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0:0?oo
o`800000F`3oool00540oooo0P0000090?ooo`800000;03oool00`000000oooo0?ooo`0Z0?ooo`80
0000203oool2000005d0oooo001C0?ooo`T00000;P3oool00`000000oooo0?ooo`0/0?ooo`P00000
G`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000
003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0
oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:
0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3o
ool008X0oooo00<000000?ooo`3oool0T`3oool00840oooo0`0000060?ooo`030000003oool0oooo
09<0oooo00200?ooo`030000003oool0oooo008000001@3oool00`000000oooo0?ooo`2C0?ooo`00
P03oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0T`3oool00800oooo
00D000000?ooo`3oool0oooo000000050?ooo`030000003oool0oooo09<0oooo00200?ooo`030000
003oool0oooo008000001@3oool3000009<0oooo00210?ooo`<000001P3oool00`000000oooo0?oo
o`2C0?ooo`00P03oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`3oool0T`3oool0
0800oooo00<000000?ooo`3oool00P0000050?ooo`030000003oool0oooo09<0oooo00200?ooo`80
000000<0oooo0000003oool01@3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool3000000H0oooo
00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<00000
0?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00
RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool0
0`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000
oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?oo
o`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.3759, -1.07928, \
0.0821481, 0.0569651}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 -2.08167e-017 0.0686704 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .13734 -9.6875 -7.875 ]
[.4875 .13734 0 7.875 ]
[.4875 .27468 -9.6875 -7.875 ]
[.4875 .27468 0 7.875 ]
[.4875 .41202 -9.6875 -7.875 ]
[.4875 .41202 0 7.875 ]
[.4875 .54936 -9.6875 -7.875 ]
[.4875 .54936 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .13734 m
.50625 .13734 L
s
gsave
.4875 .13734 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .27468 m
.50625 .27468 L
s
gsave
.4875 .27468 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .41202 m
.50625 .41202 L
s
gsave
.4875 .41202 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .54936 m
.50625 .54936 L
s
gsave
.4875 .54936 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .03434 m
.50375 .03434 L
s
.5 .06867 m
.50375 .06867 L
s
.5 .10301 m
.50375 .10301 L
s
.5 .17168 m
.50375 .17168 L
s
.5 .20601 m
.50375 .20601 L
s
.5 .24035 m
.50375 .24035 L
s
.5 .30902 m
.50375 .30902 L
s
.5 .34335 m
.50375 .34335 L
s
.5 .37769 m
.50375 .37769 L
s
.5 .44636 m
.50375 .44636 L
s
.5 .48069 m
.50375 .48069 L
s
.5 .51503 m
.50375 .51503 L
s
.5 .5837 m
.50375 .5837 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
[ .01 ] 0 setdash
.02381 .2805 m
.04262 .28114 L
.06244 .28198 L
.08255 .28305 L
.10458 .2846 L
.12415 .28644 L
.14509 .28905 L
.16639 .29261 L
.18653 .29698 L
.22495 .3082 L
.24439 .31497 L
.26581 .3224 L
.2756 .32546 L
.28613 .32829 L
.29123 .32942 L
.29607 .33033 L
.30042 .33097 L
.30289 .33127 L
.30517 .33148 L
.30772 .33167 L
.30906 .33174 L
.30974 .33176 L
.31048 .33179 L
.31171 .33181 L
.31286 .33182 L
.31357 .33182 L
.31423 .33182 L
.31548 .33179 L
.31661 .33175 L
.31781 .33169 L
.31883 .33163 L
.31996 .33154 L
.32248 .33129 L
.32484 .33099 L
.3301 .33002 L
.33493 .3288 L
.34023 .32706 L
.34581 .32477 L
.35536 .31972 L
.36555 .31275 L
.38392 .29628 L
.42542 .24674 L
.44622 .22169 L
.45535 .21207 L
.4654 .203 L
.47505 .19612 L
.47969 .19354 L
.48408 .19155 L
.48647 .19067 L
.48907 .18986 L
Mistroke
.49146 .18927 L
.49362 .18886 L
.49495 .18867 L
.4962 .18853 L
.49751 .18842 L
.49825 .18838 L
.49894 .18836 L
.50008 .18834 L
.50133 .18837 L
.50264 .18843 L
.50387 .18853 L
.50513 .18868 L
.50648 .18888 L
.50889 .18935 L
.51148 .19002 L
.51434 .19095 L
.51946 .19312 L
.52426 .19571 L
.5332 .20188 L
.54283 .2103 L
.58402 .25869 L
.60458 .28377 L
.62369 .30368 L
.64216 .31817 L
.65248 .32397 L
.66186 .3278 L
.66672 .32926 L
.67186 .33043 L
.67625 .33114 L
.67875 .33143 L
.68108 .33162 L
.68237 .3317 L
.68305 .33174 L
.68377 .33177 L
.6844 .33179 L
.6851 .33181 L
.68633 .33182 L
.68752 .33182 L
.6888 .33181 L
.69001 .33177 L
.69112 .33173 L
.69241 .33166 L
.69362 .33158 L
.69636 .33134 L
.69903 .33104 L
.70189 .33065 L
.71212 .3287 L
.72321 .32581 L
.74335 .31929 L
.78424 .3052 L
Mistroke
.80457 .29925 L
.82361 .29464 L
.84302 .29091 L
.86147 .28815 L
.88173 .28583 L
.90026 .28422 L
.92008 .2829 L
.93847 .28194 L
.97619 .2805 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`004@3oool2000000@0oooo0`00
000f0?ooo`<00000L`3oool3000003L0oooo0P0000040?ooo`<000005`3oool00180oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0d0?ooo`040000003oool0oooo00000780oooo
00@000000?ooo`3oool00000>03oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01H0oooo000B0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000003@0oooo00<000000?oo
o`3oool00P00001a0?ooo`030000003oool0oooo00800000=`3oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000F0?ooo`004P3oool01@000000oooo0?ooo`3oool000000080oooo0P00000h
0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0=@3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000F0?ooo`001`3oool7000000@0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02X0oooo1`0000040?ooo`800000M03oool2000003L0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01@0oooo000B0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0b0?ooo`040000003oool0oooo00000780
oooo00@000000?ooo`3oool00000>03oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0503oool00180oooo00D000000?ooo`3oool0oooo000000020?ooo`800000=03oool4
00000780oooo1000000h0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001H0oooo000B
0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000003@0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0i0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001H0oooo
000A0?ooo`8000000`3oool2000000030?ooo`000000oooo03@0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0h0?ooo`8000000`3oool2000000030?ooo`000000oooo01H0oooo000B
0?ooo`030000003oool0oooo0080oooo0`00000e0?ooo`<00000L`3oool3000003T0oooo00<00000
0?ooo`3oool00P3oool3000001L0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?oooa@0oooo
0P00000;0?ooo`00o`3ooolC0?ooo`040000003oool0oooo000000X0oooo003o0?oooa<0oooo00@0
00000?ooo`3oool000002P3oool000X0ooooo`000002000000L0oooo00D000000?ooo`3oool0oooo
000000090?ooo`00403oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo03X0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00/0oooo1@00
00090?ooo`00RP3oool00`000000oooo0?ooo`260?ooo`040000003oool0oooo000000T0oooo002:
0?ooo`030000003oool0oooo08H0oooo00@000000?ooo`3oool000002@3oool008X0oooo00<00000
0?ooo`3oool0Q`3oool3000000T0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`03
0000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03o
ool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0
oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?oo
o`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000
003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo00220?ooo`8000001P3oool00`000000
oooo0?ooo`2C0?ooo`00P03oool3000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0
T`3oool00800oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`2C0?ooo`00P03oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo09<0oooo00210?ooo`8000001`3oool30000
09<0oooo00230?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008<0oooo
0P0000050?ooo`030000003oool0oooo09<0oooo00200?ooo`050000003oool0oooo0?ooo`000000
1@3oool00`000000oooo0?ooo`2C0?ooo`00P03oool00`000000oooo0?ooo`02000000D0oooo00<0
00000?ooo`3oool0T`3oool00840oooo0`0000060?ooo`030000003oool0oooo09<0oooo002:0?oo
o`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000
U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008L0oooo
2000002A0?ooo`00Q@3oool2000000<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`2=0?ooo`00P`3oool2000000D0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2=
0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00@0oooo0P00002=0?oo
o`00P03oool00`000000oooo0?ooo`070?ooo`800000203oool00`000000oooo0?ooo`290?ooo`00
O`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0
R03oool008X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`270?ooo`00O@3oool0
0`000000oooo0?ooo`0:0?ooo`030000003oool0oooo09<0oooo001l0?ooo`030000003oool0oooo
00/0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`260?ooo`00O03oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0Q@3oool008X0oooo
00<000000?ooo`3oool0303oool00`000000oooo0?ooo`240?ooo`00NP3oool00`000000oooo0?oo
o`0=0?ooo`030000003oool0oooo09<0oooo001i0?ooo`030000003oool0oooo00h0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`220?ooo`00N@3oool00`000000oooo0?ooo`0>0?oo
o`8000003`3oool00`000000oooo0?ooo`220?ooo`00RP3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo0840oooo001g0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
T`3oool007H0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0A0?ooo`030000003o
ool0oooo07l0oooo001e0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`1o0?ooo`00PP3oool2000000H0oooo00<000000?ooo`3oool04P3oool20000
07l0oooo001d0?ooo`030000003oool0oooo00/0oooo0P0000060?ooo`030000003oool0oooo09<0
oooo001b0?ooo`8000003P3oool2000000H0oooo00<000000?ooo`3oool0503oool00`000000oooo
0?ooo`1l0?ooo`00P03oool4000000H0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?oo
o`1k0?ooo`00L03oool00`000000oooo0?ooo`0=0?ooo`040000003oool00000000000H0oooo0`00
000F0?ooo`030000003oool0oooo07X0oooo000@0?ooo`80000000<0oooo0000000000000P00001H
0?ooo`030000003oool0oooo00l0oooo0`0000060?ooo`030000003oool0oooo0780oooo0`00000N
0?ooo`00603oool4000000030?ooo`0000000000008000000P3oool3000004T0oooo00<000000?oo
o`3oool03`3oool3000000H0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`150?oo
o`030000003oool0oooo00<000000P3oool300000080oooo0`00000S0?ooo`00:03oool300000080
oooo0`00001B0?ooo`8000001P3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo03d0
oooo10000000103oool0000000000000000c0?ooo`00<P3oool3000003P0oooo00<000000?ooo`3o
ool04P3oool2000000H0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0g0?ooo`@0
0000?03oool003L0oooo0`00000b0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`1>0?ooo`@00000@@3oool003`0oooo00<000000?ooo`3oool0;03o
ool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0:`3o
ool4000004H0oooo000m0?ooo`8000000P3oool00`000000oooo0?ooo`160?ooo`030000003oool0
oooo01`0oooo0P00000Y0?ooo`030000003oool0oooo04T0oooo00120?ooo`8000009@3oool00`00
0000oooo0?ooo`0N0?ooo`030000003oool0oooo04<0oooo00@000000?ooo`0000000000C03oool0
04H0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0O0?ooo`800000803oool00`00
0000oooo0?ooo`0O0?ooo`800000D03oool004L0oooo0P00000N0?ooo`030000003oool0oooo0200
oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0580
oooo001:0?ooo`@000005`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0240oooo
00<000000?ooo`3oool0603oool2000005D0oooo001?0?ooo`030000003oool0oooo0140oooo0P00
000U0?ooo`030000003oool0oooo02<0oooo0P00000D0?ooo`030000003oool0oooo05L0oooo001@
0?ooo`<000003P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo02D0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`02000005X0oooo001D0?ooo`@0000000<0oooo0000
000000000P000000103oool0000000000000000Y0?ooo`030000003oool0oooo02P0oooo0`000002
0?ooo`<000000P3oool2000005l0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`03
0000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3o
ool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0
oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?oo
o`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00P@3oool3000000H0oooo00<000000?ooo`3oool0T`3oool00800oooo
0P0000000`3oool000000?ooo`050?ooo`030000003oool0oooo09<0oooo00200?ooo`030000003o
ool0oooo008000001@3oool00`000000oooo0?ooo`2C0?ooo`00P03oool01@000000oooo0?ooo`3o
ool0000000D0oooo00<000000?ooo`3oool0T`3oool00800oooo00<000000?ooo`3oool00P000005
0?ooo`<00000T`3oool00800oooo0P0000000`3oool000000?ooo`050?ooo`030000003oool0oooo
09<0oooo00200?ooo`030000003oool0000000L0oooo00<000000?ooo`3oool0T`3oool00800oooo
00@000000?ooo`3oool000001P3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo
000000060?ooo`030000003oool0oooo09<0oooo00210?ooo`<000001P3oool00`000000oooo0?oo
o`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?oo
o`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003o
ool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo
09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0
T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo
00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool3
000000H0oooo00<000000?ooo`3oool0T`3oool00800oooo00<000000?ooo`3oool00P0000050?oo
o`030000003oool0oooo09<0oooo00200?ooo`050000003oool0oooo0?ooo`0000001@3oool00`00
0000oooo0?ooo`2C0?ooo`00P03oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?oo
o`3oool0T`3oool00800oooo00<000000?ooo`3oool00P0000050?ooo`<00000T`3oool00840oooo
0`0000060?ooo`030000003oool0oooo09<0oooo00200?ooo`80000000<0oooo0000003oool01@3o
ool00`000000oooo0?ooo`2C0?ooo`00P03oool00`000000oooo0?ooo`02000000D0oooo00<00000
0?ooo`3oool0T`3oool00800oooo0P0000000`3oool000000?ooo`050?ooo`030000003oool0oooo
09<0oooo00210?ooo`<000001P3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000
003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0
oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo0000
\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.3759, -1.07928, \
0.0821481, 0.0569651}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 -2.08167e-017 0.0686704 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .13734 -9.6875 -7.875 ]
[.4875 .13734 0 7.875 ]
[.4875 .27468 -9.6875 -7.875 ]
[.4875 .27468 0 7.875 ]
[.4875 .41202 -9.6875 -7.875 ]
[.4875 .41202 0 7.875 ]
[.4875 .54936 -9.6875 -7.875 ]
[.4875 .54936 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .13734 m
.50625 .13734 L
s
gsave
.4875 .13734 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .27468 m
.50625 .27468 L
s
gsave
.4875 .27468 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .41202 m
.50625 .41202 L
s
gsave
.4875 .41202 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .54936 m
.50625 .54936 L
s
gsave
.4875 .54936 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .03434 m
.50375 .03434 L
s
.5 .06867 m
.50375 .06867 L
s
.5 .10301 m
.50375 .10301 L
s
.5 .17168 m
.50375 .17168 L
s
.5 .20601 m
.50375 .20601 L
s
.5 .24035 m
.50375 .24035 L
s
.5 .30902 m
.50375 .30902 L
s
.5 .34335 m
.50375 .34335 L
s
.5 .37769 m
.50375 .37769 L
s
.5 .44636 m
.50375 .44636 L
s
.5 .48069 m
.50375 .48069 L
s
.5 .51503 m
.50375 .51503 L
s
.5 .5837 m
.50375 .5837 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
[ .03 ] 0 setdash
.02381 .30912 m
.04262 .31436 L
.06244 .32164 L
.08255 .33152 L
.10458 .34617 L
.12415 .36335 L
.14509 .38674 L
.18653 .44806 L
.22646 .51633 L
.24474 .54392 L
.25514 .55677 L
.26022 .56205 L
.26488 .56621 L
.26945 .56962 L
.27443 .57253 L
.27717 .57373 L
.2797 .57459 L
.28095 .57492 L
.28213 .57518 L
.28278 .5753 L
.28349 .5754 L
.28471 .57554 L
.28603 .57562 L
.28725 .57563 L
.28796 .5756 L
.2886 .57556 L
.28934 .5755 L
.29004 .57541 L
.29144 .57517 L
.29274 .57487 L
.29567 .57393 L
.29799 .5729 L
.30055 .57148 L
.30574 .56768 L
.31066 .5629 L
.31584 .55662 L
.32509 .5422 L
.33505 .52218 L
.34595 .49523 L
.38651 .35907 L
.42555 .21061 L
.44547 .14569 L
.45595 .11749 L
.46705 .09325 L
.47696 .07707 L
.48259 .07032 L
.48529 .06773 L
.48785 .06567 L
.49017 .06415 L
.49269 .06285 L
Mistroke
.49379 .0624 L
.49498 .062 L
.49608 .0617 L
.4971 .06149 L
.49839 .06132 L
.49907 .06126 L
.49979 .06124 L
.50099 .06127 L
.50231 .0614 L
.50349 .06161 L
.50476 .06192 L
.50595 .0623 L
.50703 .06273 L
.50933 .06385 L
.51186 .06546 L
.51697 .06987 L
.52171 .07531 L
.52616 .08157 L
.53616 .09963 L
.54693 .12476 L
.58812 .26116 L
.6278 .41203 L
.64781 .47758 L
.66596 .52443 L
.67607 .54424 L
.68561 .5585 L
.69085 .56449 L
.69568 .56884 L
.70097 .57237 L
.70364 .57365 L
.70516 .57424 L
.70657 .57469 L
.70776 .575 L
.70908 .57527 L
.7104 .57547 L
.71112 .57554 L
.7118 .57559 L
.71305 .57563 L
.71419 .57561 L
.71544 .57553 L
.71676 .57537 L
.71787 .57518 L
.71906 .57492 L
.7212 .57431 L
.72375 .57336 L
.72606 .57228 L
.73122 .56917 L
.73681 .56478 L
.74697 .55438 L
.76682 .52705 L
Mistroke
.78785 .49215 L
.82571 .42814 L
.84676 .3973 L
.86601 .37367 L
.88614 .35379 L
.90481 .33938 L
.92381 .32808 L
.94453 .31883 L
.96114 .3132 L
.97619 .30912 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`004@3oool2000000@0oooo0`00
000f0?ooo`<00000L`3oool3000003L0oooo0P0000040?ooo`<000005`3oool00180oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0d0?ooo`040000003oool0oooo00000780oooo
00@000000?ooo`3oool00000>03oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01H0oooo000B0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000003@0oooo00<000000?oo
o`3oool00P00001a0?ooo`030000003oool0oooo00800000=`3oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000F0?ooo`004P3oool01@000000oooo0?ooo`3oool000000080oooo0P00000h
0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0=@3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000F0?ooo`001`3oool7000000@0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02X0oooo1`0000040?ooo`800000M03oool2000003L0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01@0oooo000B0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0b0?ooo`040000003oool0oooo00000780
oooo00@000000?ooo`3oool00000>03oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0503oool00180oooo00D000000?ooo`3oool0oooo000000020?ooo`800000=03oool4
00000780oooo1000000h0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001H0oooo000B
0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000003@0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0i0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001H0oooo
000A0?ooo`8000000`3oool2000000030?ooo`000000oooo03@0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0h0?ooo`8000000`3oool2000000030?ooo`000000oooo01H0oooo000B
0?ooo`030000003oool0oooo0080oooo0`00000e0?ooo`<00000L`3oool3000003T0oooo00<00000
0?ooo`3oool00P3oool3000001L0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?oooa@0oooo
0P00000;0?ooo`00o`3ooolC0?ooo`040000003oool0oooo000000X0oooo003o0?oooa<0oooo00@0
00000?ooo`3oool000002P3oool000X0ooooo`000002000000L0oooo00D000000?ooo`3oool0oooo
000000090?ooo`00403oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo03X0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00/0oooo1@00
00090?ooo`00RP3oool00`000000oooo0?ooo`260?ooo`040000003oool0oooo000000T0oooo002:
0?ooo`030000003oool0oooo08H0oooo00@000000?ooo`3oool000002@3oool008X0oooo00<00000
0?ooo`3oool0Q`3oool3000000T0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`03
0000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03o
ool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0
oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0`00002C0?oo
o`00RP3oool010000000oooo00000000002B0?ooo`00RP3oool200000080oooo00<000000?ooo`3o
ool0S`3oool008D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo08h0oooo00240?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`2=0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0S03oool008<0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`2C0?ooo`00PP3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09<0
oooo00220?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0T`3oool00840oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0?ooo`290?ooo`00RP3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo08T0oooo002:0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0R03o
ool008X0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`280?ooo`00PP3oool20000
00H0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`270?ooo`00OP3oool00`000000
oooo00000002000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`270?ooo`00OP3oool00`000000oooo000000090?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0QP3oool007d0oooo00@000000?ooo`3oool000002@3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo08H0oooo001m0?ooo`040000003oool0oooo0?ooo`800000
1`3oool3000009<0oooo001l0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`2C0?ooo`00O03oool00`000000oooo0?ooo`040?ooo`8000001@3oool0
0`000000oooo0?ooo`2C0?ooo`00N`3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo
0?ooo`0000001@3oool00`000000oooo0?ooo`2C0?ooo`00N`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo008000001@3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool3000000H0
oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<0
00000?ooo`3oool0303oool00`000000oooo0?ooo`240?ooo`00RP3oool2000000d0oooo00<00000
0?ooo`3oool0Q03oool008X0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`230?oo
o`00RP3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo08<0oooo001i0?ooo`030000
003oool0oooo00h0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`230?ooo`00N@3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0P`3o
ool007P0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0
oooo0880oooo001h0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool03P3oool00`00
0000oooo0?ooo`220?ooo`00N03oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo09<0
oooo001h0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0T`3oool007L0oooo00<0
00000?ooo`3oool0403oool2000009@0oooo001g0?ooo`030000003oool0oooo0100oooo00<00000
0?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`200?ooo`00RP3o
ool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0800oooo002:0?ooo`030000003oool0
oooo0140oooo00<000000?ooo`3oool0O`3oool008X0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`1o0?ooo`00RP3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo07l0
oooo001e0?ooo`030000003oool0oooo0180oooo0P00000C0?ooo`030000003oool0oooo07h0oooo
001e0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`1n0?ooo`00M03oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01<0oooo00<00000
0?ooo`3oool0O@3oool007@0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo07d0oooo001d0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3o
ool0T`3oool007@0oooo00<000000?ooo`3oool02`3oool2000000H0oooo00<000000?ooo`3oool0
T`3oool007<0oooo00<000000?ooo`3oool0303oool2000000H0oooo00<000000?ooo`3oool0T`3o
ool007<0oooo00<000000?ooo`3oool0303oool2000000H0oooo00<000000?ooo`3oool0T`3oool0
0800oooo100000060?ooo`030000003oool0oooo09<0oooo00200?ooo`040000003oool000000000
00H0oooo0`00002C0?ooo`00P@3oool3000000H0oooo00<000000?ooo`3oool05@3oool00`000000
oooo0?ooo`1k0?ooo`00P@3oool3000000H0oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`1k0?ooo`00PP3oool2000000H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?oo
o`1j0?ooo`00PP3oool2000000H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1j
0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01H0oooo00<000000?oo
o`3oool0NP3oool00740oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0F0?ooo`03
0000003oool0oooo07X0oooo001a0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0
5`3oool00`000000oooo0?ooo`1i0?ooo`00L03oool00`000000oooo0?ooo`0G0?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool0N@3oool00180oooo0P00001L0?ooo`030000003oool0
oooo01L0oooo0P00001h0?ooo`030000003oool0oooo01T0oooo000D0?ooo`<00000F@3oool00`00
0000oooo0?ooo`0G0?ooo`030000003oool0oooo09<0oooo000G0?ooo`<00000EP3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo06h0oooo0P00000S0?ooo`00K`3oool00`000000oooo
0?ooo`0H0?ooo`030000003oool0oooo06/0oooo0`00000U0?ooo`00K`3oool00`000000oooo0?oo
o`0H0?ooo`030000003oool0oooo06T0oooo0P00000X0?ooo`00RP3oool00`000000oooo0?ooo`1X
0?ooo`030000003oool0oooo02P0oooo000P0?ooo`030000003oool0oooo06L0oooo00<000000?oo
o`3oool0T`3oool00240oooo0P00001W0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3o
ool0M`3oool002<0oooo0P00001U0?ooo`8000006P3oool00`000000oooo0?ooo`1g0?ooo`009@3o
ool00`000000oooo0?ooo`1R0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0A@3o
ool00`000000oooo0?ooo`0^0?ooo`009P3oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0
oooo01X0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0_0?ooo`00RP3oool00`00
0000oooo0?ooo`0J0?ooo`030000003oool0oooo04<0oooo00<000000?ooo`3oool0<03oool006d0
oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0480
oooo00<000000?ooo`3oool0<@3oool006d0oooo00<000000?ooo`3oool06P3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo03l0oooo0P00000d0?ooo`00K03oool00`000000oooo0?oo
o`0K0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?oo
o`0d0?ooo`00K03oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo09<0oooo000/0?oo
o`030000003oool0oooo03d0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`2C0?oo
o`00;@3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo01/0oooo0P00002D0?ooo`00
;P3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0
T`3oool002l0oooo00<000000?ooo`3oool0>@3oool00`000000oooo0?ooo`0L0?ooo`030000003o
ool0oooo09<0oooo000`0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3oool0E`3oool0
0`000000oooo0?ooo`0i0?ooo`00<03oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo
05H0oooo00<000000?ooo`3oool0>P3oool00340oooo00<000000?ooo`3oool0C@3oool3000000H0
oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03X0
oooo00200?ooo`80000000<0oooo0000003oool01@3oool00`000000oooo0?ooo`0M0?ooo`030000
003oool0oooo03D0oooo00<000000?ooo`3oool0>`3oool00800oooo00<000000?ooo`3oool00P00
00050?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?oo
o`0l0?ooo`00P03oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool07P3o
ool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo03`0oooo001Y0?ooo`030000003oool0
oooo01@0oooo00<000000?ooo`3oool00P0000050?ooo`<000007P3oool00`000000oooo0?ooo`0b
0?ooo`030000003oool0oooo03d0oooo001Y0?ooo`030000003oool0oooo01@0oooo0P0000000`3o
ool000000?ooo`050?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0LP3oool003D0
oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0E0?ooo`030000003oool0000000L0
oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1a0?ooo`00=P3oool00`000000oooo
0?ooo`0_0?ooo`030000003oool0oooo01D0oooo00@000000?ooo`3oool000001P3oool00`000000
oooo0?ooo`0O0?ooo`030000003oool0oooo0740oooo000f0?ooo`030000003oool0oooo02l0oooo
00<000000?ooo`3oool05P3oool00`000000oooo000000060?ooo`030000003oool0oooo09<0oooo
000g0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool05P3oool3000000H0oooo00<0
00000?ooo`3oool0T`3oool003P0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0P
0?ooo`030000003oool0oooo09<0oooo000h0?ooo`030000003oool0oooo02`0oooo00<000000?oo
o`3oool0803oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo0440oooo000i0?ooo`03
0000003oool0oooo02/0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1>0?ooo`03
0000003oool0oooo0480oooo002:0?ooo`800000C`3oool00`000000oooo0?ooo`120?ooo`00RP3o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0@`3o
ool008X0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0
oooo04@0oooo002:0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool09`3oool00`00
0000oooo0?ooo`140?ooo`00RP3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo02H0
oooo00<000000?ooo`3oool0A@3oool008X0oooo00<000000?ooo`3oool08P3oool00`000000oooo
0?ooo`1^0?ooo`00?@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo02<0oooo00<0
00000?ooo`3oool08P3oool00`000000oooo0?ooo`1^0?ooo`00?P3oool00`000000oooo0?ooo`0S
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1]
0?ooo`00?P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo02<0oooo0P00000T0?oo
o`030000003oool0oooo06d0oooo000o0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3o
ool0903oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo06d0oooo000o0?ooo`030000
003oool0oooo0240oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`2C0?ooo`00@03o
ool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0A`3o
ool00`000000oooo0?ooo`190?ooo`00@03oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo02@0oooo00<000000?ooo`3oool0AP3oool00`000000oooo0?ooo`1:0?ooo`00@@3oool00`00
0000oooo0?ooo`0N0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0AP3oool00`00
0000oooo0?ooo`1:0?ooo`00RP3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo04/0
oooo002:0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0B`3oool008X0oooo00<0
00000?ooo`3oool09P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo04`0oooo002:
0?ooo`8000009`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo04`0oooo002:0?oo
o`030000003oool0oooo02H0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`1=0?oo
o`00A@3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3o
ool0J@3oool004H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0X0?ooo`030000
003oool0oooo02L0oooo00<000000?ooo`3oool0J@3oool004H0oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0J03o
ool004L0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0P0?ooo`<000001P3oool0
0`000000oooo0?ooo`0X0?ooo`030000003oool0oooo06P0oooo00180?ooo`030000003oool0oooo
0180oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`02000000D0oooo00<000000?oo
o`3oool0:@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0540oooo00180?ooo`03
0000003oool0oooo0180oooo00<000000?ooo`3oool0803oool01@000000oooo0?ooo`3oool00000
00D0oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1B0?ooo`00B@3oool00`000000
oooo0?ooo`0@0?ooo`030000003oool0oooo0240oooo00D000000?ooo`3oool0oooo000000050?oo
o`030000003oool0oooo03d0oooo00<000000?ooo`3oool0D`3oool005`0oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`02000000D0oooo0`00000m0?ooo`030000003oool0oooo05<0
oooo001K0?ooo`030000003oool0oooo02<0oooo0`0000060?ooo`030000003oool0oooo03`0oooo
00<000000?ooo`3oool0E03oool00800oooo0P0000000`3oool000000?ooo`050?ooo`030000003o
ool0oooo03/0oooo00<000000?ooo`3oool0E@3oool00800oooo00<000000?ooo`3oool00P000005
0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`1F
0?ooo`00P03oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`3oool0;P3oool00`00
0000oooo0?ooo`1R0?ooo`00C`3oool00`000000oooo0?ooo`0_0?ooo`<000001P3oool00`000000
oooo0?ooo`0_0?ooo`030000003oool0oooo0640oooo001@0?ooo`<000000P3oool2000003<0oooo
00<000000?ooo`3oool0<03oool300000600oooo001B0?ooo`@00000=03oool00`000000oooo0?oo
o`0b0?ooo`<00000GP3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?oo
o`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.3759, -1.07928, \
0.0821481, 0.0569651}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 -2.08167e-017 0.0686704 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .13734 -9.6875 -7.875 ]
[.4875 .13734 0 7.875 ]
[.4875 .27468 -9.6875 -7.875 ]
[.4875 .27468 0 7.875 ]
[.4875 .41202 -9.6875 -7.875 ]
[.4875 .41202 0 7.875 ]
[.4875 .54936 -9.6875 -7.875 ]
[.4875 .54936 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .13734 m
.50625 .13734 L
s
gsave
.4875 .13734 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .27468 m
.50625 .27468 L
s
gsave
.4875 .27468 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .41202 m
.50625 .41202 L
s
gsave
.4875 .41202 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .54936 m
.50625 .54936 L
s
gsave
.4875 .54936 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .03434 m
.50375 .03434 L
s
.5 .06867 m
.50375 .06867 L
s
.5 .10301 m
.50375 .10301 L
s
.5 .17168 m
.50375 .17168 L
s
.5 .20601 m
.50375 .20601 L
s
.5 .24035 m
.50375 .24035 L
s
.5 .30902 m
.50375 .30902 L
s
.5 .34335 m
.50375 .34335 L
s
.5 .37769 m
.50375 .37769 L
s
.5 .44636 m
.50375 .44636 L
s
.5 .48069 m
.50375 .48069 L
s
.5 .51503 m
.50375 .51503 L
s
.5 .5837 m
.50375 .5837 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .29238 m
.04262 .29467 L
.06244 .29776 L
.08255 .30191 L
.10458 .30807 L
.12415 .31545 L
.14509 .32585 L
.16639 .33957 L
.18653 .3556 L
.22495 .39265 L
.24439 .41221 L
.25471 .42183 L
.26581 .43102 L
.27642 .43817 L
.28146 .44087 L
.28613 .4429 L
.2908 .44444 L
.29326 .44505 L
.29452 .4453 L
.29589 .44552 L
.29719 .44569 L
.29839 .4458 L
.29954 .44588 L
.30075 .44592 L
.30184 .44592 L
.30286 .44589 L
.30397 .44582 L
.30517 .44571 L
.30638 .44555 L
.30773 .44533 L
.31045 .44471 L
.31297 .44393 L
.31534 .44302 L
.32066 .44032 L
.32641 .43636 L
.3369 .42625 L
.34653 .41369 L
.36545 .38017 L
.38615 .33214 L
.42671 .22221 L
.44545 .17541 L
.45531 .15433 L
.46576 .13564 L
.47105 .12782 L
.47686 .1206 L
.48221 .1153 L
.4871 .11164 L
.48968 .11017 L
.49212 .10907 L
.49337 .10862 L
Mistroke
.4947 .10823 L
.49547 .10804 L
.49616 .1079 L
.49682 .10779 L
.49751 .10769 L
.49877 .10757 L
.49993 .10754 L
.50117 .10757 L
.50188 .10762 L
.50253 .10769 L
.50373 .10788 L
.50481 .10811 L
.50725 .10884 L
.50955 .10979 L
.51208 .11113 L
.51719 .1148 L
.52193 .11929 L
.52638 .12444 L
.53638 .13913 L
.54715 .15931 L
.58834 .26337 L
.60891 .31937 L
.62802 .36614 L
.64648 .40262 L
.65681 .4184 L
.66618 .42961 L
.67105 .43425 L
.67619 .43829 L
.68058 .44104 L
.6854 .44333 L
.68812 .44429 L
.69059 .44497 L
.69196 .44527 L
.69345 .44553 L
.69414 .44562 L
.69486 .44571 L
.69616 .44583 L
.69735 .4459 L
.69863 .44592 L
.69983 .4459 L
.70094 .44585 L
.70217 .44576 L
.70286 .44568 L
.70351 .4456 L
.70622 .44515 L
.70884 .44454 L
.71125 .44383 L
.71672 .44171 L
.72665 .43629 L
.74523 .42188 L
Mistroke
.7846 .38295 L
.82245 .34808 L
.84351 .33278 L
.86276 .32161 L
.88265 .31265 L
.90155 .30615 L
.92137 .301 L
.93977 .29738 L
.95887 .29447 L
.97619 .29238 L
Mfstroke
[ .01 ] 0 setdash
.02381 .2805 m
.04262 .28114 L
.06244 .28198 L
.08255 .28305 L
.10458 .2846 L
.12415 .28644 L
.14509 .28905 L
.16639 .29261 L
.18653 .29698 L
.22495 .3082 L
.24439 .31497 L
.26581 .3224 L
.2756 .32546 L
.28613 .32829 L
.29123 .32942 L
.29607 .33033 L
.30042 .33097 L
.30289 .33127 L
.30517 .33148 L
.30772 .33167 L
.30906 .33174 L
.30974 .33176 L
.31048 .33179 L
.31171 .33181 L
.31286 .33182 L
.31357 .33182 L
.31423 .33182 L
.31548 .33179 L
.31661 .33175 L
.31781 .33169 L
.31883 .33163 L
.31996 .33154 L
.32248 .33129 L
.32484 .33099 L
.3301 .33002 L
.33493 .3288 L
.34023 .32706 L
.34581 .32477 L
.35536 .31972 L
.36555 .31275 L
.38392 .29628 L
.42542 .24674 L
.44622 .22169 L
.45535 .21207 L
.4654 .203 L
.47505 .19612 L
.47969 .19354 L
.48408 .19155 L
.48647 .19067 L
.48907 .18986 L
Mistroke
.49146 .18927 L
.49362 .18886 L
.49495 .18867 L
.4962 .18853 L
.49751 .18842 L
.49825 .18838 L
.49894 .18836 L
.50008 .18834 L
.50133 .18837 L
.50264 .18843 L
.50387 .18853 L
.50513 .18868 L
.50648 .18888 L
.50889 .18935 L
.51148 .19002 L
.51434 .19095 L
.51946 .19312 L
.52426 .19571 L
.5332 .20188 L
.54283 .2103 L
.58402 .25869 L
.60458 .28377 L
.62369 .30368 L
.64216 .31817 L
.65248 .32397 L
.66186 .3278 L
.66672 .32926 L
.67186 .33043 L
.67625 .33114 L
.67875 .33143 L
.68108 .33162 L
.68237 .3317 L
.68305 .33174 L
.68377 .33177 L
.6844 .33179 L
.6851 .33181 L
.68633 .33182 L
.68752 .33182 L
.6888 .33181 L
.69001 .33177 L
.69112 .33173 L
.69241 .33166 L
.69362 .33158 L
.69636 .33134 L
.69903 .33104 L
.70189 .33065 L
.71212 .3287 L
.72321 .32581 L
.74335 .31929 L
.78424 .3052 L
Mistroke
.80457 .29925 L
.82361 .29464 L
.84302 .29091 L
.86147 .28815 L
.88173 .28583 L
.90026 .28422 L
.92008 .2829 L
.93847 .28194 L
.97619 .2805 L
Mfstroke
[ .03 ] 0 setdash
.02381 .30912 m
.04262 .31436 L
.06244 .32164 L
.08255 .33152 L
.10458 .34617 L
.12415 .36335 L
.14509 .38674 L
.18653 .44806 L
.22646 .51633 L
.24474 .54392 L
.25514 .55677 L
.26022 .56205 L
.26488 .56621 L
.26945 .56962 L
.27443 .57253 L
.27717 .57373 L
.2797 .57459 L
.28095 .57492 L
.28213 .57518 L
.28278 .5753 L
.28349 .5754 L
.28471 .57554 L
.28603 .57562 L
.28725 .57563 L
.28796 .5756 L
.2886 .57556 L
.28934 .5755 L
.29004 .57541 L
.29144 .57517 L
.29274 .57487 L
.29567 .57393 L
.29799 .5729 L
.30055 .57148 L
.30574 .56768 L
.31066 .5629 L
.31584 .55662 L
.32509 .5422 L
.33505 .52218 L
.34595 .49523 L
.38651 .35907 L
.42555 .21061 L
.44547 .14569 L
.45595 .11749 L
.46705 .09325 L
.47696 .07707 L
.48259 .07032 L
.48529 .06773 L
.48785 .06567 L
.49017 .06415 L
.49269 .06285 L
Mistroke
.49379 .0624 L
.49498 .062 L
.49608 .0617 L
.4971 .06149 L
.49839 .06132 L
.49907 .06126 L
.49979 .06124 L
.50099 .06127 L
.50231 .0614 L
.50349 .06161 L
.50476 .06192 L
.50595 .0623 L
.50703 .06273 L
.50933 .06385 L
.51186 .06546 L
.51697 .06987 L
.52171 .07531 L
.52616 .08157 L
.53616 .09963 L
.54693 .12476 L
.58812 .26116 L
.6278 .41203 L
.64781 .47758 L
.66596 .52443 L
.67607 .54424 L
.68561 .5585 L
.69085 .56449 L
.69568 .56884 L
.70097 .57237 L
.70364 .57365 L
.70516 .57424 L
.70657 .57469 L
.70776 .575 L
.70908 .57527 L
.7104 .57547 L
.71112 .57554 L
.7118 .57559 L
.71305 .57563 L
.71419 .57561 L
.71544 .57553 L
.71676 .57537 L
.71787 .57518 L
.71906 .57492 L
.7212 .57431 L
.72375 .57336 L
.72606 .57228 L
.73122 .56917 L
.73681 .56478 L
.74697 .55438 L
.76682 .52705 L
Mistroke
.78785 .49215 L
.82571 .42814 L
.84676 .3973 L
.86601 .37367 L
.88614 .35379 L
.90481 .33938 L
.92381 .32808 L
.94453 .31883 L
.96114 .3132 L
.97619 .30912 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{44, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`004@3oool2000000@0oooo0`00
000f0?ooo`<00000L`3oool3000003L0oooo0P0000040?ooo`<000005`3oool00180oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0d0?ooo`040000003oool0oooo00000780oooo
00@000000?ooo`3oool00000>03oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01H0oooo000B0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000003@0oooo00<000000?oo
o`3oool00P00001a0?ooo`030000003oool0oooo00800000=`3oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000F0?ooo`004P3oool01@000000oooo0?ooo`3oool000000080oooo0P00000h
0?ooo`030000003oool0oooo07<0oooo00<000000?ooo`3oool0=@3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000F0?ooo`001`3oool7000000@0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02X0oooo1`0000040?ooo`800000M03oool2000003L0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01@0oooo000B0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0b0?ooo`040000003oool0oooo00000780
oooo00@000000?ooo`3oool00000>03oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0503oool00180oooo00D000000?ooo`3oool0oooo000000020?ooo`800000=03oool4
00000780oooo1000000h0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001H0oooo000B
0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000003@0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0i0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001H0oooo
000A0?ooo`8000000`3oool2000000030?ooo`000000oooo03@0oooo00<000000?ooo`3oool0L`3o
ool00`000000oooo0?ooo`0h0?ooo`8000000`3oool2000000030?ooo`000000oooo01H0oooo000B
0?ooo`030000003oool0oooo0080oooo0`00000e0?ooo`<00000L`3oool3000003T0oooo00<00000
0?ooo`3oool00P3oool3000001L0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?oooa@0oooo
0P00000;0?ooo`00o`3ooolC0?ooo`040000003oool0oooo000000X0oooo003o0?oooa<0oooo00@0
00000?ooo`3oool000002P3oool000X0ooooo`000002000000L0oooo00D000000?ooo`3oool0oooo
000000090?ooo`00403oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo03X0oooo00<0
00000?ooo`3oool0>P3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0oooo00/0oooo1@00
00090?ooo`00RP3oool00`000000oooo0?ooo`260?ooo`040000003oool0oooo000000T0oooo002:
0?ooo`030000003oool0oooo08H0oooo00@000000?ooo`3oool000002@3oool008X0oooo00<00000
0?ooo`3oool0Q`3oool3000000T0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`03
0000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03o
ool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0
oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0`00002C0?oo
o`00RP3oool010000000oooo00000000002B0?ooo`00RP3oool200000080oooo00<000000?ooo`3o
ool0S`3oool008D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo08h0oooo00240?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`2=0?ooo`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0S03oool008<0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`2C0?ooo`00PP3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09<0
oooo00220?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0T`3oool00840oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008P0oooo1@0000070?ooo`03
0000003oool0oooo08T0oooo00270?ooo`050000003oool0oooo0000003oool00P0000060?ooo`03
0000003oool0oooo08T0oooo00250?ooo`8000000`3oool01@000000oooo0?ooo`3oool0000000H0
oooo00<000000?ooo`3oool0R03oool008@0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`020?ooo`800000103oool00`000000oooo0?ooo`280?ooo`00PP3oool2000000H0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo08L0oooo001n
0?ooo`030000003oool0000000@000001@3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0Q`3oool007h0oooo00D000000?ooo`000000oooo00000007
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`26
0?ooo`00O@3oool00`000000oooo0?ooo`02000000P0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo08H0oooo001m0?ooo`040000003oool0oooo0?oo
o`8000001`3oool3000000H0oooo00<000000?ooo`3oool0RP3oool007`0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`290?ooo`00O03oool01@000000oooo0?ooo`3oool000000080oooo0P0000050?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool0R@3oool007/0oooo00@000000?ooo`3o
ool0oooo0P0000030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`280?ooo`00N`3oool010000000oooo0?ooo`3oool200000080oooo0P0000050?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool0R03oool007h0oooo00<000000?ooo`3o
ool00`0000060?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0Q`3oool007h0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo08L0oooo
001m0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0000
00260?ooo`00O@3oool00`000000oooo0?ooo`0:0?ooo`8000002`3oool00`000000oooo00000026
0?ooo`00O03oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo00<000000?oo
o`000000Q@3oool007`0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0;0?ooo`03
0000003oool0000008D0oooo001i0?ooo`030000003oool0000000h0oooo00<000000?ooo`3oool0
2`3oool00`000000oooo000000250?ooo`00N@3oool00`000000oooo0000000>0?ooo`030000003o
ool0oooo00`0oooo0P0000250?ooo`00N03oool00`000000oooo0000000<0?ooo`P000002P3oool0
0`000000oooo000000240?ooo`00N03oool00`000000oooo0000000:0?ooo`8000000`3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo00L0oooo0P0000240?ooo`00N03oool2000000T0
oooo0P0000050?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`230?ooo`00N03oool2000000L0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`040?ooo`8000001`3oool00`000000oooo0?ooo`230?ooo`00M`3oool00`000000oooo0000
00060?ooo`030000003oool0oooo00L0oooo0P0000080?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool0PP3oool007L0oooo0P0000060?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0880oooo001h0?oo
o`030000003oool0oooo00l0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo0840oooo001g0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0840oooo001g0?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0:0?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0P03oool007L0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`200?ooo`00MP3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo00`0oooo00@000000?ooo`3oool0oooo0P0000210?ooo`00MP3oool01@000000oooo0?ooo`3o
ool0000000l0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1o0?ooo`00MP3oool0
10000000oooo0?ooo`00000@0?ooo`030000003oool0oooo00h0oooo00@000000?ooo`3oool00000
P@3oool007D0oooo00D000000?ooo`3oool0oooo0000000@0?ooo`8000003`3oool01@000000oooo
0?ooo`3oool000000800oooo001e0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0
3`3oool010000000oooo0?ooo`0000200?ooo`00M03oool010000000oooo0?ooo`00000B0?ooo`03
0000003oool0oooo0180oooo0P00001o0?ooo`00M03oool00`000000oooo0000000C0?ooo`030000
003oool0oooo0140oooo00<000000?ooo`000000O`3oool007@0oooo0P00000D0?ooo`030000003o
ool0oooo0140oooo00<000000?ooo`000000O`3oool007<0oooo0P00000=0?ooo`8000001P3oool0
0`000000oooo0?ooo`0B0?ooo`<00000OP3oool007<0oooo0P00000=0?ooo`8000001P3oool00`00
0000oooo0?ooo`0D0?ooo`030000003oool0oooo07`0oooo001b0?ooo`8000003P3oool2000000H0
oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1l0?ooo`00LP3oool00`000000oooo
0?ooo`0;0?ooo`@000001P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo07/0oooo
001`0?ooo`030000003oool0000000d0oooo00@000000?ooo`00000000001P3oool3000001D0oooo
0P00001l0?ooo`00403oool2000000030?ooo`000000000000800000F03oool010000000oooo0?oo
o`00000>0?ooo`<000001P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo05X0oooo
0`00000N0?ooo`00603oool4000000030?ooo`0000000000008000000P3oool3000004T0oooo00<0
00000?ooo`0000003`3oool3000000H0oooo00<000000?ooo`3oool05@3oool2000000030?ooo`00
0000oooo04H0oooo00<000000?ooo`3oool00`0000020?ooo`<000000P3oool3000002<0oooo000X
0?ooo`<000000P3oool300000440oooo00<000000?ooo`3oool03P3oool2000000H0oooo00<00000
0?ooo`3oool05P3oool00`000000oooo0000000o0?ooo`@0000000@0oooo0000000000000000<`3o
ool00100oooo0`00000O0?ooo`<00000>03oool01@000000oooo0?ooo`3oool000000100oooo0P00
00060?ooo`030000003oool0oooo01H0oooo00@000000?ooo`3oool00000>@3oool4000001h0oooo
0`00000K0?ooo`004`3oool5000001l0oooo0`00000b0?ooo`050000003oool0oooo0?ooo`000000
4P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01H0oooo0P00000f0?ooo`@00000
7P3oool5000001h0oooo000H0?ooo`D000007`3oool00`000000oooo0?ooo`0/0?ooo`030000003o
ool0oooo0080oooo0P00000H0?ooo`030000003oool0oooo01H0oooo0P0000030?ooo`030000003o
ool0oooo02/0oooo1000000K0?ooo`P000008`3oool001d0oooo1@00000K0?ooo`8000000P3oool0
0`000000oooo0?ooo`0[0?ooo`030000003oool0000001P0oooo00<000000?ooo`3oool05`3oool2
000000<0oooo0P00000Y0?ooo`030000003oool0oooo01`0oooo0P00000[0?ooo`008P3oool50000
01/0oooo0P00000U0?ooo`030000003oool0oooo00<0oooo0P00000I0?ooo`030000003oool0oooo
01L0oooo0P00000Z0?ooo`040000003oool00000000001/0oooo1000000]0?ooo`004P3oool20000
01<0oooo0P00000M0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0103oool20000
01T0oooo0P00000I0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool07`3oool20000
01`0oooo0`00000E0?ooo`030000003oool0oooo01T0oooo000D0?ooo`<000004P3oool2000001`0
oooo0P00000N0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`0000006@3oool00`000000
oooo0?ooo`0I0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`0L0?ooo`800000=03oool001L0oooo0`00000A0?ooo`8000007@3oool4000001L0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0000000I0?ooo`030000003oool0oooo01T0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0H0?ooo`8000007@3oool200000140oooo
0P00000S0?ooo`00;@3oool200000200oooo00<000000?ooo`3oool04@3oool2000000T0oooo0P00
000J0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool01`3oool2000001@0oooo00<0
00000?ooo`3oool07P3oool00`000000oooo0?ooo`0>0?ooo`<000009@3oool002l0oooo00<00000
0?ooo`3oool07P3oool3000000h0oooo00<000000?ooo`3oool02@3oool00`000000oooo0000000J
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0<
0?ooo`030000003oool0oooo008000007`3oool2000000l0oooo0P00000X0?ooo`00<03oool20000
0280oooo100000000`3oool0000000000002000000040?ooo`0000000000000000`0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00/0oooo0`000002
0?ooo`<000000P3oool200000280oooo0P00000@0?ooo`030000003oool0oooo02P0oooo000P0?oo
o`030000003oool0oooo00l0oooo0P00000i0?ooo`030000003oool0oooo01X0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03/0oooo000Q0?ooo`80
00004@3oool2000003H0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0I0?ooo`03
0000003oool0000003L0oooo0P00000n0?ooo`008`3oool200000140oooo00<000000?ooo`3oool0
<`3oool00`000000oooo0?ooo`0K0?ooo`8000006P3oool00`000000oooo0000000e0?ooo`800000
@03oool002D0oooo00<000000?ooo`3oool03`3oool200000380oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`0J0?ooo`030000003oool000000380oooo0P00000A0?ooo`030000003o
ool0oooo02h0oooo000V0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0;`3oool0
0`000000oooo0?ooo`0L0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`000000<@3oool0
0`000000oooo0?ooo`0@0?ooo`030000003oool0oooo02l0oooo000j0?ooo`030000003oool0oooo
02h0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0J0?ooo`040000003oool0oooo
000002l0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0`0?ooo`00>`3oool00`00
0000oooo0?ooo`0/0?ooo`040000003oool0oooo000001`0oooo00<000000?ooo`3oool06P3oool0
10000000oooo0?ooo`00000^0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0<@3o
ool003`0oooo00<000000?ooo`3oool0:`3oool010000000oooo0?ooo`00000L0?ooo`030000003o
ool0oooo01/0oooo00@000000?ooo`3oool00000;03oool00`000000oooo0?ooo`0?0?ooo`800000
=03oool003d0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0000000M0?ooo`030000003o
ool0oooo01/0oooo00@000000?ooo`3oool00000:`3oool00`000000oooo0?ooo`0?0?ooo`030000
003oool0oooo03@0oooo000n0?ooo`030000003oool0oooo02P0oooo00@000000?ooo`3oool00000
7@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0
A`3oool002`0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0W0?ooo`040000003o
ool0oooo000001d0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0V0?ooo`030000
003oool0oooo04P0oooo000]0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool09@3o
ool01@000000oooo0?ooo`3oool0000001d0oooo0P00000P0?ooo`030000003oool0oooo02D0oooo
00<000000?ooo`3oool0B@3oool002h0oooo00<000000?ooo`3oool0403oool00`000000oooo0?oo
o`0T0?ooo`040000003oool0oooo000001h0oooo00<000000?ooo`3oool0803oool00`000000oooo
0?ooo`0S0?ooo`030000003oool0oooo04X0oooo000_0?ooo`030000003oool0oooo0100oooo00<0
00000?ooo`3oool08P3oool01@000000oooo0?ooo`3oool0000001h0oooo00<000000?ooo`3oool0
803oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo04/0oooo000`0?ooo`030000003o
ool0oooo0100oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0P0?ooo`030000003o
ool0oooo0240oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo03T0oooo000`0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool07`3oool0
0`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool07`3oool0
0`000000oooo0?ooo`0@0?ooo`030000003oool0oooo03X0oooo000a0?ooo`030000003oool0oooo
0140oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0I0?ooo`<000001P3oool00`00
0000oooo0?ooo`0M0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool07@3oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo03X0oooo00160?ooo`030000003oool0oooo01`0
oooo00<000000?ooo`3oool0603oool2000000030?ooo`000000oooo00D0oooo00<000000?ooo`3o
ool07@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3o
ool04@3oool00`000000oooo0?ooo`0k0?ooo`00A`3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo01T0oooo00<000000?ooo`3oool00P0000050?ooo`030000003oool0oooo01d0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0140oooo
00<000000?ooo`3oool0?03oool004P0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?oo
o`0I0?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`0N0?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0B0?ooo`030000
003oool0oooo03`0oooo00190?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo008000001@3oool3000001h0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo0180oooo00<0
00000?ooo`3oool0?@3oool004X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo01@0oooo0P0000000`3oool000000?ooo`050?ooo`030000003oool0
oooo01h0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0E0?ooo`030000003oool0
oooo05<0oooo000e0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo01D0oooo00<000000?ooo`0000001`3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`1D0?ooo`00=P3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0140
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0E0?ooo`040000003oool0oooo0000
00H0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0180oooo00<000000?ooo`3oool0E@3oool003H0oooo00<000000?ooo`3oool0503oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool05P3oool00`000000
oooo000000060?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool03`3oool2000005P0
oooo000g0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool03P3oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo01H0oooo0`0000060?ooo`030000003oool0oooo02P0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`1H0?ooo`00>03oool00`000000oooo0?oo
o`0D0?ooo`8000003@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0200oooo00<0
00000?ooo`3oool0:@3oool00`000000oooo0?ooo`0:0?ooo`800000F`3oool003P0oooo00<00000
0?ooo`3oool05P3oool2000000T0oooo0P0000090?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool0:P3oool2000000P0oooo0P00000I0?ooo`030000003oool0oooo0440oooo000i0?oo
o`030000003oool0oooo01L0oooo2@00000;0?ooo`030000003oool0oooo0200oooo00<000000?oo
o`3oool0;03oool8000001X0oooo00<000000?ooo`3oool0@P3oool008X0oooo0P00001?0?ooo`03
0000003oool0oooo0480oooo002:0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
:@3oool00`000000oooo0?ooo`130?ooo`00RP3oool00`000000oooo0?ooo`0Q0?ooo`030000003o
ool0oooo02P0oooo00<000000?ooo`3oool0A03oool008X0oooo00<000000?ooo`3oool08P3oool0
0`000000oooo0?ooo`0W0?ooo`030000003oool0oooo04@0oooo002:0?ooo`030000003oool0oooo
0280oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`150?ooo`00RP3oool00`000000
oooo0?ooo`0R0?ooo`030000003oool0oooo06h0oooo000m0?ooo`030000003oool0oooo02@0oooo
00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo06h0oooo
000n0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?oo
o`0S0?ooo`030000003oool0oooo06d0oooo000n0?ooo`030000003oool0oooo02<0oooo00<00000
0?ooo`3oool08`3oool2000002@0oooo00<000000?ooo`3oool0K@3oool003l0oooo00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo02<0oooo00<000000?oo
o`3oool0K@3oool003l0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo09<0oooo00100?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0
903oool00`000000oooo0?ooo`170?ooo`030000003oool0oooo04T0oooo00100?ooo`030000003o
ool0oooo0200oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`160?ooo`030000003o
ool0oooo04X0oooo00110?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool09@3oool0
0`000000oooo0?ooo`160?ooo`030000003oool0oooo04X0oooo002:0?ooo`030000003oool0oooo
04D0oooo00<000000?ooo`3oool0B`3oool008X0oooo00<000000?ooo`3oool0A@3oool00`000000
oooo0?ooo`1;0?ooo`00RP3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo01/0oooo
00<000000?ooo`3oool0C03oool008X0oooo0P00000W0?ooo`030000003oool0oooo01/0oooo00<0
00000?ooo`3oool0C03oool008X0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0J
0?ooo`030000003oool0oooo04d0oooo00150?ooo`030000003oool0oooo0480oooo00<000000?oo
o`3oool09`3oool00`000000oooo0?ooo`1Y0?ooo`00AP3oool00`000000oooo0?ooo`0F0?ooo`03
0000003oool0oooo02P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`1Y0?ooo`00
AP3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0
:03oool00`000000oooo0?ooo`1X0?ooo`00A`3oool00`000000oooo0?ooo`0D0?ooo`030000003o
ool0oooo0200oooo0`0000060?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0J03o
ool004P0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
oooo008000001@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo01<0oooo00<00000
0?ooo`3oool0D@3oool004P0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0P0?oo
o`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0
oooo0580oooo00190?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool08@3oool01@00
0000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0?@3oool00`000000oooo0?ooo`1C
0?ooo`00G03oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo008000001@3oool30000
03d0oooo00<000000?ooo`3oool0D`3oool005/0oooo00<000000?ooo`3oool08`3oool3000000H0
oooo00<000000?ooo`3oool0?03oool00`000000oooo0?ooo`1D0?ooo`00P03oool2000000030?oo
o`000000oooo00D0oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`1E0?ooo`00P03o
ool00`000000oooo0?ooo`02000000D0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo05H0oooo00200?ooo`80000000<0oooo0000003oool01@3oool0
0`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0680oooo001?0?ooo`030000003oool0oooo
02l0oooo0`0000060?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0H@3oool00500
oooo0`0000020?ooo`800000<`3oool00`000000oooo0?ooo`0`0?ooo`<00000H03oool00580oooo
1000000d0?ooo`030000003oool0oooo0380oooo0`00001N0?ooo`00RP3oool00`000000oooo0?oo
o`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`03
0000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003o
ool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo
09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo
0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.3759, -1.07928, \
0.0821481, 0.0569651}}]
}, Open  ]],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    StyleBox[\(\(Here\ is\ the\ Exact\ Bias\ Squared\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[""], "Input"],

Cell[CellGroupData[{

Cell[BoxData[""], "Input"],

Cell[BoxData[
    \(Bias\ Exact\ Here\ is\ Squared\ the ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\( (*\ sig\  = \ 2, \ k\  = \ 3/4\ *) \), "\[IndentingNewLine]", 
      RowBox[{\(pl1 = 
          Plot[\[IndentingNewLine]\((th\ \  - \ 
                  NIntegrate[\ \ 1/2 \((\ 
                        d\  - \ 
                          Sqrt[d^2\  - \ 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ phi[
                        d, \ th, \ 
                        2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ 3/4\  - 1]}]\  - \[IndentingNewLine]\ 
                  NIntegrate[\ 
                    1/2 \((\ 
                        d\  + \ 
                          Sqrt[d^2\  - 4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ \ phi[
                        d, \ th, \ 
                        2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                      Infinity}])\)^2, \[IndentingNewLine]{th, \(-10\), 
              10}, \ PlotRange\  \[Rule] \ {0, \ 2}, \ 
            AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
            DefaultFont\  \[Rule] \ {"\<Times\>", 12}]\), 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", \( (*\ sig\  = \ 2, \ k\  = \ 0.6\ *) \), 
        "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"pl2", "=", 
            RowBox[{"Plot", "[", "\[IndentingNewLine]", 
              
              RowBox[{\(\((th\ \  - \ 
                      NIntegrate[\ \ 1/2 \((\ 
                            d\  - \ 
                              Sqrt[d^2\  - \ 
                                  4\ \ 2^2\ \((2\ \ 0.6 - 1)\)])\)\ phi[d, \ 
                            th, \ 2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ \ 0.6\  - 1]}]\  - \[IndentingNewLine]\ 
                      NIntegrate[\ 
                        1/2 \((\ 
                            d\  + \ 
                              Sqrt[d^2\  - 
                                  4\ \ 2^2\ \((2\ \ 0.6 - 1)\)])\)\ \ phi[
                            d, \ th, \ 
                            2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[
                              2\ \ \ 0.6 - 1], \ Infinity}])\)^2\), ",", 
                "\[IndentingNewLine]", \({th, \(-10\), 10}\), ",", " ", 
                StyleBox[\(PlotRange\  \[Rule] \ {0, 2}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(AxesLabel\  \[Rule] \ {\[Theta], \ None}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(DefaultFont\  \[Rule] \ {"\<Roman\>", 12}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox["\[IndentingNewLine]",
                  "Text"], 
                
                StyleBox[\(PlotStyle \[Rule] {GrayLevel[0], 
                      Dashing[{ .01}]}\),
                  "Text"]}], 
              StyleBox["]",
                "Text"]}]}], 
          StyleBox[";",
            "Text"]}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", \( (*\ sig\  = \ 2, \ k\  = \ 0.9\ *) \), 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        RowBox[{
          RowBox[{
            StyleBox["pl3",
              "Text"], 
            StyleBox["=",
              "Text"], 
            RowBox[{"Plot", "[", "\[IndentingNewLine]", 
              
              RowBox[{\(\((th\ \  - \ 
                      NIntegrate[\ \ 1/2 \((\ 
                            d\  - \ 
                              Sqrt[d^2\  - \ 
                                  4\ \ 2^2\ \((2\ \ 0.9 - 1)\)])\)\ phi[d, \ 
                            th, \ 2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ \ 0.9\  - 1]}]\  - \[IndentingNewLine]\ 
                      NIntegrate[\ 
                        1/2 \((\ 
                            d\  + \ 
                              Sqrt[d^2\  - 
                                  4\ \ 2^2\ \((2\ \ 0.9 - 1)\)])\)\ \ phi[
                            d, \ th, \ 
                            2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[
                              2\ \ 0.9\  - 1], \ Infinity}])\)^2\), ",", 
                "\[IndentingNewLine]", \({th, \(-10\), 10}\), ",", 
                " ", \(PlotRange\  \[Rule] \ {0, \ 2}\), ",", 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(AxesLabel\  \[Rule] \ {\[Theta], \ None}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(DefaultFont\  \[Rule] \ {"\<Roman\>", 12}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox["\[IndentingNewLine]",
                  "Text"], 
                
                StyleBox[\(PlotStyle \[Rule] {GrayLevel[0], 
                      Dashing[{ .03}]}\),
                  "Text"]}], 
              StyleBox["]",
                "Text"]}]}], 
          StyleBox[";",
            "Text"]}], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox[\(Show[pl1, \ pl2, \ pl3]\),
          "Text"]}]}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.309017 [
[.02381 -0.0125 -12.1875 -15.5 ]
[.02381 -0.0125 12.1875 0 ]
[.2619 -0.0125 -9.1875 -15.5 ]
[.2619 -0.0125 9.1875 0 ]
[.7381 -0.0125 -5 -15.5 ]
[.7381 -0.0125 5 0 ]
[.97619 -0.0125 -8 -15.5 ]
[.97619 -0.0125 8 0 ]
[1.025 0 0 -7.75 ]
[1.025 0 9.4375 7.75 ]
[.4875 .07725 -25 -7.75 ]
[.4875 .07725 0 7.75 ]
[.4875 .15451 -19 -7.75 ]
[.4875 .15451 0 7.75 ]
[.4875 .23176 -25 -7.75 ]
[.4875 .23176 0 7.75 ]
[.4875 .30902 -10 -7.75 ]
[.4875 .30902 0 7.75 ]
[.4875 .38627 -25 -7.75 ]
[.4875 .38627 0 7.75 ]
[.4875 .46353 -19 -7.75 ]
[.4875 .46353 0 7.75 ]
[.4875 .54078 -25 -7.75 ]
[.4875 .54078 0 7.75 ]
[.4875 .61803 -10 -7.75 ]
[.4875 .61803 0 7.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -73.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -66 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -86 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.25) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -86 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.75) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -86 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.25) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -86 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.75) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01433 m
.04262 .01582 L
.06244 .0177 L
.08255 .02007 L
.10458 .02341 L
.12415 .02731 L
.14509 .03288 L
.16639 .0407 L
.18653 .05088 L
.20651 .06459 L
.22495 .08128 L
.24367 .10286 L
.2643 .13222 L
.30459 .20086 L
.32312 .23086 L
.33292 .24402 L
.34336 .25482 L
.34632 .25715 L
.34911 .25901 L
.35182 .26049 L
.35432 .26156 L
.35669 .2623 L
.35789 .26257 L
.35921 .26279 L
.36053 .26291 L
.36127 .26295 L
.36194 .26295 L
.36325 .2629 L
.36449 .26276 L
.36564 .26256 L
.36692 .26225 L
.36824 .26184 L
.36949 .26137 L
.37172 .26031 L
.37412 .25887 L
.37958 .25437 L
.38458 .24878 L
.39439 .23382 L
.40351 .21542 L
.42421 .16103 L
.44294 .1044 L
.46325 .04801 L
.46865 .03566 L
.47436 .02427 L
.47965 .01549 L
.4846 .00896 L
.48922 .00441 L
.49182 .00255 L
.49419 .00129 L
.49554 .00076 L
Mistroke
.49678 .0004 L
.4975 .00024 L
.49815 .00013 L
.4989 5e-005 L
.49961 1e-005 L
.5009 3e-005 L
.50208 .00017 L
.50338 .00044 L
.50403 .00062 L
.50475 .00086 L
.50727 .00202 L
.50869 .00288 L
.51001 .00381 L
.51498 .00848 L
.5195 .01425 L
.5243 .02188 L
.53425 .04212 L
.54523 .07004 L
.56624 .13234 L
.58548 .18828 L
.59527 .21266 L
.60437 .23155 L
.61385 .24675 L
.61887 .25279 L
.62147 .25536 L
.62422 .25768 L
.62677 .25944 L
.62957 .26096 L
.6308 .26149 L
.63211 .26196 L
.63335 .26232 L
.63449 .26258 L
.63518 .26271 L
.63592 .26281 L
.63666 .26289 L
.63747 .26294 L
.63818 .26295 L
.63893 .26294 L
.63965 .2629 L
.6403 .26284 L
.64154 .26268 L
.64224 .26255 L
.64289 .26241 L
.64419 .26206 L
.64561 .26159 L
.64823 .26047 L
.65071 .25912 L
.65535 .25588 L
.66577 .24558 L
.67522 .23325 L
Mistroke
.68562 .21731 L
.70666 .18118 L
.72771 .14501 L
.74697 .11548 L
.76709 .08987 L
.78576 .07108 L
.80476 .05636 L
.82549 .04443 L
.84602 .03584 L
.86464 .03008 L
.8839 .02557 L
.90472 .02188 L
.92468 .01916 L
.94574 .01688 L
.97619 .01433 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005P3oool3000000<0oooo0`00
000c0?ooo`<00000K03oool3000003D0oooo0`0000030?ooo`<000007P3oool001L0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo01/0oooo000=0?ooo`L000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0:03oool7000000D0oooo00<000000?ooo`3o
ool0K03oool00`000000oooo0?ooo`0b0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01/0oooo000G0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo06`0oooo00<00000
0?ooo`3oool0<`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06`3o
ool001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0340oooo0P00
001]0?ooo`800000=P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
6`3oool001H0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000<`3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo03@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00007@3oool001L0oooo00<000000?ooo`3oool00P3oool3000003D0oooo0`00001/0?ooo`<00000
=03oool00`000000oooo0?ooo`020?ooo`<000007P3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo3P3oool200000140oooo003o0?ooo`d0oooo00@000000?ooo`3oool00000403oool00?l0
oooo3@3oool010000000oooo0?ooo`00000@0?ooo`004@3ooood000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`005P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`060?ooo`040000003oool000000?oo
o`800000203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<000000?oo
o`3oool0203oool00`000000oooo0?ooo`0;0?ooo`D000003`3oool001H0oooo00<000000?ooo`3o
ool0=`3oool00`000000oooo0?ooo`0d0?ooo`040000003oool0oooo000000<0oooo00<000000?oo
o`3oool0<`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00`0oooo00@000000?oo
o`3oool000003`3oool008H0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0
oooo07`0oooo00@000000?ooo`3oool000003`3oool001H0oooo3@00001R0?ooo`030000003oool0
oooo0080oooo0P0000030?ooo`030000003oool0oooo06<0oooo2P00000?0?ooo`<000003`3oool0
02<0oooo1@00001L0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`1H0?ooo`X00000:`3oool002P0oooo1@00001G0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1B0?ooo`D00000=@3oool002d0oooo
1@00001B0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`1?0?ooo`<00000>P3oool00380oooo1000001=0?ooo`030000003oool0oooo00@0oooo0P00
00060?ooo`030000003oool0oooo04`0oooo0P00000m0?ooo`00=P3oool2000004/0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo04T0oooo0`00000o
0?ooo`00>03oool2000004P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo04H0oooo0P0000120?ooo`00>P3oool2000004H0oooo00<000000?ooo`3o
ool01@3oool2000000L0oooo00<000000?ooo`3oool0A03oool2000004@0oooo000l0?ooo`800000
@`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
@@3oool2000004H0oooo000n0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo03l0oooo0P0000180?ooo`00?`3oool2
000003l0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo03h0oooo00<000000?ooo`3oool0B03oool00440oooo0P00000m0?ooo`030000003oool0oooo
00L0oooo0P0000080?ooo`030000003oool0oooo03`0oooo0P00001;0?ooo`00@`3oool00`000000
oooo0?ooo`0[0?ooo`<000000`3oool00`000000oooo00000004000000040?ooo`00000000000000
00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0i0?ooo`800000C@3oool004@0
oooo00<000000?ooo`3oool0:@3oool01@000000oooo0?ooo`3oool0000000D0oooo00@000000?oo
o`3oool000000P3oool00`000000oooo000000070?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool0>03oool00`000000oooo0?ooo`1=0?ooo`00A@3oool00`000000oooo0?ooo`0X0?oo
o`050000003oool0oooo0?ooo`0000001P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool0CP3oool004H0oooo00<000000?ooo`3oool09`3oool01@000000oooo0?ooo`3o
ool0000000L0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`040?ooo`<00000
2@3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo04l0oooo00170?ooo`030000003o
ool0oooo02H0oooo00D000000?ooo`3oool0oooo000000080?ooo`030000003oool0000000<0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo03D0oooo
00<000000?ooo`3oool0C`3oool004P0oooo00<000000?ooo`3oool09@3oool01@000000oooo0?oo
o`3oool0000000P0oooo0P0000030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo0500oooo00190?ooo`030000003o
ool0oooo02@0oooo00D000000?ooo`3oool0oooo000000080?ooo`80000000<0oooo000000000000
203oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool0
D@3oool004X0oooo00<000000?ooo`3oool08`3oool01@000000oooo0?ooo`3oool0000000@0oooo
00@000000?ooo`3oool0oooo0P0000000`3oool000000?ooo`080?ooo`8000002`3oool00`000000
oooo0?ooo`0a0?ooo`030000003oool0oooo0580oooo001;0?ooo`030000003oool0oooo02<0oooo
0`0000060?ooo`<0000000@0oooo0000003oool0oooo0`0000060?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`1C0?ooo`00C03oool00`000000oooo
0?ooo`0^0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02`3oool00`000000oooo
0?ooo`0^0?ooo`030000003oool0oooo05@0oooo001=0?ooo`030000003oool0oooo02d0oooo00<0
00000?ooo`3oool02P3oool2000000d0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?oo
o`1D0?ooo`00C@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo00X0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo05D0oooo001>0?oo
o`030000003oool0oooo02/0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo02/0oooo00<000000?ooo`3oool0EP3oool004l0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool0:@3oool00`000000oooo0?ooo`1G0?ooo`00D03oool00`000000oooo0?ooo`0X0?ooo`030000
003oool0oooo00`0oooo0P00000>0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0
E`3oool00500oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0<0?ooo`030000003o
ool0oooo00h0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`1H0?ooo`00D@3oool0
0`000000oooo0?ooo`0W0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool03P3oool0
0`000000oooo0?ooo`0V0?ooo`030000003oool0oooo05T0oooo001B0?ooo`030000003oool0oooo
02D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo
02D0oooo00<000000?ooo`3oool0FP3oool00580oooo00<000000?ooo`3oool09@3oool00`000000
oooo0?ooo`0=0?ooo`800000403oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo05X0
oooo001C0?ooo`030000003oool0oooo0240oooo100000020?ooo`030000003oool0000000800000
203oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0
F`3oool005<0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`02000000L0oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool0G03oool005@0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`02
000000P0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0?0?ooo`030000003oool0
oooo0280oooo00<000000?ooo`3oool0G03oool005D0oooo00<000000?ooo`3oool07P3oool01@00
0000oooo0000003oool0000000P0oooo00<000000?ooo`3oool0103oool300000100oooo00<00000
0?ooo`3oool0803oool00`000000oooo0?ooo`1M0?ooo`00E@3oool00`000000oooo0?ooo`0N0?oo
o`050000003oool000000?ooo`000000203oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0100oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1M0?ooo`00EP3oool00`00
0000oooo0?ooo`0M0?ooo`050000003oool000000?ooo`0000001`3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1N
0?ooo`00EP3oool00`000000oooo0?ooo`0M0?ooo`8000000P3oool00`000000oooo0?ooo`030?oo
o`800000203oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo01h0oooo00<000000?oo
o`3oool0GP3oool005L0oooo00<000000?ooo`3oool0703oool200000080oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`070?ooo`8000004P3oool00`000000oooo0?ooo`0M0?ooo`03
0000003oool0oooo05l0oooo001G0?ooo`030000003oool0oooo01d0oooo0`0000070?ooo`<00000
1P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0
G`3oool005P0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0A0?ooo`030000003o
ool0oooo0140oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`1P0?ooo`00F@3oool0
0`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0140oooo0P00000C0?ooo`030000003oool0
oooo01X0oooo00<000000?ooo`3oool0H@3oool005T0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`0B0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool06P3oool00`00
0000oooo0?ooo`1Q0?ooo`00FP3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo0180
oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0680
oooo001J0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool04P3oool00`000000oooo
0?ooo`0C0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0HP3oool005/0oooo00<0
00000?ooo`3oool05P3oool00`000000oooo0?ooo`0C0?ooo`800000503oool00`000000oooo0?oo
o`0G0?ooo`030000003oool0oooo06<0oooo001L0?ooo`030000003oool0oooo01D0oooo00<00000
0?ooo`3oool04`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01H0oooo00<00000
0?ooo`3oool0H`3oool005`0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo01@0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1T0?oo
o`00G@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo06@0oooo001M0?ooo`030000
003oool0oooo01<0oooo00<000000?ooo`3oool0503oool2000001H0oooo00<000000?ooo`3oool0
4`3oool00`000000oooo0?ooo`1U0?ooo`00GP3oool00`000000oooo0?ooo`0@0?ooo`<000000`3o
ool01@000000oooo0?ooo`3oool0000000<0oooo0`0000080?ooo`030000003oool0oooo01H0oooo
00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1V0?ooo`00GP3oool00`000000oooo0?oo
o`0?0?ooo`050000003oool000000?ooo`0000001P3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo06L0oooo001O0?ooo`030000003oool0oooo00h0oooo0P0000020?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo01L0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1W0?ooo`00H03oool0
0`000000oooo0?ooo`0=0?ooo`8000000P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0103oool3000001L0oooo00<000000?ooo`3oool03P3oool0
0`000000oooo0?ooo`1X0?ooo`00H03oool00`000000oooo0?ooo`0=0?ooo`050000003oool0oooo
0?ooo`0000001`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0603oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo06T0oooo001Q0?oo
o`030000003oool0oooo00/0oooo0P0000030?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01P0oooo00<000000?oo
o`3oool0303oool00`000000oooo0?ooo`1Y0?ooo`00HP3oool00`000000oooo0?ooo`0:0?ooo`80
00000`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00800000203oool2000001X0
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`1Z0?ooo`00H`3oool00`000000oooo
0?ooo`080?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool00P3oool01@000000oooo
0?ooo`3oool000000080oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0I0?ooo`03
0000003oool0oooo00P0oooo0P00001]0?ooo`00I03oool00`000000oooo0?ooo`060?ooo`040000
003oool0oooo0?ooo`<000001P3oool4000000<0oooo0`0000060?ooo`030000003oool0oooo01X0
oooo0P0000070?ooo`030000003oool0oooo06d0oooo001U0?ooo`8000001@3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`1^0?ooo`00IP3oool6000001h0oooo0P00000N0?ooo`H00000L03oool008X0oooo00<00000
0?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool0
0`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00P03oool3000000L0
oooo0P00002D0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo
00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool00840oooo00<00000
0?ooo`3oool01P3oool3000009<0oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0T`3oool00840oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`2C0?ooo`00
P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo00200?ooo`800000203o
ool2000009@0oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo
0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000
003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool0
0740oooo0`0000030?ooo`030000003oool0000000@0000000@0oooo0000000000000000203oool0
0`000000oooo0?ooo`2C0?ooo`00LP3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo
000000@0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2C0?ooo`00LP3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`2C0?ooo`00LP3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0103oool3000009<0oooo001b0?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo
001b0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo09<0oooo001b0?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool00P0000080?ooo`030000003oool0oooo09<0oooo001a0?ooo`8000001P3oool01@00
0000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool01`3oool2000009@0oooo001b0?oo
o`030000003oool0oooo00D0oooo0`0000040?ooo`<000001P3oool00`000000oooo0?ooo`2C0?oo
o`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3o
ool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo
09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?oo
o`00M`3oool3000000<0oooo00<000000?ooo`0000000P0000080?ooo`030000003oool0oooo09<0
oooo001h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`2C0?ooo`00N03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool0T`3oool007P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`04
0?ooo`<00000T`3oool007P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo09<0oooo001h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`2C0?ooo`00N03oool00`000000oooo0?ooo`050?ooo`800000
203oool00`000000oooo0?ooo`2C0?ooo`00M`3oool2000000L0oooo00<000000?ooo`3oool01`3o
ool2000009@0oooo001h0?ooo`030000003oool0oooo00H0oooo0`0000060?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0
oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<00000
0?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2
000009@0oooo001a0?ooo`<000000`3oool01@000000oooo0?ooo`3oool0000000<0oooo0`000008
0?ooo`030000003oool0oooo09<0oooo001b0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09<0oooo001b0?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo09<0oooo001b0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`040?ooo`<00000T`3oool00780oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3o
ool00780oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool0T`3oool00780oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`02000000P0oooo00<000000?ooo`3oool0T`3oool00740oooo0P0000060?ooo`05
0000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`070?ooo`800000U03oool00780
oooo00<000000?ooo`3oool01@3oool4000000<0oooo0`0000060?ooo`030000003oool0oooo09<0
oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<00000
0?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool0
0`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0
oooo001o0?ooo`D000001P3oool00`000000oooo0?ooo`2C0?ooo`00P03oool010000000oooo0?oo
o`0000060?ooo`030000003oool0oooo09<0oooo00210?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool0T`3oool00880oooo00<000000?ooo`3oool01@3oool3000009<0oooo00230?oo
o`030000003oool0oooo09X0oooo00230?ooo`030000003oool0oooo09X0oooo00230?ooo`030000
003oool0oooo09X0oooo001o0?ooo`050000003oool0oooo0?ooo`000000W03oool00800oooo0`00
002M0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9695, -0.246249, \
0.086157, 0.0132767}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.309017 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .07725 -23.9375 -7.875 ]
[.4875 .07725 0 7.875 ]
[.4875 .15451 -18.25 -7.875 ]
[.4875 .15451 0 7.875 ]
[.4875 .23176 -23.9375 -7.875 ]
[.4875 .23176 0 7.875 ]
[.4875 .30902 -9.6875 -7.875 ]
[.4875 .30902 0 7.875 ]
[.4875 .38627 -23.9375 -7.875 ]
[.4875 .38627 0 7.875 ]
[.4875 .46353 -18.25 -7.875 ]
[.4875 .46353 0 7.875 ]
[.4875 .54078 -23.9375 -7.875 ]
[.4875 .54078 0 7.875 ]
[.4875 .61803 -9.6875 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.25) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.75) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.25) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.75) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
[ .01 ] 0 setdash
.02381 .00221 m
.04262 .00243 L
.06244 .00269 L
.08426 .00305 L
.10458 .00346 L
.12414 .00395 L
.14264 .00455 L
.16305 .0054 L
.18163 .00644 L
.2016 .00794 L
.22004 .00981 L
.23877 .01232 L
.25939 .01597 L
.29968 .02603 L
.33845 .03727 L
.34856 .03966 L
.3539 .0407 L
.35959 .04161 L
.3624 .04197 L
.36505 .04225 L
.36743 .04246 L
.36866 .04254 L
.37001 .04262 L
.37127 .04268 L
.37246 .04272 L
.3737 .04275 L
.3744 .04276 L
.37504 .04276 L
.37618 .04276 L
.37742 .04274 L
.37859 .04271 L
.37968 .04267 L
.38086 .04262 L
.38209 .04254 L
.38431 .04236 L
.3867 .04211 L
.3893 .04177 L
.39399 .04096 L
.39834 .04 L
.4083 .03702 L
.41894 .03276 L
.43886 .02263 L
.46044 .01102 L
.47055 .00641 L
.47607 .00432 L
.48124 .0027 L
.48565 .0016 L
.48791 .00114 L
.49038 .00072 L
.49177 .00053 L
Mistroke
.49307 .00038 L
.49441 .00024 L
.49563 .00015 L
.49682 8e-005 L
.49795 3e-005 L
.49914 1e-005 L
.50042 0 L
.50167 2e-005 L
.50281 6e-005 L
.50412 .00013 L
.50536 .00022 L
.50756 .00045 L
.50995 .00077 L
.51259 .00123 L
.51538 .00183 L
.5204 .00318 L
.53043 .00682 L
.54148 .01198 L
.56249 .02337 L
.57169 .02826 L
.58173 .03306 L
.59087 .03673 L
.60062 .03974 L
.60601 .04096 L
.61091 .0418 L
.61327 .04211 L
.61583 .04237 L
.61701 .04247 L
.61825 .04256 L
.6194 .04263 L
.62047 .04268 L
.62169 .04272 L
.62233 .04274 L
.62301 .04275 L
.62416 .04276 L
.62542 .04276 L
.62654 .04274 L
.62775 .04271 L
.62889 .04267 L
.62994 .04262 L
.6323 .04248 L
.63488 .04226 L
.64009 .04165 L
.64467 .04095 L
.64958 .04004 L
.65841 .03806 L
.69988 .02616 L
.72066 .02049 L
.73983 .01613 L
.75849 .01275 L
Mistroke
.77826 .01 L
.79781 .00799 L
.81612 .00659 L
.83638 .00543 L
.85491 .00464 L
.87391 .00401 L
.89464 .00348 L
.91597 .00304 L
.9353 .00273 L
.97445 .00223 L
.97619 .00221 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005`3oool2000000@0oooo0`00
000d0?ooo`<00000K03oool3000003@0oooo0P0000040?ooo`<000007@3oool001P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0b0?ooo`040000003oool0oooo000006/0oooo
00@000000?ooo`3oool00000=@3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01`0oooo000H0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?oo
o`3oool00P00001Z0?ooo`030000003oool0oooo00800000=03oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000L0?ooo`00603oool01@000000oooo0?ooo`3oool000000080oooo0P00000f
0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0<P3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000L0?ooo`003P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02L0oooo1`0000050?ooo`800000K@3oool2000003@0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01X0oooo000H0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0`0?ooo`040000003oool0oooo000006/0
oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool06P3oool001P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000<P3oool4
000006/0oooo1000000e0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo000H
0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0f0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo
000G0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0e0?ooo`8000000`3oool2000000030?ooo`000000oooo01`0oooo000H
0?ooo`030000003oool0oooo0080oooo0`00000c0?ooo`<00000K03oool3000003H0oooo00<00000
0?ooo`3oool00P3oool3000001d0oooo003o0?ooob40oooo003o0?ooo`h0oooo0P00000A0?ooo`00
o`3oool=0?ooo`040000003oool0oooo00000100oooo003o0?ooo`d0oooo00@000000?ooo`3oool0
0000403oool00140oooom00000070?ooo`050000003oool0oooo0?ooo`0000003`3oool001L0oooo
0`0000000`3oool0000000000002000000030?ooo`00000000000080000000@0oooo000000000000
00000P3oool3000000030?ooo`0000000000008000001`3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`020?ooo`<0
000000@0oooo0000003oool000000P3oool3000000H0oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00`3oool40000
00030?ooo`00000000000080000000<0oooo0000000000000P000000103oool00000000000000002
0?ooo`<000000P3oool3000000030?ooo`000000oooo00`0oooo1@00000?0?ooo`005`3oool00`00
0000oooo0?ooo`0J0?ooo`<0000000<0oooo0000000000000P0000000`3oool00000000000020000
00030?ooo`000000000000`0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0<0?oo
o`<000000P3oool300000080oooo0`00000N0?ooo`030000003oool0oooo00`0oooo00@000000?oo
o`3oool000003`3oool004@0oooo0P000000103oool0000000000000000g0?ooo`030000003oool0
oooo00H0oooo00<000000?ooo`3oool01P3oool2000003@0oooo10000000103oool0000000000000
000l0?ooo`040000003oool0oooo000000l0oooo001<0?ooo`<000000P3oool00`000000oooo0?oo
o`0[0?ooo`8000002@3oool2000000X0oooo00<000000?ooo`3oool0;03oool3000004H0oooo0`00
000?0?ooo`00DP3oool2000002T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:
0?ooo`8000009`3oool3000005d0oooo001E0?ooo`@000008P3oool2000000d0oooo00<000000?oo
o`3oool0<03oool00`000000oooo0?ooo`1P0?ooo`00FP3oool3000001/0oooo00<000000?ooo`3o
ool03`3oool00`000000oooo0?ooo`0=0?ooo`<000006`3oool2000000030?ooo`000000000006<0
oooo001O0?ooo`030000003oool0oooo01@0oooo0P00000B0?ooo`8000004@3oool00`000000oooo
0?ooo`0F0?ooo`800000J03oool00600oooo0P00000B0?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool04P3oool200000140oooo0`00001[0?ooo`00H`3oool4000000030?ooo`000000
oooo00H0oooo00@000000?ooo`00000000005P3oool00`000000oooo0?ooo`0D0?ooo`040000003o
ool00000000000P0oooo0`00001`0?ooo`00J@3oool200000080oooo0`00000J0?ooo`030000003o
ool0oooo01P0oooo0P0000000`3oool0000000000002000007@0oooo002:0?ooo`800000U03oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool007<0oooo
0`0000020?ooo`030000003oool0oooo0080oooo0P0000030?ooo`<000001@3oool2000009@0oooo
001b0?ooo`80000000<0oooo0000003oool0103oool3000000040?ooo`000000oooo00000080oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2C0?ooo`00LP3oool00`000000oooo0?oo
o`02000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`02000000@0oooo00<0
00000?ooo`3oool0T`3oool00780oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2C0?ooo`00LP3oool01@00
0000oooo0?ooo`3oool0000000D0oooo0P0000060?ooo`800000103oool3000009<0oooo001b0?oo
o`050000003oool0oooo0?ooo`0000001`3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo00<0oooo00<000000?ooo`3oool0T`3oool00780oooo00<000000?ooo`3oool00P000007
0?ooo`80000000<0oooo0000000000000P0000050?ooo`030000003oool0oooo09<0oooo001b0?oo
o`030000003oool0oooo00800000103oool01`000000oooo0?ooo`3oool000000?ooo`000000203o
ool00`000000oooo0?ooo`2C0?ooo`00LP3oool2000000030?ooo`000000oooo00@0oooo00<00000
0?ooo`3oool00P0000000`3oool000000?ooo`070?ooo`800000U03oool007<0oooo0`0000060?oo
o`<000000P3oool3000000H0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool0
0`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0
oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:
0?ooo`030000003oool0oooo09<0oooo001i0?ooo`<000000P3oool010000000oooo0?ooo`3oool3
000000D0oooo0P00002D0?ooo`00N03oool2000000030?ooo`000000oooo00@0oooo00@000000?oo
o`3oool000001@3oool00`000000oooo0?ooo`2C0?ooo`00N03oool00`000000oooo0?ooo`020000
00@0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo09<0oooo001h0?ooo`03
0000003oool0oooo00800000203oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo09<0
oooo001h0?ooo`050000003oool0oooo0?ooo`0000001`3oool2000000@0oooo0`00002C0?ooo`00
N03oool01@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3oool000001@3oool00`00
0000oooo0?ooo`2C0?ooo`00N03oool00`000000oooo0?ooo`02000000@0oooo100000050?ooo`03
0000003oool0oooo09<0oooo001h0?ooo`030000003oool0oooo00800000103oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo09<0oooo001h0?ooo`80000000<0oooo0000003oool0103o
ool00`000000oooo0?ooo`060?ooo`800000U03oool007T0oooo0`0000050?ooo`<000001P3oool0
0`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0
oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:
0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3o
ool007<0oooo0`0000020?ooo`030000003oool0oooo00L0oooo0`0000050?ooo`800000U03oool0
0780oooo0P0000000`3oool000000?ooo`060?ooo`050000003oool0oooo0?ooo`0000000P3oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo09<0oooo001b0?ooo`030000003oool0oooo
008000001P3oool01@000000oooo0?ooo`3oool000000080oooo0P0000040?ooo`030000003oool0
oooo09<0oooo001b0?ooo`030000003oool0oooo008000001P3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0T`3oool00780oooo00D000000?ooo`3o
ool0oooo000000060?ooo`030000003oool0oooo00@0oooo0P0000040?ooo`<00000T`3oool00780
oooo00D000000?ooo`3oool0oooo000000070?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`2C0?ooo`00LP3oool00`000000oooo0?ooo`020000
00L0oooo00<000000?ooo`3oool0100000050?ooo`030000003oool0oooo09<0oooo001b0?ooo`03
0000003oool0oooo00800000103oool01`000000oooo0?ooo`3oool000000?ooo`000000203oool2
000009@0oooo001b0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo000000020000
00030?ooo`000000oooo00L0oooo00<000000?ooo`3oool0T`3oool007<0oooo0`0000050?ooo`80
00000P3oool00`000000oooo00000002000000H0oooo00<000000?ooo`3oool0T`3oool008X0oooo
00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo00220?ooo`8000001P3oool2000009@0
oooo00230?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008<0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`2C0?ooo`00P`3oool00`000000oooo0?ooo`04
0?ooo`<00000T`3oool008<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2C0?oo
o`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo00230?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008<0oooo00<000000?ooo`3oool0103o
ool2000009@0oooo00220?ooo`8000001P3oool00`000000oooo0?ooo`2C0?ooo`00P`3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0
oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<00000
0?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00
RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00L`3oool2
000000<0oooo00<000000?ooo`3oool00P3oool2000000<0oooo0`0000050?ooo`030000003oool0
oooo09<0oooo001d0?ooo`030000003oool0oooo00@0oooo0`000000103oool000000?ooo`000002
0?ooo`030000003oool0oooo00<0oooo0P00002D0?ooo`00M03oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo
09<0oooo001d0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo09<0oooo001d0?ooo`030000003oool0oooo00D0oooo
0P0000060?ooo`800000103oool3000009<0oooo001d0?ooo`030000003oool0oooo00L0oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo09<0oooo
001d0?ooo`030000003oool0oooo00L0oooo0P0000000`3oool0000000000002000000D0oooo00<0
00000?ooo`3oool0T`3oool007@0oooo00<000000?ooo`3oool0103oool01`000000oooo0?ooo`3o
ool000000?ooo`000000203oool00`000000oooo0?ooo`2C0?ooo`00L`3oool2000000H0oooo00<0
00000?ooo`3oool00P0000000`3oool000000?ooo`070?ooo`800000U03oool007@0oooo00<00000
0?ooo`3oool01@3oool300000080oooo0`0000060?ooo`030000003oool0oooo09<0oooo002:0?oo
o`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000
U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00N@3oool2000000<0oooo00@00000
0?ooo`3oool0oooo0`0000050?ooo`800000U03oool007X0oooo00<000000?ooo`3oool0103oool0
10000000oooo0?ooo`0000050?ooo`030000003oool0oooo09<0oooo001j0?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo09<0oooo001j0?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2C0?oo
o`00NP3oool00`000000oooo0?ooo`070?ooo`800000103oool3000009<0oooo001j0?ooo`030000
003oool0oooo00@0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`2C0?ooo`00
NP3oool00`000000oooo0?ooo`040?ooo`@000001@3oool00`000000oooo0?ooo`2C0?ooo`00NP3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3o
ool007T0oooo0P0000060?ooo`030000003oool0oooo00H0oooo0P00002D0?ooo`00NP3oool00`00
0000oooo0?ooo`040?ooo`<000001P3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000
oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo002:
0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`80
0000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3o
ool008X0oooo00<000000?ooo`3oool0T`3oool007<0oooo0P0000030?ooo`030000003oool0oooo
00L0oooo0`0000050?ooo`800000U03oool007@0oooo00<000000?ooo`3oool01P3oool01@000000
oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2C0?oo
o`00M03oool00`000000oooo0?ooo`060?ooo`050000003oool0oooo0?ooo`0000000P3oool20000
00@0oooo00<000000?ooo`3oool0T`3oool007@0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0T`3oool007@0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`040?ooo`800000103oool3000009<0oooo
001d0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`3oool000000P3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo09<0oooo001d0?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool0100000050?ooo`030000003oool0oooo09<0oooo001d0?ooo`030000003oool0
oooo00@0oooo00L000000?ooo`3oool0oooo0000003oool0000000P0oooo00<000000?ooo`3oool0
T`3oool007<0oooo0P0000060?ooo`030000003oool000000080000000<0oooo0000003oool01`3o
ool2000009@0oooo001d0?ooo`030000003oool0oooo00@0oooo0P0000020?ooo`030000003oool0
0000008000001P3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?oo
o`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003o
ool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0
oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<0
00000?ooo`3oool0T`3oool008<0oooo0P0000050?ooo`800000U03oool00840oooo0`0000000`3o
ool000000?ooo`030?ooo`030000003oool0oooo09<0oooo00210?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`2C0?ooo`00PP3oool2000000H0oooo0`00002C0?ooo`00Q03oool00`000000oooo0?ooo`2I
0?ooo`00Q03oool2000009X0oooo00210?ooo`050000003oool0oooo0?ooo`000000VP3oool00840
oooo00<000000?ooo`3oool00P00002J0?ooo`00PP3oool3000009/0oooo003o0?ooob40oooo003o
0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9865, -0.25008, \
0.0863677, 0.0133091}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.309017 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .07725 -23.9375 -7.875 ]
[.4875 .07725 0 7.875 ]
[.4875 .15451 -18.25 -7.875 ]
[.4875 .15451 0 7.875 ]
[.4875 .23176 -23.9375 -7.875 ]
[.4875 .23176 0 7.875 ]
[.4875 .30902 -9.6875 -7.875 ]
[.4875 .30902 0 7.875 ]
[.4875 .38627 -23.9375 -7.875 ]
[.4875 .38627 0 7.875 ]
[.4875 .46353 -18.25 -7.875 ]
[.4875 .46353 0 7.875 ]
[.4875 .54078 -23.9375 -7.875 ]
[.4875 .54078 0 7.875 ]
[.4875 .61803 -9.6875 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.25) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.75) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.25) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.75) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
[ .03 ] 0 setdash
.02381 .03823 m
.04262 .04254 L
.06244 .04816 L
.08255 .05544 L
.10458 .06604 L
.12415 .07875 L
.14509 .09723 L
.16639 .1232 L
.18653 .1566 L
.20651 .20028 L
.22495 .25119 L
.2643 .3913 L
.30213 .53657 L
.31208 .56802 L
.32154 .5925 L
.32676 .60322 L
.32951 .60799 L
.33245 .61235 L
.33516 .61569 L
s
.33516 .61569 m
.33753 .61803 L
s
.35467 .61803 m
.35695 .61568 L
.36236 .60772 L
.36726 .59769 L
.37262 .58367 L
.38342 .54606 L
.40304 .44991 L
.42399 .32114 L
.4439 .19479 L
.45438 .13448 L
.46548 .07981 L
.47539 .04155 L
.48102 .02496 L
.48372 .01843 L
.48629 .01312 L
.4886 .00909 L
.49112 .00553 L
.49341 .00305 L
.49443 .00218 L
.49553 .0014 L
.49683 .0007 L
.49806 .00027 L
.49925 4e-005 L
.50034 1e-005 L
.50153 .00017 L
.50284 .00057 L
.50349 .00086 L
.5042 .00124 L
.50547 .0021 L
.50804 .00453 L
.51077 .00811 L
.51567 .01708 L
.52094 .03027 L
.52675 .04885 L
.53714 .0917 L
.54688 .14136 L
.58562 .38219 L
.6053 .49467 L
.61571 .54253 L
.62142 .56444 L
.62681 .582 L
.63199 .59592 L
.63759 .60764 L
.64007 .6117 L
.64269 .61525 L
.64492 .61767 L
s
.64492 .61767 m
.64536 .61803 L
s
.66242 .61803 m
.66398 .6166 L
.66649 .61375 L
.67176 .60587 L
.67675 .59626 L
.68607 .57325 L
.70702 .50387 L
.74545 .35346 L
.76491 .28358 L
.78634 .21879 L
.80667 .17019 L
.82571 .13515 L
.84597 .10712 L
.8645 .08803 L
.8835 .07333 L
.90423 .0614 L
.92392 .05289 L
.94489 .04593 L
.97619 .03823 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005`3oool2000000@0oooo0`00
000d0?ooo`<00000K03oool3000003@0oooo0P0000040?ooo`<000007@3oool001P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0b0?ooo`040000003oool0oooo000006/0oooo
00@000000?ooo`3oool00000=@3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01`0oooo000H0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?oo
o`3oool00P00001Z0?ooo`030000003oool0oooo00800000=03oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000L0?ooo`00603oool01@000000oooo0?ooo`3oool000000080oooo0P00000f
0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0<P3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000L0?ooo`003P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02L0oooo1`0000050?ooo`800000K@3oool2000003@0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01X0oooo000H0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0`0?ooo`040000003oool0oooo000006/0
oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool06P3oool001P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000<P3oool4
000006/0oooo1000000e0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo000H
0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0f0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo
000G0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0e0?ooo`8000000`3oool2000000030?ooo`000000oooo01`0oooo000H
0?ooo`030000003oool0oooo0080oooo0`00000c0?ooo`<00000K03oool3000003H0oooo00<00000
0?ooo`3oool00P3oool3000001d0oooo003o0?ooob40oooo003o0?ooo`h0oooo0P00000A0?ooo`00
o`3oool=0?ooo`040000003oool0oooo00000100oooo003o0?ooo`d0oooo00@000000?ooo`3oool0
0000403oool00140oooom00000070?ooo`050000003oool0oooo0?ooo`0000003`3oool001L0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00/0oooo
1@00000?0?ooo`005`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03D0oooo00<0
00000?ooo`000000>@3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00`0oooo00@0
00000?ooo`3oool000003`3oool008P0oooo00<000000?ooo`0000000P3oool00`000000oooo0?oo
o`1m0?ooo`040000003oool0oooo000000l0oooo00270?ooo`030000003oool0oooo0080000000<0
oooo0000003oool0O`3oool3000000l0oooo00260?ooo`050000003oool0oooo0?ooo`0000000`3o
ool00`000000oooo0?ooo`2?0?ooo`00QP3oool01@000000oooo0?ooo`3oool0000000<0oooo00<0
00000?ooo`3oool0S`3oool008D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo08h0oooo00250?ooo`030000003oool0oooo0080oooo0P0000030?oo
o`030000003oool0oooo08h0oooo002:0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0SP3oool001L0oooo0P00001a0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
J03oool2000002<0oooo000I0?ooo`H00000J`3oool00`000000oooo0?ooo`1[0?ooo`<000009@3o
ool008X0oooo0P00001Y0?ooo`<00000:03oool008X0oooo00<000000?ooo`3oool0T`3oool002@0
oooo0`00001S0?ooo`030000003oool0oooo0680oooo00<000000?ooo`3oool0;P3oool002L0oooo
0P00001:0?ooo`<000000P3oool00`000000oooo0?ooo`020?ooo`8000000`3oool3000000D0oooo
0P00001Q0?ooo`800000<@3oool002T0oooo0P0000170?ooo`80000000<0oooo0000003oool0103o
ool3000000050?ooo`000000oooo0000003oool00P0000050?ooo`030000003oool0oooo05h0oooo
0P00000c0?ooo`00:`3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo00800000103o
ool00`000000oooo0?ooo`030?ooo`030000003oool0000000800000103oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo05@0oooo0P00000e0?ooo`00LP3oool00`000000oooo0?ooo`02
000000@0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000040?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`0e0?ooo`00LP3oool0
1@000000oooo0?ooo`3oool0000000D0oooo0P0000040?ooo`040000003oool00000000000@0oooo
0`0000050?ooo`030000003oool0oooo08/0oooo001b0?ooo`050000003oool0oooo0?ooo`000000
1`3oool00`000000oooo0?ooo`02000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`2;0?ooo`00<@3oool00`000000oooo0?ooo`0n0?ooo`030000003o
ool0oooo008000001`3oool2000000030?ooo`0000000000008000001@3oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo08X0oooo000b0?ooo`030000003oool0oooo03d0oooo00<00000
0?ooo`3oool00P0000040?ooo`070000003oool0oooo0?ooo`000000oooo000000080?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0k0?ooo`00<`3o
ool00`000000oooo0?ooo`0l0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0?oo
o`02000000030?ooo`000000oooo00L0oooo0P0000070?ooo`030000003oool0oooo04/0oooo00<0
00000?ooo`3oool0?03oool003@0oooo00<000000?ooo`3oool0?03oool3000000H0oooo0`000002
0?ooo`<000001P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo04T0oooo00<00000
0?ooo`3oool0?@3oool003D0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`1B0?oo
o`030000003oool0oooo03h0oooo000f0?ooo`030000003oool0oooo0540oooo00<000000?ooo`3o
ool0D@3oool00`000000oooo0?ooo`0o0?ooo`00RP3oool200000540oooo00<000000?ooo`3oool0
@03oool008X0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`100?ooo`00RP3oool0
0`000000oooo0?ooo`2C0?ooo`00P03oool00`000000oooo0?ooo`070?ooo`800000U03oool00800
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo08P0
oooo000j0?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool0203oool00`000000oooo
0?ooo`080?ooo`030000003oool0oooo08P0oooo000k0?ooo`030000003oool0oooo0440oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo08P0oooo000k
0?ooo`030000003oool0oooo03/0oooo0`0000020?ooo`8000000P3oool3000000D0oooo0P00000:
0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0A03oool003`0oooo00<000000?oo
o`3oool0>@3oool2000000030?ooo`000000oooo0080oooo00<000000?ooo`0000000P3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0?`3oool00`00
0000oooo0?ooo`150?ooo`00?@3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo0080
00000P3oool00`000000oooo000000020?ooo`800000103oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo03l0oooo00<000000?ooo`3oool0A@3oool003d0oooo00<000000?ooo`3oool0
>03oool00`000000oooo0?ooo`0200000080oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0?P3oool00`000000oooo
0?ooo`160?ooo`00?P3oool00`000000oooo0?ooo`0g0?ooo`050000003oool0oooo0?ooo`000000
1`3oool2000000@0oooo0`0000090?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool0
AP3oool003h0oooo00<000000?ooo`3oool0=`3oool01@000000oooo0?ooo`3oool0000000@0oooo
00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo03d0
oooo00<000000?ooo`3oool0A`3oool007P0oooo00<000000?ooo`3oool00P0000040?ooo`@00000
1@3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo04L0oooo001h0?ooo`030000003o
ool0oooo00800000103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo001h
0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`060?ooo`800000U03oool0
07T0oooo0`0000050?ooo`<000001P3oool00`000000oooo0?ooo`2C0?ooo`00O@3oool00`000000
oooo0?ooo`0:0?ooo`030000003oool0oooo09<0oooo00110?ooo`030000003oool0oooo03T0oooo
00<000000?ooo`3oool02P3oool2000009@0oooo00110?ooo`030000003oool0oooo03T0oooo00<0
00000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo08H0oooo0012
0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:
0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0BP3oool00480oooo00<000000?oo
o`3oool0>03oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00/0oooo00<000000?oo
o`3oool0=`3oool00`000000oooo0?ooo`1;0?ooo`00@`3oool00`000000oooo0?ooo`0g0?ooo`03
0000003oool0oooo00X0oooo0P00000<0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3o
ool0B`3oool004<0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`0;0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool0=P3oool00`000000oooo0?ooo`1<0?ooo`00A03o
ool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool02`3o
ool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo04`0oooo00140?ooo`030000003oool0
oooo04<0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0d0?ooo`030000003oool0
oooo04d0oooo001c0?ooo`<000000P3oool00`000000oooo0?ooo`070?ooo`<000001@3oool20000
00d0oooo00<000000?ooo`3oool0=03oool00`000000oooo0?ooo`1=0?ooo`00LP3oool200000003
0?ooo`000000oooo00H0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0T`3oool00780oooo00<000000?ooo`3oool00P0000060?ooo`05
0000003oool0oooo0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3oool0T`3oool00780
oooo00<000000?ooo`3oool00P0000060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`2C0?ooo`00LP3oool01@000000oooo0?ooo`3oool0000000H0
oooo00<000000?ooo`3oool0103oool2000000@0oooo0`00002C0?ooo`00LP3oool01@000000oooo
0?ooo`3oool0000000@0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000005
0?ooo`030000003oool0oooo09<0oooo00160?ooo`030000003oool0oooo02T0oooo00<000000?oo
o`3oool00P0000040?ooo`040000003oool0oooo00000080oooo100000050?ooo`030000003oool0
oooo09<0oooo00160?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool00P0000040?oo
o`070000003oool0oooo0?ooo`000000oooo000000080?ooo`8000003P3oool00`000000oooo0?oo
o`0a0?ooo`030000003oool0oooo04l0oooo00170?ooo`030000003oool0oooo02P0oooo0P000000
0`3oool000000?ooo`040?ooo`030000003oool000000080000000<0oooo0000003oool01`3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0C`3oool0
04L0oooo00<000000?ooo`3oool0:@3oool3000000@0oooo0`0000020?ooo`030000003oool00000
008000001P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo0300oooo00<000000?oo
o`3oool0D03oool004P0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0=0?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1@0?ooo`00
B03oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo00d0oooo0P00000?0?ooo`030000
003oool0oooo02h0oooo00<000000?ooo`3oool0D@3oool004T0oooo00<000000?ooo`3oool0;P3o
ool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0;P3o
ool00`000000oooo0?ooo`1A0?ooo`00B@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0
oooo00d0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0
oooo0580oooo002:0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0;@3oool00`00
0000oooo0?ooo`1B0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo00220?oo
o`8000001P3oool2000009@0oooo001;0?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo001;0?ooo`030000
003oool0oooo02/0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo03`0oooo00<000000?ooo`3oool0E03oool004`0oooo00<000000?ooo`3oool0:P3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00@0oooo0`00000?0?ooo`030000003o
ool0oooo02X0oooo00<000000?ooo`3oool0E03oool004`0oooo00<000000?ooo`3oool0:@3oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool03`3oool0
0`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo05D0oooo001<0?ooo`030000003oool0oooo
02T0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`1E0?ooo`00C03oool00`000000
oooo0?ooo`0Y0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0E@3oool004d0oooo
00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00@0oooo
0P00000A0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0E@3oool004d0oooo00<0
00000?ooo`3oool09`3oool00`000000oooo0?ooo`080?ooo`8000001P3oool00`000000oooo0?oo
o`0@0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0EP3oool008<0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo02L0oooo00<00000
0?ooo`3oool0EP3oool008X0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`200?oo
o`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003o
ool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo001?0?ooo`030000003oool0oooo
02@0oooo00<000000?ooo`3oool04@3oool2000009@0oooo001?0?ooo`030000003oool0oooo02@0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0h0?ooo`030000003oool0oooo05P0
oooo001?0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0A0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0F03oool004l0oooo00<0
00000?ooo`3oool08@3oool2000000040?ooo`000000oooo000000@0oooo0P0000030?ooo`<00000
1@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0
F03oool00500oooo00<000000?ooo`3oool08@3oool2000000D0oooo0`000000103oool000000?oo
o`0000020?ooo`030000003oool0oooo00<0oooo0P00000B0?ooo`030000003oool0oooo02@0oooo
00<000000?ooo`3oool0F03oool00500oooo00<000000?ooo`3oool08@3oool2000000D0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool04P3o
ool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo05T0oooo001@0?ooo`030000003oool0
oooo0240oooo0P0000050?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0F@3oool0
0500oooo00<000000?ooo`3oool08@3oool2000000H0oooo0P0000060?ooo`800000103oool30000
0180oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`1I0?ooo`00M03oool00`000000
oooo0?ooo`070?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`0C0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0F@3oool007@0
oooo00<000000?ooo`3oool01`3oool2000000030?ooo`0000000000008000001@3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo07d0oooo001d0?ooo`030000003oool0oooo00@0oooo
00L000000?ooo`3oool0oooo0000003oool0000000P0oooo00<000000?ooo`3oool0T`3oool007<0
oooo0P0000060?ooo`030000003oool0oooo0080000000<0oooo0000003oool01`3oool2000009@0
oooo001d0?ooo`030000003oool0oooo00D0oooo0`0000020?ooo`<000001P3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00DP3oool00`000000oooo0?ooo`0e
0?ooo`030000003oool0oooo09<0oooo001B0?ooo`030000003oool0oooo01l0oooo00<000000?oo
o`3oool04`3oool2000003H0oooo00<000000?ooo`3oool0F`3oool005<0oooo00<000000?ooo`3o
ool07P3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3o
ool07P3oool00`000000oooo0?ooo`1K0?ooo`00D`3oool00`000000oooo0?ooo`0N0?ooo`030000
003oool0oooo01<0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0M0?ooo`030000
003oool0oooo05`0oooo001C0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool04`3o
ool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0G03o
ool005<0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0D0?ooo`8000005@3oool0
0`000000oooo0?ooo`0M0?ooo`030000003oool0oooo05`0oooo001D0?ooo`030000003oool0oooo
01`0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo
01d0oooo00<000000?ooo`3oool0G03oool005@0oooo00<000000?ooo`3oool0703oool00`000000
oooo0?ooo`0D0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`1M0?ooo`00L`3oool00`000000oooo0?ooo`030?ooo`8000000`3oool010000000oooo
0?ooo`3oool3000000D0oooo0P00000F0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3o
ool0G@3oool007X0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`0000050?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1M0?ooo`00
NP3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00800000103oool00`000000oooo
0?ooo`0E0?ooo`030000003oool0oooo07/0oooo001j0?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`2C0?ooo`00NP3oool00`000000oooo0?ooo`07
0?ooo`800000103oool3000009<0oooo001j0?ooo`030000003oool0oooo00@0oooo00@000000?oo
o`3oool000001@3oool00`000000oooo0?ooo`2C0?ooo`00EP3oool00`000000oooo0?ooo`0Q0?oo
o`030000003oool0oooo00@0oooo100000050?ooo`030000003oool0oooo09<0oooo001F0?ooo`03
0000003oool0oooo01P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool005L0oooo00<000000?ooo`3oool0
5`3oool00`000000oooo0?ooo`050?ooo`8000001P3oool00`000000oooo0?ooo`060?ooo`800000
<P3oool00`000000oooo0?ooo`1O0?ooo`00E`3oool00`000000oooo0?ooo`0G0?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0103oool3000000H0oooo00<000000?ooo`3oool05P3o
ool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo05l0oooo001G0?ooo`030000003oool0
oooo01L0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0
oooo01P0oooo00<000000?ooo`3oool0G`3oool005L0oooo00<000000?ooo`3oool05P3oool00`00
0000oooo0?ooo`0G0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool05P3oool00`00
0000oooo0?ooo`1P0?ooo`00F03oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01L0
oooo0P00000H0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0H03oool005P0oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1P0?ooo`00L03oool00`000000oooo0?oo
o`0G0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?oo
o`1P0?ooo`00RP3oool2000001T0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1Q
0?ooo`00RP3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo07P0oooo002:0?ooo`03
0000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo001c0?ooo`8000000`3o
ool00`000000oooo0?ooo`070?ooo`<000001@3oool2000009@0oooo001J0?ooo`030000003oool0
oooo01L0oooo00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3oool000000080oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`2C0?ooo`00FP3oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01P3oool01@000000oooo0?ooo`3o
ool000000080oooo0P0000040?ooo`030000003oool0oooo09<0oooo001J0?ooo`030000003oool0
oooo0180oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0
oooo06<0oooo001J0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00@0oooo0P0000040?ooo`<000006@3oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo06<0oooo001K0?ooo`030000003oool0oooo0100
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`070?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool0I03oool005/0oooo00<000000?ooo`3oool0403oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0100000050?ooo`03
0000003oool0oooo01X0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1T0?ooo`00
G03oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
103oool01`000000oooo0?ooo`3oool000000?ooo`000000203oool00`000000oooo0?ooo`0J0?oo
o`030000003oool0oooo00l0oooo00<000000?ooo`3oool0I03oool005`0oooo00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`030?ooo`8000001P3oool00`000000oooo0000000200000003
0?ooo`000000oooo00L0oooo0P00000K0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3o
ool0I03oool006d0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`040?ooo`800000
0P3oool00`000000oooo00000002000000H0oooo00<000000?ooo`3oool06`3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo06D0oooo002:0?ooo`030000003oool0oooo01/0oooo00<0
00000?ooo`3oool03@3oool00`000000oooo0?ooo`1U0?ooo`00RP3oool2000001`0oooo00<00000
0?ooo`3oool0M@3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool005h0oooo00<000000?ooo`3oool0:@3o
ool2000009@0oooo001O0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0703oool0
0`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo06L0oooo001O0?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo
06P0oooo001P0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool07@3oool00`000000
oooo0?ooo`0N0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0J03oool00600oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0G0?ooo`8000001@3oool2000001l0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`1Y0?ooo`00H@3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo01D0oooo0`0000000`3oool000000?ooo`030?ooo`030000003o
ool0oooo01l0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1Y0?ooo`00HP3oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`0O0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0JP3oool0
0680oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`020?ooo`800000K03oool006<0
oooo00D000000?ooo`3oool0oooo0000000J0?ooo`8000001P3oool300000240oooo00D000000?oo
o`3oool0oooo0000001]0?ooo`00Q03oool00`000000oooo0?ooo`2I0?ooo`00Q03oool2000009X0
oooo00210?ooo`050000003oool0oooo0?ooo`000000VP3oool00840oooo00<000000?ooo`3oool0
0P00002J0?ooo`00PP3oool3000009/0oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9865, -0.25008, \
0.0863677, 0.0133091}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.309017 [
[.02381 -0.0125 -12.1875 -15.5 ]
[.02381 -0.0125 12.1875 0 ]
[.2619 -0.0125 -9.1875 -15.5 ]
[.2619 -0.0125 9.1875 0 ]
[.7381 -0.0125 -5 -15.5 ]
[.7381 -0.0125 5 0 ]
[.97619 -0.0125 -8 -15.5 ]
[.97619 -0.0125 8 0 ]
[1.025 0 0 -7.75 ]
[1.025 0 9.4375 7.75 ]
[.4875 .07725 -25 -7.75 ]
[.4875 .07725 0 7.75 ]
[.4875 .15451 -19 -7.75 ]
[.4875 .15451 0 7.75 ]
[.4875 .23176 -25 -7.75 ]
[.4875 .23176 0 7.75 ]
[.4875 .30902 -10 -7.75 ]
[.4875 .30902 0 7.75 ]
[.4875 .38627 -25 -7.75 ]
[.4875 .38627 0 7.75 ]
[.4875 .46353 -19 -7.75 ]
[.4875 .46353 0 7.75 ]
[.4875 .54078 -25 -7.75 ]
[.4875 .54078 0 7.75 ]
[.4875 .61803 -10 -7.75 ]
[.4875 .61803 0 7.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -73.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -66 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -86 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.25) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -86 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.75) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -86 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.25) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -80 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -86 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.75) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01433 m
.04262 .01582 L
.06244 .0177 L
.08255 .02007 L
.10458 .02341 L
.12415 .02731 L
.14509 .03288 L
.16639 .0407 L
.18653 .05088 L
.20651 .06459 L
.22495 .08128 L
.24367 .10286 L
.2643 .13222 L
.30459 .20086 L
.32312 .23086 L
.33292 .24402 L
.34336 .25482 L
.34632 .25715 L
.34911 .25901 L
.35182 .26049 L
.35432 .26156 L
.35669 .2623 L
.35789 .26257 L
.35921 .26279 L
.36053 .26291 L
.36127 .26295 L
.36194 .26295 L
.36325 .2629 L
.36449 .26276 L
.36564 .26256 L
.36692 .26225 L
.36824 .26184 L
.36949 .26137 L
.37172 .26031 L
.37412 .25887 L
.37958 .25437 L
.38458 .24878 L
.39439 .23382 L
.40351 .21542 L
.42421 .16103 L
.44294 .1044 L
.46325 .04801 L
.46865 .03566 L
.47436 .02427 L
.47965 .01549 L
.4846 .00896 L
.48922 .00441 L
.49182 .00255 L
.49419 .00129 L
.49554 .00076 L
Mistroke
.49678 .0004 L
.4975 .00024 L
.49815 .00013 L
.4989 5e-005 L
.49961 1e-005 L
.5009 3e-005 L
.50208 .00017 L
.50338 .00044 L
.50403 .00062 L
.50475 .00086 L
.50727 .00202 L
.50869 .00288 L
.51001 .00381 L
.51498 .00848 L
.5195 .01425 L
.5243 .02188 L
.53425 .04212 L
.54523 .07004 L
.56624 .13234 L
.58548 .18828 L
.59527 .21266 L
.60437 .23155 L
.61385 .24675 L
.61887 .25279 L
.62147 .25536 L
.62422 .25768 L
.62677 .25944 L
.62957 .26096 L
.6308 .26149 L
.63211 .26196 L
.63335 .26232 L
.63449 .26258 L
.63518 .26271 L
.63592 .26281 L
.63666 .26289 L
.63747 .26294 L
.63818 .26295 L
.63893 .26294 L
.63965 .2629 L
.6403 .26284 L
.64154 .26268 L
.64224 .26255 L
.64289 .26241 L
.64419 .26206 L
.64561 .26159 L
.64823 .26047 L
.65071 .25912 L
.65535 .25588 L
.66577 .24558 L
.67522 .23325 L
Mistroke
.68562 .21731 L
.70666 .18118 L
.72771 .14501 L
.74697 .11548 L
.76709 .08987 L
.78576 .07108 L
.80476 .05636 L
.82549 .04443 L
.84602 .03584 L
.86464 .03008 L
.8839 .02557 L
.90472 .02188 L
.92468 .01916 L
.94574 .01688 L
.97619 .01433 L
Mfstroke
[ .01 ] 0 setdash
.02381 .00221 m
.04262 .00243 L
.06244 .00269 L
.08426 .00305 L
.10458 .00346 L
.12414 .00395 L
.14264 .00455 L
.16305 .0054 L
.18163 .00644 L
.2016 .00794 L
.22004 .00981 L
.23877 .01232 L
.25939 .01597 L
.29968 .02603 L
.33845 .03727 L
.34856 .03966 L
.3539 .0407 L
.35959 .04161 L
.3624 .04197 L
.36505 .04225 L
.36743 .04246 L
.36866 .04254 L
.37001 .04262 L
.37127 .04268 L
.37246 .04272 L
.3737 .04275 L
.3744 .04276 L
.37504 .04276 L
.37618 .04276 L
.37742 .04274 L
.37859 .04271 L
.37968 .04267 L
.38086 .04262 L
.38209 .04254 L
.38431 .04236 L
.3867 .04211 L
.3893 .04177 L
.39399 .04096 L
.39834 .04 L
.4083 .03702 L
.41894 .03276 L
.43886 .02263 L
.46044 .01102 L
.47055 .00641 L
.47607 .00432 L
.48124 .0027 L
.48565 .0016 L
.48791 .00114 L
.49038 .00072 L
.49177 .00053 L
Mistroke
.49307 .00038 L
.49441 .00024 L
.49563 .00015 L
.49682 8e-005 L
.49795 3e-005 L
.49914 1e-005 L
.50042 0 L
.50167 2e-005 L
.50281 6e-005 L
.50412 .00013 L
.50536 .00022 L
.50756 .00045 L
.50995 .00077 L
.51259 .00123 L
.51538 .00183 L
.5204 .00318 L
.53043 .00682 L
.54148 .01198 L
.56249 .02337 L
.57169 .02826 L
.58173 .03306 L
.59087 .03673 L
.60062 .03974 L
.60601 .04096 L
.61091 .0418 L
.61327 .04211 L
.61583 .04237 L
.61701 .04247 L
.61825 .04256 L
.6194 .04263 L
.62047 .04268 L
.62169 .04272 L
.62233 .04274 L
.62301 .04275 L
.62416 .04276 L
.62542 .04276 L
.62654 .04274 L
.62775 .04271 L
.62889 .04267 L
.62994 .04262 L
.6323 .04248 L
.63488 .04226 L
.64009 .04165 L
.64467 .04095 L
.64958 .04004 L
.65841 .03806 L
.69988 .02616 L
.72066 .02049 L
.73983 .01613 L
.75849 .01275 L
Mistroke
.77826 .01 L
.79781 .00799 L
.81612 .00659 L
.83638 .00543 L
.85491 .00464 L
.87391 .00401 L
.89464 .00348 L
.91597 .00304 L
.9353 .00273 L
.97445 .00223 L
.97619 .00221 L
Mfstroke
[ .03 ] 0 setdash
.02381 .03823 m
.04262 .04254 L
.06244 .04816 L
.08255 .05544 L
.10458 .06604 L
.12415 .07875 L
.14509 .09723 L
.16639 .1232 L
.18653 .1566 L
.20651 .20028 L
.22495 .25119 L
.2643 .3913 L
.30213 .53657 L
.31208 .56802 L
.32154 .5925 L
.32676 .60322 L
.32951 .60799 L
.33245 .61235 L
.33516 .61569 L
s
.33516 .61569 m
.33753 .61803 L
s
.35467 .61803 m
.35695 .61568 L
.36236 .60772 L
.36726 .59769 L
.37262 .58367 L
.38342 .54606 L
.40304 .44991 L
.42399 .32114 L
.4439 .19479 L
.45438 .13448 L
.46548 .07981 L
.47539 .04155 L
.48102 .02496 L
.48372 .01843 L
.48629 .01312 L
.4886 .00909 L
.49112 .00553 L
.49341 .00305 L
.49443 .00218 L
.49553 .0014 L
.49683 .0007 L
.49806 .00027 L
.49925 4e-005 L
.50034 1e-005 L
.50153 .00017 L
.50284 .00057 L
.50349 .00086 L
.5042 .00124 L
.50547 .0021 L
.50804 .00453 L
.51077 .00811 L
.51567 .01708 L
.52094 .03027 L
.52675 .04885 L
.53714 .0917 L
.54688 .14136 L
.58562 .38219 L
.6053 .49467 L
.61571 .54253 L
.62142 .56444 L
.62681 .582 L
.63199 .59592 L
.63759 .60764 L
.64007 .6117 L
.64269 .61525 L
.64492 .61767 L
s
.64492 .61767 m
.64536 .61803 L
s
.66242 .61803 m
.66398 .6166 L
.66649 .61375 L
.67176 .60587 L
.67675 .59626 L
.68607 .57325 L
.70702 .50387 L
.74545 .35346 L
.76491 .28358 L
.78634 .21879 L
.80667 .17019 L
.82571 .13515 L
.84597 .10712 L
.8645 .08803 L
.8835 .07333 L
.90423 .0614 L
.92392 .05289 L
.94489 .04593 L
.97619 .03823 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005P3oool3000000<0oooo0`00
000c0?ooo`<00000K03oool3000003D0oooo0`0000030?ooo`<000007P3oool001L0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo01/0oooo000=0?ooo`L000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0:03oool7000000D0oooo00<000000?ooo`3o
ool0K03oool00`000000oooo0?ooo`0b0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01/0oooo000G0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo06`0oooo00<00000
0?ooo`3oool0<`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06`3o
ool001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0340oooo0P00
001]0?ooo`800000=P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
6`3oool001H0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000<`3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo03@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00007@3oool001L0oooo00<000000?ooo`3oool00P3oool3000003D0oooo0`00001/0?ooo`<00000
=03oool00`000000oooo0?ooo`020?ooo`<000007P3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo3P3oool200000140oooo003o0?ooo`d0oooo00@000000?ooo`3oool00000403oool00?l0
oooo3@3oool010000000oooo0?ooo`00000@0?ooo`004@3ooood000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`005P3oool4000000040?ooo`000000000000000080oooo0`0000020?oo
o`<000000P3oool3000000030?ooo`00000000000080000000<0oooo0000000000000P0000000`3o
ool000000000000;0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`030?ooo`80000000D0oooo0000003oool000000?ooo`05000000D0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo10000002
0?ooo`<000000P3oool3000000030?ooo`00000000000080000000<0oooo0000000000000P000000
0`3oool0000000000002000000060?ooo`00000000000000003oool000003@3oool5000000l0oooo
000F0?ooo`030000003oool0oooo0240oooo0P0000000`3oool0000000000002000000040?ooo`00
00000000000000/0oooo00<000000?ooo`3oool0<03oool200000080oooo0P0000000`3oool00000
0?ooo`020?ooo`050000003oool0oooo0?ooo`000000<@3oool00`000000oooo0?ooo`090?ooo`80
000000@0oooo00000000000000000P3oool3000002<0oooo00<000000?ooo`3oool0303oool01000
0000oooo0?ooo`00000?0?ooo`00A`3oool300000080oooo00<000000?ooo`3oool0<P3oool00`00
0000oooo0?ooo`020?ooo`8000000P3oool01@000000oooo0?ooo`3oool0000000@0oooo0P00000d
0?ooo`@0000000<0oooo000000000000?@3oool010000000oooo0?ooo`00000?0?ooo`005P3oool=
000002X0oooo0P0000000`3oool000000000000]0?ooo`800000103oool2000000<0oooo0P000002
0?ooo`8000001P3oool00`000000oooo0?ooo`0/0?ooo`<00000;@3oool:000000l0oooo0`00000?
0?ooo`008`3oool5000002X0oooo0P0000000`3oool000000000000V0?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`8000001P3oool20000
02L0oooo0`00000X0?ooo`X00000:`3oool002P0oooo1@00000Z0?ooo`8000008P3oool2000000L0
oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0000000T0
oooo00<000000?ooo`3oool07@3oool4000002L0oooo1@00000e0?ooo`00;@3oool5000002P0oooo
0`00000K0?ooo`030000003oool0oooo00T0oooo0P0000040?ooo`030000003oool0oooo00<0oooo
0P00000:0?ooo`8000006`3oool00`000000oooo0?ooo`0W0?ooo`<00000>P3oool00380oooo1000
000Y0?ooo`030000003oool0oooo01@0oooo0P00000;0?ooo`030000003oool0000000@0oooo0P00
00040?ooo`030000003oool0000000`0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?oo
o`02000002P0oooo0P00000m0?ooo`005P3oool3000001d0oooo0P00000X0?ooo`80000000<0oooo
0000000000003`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0000000=0?ooo`800000403oool2000002X0oooo0`00000o
0?ooo`006@3oool3000001`0oooo0P00000[0?ooo`80000000<0oooo0000000000000P000000103o
ool000000000000000020?ooo`8000003P3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00<0oooo00@000000?ooo`3oool00000403oool3000000<0oooo0P0000000`3oool000000000
0002000002/0oooo0P00000M0?ooo`<000008P3oool001`0oooo0P00000L0?ooo`800000<@3oool0
0`000000oooo0?ooo`0B0?ooo`030000003oool0oooo00D0oooo0P0000070?ooo`030000003oool0
oooo0180oooo0`00000_0?ooo`8000006`3oool4000002D0oooo000l0?ooo`800000@`3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0@@3oool20000
01`0oooo00<000000?ooo`3oool09`3oool003h0oooo00<000000?ooo`3oool0@03oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0?`3oool2000004P0
oooo000T0?ooo`<00000603oool2000003l0oooo00<000000?ooo`3oool01`3oool00`000000oooo
0?ooo`070?ooo`030000003oool0oooo03h0oooo00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`0^0?ooo`009`3oool2000001P0oooo0P00000m0?ooo`040000003oool0oooo000000H0oooo
0P0000080?ooo`030000003oool0oooo03`0oooo0P00000H0?ooo`800000<@3oool002T0oooo0P00
000H0?ooo`030000003oool0oooo02/0oooo0`0000030?ooo`030000003oool0000000@0000000H0
oooo00000000000000000?ooo`0000060?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool0>@3oool2000001P0oooo0P00000c0?ooo`00:`3oool00`000000oooo0?ooo`0F0?ooo`030000
003oool0oooo02T0oooo00D000000?ooo`3oool0oooo000000050?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`00000000001P3oool00`000000oooo0?ooo`050?ooo`040000003oool0
oooo000003X0oooo00<000000?ooo`3oool05P3oool2000003D0oooo00150?ooo`030000003oool0
oooo02P0oooo00D000000?ooo`3oool0oooo000000060?ooo`050000003oool0oooo0?ooo`000000
0P3oool2000000H0oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`00000i0?ooo`03
0000003oool0oooo01H0oooo00<000000?ooo`3oool0=@3oool004H0oooo00<000000?ooo`3oool0
9`3oool01@000000oooo0?ooo`3oool0000000L0oooo00@000000?ooo`3oool000000P3oool20000
00H0oooo0`0000050?ooo`050000003oool0oooo0?ooo`000000=`3oool00`000000oooo0?ooo`1?
0?ooo`00A`3oool00`000000oooo0?ooo`0V0?ooo`050000003oool0oooo0?ooo`000000203oool0
0`000000oooo000000020?ooo`8000001P3oool00`000000oooo0?ooo`060?ooo`040000003oool0
oooo000003L0oooo00<000000?ooo`3oool0C`3oool00340oooo00<000000?ooo`3oool0503oool0
0`000000oooo0?ooo`0U0?ooo`050000003oool0oooo0?ooo`000000203oool200000080oooo0P00
00070?ooo`030000003oool0oooo00H0oooo00D000000?ooo`3oool0oooo0000000e0?ooo`030000
003oool0oooo0500oooo000b0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0903o
ool01@000000oooo0?ooo`3oool0000000P0oooo0P0000000`3oool00000000000080?ooo`030000
003oool0oooo00H0oooo00D000000?ooo`3oool0oooo0000000d0?ooo`030000003oool0oooo01@0
oooo00<000000?ooo`3oool0>P3oool003<0oooo00<000000?ooo`3oool0503oool00`000000oooo
0?ooo`0S0?ooo`050000003oool0oooo0?ooo`000000103oool010000000oooo0?ooo`3oool20000
00030?ooo`000000oooo00P0oooo0P0000070?ooo`050000003oool0oooo0?ooo`000000<`3oool0
0`000000oooo0?ooo`0D0?ooo`030000003oool0oooo03/0oooo000d0?ooo`030000003oool0oooo
01@0oooo00<000000?ooo`3oool08`3oool3000000H0oooo0`000000103oool000000?ooo`3oool3
000000H0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool000000340oooo00<0
00000?ooo`3oool0503oool00`000000oooo0?ooo`0l0?ooo`00=@3oool00`000000oooo0?ooo`0D
0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0;
0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0m
0?ooo`00=P3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo02d0oooo00<000000?oo
o`3oool02P3oool2000000d0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo03h0oooo001=0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`0o0?ooo`00CP3oool00`000000oooo0?ooo`0[0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0[0?ooo`030000
003oool0oooo01@0oooo00<000000?ooo`3oool0?`3oool004l0oooo00<000000?ooo`3oool0:P3o
ool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0:@3o
ool00`000000oooo0?ooo`1G0?ooo`00D03oool00`000000oooo0?ooo`0X0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool01`3oool2000000h0oooo00<000000?ooo`3oool0:@3oool0
0`000000oooo0?ooo`1G0?ooo`00D03oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`1H0?ooo`00>P3oool00`000000
oooo0?ooo`0D0?ooo`030000003oool0oooo02L0oooo00D000000?ooo`3oool0oooo0000000:0?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0V0?oo
o`030000003oool0oooo05T0oooo000k0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3o
ool09@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3o
ool0FP3oool003/0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0U0?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0203oool2000000X0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0
@`3oool003`0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0Q0?ooo`@000000P3o
ool00`000000oooo00000002000000P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0503oool00`000000oooo0?oo
o`140?ooo`00?@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool00P0000040?ooo`040000003oool0oooo000000L0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool05@3o
ool00`000000oooo0?ooo`140?ooo`00?@3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo01l0oooo00<000000?ooo`3oool00P0000040?ooo`050000003oool0oooo0?ooo`0000001P3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool08P3o
ool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo04D0oooo000n0?ooo`030000003oool0
oooo01@0oooo00<000000?ooo`3oool07P3oool01@000000oooo0000003oool0000000P0oooo00<0
00000?ooo`3oool0103oool3000000T0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`0P0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0AP3oool005D0oooo00<00000
0?ooo`3oool07P3oool01@000000oooo0000003oool0000000P0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0503o
ool00`000000oooo0?ooo`160?ooo`00EP3oool00`000000oooo0?ooo`0M0?ooo`050000003oool0
00000?ooo`0000001`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0100oooo00<0
00000?ooo`3oool07`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo04L0oooo001F
0?ooo`030000003oool0oooo01d0oooo0P0000020?ooo`030000003oool0oooo00<0oooo0P000008
0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`1N
0?ooo`00E`3oool00`000000oooo0?ooo`0L0?ooo`8000000P3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo00L0oooo0P00000B0?ooo`030000003oool0oooo01d0oooo00<000000?oo
o`3oool0G`3oool005L0oooo00<000000?ooo`3oool07@3oool3000000L0oooo0`0000060?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1O0?ooo`00
F03oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0
H03oool00440oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool02P3oool2000001<0oooo00<000000?ooo`3oool06P3o
ool00`000000oooo0?ooo`1Q0?ooo`00@@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0
oooo01T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0
oooo00/0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo0640oooo00120?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0603oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02`3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`1:0?ooo`00@P3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01P0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo01@0
oooo00<000000?ooo`3oool0B`3oool004<0oooo00<000000?ooo`3oool05@3oool00`000000oooo
0?ooo`0F0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool02P3oool2000000`0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool0B`3oool004<0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?oo
o`0E0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?oo
o`0D0?ooo`030000003oool0oooo04`0oooo00140?ooo`030000003oool0oooo01D0oooo00<00000
0?ooo`3oool05@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00/0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01D0oooo00<00000
0?ooo`3oool05@3oool00`000000oooo0?ooo`1<0?ooo`00A03oool00`000000oooo0?ooo`0F0?oo
o`030000003oool0oooo01<0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0D0?oo
o`030000003oool0oooo04d0oooo001M0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3o
ool0503oool2000000d0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0C0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool0C@3oool005h0oooo00<000000?ooo`3oool0
403oool3000000<0oooo00D000000?ooo`3oool0oooo000000030?ooo`<00000203oool00`000000
oooo0?ooo`0F0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0IP3oool005h0oooo
00<000000?ooo`3oool03`3oool01@000000oooo0000003oool0000000H0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3o
ool0403oool00`000000oooo0?ooo`1W0?ooo`00G`3oool00`000000oooo0?ooo`0>0?ooo`800000
0P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
I`3oool00600oooo00<000000?ooo`3oool03@3oool200000080oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo0`00000G0?ooo`030000003o
ool0oooo00h0oooo00<000000?ooo`3oool0J03oool00600oooo00<000000?ooo`3oool03@3oool0
1@000000oooo0?ooo`3oool0000000H0oooo0P0000060?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool0603oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo06T0oooo0016
0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool02`3oool2000000<0oooo00<00000
0?ooo`3oool0103oool2000000D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0H
0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0J@3oool004H0oooo00<000000?oo
o`3oool06@3oool00`000000oooo0?ooo`0:0?ooo`8000000`3oool00`000000oooo0?ooo`040?oo
o`030000003oool000000080oooo0P0000080?ooo`8000003P3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1?0?oo
o`00A`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`00
00000`3oool00`000000oooo0?ooo`020?ooo`050000003oool000000?ooo`0000000P3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`080?ooo`8000006`3oool00`000000oooo0?ooo`1?0?ooo`00A`3oool00`000000
oooo0?ooo`0J0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool0oooo0`0000060?oo
o`@000000`3oool3000000H0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0:0?oo
o`8000001`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0500oooo00180?ooo`03
0000003oool0oooo01X0oooo0P0000050?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3o
ool03@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo0500oooo00180?ooo`030000
003oool0oooo01/0oooo1P00000>0?ooo`030000003oool0oooo00d0oooo0P00000?0?ooo`030000
003oool0oooo00`0oooo1P00000M0?ooo`030000003oool0oooo0500oooo00190?ooo`030000003o
ool0oooo02h0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0>0?ooo`030000003o
ool0oooo02l0oooo00<000000?ooo`3oool0D03oool004T0oooo00<000000?ooo`3oool0;P3oool0
0`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0;P3oool0
0`000000oooo0?ooo`1A0?ooo`00RP3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo
02h0oooo00<000000?ooo`3oool0D@3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00P03oool3000000L0oooo0P00002D0?ooo`00B`3oool00`000000oooo0?ooo`0[0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`2C0?ooo`00
B`3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo05<0oooo001<0?ooo`030000003o
ool0oooo02X0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`<000003`3o
ool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo05<0oooo001<0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00l0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`1D0?ooo`00C03oool00`00
0000oooo0?ooo`0Y0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`0?0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0E03oool004`0
oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo05@0
oooo001=0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool01@3oool2000000P0oooo
0P00000A0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0E03oool004d0oooo00<0
00000?ooo`3oool0:03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool0403oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo05D0oooo002:
0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`1E
0?ooo`00RP3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0800oooo002:0?ooo`80
0000U03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3o
ool008X0oooo00<000000?ooo`3oool0T`3oool004h0oooo00<000000?ooo`3oool09@3oool00`00
0000oooo0?ooo`0A0?ooo`800000U03oool004h0oooo00<000000?ooo`3oool09@3oool00`000000
oooo0?ooo`0A0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3oool0E`3oool004l0oooo
00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool0903oool00`000000oooo0?ooo`1G0?ooo`00C`3oool00`000000oooo0?oo
o`0T0?ooo`030000003oool0oooo0140oooo0P00000C0?ooo`030000003oool0oooo02<0oooo00<0
00000?ooo`3oool0F03oool004l0oooo00<000000?ooo`3oool07`3oool3000000050?ooo`000000
oooo0000003oool01@000000103oool000000000000000080?ooo`030000003oool0oooo0180oooo
00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1H0?ooo`00C`3oool00`000000oooo0?oo
o`0P0?ooo`040000003oool0oooo000000@0oooo00@000000?ooo`3oool00000103oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool08`3oool00`000000
oooo0?ooo`1H0?ooo`00D03oool00`000000oooo0?ooo`0O0?ooo`040000003oool0oooo000000D0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0180
oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1H0?ooo`00D03oool00`000000oooo
0?ooo`0O0?ooo`040000003oool0oooo000000H0oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`040?ooo`<000004P3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo05T0
oooo001b0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool08@3oool00`000000oooo
0?ooo`1I0?ooo`00LP3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo07d0oooo001b
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00P0000080?ooo`030000003oool0
oooo09<0oooo001a0?ooo`8000001P3oool01@000000oooo0?ooo`3oool000000080oooo00<00000
0?ooo`3oool01`3oool2000009@0oooo001b0?ooo`030000003oool0oooo00D0oooo0`0000040?oo
o`<000001P3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
DP3oool00`000000oooo0?ooo`0e0?ooo`030000003oool0oooo09<0oooo001B0?ooo`030000003o
ool0oooo01l0oooo00<000000?ooo`3oool04`3oool2000009@0oooo001C0?ooo`030000003oool0
oooo01h0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo01h0oooo00<000000?ooo`3oool0F`3oool005<0oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`0C0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`1K0?ooo`00D`3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01<0
oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo05`0
oooo001C0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0503oool2000001D0oooo
00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1L0?ooo`00E03oool00`000000oooo0?oo
o`0L0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0503oool00`000000oooo0?oo
o`0M0?ooo`030000003oool0oooo05`0oooo001D0?ooo`030000003oool0oooo01`0oooo00<00000
0?ooo`3oool0503oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01`0oooo00<00000
0?ooo`3oool0G03oool007<0oooo00<000000?ooo`3oool0503oool2000001H0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`1M0?ooo`00M`3oool3000000<0oooo00<000000?ooo`00
00000P0000080?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`1M0?ooo`00N03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1k0?ooo`00N03oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool007P0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`040?ooo`<00000T`3oool007P0oooo00<000000?oo
o`3oool0203oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo001F0?ooo`03
0000003oool0oooo01l0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo09<0oooo001F0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`050?ooo`800000203oool00`000000oooo0?ooo`2C0?ooo`00E`3o
ool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00<0oooo0P0000070?ooo`030000003o
ool0oooo00L0oooo0P00000b0?ooo`030000003oool0oooo05l0oooo001G0?ooo`030000003oool0
oooo01L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`<000001P3oool0
0`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0G`3oool0
05L0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo
01L0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`1O0?ooo`00E`3oool00`000000
oooo0?ooo`0F0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`0F0?ooo`030000003oool0oooo0600oooo001H0?ooo`030000003oool0oooo01D0oooo
00<000000?ooo`3oool05`3oool2000001P0oooo00<000000?ooo`3oool05P3oool00`000000oooo
0?ooo`1P0?ooo`00F03oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo01L0oooo00<0
00000?ooo`3oool05`3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo0600oooo001`
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0F
0?ooo`030000003oool0oooo0600oooo002:0?ooo`8000006@3oool00`000000oooo0?ooo`0E0?oo
o`030000003oool0oooo0600oooo002:0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3o
ool0N03oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3o
ool008X0oooo0P00002D0?ooo`00FP3oool00`000000oooo0?ooo`0D0?ooo`<000000`3oool01@00
0000oooo0?ooo`3oool0000000<0oooo0`0000080?ooo`030000003oool0oooo09<0oooo001J0?oo
o`030000003oool0oooo0180oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0T`3oool005X0oooo00<000000?oo
o`3oool04P3oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo0680oooo001J0?oo
o`030000003oool0oooo0140oooo00D000000?ooo`3oool0oooo000000090?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0103oool3000001X0oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`1R0?ooo`00F`3oool00`000000oooo0?ooo`0@0?ooo`050000003oool0oooo
0?ooo`0000002@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo06<0oooo001K0?oo
o`030000003oool0oooo0100oooo00D000000?ooo`3oool0oooo000000090?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo0100oooo00<000000?ooo`3oool0H`3oool005`0oooo00<000000?ooo`3oool03P3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00P0000080?oo
o`030000003oool0oooo01X0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`1T0?oo
o`00G03oool00`000000oooo0?ooo`0>0?ooo`040000003oool0oooo0?ooo`8000001P3oool01@00
0000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool01`3oool2000001`0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`1T0?ooo`00K@3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00D0oooo100000030?ooo`<000001P3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo00d0oooo00<000000?ooo`3oool0I@3oool008X0oooo00<000000?ooo`3o
ool06`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo06D0oooo002:0?ooo`800000
703oool00`000000oooo0?ooo`1e0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool0
0`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00GP3oool00`000000
oooo0?ooo`0Y0?ooo`800000U03oool005h0oooo00<000000?ooo`3oool02P3oool00`000000oooo
0?ooo`0L0?ooo`030000003oool0oooo09<0oooo001O0?ooo`030000003oool0oooo00P0oooo00<0
00000?ooo`3oool07@3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo06L0oooo001O
0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0N
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0J03oool00600oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0N0?ooo`8000007`3oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo06P0oooo001Q0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool04`3oool5000000H0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo06T0oooo001R0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
5@3oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo0200oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`1Z0?ooo`00HP3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo01H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0P0?ooo`030000
003oool0oooo0080oooo0P00001/0?ooo`00H`3oool01@000000oooo0?ooo`3oool0000001X0oooo
00<000000?ooo`3oool01@3oool300000240oooo00D000000?ooo`3oool0oooo0000001]0?ooo`00
P`3oool00`000000oooo0?ooo`2J0?ooo`00P`3oool00`000000oooo0?ooo`2J0?ooo`00P`3oool0
0`000000oooo0?ooo`2J0?ooo`00O`3oool01@000000oooo0?ooo`3oool0000009`0oooo00200?oo
o`<00000W@3oool00?l0oooo8@3oool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9695, -0.246249, \
0.086157, 0.0132767}}]
}, Open  ]],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    StyleBox[\(\(\ \)\(Here\ is\ the\ Exact\ Variance\  ... \)\(\ \)\),
      "Subtitle"]], "Input"],

Cell[BoxData[
    \(Exact\ Here\ is\ the\ Variance ... \)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\( (*\ sig\  = \ 2, \ k\  = \ 3/4\ *) \), "\[IndentingNewLine]", 
      RowBox[{\(pl1 = \ 
          Plot[\[IndentingNewLine]\ 
            NIntegrate[\ \ \((1/2 \((\ 
                          d\  - \ 
                            Sqrt[d^2\  - \ 
                                4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ \ phi[
                    d, \ th, \ 
                    2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                      2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
              NIntegrate[\ \((\ 
                      1/2 \((\ 
                          d\  + \ 
                            Sqrt[d^2\  - 
                                4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ \ phi[
                    d, \ th, \ 
                    2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                  Infinity}] - \ \((NIntegrate[\ \ 1/2 \((\ 
                          d\  - \ 
                            Sqrt[d^2\  - \ 
                                4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ phi[d, \ 
                          th, \ 2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
                    NIntegrate[\ 
                      1/2 \((\ 
                          d\  + \ 
                            Sqrt[d^2\  - 
                                4\ \ 2^2\ \((2\ 3/4 - 1)\)])\)\ \ phi[d, \ 
                          th, \ 2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[
                            2\ 3/4\  - 1], \ 
                        Infinity}])\)^2, \[IndentingNewLine]{th, \(-10\), 
              10}, \ PlotRange\  \[Rule] \ {0, \ 8}, \ 
            AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
            DefaultFont\  \[Rule] \ {"\<Times\>", 12}]\), 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", \( (*\ sig\  = \ 2, \ k\  = \ 0.6\ *) \), 
        "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"pl2", "=", " ", 
            RowBox[{"Plot", "[", "\[IndentingNewLine]", " ", 
              
              RowBox[{\(NIntegrate[\ \ \((1/2 \((\ 
                              d\  - \ 
                                Sqrt[d^2\  - \ 
                                    4\ \ 2^2\ \((2\ \ 0.6 - 
                                        1)\)])\))\)^2\ \ phi[d, \ th, \ 
                        2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ \ 0.6\  - 1]}]\  + \[IndentingNewLine]\ 
                  NIntegrate[\ \((\ 
                          1/2 \((\ 
                              d\  + \ 
                                Sqrt[d^2\  - 
                                    4\ \ 2^2\ \((2\ \ 0.6 - 
                                        1)\)])\))\)^2\ \ phi[d, \ th, \ 
                        2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ \ 0.6\  - 1], \ 
                      Infinity}] - \ \((NIntegrate[\ \ 1/2 \((\ 
                              d\  - \ 
                                Sqrt[d^2\  - \ 
                                    4\ \ 2^2\ \((2\ \ 0.6 - 1)\)])\)\ phi[
                              d, \ th, \ 
                              2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ \ 0.6\  - 1]}]\  + \[IndentingNewLine]\ 
                        NIntegrate[\ 
                          1/2 \((\ 
                              d\  + \ 
                                Sqrt[d^2\  - 
                                    4\ \ 2^2\ \((2\ \ 0.6 - 1)\)])\)\ \ phi[
                              d, \ th, \ 
                              2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[
                                2\ \ 0.6\  - 1], \ Infinity}])\)^2\), ",", 
                "\[IndentingNewLine]", \({th, \(-10\), 10}\), ",", 
                " ", \(PlotRange\  \[Rule] \ {0, \ 8}\), ",", 
                StyleBox[
                  RowBox[{" ", 
                    StyleBox[" ",
                      "Text"]}]], 
                StyleBox[\(AxesLabel\  \[Rule] \ {\[Theta], \ None}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(DefaultFont\  \[Rule] \ {"\<Roman\>", 12}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox["\[IndentingNewLine]",
                  "Text"], 
                
                StyleBox[\(PlotStyle \[Rule] {GrayLevel[0], 
                      Dashing[{ .01}]}\),
                  "Text"]}], 
              StyleBox["]",
                "Text"]}]}], 
          StyleBox[";",
            "Text"]}], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        "\[IndentingNewLine]", \( (*\ sig\  = \ 2, \ k\  = \ 0.9\ *) \), 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        RowBox[{
          RowBox[{"pl3", "=", " ", 
            RowBox[{"Plot", "[", "\[IndentingNewLine]", " ", 
              
              RowBox[{\(NIntegrate[\ \ \((1/2 \((\ 
                              d\  - \ 
                                Sqrt[d^2\  - \ 
                                    4\ \ 2^2\ \((2\ \ 0.9 - 
                                        1)\)])\))\)^2\ \ phi[d, \ th, \ 
                        2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ \ 0.9\  - 1]}]\  + \[IndentingNewLine]\ 
                  NIntegrate[\ \((\ 
                          1/2 \((\ 
                              d\  + \ 
                                Sqrt[d^2\  - 
                                    4\ \ 2^2\ \((2\ \ 0.9 - 
                                        1)\)])\))\)^2\ \ phi[d, \ th, \ 
                        2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ \ 0.9\  - 1], \ 
                      Infinity}] - \ \((NIntegrate[\ \ 1/2 \((\ 
                              d\  - \ 
                                Sqrt[d^2\  - \ 
                                    4\ \ 2^2\ \((2\ \ 0.9 - 1)\)])\)\ phi[
                              d, \ th, \ 
                              2^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 2)\)\)\ \ Sqrt[2\ \ 0.9\  - 1]}]\  + \[IndentingNewLine]\ 
                        NIntegrate[\ 
                          1/2 \((\ 
                              d\  + \ 
                                Sqrt[d^2\  - 
                                    4\ \ 2^2\ \((2\ \ 0.9 - 1)\)])\)\ \ phi[
                              d, \ th, \ 
                              2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[
                                2\ \ 0.9\  - 1], \ Infinity}])\)^2\), ",", 
                "\[IndentingNewLine]", \({th, \(-10\), 10}\), ",", 
                " ", \(PlotRange\  \[Rule] \ {0, \ 8}\), ",", 
                StyleBox[
                  RowBox[{" ", 
                    StyleBox[" ",
                      "Text"]}]], 
                StyleBox[\(AxesLabel\  \[Rule] \ {\[Theta], \ None}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(DefaultFont\  \[Rule] \ {"\<Roman\>", 12}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox["\[IndentingNewLine]",
                  "Text"], 
                
                StyleBox[\(PlotStyle \[Rule] {GrayLevel[0], 
                      Dashing[{ .03}]}\),
                  "Text"]}], 
              StyleBox["]",
                "Text"]}]}], 
          StyleBox[";",
            "Text"]}], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox[\(Show[pl1, \ pl2, \ pl3]\),
          "Text"]}]}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.0772542 [
[.02381 -0.0125 -12.1875 -15.5 ]
[.02381 -0.0125 12.1875 0 ]
[.2619 -0.0125 -9.1875 -15.5 ]
[.2619 -0.0125 9.1875 0 ]
[.7381 -0.0125 -5 -15.5 ]
[.7381 -0.0125 5 0 ]
[.97619 -0.0125 -8 -15.5 ]
[.97619 -0.0125 8 0 ]
[1.025 0 0 -7.75 ]
[1.025 0 9.4375 7.75 ]
[.4875 .07725 -10 -7.75 ]
[.4875 .07725 0 7.75 ]
[.4875 .15451 -10 -7.75 ]
[.4875 .15451 0 7.75 ]
[.4875 .23176 -10 -7.75 ]
[.4875 .23176 0 7.75 ]
[.4875 .30902 -10 -7.75 ]
[.4875 .30902 0 7.75 ]
[.4875 .38627 -10 -7.75 ]
[.4875 .38627 0 7.75 ]
[.4875 .46353 -10 -7.75 ]
[.4875 .46353 0 7.75 ]
[.4875 .54078 -10 -7.75 ]
[.4875 .54078 0 7.75 ]
[.4875 .61803 -10 -7.75 ]
[.4875 .61803 0 7.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -73.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -66 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .32535 m
.04262 .32755 L
.06244 .33056 L
.08255 .33463 L
.10458 .34073 L
.12415 .34805 L
.14509 .35836 L
.18653 .38733 L
.22646 .42277 L
.24474 .43805 L
.25514 .44537 L
.26022 .4484 L
.26488 .45081 L
.26945 .45279 L
.27443 .45446 L
.27717 .45514 L
.2785 .45541 L
.2797 .45562 L
.28087 .45579 L
.28213 .45594 L
.28282 .456 L
.28346 .45605 L
.28471 .45611 L
.28593 .45613 L
.28724 .45611 L
.28847 .45605 L
.28959 .45596 L
.29091 .45581 L
.29234 .45559 L
.29494 .45504 L
.29766 .45426 L
.30055 .45319 L
.30574 .45063 L
.31063 .44746 L
.31511 .44388 L
.32522 .43347 L
.33412 .4216 L
.3435 .4065 L
.3816 .32339 L
.42216 .22202 L
.4409 .18169 L
.46121 .14792 L
.4666 .14106 L
.47232 .13485 L
.47761 .13009 L
.48256 .12652 L
.48718 .12398 L
.48978 .12289 L
.49215 .1221 L
.49341 .12177 L
Mistroke
.49474 .12148 L
.49551 .12135 L
.49621 .12124 L
.49692 .12115 L
.49757 .12109 L
.49884 .121 L
.49951 .12098 L
.50022 .12098 L
.5014 .12101 L
.50271 .12111 L
.50402 .12127 L
.50523 .12148 L
.50656 .12176 L
.50796 .12214 L
.51033 .12293 L
.51294 .12403 L
.51775 .12671 L
.52226 .12998 L
.53233 .13982 L
.54318 .1542 L
.56326 .18999 L
.58438 .23761 L
.62254 .33362 L
.64383 .38222 L
.66315 .41747 L
.67281 .43105 L
.6779 .43702 L
.68327 .44244 L
.68798 .44642 L
.69315 .44998 L
.69785 .45249 L
.70225 .45423 L
.70484 .45499 L
.70724 .45551 L
.7085 .45572 L
.70988 .4559 L
.71057 .45597 L
.71132 .45604 L
.71203 .45608 L
.71268 .45611 L
.71387 .45613 L
.71498 .45612 L
.7162 .45607 L
.7175 .45597 L
.71815 .45591 L
.71887 .45583 L
.72016 .45564 L
.72257 .4552 L
.7248 .45467 L
.72726 .45395 L
Mistroke
.73222 .45211 L
.74112 .44764 L
.76055 .43388 L
.78143 .41567 L
.82268 .37994 L
.84328 .36533 L
.8624 .35435 L
.8809 .34596 L
.90062 .33911 L
.92204 .33359 L
.94222 .32977 L
.95992 .32722 L
.97619 .32535 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005P3oool3000000<0oooo0`00
000c0?ooo`<00000K03oool3000003D0oooo0`0000030?ooo`<000007P3oool001L0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo01/0oooo000=0?ooo`L000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0:03oool7000000D0oooo00<000000?ooo`3o
ool0K03oool00`000000oooo0?ooo`0b0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01/0oooo000G0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo06`0oooo00<00000
0?ooo`3oool0<`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06`3o
ool001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0340oooo0P00
001]0?ooo`800000=P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
6`3oool001H0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000<`3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo03@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00007@3oool001L0oooo00<000000?ooo`3oool00P3oool3000003D0oooo0`00001/0?ooo`<00000
=03oool00`000000oooo0?ooo`020?ooo`<000007P3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo3P3oool200000140oooo003o0?ooo`d0oooo00@000000?ooo`3oool00000403oool00?l0
oooo3@3oool010000000oooo0?ooo`00000@0?ooo`004@3ooood000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`005P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02`3oool5000000l0oooo000F0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0303oool010000000oooo0?ooo`00000?0?ooo`00RP3oool00`000000oooo
0?ooo`200?ooo`040000003oool0oooo000000l0oooo002:0?ooo`800000PP3oool3000000l0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0
T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool2000009@0oooo00200?ooo`<000001`3oool00`000000oooo0?ooo`2C
0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo00210?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`3oool0
1P3oool3000009<0oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3o
ool00840oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo00200?ooo`800000203oool2000009@0
oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?oo
o`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00Q`3o
ool800000940oooo00260?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?oo
o`2>0?ooo`00Q@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool0S@3oool008@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo08`0oooo00220?ooo`8000001P3oool2000000H0oooo00<000000?ooo`3o
ool0R`3oool007l0oooo1@0000060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
RP3oool00800oooo0P0000000`3oool000000?ooo`050?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool0RP3oool00800oooo0P0000080?ooo`030000003oool0oooo00L0oooo00<00000
0?ooo`3oool0R@3oool00800oooo00<000000?ooo`0000001`3oool3000000P0oooo00<000000?oo
o`3oool0R03oool007l0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0Q`3oool007h0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0Q`3oool007h0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0QP3oool007d0oooo00<000000?ooo`0000000`3oool00`000000oooo0?oo
o`040?ooo`8000002`3oool00`000000oooo0?ooo`260?ooo`00O@3oool00`000000oooo0?ooo`03
000000L0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`250?ooo`00O03oool00`00
0000oooo0?ooo`0;0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0Q03oool007/0
oooo00<000000?ooo`3oool0303oool2000000d0oooo00<000000?ooo`3oool0Q03oool007/0oooo
00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo08<0oooo
001j0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`230?ooo`00NP3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00h0oooo00<00000
0?ooo`3oool0PP3oool007T0oooo00<000000?ooo`3oool03P3oool2000000l0oooo00<000000?oo
o`3oool0PP3oool007T0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo0840oooo001h0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
3`3oool00`000000oooo0?ooo`210?ooo`00N03oool00`000000oooo0?ooo`0?0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0P@3oool007L0oooo00<000000?ooo`3oool0403oool2
00000140oooo00<000000?ooo`3oool0P03oool007L0oooo00<000000?ooo`3oool01@3oool40000
00L0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`200?ooo`00M`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`1o0?ooo`00MP3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1o0?ooo`00MP3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00@0oooo0`00000B0?ooo`030000003oool0oooo07h0oooo001f
0?ooo`030000003oool0oooo00P0oooo0P0000070?ooo`030000003oool0oooo0180oooo00<00000
0?ooo`3oool0OP3oool007D0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo0180oooo00<000000?ooo`3oool0OP3oool007D0oooo00<000000?ooo`3o
ool02`3oool00`000000oooo0?ooo`040?ooo`800000503oool00`000000oooo0?ooo`1m0?ooo`00
M03oool00`000000oooo0?ooo`080?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo07d0oooo001d0?ooo`030000003oool0oooo00T0oooo
0`0000070?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0O03oool007@0oooo00<0
00000?ooo`3oool04`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo07`0oooo001c
0?ooo`030000003oool0oooo01@0oooo0P00000E0?ooo`030000003oool0oooo07`0oooo001c0?oo
o`030000003oool0oooo01@0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`1k0?oo
o`00L`3oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool0N`3oool00780oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0F0?ooo`030000
003oool0oooo07X0oooo001b0?ooo`030000003oool0oooo01D0oooo0P00000G0?ooo`030000003o
ool0oooo07X0oooo001b0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool05P3oool0
0`000000oooo0?ooo`1j0?ooo`00L@3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo
01L0oooo00<000000?ooo`3oool0N@3oool00740oooo00<000000?ooo`3oool05P3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo07T0oooo001a0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool0103oool2000001P0oooo00<000000?ooo`3oool0N@3oool00700oooo00<0
00000?ooo`3oool0403oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo01P0oooo00<0
00000?ooo`3oool0N03oool00700oooo00<000000?ooo`3oool0303oool6000000D0oooo00<00000
0?ooo`3oool0603oool00`000000oooo0?ooo`1h0?ooo`00K`3oool00`000000oooo0?ooo`0=0?oo
o`050000003oool0oooo0?ooo`0000001P3oool3000001T0oooo00<000000?ooo`3oool0M`3oool0
06l0oooo00<000000?ooo`3oool03P3oool010000000oooo0?ooo`0000060?ooo`030000003oool0
oooo01T0oooo00<000000?ooo`3oool0M`3oool006l0oooo00<000000?ooo`3oool03`3oool00`00
0000oooo000000060?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0M`3oool006h0
oooo00<000000?ooo`3oool0403oool00`000000oooo000000060?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool0MP3oool001H0oooo0`00001E0?ooo`030000003oool0oooo0140oooo
0P0000060?ooo`8000006`3oool00`000000oooo0?ooo`1C0?ooo`8000008@3oool001T0oooo1@00
001?0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`0K0?ooo`030000003oool0oooo04T0oooo2@00000S0?ooo`007P3oool5000004X0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo04D0oooo1000000/
0?ooo`008`3oool5000004@0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0K0?oo
o`030000003oool0oooo04<0oooo0P00000`0?ooo`00:03oool400000400oooo00<000000?ooo`3o
ool06`3oool2000001d0oooo00<000000?ooo`3oool0?P3oool400000380oooo000/0?ooo`800000
?@3oool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0
>`3oool3000003H0oooo000^0?ooo`<00000>P3oool00`000000oooo0?ooo`0L0?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`3oool0>03oool2000003T0oooo000a0?ooo`800000=`3oool0
0`000000oooo0?ooo`0M0?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0=P3oool2
000003/0oooo000c0?ooo`800000=@3oool00`000000oooo0?ooo`0M0?ooo`8000007P3oool00`00
0000oooo0?ooo`0d0?ooo`800000?@3oool003D0oooo00<000000?ooo`3oool0<@3oool00`000000
oooo0?ooo`0N0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0<@3oool2000003l0
oooo000f0?ooo`800000<@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo01h0oooo
00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0o0?ooo`00>03oool00`000000oooo0?oo
o`0]0?ooo`030000003oool0oooo01l0oooo0P00000P0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool0@03oool003T0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0D
0?ooo`<00000203oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo02`0oooo0P000013
0?ooo`00>P3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo01P0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo02X0oooo00<000000?oo
o`3oool0@`3oool003/0oooo0P00000Z0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3o
ool0A03oool003d0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`0J0?ooo`030000
003oool0oooo00@0oooo0`00000Q0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool0
A@3oool003h0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0J0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0U0?ooo`800000B03o
ool003l0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0
oooo04P0oooo00100?ooo`8000008`3oool00`000000oooo0?ooo`0H0?ooo`800000203oool00`00
0000oooo0?ooo`0R0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0B@3oool00480
oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo00L0
oooo0P00000T0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0BP3oool004<0oooo
00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0J0?ooo`<000001P3oool00`000000oooo
0?ooo`0S0?ooo`030000003oool0oooo01h0oooo0P00001=0?ooo`00A03oool00`000000oooo0?oo
o`0L0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0903oool00`000000oooo0?oo
o`0L0?ooo`030000003oool0oooo04d0oooo00150?ooo`800000703oool00`000000oooo0?ooo`0T
0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`1>
0?ooo`00A`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo02D0oooo0P00000V0?oo
o`030000003oool0oooo01T0oooo00<000000?ooo`3oool0C`3oool004P0oooo00<000000?ooo`3o
ool05`3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3o
ool05`3oool00`000000oooo0?ooo`1@0?ooo`00B@3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo02H0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0E0?ooo`030000
003oool0oooo0540oooo001:0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool09P3o
ool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0DP3o
ool004/0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0W0?ooo`800000:@3oool0
0`000000oooo0?ooo`0B0?ooo`030000003oool0oooo05<0oooo001<0?ooo`030000003oool0oooo
00l0oooo0P00000Z0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool03`3oool20000
05H0oooo001=0?ooo`8000003P3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo02X0
oooo00<000000?ooo`3oool0303oool2000005P0oooo001?0?ooo`8000002`3oool00`000000oooo
0?ooo`0[0?ooo`800000;03oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo05P0oooo
001A0?ooo`800000203oool00`000000oooo0?ooo`0R0?ooo`<000001`3oool00`000000oooo0?oo
o`0/0?ooo`<000001`3oool2000005/0oooo001C0?ooo`P00000903oool01@000000oooo0?ooo`3o
ool0000000H0oooo00<000000?ooo`3oool0;`3oool7000005d0oooo001o0?ooo`050000003oool0
oooo0?ooo`0000001P3oool00`000000oooo0?ooo`2C0?ooo`00O`3oool01@000000oooo0?ooo`3o
ool0000000H0oooo0`00002C0?ooo`00O`3oool200000080oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`2C0?ooo`00O`3oool010000000oooo0000000000070?ooo`030000003oool0
oooo09<0oooo00200?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0T`3oool00840
oooo00<000000?ooo`3oool01P3oool2000009@0oooo00220?ooo`8000001P3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000
003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo
0P00002D0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo0021
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0T`3oool00880oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`2C0?ooo`00PP3oool00`000000oooo0?ooo`050?ooo`<0
0000T`3oool00880oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2C0?ooo`00PP3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09<0oooo00230?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0T`3oool007l0oooo00D000000?ooo`3oool0oooo00000006
0?ooo`800000U03oool00800oooo100000060?ooo`030000003oool0oooo09<0oooo002:0?ooo`03
0000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0T`3o
ool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0
oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?oo
o`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0oooo00200?ooo`<0
00001`3oool00`000000oooo0?ooo`2C0?ooo`00O`3oool01@000000oooo0?ooo`3oool0000000H0
oooo00<000000?ooo`3oool0T`3oool007l0oooo00D000000?ooo`3oool0oooo000000060?ooo`03
0000003oool0oooo09<0oooo00200?ooo`030000003oool0000000L0oooo0`00002C0?ooo`00P@3o
ool00`000000oooo0?ooo`2L0?ooo`00P03oool00`000000oooo0000002M0?ooo`00O`3oool01@00
0000oooo0?ooo`3oool0000009`0oooo001o0?ooo`050000003oool0oooo0?ooo`000000W03oool0
0800oooo0`00002M0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9695, -0.984998, \
0.086157, 0.0531067}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.0772542 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .07725 -9.6875 -7.875 ]
[.4875 .07725 0 7.875 ]
[.4875 .15451 -9.6875 -7.875 ]
[.4875 .15451 0 7.875 ]
[.4875 .23176 -9.6875 -7.875 ]
[.4875 .23176 0 7.875 ]
[.4875 .30902 -9.6875 -7.875 ]
[.4875 .30902 0 7.875 ]
[.4875 .38627 -9.6875 -7.875 ]
[.4875 .38627 0 7.875 ]
[.4875 .46353 -9.6875 -7.875 ]
[.4875 .46353 0 7.875 ]
[.4875 .54078 -9.6875 -7.875 ]
[.4875 .54078 0 7.875 ]
[.4875 .61803 -9.6875 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
[ .01 ] 0 setdash
.02381 .31501 m
.04262 .31568 L
.06244 .31655 L
.08255 .31768 L
.10458 .31931 L
.12415 .32125 L
.14509 .32402 L
.16639 .32779 L
.18653 .33241 L
.22495 .34413 L
.24439 .35103 L
.26581 .35837 L
.2756 .36125 L
.281 .36263 L
.28613 .36377 L
.29088 .36464 L
.29339 .36502 L
.29607 .36537 L
.29854 .36563 L
.30079 .36581 L
.30187 .36588 L
.30304 .36594 L
.30415 .36598 L
.30517 .36601 L
.30643 .36603 L
.30762 .36603 L
.3087 .36601 L
.30986 .36598 L
.31113 .36593 L
.31248 .36585 L
.3149 .36565 L
.31713 .36539 L
.31922 .36509 L
.32399 .36418 L
.32918 .36281 L
.33393 .3612 L
.34465 .35625 L
.35446 .35009 L
.36358 .34298 L
.38428 .32231 L
.42332 .27288 L
.44323 .24814 L
.45372 .2368 L
.46482 .22668 L
.47473 .21966 L
.48036 .21662 L
.48562 .21444 L
.4881 .21364 L
.49045 .21301 L
.49257 .21257 L
Mistroke
.49487 .21221 L
.49618 .21207 L
.49737 .21197 L
.49802 .21193 L
.49873 .21191 L
.50002 .21189 L
.50124 .2119 L
.50251 .21196 L
.50361 .21205 L
.5048 .21217 L
.50611 .21235 L
.50732 .21255 L
.51006 .21314 L
.51247 .21381 L
.51503 .21467 L
.52435 .21911 L
.52949 .2224 L
.53431 .22598 L
.54528 .2358 L
.58402 .28252 L
.6037 .30798 L
.62521 .3325 L
.63516 .34189 L
.64578 .35026 L
.6558 .35649 L
.66489 .36074 L
.66975 .36248 L
.67489 .36392 L
.67929 .36484 L
.68178 .36524 L
.68411 .36554 L
.6854 .36567 L
.6868 .36579 L
.68813 .36589 L
.68936 .36595 L
.69046 .36599 L
.69168 .36602 L
.69295 .36603 L
.69415 .36602 L
.69547 .36599 L
.69613 .36597 L
.69685 .36594 L
.69814 .36588 L
.69933 .3658 L
.70203 .36557 L
.70492 .36525 L
.71024 .36445 L
.71515 .3635 L
.72624 .36075 L
.74639 .35429 L
Mistroke
.78576 .34052 L
.82361 .32994 L
.84304 .32599 L
.86392 .32273 L
.88507 .32027 L
.90516 .31853 L
.92498 .31722 L
.94338 .31628 L
.97619 .31501 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005`3oool2000000@0oooo0`00
000d0?ooo`<00000K03oool3000003@0oooo0P0000040?ooo`<000007@3oool001P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0b0?ooo`040000003oool0oooo000006/0oooo
00@000000?ooo`3oool00000=@3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01`0oooo000H0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?oo
o`3oool00P00001Z0?ooo`030000003oool0oooo00800000=03oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000L0?ooo`00603oool01@000000oooo0?ooo`3oool000000080oooo0P00000f
0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0<P3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000L0?ooo`003P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02L0oooo1`0000050?ooo`800000K@3oool2000003@0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01X0oooo000H0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0`0?ooo`040000003oool0oooo000006/0
oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool06P3oool001P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000<P3oool4
000006/0oooo1000000e0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo000H
0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0f0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo
000G0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0e0?ooo`8000000`3oool2000000030?ooo`000000oooo01`0oooo000H
0?ooo`030000003oool0oooo0080oooo0`00000c0?ooo`<00000K03oool3000003H0oooo00<00000
0?ooo`3oool00P3oool3000001d0oooo003o0?ooob40oooo003o0?ooo`h0oooo0P00000A0?ooo`00
o`3oool=0?ooo`040000003oool0oooo00000100oooo003o0?ooo`d0oooo00@000000?ooo`3oool0
0000403oool00140oooom00000070?ooo`050000003oool0oooo0?ooo`0000003`3oool001L0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00/0oooo
1@00000?0?ooo`005`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00`0oooo00@0
00000?ooo`3oool000003`3oool008X0oooo00<000000?ooo`3oool0P03oool010000000oooo0?oo
o`00000?0?ooo`00RP3oool200000880oooo0`00000?0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo
00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool00880oooo0P000006
0?ooo`800000U03oool008<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2C0?oo
o`00P`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo00230?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008<0oooo00<000000?ooo`3oool0103o
ool3000009<0oooo00230?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool0
08<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2C0?ooo`00P`3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo09<0oooo00220?ooo`8000001P3oool2000009@0oooo
00230?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<00000
0?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00
RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2
000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0
oooo002:0?ooo`030000003oool0oooo09<0oooo00230?ooo`8000001@3oool2000009@0oooo0021
0?ooo`<0000000<0oooo0000003oool00`3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo00210?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0T`3oool00880oooo0P0000060?ooo`<00000T`3oool008@0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`2C0?ooo`00Q03oool2000000@0oooo00<00000
0?ooo`3oool0T`3oool00840oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0
oooo09<0oooo00210?ooo`030000003oool0oooo00800000103oool2000009@0oooo00220?ooo`<0
00001@3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3o
ool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo
09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008L0oooo00<000000?oo
o`0000000`00002C0?ooo`00PP3oool5000000<0oooo0P0000020?ooo`030000003oool0oooo08l0
oooo00210?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`020?ooo`800000
S`3oool00840oooo0`0000000`3oool000000?ooo`030?ooo`030000003oool0oooo00D0oooo0P00
002<0?ooo`00P@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`2:0?ooo`00Q03oool00`000000oooo0?ooo`030?ooo`<000001`3oool0
0`000000oooo0?ooo`290?ooo`00O`3oool010000000oooo0?ooo`3oool2000000D0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`270?ooo`00OP3oool00`000000oooo0?ooo`030?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`270?oo
o`00O@3oool01@000000oooo0?ooo`3oool000000080oooo0P0000040?ooo`8000002`3oool00`00
0000oooo0?ooo`260?ooo`00O03oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo0000
00D0oooo00<000000?ooo`3oool0T`3oool007/0oooo00<000000?ooo`3oool0103oool3000000D0
oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`240?ooo`00NP3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0Q03oool008X0oooo0P00
000>0?ooo`030000003oool0oooo08<0oooo001i0?ooo`030000003oool0oooo00h0oooo00<00000
0?ooo`3oool0T`3oool007P0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0?0?oo
o`030000003oool0oooo0840oooo001g0?ooo`8000004@3oool00`000000oooo0?ooo`0@0?ooo`03
0000003oool0oooo0800oooo002:0?ooo`8000004P3oool00`000000oooo0?ooo`1o0?ooo`00MP3o
ool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo09<0oooo001e0?ooo`030000003oool0
oooo0180oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`1n0?ooo`00M03oool00`00
0000oooo0?ooo`0C0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0O@3oool008<0
oooo0P0000050?ooo`8000005@3oool00`000000oooo0?ooo`1l0?ooo`00L`3oool00`000000oooo
0?ooo`0=0?ooo`8000001@3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo07/0oooo
001b0?ooo`030000003oool0oooo00h0oooo0P0000050?ooo`030000003oool0oooo01H0oooo00<0
00000?ooo`3oool0NP3oool00740oooo00<000000?ooo`3oool03@3oool4000000D0oooo0`00000G
0?ooo`030000003oool0oooo07T0oooo00210?ooo`040000003oool00000000000D0oooo00<00000
0?ooo`3oool0T`3oool001L0oooo0`0000020?ooo`<000000P3oool00`000000oooo0?ooo`1<0?oo
o`030000003oool0oooo00l0oooo0`0000050?ooo`030000003oool0oooo01P0oooo00<000000?oo
o`3oool0BP3oool300000080oooo0`0000000`3oool000000000000200000240oooo000R0?ooo`80
00000P3oool3000000030?ooo`000000000000800000@@3oool00`000000oooo0?ooo`0@0?ooo`<0
00001@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo03l0oooo0`0000020?ooo`<0
0000<03oool002l0oooo100000000`3oool000000000000h0?ooo`030000003oool0oooo0180oooo
0P0000050?ooo`8000006`3oool00`000000oooo0?ooo`0f0?ooo`80000000<0oooo000000000000
0P00000i0?ooo`00=P3oool2000000030?ooo`000000oooo0380oooo00<000000?ooo`3oool04`3o
ool2000000D0oooo00<000000?ooo`3oool0C@3oool3000000030?ooo`00000000000400oooo000j
0?ooo`8000000P3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo01D0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`0K0?ooo`800000;@3oool00`000000oooo0?ooo`16
0?ooo`00?`3oool2000000030?ooo`000000000002L0oooo00<000000?ooo`3oool0703oool00`00
0000oooo0?ooo`0L0?ooo`030000003oool0oooo02H0oooo0P0000000`3oool00000000000190?oo
o`00A03oool2000002<0oooo00<000000?ooo`3oool07P3oool2000001h0oooo00<000000?ooo`3o
ool08`3oool2000004h0oooo00170?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
7P3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
C`3oool004P0oooo0P00000M0?ooo`8000008@3oool00`000000oooo0?ooo`0P0?ooo`030000003o
ool0oooo01T0oooo00<000000?ooo`3oool00P00001B0?ooo`00C03oool3000003/0oooo00<00000
0?ooo`3oool08@3oool00`000000oooo0?ooo`0F0?ooo`800000E`3oool00500oooo0P00000C0?oo
o`030000003oool0oooo0280oooo0P00000T0?ooo`030000003oool0oooo0180oooo00<000000?oo
o`3oool0F03oool00580oooo00<000000?ooo`3oool0303oool010000000oooo00000000000U0?oo
o`030000003oool0oooo02@0oooo0P00000=0?ooo`030000003oool0oooo00800000F`3oool005D0
oooo0`0000020?ooo`<0000000<0oooo0000000000000P00000X0?ooo`030000003oool0oooo02L0
oooo100000000`3oool0000000000002000000030?ooo`00000000000600oooo00220?ooo`<00000
1@3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool010000000oooo0?ooo`0000050?ooo`800000
U03oool00840oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo09<0oooo0025
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0T`3oool008@0oooo0P0000040?oo
o`<00000T`3oool00840oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`2C0?oo
o`00P@3oool4000000D0oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`060?ooo`800000U03o
ool00840oooo0`0000060?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo
09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<0
00000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?oo
o`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00PP3oool3000000D0oooo0P00002D0?ooo`00P@3oool20000
00030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`3o
ool00P0000040?ooo`030000003oool0oooo09<0oooo00210?ooo`050000003oool0oooo0?ooo`00
0000103oool00`000000oooo0?ooo`2C0?ooo`00P@3oool00`000000oooo0?ooo`02000000@0oooo
0`00002C0?ooo`00P@3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0T`3o
ool00840oooo00<000000?ooo`0000001P3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool01000
0000oooo0?ooo`0000050?ooo`030000003oool0oooo09<0oooo00220?ooo`030000003oool00000
00D0oooo0P00002D0?ooo`00PP3oool3000000D0oooo00<000000?ooo`3oool0T`3oool008X0oooo
00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008<0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2C0?ooo`00P`3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo09<0oooo00230?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool0T`3oool008<0oooo00<000000?ooo`3oool0103oool3000009<0oooo00240?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0T`3oool008@0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`2C0?ooo`00P@3oool01@000000oooo0?ooo`3oool0000000@0oooo
00<000000?ooo`3oool0T`3oool00840oooo00<000000?ooo`0000000P0000040?ooo`800000U03o
ool00840oooo0P0000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0T`3oool0
08X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000
003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo00220?ooo`<000001@3oool2
000009@0oooo00210?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`2C0?oo
o`00P@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0T`3oool00840
oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo09<0oooo00210?ooo`03
0000003oool0oooo00800000103oool3000009<0oooo00220?ooo`<00000V`3oool00840oooo0P00
00000`3oool000000?ooo`2J0?ooo`00P@3oool00`000000oooo0?ooo`02000009X0oooo00210?oo
o`80000000<0oooo0000003oool0VP3oool00880oooo0`00002K0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9865, -1.00032, \
0.0863677, 0.0532366}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.0772542 [
[.02381 -0.0125 -11.875 -15.75 ]
[.02381 -0.0125 11.875 0 ]
[.2619 -0.0125 -9.03125 -15.75 ]
[.2619 -0.0125 9.03125 0 ]
[.7381 -0.0125 -4.84375 -15.75 ]
[.7381 -0.0125 4.84375 0 ]
[.97619 -0.0125 -7.6875 -15.75 ]
[.97619 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .07725 -9.6875 -7.875 ]
[.4875 .07725 0 7.875 ]
[.4875 .15451 -9.6875 -7.875 ]
[.4875 .15451 0 7.875 ]
[.4875 .23176 -9.6875 -7.875 ]
[.4875 .23176 0 7.875 ]
[.4875 .30902 -9.6875 -7.875 ]
[.4875 .30902 0 7.875 ]
[.4875 .38627 -9.6875 -7.875 ]
[.4875 .38627 0 7.875 ]
[.4875 .46353 -9.6875 -7.875 ]
[.4875 .46353 0 7.875 ]
[.4875 .54078 -9.6875 -7.875 ]
[.4875 .54078 0 7.875 ]
[.4875 .61803 -9.6875 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
[ .03 ] 0 setdash
.02381 .33821 m
.04262 .34302 L
.06244 .3498 L
.08255 .3591 L
.10458 .37293 L
.12415 .38909 L
.14509 .41078 L
.18653 .46492 L
.2073 .49364 L
.22646 .51691 L
.23609 .5262 L
.24511 .53286 L
.24964 .53533 L
.25197 .53634 L
.25452 .53725 L
.25596 .53767 L
.25729 .53799 L
.25867 .53826 L
.25993 .53844 L
.26116 .53856 L
.26232 .53863 L
.26355 .53864 L
.26424 .53862 L
.26488 .53859 L
.26614 .53848 L
.26734 .53832 L
.26841 .53813 L
.26958 .53787 L
.27219 .53709 L
.27461 .53611 L
.27902 .53372 L
.2837 .53029 L
.28877 .52551 L
.29352 .52002 L
.30437 .5039 L
.32455 .46132 L
.34305 .4104 L
.38268 .28302 L
.42079 .17089 L
.4404 .127 L
.4513 .10772 L
.46135 .09334 L
.47159 .08209 L
.47698 .07755 L
.48269 .07379 L
.48508 .07253 L
.48765 .07138 L
.48987 .07057 L
.49229 .06986 L
.49376 .06953 L
Mistroke
.49512 .06928 L
.49642 .0691 L
.49715 .06903 L
.4978 .06897 L
.49905 .06891 L
.49976 .06889 L
.5004 .06889 L
.50159 .06893 L
.50284 .06902 L
.50407 .06916 L
.5054 .06937 L
.50782 .06989 L
.51017 .07058 L
.51235 .07138 L
.51728 .07377 L
.52252 .07718 L
.53125 .08486 L
.54087 .09622 L
.56025 .12826 L
.58112 .17575 L
.62232 .2993 L
.66199 .42519 L
.682 .4768 L
.69072 .49497 L
.70015 .51122 L
.70542 .51867 L
.71027 .52448 L
.7152 .52934 L
.7198 .53295 L
.72466 .53577 L
.72723 .53688 L
.72999 .53776 L
.73138 .53808 L
.73211 .53823 L
.73288 .53835 L
.73356 .53845 L
.73431 .53853 L
.73563 .53862 L
.7369 .53864 L
.73762 .53863 L
.73828 .5386 L
.73949 .5385 L
.74077 .53834 L
.742 .53813 L
.74333 .53785 L
.74576 .53716 L
.75029 .53536 L
.75559 .53242 L
.76048 .52899 L
.77884 .511 L
Mistroke
.81821 .45826 L
.85607 .40946 L
.87712 .38792 L
.89638 .37224 L
.91627 .35974 L
.93517 .35077 L
.95499 .34374 L
.97338 .33884 L
.97619 .33821 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005`3oool2000000@0oooo0`00
000d0?ooo`<00000K03oool3000003@0oooo0P0000040?ooo`<000007@3oool001P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0b0?ooo`040000003oool0oooo000006/0oooo
00@000000?ooo`3oool00000=@3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
01`0oooo000H0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?oo
o`3oool00P00001Z0?ooo`030000003oool0oooo00800000=03oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000L0?ooo`00603oool01@000000oooo0?ooo`3oool000000080oooo0P00000f
0?ooo`030000003oool0oooo06`0oooo00<000000?ooo`3oool0<P3oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000L0?ooo`003P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo02L0oooo1`0000050?ooo`800000K@3oool2000003@0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo01X0oooo000H0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0`0?ooo`040000003oool0oooo000006/0
oooo00@000000?ooo`3oool00000=@3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool06P3oool001P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000<P3oool4
000006/0oooo1000000e0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo000H
0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0f0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000001`0oooo
000G0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0e0?ooo`8000000`3oool2000000030?ooo`000000oooo01`0oooo000H
0?ooo`030000003oool0oooo0080oooo0`00000c0?ooo`<00000K03oool3000003H0oooo00<00000
0?ooo`3oool00P3oool3000001d0oooo003o0?ooob40oooo003o0?ooo`h0oooo0P00000A0?ooo`00
o`3oool=0?ooo`040000003oool0oooo00000100oooo003o0?ooo`d0oooo00@000000?ooo`3oool0
0000403oool00140oooom00000070?ooo`050000003oool0oooo0?ooo`0000003`3oool001L0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00/0oooo
1@00000?0?ooo`005`3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo03L0oooo00<0
00000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00`0oooo00@0
00000?ooo`3oool000003`3oool008X0oooo00<000000?ooo`3oool0P03oool010000000oooo0?oo
o`00000?0?ooo`00RP3oool200000880oooo0`00000?0?ooo`00RP3oool00`000000oooo0?ooo`2C
0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00
RP3oool2000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0
oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo
00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool00880oooo0P000006
0?ooo`800000U03oool008<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2C0?oo
o`00P`3oool00`000000oooo0?ooo`030?ooo`<00000U03oool008<0oooo00<000000?ooo`3oool0
0P0000020?ooo`030000003oool0oooo09<0oooo00230?ooo`030000003oool0000000@0oooo0`00
002C0?ooo`00P`3oool2000000D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2<
0?ooo`00PP3oool2000000H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2;0?oo
o`00PP3oool2000000H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`2:0?ooo`00
P@3oool3000000H0oooo0P0000070?ooo`030000003oool0oooo08X0oooo00230?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`290?ooo`00RP3oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo08T0oooo002:0?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool0R03oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00O@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo09<0oooo001l
0?ooo`030000003oool0oooo00/0oooo0P00002D0?ooo`00O03oool00`000000oooo0?ooo`0;0?oo
o`030000003oool0oooo09<0oooo001k0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool0303oool00`000000oooo0?ooo`240?ooo`00N`3oool00`000000oooo0?ooo`0<0?ooo`030000
003oool0oooo00`0oooo00<000000?ooo`3oool0Q03oool007X0oooo00<000000?ooo`3oool01P3o
ool2000000D0oooo0P00000>0?ooo`030000003oool0oooo08<0oooo001j0?ooo`030000003oool0
oooo00@0oooo0`0000000`3oool000000?ooo`030?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0P`3oool00840oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0>0?oo
o`030000003oool0oooo0880oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`220?ooo`00PP3oool2000000H0oooo0`00000?0?ooo`030000
003oool0oooo0840oooo00240?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool03`3o
ool00`000000oooo0?ooo`210?ooo`00Q03oool2000000@0oooo00<000000?ooo`3oool0T`3oool0
0840oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo09<0oooo001g0?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool00P0000040?ooo`800000U03oool007L0
oooo00<000000?ooo`3oool0203oool3000000D0oooo00<000000?ooo`3oool0T`3oool007H0oooo
00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`2C0?ooo`00MP3oool00`000000oooo0?oo
o`0A0?ooo`800000U03oool007H0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0B
0?ooo`030000003oool0oooo07h0oooo001f0?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool04P3oool00`000000oooo0?ooo`1n0?ooo`00M@3oool00`000000oooo0?ooo`0B0?ooo`03
0000003oool0oooo01<0oooo00<000000?ooo`3oool0O@3oool007D0oooo00<000000?ooo`3oool0
4P3oool2000001@0oooo00<000000?ooo`3oool0O@3oool008X0oooo00<000000?ooo`3oool04`3o
ool00`000000oooo0?ooo`1m0?ooo`00RP3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0
oooo07d0oooo002:0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0O03oool00880
oooo0`0000050?ooo`8000005@3oool00`000000oooo0?ooo`1l0?ooo`00P@3oool00`000000oooo
0?ooo`02000000@0oooo00<000000?ooo`3oool0T`3oool00840oooo00D000000?ooo`3oool0oooo
000000040?ooo`030000003oool0oooo09<0oooo001b0?ooo`030000003oool0oooo0100oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`2C0?ooo`00LP3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo00<0oooo0`00002C0?ooo`00L@3oool00`000000oooo0?ooo`0?0?oo
o`8000001@3oool00`000000oooo0?ooo`2C0?ooo`00L@3oool00`000000oooo0?ooo`0@0?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`1j0?ooo`00
L@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00800000103oool2000001L0oooo
00<000000?ooo`3oool0NP3oool00740oooo00<000000?ooo`3oool03@3oool010000000oooo0?oo
o`0000050?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0N@3oool00700oooo00<0
00000?ooo`3oool03`3oool3000000D0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?oo
o`1i0?ooo`00L03oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo01P0oooo00<00000
0?ooo`3oool0N03oool008X0oooo0P00000I0?ooo`030000003oool0oooo07P0oooo002:0?ooo`03
0000003oool0oooo01T0oooo00<000000?ooo`3oool0M`3oool008X0oooo00<000000?ooo`3oool0
6@3oool00`000000oooo0?ooo`1g0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2
000009@0oooo002:0?ooo`030000003oool0oooo09<0oooo001^0?ooo`030000003oool0oooo01T0
oooo00<000000?ooo`3oool0T`3oool006h0oooo00<000000?ooo`3oool06@3oool00`000000oooo
0?ooo`2C0?ooo`00K@3oool00`000000oooo0?ooo`0C0?ooo`8000001@3oool2000009@0oooo001]
0?ooo`030000003oool0oooo01<0oooo0P0000050?ooo`030000003oool0oooo01/0oooo00<00000
0?ooo`3oool0M@3oool006`0oooo00<000000?ooo`3oool0503oool2000000D0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`1e0?ooo`00K03oool00`000000oooo0?ooo`0B0?ooo`@0
00001@3oool3000001`0oooo00<000000?ooo`3oool0M03oool006/0oooo00<000000?ooo`3oool0
4`3oool010000000oooo0000000000050?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3o
ool0M03oool006/0oooo00<000000?ooo`3oool0503oool3000000D0oooo00<000000?ooo`3oool0
703oool00`000000oooo0?ooo`1d0?ooo`00PP3oool3000000D0oooo00<000000?ooo`3oool0703o
ool00`000000oooo0?ooo`1d0?ooo`00P`3oool2000000D0oooo0P00000N0?ooo`030000003oool0
oooo07<0oooo00230?ooo`8000001@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo
07<0oooo00240?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0T`3oool008X0oooo
00<000000?ooo`3oool0T`3oool001L0oooo0`00001`0?ooo`800000U03oool006T0oooo00<00000
0?ooo`3oool07P3oool00`000000oooo0?ooo`1[0?ooo`8000009P3oool00200oooo00<000000?oo
o`3oool0AP3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo06T0oooo0P00000X0?oo
o`008@3oool2000004D0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1W0?ooo`80
0000:P3oool002<0oooo0P0000130?ooo`030000003oool0oooo01l0oooo0P00000P0?ooo`030000
003oool0oooo04<0oooo0P00000/0?ooo`009@3oool00`000000oooo0?ooo`100?ooo`030000003o
ool0oooo01l0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`1a0?ooo`009P3oool0
0`000000oooo0?ooo`0o0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0803oool0
0`000000oooo0?ooo`1`0?ooo`00I`3oool00`000000oooo0?ooo`0H0?ooo`<000001@3oool00`00
0000oooo0?ooo`0P0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0<@3oool006L0
oooo00<000000?ooo`3oool05`3oool010000000oooo0?ooo`0000050?ooo`8000008P3oool00`00
0000oooo0?ooo`0j0?ooo`030000003oool0oooo0380oooo00210?ooo`030000003oool0oooo0080
0000103oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo03T0oooo00<000000?ooo`3o
ool0<`3oool002`0oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo0280oooo00<000000?ooo`3oool0=P3oool2000003H0oooo000]0?ooo`800000E@3o
ool2000000@0oooo0`00000R0?ooo`030000003oool0oooo03D0oooo00<000000?ooo`3oool0=P3o
ool002l0oooo00<000000?ooo`3oool0C`3oool010000000oooo0?ooo`0000050?ooo`030000003o
ool0oooo05T0oooo00<000000?ooo`3oool0=`3oool00300oooo00<000000?ooo`3oool0CP3oool4
000000D0oooo00<000000?ooo`3oool0T`3oool00340oooo00<000000?ooo`3oool0C@3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo09<0oooo000b0?ooo`030000003oool0oooo0300
oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`060?ooo`800000U03oool006@0oooo
00<000000?ooo`3oool06P3oool3000000H0oooo00<000000?ooo`3oool0T`3oool006@0oooo00<0
00000?ooo`3oool08`3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo03`0oooo001T
0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0/
0?ooo`030000003oool0oooo03d0oooo001T0?ooo`030000003oool0oooo02<0oooo0P00000U0?oo
o`030000003oool0oooo02/0oooo00<000000?ooo`3oool0?P3oool003H0oooo00<000000?ooo`3o
ool0:P3oool00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3o
ool0:@3oool00`000000oooo0?ooo`0o0?ooo`00=`3oool00`000000oooo0?ooo`0Y0?ooo`030000
003oool0oooo02@0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0Y0?ooo`030000
003oool0oooo03l0oooo000h0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0903o
ool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0@03o
ool003P0oooo00<000000?ooo`3oool0C`3oool2000002H0oooo00<000000?ooo`3oool09`3oool0
0`000000oooo0?ooo`110?ooo`00>@3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo
02H0oooo00<000000?ooo`3oool0JP3oool003X0oooo00<000000?ooo`3oool0C@3oool00`000000
oooo0?ooo`0V0?ooo`030000003oool0oooo06X0oooo000k0?ooo`030000003oool0oooo04@0oooo
0`0000050?ooo`800000U03oool00840oooo0P0000000`3oool000000?ooo`040?ooo`030000003o
ool0oooo09<0oooo001P0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool00P000004
0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0A@3oool00600oooo00<000000?oo
o`3oool07P3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0B`3oool0
0`000000oooo0?ooo`150?ooo`00H03oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo
00800000103oool3000004X0oooo00<000000?ooo`3oool0AP3oool005l0oooo00<000000?ooo`3o
ool07`3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0B@3oool00`000000
oooo0?ooo`170?ooo`00?`3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo01l0oooo
00<000000?ooo`0000001P3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo01d0oooo
00<000000?ooo`3oool0A`3oool00400oooo00<000000?ooo`3oool06`3oool00`000000oooo0?oo
o`0P0?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0:P3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo04P0oooo00110?ooo`030000003oool0oooo01X0oooo00<0
00000?ooo`3oool08@3oool00`000000oooo000000050?ooo`800000:`3oool00`000000oooo0?oo
o`0J0?ooo`030000003oool0oooo04T0oooo00110?ooo`030000003oool0oooo01T0oooo00<00000
0?ooo`3oool08P3oool3000000D0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`1U
0?ooo`00@P3oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo02/0oooo00<000000?oo
o`3oool0I@3oool004<0oooo00<000000?ooo`3oool0A03oool00`000000oooo0?ooo`0/0?ooo`03
0000003oool0oooo06@0oooo00130?ooo`030000003oool0oooo04@0oooo0P00000]0?ooo`030000
003oool0oooo06@0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0
oooo0480oooo00<000000?ooo`3oool0CP3oool005X0oooo00<000000?ooo`3oool0;@3oool20000
0480oooo00<000000?ooo`3oool0C`3oool005T0oooo00<000000?ooo`3oool0;P3oool00`000000
oooo0?ooo`110?ooo`030000003oool0oooo04l0oooo00180?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo0500oooo
00190?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?oo
o`0`0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0D@3oool004X0oooo00<00000
0?ooo`3oool02P3oool00`000000oooo0?ooo`0`0?ooo`800000<@3oool00`000000oooo0?ooo`0;
0?ooo`030000003oool0oooo0580oooo001;0?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool0:P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0340oooo0P00000:0?oo
o`030000003oool0oooo05<0oooo001<0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool0:`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3o
ool0G@3oool004d0oooo0P00000d0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
=03oool3000005`0oooo00230?ooo`030000003oool0oooo00@0oooo0`00002C0?ooo`00Q03oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo09<0oooo00240?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0T`3oool00840oooo00D000000?ooo`3oool0oooo000000040?oo
o`030000003oool0oooo09<0oooo00210?ooo`030000003oool0000000800000103oool2000009@0
oooo00210?ooo`8000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo09<0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?oo
o`3oool0T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3oool0
T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00PP3oool3000000D0oooo
0P00002D0?ooo`00P@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0T`3o
ool00840oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo09<0oooo0021
0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`2C0?ooo`00P@3oool0
0`000000oooo0?ooo`02000000@0oooo0`00002C0?ooo`00PP3oool3000009/0oooo00210?ooo`80
000000<0oooo0000003oool0VP3oool00840oooo00<000000?ooo`3oool00P00002J0?ooo`00P@3o
ool2000000030?ooo`000000oooo09X0oooo00220?ooo`<00000V`3oool00?l0oooo8@3oool00?l0
oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9865, -1.00032, \
0.0863677, 0.0532366}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0476191 0 0.0772542 [
[.02381 -0.0125 -12.1875 -15.5 ]
[.02381 -0.0125 12.1875 0 ]
[.2619 -0.0125 -9.1875 -15.5 ]
[.2619 -0.0125 9.1875 0 ]
[.7381 -0.0125 -5 -15.5 ]
[.7381 -0.0125 5 0 ]
[.97619 -0.0125 -8 -15.5 ]
[.97619 -0.0125 8 0 ]
[1.025 0 0 -7.75 ]
[1.025 0 9.4375 7.75 ]
[.4875 .07725 -10 -7.75 ]
[.4875 .07725 0 7.75 ]
[.4875 .15451 -10 -7.75 ]
[.4875 .15451 0 7.75 ]
[.4875 .23176 -10 -7.75 ]
[.4875 .23176 0 7.75 ]
[.4875 .30902 -10 -7.75 ]
[.4875 .30902 0 7.75 ]
[.4875 .38627 -10 -7.75 ]
[.4875 .38627 0 7.75 ]
[.4875 .46353 -10 -7.75 ]
[.4875 .46353 0 7.75 ]
[.4875 .54078 -10 -7.75 ]
[.4875 .54078 0 7.75 ]
[.4875 .61803 -10 -7.75 ]
[.4875 .61803 0 7.75 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -73.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.2619 0 m
.2619 .00625 L
s
gsave
.2619 -0.0125 -70.1875 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.7381 0 m
.7381 .00625 L
s
gsave
.7381 -0.0125 -66 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69 -19.5 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 0 m
.07143 .00375 L
s
.11905 0 m
.11905 .00375 L
s
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.30952 0 m
.30952 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.69048 0 m
.69048 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.88095 0 m
.88095 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.813 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -71 -11.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.813 moveto
%%IncludeResource: font Times
%%IncludeFont: Times
/Times findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .32535 m
.04262 .32755 L
.06244 .33056 L
.08255 .33463 L
.10458 .34073 L
.12415 .34805 L
.14509 .35836 L
.18653 .38733 L
.22646 .42277 L
.24474 .43805 L
.25514 .44537 L
.26022 .4484 L
.26488 .45081 L
.26945 .45279 L
.27443 .45446 L
.27717 .45514 L
.2785 .45541 L
.2797 .45562 L
.28087 .45579 L
.28213 .45594 L
.28282 .456 L
.28346 .45605 L
.28471 .45611 L
.28593 .45613 L
.28724 .45611 L
.28847 .45605 L
.28959 .45596 L
.29091 .45581 L
.29234 .45559 L
.29494 .45504 L
.29766 .45426 L
.30055 .45319 L
.30574 .45063 L
.31063 .44746 L
.31511 .44388 L
.32522 .43347 L
.33412 .4216 L
.3435 .4065 L
.3816 .32339 L
.42216 .22202 L
.4409 .18169 L
.46121 .14792 L
.4666 .14106 L
.47232 .13485 L
.47761 .13009 L
.48256 .12652 L
.48718 .12398 L
.48978 .12289 L
.49215 .1221 L
.49341 .12177 L
Mistroke
.49474 .12148 L
.49551 .12135 L
.49621 .12124 L
.49692 .12115 L
.49757 .12109 L
.49884 .121 L
.49951 .12098 L
.50022 .12098 L
.5014 .12101 L
.50271 .12111 L
.50402 .12127 L
.50523 .12148 L
.50656 .12176 L
.50796 .12214 L
.51033 .12293 L
.51294 .12403 L
.51775 .12671 L
.52226 .12998 L
.53233 .13982 L
.54318 .1542 L
.56326 .18999 L
.58438 .23761 L
.62254 .33362 L
.64383 .38222 L
.66315 .41747 L
.67281 .43105 L
.6779 .43702 L
.68327 .44244 L
.68798 .44642 L
.69315 .44998 L
.69785 .45249 L
.70225 .45423 L
.70484 .45499 L
.70724 .45551 L
.7085 .45572 L
.70988 .4559 L
.71057 .45597 L
.71132 .45604 L
.71203 .45608 L
.71268 .45611 L
.71387 .45613 L
.71498 .45612 L
.7162 .45607 L
.7175 .45597 L
.71815 .45591 L
.71887 .45583 L
.72016 .45564 L
.72257 .4552 L
.7248 .45467 L
.72726 .45395 L
Mistroke
.73222 .45211 L
.74112 .44764 L
.76055 .43388 L
.78143 .41567 L
.82268 .37994 L
.84328 .36533 L
.8624 .35435 L
.8809 .34596 L
.90062 .33911 L
.92204 .33359 L
.94222 .32977 L
.95992 .32722 L
.97619 .32535 L
Mfstroke
[ .01 ] 0 setdash
.02381 .31501 m
.04262 .31568 L
.06244 .31655 L
.08255 .31768 L
.10458 .31931 L
.12415 .32125 L
.14509 .32402 L
.16639 .32779 L
.18653 .33241 L
.22495 .34413 L
.24439 .35103 L
.26581 .35837 L
.2756 .36125 L
.281 .36263 L
.28613 .36377 L
.29088 .36464 L
.29339 .36502 L
.29607 .36537 L
.29854 .36563 L
.30079 .36581 L
.30187 .36588 L
.30304 .36594 L
.30415 .36598 L
.30517 .36601 L
.30643 .36603 L
.30762 .36603 L
.3087 .36601 L
.30986 .36598 L
.31113 .36593 L
.31248 .36585 L
.3149 .36565 L
.31713 .36539 L
.31922 .36509 L
.32399 .36418 L
.32918 .36281 L
.33393 .3612 L
.34465 .35625 L
.35446 .35009 L
.36358 .34298 L
.38428 .32231 L
.42332 .27288 L
.44323 .24814 L
.45372 .2368 L
.46482 .22668 L
.47473 .21966 L
.48036 .21662 L
.48562 .21444 L
.4881 .21364 L
.49045 .21301 L
.49257 .21257 L
Mistroke
.49487 .21221 L
.49618 .21207 L
.49737 .21197 L
.49802 .21193 L
.49873 .21191 L
.50002 .21189 L
.50124 .2119 L
.50251 .21196 L
.50361 .21205 L
.5048 .21217 L
.50611 .21235 L
.50732 .21255 L
.51006 .21314 L
.51247 .21381 L
.51503 .21467 L
.52435 .21911 L
.52949 .2224 L
.53431 .22598 L
.54528 .2358 L
.58402 .28252 L
.6037 .30798 L
.62521 .3325 L
.63516 .34189 L
.64578 .35026 L
.6558 .35649 L
.66489 .36074 L
.66975 .36248 L
.67489 .36392 L
.67929 .36484 L
.68178 .36524 L
.68411 .36554 L
.6854 .36567 L
.6868 .36579 L
.68813 .36589 L
.68936 .36595 L
.69046 .36599 L
.69168 .36602 L
.69295 .36603 L
.69415 .36602 L
.69547 .36599 L
.69613 .36597 L
.69685 .36594 L
.69814 .36588 L
.69933 .3658 L
.70203 .36557 L
.70492 .36525 L
.71024 .36445 L
.71515 .3635 L
.72624 .36075 L
.74639 .35429 L
Mistroke
.78576 .34052 L
.82361 .32994 L
.84304 .32599 L
.86392 .32273 L
.88507 .32027 L
.90516 .31853 L
.92498 .31722 L
.94338 .31628 L
.97619 .31501 L
Mfstroke
[ .03 ] 0 setdash
.02381 .33821 m
.04262 .34302 L
.06244 .3498 L
.08255 .3591 L
.10458 .37293 L
.12415 .38909 L
.14509 .41078 L
.18653 .46492 L
.2073 .49364 L
.22646 .51691 L
.23609 .5262 L
.24511 .53286 L
.24964 .53533 L
.25197 .53634 L
.25452 .53725 L
.25596 .53767 L
.25729 .53799 L
.25867 .53826 L
.25993 .53844 L
.26116 .53856 L
.26232 .53863 L
.26355 .53864 L
.26424 .53862 L
.26488 .53859 L
.26614 .53848 L
.26734 .53832 L
.26841 .53813 L
.26958 .53787 L
.27219 .53709 L
.27461 .53611 L
.27902 .53372 L
.2837 .53029 L
.28877 .52551 L
.29352 .52002 L
.30437 .5039 L
.32455 .46132 L
.34305 .4104 L
.38268 .28302 L
.42079 .17089 L
.4404 .127 L
.4513 .10772 L
.46135 .09334 L
.47159 .08209 L
.47698 .07755 L
.48269 .07379 L
.48508 .07253 L
.48765 .07138 L
.48987 .07057 L
.49229 .06986 L
.49376 .06953 L
Mistroke
.49512 .06928 L
.49642 .0691 L
.49715 .06903 L
.4978 .06897 L
.49905 .06891 L
.49976 .06889 L
.5004 .06889 L
.50159 .06893 L
.50284 .06902 L
.50407 .06916 L
.5054 .06937 L
.50782 .06989 L
.51017 .07058 L
.51235 .07138 L
.51728 .07377 L
.52252 .07718 L
.53125 .08486 L
.54087 .09622 L
.56025 .12826 L
.58112 .17575 L
.62232 .2993 L
.66199 .42519 L
.682 .4768 L
.69072 .49497 L
.70015 .51122 L
.70542 .51867 L
.71027 .52448 L
.7152 .52934 L
.7198 .53295 L
.72466 .53577 L
.72723 .53688 L
.72999 .53776 L
.73138 .53808 L
.73211 .53823 L
.73288 .53835 L
.73356 .53845 L
.73431 .53853 L
.73563 .53862 L
.7369 .53864 L
.73762 .53863 L
.73828 .5386 L
.73949 .5385 L
.74077 .53834 L
.742 .53813 L
.74333 .53785 L
.74576 .53716 L
.75029 .53536 L
.75559 .53242 L
.76048 .52899 L
.77884 .511 L
Mistroke
.81821 .45826 L
.85607 .40946 L
.87712 .38792 L
.89638 .37224 L
.91627 .35974 L
.93517 .35077 L
.95499 .34374 L
.97338 .33884 L
.97619 .33821 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005P3oool3000000<0oooo0`00
000c0?ooo`<00000K03oool3000003D0oooo0`0000030?ooo`<000007P3oool001L0oooo00D00000
0?ooo`3oool0oooo000000030?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0K03o
ool00`000000oooo0?ooo`0c0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000oooo
0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?ooo`3oool0
oooo000000030?ooo`030000003oool0oooo01/0oooo000=0?ooo`L000000`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0:03oool7000000D0oooo00<000000?ooo`3o
ool0K03oool00`000000oooo0?ooo`0b0?ooo`050000003oool0oooo0?ooo`0000000`3oool00`00
0000oooo0?ooo`0K0?ooo`005`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?oo
o`3oool0=03oool00`000000oooo0?ooo`1/0?ooo`030000003oool0oooo0380oooo00D000000?oo
o`3oool0oooo000000030?ooo`030000003oool0oooo01/0oooo000G0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0c0?ooo`030000003oool0oooo06`0oooo00<00000
0?ooo`3oool0<`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool06`3o
ool001L0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0340oooo0P00
001]0?ooo`800000=P3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0
6`3oool001H0oooo0P0000030?ooo`050000003oool0oooo0?ooo`000000<`3oool00`000000oooo
0?ooo`1/0?ooo`030000003oool0oooo03@0oooo0P0000030?ooo`050000003oool0oooo0?ooo`00
00007@3oool001L0oooo00<000000?ooo`3oool00P3oool3000003D0oooo0`00001/0?ooo`<00000
=03oool00`000000oooo0?ooo`020?ooo`<000007P3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0?l0oooo3P3oool200000140oooo003o0?ooo`d0oooo00@000000?ooo`3oool00000403oool00?l0
oooo3@3oool010000000oooo0?ooo`00000@0?ooo`004@3ooood000000L0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`005P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00P0
oooo00<000000?ooo`3oool02`3oool5000000l0oooo000F0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool0303oool010000000oooo0?ooo`00000?0?ooo`00RP3oool00`000000oooo
0?ooo`200?ooo`040000003oool0oooo000000l0oooo002:0?ooo`800000PP3oool3000000l0oooo
002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?oo
o`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool008X0oooo00<000000?ooo`3oool0
T`3oool008X0oooo00<000000?ooo`3oool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`00
0000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo
0?ooo`2C0?ooo`00RP3oool2000009@0oooo00200?ooo`<000001`3oool00`000000oooo0?ooo`2C
0?ooo`00P@3oool00`000000oooo0?ooo`050?ooo`<00000U03oool00840oooo00<000000?ooo`3o
ool00P3oool200000080oooo00<000000?ooo`3oool0T`3oool00840oooo00D000000?ooo`3oool0
oooo000000040?ooo`<00000T`3oool00840oooo00@000000?ooo`3oool000001@3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo08`0oooo00210?ooo`030000003oool0000000H0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2;0?ooo`00P@3oool2000000L0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`2:0?ooo`00P03oool2000000P0oooo0P000007
0?ooo`030000003oool0oooo08X0oooo00210?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`290?ooo`00RP3oool00`000000oooo0?ooo`080?ooo`03
0000003oool0oooo08P0oooo002:0?ooo`8000002P3oool00`000000oooo0?ooo`270?ooo`00RP3o
ool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00O@3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo09<0oooo001l0?ooo`030000003oool0oooo00P0
oooo2000002A0?ooo`00O03oool00`000000oooo0?ooo`070?ooo`050000003oool0oooo0?ooo`00
0000103oool00`000000oooo0?ooo`2>0?ooo`00N`3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo08@0oooo001k0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0Q03o
ool007X0oooo00<000000?ooo`3oool01@3oool2000000H0oooo0P0000060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool0P`3oool007X0oooo00<000000?ooo`3oool00P3oool50000
00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
08<0oooo00200?ooo`80000000<0oooo0000003oool01@3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool0PP3oool00800oooo0P0000080?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`220?ooo`00P03o
ool00`000000oooo000000070?ooo`<00000203oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0840oooo001o0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0P@3oool007h0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool0Q`3oool007h0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool0QP3oool007L0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo000000030?ooo`030000003oool0oooo00@0oooo0P00000;0?ooo`03
0000003oool0oooo08H0oooo001g0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
0`0000070?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0Q@3oool007H0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00`0oooo00<0
00000?ooo`3oool0Q03oool007H0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0<
0?ooo`8000003@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo07h0oooo001f0?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0OP3oool007H0oooo00D000000?ooo`3o
ool0oooo0000000?0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`1m0?ooo`00M@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00d0
oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo07d0
oooo001e0?ooo`050000003oool0oooo0?ooo`000000403oool2000000l0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`1m0?ooo`00N@3oool00`000000oooo0?ooo`0>0?ooo`030000
003oool0oooo00l0oooo00D000000?ooo`3oool0oooo0000001o0?ooo`00N03oool00`000000oooo
0?ooo`0?0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`1l0?ooo`00N03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0000000<000003`3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo07`0oooo001g0?ooo`030000003oool0
oooo00/0oooo0P0000030?ooo`8000000P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0
oooo0800oooo001g0?ooo`030000003oool0oooo00D0oooo100000070?ooo`030000003oool0oooo
0080oooo0P00000<0?ooo`030000003oool0oooo0800oooo001g0?ooo`030000003oool0oooo00P0
oooo0P0000060?ooo`030000003oool0oooo00D0oooo0P00000:0?ooo`030000003oool0oooo07l0
oooo001b0?ooo`050000003oool0oooo0?ooo`0000002P3oool00`000000oooo000000060?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`1o0?ooo`00
LP3oool01@000000oooo0?ooo`3oool0000000`0oooo00<000000?ooo`3oool0103oool3000000L0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`1n0?ooo`00L@3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00H0oooo00@000000?ooo`00000000001`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0OP3oool00740oooo
00D000000?ooo`3oool0oooo000000080?ooo`050000003oool0oooo0?ooo`0000001`3oool00`00
0000oooo0?ooo`0:0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`1i0?ooo`00L@3oool01@000000oooo0?ooo`3oool0000000P0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`040?ooo`800000303oool00`000000oooo0?ooo`050?oo
o`050000003oool0oooo0?ooo`000000N`3oool00740oooo00@000000?ooo`3oool000001`3oool0
10000000oooo0?ooo`0000030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool04`3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo07P0oooo001`0?ooo`050000003oool0
oooo0?ooo`0000001P3oool00`000000oooo0?ooo`020?ooo`<000001`3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo00D0oooo00D000000?ooo`3oool0oooo0000001j0?ooo`00L03o
ool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool03@3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo0000001j0?ooo`00
L`3oool00`000000oooo0?ooo`0D0?ooo`8000003`3oool00`000000oooo0?ooo`030?ooo`050000
003oool0oooo0?ooo`000000NP3oool007<0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`0>0?ooo`030000003oool0oooo01D0oooo00D000000?ooo`3oool0oooo0000001i0?ooo`00
L`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0
3`3oool00`000000oooo0?ooo`030?ooo`050000003oool0oooo0?ooo`000000N@3oool00780oooo
00<000000?ooo`3oool00P3oool200000140oooo00<000000?ooo`3oool0403oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo07X0oooo001b0?ooo`030000003oool0oooo01D0oooo0P00
000B0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0NP3oool00780oooo00D00000
0?ooo`3oool0oooo0000000C0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0NP3o
ool006h0oooo00@000000?ooo`3oool000000`3oool00`000000oooo0?ooo`0B0?ooo`030000003o
ool0oooo0180oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1i0?ooo`00KP3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool04`3o
ool200000080oooo00<000000?ooo`3oool0N@3oool006d0oooo00D000000?ooo`3oool0oooo0000
000A0?ooo`030000003oool0oooo00@0oooo0P00000H0?ooo`030000003oool0oooo07T0oooo001]
0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo01D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo
0?ooo`1e0?ooo`00K03oool01`000000oooo0?ooo`3oool000000?ooo`000000303oool6000000D0
oooo00<000000?ooo`3oool05P3oool00`000000oooo000000020?ooo`030000003oool0oooo07D0
oooo001/0?ooo`060000003oool0oooo0000003oool000003@3oool01@000000oooo0?ooo`3oool0
000000H0oooo0`00000G0?ooo`030000003oool000000080oooo00<000000?ooo`3oool0M03oool0
06/0oooo00D000000?ooo`3oool0oooo0000000@0?ooo`040000003oool0oooo000000H0oooo00<0
00000?ooo`3oool06@3oool010000000oooo0?ooo`00001f0?ooo`005`3oool300000080oooo0`00
00020?ooo`<00000A`3oool010000000oooo0?ooo`3oool200000100oooo00<000000?ooo`000000
1P3oool00`000000oooo0?ooo`0H0?ooo`8000000P3oool00`000000oooo0?ooo`160?ooo`@00000
00@0oooo00000000000000000P3oool300000240oooo000U0?ooo`@0000000<0oooo000000000000
0P0000000`3oool000000000000m0?ooo`8000004@3oool00`000000oooo000000060?ooo`030000
003oool0oooo01T0oooo0P0000000`3oool000000?ooo`0k0?ooo`030000003oool0000000<00000
00<0oooo0000000000000P00000_0?ooo`005P3oool3000001P0oooo0P0000000`3oool000000?oo
o`0h0?ooo`030000003oool0oooo0140oooo0P0000060?ooo`8000006`3oool010000000oooo0?oo
o`00000f0?ooo`030000003oool0oooo008000005`3oool200000240oooo000I0?ooo`D000005`3o
ool200000080oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0C0?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool06`3oool00`000000oooo0000000_0?ooo`<000000P3o
ool2000001<0oooo2@00000S0?ooo`007P3oool5000001L0oooo0P0000020?ooo`030000003oool0
oooo02/0oooo0P00000L0?ooo`030000003oool0oooo01/0oooo0P00000]0?ooo`8000005`3oool4
000002`0oooo000S0?ooo`D000005`3oool2000000030?ooo`000000000002L0oooo0P00000M0?oo
o`030000003oool0oooo01/0oooo0P00000Y0?ooo`040000003oool00000000001L0oooo0P00000`
0?ooo`005P3oool4000000h0oooo1000000H0?ooo`8000008`3oool010000000oooo0?ooo`00000M
0?ooo`8000007@3oool2000002H0oooo0P00000G0?ooo`@00000<P3oool002`0oooo0P00000I0?oo
o`030000003oool0oooo01l0oooo00<000000?ooo`0000007P3oool00`000000oooo0?ooo`0L0?oo
o`040000003oool0oooo00000240oooo00<000000?ooo`3oool05P3oool3000000h0oooo0P00000V
0?ooo`00803oool00`000000oooo0?ooo`0;0?ooo`<000005`3oool2000000030?ooo`000000oooo
01X0oooo0`0000000`3oool000000?ooo`0M0?ooo`030000003oool0oooo01d0oooo00<000000?oo
o`3oool00P00000J0?ooo`80000000<0oooo0000000000005`3oool2000000l0oooo0P00000X0?oo
o`008@3oool2000000h0oooo0P00000I0?ooo`<000006@3oool00`000000oooo0000000O0?ooo`03
0000003oool0oooo01d0oooo00D000000?ooo`3oool0oooo0000000H0?ooo`8000006P3oool20000
00l0oooo0P00000Z0?ooo`008`3oool2000000h0oooo0P00000K0?ooo`8000004`3oool01P000000
oooo0?ooo`000000oooo000001l0oooo0P00000N0?ooo`040000003oool0oooo00000080oooo00<0
00000?ooo`3oool04P3oool00`000000oooo0?ooo`0I0?ooo`8000003`3oool2000002`0oooo000U
0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool06P3oool010000000oooo0?ooo`00
000;0?ooo`040000003oool00000000000<0oooo0P00000P0?ooo`030000003oool0oooo01h0oooo
00<000000?ooo`0000000`3oool2000000h0oooo00@000000?ooo`00000000006P3oool2000003l0
oooo000V0?ooo`030000003oool0oooo00d0oooo0P00000N0?ooo`8000000P3oool3000000030?oo
o`0000000000008000001P3oool200000200oooo00<000000?ooo`3oool07P3oool010000000oooo
0?ooo`0000060?ooo`<000000P3oool3000000040?ooo`0000000000000001d0oooo00<000000?oo
o`3oool0?`3oool003P0oooo00<000000?ooo`3oool0;03oool200000240oooo0P00000P0?ooo`03
0000003oool0000002h0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0a0?ooo`00
>@3oool00`000000oooo0?ooo`0[0?ooo`8000005P3oool3000000P0oooo00<000000?ooo`3oool0
7`3oool00`000000oooo0000000/0?ooo`8000003P3oool00`000000oooo0?ooo`0b0?ooo`00>P3o
ool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`0P0?ooo`800000:`3oool00`000000oooo0?ooo`0=0?ooo`030000003o
ool0oooo03<0oooo000/0?ooo`030000003oool0oooo00`0oooo0P00000Z0?ooo`030000003oool0
oooo01T0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0P0?ooo`030000003oool0
000002T0oooo00<000000?ooo`3oool0303oool2000003H0oooo000]0?ooo`8000003P3oool00`00
0000oooo0?ooo`0V0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0103oool30000
0240oooo0P00000X0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0=P3oool002l0
oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo01X0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo02D0
oooo0P00000>0?ooo`030000003oool0oooo03L0oooo000`0?ooo`030000003oool0oooo00`0oooo
00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo04P0oooo
000a0?ooo`030000003oool0oooo00`0oooo0P00000S0?ooo`030000003oool0oooo01P0oooo0P00
00080?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`190?ooo`00<P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo01l0oooo0P00000J
0?ooo`030000003oool0oooo00L0oooo0P00000T0?ooo`030000003oool0oooo0200oooo00<00000
0?ooo`3oool0BP3oool004<0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0J0?oo
o`<000001P3oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo01h0oooo0P00001=0?oo
o`00A03oool00`000000oooo0?ooo`0L0?ooo`8000009@3oool00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo01`0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0l0?ooo`00
A@3oool2000001`0oooo0P00000U0?ooo`030000003oool0oooo02@0oooo00<000000?ooo`3oool0
6`3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo03d0oooo00170?ooo`030000003o
ool0oooo01P0oooo00<000000?ooo`0000009@3oool2000002D0oooo0P00000K0?ooo`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool0?@3oool003H0oooo00<000000?ooo`3oool03`3oool0
0`000000oooo0?ooo`0G0?ooo`8000009P3oool00`000000oooo0?ooo`0U0?ooo`8000006@3oool0
0`000000oooo0?ooo`0?0?ooo`030000003oool0oooo03h0oooo000g0?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool05@3oool00`000000oooo0000000V0?ooo`030000003oool0oooo
02D0oooo00<000000?ooo`0000005`3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
03l0oooo000h0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0503oool00`000000
oooo0000000V0?ooo`030000003oool0oooo02D0oooo00@000000?ooo`3oool000005@3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo03l0oooo000h0?ooo`030000003oool0oooo0100
oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`0W0?ooo`8000009`3oool00`000000
oooo0000000D0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0@03oool003T0oooo
00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0?0?ooo`800000:P3oool00`000000oooo
0?ooo`0V0?ooo`040000003oool0oooo00000140oooo0P00001F0?ooo`00>P3oool00`000000oooo
0?ooo`0@0?ooo`8000003P3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo02L0oooo
00@000000?ooo`3oool000003P3oool2000005P0oooo000k0?ooo`030000003oool0oooo0140oooo
0P00000;0?ooo`030000003oool0oooo02/0oooo0P00000/0?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0F03oool00540oooo0P0000080?ooo`030000003oool0oooo0280oooo0`00
00070?ooo`030000003oool0oooo02`0oooo0`0000070?ooo`800000F`3oool005<0oooo20000005
0?ooo`030000003oool0oooo01`0oooo00D000000?ooo`3oool0oooo000000060?ooo`030000003o
ool0oooo02l0oooo1`00001M0?ooo`00H03oool00`000000oooo0?ooo`0L0?ooo`050000003oool0
oooo0?ooo`0000001P3oool00`000000oooo0?ooo`1;0?ooo`030000003oool0oooo04D0oooo001P
0?ooo`030000003oool0oooo01`0oooo00D000000?ooo`3oool0oooo000000060?ooo`<00000BP3o
ool00`000000oooo0?ooo`160?ooo`00G`3oool00`000000oooo0?ooo`0M0?ooo`8000000P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3oool0A`3oool0
03l0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0M0?ooo`040000003oool00000
000000L0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0
oooo04L0oooo00100?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool07`3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool06`3oool00`00
0000oooo0?ooo`180?ooo`00@@3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0200
oooo00<000000?ooo`3oool01P3oool2000002/0oooo00<000000?ooo`3oool06P3oool00`000000
oooo0?ooo`190?ooo`00@@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0280oooo
0P0000060?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3oool0I@3oool00480oooo00<0
00000?ooo`3oool0A@3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo06D0oooo0013
0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`1T
0?ooo`00@`3oool00`000000oooo0?ooo`140?ooo`800000;@3oool00`000000oooo0?ooo`1T0?oo
o`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`120?ooo`030000
003oool0oooo04h0oooo002:0?ooo`800000@P3oool00`000000oooo0?ooo`1?0?ooo`00FP3oool0
0`000000oooo0?ooo`0]0?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0C`3oool0
04P0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo
0400oooo00<000000?ooo`3oool0D03oool004T0oooo00<000000?ooo`3oool0303oool00`000000
oooo0?ooo`0_0?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0D@3oool004X0oooo
00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0`0?ooo`800000<@3oool2000000`0oooo
00<000000?ooo`3oool0DP3oool004/0oooo00<000000?ooo`3oool0203oool00`000000oooo0?oo
o`0X0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo05<0oooo001<0?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool0:@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo03<0oooo00<00000
0?ooo`3oool0G@3oool004d0oooo0P00000c0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0=03oool3000005`0oooo00220?ooo`030000003oool0oooo00D0oooo0`00002C0?ooo`00
PP3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09<0oooo00220?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool0T`3oool008<0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`2C0?ooo`00O`3oool01@000000oooo0?ooo`3oool0000000H0oooo0P00002D
0?ooo`00P03oool4000000H0oooo00<000000?ooo`3oool0T`3oool008X0oooo00<000000?ooo`3o
ool0T`3oool008X0oooo0P00002D0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool0
0`000000oooo0?ooo`2C0?ooo`00RP3oool00`000000oooo0?ooo`2C0?ooo`00RP3oool2000009@0
oooo002:0?ooo`030000003oool0oooo09<0oooo002:0?ooo`030000003oool0oooo09<0oooo002:
0?ooo`030000003oool0oooo09<0oooo002:0?ooo`800000U03oool00800oooo0`0000070?ooo`03
0000003oool0oooo09<0oooo001o0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000
oooo0?ooo`2C0?ooo`00O`3oool01@000000oooo0?ooo`3oool0000000H0oooo00<000000?ooo`3o
ool0T`3oool00800oooo00<000000?ooo`0000001`3oool3000009<0oooo00210?ooo`030000003o
ool0oooo09`0oooo00200?ooo`030000003oool0000009d0oooo001o0?ooo`050000003oool0oooo
0?ooo`000000W03oool007l0oooo00D000000?ooo`3oool0oooo0000002L0?ooo`00P03oool30000
09d0oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-11.9695, -0.984998, \
0.086157, 0.0531067}}]
}, Open  ]],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[CellGroupData[{

Cell[BoxData[""], "Input"],

Cell[BoxData[
    RowBox[{"\<\"PlotStyle is an option for Plot and ListPlot that specifies \
the style of lines or points to be plotted.\"\>", " ", 
      ButtonBox[
        StyleBox["More\[Ellipsis]",
          "SR"],
        ButtonData:>"PlotStyle",
        Active->True,
        ButtonStyle->"RefGuideLink"]}]], "Print",
  CellTags->"Info3327396267-1525374"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(Attributes[PlotStyle] = {Protected}\)}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "PlotStyle"],
      Editable->False]], "Print",
  CellTags->"Info3327396267-1525374"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{\( (*\ sig\  = \ 2, \ k\  = \ 3/4\ *) \), "\[IndentingNewLine]", 
      RowBox[{\(pl1 = \ 
          Plot[\[IndentingNewLine]NIntegrate[\ \ \((th\  - 
                        1/2 \((\ 
                            d\  - \ 
                              Sqrt[d^2\  - \ 
                                  4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ phi[
                    d, \ th, \ 
                    2^2], {d, \ \(-Infinity\), \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                      2\ 3/4\  - 
                        1]}]\  + \[IndentingNewLine]NIntegrate[\ \ th^2\ phi[
                    d, \ th, \ 
                    2^2], {d, \ \(-\((2\ \ 2)\)\)\ \ Sqrt[
                      2\ 3/4\  - 1], \ \((2\ \ 2)\)\ \ Sqrt[
                      2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
              NIntegrate[\ \ \((th\  - 
                        1/2 \((\ 
                            d\  + \ 
                              Sqrt[d^2\  - 
                                  4\ \ 2^2\ \((2\ 3/4 - 1)\)])\))\)^2\ phi[
                    d, \ th, \ 
                    2^2], {d, \ \((2\ \ 2)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                  Infinity}], \[IndentingNewLine]{th, \(-12\), 12}\ , 
            PlotRange\  \[Rule] \ {0, \ 16}, \ 
            AxesLabel\  \[Rule] \ {\[Theta], \ None}, \ 
            DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\), 
        "\[IndentingNewLine]", "\n", "\n", 
        "\[IndentingNewLine]", \( (*\ sig\  = \ 1, \ k\  = \ 3/4\ *) \), "\n",
         
        RowBox[{
          RowBox[{"pl2", "=", " ", 
            RowBox[{"Plot", "[", "\[IndentingNewLine]", 
              
              RowBox[{\(NIntegrate[\ \ \((th\  - 
                            1/2 \((\ 
                                d\  - \ 
                                  Sqrt[d^2\  - \ 
                                      4\ \ 1^2\ \((2\ 3/4 - 
                                        1)\)])\))\)^2\ phi[d, \ th, \ 
                        1^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 1)\)\)\ \ Sqrt[
                          2\ 3/4\  - 
                            1]}]\  + \[IndentingNewLine]NIntegrate[\ \ th^2\ \
phi[d, \ th, \ 1^2], {d, \ \(-\((2\ \ 1)\)\)\ \ Sqrt[
                          2\ 3/4\  - 1], \ \((2\ \ 1)\)\ \ Sqrt[
                          2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
                  NIntegrate[\ \ \((th\  - 
                            1/2 \((\ 
                                d\  + \ 
                                  Sqrt[d^2\  - 
                                      4\ \ 1^2\ \((2\ 3/4 - 
                                        1)\)])\))\)^2\ phi[d, \ th, \ 
                        1^2], {d, \ \((2\ \ 1)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                      Infinity}]\), ",", "\[IndentingNewLine]", 
                StyleBox[\({th, \(-12\), 12}\),
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[\(PlotRange\  \[Rule] \ {0, \ 16}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(AxesLabel\  \[Rule] \ {\[Theta], \ None}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(DefaultFont\  \[Rule] \ {"\<Roman\>", 12}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox["\[IndentingNewLine]",
                  "Text"], 
                
                StyleBox[\(PlotStyle \[Rule] {GrayLevel[0], 
                      Dashing[{ .01}]}\),
                  "Text"]}], 
              StyleBox["]",
                "Text"]}]}], 
          StyleBox[";",
            "Text"]}], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], "\[IndentingNewLine]", 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        "\[IndentingNewLine]", \( (*\ sig\  = \ 3, \ k\  = \ 3/4\ *) \), 
        "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"pl3", "=", " ", 
            RowBox[{"Plot", "[", "\[IndentingNewLine]", 
              
              RowBox[{\(NIntegrate[\ \ \((th\  - 
                            1/2 \((\ 
                                d\  - \ 
                                  Sqrt[d^2\  - \ 
                                      4\ \ 3^2\ \((2\ 3/4 - 
                                        1)\)])\))\)^2\ phi[d, \ th, \ 
                        3^2], {d, \ \(-Infinity\), \ \
\(-\((2\ \ 3)\)\)\ \ Sqrt[
                          2\ 3/4\  - 
                            1]}]\  + \[IndentingNewLine]NIntegrate[\ \ th^2\ \
phi[d, \ th, \ 3^2], {d, \ \(-\((2\ \ 3)\)\)\ \ Sqrt[
                          2\ 3/4\  - 1], \ \((2\ \ 3)\)\ \ Sqrt[
                          2\ 3/4\  - 1]}]\  + \[IndentingNewLine]\ 
                  NIntegrate[\ \ \((th\  - 
                            1/2 \((\ 
                                d\  + \ 
                                  Sqrt[d^2\  - 
                                      4\ \ 3^2\ \((2\ 3/4 - 
                                        1)\)])\))\)^2\ phi[d, \ th, \ 
                        3^2], {d, \ \((2\ \ 3)\)\ \ Sqrt[2\ 3/4\  - 1], \ 
                      Infinity}]\), ",", "\[IndentingNewLine]", 
                StyleBox[\({th, \(-12\), 12}\),
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[\(PlotRange\  \[Rule] \ {0, 16}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(AxesLabel\  \[Rule] \ {\[Theta], \ None}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox[" ",
                  "Text"], 
                StyleBox[\(DefaultFont\  \[Rule] \ {"\<Roman\>", 12}\),
                  "Text"], 
                StyleBox[",",
                  "Text"], 
                StyleBox["\[IndentingNewLine]",
                  "Text"], 
                
                StyleBox[\(PlotStyle \[Rule] {GrayLevel[0], 
                      Dashing[{ .03}]}\),
                  "Text"]}], 
              StyleBox["]",
                "Text"]}]}], 
          StyleBox[";",
            "Text"]}], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"], 
        StyleBox[\(Show[pl1, \ pl2, \ pl3]\),
          "Text"], 
        StyleBox["\[IndentingNewLine]",
          "Text"]}]}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0396825 0 0.0386271 [
[.10317 -0.0125 -11.875 -15.75 ]
[.10317 -0.0125 11.875 0 ]
[.30159 -0.0125 -9.03125 -15.75 ]
[.30159 -0.0125 9.03125 0 ]
[.69841 -0.0125 -4.84375 -15.75 ]
[.69841 -0.0125 4.84375 0 ]
[.89683 -0.0125 -7.6875 -15.75 ]
[.89683 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .07725 -9.6875 -7.875 ]
[.4875 .07725 0 7.875 ]
[.4875 .15451 -9.6875 -7.875 ]
[.4875 .15451 0 7.875 ]
[.4875 .23176 -9.6875 -7.875 ]
[.4875 .23176 0 7.875 ]
[.4875 .30902 -9.6875 -7.875 ]
[.4875 .30902 0 7.875 ]
[.4875 .38627 -15.375 -7.875 ]
[.4875 .38627 0 7.875 ]
[.4875 .46353 -15.375 -7.875 ]
[.4875 .46353 0 7.875 ]
[.4875 .54078 -15.375 -7.875 ]
[.4875 .54078 0 7.875 ]
[.4875 .61803 -15.375 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.10317 0 m
.10317 .00625 L
s
gsave
.10317 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.30159 0 m
.30159 .00625 L
s
gsave
.30159 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.69841 0 m
.69841 .00625 L
s
gsave
.69841 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.89683 0 m
.89683 .00625 L
s
gsave
.89683 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.14286 0 m
.14286 .00375 L
s
.18254 0 m
.18254 .00375 L
s
.22222 0 m
.22222 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.34127 0 m
.34127 .00375 L
s
.38095 0 m
.38095 .00375 L
s
.42063 0 m
.42063 .00375 L
s
.46032 0 m
.46032 .00375 L
s
.53968 0 m
.53968 .00375 L
s
.57937 0 m
.57937 .00375 L
s
.61905 0 m
.61905 .00375 L
s
.65873 0 m
.65873 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.77778 0 m
.77778 .00375 L
s
.81746 0 m
.81746 .00375 L
s
.85714 0 m
.85714 .00375 L
s
.06349 0 m
.06349 .00375 L
s
.02381 0 m
.02381 .00375 L
s
.93651 0 m
.93651 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(14) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(16) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01931 m
.50375 .01931 L
s
.5 .03863 m
.50375 .03863 L
s
.5 .05794 m
.50375 .05794 L
s
.5 .09657 m
.50375 .09657 L
s
.5 .11588 m
.50375 .11588 L
s
.5 .13519 m
.50375 .13519 L
s
.5 .17382 m
.50375 .17382 L
s
.5 .19314 m
.50375 .19314 L
s
.5 .21245 m
.50375 .21245 L
s
.5 .25108 m
.50375 .25108 L
s
.5 .27039 m
.50375 .27039 L
s
.5 .2897 m
.50375 .2897 L
s
.5 .32833 m
.50375 .32833 L
s
.5 .34764 m
.50375 .34764 L
s
.5 .36696 m
.50375 .36696 L
s
.5 .40558 m
.50375 .40558 L
s
.5 .4249 m
.50375 .4249 L
s
.5 .44421 m
.50375 .44421 L
s
.5 .48284 m
.50375 .48284 L
s
.5 .50215 m
.50375 .50215 L
s
.5 .52147 m
.50375 .52147 L
s
.5 .56009 m
.50375 .56009 L
s
.5 .57941 m
.50375 .57941 L
s
.5 .59872 m
.50375 .59872 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .16072 m
.04262 .16135 L
.06244 .16215 L
.08255 .16315 L
.10458 .16457 L
.12415 .16626 L
.14509 .16876 L
.1553 .17035 L
.16639 .17242 L
.18653 .17736 L
.20637 .18412 L
.2274 .19373 L
.26524 .21705 L
.28627 .23139 L
.30552 .24279 L
.31503 .24699 L
.32041 .24876 L
.32298 .24943 L
.3254 .24995 L
.3277 .25034 L
.32892 .2505 L
.3302 .25063 L
.33128 .25072 L
.33246 .25079 L
.33354 .25082 L
.33455 .25083 L
.33581 .25081 L
.33701 .25075 L
.33808 .25068 L
.33925 .25056 L
.34052 .2504 L
.34187 .25018 L
.3443 .24968 L
.34668 .24904 L
.34918 .24821 L
.35367 .2463 L
.35849 .24365 L
.36377 .24001 L
.37324 .23156 L
.38205 .22154 L
.4025 .19128 L
.42109 .15802 L
.44189 .11971 L
.45103 .10422 L
.46107 .0891 L
.47008 .07781 L
.47976 .06857 L
.4851 .0649 L
.48998 .0625 L
.49232 .06167 L
Mistroke
.49356 .06132 L
.49488 .06101 L
.49615 .06079 L
.4973 .06064 L
.49845 .06054 L
.49954 .06049 L
.50071 .0605 L
.50196 .06057 L
.50314 .06069 L
.50421 .06084 L
.50547 .06109 L
.50684 .06143 L
.50933 .06223 L
.51193 .06333 L
.5147 .06478 L
.51966 .06812 L
.52845 .07621 L
.53814 .08803 L
.5784 .15707 L
.59691 .1903 L
.6074 .20702 L
.61714 .22051 L
.62766 .23247 L
.63722 .24075 L
.64247 .24423 L
.64743 .24682 L
.65266 .24883 L
.65561 .24966 L
.65701 .24997 L
.65833 .25022 L
.6595 .2504 L
.66078 .25056 L
.66194 .25068 L
.66302 .25076 L
.66418 .25081 L
.66546 .25083 L
.6661 .25083 L
.66679 .25081 L
.66805 .25076 L
.66915 .25069 L
.67035 .25058 L
.67278 .25026 L
.67504 .24986 L
.67713 .2494 L
.68236 .24791 L
.68711 .24615 L
.69778 .24107 L
.73773 .21502 L
.77617 .19191 L
.79602 .18319 L
Mistroke
.81705 .17635 L
.8366 .17182 L
.85491 .16876 L
.87517 .16633 L
.8937 .1647 L
.9127 .16342 L
.93343 .16234 L
.9741 .16078 L
.97619 .16072 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`009`3oool2000000@0oooo0`00
000Z0?ooo`<00000FP3oool3000002X0oooo0P0000040?ooo`<00000<`3oool002P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0X0?ooo`040000003oool0oooo000005T0oooo
00@000000?ooo`3oool00000:`3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
0380oooo000X0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000002P0oooo00<000000?oo
o`3oool00P00001H0?ooo`030000003oool0oooo00800000:P3oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000b0?ooo`00:03oool01@000000oooo0?ooo`3oool000000080oooo0P00000/
0?ooo`030000003oool0oooo05X0oooo00<000000?ooo`3oool0:03oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000b0?ooo`007P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo01h0oooo1`0000040?ooo`800000F`3oool2000002X0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0300oooo000X0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0V0?ooo`040000003oool0oooo000005T0
oooo00@000000?ooo`3oool00000:`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0<03oool002P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000:03oool4
000005T0oooo1000000[0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo000X
0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000002P0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0/0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo
000W0?ooo`8000000`3oool2000000030?ooo`000000oooo02P0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0[0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo000X
0?ooo`030000003oool0oooo0080oooo0`00000Y0?ooo`<00000FP3oool3000002`0oooo00<00000
0?ooo`3oool00P3oool3000003<0oooo003o0?ooob40oooo003o0?ooo`/0oooo0P00000D0?ooo`00
o`3oool:0?ooo`040000003oool0oooo000001<0oooo003o0?ooo`X0oooo00@000000?ooo`3oool0
00004`3oool000h0oooom00000070?ooo`050000003oool0oooo0?ooo`0000004P3oool001<0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool02`3oool500000180oooo000W0?ooo`030000003oool0oooo02d0oooo00<0
00000?ooo`3oool0;@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool07`3oool010000000oooo0?ooo`00000B0?ooo`00Q`3oool00`000000oooo0?oo
o`200?ooo`040000003oool0oooo00000180oooo00270?ooo`030000003oool0oooo0840oooo0`00
000B0?ooo`00Q`3oool2000009L0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`03
0000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003o
ool0oooo09H0oooo00270?ooo`800000U`3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0
oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00
002G0?ooo`00P03oool2000000<0oooo1P00002E0?ooo`00OP3oool3000000030?ooo`000000oooo
0080000000@0oooo0000003oool0oooo0P00002D0?ooo`00OP3oool010000000oooo0?ooo`3oool2
000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2A0?ooo`00OP3oool01000
0000oooo0?ooo`0000050?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0T03oool0
07l0oooo0P0000060?ooo`<00000103oool00`000000oooo0?ooo`2?0?ooo`00O`3oool00`000000
oooo000000050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0SP3oool007l0oooo
00@000000?ooo`0000000000103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo08d0
oooo001n0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo08`0oooo001m0?ooo`8000000P3oool2000000@0oooo00<000000?ooo`3oool0
203oool00`000000oooo0?ooo`2;0?ooo`00O03oool00`000000oooo0?ooo`03000000D0oooo0P00
00090?ooo`030000003oool0oooo08/0oooo001l0?ooo`030000003oool0oooo00P0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`2:0?ooo`00N`3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool0RP3oool007X0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo08T0oooo001j0?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`290?ooo`00N@3o
ool00`000000oooo0?ooo`0;0?ooo`800000303oool00`000000oooo0?ooo`280?ooo`00N03oool0
0`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0R03oool0
07P0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo
08L0oooo001g0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0303oool00`000000
oooo0?ooo`270?ooo`00M`3oool00`000000oooo0?ooo`0=0?ooo`8000003P3oool00`000000oooo
0?ooo`260?ooo`00MP3oool00`000000oooo0?ooo`070?ooo`8000001@3oool00`000000oooo0?oo
o`0=0?ooo`030000003oool0oooo08H0oooo001f0?ooo`030000003oool0oooo00L0oooo0P000005
0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0Q@3oool007D0oooo00<000000?oo
o`3oool0203oool2000000D0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`250?oo
o`00M@3oool00`000000oooo0?ooo`060?ooo`@000001@3oool00`000000oooo0?ooo`0?0?ooo`03
0000003oool0oooo08@0oooo001d0?ooo`030000003oool0oooo00L0oooo00@000000?ooo`000000
00001@3oool3000000l0oooo00<000000?ooo`3oool0Q03oool001<0oooo0`00001N0?ooo`030000
003oool0oooo00P0oooo0`0000050?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
FP3oool5000002@0oooo000F0?oooa@00000B@3oool00`000000oooo0?ooo`090?ooo`<000001@3o
ool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo04L0oooo4P00000Y0?ooo`00:P3oool8
00000440oooo00<000000?ooo`3oool02P3oool2000000D0oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`0n0?ooo`T00000>`3oool00380oooo1`00000i0?ooo`030000003oool0oooo
00/0oooo0P0000050?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0>03oool50000
04@0oooo000i0?ooo`@00000=@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00<0
oooo0P00000C0?ooo`030000003oool0oooo03@0oooo100000190?ooo`00?@3oool200000380oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0340oooo
0P00001=0?ooo`00?`3oool3000002l0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?oo
o`0D0?ooo`030000003oool0oooo02d0oooo0`00001?0?ooo`00@P3oool2000002`0oooo00<00000
0?ooo`3oool0503oool00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo02/0oooo0P00001B
0?ooo`00A03oool2000002X0oooo00<000000?ooo`3oool0503oool2000001H0oooo00<000000?oo
o`3oool0:03oool2000005@0oooo00160?ooo`8000009`3oool00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo01D0oooo00<000000?ooo`3oool09P3oool2000005H0oooo00180?ooo`030000
003oool0oooo02@0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0F0?ooo`030000
003oool0oooo02@0oooo00<000000?ooo`3oool0EP3oool004T0oooo0P00000S0?ooo`030000003o
ool0oooo01H0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0R0?ooo`800000F@3o
ool004/0oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0
oooo01L0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`1I0?ooo`00C03oool20000
01h0oooo00<000000?ooo`3oool0603oool2000001T0oooo00<000000?ooo`3oool07@3oool20000
05`0oooo001>0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0403oool3000000D0
oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo05`0
oooo001?0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool0403oool2000000030?oo
o`000000oooo00@0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`0H0?ooo`800000
G`3oool00500oooo0P00000H0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool00P00
00040?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool05@3oool200000640oooo001B
0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool04P3oool01@000000oooo0?ooo`3o
ool0000000@0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0D0?ooo`030000003o
ool0oooo0640oooo001C0?ooo`8000004`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0
oooo00800000103oool3000001`0oooo00<000000?ooo`3oool04@3oool2000006@0oooo001E0?oo
o`800000403oool00`000000oooo0?ooo`0D0?ooo`80000000<0oooo0000003oool0103oool00`00
0000oooo0?ooo`0M0?ooo`8000003`3oool2000006H0oooo001G0?ooo`8000003@3oool00`000000
oooo0?ooo`0E0?ooo`030000003oool0000000H0oooo00<000000?ooo`3oool07`3oool00`000000
oooo0?ooo`0;0?ooo`030000003oool0oooo06H0oooo001I0?ooo`8000002@3oool2000001P0oooo
00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`0P0?ooo`8000002@3oool2000006T0
oooo001K0?ooo`T000006`3oool00`000000oooo000000050?ooo`8000008`3oool9000006/0oooo
001o0?ooo`<000001@3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F
0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00
Q`3oool2000009L0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0
oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0
oooo00270?ooo`800000U`3oool007l0oooo0`0000050?ooo`030000003oool0oooo09H0oooo001n
0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`2F0?ooo`00OP3oool01@00
0000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0UP3oool007h0oooo00D000000?oo
o`3oool0oooo000000040?ooo`<00000UP3oool007h0oooo00<000000?ooo`3oool00P0000040?oo
o`030000003oool0oooo09H0oooo001o0?ooo`<000001@3oool00`000000oooo0?ooo`2F0?ooo`00
OP3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0UP3oool007h0oooo00<0
00000?ooo`3oool00P0000040?ooo`030000003oool0oooo09H0oooo001n0?ooo`80000000<0oooo
0000003oool0103oool2000009L0oooo001o0?ooo`<000001@3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3o
ool00`000000oooo0?ooo`2F0?ooo`00Q`3oool2000009L0oooo00270?ooo`030000003oool0oooo
09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo
00270?ooo`030000003oool0oooo09H0oooo001i0?ooo`800000103oool3000000D0oooo0P00002G
0?ooo`00NP3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo00@0oooo00<00000
0?ooo`3oool0UP3oool007X0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103oool0
0`000000oooo0?ooo`2F0?ooo`00NP3oool01@000000oooo0?ooo`3oool000000080oooo0P000004
0?ooo`030000003oool0oooo09H0oooo001j0?ooo`050000003oool0oooo0?ooo`0000000`3oool0
0`000000oooo0?ooo`020?ooo`<00000UP3oool007X0oooo00D000000?ooo`3oool0oooo00000003
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0UP3oool007X0oooo00D000000?oo
o`3oool0oooo000000020?ooo`800000103oool00`000000oooo0?ooo`2F0?ooo`00NP3oool01@00
0000oooo0?ooo`3oool000000080oooo0P0000040?ooo`030000003oool0oooo09H0oooo001i0?oo
o`8000000`3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0UP3oool007X0
oooo00<000000?ooo`3oool00P3oool3000000D0oooo0P00002G0?ooo`00Q`3oool00`000000oooo
0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F
0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool2000009L0oooo00270?ooo`030000
003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0
oooo09H0oooo00270?ooo`800000U`3oool007T0oooo0P0000050?ooo`8000001@3oool00`000000
oooo0?ooo`2F0?ooo`00NP3oool010000000oooo0?ooo`3oool3000000030?ooo`000000oooo00<0
oooo00<000000?ooo`3oool0UP3oool007X0oooo00D000000?ooo`3oool0oooo000000080?ooo`03
0000003oool0oooo09H0oooo001j0?ooo`050000003oool0oooo0?ooo`000000203oool00`000000
oooo0?ooo`2F0?ooo`00NP3oool00`000000oooo0?ooo`020?ooo`8000001P3oool3000009H0oooo
001j0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`2F0?ooo`00NP3oool00`000000oooo0?ooo`040?ooo`800000103oool00`000000oooo0?ooo`2F
0?ooo`00NP3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`2F0?ooo`00N@3oool2000000<0oooo00<000000?ooo`3oool00P0000040?oo
o`030000003oool0oooo09H0oooo001j0?ooo`030000003oool0oooo0080oooo0`0000050?ooo`80
0000U`3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3o
ool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00002G0?ooo`00Q`3oool00`000000
oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?oo
o`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool2000009L0oooo001i0?ooo`80
00001@3oool2000000D0oooo00<000000?ooo`3oool0UP3oool007X0oooo00<000000?ooo`3oool0
0`3oool2000000D0oooo00<000000?ooo`3oool0UP3oool007X0oooo00<000000?ooo`3oool00`3o
ool2000000D0oooo00<000000?ooo`3oool0UP3oool007X0oooo00@000000?ooo`3oool0oooo1000
00050?ooo`030000003oool0oooo09H0oooo001j0?ooo`060000003oool0oooo0?ooo`000000oooo
0P0000050?ooo`<00000UP3oool007X0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<0
00000?ooo`3oool0UP3oool007X0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<00000
0?ooo`3oool0UP3oool007X0oooo00<000000?ooo`3oool00`3oool2000000D0oooo00<000000?oo
o`3oool0UP3oool007T0oooo0P0000050?ooo`8000001@3oool00`000000oooo0?ooo`2F0?ooo`00
NP3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo0P00002G0?ooo`00Q`3o
ool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`00
0000oooo0?ooo`2F0?ooo`00Q`3oool2000009L0oooo00270?ooo`030000003oool0oooo09H0oooo
00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?oo
o`030000003oool0oooo09H0oooo00270?ooo`800000U`3oool007T0oooo0P0000040?ooo`<00000
1@3oool00`000000oooo0?ooo`2F0?ooo`00NP3oool010000000oooo0?ooo`3oool2000000030?oo
o`000000oooo00@0oooo00<000000?ooo`3oool0UP3oool007X0oooo00D000000?ooo`3oool0oooo
000000020?ooo`800000103oool00`000000oooo0?ooo`2F0?ooo`00NP3oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2F0?ooo`00NP3o
ool01@000000oooo0?ooo`3oool000000080oooo0P0000040?ooo`<00000UP3oool007X0oooo00@0
00000?ooo`3oool0oooo0P0000000`3oool000000?ooo`2M0?ooo`00NP3oool01`000000oooo0?oo
o`3oool000000?ooo`000000W`3oool007X0oooo00D000000?ooo`3oool0oooo000000020?ooo`03
0000003oool0oooo09`0oooo001i0?ooo`800000103oool00`000000oooo0000002N0?ooo`00NP3o
ool00`000000oooo0?ooo`020?ooo`<00000WP3oool00?l0oooo8@3oool00?l0oooo8@3oool00001
\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-14.0685, -2.00064, \
0.103641, 0.106473}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0396825 0 0.0386271 [
[.10317 -0.0125 -11.875 -15.75 ]
[.10317 -0.0125 11.875 0 ]
[.30159 -0.0125 -9.03125 -15.75 ]
[.30159 -0.0125 9.03125 0 ]
[.69841 -0.0125 -4.84375 -15.75 ]
[.69841 -0.0125 4.84375 0 ]
[.89683 -0.0125 -7.6875 -15.75 ]
[.89683 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .07725 -9.6875 -7.875 ]
[.4875 .07725 0 7.875 ]
[.4875 .15451 -9.6875 -7.875 ]
[.4875 .15451 0 7.875 ]
[.4875 .23176 -9.6875 -7.875 ]
[.4875 .23176 0 7.875 ]
[.4875 .30902 -9.6875 -7.875 ]
[.4875 .30902 0 7.875 ]
[.4875 .38627 -15.375 -7.875 ]
[.4875 .38627 0 7.875 ]
[.4875 .46353 -15.375 -7.875 ]
[.4875 .46353 0 7.875 ]
[.4875 .54078 -15.375 -7.875 ]
[.4875 .54078 0 7.875 ]
[.4875 .61803 -15.375 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.10317 0 m
.10317 .00625 L
s
gsave
.10317 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.30159 0 m
.30159 .00625 L
s
gsave
.30159 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.69841 0 m
.69841 .00625 L
s
gsave
.69841 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.89683 0 m
.89683 .00625 L
s
gsave
.89683 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.14286 0 m
.14286 .00375 L
s
.18254 0 m
.18254 .00375 L
s
.22222 0 m
.22222 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.34127 0 m
.34127 .00375 L
s
.38095 0 m
.38095 .00375 L
s
.42063 0 m
.42063 .00375 L
s
.46032 0 m
.46032 .00375 L
s
.53968 0 m
.53968 .00375 L
s
.57937 0 m
.57937 .00375 L
s
.61905 0 m
.61905 .00375 L
s
.65873 0 m
.65873 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.77778 0 m
.77778 .00375 L
s
.81746 0 m
.81746 .00375 L
s
.85714 0 m
.85714 .00375 L
s
.06349 0 m
.06349 .00375 L
s
.02381 0 m
.02381 .00375 L
s
.93651 0 m
.93651 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(14) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(16) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01931 m
.50375 .01931 L
s
.5 .03863 m
.50375 .03863 L
s
.5 .05794 m
.50375 .05794 L
s
.5 .09657 m
.50375 .09657 L
s
.5 .11588 m
.50375 .11588 L
s
.5 .13519 m
.50375 .13519 L
s
.5 .17382 m
.50375 .17382 L
s
.5 .19314 m
.50375 .19314 L
s
.5 .21245 m
.50375 .21245 L
s
.5 .25108 m
.50375 .25108 L
s
.5 .27039 m
.50375 .27039 L
s
.5 .2897 m
.50375 .2897 L
s
.5 .32833 m
.50375 .32833 L
s
.5 .34764 m
.50375 .34764 L
s
.5 .36696 m
.50375 .36696 L
s
.5 .40558 m
.50375 .40558 L
s
.5 .4249 m
.50375 .4249 L
s
.5 .44421 m
.50375 .44421 L
s
.5 .48284 m
.50375 .48284 L
s
.5 .50215 m
.50375 .50215 L
s
.5 .52147 m
.50375 .52147 L
s
.5 .56009 m
.50375 .56009 L
s
.5 .57941 m
.50375 .57941 L
s
.5 .59872 m
.50375 .59872 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
[ .01 ] 0 setdash
.02381 .03897 m
.06244 .03904 L
.10458 .03914 L
.12507 .0392 L
.14415 .03926 L
.18221 .03944 L
.20262 .03956 L
.2212 .03971 L
.24035 .0399 L
.26113 .04017 L
.28097 .04053 L
.29097 .04078 L
.302 .04113 L
.31213 .04157 L
.32141 .04211 L
.32652 .04249 L
.33211 .043 L
.34228 .0442 L
.3526 .04592 L
.36196 .04799 L
.38293 .05437 L
.39229 .05757 L
.40218 .06055 L
.40735 .06172 L
.40876 .06197 L
.41028 .0622 L
.41159 .06237 L
.41302 .06252 L
.4137 .06257 L
.41441 .06262 L
.4157 .06268 L
.41691 .06271 L
.41759 .06271 L
.41824 .0627 L
.41943 .06265 L
.42053 .06258 L
.42173 .06247 L
.423 .06231 L
.42557 .06186 L
.428 .06128 L
.43254 .05975 L
.43743 .05746 L
.44274 .05428 L
.46111 .03898 L
.47137 .02955 L
.48098 .02197 L
.48581 .01903 L
.48829 .01781 L
.491 .01673 L
.49253 .01623 L
Mistroke
.49396 .01585 L
.49531 .01556 L
.49601 .01544 L
.49676 .01533 L
.4975 .01525 L
.49818 .01519 L
.49884 .01515 L
.49952 .01513 L
.50072 .01513 L
.50202 .0152 L
.50333 .01534 L
.50454 .01554 L
.50587 .01581 L
.50728 .01618 L
.50965 .01696 L
.51226 .01806 L
.51706 .0207 L
.52157 .02379 L
.5425 .04232 L
.55236 .05074 L
.55773 .05459 L
.56272 .05755 L
.567 .05956 L
.57157 .06115 L
.57418 .06181 L
.57546 .06206 L
.57664 .06226 L
.57769 .0624 L
.57885 .06253 L
.58001 .06262 L
.58124 .06268 L
.58254 .06271 L
.58374 .0627 L
.58507 .06265 L
.58573 .06261 L
.58647 .06256 L
.5877 .06245 L
.58903 .06229 L
.59143 .06194 L
.59628 .06093 L
.60073 .05975 L
.62163 .05283 L
.64053 .04739 L
.65125 .04521 L
.66122 .04374 L
.66626 .04316 L
.67173 .04264 L
.68166 .04191 L
.69132 .0414 L
.70024 .04105 L
Mistroke
.70992 .04075 L
.71898 .04053 L
.73961 .04016 L
.75987 .03989 L
.7784 .03971 L
.79901 .03955 L
.81813 .03944 L
.85634 .03926 L
.87688 .03919 L
.89549 .03914 L
.93558 .03904 L
.97415 .03898 L
.97619 .03897 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`009`3oool2000000@0oooo0`00
000Z0?ooo`<00000FP3oool3000002X0oooo0P0000040?ooo`<00000<`3oool002P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0X0?ooo`040000003oool0oooo000005T0oooo
00@000000?ooo`3oool00000:`3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
0380oooo000X0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000002P0oooo00<000000?oo
o`3oool00P00001H0?ooo`030000003oool0oooo00800000:P3oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000b0?ooo`00:03oool01@000000oooo0?ooo`3oool000000080oooo0P00000/
0?ooo`030000003oool0oooo05X0oooo00<000000?ooo`3oool0:03oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000b0?ooo`007P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo01h0oooo1`0000040?ooo`800000F`3oool2000002X0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0300oooo000X0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0V0?ooo`040000003oool0oooo000005T0
oooo00@000000?ooo`3oool00000:`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0<03oool002P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000:03oool4
000005T0oooo1000000[0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo000X
0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000002P0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0/0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo
000W0?ooo`8000000`3oool2000000030?ooo`000000oooo02P0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0[0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo000X
0?ooo`030000003oool0oooo0080oooo0`00000Y0?ooo`<00000FP3oool3000002`0oooo00<00000
0?ooo`3oool00P3oool3000003<0oooo003o0?ooob40oooo003o0?ooo`/0oooo0P00000D0?ooo`00
o`3oool:0?ooo`040000003oool0oooo000001<0oooo003o0?ooo`X0oooo00@000000?ooo`3oool0
00004`3oool000h0oooom00000070?ooo`050000003oool0oooo0?ooo`0000004P3oool001<0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool02`3oool500000180oooo000W0?ooo`030000003oool0oooo02d0oooo00<0
00000?ooo`3oool0;@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool07`3oool010000000oooo0?ooo`00000B0?ooo`00Q`3oool00`000000oooo0?oo
o`200?ooo`040000003oool0oooo00000180oooo00270?ooo`@00000P03oool300000180oooo0024
0?ooo`80000000D0oooo000000000000oooo0000002E0?ooo`00P`3oool01@000000oooo0?ooo`3o
ool0000000@0oooo00<000000?ooo`3oool0T@3oool00840oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`030?ooo`800000T@3oool00800oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`2F0?ooo`00O`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0SP3oool001<0oooo0P0000020?ooo`<000000P3oool3000000030?oo
o`00000000000080000000<0oooo0000000000000P0000000`3oool0000000000002000000040?oo
o`000000000000000080oooo0`0000020?ooo`<000000P3oool300000080oooo0`0000000`3oool0
000000000002000000030?ooo`00000000000080000000<0oooo0000000000000P000000103oool0
000000000000000T0?ooo`030000003oool0oooo00L0oooo0P0000070?ooo`800000903oool01000
0000oooo0?ooo`3oool300000080oooo0`0000020?ooo`<0000000<0oooo0000000000000P000000
0`3oool0000000000002000000030?ooo`00000000000080000000@0oooo00000000000000000P3o
ool300000080oooo0`0000020?ooo`<0000000<0oooo0000000000000P0000000`3oool000000000
0002000000030?ooo`00000000000080000000@0oooo0000000000000000903oool005/0oooo0`00
00020?ooo`<000006@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool00`0000020?ooo`800000JP3oool006@0oooo1000000C0?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0A0?ooo`80000000<0oooo
000000000000M03oool006T0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool03P3oool2000007T0oooo001Z0?ooo`80
0000303oool2000000d0oooo0P00000<0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3o
ool0NP3oool006h0oooo0`0000040?ooo`030000003oool0000000P0oooo0P0000050?ooo`030000
003oool0oooo00d0oooo0`0000030?ooo`8000000P3oool2000007d0oooo001b0?ooo`@00000203o
ool3000000030?ooo`000000oooo00<0oooo00<000000?ooo`3oool04P3oool200000880oooo001n
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0UP3oool007h0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`2F0?ooo`00O`3oool2000000H0oooo0`00002F0?ooo`00
P@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo09H0oooo00210?ooo`800000103o
ool00`000000oooo0?ooo`2F0?ooo`00OP3oool01@000000oooo0?ooo`3oool0000000@0oooo00<0
00000?ooo`3oool0UP3oool007h0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0
oooo09H0oooo001o0?ooo`<000001@3oool2000009L0oooo00270?ooo`030000003oool0oooo09H0
oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo0027
0?ooo`030000003oool0oooo09H0oooo00270?ooo`800000U`3oool008L0oooo00<000000?ooo`3o
ool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3o
ool008L0oooo0P00002G0?ooo`00P03oool2000000D0oooo00<000000?ooo`3oool0UP3oool00800
oooo0P0000050?ooo`030000003oool0oooo09H0oooo00200?ooo`8000001@3oool00`000000oooo
0?ooo`2F0?ooo`00OP3oool4000000D0oooo00<000000?ooo`3oool0UP3oool007h0oooo00@00000
0?ooo`00000000001@3oool3000009H0oooo001o0?ooo`<000001@3oool00`000000oooo0?ooo`2F
0?ooo`00O`3oool3000000D0oooo00<000000?ooo`3oool0UP3oool00800oooo0P0000050?ooo`03
0000003oool0oooo09H0oooo00200?ooo`8000001@3oool00`000000oooo0?ooo`2F0?ooo`00P@3o
ool00`000000oooo0?ooo`030?ooo`800000U`3oool008L0oooo00<000000?ooo`3oool0UP3oool0
08L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo
0P00002G0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F
0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00
Q`3oool2000009L0oooo001o0?ooo`<000001@3oool00`000000oooo0?ooo`2F0?ooo`00OP3oool2
000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0UP3oool007h0oooo00<000000?oo
o`3oool00P0000040?ooo`030000003oool0oooo09H0oooo001n0?ooo`050000003oool0oooo0?oo
o`000000103oool00`000000oooo0?ooo`2F0?ooo`00OP3oool00`000000oooo0?ooo`02000000@0
oooo0`00002F0?ooo`00OP3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool0
UP3oool007h0oooo00<000000?ooo`0000001P3oool00`000000oooo0?ooo`2F0?ooo`00OP3oool0
10000000oooo0?ooo`0000050?ooo`030000003oool0oooo09H0oooo001o0?ooo`030000003oool0
000000D0oooo0P00002G0?ooo`00O`3oool3000000D0oooo00<000000?ooo`3oool0UP3oool008L0
oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<0
00000?ooo`3oool0UP3oool008L0oooo0P00002G0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3o
ool00`000000oooo0?ooo`2F0?ooo`00Q`3oool2000009L0oooo001o0?ooo`<000001@3oool00`00
0000oooo0?ooo`2F0?ooo`00OP3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3o
ool0UP3oool007h0oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo09H0
oooo001n0?ooo`050000003oool0oooo0?ooo`000000103oool3000009H0oooo001n0?ooo`030000
003oool0oooo00800000103oool00`000000oooo0?ooo`2F0?ooo`00O`3oool3000000D0oooo00<0
00000?ooo`3oool0UP3oool007h0oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0
oooo09H0oooo001n0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`2F0?oo
o`00OP3oool2000000030?ooo`000000oooo00@0oooo0P00002G0?ooo`00O`3oool3000000D0oooo
00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<00000
0?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00002G0?ooo`00
Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool0
0`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00N@3oool2000000@0
oooo0`0000050?ooo`800000U`3oool007X0oooo00@000000?ooo`3oool0oooo0P0000000`3oool0
00000?ooo`040?ooo`030000003oool0oooo09H0oooo001j0?ooo`050000003oool0oooo0?ooo`00
00000P3oool2000000@0oooo00<000000?ooo`3oool0UP3oool007X0oooo00D000000?ooo`3oool0
oooo000000020?ooo`800000103oool00`000000oooo0?ooo`2F0?ooo`00NP3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00P3oool3000009H0oooo001j0?ooo`050000
003oool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo09H0
oooo001j0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3o
ool0UP3oool007X0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103oool00`000000
oooo0?ooo`2F0?ooo`00N@3oool2000000<0oooo0P0000000`3oool000000?ooo`040?ooo`030000
003oool0oooo09H0oooo001j0?ooo`030000003oool0oooo0080oooo0`0000050?ooo`800000U`3o
ool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0
oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00
002G0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?oo
o`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool2000009L0oooo001i0?ooo`8000001@3o
ool2000000D0oooo00<000000?ooo`3oool0UP3oool007X0oooo00@000000?ooo`3oool0oooo0`00
00000`3oool000000?ooo`030?ooo`030000003oool0oooo09H0oooo001j0?ooo`050000003oool0
oooo0?ooo`000000203oool00`000000oooo0?ooo`2F0?ooo`00NP3oool01@000000oooo0?ooo`3o
ool0000000P0oooo00<000000?ooo`3oool0UP3oool007X0oooo00<000000?ooo`3oool00P3oool2
000000H0oooo0`00002F0?ooo`00NP3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0UP3oool007X0oooo00<000000?ooo`3oool0103oool2000000@0
oooo00<000000?ooo`3oool0UP3oool007X0oooo00D000000?ooo`3oool0oooo000000030?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0UP3oool007T0oooo0P0000030?ooo`030000
003oool0oooo00800000103oool00`000000oooo0?ooo`2F0?ooo`00NP3oool00`000000oooo0?oo
o`020?ooo`<000001@3oool2000009L0oooo00270?ooo`030000003oool0oooo09H0oooo00270?oo
o`030000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`800000
U`3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool0
08L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo
0P00002G0?ooo`00N@3oool2000000D0oooo0P0000050?ooo`030000003oool0oooo09H0oooo001j
0?ooo`030000003oool0oooo00<0oooo0P0000050?ooo`030000003oool0oooo09H0oooo001j0?oo
o`030000003oool0oooo00<0oooo0P0000050?ooo`030000003oool0oooo09H0oooo001j0?ooo`04
0000003oool0oooo0?ooo`@000001@3oool00`000000oooo0?ooo`2F0?ooo`00NP3oool01P000000
oooo0?ooo`3oool000000?ooo`8000001@3oool3000009H0oooo001j0?ooo`030000003oool0oooo
0080oooo0`0000050?ooo`030000003oool0oooo09H0oooo001j0?ooo`030000003oool0oooo0080
oooo0`0000050?ooo`030000003oool0oooo09H0oooo001j0?ooo`030000003oool0oooo00<0oooo
0P0000050?ooo`030000003oool0oooo09H0oooo001i0?ooo`8000001@3oool2000000D0oooo00<0
00000?ooo`3oool0UP3oool007X0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`03
0?ooo`800000U`3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3o
ool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00002G0?ooo`00Q`3oool0
0`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000
oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool2000009L0oooo001i
0?ooo`800000103oool3000000D0oooo00<000000?ooo`3oool0UP3oool007X0oooo00@000000?oo
o`3oool0oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo09H0oooo001j0?oo
o`050000003oool0oooo0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3oool0UP3oool0
07X0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0UP3oool007X0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103oool3
000009H0oooo001j0?ooo`040000003oool0oooo0?ooo`80000000<0oooo0000003oool0W@3oool0
07X0oooo00L000000?ooo`3oool0oooo0000003oool0000009l0oooo001j0?ooo`050000003oool0
oooo0?ooo`0000000P3oool00`000000oooo0?ooo`2L0?ooo`00N@3oool2000000@0oooo00<00000
0?ooo`000000WP3oool007X0oooo00<000000?ooo`3oool00P3oool3000009h0oooo003o0?ooob40
oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-14.0685, -2.00064, \
0.103641, 0.106473}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0396825 0 0.0386271 [
[.10317 -0.0125 -11.875 -15.75 ]
[.10317 -0.0125 11.875 0 ]
[.30159 -0.0125 -9.03125 -15.75 ]
[.30159 -0.0125 9.03125 0 ]
[.69841 -0.0125 -4.84375 -15.75 ]
[.69841 -0.0125 4.84375 0 ]
[.89683 -0.0125 -7.6875 -15.75 ]
[.89683 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .07725 -9.6875 -7.875 ]
[.4875 .07725 0 7.875 ]
[.4875 .15451 -9.6875 -7.875 ]
[.4875 .15451 0 7.875 ]
[.4875 .23176 -9.6875 -7.875 ]
[.4875 .23176 0 7.875 ]
[.4875 .30902 -9.6875 -7.875 ]
[.4875 .30902 0 7.875 ]
[.4875 .38627 -15.375 -7.875 ]
[.4875 .38627 0 7.875 ]
[.4875 .46353 -15.375 -7.875 ]
[.4875 .46353 0 7.875 ]
[.4875 .54078 -15.375 -7.875 ]
[.4875 .54078 0 7.875 ]
[.4875 .61803 -15.375 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.10317 0 m
.10317 .00625 L
s
gsave
.10317 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.30159 0 m
.30159 .00625 L
s
gsave
.30159 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.69841 0 m
.69841 .00625 L
s
gsave
.69841 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.89683 0 m
.89683 .00625 L
s
gsave
.89683 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.14286 0 m
.14286 .00375 L
s
.18254 0 m
.18254 .00375 L
s
.22222 0 m
.22222 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.34127 0 m
.34127 .00375 L
s
.38095 0 m
.38095 .00375 L
s
.42063 0 m
.42063 .00375 L
s
.46032 0 m
.46032 .00375 L
s
.53968 0 m
.53968 .00375 L
s
.57937 0 m
.57937 .00375 L
s
.61905 0 m
.61905 .00375 L
s
.65873 0 m
.65873 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.77778 0 m
.77778 .00375 L
s
.81746 0 m
.81746 .00375 L
s
.85714 0 m
.85714 .00375 L
s
.06349 0 m
.06349 .00375 L
s
.02381 0 m
.02381 .00375 L
s
.93651 0 m
.93651 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(14) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(16) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01931 m
.50375 .01931 L
s
.5 .03863 m
.50375 .03863 L
s
.5 .05794 m
.50375 .05794 L
s
.5 .09657 m
.50375 .09657 L
s
.5 .11588 m
.50375 .11588 L
s
.5 .13519 m
.50375 .13519 L
s
.5 .17382 m
.50375 .17382 L
s
.5 .19314 m
.50375 .19314 L
s
.5 .21245 m
.50375 .21245 L
s
.5 .25108 m
.50375 .25108 L
s
.5 .27039 m
.50375 .27039 L
s
.5 .2897 m
.50375 .2897 L
s
.5 .32833 m
.50375 .32833 L
s
.5 .34764 m
.50375 .34764 L
s
.5 .36696 m
.50375 .36696 L
s
.5 .40558 m
.50375 .40558 L
s
.5 .4249 m
.50375 .4249 L
s
.5 .44421 m
.50375 .44421 L
s
.5 .48284 m
.50375 .48284 L
s
.5 .50215 m
.50375 .50215 L
s
.5 .52147 m
.50375 .52147 L
s
.5 .56009 m
.50375 .56009 L
s
.5 .57941 m
.50375 .57941 L
s
.5 .59872 m
.50375 .59872 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
[ .03 ] 0 setdash
.02381 .39655 m
.04262 .40504 L
.06244 .416 L
.10458 .44694 L
.14264 .48302 L
.18314 .52428 L
.20184 .54119 L
.21169 .54878 L
.22214 .55549 L
.22741 .55826 L
.23322 .56076 L
.23576 .56166 L
.2385 .5625 L
.24106 .56315 L
.24344 .56363 L
.24602 .56402 L
.24738 .56417 L
.24808 .56423 L
.24884 .56428 L
.24956 .56432 L
.25022 .56435 L
.25152 .56437 L
.25271 .56436 L
.25396 .56431 L
.25511 .56423 L
.25633 .56411 L
.25749 .56397 L
.25855 .56381 L
.26113 .56332 L
.26358 .56269 L
.26817 .56112 L
.27324 .55875 L
.27853 .55556 L
.28349 .55188 L
.29236 .54364 L
.30191 .53232 L
.32195 .50055 L
.34305 .45633 L
.38116 .35687 L
.42172 .24639 L
.44046 .20289 L
.46077 .16614 L
.46616 .1586 L
.47187 .15175 L
.47716 .14646 L
.48211 .14248 L
.48674 .13962 L
.48934 .13838 L
.49171 .13748 L
.4943 .13675 L
Mistroke
.49577 .13646 L
.49647 .13635 L
.49712 .13627 L
.49843 .13615 L
.49961 .1361 L
.50089 .13612 L
.50161 .13615 L
.50227 .1362 L
.50353 .13635 L
.50473 .13655 L
.50698 .13708 L
.5094 .13787 L
.51203 .13899 L
.51676 .1417 L
.52113 .14498 L
.53116 .15524 L
.5418 .17008 L
.56132 .20666 L
.57961 .24975 L
.61835 .3555 L
.63803 .40922 L
.65954 .46229 L
.68034 .50472 L
.69922 .53379 L
.70933 .54537 L
.71886 .55371 L
.72411 .55724 L
.72893 .55985 L
.73423 .56201 L
.7369 .56283 L
.73983 .56352 L
.74233 .56395 L
.74375 .56412 L
.74506 .56424 L
.7462 .56432 L
.74746 .56436 L
.74878 .56437 L
.75002 .56434 L
.75115 .56428 L
.75235 .56419 L
.75337 .56409 L
.75449 .56395 L
.75699 .56355 L
.75931 .56306 L
.76461 .56154 L
.76942 .5597 L
.78022 .55411 L
.79938 .54017 L
.82017 .52105 L
.86106 .47928 L
Mistroke
.90043 .44271 L
.93828 .41556 L
.95655 .40546 L
.97619 .39655 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`009`3oool2000000@0oooo0`00
000Z0?ooo`<00000FP3oool3000002X0oooo0P0000040?ooo`<00000<`3oool002P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0X0?ooo`040000003oool0oooo000005T0oooo
00@000000?ooo`3oool00000:`3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
0380oooo000X0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000002P0oooo00<000000?oo
o`3oool00P00001H0?ooo`030000003oool0oooo00800000:P3oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000b0?ooo`00:03oool01@000000oooo0?ooo`3oool000000080oooo0P00000/
0?ooo`030000003oool0oooo05X0oooo00<000000?ooo`3oool0:03oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000b0?ooo`007P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo01h0oooo1`0000040?ooo`800000F`3oool2000002X0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0300oooo000X0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0V0?ooo`040000003oool0oooo000005T0
oooo00@000000?ooo`3oool00000:`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0<03oool002P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000:03oool4
000005T0oooo1000000[0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo000X
0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000002P0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0/0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo
000W0?ooo`8000000`3oool2000000030?ooo`000000oooo02P0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0[0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo000X
0?ooo`030000003oool0oooo0080oooo0`00000Y0?ooo`<00000FP3oool3000002`0oooo00<00000
0?ooo`3oool00P3oool3000003<0oooo003o0?ooob40oooo003o0?ooo`/0oooo0P00000D0?ooo`00
o`3oool:0?ooo`040000003oool0oooo000001<0oooo003o0?ooo`X0oooo00@000000?ooo`3oool0
00004`3oool000h0oooom00000070?ooo`050000003oool0oooo0?ooo`0000004P3oool001<0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool02`3oool500000180oooo000W0?ooo`030000003oool0oooo02d0oooo00<0
00000?ooo`3oool0;@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool07`3oool010000000oooo0?ooo`00000B0?ooo`00Q`3oool00`000000oooo0?oo
o`200?ooo`040000003oool0oooo00000180oooo00270?ooo`030000003oool0oooo0840oooo0`00
000B0?ooo`00Q`3oool2000009L0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`03
0000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003o
ool0oooo09H0oooo00270?ooo`800000U`3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0
oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00
002G0?ooo`00P03oool2000000D0oooo00<000000?ooo`3oool0UP3oool007h0oooo0`0000000`3o
ool000000?ooo`030?ooo`030000003oool0oooo09H0oooo001n0?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0UP3oool007h0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`2F0?ooo`00O`3oool2000000H0oooo0`00002F0?ooo`00P@3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo09H0oooo00210?ooo`800000103oool00`000000oooo0?ooo`2F0?oo
o`00OP3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?ooo`3oool0UP3oool007h0
oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo09H0oooo001o0?ooo`<00000
1@3oool2000009L0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0
oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0
oooo00270?ooo`800000U`3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<00000
0?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo0P00002G0?ooo`00
P03oool200000080oooo1P00002F0?ooo`00P03oool2000000030?ooo`000000oooo0080oooo00<0
00000?ooo`3oool0UP3oool00800oooo0`0000040?ooo`030000003oool0oooo09H0oooo001n0?oo
o`@000001@3oool00`000000oooo0?ooo`2F0?ooo`00OP3oool010000000oooo0000000000050?oo
o`<000001@3oool00`000000oooo0?ooo`2>0?ooo`00O`3oool3000000D0oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`2>0?ooo`00O`3oool3000000D0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`2=0?ooo`00P03oool2000000D0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`2=0?ooo`00P03oool2000000D0oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`2<0?ooo`00P@3oool00`000000oooo0?ooo`030?ooo`8000002@3oool00`00
0000oooo0?ooo`2;0?ooo`00O03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0RP3oool007/0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`2F0?ooo`00N`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo09H0oooo001j
0?ooo`030000003oool0oooo00X0oooo0P00002G0?ooo`00NP3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo09H0oooo001i0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3o
ool0UP3oool007T0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0<0?ooo`030000
003oool0oooo08L0oooo00270?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0Q`3o
ool008L0oooo0P00000=0?ooo`030000003oool0oooo08L0oooo001o0?ooo`<000001@3oool00`00
0000oooo0?ooo`0=0?ooo`030000003oool0oooo08H0oooo001n0?ooo`80000000<0oooo0000003o
ool0103oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo08H0oooo001n0?ooo`030000
003oool0oooo00800000103oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo08D0oooo
001n0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?ooo`0>0?ooo`030000
003oool0oooo08D0oooo001f0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00P00
00040?ooo`<000003`3oool00`000000oooo0?ooo`240?ooo`00M@3oool00`000000oooo0?ooo`06
0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`2F0?ooo`00M@3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0000000H0oooo00<000000?ooo`3oool0UP3oool007@0
oooo00<000000?ooo`3oool01`3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo
09H0oooo001d0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`0000001@3oool2000009L0
oooo001c0?ooo`030000003oool0oooo00T0oooo0`0000050?ooo`030000003oool0oooo09H0oooo
001c0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0UP3oool007<0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo0840oooo00270?oo
o`030000003oool0oooo0180oooo00<000000?ooo`3oool0P@3oool008L0oooo0P00000D0?ooo`03
0000003oool0oooo0800oooo00270?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
P03oool008L0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`200?ooo`00Q`3oool0
0`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0800oooo001`0?ooo`030000003oool0oooo
01@0oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`1o0?ooo`00L03oool00`000000
oooo0?ooo`0D0?ooo`8000005@3oool00`000000oooo0?ooo`1o0?ooo`00K`3oool00`000000oooo
0?ooo`0=0?ooo`<000001@3oool00`000000oooo0?ooo`2F0?ooo`00K`3oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`2F0?ooo`00K`3oool0
0`000000oooo0?ooo`0<0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?oo
o`2F0?ooo`00K`3oool00`000000oooo0?ooo`0<0?ooo`050000003oool0oooo0?ooo`000000103o
ool3000009H0oooo001^0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool00P000004
0?ooo`030000003oool0oooo09H0oooo001^0?ooo`030000003oool0oooo00h0oooo0`0000050?oo
o`030000003oool0oooo01L0oooo00<000000?ooo`3oool0O03oool007h0oooo0P0000000`3oool0
00000?ooo`040?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0O03oool007h0oooo
00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0
N`3oool007h0oooo0P0000000`3oool000000?ooo`040?ooo`8000006@3oool00`000000oooo0?oo
o`1k0?ooo`00O`3oool3000000D0oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1k
0?ooo`00Q`3oool00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo07/0oooo00270?ooo`03
0000003oool0oooo01T0oooo00<000000?ooo`3oool0NP3oool006/0oooo00<000000?ooo`3oool0
6@3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo07X0oooo001[0?ooo`030000003o
ool0oooo01T0oooo0P00002G0?ooo`00JP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo09H0oooo001Z0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0UP3oool006X0
oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`2F0?ooo`00J@3oool00`000000oooo
0?ooo`0K0?ooo`030000003oool0oooo09H0oooo001Y0?ooo`030000003oool0oooo00d0oooo0P00
00040?ooo`<000001@3oool2000009L0oooo001Y0?ooo`030000003oool0oooo00h0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0M`3oool007X0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103o
ool00`000000oooo0?ooo`0L0?ooo`030000003oool0oooo07L0oooo001j0?ooo`050000003oool0
oooo0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?oo
o`1f0?ooo`00NP3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00P3o
ool3000001d0oooo00<000000?ooo`3oool0MP3oool007X0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool07@3oool00`000000oooo0?oo
o`1f0?ooo`00NP3oool01@000000oooo0?ooo`3oool000000080oooo0P0000040?ooo`030000003o
ool0oooo01d0oooo00<000000?ooo`3oool0MP3oool001<0oooo0P00001U0?ooo`050000003oool0
oooo0?ooo`0000000P3oool2000000@0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?oo
o`1e0?ooo`005@3oool3000004h0oooo00<000000?ooo`3oool0403oool2000000<0oooo0P000000
0`3oool000000?ooo`040?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0C@3oool2
000002H0oooo001V0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool00P3oool30000
00D0oooo0P00001]0?ooo`800000:03oool006D0oooo00<000000?ooo`3oool07`3oool00`000000
oooo0?ooo`1Z0?ooo`800000:P3oool006D0oooo00<000000?ooo`3oool07`3oool00`000000oooo
0?ooo`1X0?ooo`800000;03oool001d0oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?oo
o`0O0?ooo`030000003oool0oooo09H0oooo000N0?ooo`800000A@3oool00`000000oooo0?ooo`0O
0?ooo`030000003oool0oooo09H0oooo000P0?ooo`030000003oool0oooo0440oooo00<000000?oo
o`3oool0803oool2000009L0oooo000Q0?ooo`800000@@3oool00`000000oooo0?ooo`0P0?ooo`03
0000003oool0oooo0240oooo00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`0a0?ooo`00
8`3oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0
?@3oool00`000000oooo0?ooo`0b0?ooo`00Q`3oool00`000000oooo0?ooo`0R0?ooo`030000003o
ool0oooo03/0oooo00<000000?ooo`3oool0<`3oool008L0oooo0P00000S0?ooo`030000003oool0
oooo03X0oooo00<000000?ooo`3oool0=03oool007T0oooo0P0000050?ooo`8000001@3oool00`00
0000oooo0?ooo`0R0?ooo`030000003oool0oooo03P0oooo0P00000g0?ooo`00NP3oool010000000
oooo0?ooo`3oool3000000030?ooo`000000oooo00<0oooo00<000000?ooo`3oool08P3oool00`00
0000oooo0?ooo`0g0?ooo`030000003oool0oooo03L0oooo000Y0?ooo`030000003oool0oooo03D0
oooo00<000000?ooo`3oool05P3oool01@000000oooo0?ooo`3oool0000000P0oooo00<000000?oo
o`3oool08`3oool00`000000oooo0?ooo`1`0?ooo`00:P3oool00`000000oooo0?ooo`0d0?ooo`03
0000003oool0oooo01H0oooo00D000000?ooo`3oool0oooo000000080?ooo`030000003oool0oooo
02<0oooo00<000000?ooo`3oool0L03oool002/0oooo00<000000?ooo`3oool0<P3oool00`000000
oooo0?ooo`0G0?ooo`030000003oool0oooo0080oooo0P0000060?ooo`<00000UP3oool002`0oooo
00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2F0?ooo`00;@3oool00`000000oooo0?oo
o`0_0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0103oool2000000@0oooo00<0
00000?ooo`3oool0E`3oool00`000000oooo0?ooo`0l0?ooo`00;P3oool00`000000oooo0?ooo`0^
0?ooo`030000003oool0oooo01P0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0m0?ooo`00GP3oool0
0`000000oooo0?ooo`0H0?ooo`8000000`3oool00`000000oooo0?ooo`02000000@0oooo00<00000
0?ooo`3oool0E@3oool00`000000oooo0?ooo`0n0?ooo`00GP3oool00`000000oooo0?ooo`0I0?oo
o`030000003oool0oooo0080oooo0`0000050?ooo`800000:03oool00`000000oooo0?ooo`0Z0?oo
o`030000003oool0oooo03l0oooo00270?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3o
ool0:@3oool00`000000oooo0?ooo`100?ooo`00Q`3oool00`000000oooo0?ooo`0X0?ooo`030000
003oool0oooo02L0oooo00<000000?ooo`3oool0@@3oool003<0oooo00<000000?ooo`3oool0D@3o
ool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool0@P3o
ool003@0oooo00<000000?ooo`3oool0D03oool2000002X0oooo00<000000?ooo`3oool0JP3oool0
03D0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo
06X0oooo000f0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0:P3oool00`000000
oooo0?ooo`0Y0?ooo`030000003oool0oooo06X0oooo000g0?ooo`030000003oool0oooo01l0oooo
00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo06T0oooo
000h0?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?oo
o`1<0?ooo`030000003oool0oooo04L0oooo001H0?ooo`030000003oool0oooo02`0oooo0P00001<
0?ooo`030000003oool0oooo04P0oooo001H0?ooo`030000003oool0oooo01h0oooo0P0000050?oo
o`8000001@3oool00`000000oooo0?ooo`1:0?ooo`030000003oool0oooo04T0oooo001G0?ooo`03
0000003oool0oooo0200oooo00<000000?ooo`3oool00`3oool2000000D0oooo00<000000?ooo`3o
ool0B@3oool00`000000oooo0?ooo`1:0?ooo`00E`3oool00`000000oooo0?ooo`0P0?ooo`030000
003oool0oooo00<0oooo0P0000050?ooo`030000003oool0oooo04P0oooo00<000000?ooo`3oool0
B`3oool003h0oooo00<000000?ooo`3oool0>@3oool010000000oooo0?ooo`3oool4000000D0oooo
00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo04`0oooo
000o0?ooo`030000003oool0oooo03P0oooo00H000000?ooo`3oool0oooo0000003oool2000000D0
oooo0`00000_0?ooo`030000003oool0oooo06@0oooo00100?ooo`030000003oool0oooo03L0oooo
00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3oool0<03oool00`000000oooo
0?ooo`1S0?ooo`00@@3oool2000003L0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<0
00000?ooo`3oool0<@3oool00`000000oooo0?ooo`1R0?ooo`00@`3oool2000003D0oooo00<00000
0?ooo`3oool00`3oool2000000D0oooo00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`0<
0?ooo`030000003oool0oooo0580oooo001@0?ooo`8000009`3oool2000000D0oooo0P0000050?oo
o`030000003oool0oooo03<0oooo00<000000?ooo`3oool02@3oool2000005D0oooo001<0?ooo`@0
0000:P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo0P00000l0?ooo`@0
0000E`3oool004X0oooo0`00000j0?ooo`030000003oool0oooo03X0oooo0P00001J0?ooo`00Q`3o
ool00`000000oooo0?ooo`2F0?ooo`00Q`3oool00`000000oooo0?ooo`2F0?ooo`00Q`3oool20000
09L0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo
00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003oool0oooo09H0oooo00270?oo
o`800000U`3oool007T0oooo0P0000040?ooo`<000001@3oool00`000000oooo0?ooo`2F0?ooo`00
NP3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3o
ool0UP3oool007X0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103oool00`000000
oooo0?ooo`2F0?ooo`00NP3oool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`2F0?ooo`00NP3oool01@000000oooo0?ooo`3oool000000080
oooo0P0000040?ooo`<00000UP3oool007X0oooo00@000000?ooo`3oool0oooo0P0000000`3oool0
00000?ooo`2M0?ooo`00NP3oool01`000000oooo0?ooo`3oool000000?ooo`000000W`3oool007X0
oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo09`0oooo001i0?ooo`80
0000103oool00`000000oooo0000002N0?ooo`00NP3oool00`000000oooo0?ooo`020?ooo`<00000
WP3oool00?l0oooo8@3oool00?l0oooo8@3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-14.0685, -2.00064, \
0.103641, 0.106473}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.0396825 0 0.0386271 [
[.10317 -0.0125 -11.875 -15.75 ]
[.10317 -0.0125 11.875 0 ]
[.30159 -0.0125 -9.03125 -15.75 ]
[.30159 -0.0125 9.03125 0 ]
[.69841 -0.0125 -4.84375 -15.75 ]
[.69841 -0.0125 4.84375 0 ]
[.89683 -0.0125 -7.6875 -15.75 ]
[.89683 -0.0125 7.6875 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.4875 .07725 -9.6875 -7.875 ]
[.4875 .07725 0 7.875 ]
[.4875 .15451 -9.6875 -7.875 ]
[.4875 .15451 0 7.875 ]
[.4875 .23176 -9.6875 -7.875 ]
[.4875 .23176 0 7.875 ]
[.4875 .30902 -9.6875 -7.875 ]
[.4875 .30902 0 7.875 ]
[.4875 .38627 -15.375 -7.875 ]
[.4875 .38627 0 7.875 ]
[.4875 .46353 -15.375 -7.875 ]
[.4875 .46353 0 7.875 ]
[.4875 .54078 -15.375 -7.875 ]
[.4875 .54078 0 7.875 ]
[.4875 .61803 -15.375 -7.875 ]
[.4875 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.10317 0 m
.10317 .00625 L
s
gsave
.10317 -0.0125 -72.875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.30159 0 m
.30159 .00625 L
s
gsave
.30159 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.69841 0 m
.69841 .00625 L
s
gsave
.69841 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.89683 0 m
.89683 .00625 L
s
gsave
.89683 -0.0125 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.14286 0 m
.14286 .00375 L
s
.18254 0 m
.18254 .00375 L
s
.22222 0 m
.22222 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.34127 0 m
.34127 .00375 L
s
.38095 0 m
.38095 .00375 L
s
.42063 0 m
.42063 .00375 L
s
.46032 0 m
.46032 .00375 L
s
.53968 0 m
.53968 .00375 L
s
.57937 0 m
.57937 .00375 L
s
.61905 0 m
.61905 .00375 L
s
.65873 0 m
.65873 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.77778 0 m
.77778 .00375 L
s
.81746 0 m
.81746 .00375 L
s
.85714 0 m
.85714 .00375 L
s
.06349 0 m
.06349 .00375 L
s
.02381 0 m
.02381 .00375 L
s
.93651 0 m
.93651 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.5 .07725 m
.50625 .07725 L
s
gsave
.4875 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .15451 m
.50625 .15451 L
s
gsave
.4875 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .23176 m
.50625 .23176 L
s
gsave
.4875 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.5 .30902 m
.50625 .30902 L
s
gsave
.4875 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.5 .38627 m
.50625 .38627 L
s
gsave
.4875 .38627 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.5 .46353 m
.50625 .46353 L
s
gsave
.4875 .46353 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
1.000 setlinewidth
grestore
.5 .54078 m
.50625 .54078 L
s
gsave
.4875 .54078 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(14) show
1.000 setlinewidth
grestore
.5 .61803 m
.50625 .61803 L
s
gsave
.4875 .61803 -76.375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(16) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .01931 m
.50375 .01931 L
s
.5 .03863 m
.50375 .03863 L
s
.5 .05794 m
.50375 .05794 L
s
.5 .09657 m
.50375 .09657 L
s
.5 .11588 m
.50375 .11588 L
s
.5 .13519 m
.50375 .13519 L
s
.5 .17382 m
.50375 .17382 L
s
.5 .19314 m
.50375 .19314 L
s
.5 .21245 m
.50375 .21245 L
s
.5 .25108 m
.50375 .25108 L
s
.5 .27039 m
.50375 .27039 L
s
.5 .2897 m
.50375 .2897 L
s
.5 .32833 m
.50375 .32833 L
s
.5 .34764 m
.50375 .34764 L
s
.5 .36696 m
.50375 .36696 L
s
.5 .40558 m
.50375 .40558 L
s
.5 .4249 m
.50375 .4249 L
s
.5 .44421 m
.50375 .44421 L
s
.5 .48284 m
.50375 .48284 L
s
.5 .50215 m
.50375 .50215 L
s
.5 .52147 m
.50375 .52147 L
s
.5 .56009 m
.50375 .56009 L
s
.5 .57941 m
.50375 .57941 L
s
.5 .59872 m
.50375 .59872 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .16072 m
.04262 .16135 L
.06244 .16215 L
.08255 .16315 L
.10458 .16457 L
.12415 .16626 L
.14509 .16876 L
.1553 .17035 L
.16639 .17242 L
.18653 .17736 L
.20637 .18412 L
.2274 .19373 L
.26524 .21705 L
.28627 .23139 L
.30552 .24279 L
.31503 .24699 L
.32041 .24876 L
.32298 .24943 L
.3254 .24995 L
.3277 .25034 L
.32892 .2505 L
.3302 .25063 L
.33128 .25072 L
.33246 .25079 L
.33354 .25082 L
.33455 .25083 L
.33581 .25081 L
.33701 .25075 L
.33808 .25068 L
.33925 .25056 L
.34052 .2504 L
.34187 .25018 L
.3443 .24968 L
.34668 .24904 L
.34918 .24821 L
.35367 .2463 L
.35849 .24365 L
.36377 .24001 L
.37324 .23156 L
.38205 .22154 L
.4025 .19128 L
.42109 .15802 L
.44189 .11971 L
.45103 .10422 L
.46107 .0891 L
.47008 .07781 L
.47976 .06857 L
.4851 .0649 L
.48998 .0625 L
.49232 .06167 L
Mistroke
.49356 .06132 L
.49488 .06101 L
.49615 .06079 L
.4973 .06064 L
.49845 .06054 L
.49954 .06049 L
.50071 .0605 L
.50196 .06057 L
.50314 .06069 L
.50421 .06084 L
.50547 .06109 L
.50684 .06143 L
.50933 .06223 L
.51193 .06333 L
.5147 .06478 L
.51966 .06812 L
.52845 .07621 L
.53814 .08803 L
.5784 .15707 L
.59691 .1903 L
.6074 .20702 L
.61714 .22051 L
.62766 .23247 L
.63722 .24075 L
.64247 .24423 L
.64743 .24682 L
.65266 .24883 L
.65561 .24966 L
.65701 .24997 L
.65833 .25022 L
.6595 .2504 L
.66078 .25056 L
.66194 .25068 L
.66302 .25076 L
.66418 .25081 L
.66546 .25083 L
.6661 .25083 L
.66679 .25081 L
.66805 .25076 L
.66915 .25069 L
.67035 .25058 L
.67278 .25026 L
.67504 .24986 L
.67713 .2494 L
.68236 .24791 L
.68711 .24615 L
.69778 .24107 L
.73773 .21502 L
.77617 .19191 L
.79602 .18319 L
Mistroke
.81705 .17635 L
.8366 .17182 L
.85491 .16876 L
.87517 .16633 L
.8937 .1647 L
.9127 .16342 L
.93343 .16234 L
.9741 .16078 L
.97619 .16072 L
Mfstroke
[ .01 ] 0 setdash
.02381 .03897 m
.06244 .03904 L
.10458 .03914 L
.12507 .0392 L
.14415 .03926 L
.18221 .03944 L
.20262 .03956 L
.2212 .03971 L
.24035 .0399 L
.26113 .04017 L
.28097 .04053 L
.29097 .04078 L
.302 .04113 L
.31213 .04157 L
.32141 .04211 L
.32652 .04249 L
.33211 .043 L
.34228 .0442 L
.3526 .04592 L
.36196 .04799 L
.38293 .05437 L
.39229 .05757 L
.40218 .06055 L
.40735 .06172 L
.40876 .06197 L
.41028 .0622 L
.41159 .06237 L
.41302 .06252 L
.4137 .06257 L
.41441 .06262 L
.4157 .06268 L
.41691 .06271 L
.41759 .06271 L
.41824 .0627 L
.41943 .06265 L
.42053 .06258 L
.42173 .06247 L
.423 .06231 L
.42557 .06186 L
.428 .06128 L
.43254 .05975 L
.43743 .05746 L
.44274 .05428 L
.46111 .03898 L
.47137 .02955 L
.48098 .02197 L
.48581 .01903 L
.48829 .01781 L
.491 .01673 L
.49253 .01623 L
Mistroke
.49396 .01585 L
.49531 .01556 L
.49601 .01544 L
.49676 .01533 L
.4975 .01525 L
.49818 .01519 L
.49884 .01515 L
.49952 .01513 L
.50072 .01513 L
.50202 .0152 L
.50333 .01534 L
.50454 .01554 L
.50587 .01581 L
.50728 .01618 L
.50965 .01696 L
.51226 .01806 L
.51706 .0207 L
.52157 .02379 L
.5425 .04232 L
.55236 .05074 L
.55773 .05459 L
.56272 .05755 L
.567 .05956 L
.57157 .06115 L
.57418 .06181 L
.57546 .06206 L
.57664 .06226 L
.57769 .0624 L
.57885 .06253 L
.58001 .06262 L
.58124 .06268 L
.58254 .06271 L
.58374 .0627 L
.58507 .06265 L
.58573 .06261 L
.58647 .06256 L
.5877 .06245 L
.58903 .06229 L
.59143 .06194 L
.59628 .06093 L
.60073 .05975 L
.62163 .05283 L
.64053 .04739 L
.65125 .04521 L
.66122 .04374 L
.66626 .04316 L
.67173 .04264 L
.68166 .04191 L
.69132 .0414 L
.70024 .04105 L
Mistroke
.70992 .04075 L
.71898 .04053 L
.73961 .04016 L
.75987 .03989 L
.7784 .03971 L
.79901 .03955 L
.81813 .03944 L
.85634 .03926 L
.87688 .03919 L
.89549 .03914 L
.93558 .03904 L
.97415 .03898 L
.97619 .03897 L
Mfstroke
[ .03 ] 0 setdash
.02381 .39655 m
.04262 .40504 L
.06244 .416 L
.10458 .44694 L
.14264 .48302 L
.18314 .52428 L
.20184 .54119 L
.21169 .54878 L
.22214 .55549 L
.22741 .55826 L
.23322 .56076 L
.23576 .56166 L
.2385 .5625 L
.24106 .56315 L
.24344 .56363 L
.24602 .56402 L
.24738 .56417 L
.24808 .56423 L
.24884 .56428 L
.24956 .56432 L
.25022 .56435 L
.25152 .56437 L
.25271 .56436 L
.25396 .56431 L
.25511 .56423 L
.25633 .56411 L
.25749 .56397 L
.25855 .56381 L
.26113 .56332 L
.26358 .56269 L
.26817 .56112 L
.27324 .55875 L
.27853 .55556 L
.28349 .55188 L
.29236 .54364 L
.30191 .53232 L
.32195 .50055 L
.34305 .45633 L
.38116 .35687 L
.42172 .24639 L
.44046 .20289 L
.46077 .16614 L
.46616 .1586 L
.47187 .15175 L
.47716 .14646 L
.48211 .14248 L
.48674 .13962 L
.48934 .13838 L
.49171 .13748 L
.4943 .13675 L
Mistroke
.49577 .13646 L
.49647 .13635 L
.49712 .13627 L
.49843 .13615 L
.49961 .1361 L
.50089 .13612 L
.50161 .13615 L
.50227 .1362 L
.50353 .13635 L
.50473 .13655 L
.50698 .13708 L
.5094 .13787 L
.51203 .13899 L
.51676 .1417 L
.52113 .14498 L
.53116 .15524 L
.5418 .17008 L
.56132 .20666 L
.57961 .24975 L
.61835 .3555 L
.63803 .40922 L
.65954 .46229 L
.68034 .50472 L
.69922 .53379 L
.70933 .54537 L
.71886 .55371 L
.72411 .55724 L
.72893 .55985 L
.73423 .56201 L
.7369 .56283 L
.73983 .56352 L
.74233 .56395 L
.74375 .56412 L
.74506 .56424 L
.7462 .56432 L
.74746 .56436 L
.74878 .56437 L
.75002 .56434 L
.75115 .56428 L
.75235 .56419 L
.75337 .56409 L
.75449 .56395 L
.75699 .56355 L
.75931 .56306 L
.76461 .56154 L
.76942 .5597 L
.78022 .55411 L
.79938 .54017 L
.82017 .52105 L
.86106 .47928 L
Mistroke
.90043 .44271 L
.93828 .41556 L
.95655 .40546 L
.97619 .39655 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`009`3oool2000000@0oooo0`00
000Z0?ooo`<00000FP3oool3000002X0oooo0P0000040?ooo`<00000<`3oool002P0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0X0?ooo`040000003oool0oooo000005T0oooo
00@000000?ooo`3oool00000:`3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo
0380oooo000X0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000002P0oooo00<000000?oo
o`3oool00P00001H0?ooo`030000003oool0oooo00800000:P3oool01@000000oooo0?ooo`3oool0
00000080oooo0P00000b0?ooo`00:03oool01@000000oooo0?ooo`3oool000000080oooo0P00000/
0?ooo`030000003oool0oooo05X0oooo00<000000?ooo`3oool0:03oool01@000000oooo0?ooo`3o
ool000000080oooo0P00000b0?ooo`007P3oool7000000<0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo01h0oooo1`0000040?ooo`800000F`3oool2000002X0oooo00D0
00000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo0300oooo000X0?ooo`050000003o
ool0oooo0?ooo`0000000`3oool00`000000oooo0?ooo`0V0?ooo`040000003oool0oooo000005T0
oooo00@000000?ooo`3oool00000:`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0<03oool002P0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000:03oool4
000005T0oooo1000000[0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo000X
0?ooo`050000003oool0oooo0?ooo`0000000P3oool2000002P0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0/0?ooo`050000003oool0oooo0?ooo`0000000P3oool200000380oooo
000W0?ooo`8000000`3oool2000000030?ooo`000000oooo02P0oooo00<000000?ooo`3oool0FP3o
ool00`000000oooo0?ooo`0[0?ooo`8000000`3oool2000000030?ooo`000000oooo0380oooo000X
0?ooo`030000003oool0oooo0080oooo0`00000Y0?ooo`<00000FP3oool3000002`0oooo00<00000
0?ooo`3oool00P3oool3000003<0oooo003o0?ooob40oooo003o0?ooo`/0oooo0P00000D0?ooo`00
o`3oool:0?ooo`040000003oool0oooo000001<0oooo003o0?ooo`X0oooo00@000000?ooo`3oool0
00004`3oool000h0oooom00000070?ooo`050000003oool0oooo0?ooo`0000004P3oool001<0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool02`3oool500000180oooo000W0?ooo`030000003oool0oooo02d0oooo00<0
00000?ooo`3oool0;@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0oooo02h0oooo00<0
00000?ooo`3oool07`3oool010000000oooo0?ooo`00000B0?ooo`00Q`3oool00`000000oooo0?oo
o`200?ooo`040000003oool0oooo00000180oooo00270?ooo`@00000P03oool300000180oooo0024
0?ooo`80000000D0oooo000000000000oooo0000002E0?ooo`00P`3oool01@000000oooo0?ooo`3o
ool0000000@0oooo00<000000?ooo`3oool0T@3oool00840oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`030?ooo`800000T@3oool00800oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`2F0?ooo`00O`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0SP3oool001<0oooo0P0000020?ooo`<000000P3oool3000000030?oo
o`00000000000080000000<0oooo0000000000000P0000000`3oool0000000000002000000040?oo
o`000000000000000080oooo0`0000020?ooo`<000000P3oool300000080oooo0`0000000`3oool0
000000000002000000030?ooo`00000000000080000000<0oooo0000000000000P000000103oool0
000000000000000T0?ooo`030000003oool0oooo00L0oooo0P0000070?ooo`800000903oool01000
0000oooo0?ooo`3oool300000080oooo0`0000020?ooo`<0000000<0oooo0000000000000P000000
0`3oool0000000000002000000030?ooo`00000000000080000000@0oooo00000000000000000P3o
ool300000080oooo0`0000020?ooo`<0000000<0oooo0000000000000P0000000`3oool000000000
0002000000030?ooo`00000000000080000000@0oooo0000000000000000903oool005/0oooo0`00
00020?ooo`<000006@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0280oooo00<0
00000?ooo`3oool00`0000020?ooo`800000JP3oool006@0oooo1000000C0?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0A0?ooo`80000000<0oooo
000000000000M03oool006T0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool03P3oool2000007T0oooo001Z0?ooo`80
0000303oool2000000d0oooo0P00000<0?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3o
ool0NP3oool006h0oooo0`0000040?ooo`030000003oool0000000P0oooo0P0000030?ooo`H00000
303oool3000000<0oooo0P0000020?ooo`800000O@3oool00780oooo100000080?ooo`<0000000<0
oooo0000003oool00P000000103oool000000?ooo`3oool200000100oooo0P0000220?ooo`00OP3o
ool010000000oooo0?ooo`3oool2000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`2A0?ooo`00OP3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool0T03oool007l0oooo0P0000060?ooo`<00000103oool00`000000oooo0?oo
o`2?0?ooo`00O`3oool00`000000oooo000000050?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0SP3oool007l0oooo00@000000?ooo`0000000000103oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo08d0oooo001n0?ooo`050000003oool0oooo0?ooo`000000103oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo08`0oooo001m0?ooo`8000000P3oool20000
00@0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`2;0?ooo`00O03oool00`000000
oooo0?ooo`03000000D0oooo0P0000090?ooo`030000003oool0oooo08/0oooo001l0?ooo`030000
003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`2:0?ooo`00N`3o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0RP3o
ool007X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0
oooo08T0oooo001j0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`00
0000oooo0?ooo`290?ooo`00N@3oool00`000000oooo0?ooo`0;0?ooo`800000303oool00`000000
oooo0?ooo`280?ooo`00N03oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool0R03oool007P0oooo00<000000?ooo`3oool0303oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo08L0oooo001g0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`270?ooo`00M`3oool00`000000oooo0?ooo`0=0?oo
o`8000003P3oool00`000000oooo0?ooo`260?ooo`00MP3oool00`000000oooo0?ooo`070?ooo`80
00000P3oool6000000d0oooo00<000000?ooo`3oool0QP3oool007H0oooo00<000000?ooo`3oool0
1`3oool2000000030?ooo`000000oooo0080oooo00<000000?ooo`3oool03P3oool00`000000oooo
0?ooo`250?ooo`00M@3oool00`000000oooo0?ooo`080?ooo`<00000103oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo08D0oooo001e0?ooo`030000003oool0oooo00H0oooo10000005
0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0Q03oool007@0oooo00<000000?oo
o`3oool01`3oool010000000oooo0000000000050?ooo`<000001@3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo08@0oooo000C0?ooo`<00000GP3oool00`000000oooo0?ooo`080?oo
o`<000001@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool0FP3oool5000002@0oooo000F0?oooa@00000B@3oool00`000000oooo0?ooo`090?ooo`<0
00001@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool0A`3ooolB000002T0oooo000Z0?ooo`P00000@@3oool00`000000oooo0?ooo`0:0?ooo`800000
1@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0
?P3oool9000003/0oooo000b0?ooo`L00000>@3oool00`000000oooo0?ooo`0;0?ooo`8000001@3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0>03o
ool5000004@0oooo000i0?ooo`@00000=@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0
oooo00<0oooo0P0000090?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0=03oool4
000004T0oooo000m0?ooo`800000<P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
0340oooo0P00001=0?ooo`00?`3oool3000002l0oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool0;@3oool3000004l0
oooo00120?ooo`800000;03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0[0?ooo`800000DP3oool004@0oooo0P00
000Z0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool02P3oool2000001H0oooo00<0
00000?ooo`3oool0:03oool2000005@0oooo00160?ooo`8000009`3oool00`000000oooo0?ooo`08
0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool05@3oool00`000000oooo0?ooo`0V
0?ooo`800000EP3oool004P0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00/0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0T0?oo
o`030000003oool0oooo05H0oooo00190?ooo`8000008`3oool00`000000oooo0?ooo`080?ooo`03
0000003oool0oooo00/0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo0280oooo0P00001I0?ooo`00B`3oool00`000000oooo0?ooo`0O0?ooo`030000
003oool0oooo01L0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo0200oooo00<000000?ooo`3oool0F@3oool004`0oooo0P00000N0?ooo`030000003o
ool0oooo01P0oooo0P00000=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool07@3o
ool2000005`0oooo001>0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0403oool3
000000D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool0G03oool004l0oooo00<000000?ooo`3oool06@3oool00`00
0000oooo0?ooo`0@0?ooo`80000000<0oooo0000003oool0103oool00`000000oooo0?ooo`0=0?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool0603oool2000005l0oooo001@0?ooo`80
0000603oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00800000103oool00`000000
oooo0?ooo`0>0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool05@3oool200000640
oooo001B0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3oool04P3oool01@000000oooo
0?ooo`3oool0000000@0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0:0?ooo`03
0000003oool0oooo01@0oooo00<000000?ooo`3oool0H@3oool005<0oooo0P00000C0?ooo`030000
003oool0oooo00/0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`02000000@0oooo
0`00000?0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool04@3oool2000006@0oooo
001E0?ooo`800000403oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00H0oooo0P00
00000`3oool000000?ooo`040?ooo`030000003oool0oooo01d0oooo0P00000?0?ooo`800000IP3o
ool005L0oooo0P00000=0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo000000060?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool02`3oool0
0`000000oooo0?ooo`1V0?ooo`00F@3oool2000000T0oooo0P00000>0?ooo`030000003oool0oooo
00L0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`0P0?ooo`8000002@3oool2
000006T0oooo001K0?ooo`T00000403oool00`000000oooo0?ooo`080?ooo`030000003oool00000
00D0oooo0P00000S0?ooo`T00000J`3oool007<0oooo00<000000?ooo`3oool02@3oool3000000D0
oooo00<000000?ooo`3oool0UP3oool007<0oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`2F0?ooo`00L`3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0180oooo00<0
00000?ooo`3oool0P@3oool008L0oooo00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`21
0?ooo`00Q`3oool2000001@0oooo00<000000?ooo`3oool0P03oool008L0oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`200?ooo`00Q`3oool00`000000oooo0?ooo`0C0?ooo`030000
003oool0oooo0800oooo00270?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0P03o
ool00700oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`0D0?ooo`030000003oool0
oooo07l0oooo001`0?ooo`030000003oool0oooo01@0oooo0P00000E0?ooo`030000003oool0oooo
07l0oooo001_0?ooo`030000003oool0oooo00d0oooo0`0000050?ooo`030000003oool0oooo09H0
oooo001_0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool00P0000040?ooo`030000
003oool0oooo09H0oooo001_0?ooo`030000003oool0oooo00`0oooo00D000000?ooo`3oool0oooo
000000040?ooo`030000003oool0oooo09H0oooo001_0?ooo`030000003oool0oooo00`0oooo00D0
00000?ooo`3oool0oooo000000040?ooo`<00000UP3oool006h0oooo00<000000?ooo`3oool03@3o
ool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0UP3oool006h0oooo00<00000
0?ooo`3oool03P3oool3000000D0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`1l
0?ooo`00OP3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool05`3oool00`00
0000oooo0?ooo`1l0?ooo`00OP3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`1k0?ooo`00OP3oool2000000030?ooo`000000oooo00@0oooo
0P00000I0?ooo`030000003oool0oooo07/0oooo001o0?ooo`<000001@3oool00`000000oooo0?oo
o`0H0?ooo`030000003oool0oooo07/0oooo00270?ooo`030000003oool0oooo01P0oooo00<00000
0?ooo`3oool0N`3oool008L0oooo00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`1j0?oo
o`00J`3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3o
ool0NP3oool006/0oooo00<000000?ooo`3oool06@3oool2000009L0oooo001Z0?ooo`030000003o
ool0oooo01X0oooo00<000000?ooo`3oool0UP3oool006X0oooo00<000000?ooo`3oool06P3oool0
0`000000oooo0?ooo`2F0?ooo`00JP3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo
09H0oooo001Y0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0UP3oool006T0oooo
00<000000?ooo`3oool03@3oool2000000@0oooo0`0000050?ooo`800000U`3oool006T0oooo00<0
00000?ooo`3oool03P3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo00@0oooo
00<000000?ooo`3oool0703oool00`000000oooo0?ooo`1g0?ooo`00NP3oool01@000000oooo0?oo
o`3oool000000080oooo0P0000040?ooo`030000003oool0oooo01`0oooo00<000000?ooo`3oool0
M`3oool007X0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103oool00`000000oooo
0?ooo`0M0?ooo`030000003oool0oooo07H0oooo001j0?ooo`050000003oool0oooo0?ooo`000000
0`3oool00`000000oooo0?ooo`020?ooo`<000007@3oool00`000000oooo0?ooo`1f0?ooo`00NP3o
ool01@000000oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`0M0?ooo`030000003oool0oooo07H0oooo001j0?ooo`050000003oool0oooo0?ooo`000000
0P3oool2000000@0oooo00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`1f0?ooo`004`3o
ool2000006D0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000103oool00`000000oooo
0?ooo`0N0?ooo`030000003oool0oooo07D0oooo000E0?ooo`<00000CP3oool00`000000oooo0?oo
o`0@0?ooo`8000000`3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool07P3o
ool00`000000oooo0?ooo`1=0?ooo`8000009P3oool006H0oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`020?ooo`<000001@3oool2000006d0oooo0P00000X0?ooo`00I@3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo06X0oooo0P00000Z0?ooo`00I@3oool00`000000
oooo0?ooo`0O0?ooo`030000003oool0oooo06P0oooo0P00000/0?ooo`007@3oool00`000000oooo
0?ooo`150?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0UP3oool001h0oooo0P00
00150?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0UP3oool00200oooo00<00000
0?ooo`3oool0@@3oool00`000000oooo0?ooo`0P0?ooo`800000U`3oool00240oooo0P0000110?oo
o`030000003oool0oooo0200oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`0n0?oo
o`030000003oool0oooo0340oooo000S0?ooo`030000003oool0oooo0640oooo00<000000?ooo`3o
ool08@3oool00`000000oooo0?ooo`0m0?ooo`030000003oool0oooo0380oooo00270?ooo`030000
003oool0oooo0280oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`0c0?ooo`00Q`3o
ool2000002<0oooo00<000000?ooo`3oool0>P3oool00`000000oooo0?ooo`0d0?ooo`00N@3oool2
000000D0oooo0P0000050?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0>03oool2
000003L0oooo001j0?ooo`040000003oool0oooo0?ooo`<0000000<0oooo0000003oool00`3oool0
0`000000oooo0?ooo`0R0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0=`3oool0
02T0oooo00<000000?ooo`3oool0=@3oool00`000000oooo0?ooo`0F0?ooo`050000003oool0oooo
0?ooo`000000203oool00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0700oooo000Z0?oo
o`030000003oool0oooo03@0oooo00<000000?ooo`3oool05P3oool01@000000oooo0?ooo`3oool0
000000P0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`1`0?ooo`00:`3oool00`00
0000oooo0?ooo`0b0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool00P3oool20000
00H0oooo0`00002F0?ooo`00;03oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo01L0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo09H0
oooo000]0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0603oool00`000000oooo
0?ooo`040?ooo`800000103oool00`000000oooo0?ooo`1G0?ooo`030000003oool0oooo03`0oooo
000^0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0603oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1F0?ooo`030000
003oool0oooo03d0oooo001N0?ooo`030000003oool0oooo01P0oooo0P0000030?ooo`030000003o
ool0oooo00800000103oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo03h0oooo001N
0?ooo`030000003oool0oooo01T0oooo00<000000?ooo`3oool00P3oool3000000D0oooo0P00000X
0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool0?`3oool008L0oooo00<000000?oo
o`3oool09`3oool00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo0400oooo00270?ooo`03
0000003oool0oooo02P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`110?ooo`00
<`3oool00`000000oooo0?ooo`1A0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool0
9P3oool00`000000oooo0?ooo`120?ooo`00=03oool00`000000oooo0?ooo`1@0?ooo`800000:P3o
ool00`000000oooo0?ooo`1Z0?ooo`00=@3oool00`000000oooo0?ooo`1?0?ooo`030000003oool0
oooo02T0oooo00<000000?ooo`3oool0JP3oool003H0oooo00<000000?ooo`3oool08@3oool00`00
0000oooo0?ooo`0Z0?ooo`030000003oool0oooo02T0oooo00<000000?ooo`3oool0JP3oool003L0
oooo00<000000?ooo`3oool07`3oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo02X0
oooo00<000000?ooo`3oool0J@3oool003P0oooo00<000000?ooo`3oool07P3oool00`000000oooo
0?ooo`0[0?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool0A`3oool005P0oooo00<0
00000?ooo`3oool0;03oool2000004`0oooo00<000000?ooo`3oool0B03oool005P0oooo00<00000
0?ooo`3oool07P3oool2000000D0oooo0P0000050?ooo`030000003oool0oooo04X0oooo00<00000
0?ooo`3oool0B@3oool005L0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`030?oo
o`8000001@3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo04X0oooo001G0?ooo`03
0000003oool0oooo0200oooo00<000000?ooo`3oool00`3oool2000000D0oooo00<000000?ooo`3o
ool0B03oool00`000000oooo0?ooo`1;0?ooo`00?P3oool00`000000oooo0?ooo`0i0?ooo`040000
003oool0oooo0?ooo`@000001@3oool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo01H0
oooo00<000000?ooo`3oool0C03oool003l0oooo00<000000?ooo`3oool0>03oool01P000000oooo
0?ooo`3oool000000?ooo`8000001@3oool3000002l0oooo00<000000?ooo`3oool0I03oool00400
oooo00<000000?ooo`3oool0=`3oool00`000000oooo0?ooo`020?ooo`<000001@3oool00`000000
oooo0?ooo`0`0?ooo`030000003oool0oooo06<0oooo00110?ooo`800000=`3oool00`000000oooo
0?ooo`020?ooo`<000001@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0680oooo
00130?ooo`800000=@3oool00`000000oooo0?ooo`030?ooo`8000001@3oool00`000000oooo0?oo
o`0b0?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3oool0DP3oool00500oooo0P00000W
0?ooo`8000001@3oool2000000D0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`09
0?ooo`800000E@3oool004`0oooo1000000Z0?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool00`3oool2000003`0oooo1000001G0?ooo`00BP3oool3000003X0oooo00<000000?ooo`3o
ool0>P3oool2000005X0oooo00270?ooo`030000003oool0oooo09H0oooo00270?ooo`030000003o
ool0oooo09H0oooo00270?ooo`800000U`3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0
oooo00<000000?ooo`3oool0UP3oool008L0oooo00<000000?ooo`3oool0UP3oool008L0oooo00<0
00000?ooo`3oool0UP3oool008L0oooo0P00002G0?ooo`00N@3oool2000000@0oooo0`0000050?oo
o`030000003oool0oooo09H0oooo001j0?ooo`040000003oool0oooo0?ooo`80000000<0oooo0000
003oool0103oool00`000000oooo0?ooo`2F0?ooo`00NP3oool01@000000oooo0?ooo`3oool00000
0080oooo0P0000040?ooo`030000003oool0oooo09H0oooo001j0?ooo`050000003oool0oooo0?oo
o`0000000`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo09H0oooo001j0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool2000000@0oooo0`00002F0?ooo`00NP3oool010000000
oooo0?ooo`3oool2000000030?ooo`000000oooo09d0oooo001j0?ooo`070000003oool0oooo0?oo
o`000000oooo0000002O0?ooo`00NP3oool01@000000oooo0?ooo`3oool000000080oooo00<00000
0?ooo`3oool0W03oool007T0oooo0P0000040?ooo`030000003oool0000009h0oooo001j0?ooo`03
0000003oool0oooo0080oooo0`00002N0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-14.0685, -2.00064, \
0.103641, 0.106473}}]
}, Open  ]],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1440}, {0, 783}},
WindowSize->{840, 671},
WindowMargins->{{175, Automatic}, {Automatic, -13}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Info3327396267-1525374"->{
    Cell[494875, 15298, 361, 9, 44, "Print",
      CellTags->"Info3327396267-1525374"],
    Cell[495239, 15309, 291, 8, 25, "Print",
      CellTags->"Info3327396267-1525374"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Info3327396267-1525374", 637495, 19830}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 221, 5, 96, "Input"],
Cell[2000, 60, 356, 5, 22, "Message"],
Cell[2359, 67, 57, 1, 29, "Output"],
Cell[2419, 70, 43, 1, 29, "Output"]
}, Open  ]],
Cell[2477, 74, 90, 1, 30, "Input"],
Cell[2570, 77, 52, 1, 50, "Input"],

Cell[CellGroupData[{
Cell[2647, 82, 132, 3, 43, "Input"],
Cell[2782, 87, 354, 5, 22, "Message"],
Cell[3139, 94, 169, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3345, 102, 266, 5, 50, "Input"],
Cell[3614, 109, 26970, 798, 186, 13677, 629, "GraphicsData", "PostScript", \
"Graphics"],
Cell[30587, 909, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30754, 917, 96, 2, 43, "Input"],
Cell[30853, 921, 41, 1, 29, "Output"]
}, Open  ]],
Cell[30909, 925, 163, 4, 30, "Input"],
Cell[31075, 931, 173, 3, 50, "Input"],

Cell[CellGroupData[{
Cell[31273, 938, 355, 6, 70, "Input"],
Cell[31631, 946, 38920, 1375, 296, 18752, 1121, "GraphicsData", "PostScript", \
"Graphics"],
Cell[70554, 2323, 130, 3, 29, "Output"]
}, Open  ]],
Cell[70699, 2329, 26, 0, 30, "Input"],
Cell[70728, 2331, 164, 3, 30, "Input"],
Cell[70895, 2336, 52, 1, 50, "Input"],

Cell[CellGroupData[{
Cell[70972, 2341, 104, 2, 43, "Input"],
Cell[71079, 2345, 65, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[71181, 2351, 5186, 105, 730, "Input"],
Cell[76370, 2458, 27746, 814, 186, 12957, 627, "GraphicsData", "PostScript", \
"Graphics"],
Cell[104119, 3274, 130, 3, 29, "Output"],

Cell[CellGroupData[{
Cell[104274, 3281, 23972, 768, 186, 12957, 627, "GraphicsData", "PostScript", \
"Graphics"],
Cell[128249, 4051, 27763, 815, 186, 12970, 628, "GraphicsData", "PostScript", \
"Graphics"],
Cell[156015, 4868, 36838, 1110, 186, 16504, 854, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[192868, 5981, 130, 3, 29, "Output"]
}, Open  ]],
Cell[193013, 5987, 113, 2, 43, "Input"],
Cell[193129, 5991, 26, 0, 30, "Input"],

Cell[CellGroupData[{
Cell[193180, 5995, 26, 0, 30, "Input"],
Cell[193209, 5997, 74, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[193320, 6003, 5295, 124, 570, "Input"],
Cell[198618, 6129, 35141, 1068, 186, 17440, 845, "GraphicsData", \
"PostScript", "Graphics"],
Cell[233762, 7199, 130, 3, 29, "Output"],

Cell[CellGroupData[{
Cell[233917, 7206, 31155, 1015, 186, 17532, 842, "GraphicsData", \
"PostScript", "Graphics"],
Cell[265075, 8223, 38205, 1085, 186, 17155, 821, "GraphicsData", \
"PostScript", "Graphics"],
Cell[303283, 9310, 47187, 1386, 186, 20649, 1054, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[350485, 10699, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[350652, 10707, 114, 2, 43, "Input"],
Cell[350769, 10711, 69, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[350875, 10717, 7734, 168, 830, "Input"],
Cell[358612, 10887, 32587, 1035, 186, 17385, 843, "GraphicsData", \
"PostScript", "Graphics"],
Cell[391202, 11924, 130, 3, 29, "Output"],

Cell[CellGroupData[{
Cell[391357, 11931, 29738, 996, 186, 17496, 840, "GraphicsData", \
"PostScript", "Graphics"],
Cell[421098, 12929, 32406, 1029, 186, 17487, 840, "GraphicsData", \
"PostScript", "Graphics"],
Cell[453507, 13960, 41128, 1323, 186, 20916, 1069, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[494650, 15286, 130, 3, 29, "Output"]
}, Open  ]],
Cell[494795, 15292, 26, 0, 30, "Input"],

Cell[CellGroupData[{
Cell[494846, 15296, 26, 0, 30, "Input"],
Cell[494875, 15298, 361, 9, 44, "Print",
  CellTags->"Info3327396267-1525374"],
Cell[495239, 15309, 291, 8, 25, "Print",
  CellTags->"Info3327396267-1525374"]
}, Open  ]],
Cell[495545, 15320, 26, 0, 30, "Input"],

Cell[CellGroupData[{
Cell[495596, 15324, 6809, 159, 730, "Input"],
Cell[502408, 15485, 31279, 1004, 186, 17350, 827, "GraphicsData", \
"PostScript", "Graphics"],
Cell[533690, 16491, 130, 3, 29, "Output"],

Cell[CellGroupData[{
Cell[533845, 16498, 29764, 989, 186, 17431, 832, "GraphicsData", \
"PostScript", "Graphics"],
Cell[563612, 17489, 32652, 1017, 186, 17302, 823, "GraphicsData", \
"PostScript", "Graphics"],
Cell[596267, 18508, 40457, 1298, 186, 20867, 1052, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[636739, 19809, 130, 3, 29, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

