(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    165578,       5347]*)
(*NotebookOutlinePosition[    166225,       5369]*)
(*  CellTagsIndexPosition[    166181,       5365]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[""], "Input"],

Cell[BoxData[
    \(\(de[d_, \ th_, \ mu_] := \ 
        1/2\ Sqrt[
            2\ mu]\ \ \ Exp[\ \(-\ Sqrt[2\ mu]\)\ Abs[
                d\  - \ th]];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\ \ \)\(mu = 1; \ k = 0.75;\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(d = 1.5; \ 
    a = Plot[\ \ de[d, \ th, \ 
            mu]\ Gamma[
              k - 0.5]/\((\ \ \((th^2/2)\)^\((k - 
                    0.5)\))\), \ \ {th, \ \(-1\), 4}, \ 
        PlotRange \[Rule] \ {0, 8}, \[IndentingNewLine]\ 
        PlotStyle\  \[Rule] \ {{Thickness[0.01]}, {Dashing[
                0.2]}}, \[IndentingNewLine]\ 
        DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.214286 0.190476 0 0.0772542 [
[.02381 -0.0125 -9.03125 -15.75 ]
[.02381 -0.0125 9.03125 0 ]
[.40476 -0.0125 -4.84375 -15.75 ]
[.40476 -0.0125 4.84375 0 ]
[.59524 -0.0125 -4.84375 -15.75 ]
[.59524 -0.0125 4.84375 0 ]
[.78571 -0.0125 -4.84375 -15.75 ]
[.78571 -0.0125 4.84375 0 ]
[.97619 -0.0125 -4.84375 -15.75 ]
[.97619 -0.0125 4.84375 0 ]
[.20179 .07725 -9.6875 -7.875 ]
[.20179 .07725 0 7.875 ]
[.20179 .15451 -9.6875 -7.875 ]
[.20179 .15451 0 7.875 ]
[.20179 .23176 -9.6875 -7.875 ]
[.20179 .23176 0 7.875 ]
[.20179 .30902 -9.6875 -7.875 ]
[.20179 .30902 0 7.875 ]
[.20179 .38627 -9.6875 -7.875 ]
[.20179 .38627 0 7.875 ]
[.20179 .46353 -9.6875 -7.875 ]
[.20179 .46353 0 7.875 ]
[.20179 .54078 -9.6875 -7.875 ]
[.20179 .54078 0 7.875 ]
[.20179 .61803 -9.6875 -7.875 ]
[.20179 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.40476 0 m
.40476 .00625 L
s
gsave
.40476 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.59524 0 m
.59524 .00625 L
s
gsave
.59524 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.78571 0 m
.78571 .00625 L
s
gsave
.78571 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.21429 .07725 m
.22054 .07725 L
s
gsave
.20179 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.21429 .15451 m
.22054 .15451 L
s
gsave
.20179 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.21429 .23176 m
.22054 .23176 L
s
gsave
.20179 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.21429 .30902 m
.22054 .30902 L
s
gsave
.20179 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.21429 .38627 m
.22054 .38627 L
s
gsave
.20179 .38627 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.21429 .46353 m
.22054 .46353 L
s
gsave
.20179 .46353 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.21429 .54078 m
.22054 .54078 L
s
gsave
.20179 .54078 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.21429 .61803 m
.22054 .61803 L
s
gsave
.20179 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.21429 .01545 m
.21804 .01545 L
s
.21429 .0309 m
.21804 .0309 L
s
.21429 .04635 m
.21804 .04635 L
s
.21429 .0618 m
.21804 .0618 L
s
.21429 .09271 m
.21804 .09271 L
s
.21429 .10816 m
.21804 .10816 L
s
.21429 .12361 m
.21804 .12361 L
s
.21429 .13906 m
.21804 .13906 L
s
.21429 .16996 m
.21804 .16996 L
s
.21429 .18541 m
.21804 .18541 L
s
.21429 .20086 m
.21804 .20086 L
s
.21429 .21631 m
.21804 .21631 L
s
.21429 .24721 m
.21804 .24721 L
s
.21429 .26266 m
.21804 .26266 L
s
.21429 .27812 m
.21804 .27812 L
s
.21429 .29357 m
.21804 .29357 L
s
.21429 .32447 m
.21804 .32447 L
s
.21429 .33992 m
.21804 .33992 L
s
.21429 .35537 m
.21804 .35537 L
s
.21429 .37082 m
.21804 .37082 L
s
.21429 .40172 m
.21804 .40172 L
s
.21429 .41717 m
.21804 .41717 L
s
.21429 .43262 m
.21804 .43262 L
s
.21429 .44807 m
.21804 .44807 L
s
.21429 .47898 m
.21804 .47898 L
s
.21429 .49443 m
.21804 .49443 L
s
.21429 .50988 m
.21804 .50988 L
s
.21429 .52533 m
.21804 .52533 L
s
.21429 .55623 m
.21804 .55623 L
s
.21429 .57168 m
.21804 .57168 L
s
.21429 .58713 m
.21804 .58713 L
s
.21429 .60258 m
.21804 .60258 L
s
.25 Mabswid
.21429 0 m
.21429 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .00686 m
.04262 .00831 L
.06244 .01024 L
.08255 .01277 L
.10458 .01648 L
.12415 .02102 L
.13511 .02433 L
.14509 .02802 L
.15438 .03227 L
.16424 .03798 L
.16938 .04166 L
.17504 .04648 L
.18502 .05796 L
.19021 .06642 L
.19515 .07729 L
.19959 .09113 L
.2021 .10196 L
.20443 .11535 L
.20574 .12509 L
.20716 .13841 L
.2085 .15512 L
.20973 .17644 L
.21084 .20466 L
.21206 .25716 L
.21334 .3981 L
s
.21334 .3981 m
.21402 .61803 L
s
.21483 .61803 m
.2152 .40987 L
.21593 .30765 L
.21662 .25967 L
.21725 .23126 L
.21845 .19684 L
.21973 .17386 L
.22039 .16503 L
.2211 .15703 L
.22238 .14543 L
.22391 .13492 L
.22531 .12739 L
.22779 .11722 L
.23005 .11034 L
.23265 .10421 L
.23511 .09967 L
.23949 .09359 L
.24423 .08894 L
.24946 .08531 L
.2521 .08391 L
.255 .08262 L
.25747 .08171 L
.26013 .08089 L
.26493 .07975 L
.26748 .0793 L
.27019 .07893 L
.27274 .07866 L
.27506 .07849 L
.27649 .07841 L
.2778 .07835 L
.27848 .07833 L
.27923 .07831 L
.28002 .0783 L
.28075 .07829 L
.28145 .07829 L
.2821 .07829 L
.28334 .0783 L
.28403 .07831 L
.28466 .07833 L
.2861 .07837 L
.28726 .07842 L
.2885 .07848 L
.29074 .07862 L
.29586 .07906 L
.30126 .0797 L
.30621 .08042 L
.32517 .08429 L
.34588 .09024 L
.3865 .10665 L
.42559 .1287 L
Mistroke
.44554 .14267 L
.46714 .16017 L
.47727 .16932 L
.48799 .17972 L
.4924 .18422 L
.49713 .18921 L
.49853 .19071 L
.49985 .19214 L
.50103 .1905 L
.50233 .18825 L
.50718 .18008 L
.52654 .15106 L
.54793 .12468 L
.58716 .08813 L
.60648 .07445 L
.62733 .06214 L
.64696 .05248 L
.66844 .04368 L
.70803 .03122 L
.74856 .02221 L
.78757 .01605 L
.82904 .01139 L
.86899 .00821 L
.90742 .006 L
.94831 .0043 L
.97619 .00343 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00803oool2000005L0oooo0P00
000]0?ooo`800000:`3oool3000002d0oooo0P00000I0?ooo`008@3oool00`000000oooo0?ooo`1F
0?ooo`030000003oool0oooo02T0oooo0`0000000`3oool000000?ooo`0X0?ooo`030000003oool0
oooo00800000;03oool2000001T0oooo000Q0?ooo`030000003oool0oooo05H0oooo00<000000?oo
o`3oool0:@3oool00`000000oooo0?ooo`0[0?ooo`050000003oool0oooo0?ooo`000000;03oool2
000001T0oooo000Q0?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0:@3oool00`00
0000oooo0?ooo`0_0?ooo`030000003oool0oooo02P0oooo1000000I0?ooo`005`3oool7000000<0
oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0Z0?ooo`800000;P3oool00`000000
oooo0?ooo`0Y0?ooo`040000003oool00000000001T0oooo000Q0?ooo`030000003oool0oooo05H0
oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0Z0?ooo`800000;03oool3000001T0
oooo000Q0?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0;03oool2000002`0oooo
00<000000?ooo`3oool0:P3oool3000001T0oooo000Q0?ooo`030000003oool0oooo05H0oooo00<0
00000?ooo`3oool0:@3oool01@000000oooo0?ooo`3oool0000002T0oooo00<000000?ooo`3oool0
0P00000/0?ooo`8000006@3oool00200oooo0P00001G0?ooo`800000:`3oool00`000000oooo0?oo
o`02000002T0oooo00@000000?ooo`3oool00000;@3oool2000001T0oooo000Q0?ooo`030000003o
ool0oooo05H0oooo00<000000?ooo`3oool0:P3oool3000002/0oooo0`00000^0?ooo`030000003o
ool0oooo01L0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo
000G0?oooo@000005@3oool001d0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`06
0?ooo`030000003oool00000010000006`3oool001`0oooo2P00000U0?ooo`030000003oool0oooo
02/0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0[0?ooo`030000003oool0oooo
00P0oooo9000000K0?ooo`00703ooolD000001/0oooo00<000000?ooo`3oool0R@3ooolM000002`0
oooo000V0?ooo`l000005P3oool2000008D0oooo3`00000o0?ooo`00<03oool900000180oooo00<0
00000?ooo`3oool0O`3oool:000004T0oooo000e0?ooo`H00000403oool00`000000oooo0?ooo`1j
0?ooo`X00000CP3oool003P0oooo1P00000=0?ooo`030000003oool0oooo07D0oooo2P00001C0?oo
o`00>P3oool5000000`0oooo0P00001c0?ooo`P00000F03oool003d0oooo0`00000;0?ooo`030000
003oool0oooo06l0oooo1`00001L0?ooo`00?P3oool4000000T0oooo00<000000?ooo`3oool0K03o
ool7000005l0oooo000o0?ooo`@00000203oool00`000000oooo0?ooo`1Y0?ooo`L00000HP3oool0
0440oooo0`0000070?ooo`800000I`3oool7000006D0oooo00120?ooo`<000001P3oool00`000000
oooo0?ooo`1T0?ooo`H00000J03oool004<0oooo0`0000050?ooo`030000003oool0oooo0680oooo
1@00001[0?ooo`00@P3oool4000000D0oooo0P00001Q0?ooo`D00000K@3oool004<0oooo0`000005
0?ooo`030000003oool0oooo05l0oooo1000001_0?ooo`00@`3oool00`000000oooo000000050?oo
o`030000003oool0oooo05d0oooo1000001a0?ooo`00@`3oool010000000oooo0000000000040?oo
o`030000003oool0oooo05`0oooo1000001b0?ooo`00@`3oool010000000oooo0?ooo`0000040?oo
o`<000002P3oool8000004P0oooo1000001d0?ooo`00@`3oool00`000000oooo0?ooo`02000000<0
oooo00<000000?ooo`3oool01P3ooolB00000440oooo1000001e0?ooo`00@`3oool01@000000oooo
0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0103oool8000000D0oooo3000000k0?ooo`<0
0000M`3oool004<0oooo00@000000?ooo`3oool0oooo0P0000020?ooo`030000003oool0oooo00<0
oooo1000000A0?ooo`P00000=`3oool3000007P0oooo00120?ooo`800000103oool00`000000oooo
0?ooo`02000000@0oooo0P00000H0?ooo`H00000<`3oool3000007T0oooo00130?ooo`040000003o
ool0oooo0?ooo`8000000P3oool00`000000oooo0?ooo`020?ooo`8000006`3oool600000300oooo
0`00001j0?ooo`00A`3oool3000000030?ooo`000000oooo00<0oooo00<000000?ooo`3oool07@3o
ool6000002`0oooo0`00001k0?ooo`00B03oool2000000030?ooo`000000oooo0080oooo0P00000Q
0?ooo`H00000:03oool4000007`0oooo00180?ooo`80000000<0oooo0000000000000P3oool20000
02@0oooo1000000V0?ooo`@00000O@3oool004P0oooo0P000000103oool000000?ooo`3oool20000
02L0oooo1000000S0?ooo`<00000O`3oool004P0oooo0P0000001@3oool000000?ooo`3oool00000
02T0oooo1@00000P0?ooo`<00000P03oool004P0oooo0P0000000`3oool0000000000002000002/0
oooo1000000N0?ooo`<00000P@3oool004P0oooo0P0000000`3oool000000?ooo`02000002d0oooo
1000000K0?ooo`<00000PP3oool004P0oooo0P0000000`3oool000000?ooo`02000002h0oooo1000
000I0?ooo`<00000P`3oool004P0oooo0P000000103oool000000?ooo`00000a0?ooo`@000005P3o
ool3000008@0oooo00130?ooo`8000000`3oool600000380oooo1000000E0?ooo`800000Q@3oool0
0440oooo0`0000000`3oool000000?ooo`020?ooo`D00000=03oool3000001<0oooo0P0000260?oo
o`00@@3oool00`000000oooo0?ooo`050?ooo`D00000=@3oool400000100oooo0`0000260?ooo`00
@@3oool00`000000oooo0?ooo`050?ooo`D00000=P3oool4000000l0oooo0P0000270?ooo`00@P3o
ool2000000D0oooo1@00000h0?ooo`@00000303oool2000008P0oooo00140?ooo`030000003oool0
oooo0080oooo1@00000i0?ooo`<000002`3oool2000008T0oooo00140?ooo`8000000`3oool50000
03/0oooo0P0000090?ooo`800000RP3oool00440oooo00D000000?ooo`3oool0oooo000000030?oo
o`D00000?03oool2000000P0oooo00<000000?ooo`3oool0R@3oool00440oooo00<000000?ooo`3o
ool00P0000030?ooo`D00000?@3oool2000000H0oooo0P00002;0?ooo`00@P3oool3000000@0oooo
1@00000m0?ooo`@000000`3oool2000008`0oooo00190?ooo`@00000?`3oool400000080oooo00<0
00000?ooo`3oool0R`3oool004T0oooo100000110?ooo`D00000S@3oool004T0oooo100000120?oo
o`<00000SP3oool004T0oooo100000120?ooo`<00000SP3oool004T0oooo100000120?ooo`<00000
SP3oool004T0oooo1000003C0?ooo`00B@3oool400000=<0oooo001:0?ooo`<00000d`3oool004X0
oooo0`00003C0?ooo`00@P3oool3000000D0oooo0`00003C0?ooo`00@@3oool00`000000oooo0?oo
o`02000000@0oooo0`00003C0?ooo`00@@3oool01@000000oooo0?ooo`3oool0000000@0oooo0`00
003C0?ooo`00A@3oool00`000000oooo0?ooo`020?ooo`<00000d`3oool004@0oooo00<000000?oo
o`3oool00`3oool400000=80oooo00130?ooo`8000001@3oool300000=<0oooo00140?ooo`030000
003oool0oooo00<0oooo0`00003C0?ooo`00@@3oool00`000000oooo0?ooo`02000000@0oooo0`00
003C0?ooo`00@@3oool010000000oooo0?ooo`0000050?ooo`<00000d`3oool00480oooo0`000005
0?ooo`<00000d`3oool004X0oooo0`00003C0?ooo`00BP3oool300000=<0oooo001:0?ooo`<00000
d`3oool004X0oooo0`00003C0?ooo`00BP3oool300000=<0oooo001:0?ooo`<00000d`3oool004X0
oooo0`00003C0?ooo`00BP3oool300000=<0oooo001:0?ooo`<00000d`3oool004<0oooo0P000005
0?ooo`<00000d`3oool004<0oooo0P0000050?ooo`<00000d`3oool004<0oooo0P0000050?ooo`<0
0000d`3oool00440oooo100000050?ooo`@00000dP3oool00440oooo00@000000?ooo`0000000000
1@3oool300000=<0oooo00120?ooo`<000001@3oool300000=<0oooo00120?ooo`<000001@3oool3
00000=<0oooo00130?ooo`8000001@3oool300000=<0oooo00130?ooo`8000001@3oool300000=<0
oooo00140?ooo`030000003oool0oooo00<0oooo0`00003C0?ooo`00BP3oool300000=<0oooo001:
0?ooo`<00000d`3oool004X0oooo0`00003C0?ooo`00BP3oool300000=<0oooo001:0?ooo`<00000
d`3oool004X0oooo0`00003C0?ooo`00BP3oool300000=<0oooo001:0?ooo`<00000d`3oool00480
oooo0`0000050?ooo`<00000d`3oool00440oooo00@000000?ooo`3oool000001@3oool300000=<0
oooo00110?ooo`030000003oool0oooo00800000103oool300000=<0oooo00150?ooo`030000003o
ool0oooo0080oooo0`00003C0?ooo`00A03oool2000000@0oooo1000003B0?ooo`00@@3oool01000
0000oooo0?ooo`0000050?ooo`<00000d`3oool00440oooo100000050?ooo`<00000d`3oool00440
oooo00<000000?ooo`3oool01P3oool300000=<0oooo00110?ooo`030000003oool0oooo00H0oooo
0`00003C0?ooo`00@@3oool3000000H0oooo0`00003C0?ooo`00BP3oool200000=@0oooo001:0?oo
o`800000e03oool004X0oooo0`00003C0?ooo`00BP3oool200000=@0oooo001:0?ooo`800000e03o
ool004X0oooo0P00003D0?ooo`00BP3oool300000=<0oooo001:0?ooo`800000e03oool004X0oooo
0P00003D0?ooo`00@P3oool3000000D0oooo0`00003C0?ooo`00@@3oool2000000030?ooo`000000
oooo00@0oooo0P00003D0?ooo`00@@3oool00`000000oooo0?ooo`02000000@0oooo0P00003D0?oo
o`00@@3oool01@000000oooo0?ooo`3oool0000000@0oooo0P00003D0?ooo`00@@3oool00`000000
oooo0?ooo`02000000@0oooo1000003B0?ooo`00@@3oool2000000030?ooo`000000oooo00@0oooo
0P00003D0?ooo`00@@3oool00`000000oooo000000060?ooo`800000e03oool00440oooo00@00000
0?ooo`3oool000001@3oool200000=@0oooo00120?ooo`030000003oool0000000D0oooo0`00003C
0?ooo`00@P3oool3000000D0oooo0P00003D0?ooo`00BP3oool200000=@0oooo001:0?ooo`800000
e03oool004X0oooo0`00003C0?ooo`00BP3oool200000=@0oooo001:0?ooo`800000e03oool004X0
oooo0`00003C0?ooo`00BP3oool200000=@0oooo001:0?ooo`800000e03oool004X0oooo0P00003D
0?ooo`00BP3oool300000=<0oooo00130?ooo`030000003oool0oooo00@0oooo0P00003D0?ooo`00
@`3oool00`000000oooo0?ooo`040?ooo`800000e03oool004<0oooo00<000000?ooo`3oool0103o
ool200000=@0oooo00130?ooo`030000003oool0oooo00@0oooo1000003B0?ooo`00A03oool00`00
0000oooo0?ooo`030?ooo`800000e03oool004@0oooo00<000000?ooo`3oool00`3oool200000=@0
oooo00110?ooo`050000003oool0oooo0?ooo`000000103oool200000=@0oooo00110?ooo`030000
003oool0000000800000103oool300000=<0oooo00110?ooo`8000000P3oool00`000000oooo0?oo
o`020?ooo`800000e03oool004X0oooo0P00003D0?ooo`00BP3oool300000=<0oooo001:0?ooo`80
0000e03oool004X0oooo0P00003D0?ooo`00BP3oool200000=@0oooo001:0?ooo`<00000d`3oool0
04X0oooo0P00003D0?ooo`00BP3oool200000=@0oooo001:0?ooo`800000e03oool00480oooo0`00
00050?ooo`<00000d`3oool00440oooo00<000000?ooo`3oool00P0000040?ooo`800000e03oool0
0440oooo00D000000?ooo`3oool0oooo000000040?ooo`800000e03oool00440oooo00D000000?oo
o`3oool0oooo000000040?ooo`800000e03oool00440oooo00<000000?ooo`3oool00P0000040?oo
o`@00000dP3oool00480oooo0`00003K0?ooo`00@@3oool2000000030?ooo`000000oooo0=X0oooo
00110?ooo`030000003oool0oooo00800000fP3oool00440oooo0P0000000`3oool000000?ooo`3J
0?ooo`00@P3oool300000=/0oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.63345, -1.00032, \
0.021592, 0.0532366}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(d = 0.3; 
    b = Plot[\ \ de[d, \ th, \ 
            mu]\ Gamma[
              k - 0.5]/\((\ \ \((th^2/2)\)^\((k - 
                    0.5)\))\), \ \ {th, \ \(-1\), 4}, \ 
        PlotRange \[Rule] \ {0, 8}, \[IndentingNewLine]\ 
        PlotStyle\  \[Rule] \ {{Thickness[0.01]}, {Dashing[
                0.2]}}, \[IndentingNewLine]\ 
        DefaultFont\  \[Rule] \ {"\<Roman\>", 
            12}]\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.214286 0.190476 0 0.0772542 [
[.02381 -0.0125 -9.03125 -15.75 ]
[.02381 -0.0125 9.03125 0 ]
[.40476 -0.0125 -4.84375 -15.75 ]
[.40476 -0.0125 4.84375 0 ]
[.59524 -0.0125 -4.84375 -15.75 ]
[.59524 -0.0125 4.84375 0 ]
[.78571 -0.0125 -4.84375 -15.75 ]
[.78571 -0.0125 4.84375 0 ]
[.97619 -0.0125 -4.84375 -15.75 ]
[.97619 -0.0125 4.84375 0 ]
[.20179 .07725 -9.6875 -7.875 ]
[.20179 .07725 0 7.875 ]
[.20179 .15451 -9.6875 -7.875 ]
[.20179 .15451 0 7.875 ]
[.20179 .23176 -9.6875 -7.875 ]
[.20179 .23176 0 7.875 ]
[.20179 .30902 -9.6875 -7.875 ]
[.20179 .30902 0 7.875 ]
[.20179 .38627 -9.6875 -7.875 ]
[.20179 .38627 0 7.875 ]
[.20179 .46353 -9.6875 -7.875 ]
[.20179 .46353 0 7.875 ]
[.20179 .54078 -9.6875 -7.875 ]
[.20179 .54078 0 7.875 ]
[.20179 .61803 -9.6875 -7.875 ]
[.20179 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.40476 0 m
.40476 .00625 L
s
gsave
.40476 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.59524 0 m
.59524 .00625 L
s
gsave
.59524 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.78571 0 m
.78571 .00625 L
s
gsave
.78571 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.21429 .07725 m
.22054 .07725 L
s
gsave
.20179 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.21429 .15451 m
.22054 .15451 L
s
gsave
.20179 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.21429 .23176 m
.22054 .23176 L
s
gsave
.20179 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.21429 .30902 m
.22054 .30902 L
s
gsave
.20179 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.21429 .38627 m
.22054 .38627 L
s
gsave
.20179 .38627 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.21429 .46353 m
.22054 .46353 L
s
gsave
.20179 .46353 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.21429 .54078 m
.22054 .54078 L
s
gsave
.20179 .54078 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.21429 .61803 m
.22054 .61803 L
s
gsave
.20179 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.21429 .01545 m
.21804 .01545 L
s
.21429 .0309 m
.21804 .0309 L
s
.21429 .04635 m
.21804 .04635 L
s
.21429 .0618 m
.21804 .0618 L
s
.21429 .09271 m
.21804 .09271 L
s
.21429 .10816 m
.21804 .10816 L
s
.21429 .12361 m
.21804 .12361 L
s
.21429 .13906 m
.21804 .13906 L
s
.21429 .16996 m
.21804 .16996 L
s
.21429 .18541 m
.21804 .18541 L
s
.21429 .20086 m
.21804 .20086 L
s
.21429 .21631 m
.21804 .21631 L
s
.21429 .24721 m
.21804 .24721 L
s
.21429 .26266 m
.21804 .26266 L
s
.21429 .27812 m
.21804 .27812 L
s
.21429 .29357 m
.21804 .29357 L
s
.21429 .32447 m
.21804 .32447 L
s
.21429 .33992 m
.21804 .33992 L
s
.21429 .35537 m
.21804 .35537 L
s
.21429 .37082 m
.21804 .37082 L
s
.21429 .40172 m
.21804 .40172 L
s
.21429 .41717 m
.21804 .41717 L
s
.21429 .43262 m
.21804 .43262 L
s
.21429 .44807 m
.21804 .44807 L
s
.21429 .47898 m
.21804 .47898 L
s
.21429 .49443 m
.21804 .49443 L
s
.21429 .50988 m
.21804 .50988 L
s
.21429 .52533 m
.21804 .52533 L
s
.21429 .55623 m
.21804 .55623 L
s
.21429 .57168 m
.21804 .57168 L
s
.21429 .58713 m
.21804 .58713 L
s
.21429 .60258 m
.21804 .60258 L
s
.25 Mabswid
.21429 0 m
.21429 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .03746 m
.04262 .04538 L
.06244 .0559 L
.08255 .06968 L
.10458 .08992 L
.12415 .11472 L
.13511 .13278 L
.14509 .15295 L
.15438 .17613 L
.16424 .20731 L
.16938 .22738 L
.17504 .25368 L
.18502 .31633 L
.19021 .36253 L
.19515 .42184 L
.19959 .49738 L
.2021 .55647 L
s
.2021 .55647 m
.20406 .61803 L
s
.2291 .61803 m
.23005 .60221 L
.23265 .56877 L
.23511 .54398 L
.23949 .51082 L
.24423 .48541 L
.24946 .4656 L
.2521 .45795 L
.255 .45094 L
.25747 .44595 L
.26013 .44146 L
.26493 .43526 L
.26748 .43282 L
.26887 .4317 L
.27019 .43078 L
.27142 .43002 L
.27211 .42533 L
.27274 .42101 L
.27506 .40587 L
.2861 .34397 L
.30621 .26189 L
.32507 .20738 L
.34575 .16328 L
.36529 .13176 L
.38622 .10571 L
.4075 .08515 L
.42764 .06978 L
.46602 .04831 L
.48583 .04015 L
.50685 .03309 L
.54466 .02352 L
.56404 .0198 L
.58491 .01647 L
.6046 .01387 L
.6261 .01151 L
.66578 .00819 L
.68543 .00693 L
.70639 .0058 L
.74794 .00409 L
.78798 .00293 L
.82649 .00213 L
.86747 .00152 L
.90692 .0011 L
.94486 .00081 L
.97619 .00063 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00803oool2000005L0oooo0P00
000]0?ooo`800000:`3oool3000002d0oooo0P00000I0?ooo`008@3oool00`000000oooo0?ooo`1F
0?ooo`030000003oool0oooo02T0oooo0`0000000`3oool000000?ooo`0X0?ooo`030000003oool0
oooo00800000;03oool2000001T0oooo000Q0?ooo`030000003oool0oooo05H0oooo00<000000?oo
o`3oool0:@3oool00`000000oooo0?ooo`0[0?ooo`050000003oool0oooo0?ooo`000000;03oool2
000001T0oooo000Q0?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0:@3oool00`00
0000oooo0?ooo`0_0?ooo`030000003oool0oooo02P0oooo1000000I0?ooo`005`3oool7000000<0
oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0Z0?ooo`800000;P3oool00`000000
oooo0?ooo`0Y0?ooo`040000003oool00000000001T0oooo000Q0?ooo`030000003oool0oooo05H0
oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0Z0?ooo`800000;03oool3000001T0
oooo000Q0?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0;03oool2000002`0oooo
00<000000?ooo`3oool0:P3oool3000001T0oooo000Q0?ooo`030000003oool0oooo05H0oooo00<0
00000?ooo`3oool0:@3oool01@000000oooo0?ooo`3oool0000002T0oooo00<000000?ooo`3oool0
0P00000/0?ooo`8000006@3oool00200oooo0P00001G0?ooo`800000:`3oool00`000000oooo0?oo
o`02000002T0oooo00@000000?ooo`3oool00000;@3oool2000001T0oooo000Q0?ooo`030000003o
ool0oooo05H0oooo00<000000?ooo`3oool0:P3oool3000002/0oooo0`00000^0?ooo`030000003o
ool0oooo01L0oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo
000G0?oooo@000005@3oool001d0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo00H0oooo@P00000K0?ooo`007@3oool00`000000oooo0?ooo`0[0?oo
o`030000003oool0oooo02/0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`040?oo
oeH000006`3oool004/0oooo00<000000?ooo`3oool0G03ooolI000005d0oooo001;0?ooo`800000
D`3oool?00000740oooo001;0?ooo`030000003oool0oooo04d0oooo3`00001f0?ooo`00B`3oool0
0`000000oooo0?ooo`190?ooo`T00000P03oool004/0oooo00<000000?ooo`3oool0A03oool90000
08D0oooo000M0?ooo`030000003oool0oooo02/0oooo0P0000120?ooo`P00000R@3oool001`0oooo
1000000[0?ooo`030000003oool0oooo03l0oooo1P00002=0?ooo`007@3oool5000002T0oooo00<0
00000?ooo`3oool0?03oool600000900oooo000O0?ooo`D000009`3oool00`000000oooo0?ooo`0j
0?ooo`H00000TP3oool00240oooo1000000V0?ooo`800000>@3oool5000009D0oooo000S0?ooo`@0
0000903oool00`000000oooo0?ooo`0f0?ooo`D00000U`3oool002@0oooo1@00000R0?ooo`030000
003oool0oooo03D0oooo1000002I0?ooo`009P3oool4000001P0oooo0P0000070?ooo`800000=03o
ool4000009/0oooo000X0?ooo`@000005`3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo0340oooo1@00002L0?ooo`00:@3oool4000001H0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`0`0?ooo`@00000WP3oool002/0oooo0`00000E0?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0;P3oool400000:00oooo000/0?ooo`<00000503oool00`000000oooo
0?ooo`050?ooo`<00000;@3oool400000:40oooo000]0?ooo`<000004`3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo02`0oooo0`00002S0?ooo`00;P3oool300000180oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`0[0?ooo`<00000Y03oool002l0oooo0`00000A0?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0:P3oool300000:D0oooo000`0?ooo`<0
00003`3oool2000000L0oooo0P00000Z0?ooo`<00000YP3oool00340oooo0P00000@0?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool0:03oool300000:L0oooo000b0?ooo`8000005`3o
ool00`000000oooo0?ooo`0W0?ooo`<00000Z03oool00380oooo0`00000F0?ooo`030000003oool0
oooo02H0oooo0`00002Y0?ooo`00<`3oool3000001D0oooo0P00000V0?ooo`<00000ZP3oool003@0
oooo0P00000E0?ooo`030000003oool0oooo02@0oooo0`00002[0?ooo`00=@3oool2000001@0oooo
00<000000?ooo`3oool0903oool200000:`0oooo000f0?ooo`030000003oool0oooo0180oooo0P00
000T0?ooo`800000[@3oool003H0oooo0P00000C0?ooo`030000003oool0oooo0280oooo0`00002]
0?ooo`00=`3oool200000180oooo00<000000?ooo`3oool08P3oool200000:h0oooo000h0?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool08@3oool200000:l0oooo000h0?ooo`800000
2@3oool2000000H0oooo0P00000Q0?ooo`800000/03oool003P0oooo0P0000070?ooo`<0000000<0
oooo0000003oool0103oool00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0:l0oooo000h
0?ooo`<000001P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo01l0oooo0P00002a
0?ooo`00>@3oool2000000H0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0O0?oo
o`030000003oool0oooo0;00oooo000j0?ooo`030000003oool0oooo00D0oooo0P0000070?ooo`<0
00007P3oool200000;80oooo000j0?ooo`800000203oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo01d0oooo0P00002c0?ooo`00>`3oool00`000000oooo0?ooo`060?ooo`8000001@3o
ool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0;80oooo000k0?ooo`800000103oool0
1@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool0703oool200000;@0oooo000l
0?ooo`8000000`3oool00`000000oooo0?ooo`02000000D0oooo0P00000M0?ooo`030000003oool0
oooo0;<0oooo000m0?ooo`030000003oool0oooo0080oooo0`0000060?ooo`030000003oool0oooo
01/0oooo0P00002e0?ooo`00?@3oool2000000`0oooo00<000000?ooo`3oool06`3oool00`000000
oooo0?ooo`2d0?ooo`00?@3oool2000000`0oooo0P00000K0?ooo`800000]P3oool003d0oooo0P00
000<0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0]@3oool003d0oooo0`00000;
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0]@3oool003h0oooo0P00000;0?oo
o`030000003oool0oooo01T0oooo0P00002g0?ooo`00?P3oool2000000/0oooo0P00000J0?ooo`03
0000003oool0oooo0;H0oooo000n0?ooo`8000002`3oool00`000000oooo0?ooo`0H0?ooo`800000
^03oool003h0oooo0P00000;0?ooo`030000003oool0oooo01P0oooo00<000000?ooo`3oool0]`3o
ool003l0oooo0P00000:0?ooo`030000003oool0oooo01L0oooo0P00002i0?ooo`00?`3oool20000
00040?ooo`0000000000000000H0oooo0P00000H0?ooo`800000^@3oool003l0oooo0`0000020?oo
o`8000001@3oool00`000000oooo0?ooo`0F0?ooo`<00000^@3oool003l0oooo0`0000030?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool05P3oool200000;X0oooo000o0?ooo`<00000
0`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo01H0oooo0P00002j0?ooo`00@03o
ool200000080oooo00<000000?ooo`3oool0103oool3000001D0oooo0`00002j0?ooo`00@03oool2
000000030?ooo`000000000000H0oooo00<000000?ooo`3oool05@3oool200000;/0oooo00100?oo
o`<0000000<0oooo0000003oool01@3oool00`000000oooo0?ooo`0E0?ooo`800000^`3oool00440
oooo0P0000000`3oool00000000000050?ooo`8000005P3oool200000;/0oooo00110?ooo`800000
00<0oooo0000003oool01@3oool00`000000oooo0?ooo`0D0?ooo`<00000^`3oool00440oooo1000
00060?ooo`030000003oool0oooo01@0oooo0P00002l0?ooo`00@P3oool2000000L0oooo00<00000
0?ooo`3oool0503oool200000;`0oooo00120?ooo`8000001`3oool2000001@0oooo0`00002l0?oo
o`00@P3oool2000000L0oooo00<000000?ooo`3oool04`3oool200000;d0oooo00120?ooo`800000
1`3oool00`000000oooo0?ooo`0C0?ooo`800000_@3oool00480oooo0P0000070?ooo`030000003o
ool0oooo01<0oooo0P00002m0?ooo`00@P3oool2000000L0oooo0P00000C0?ooo`<00000_@3oool0
0480oooo0P0000070?ooo`030000003oool0oooo0180oooo0P00002n0?ooo`00@`3oool2000000H0
oooo00<000000?ooo`3oool04P3oool200000;h0oooo00130?ooo`8000001P3oool00`000000oooo
0?ooo`0B0?ooo`800000_P3oool004<0oooo0P0000060?ooo`8000004P3oool300000;h0oooo0013
0?ooo`8000001P3oool00`000000oooo0?ooo`0A0?ooo`800000_`3oool004<0oooo0P0000060?oo
o`030000003oool0oooo0140oooo0P00002o0?ooo`00@@3oool4000000H0oooo0`00000A0?ooo`80
0000_`3oool00440oooo00@000000?ooo`00000000001P3oool00`000000oooo0?ooo`0@0?ooo`<0
0000_`3oool00480oooo0`0000060?ooo`030000003oool0oooo0100oooo0P0000300?ooo`00@P3o
ool4000000D0oooo00<000000?ooo`3oool0403oool200000<00oooo00130?ooo`<000001@3oool2
00000140oooo0P0000300?ooo`00@`3oool3000000D0oooo00<000000?ooo`3oool03`3oool30000
0<00oooo00140?ooo`8000001@3oool00`000000oooo0?ooo`0?0?ooo`800000`@3oool004@0oooo
0P0000050?ooo`030000003oool0oooo00l0oooo0P0000310?ooo`00A03oool2000000D0oooo0P00
000@0?ooo`800000`@3oool004@0oooo0P0000050?ooo`030000003oool0oooo00h0oooo0`000031
0?ooo`00A03oool2000000D0oooo00<000000?ooo`3oool03P3oool200000<80oooo00140?ooo`80
00001@3oool00`000000oooo0?ooo`0>0?ooo`800000`P3oool004@0oooo0P0000050?ooo`800000
3`3oool200000<80oooo00140?ooo`8000001@3oool00`000000oooo0?ooo`0>0?ooo`800000`P3o
ool004D0oooo0P0000040?ooo`030000003oool0oooo00d0oooo0P0000330?ooo`00@P3oool50000
00@0oooo00<000000?ooo`3oool03@3oool200000<<0oooo00110?ooo`030000003oool0oooo00<0
0000103oool2000000h0oooo0P0000330?ooo`00@@3oool00`000000oooo0?ooo`03000000@0oooo
00<000000?ooo`3oool03@3oool200000<<0oooo00150?ooo`800000103oool00`000000oooo0?oo
o`0=0?ooo`800000``3oool004@0oooo0`0000040?ooo`<00000303oool200000<@0oooo00110?oo
o`030000003oool0oooo00<00000103oool00`000000oooo0?ooo`0<0?ooo`800000a03oool00440
oooo1P0000040?ooo`030000003oool0oooo00`0oooo0P0000340?ooo`00@@3oool010000000oooo
0?ooo`3oool2000000@0oooo00<000000?ooo`3oool0303oool200000<@0oooo00110?ooo`040000
003oool0oooo0?ooo`800000103oool2000000d0oooo0P0000340?ooo`00@@3oool3000000030?oo
o`000000000000@0oooo00<000000?ooo`3oool02`3oool200000<D0oooo00150?ooo`800000103o
ool00`000000oooo0?ooo`0;0?ooo`800000a@3oool004D0oooo0P0000040?ooo`030000003oool0
oooo00/0oooo0P0000350?ooo`00A@3oool2000000@0oooo0P00000<0?ooo`800000a@3oool004D0
oooo0P0000040?ooo`030000003oool0oooo00X0oooo0`0000350?ooo`00AP3oool2000000<0oooo
00<000000?ooo`3oool02P3oool200000<H0oooo00160?ooo`8000000`3oool00`000000oooo0?oo
o`090?ooo`<00000aP3oool004H0oooo0P0000030?ooo`8000002P3oool300000<H0oooo00160?oo
o`8000000`3oool00`000000oooo0?ooo`080?ooo`<00000a`3oool004H0oooo0P0000030?ooo`03
0000003oool0oooo00P0oooo00<000000?ooo`3oool0a`3oool00480oooo0`0000000`3oool00000
000000030?ooo`800000203oool200000<T0oooo00110?ooo`80000000<0oooo0000003oool00P00
00030?ooo`030000003oool0oooo00L0oooo0P0000390?ooo`00@@3oool00`000000oooo0?ooo`04
000000<0oooo00<000000?ooo`3oool01P3oool200000<X0oooo00110?ooo`040000003oool0oooo
0?ooo`<000000`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0<T0oooo00110?oo
o`030000003oool0oooo0080000000<0oooo0000000000000P3oool3000000D0oooo0P00003;0?oo
o`00@@3oool2000000040?ooo`000000oooo0?ooo`8000000P3oool00`000000oooo0?ooo`050?oo
o`800000b`3oool00440oooo00<000000?ooo`0000000`3oool200000080oooo00<000000?ooo`3o
ool01@3oool200000</0oooo00110?ooo`040000003oool0oooo00000080oooo0P0000020?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool0bP3oool00480oooo00<000000?ooo`000000
0P3oool200000080oooo0P0000050?ooo`800000c03oool00480oooo0`0000020?ooo`8000000P3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0</0oooo00170?ooo`8000000P3oool0
0`000000oooo0?ooo`030?ooo`800000c@3oool004L0oooo0P0000020?ooo`030000003oool0oooo
00<0oooo0P00003=0?ooo`00A`3oool200000080oooo0P0000040?ooo`800000c@3oool004L0oooo
0P0000020?ooo`030000003oool0oooo00<0oooo0P00003=0?ooo`00A`3oool200000080oooo00<0
00000?ooo`3oool00`3oool200000<d0oooo00170?ooo`8000000P3oool2000000@0oooo0P00003=
0?ooo`00A`3oool200000080oooo00<000000?ooo`3oool00P3oool200000<h0oooo00170?ooo`80
00000P3oool00`000000oooo0?ooo`020?ooo`800000cP3oool004L0oooo0P0000020?ooo`030000
003oool0oooo0080oooo0P00003>0?ooo`00A`3oool200000080oooo0P0000030?ooo`800000cP3o
ool004<0oooo00@000000?ooo`3oool0oooo0P0000020?ooo`030000003oool0oooo0080oooo0P00
003>0?ooo`00@`3oool010000000oooo0?ooo`3oool200000080oooo00<000000?ooo`3oool00P3o
ool200000<h0oooo00130?ooo`040000003oool0oooo0?ooo`8000000P3oool00`000000oooo0?oo
o`020?ooo`800000cP3oool004<0oooo00@000000?ooo`3oool0oooo0P0000020?ooo`<000000P3o
ool200000<h0oooo00140?ooo`030000003oool0oooo008000000P3oool010000000oooo0?ooo`3o
ool200000<l0oooo00140?ooo`030000003oool0oooo008000000P3oool010000000oooo0?ooo`3o
ool200000<l0oooo00110?ooo`060000003oool0oooo0?ooo`000000oooo0P0000020?ooo`040000
003oool0oooo0?ooo`800000c`3oool00440oooo00<000000?ooo`0000000P0000001@3oool00000
000000000000oooo008000000P3oool200000<l0oooo00110?ooo`8000000P3oool00`000000oooo
00000002000000030?ooo`000000oooo0080oooo0P00003?0?ooo`00B03oool2000000030?ooo`00
0000oooo0080oooo0P00003?0?ooo`00B03oool2000000030?ooo`00000000000080oooo0P00003?
0?ooo`00B03oool2000000030?ooo`000000oooo0080oooo0P00003?0?ooo`00B03oool200000003
0?ooo`000000oooo0080oooo0P00003?0?ooo`00B03oool2000000030?ooo`000000oooo0080oooo
0P00003?0?ooo`00B03oool2000000030?ooo`00000000000080oooo0P00003?0?ooo`00B03oool2
000000030?ooo`000000oooo0080oooo0P00003?0?ooo`00B03oool2000000030?ooo`000000oooo
0080oooo0P00003?0?ooo`00B03oool2000000030?ooo`000000oooo0080oooo0P00003?0?ooo`00
@P3oool3000000<0oooo0P000000103oool000000000003oool200000=00oooo00110?ooo`030000
003oool0oooo008000000P3oool2000000040?ooo`000000oooo0?ooo`800000d03oool00440oooo
00D000000?ooo`3oool0oooo000000020?ooo`80000000@0oooo0000003oool0oooo0P00003@0?oo
o`00@@3oool01@000000oooo0?ooo`3oool000000080oooo0P000000103oool000000?ooo`3oool2
00000=00oooo00110?ooo`030000003oool0oooo008000000P3oool2000000030?ooo`0000000000
00<00000d03oool00480oooo0`00003K0?ooo`00@@3oool2000000030?ooo`000000oooo0=X0oooo
00110?ooo`030000003oool0oooo00800000fP3oool00440oooo0P0000000`3oool000000?ooo`3J
0?ooo`00@P3oool300000=/0oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.63345, -1.00032, \
0.021592, 0.0532366}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Show[a, 
      b, \ \ \ AxesLabel\  \[Rule] \ {\[Theta], \ 
          None}]\[IndentingNewLine]\[IndentingNewLine]\), \
"\[IndentingNewLine]", 
    \(Plot[\ \ de[0.2, \ th, \ 
          mu]\ Gamma[
            k - 0.5]/\((\ \ \((th^2/2)\)^\((k - 0.5)\))\), \ \ {th, \ \(-5\), 
        5}, \ PlotRange \[Rule] \ {0, 10}]\)}], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.214286 0.190476 0 0.0772542 [
[.02381 -0.0125 -9.03125 -15.75 ]
[.02381 -0.0125 9.03125 0 ]
[.40476 -0.0125 -4.84375 -15.75 ]
[.40476 -0.0125 4.84375 0 ]
[.59524 -0.0125 -4.84375 -15.75 ]
[.59524 -0.0125 4.84375 0 ]
[.78571 -0.0125 -4.84375 -15.75 ]
[.78571 -0.0125 4.84375 0 ]
[.97619 -0.0125 -4.84375 -15.75 ]
[.97619 -0.0125 4.84375 0 ]
[1.025 0 0 -7.875 ]
[1.025 0 9.4375 7.875 ]
[.20179 .07725 -9.6875 -7.875 ]
[.20179 .07725 0 7.875 ]
[.20179 .15451 -9.6875 -7.875 ]
[.20179 .15451 0 7.875 ]
[.20179 .23176 -9.6875 -7.875 ]
[.20179 .23176 0 7.875 ]
[.20179 .30902 -9.6875 -7.875 ]
[.20179 .30902 0 7.875 ]
[.20179 .38627 -9.6875 -7.875 ]
[.20179 .38627 0 7.875 ]
[.20179 .46353 -9.6875 -7.875 ]
[.20179 .46353 0 7.875 ]
[.20179 .54078 -9.6875 -7.875 ]
[.20179 .54078 0 7.875 ]
[.20179 .61803 -9.6875 -7.875 ]
[.20179 .61803 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.40476 0 m
.40476 .00625 L
s
gsave
.40476 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.59524 0 m
.59524 .00625 L
s
gsave
.59524 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.78571 0 m
.78571 .00625 L
s
gsave
.78571 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
1.025 0 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.21429 .07725 m
.22054 .07725 L
s
gsave
.20179 .07725 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.21429 .15451 m
.22054 .15451 L
s
gsave
.20179 .15451 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.21429 .23176 m
.22054 .23176 L
s
gsave
.20179 .23176 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.21429 .30902 m
.22054 .30902 L
s
gsave
.20179 .30902 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.21429 .38627 m
.22054 .38627 L
s
gsave
.20179 .38627 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.21429 .46353 m
.22054 .46353 L
s
gsave
.20179 .46353 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.21429 .54078 m
.22054 .54078 L
s
gsave
.20179 .54078 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.21429 .61803 m
.22054 .61803 L
s
gsave
.20179 .61803 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.125 Mabswid
.21429 .01545 m
.21804 .01545 L
s
.21429 .0309 m
.21804 .0309 L
s
.21429 .04635 m
.21804 .04635 L
s
.21429 .0618 m
.21804 .0618 L
s
.21429 .09271 m
.21804 .09271 L
s
.21429 .10816 m
.21804 .10816 L
s
.21429 .12361 m
.21804 .12361 L
s
.21429 .13906 m
.21804 .13906 L
s
.21429 .16996 m
.21804 .16996 L
s
.21429 .18541 m
.21804 .18541 L
s
.21429 .20086 m
.21804 .20086 L
s
.21429 .21631 m
.21804 .21631 L
s
.21429 .24721 m
.21804 .24721 L
s
.21429 .26266 m
.21804 .26266 L
s
.21429 .27812 m
.21804 .27812 L
s
.21429 .29357 m
.21804 .29357 L
s
.21429 .32447 m
.21804 .32447 L
s
.21429 .33992 m
.21804 .33992 L
s
.21429 .35537 m
.21804 .35537 L
s
.21429 .37082 m
.21804 .37082 L
s
.21429 .40172 m
.21804 .40172 L
s
.21429 .41717 m
.21804 .41717 L
s
.21429 .43262 m
.21804 .43262 L
s
.21429 .44807 m
.21804 .44807 L
s
.21429 .47898 m
.21804 .47898 L
s
.21429 .49443 m
.21804 .49443 L
s
.21429 .50988 m
.21804 .50988 L
s
.21429 .52533 m
.21804 .52533 L
s
.21429 .55623 m
.21804 .55623 L
s
.21429 .57168 m
.21804 .57168 L
s
.21429 .58713 m
.21804 .58713 L
s
.21429 .60258 m
.21804 .60258 L
s
.25 Mabswid
.21429 0 m
.21429 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .00686 m
.04262 .00831 L
.06244 .01024 L
.08255 .01277 L
.10458 .01648 L
.12415 .02102 L
.13511 .02433 L
.14509 .02802 L
.15438 .03227 L
.16424 .03798 L
.16938 .04166 L
.17504 .04648 L
.18502 .05796 L
.19021 .06642 L
.19515 .07729 L
.19959 .09113 L
.2021 .10196 L
.20443 .11535 L
.20574 .12509 L
.20716 .13841 L
.2085 .15512 L
.20973 .17644 L
.21084 .20466 L
.21206 .25716 L
.21334 .3981 L
s
.21334 .3981 m
.21402 .61803 L
s
.21483 .61803 m
.2152 .40987 L
.21593 .30765 L
.21662 .25967 L
.21725 .23126 L
.21845 .19684 L
.21973 .17386 L
.22039 .16503 L
.2211 .15703 L
.22238 .14543 L
.22391 .13492 L
.22531 .12739 L
.22779 .11722 L
.23005 .11034 L
.23265 .10421 L
.23511 .09967 L
.23949 .09359 L
.24423 .08894 L
.24946 .08531 L
.2521 .08391 L
.255 .08262 L
.25747 .08171 L
.26013 .08089 L
.26493 .07975 L
.26748 .0793 L
.27019 .07893 L
.27274 .07866 L
.27506 .07849 L
.27649 .07841 L
.2778 .07835 L
.27848 .07833 L
.27923 .07831 L
.28002 .0783 L
.28075 .07829 L
.28145 .07829 L
.2821 .07829 L
.28334 .0783 L
.28403 .07831 L
.28466 .07833 L
.2861 .07837 L
.28726 .07842 L
.2885 .07848 L
.29074 .07862 L
.29586 .07906 L
.30126 .0797 L
.30621 .08042 L
.32517 .08429 L
.34588 .09024 L
.3865 .10665 L
.42559 .1287 L
Mistroke
.44554 .14267 L
.46714 .16017 L
.47727 .16932 L
.48799 .17972 L
.4924 .18422 L
.49713 .18921 L
.49853 .19071 L
.49985 .19214 L
.50103 .1905 L
.50233 .18825 L
.50718 .18008 L
.52654 .15106 L
.54793 .12468 L
.58716 .08813 L
.60648 .07445 L
.62733 .06214 L
.64696 .05248 L
.66844 .04368 L
.70803 .03122 L
.74856 .02221 L
.78757 .01605 L
.82904 .01139 L
.86899 .00821 L
.90742 .006 L
.94831 .0043 L
.97619 .00343 L
Mfstroke
.02381 .03746 m
.04262 .04538 L
.06244 .0559 L
.08255 .06968 L
.10458 .08992 L
.12415 .11472 L
.13511 .13278 L
.14509 .15295 L
.15438 .17613 L
.16424 .20731 L
.16938 .22738 L
.17504 .25368 L
.18502 .31633 L
.19021 .36253 L
.19515 .42184 L
.19959 .49738 L
.2021 .55647 L
s
.2021 .55647 m
.20406 .61803 L
s
.2291 .61803 m
.23005 .60221 L
.23265 .56877 L
.23511 .54398 L
.23949 .51082 L
.24423 .48541 L
.24946 .4656 L
.2521 .45795 L
.255 .45094 L
.25747 .44595 L
.26013 .44146 L
.26493 .43526 L
.26748 .43282 L
.26887 .4317 L
.27019 .43078 L
.27142 .43002 L
.27211 .42533 L
.27274 .42101 L
.27506 .40587 L
.2861 .34397 L
.30621 .26189 L
.32507 .20738 L
.34575 .16328 L
.36529 .13176 L
.38622 .10571 L
.4075 .08515 L
.42764 .06978 L
.46602 .04831 L
.48583 .04015 L
.50685 .03309 L
.54466 .02352 L
.56404 .0198 L
.58491 .01647 L
.6046 .01387 L
.6261 .01151 L
.66578 .00819 L
.68543 .00693 L
.70639 .0058 L
.74794 .00409 L
.78798 .00293 L
.82649 .00213 L
.86747 .00152 L
.90692 .0011 L
.94486 .00081 L
.97619 .00063 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{44, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00603oool2000005L0oooo0P00
000]0?ooo`800000:`3oool3000002d0oooo0P00000Q0?ooo`006@3oool00`000000oooo0?ooo`1F
0?ooo`030000003oool0oooo02T0oooo0`0000000`3oool000000?ooo`0X0?ooo`030000003oool0
oooo00800000;03oool200000240oooo000I0?ooo`030000003oool0oooo05H0oooo00<000000?oo
o`3oool0:@3oool00`000000oooo0?ooo`0[0?ooo`050000003oool0oooo0?ooo`000000;03oool2
00000240oooo000I0?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0:@3oool00`00
0000oooo0?ooo`0_0?ooo`030000003oool0oooo02P0oooo1000000Q0?ooo`003`3oool7000000<0
oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0Z0?ooo`800000;P3oool00`000000
oooo0?ooo`0Y0?ooo`040000003oool0000000000240oooo000I0?ooo`030000003oool0oooo05H0
oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0Z0?ooo`800000;03oool300000240
oooo000I0?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0;03oool2000002`0oooo
00<000000?ooo`3oool0:P3oool300000240oooo000I0?ooo`030000003oool0oooo05H0oooo00<0
00000?ooo`3oool0:@3oool01@000000oooo0?ooo`3oool0000002T0oooo00<000000?ooo`3oool0
0P00000/0?ooo`8000008@3oool001P0oooo0P00001G0?ooo`800000:`3oool00`000000oooo0?oo
o`02000002T0oooo00@000000?ooo`3oool00000;@3oool200000240oooo000I0?ooo`030000003o
ool0oooo05H0oooo00<000000?ooo`3oool0:P3oool3000002/0oooo0`00000^0?ooo`030000003o
ool0oooo01l0oooo003o0?ooob40oooo003o0?ooo`d0oooo0P00000B0?ooo`00o`3oool<0?ooo`04
0000003oool0oooo00000140oooo003o0?ooo``0oooo00@000000?ooo`3oool000004@3oool000l0
oooom00000080?ooo`050000003oool0oooo0?ooo`000000403oool001D0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00D0oooo@`00000=0?ooo`D0
0000403oool001@0oooo2P00000U0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0
:`3oool00`000000oooo0?ooo`050?oooeH000003P3oool010000000oooo0?ooo`00000@0?ooo`00
503ooolE000001X0oooo00<000000?ooo`3oool0G03ooolI000001@0oooo7@00000P0?ooo`040000
003oool0oooo00000100oooo000N0?ooo`l000005P3oool2000005<0oooo4000000R0?ooo`l00000
=03oool300000100oooo000Y0?ooo`P000004P3oool00`000000oooo0?ooo`1>0?ooo`h000008`3o
ool:00000540oooo000]0?ooo`L000003`3oool00`000000oooo0?ooo`1:0?ooo`P00000:03oool:
000005H0oooo000`0?ooo`H000003@3oool00`000000oooo0?ooo`150?ooo`T000009`3oool:0000
05/0oooo000E0?ooo`030000003oool0oooo01/0oooo1000000<0?ooo`800000@`3oool8000002P0
oooo2000001P0?ooo`00503oool4000001d0oooo0`00000;0?ooo`030000003oool0oooo03l0oooo
1`00000Y0?ooo`L00000I03oool001D0oooo1P00000K0?ooo`@000002@3oool00`000000oooo0?oo
o`0m0?ooo`H00000:@3oool7000006L0oooo000G0?ooo`D000006`3oool4000000P0oooo00<00000
0?ooo`3oool0>`3oool5000002T0oooo1`00001Z0?ooo`006P3oool4000001/0oooo0`0000070?oo
o`800000>P3oool5000002T0oooo1P00001]0?ooo`006`3oool4000001/0oooo0`0000060?ooo`03
0000003oool0oooo03L0oooo1@00000X0?ooo`H00000L03oool001d0oooo1000000J0?ooo`800000
1P3oool00`000000oooo0?ooo`0e0?ooo`D00000:03oool600000780oooo000N0?ooo`@000006@3o
ool3000000D0oooo0P00000d0?ooo`D00000:03oool5000007D0oooo000P0?ooo`@00000603oool3
000000@0oooo00<000000?ooo`3oool0<@3oool5000002T0oooo1000001g0?ooo`008@3oool40000
01L0oooo00<000000?ooo`000000103oool00`000000oooo0?ooo`0`0?ooo`@00000:@3oool40000
07T0oooo000S0?ooo`<000005P3oool010000000oooo0000000000030?ooo`030000003oool0oooo
02h0oooo1000000Z0?ooo`@00000NP3oool002@0oooo1000000D0?ooo`040000003oool0oooo0000
00<0oooo0`00000;0?ooo`L000006`3oool4000002T0oooo1000001l0?ooo`009@3oool4000001<0
oooo00<000000?ooo`3oool00P0000020?ooo`030000003oool0oooo00H0oooo4P00000D0?ooo`<0
0000:P3oool4000007d0oooo000W0?ooo`<000004P3oool00`000000oooo0?ooo`0200000080oooo
00<000000?ooo`3oool01@3oool7000000D0oooo3000000>0?ooo`<00000:P3oool3000007l0oooo
000X0?ooo`8000004P3oool00`000000oooo0?ooo`0200000080oooo00<000000?ooo`3oool0103o
ool400000100oooo2000000:0?ooo`<00000:P3oool300000800oooo000Y0?ooo`800000403oool2
00000080oooo0P0000020?ooo`800000103oool3000001L0oooo1P0000060?ooo`<00000:P3oool3
00000840oooo000Z0?ooo`800000403oool00`000000oooo0?ooo`0200000080oooo00<000000?oo
o`3oool00P3oool3000001X0oooo1P0000030?ooo`<00000:P3oool300000880oooo000[0?ooo`03
0000003oool0oooo0140oooo0`0000000`3oool000000?ooo`020?ooo`<000007P3oool8000002X0
oooo0`0000230?ooo`00:`3oool2000001<0oooo0P0000000`3oool000000?ooo`020?ooo`800000
8@3oool6000002T0oooo0`0000240?ooo`00;03oool200000180oooo0P000000103oool000000000
003oool300000280oooo1P00000W0?ooo`<00000Q@3oool002d0oooo00<000000?ooo`3oool0403o
ool2000000040?ooo`000000oooo0?ooo`8000008P3oool300000080oooo1000000T0?ooo`<00000
QP3oool002d0oooo0P00000A0?ooo`80000000@0oooo0000003oool0oooo0P00000R0?ooo`800000
103oool500000240oooo0`0000270?ooo`00;P3oool00`000000oooo0?ooo`0?0?ooo`80000000@0
oooo000000000000oooo0P00000Q0?ooo`8000001`3oool4000001l0oooo0`0000280?ooo`00;P3o
ool200000100oooo100000020?ooo`030000003oool0oooo01l0oooo0`0000090?ooo`@00000703o
ool3000008T0oooo000_0?ooo`800000403oool3000000030?ooo`00000000000240oooo0P00000;
0?ooo`D000006@3oool3000008X0oooo000`0?ooo`030000003oool0oooo00h0oooo0`0000000`3o
ool000000000000P0?ooo`8000003P3oool4000001L0oooo0`00002;0?ooo`00<03oool2000000X0
oooo0P0000030?ooo`H000007`3oool200000140oooo1000000D0?ooo`<00000S03oool00340oooo
00<000000?ooo`3oool01P3oool3000000040?ooo`000000oooo0?ooo`<0000000<0oooo00000000
00007`3oool00`000000oooo0?ooo`0A0?ooo`@000004P3oool3000008d0oooo000a0?ooo`800000
1`3oool00`000000oooo0?ooo`040?ooo`H000007P3oool2000001D0oooo0`00000@0?ooo`<00000
SP3oool00380oooo0P0000060?ooo`030000003oool0oooo00@0oooo1@00000O0?ooo`030000003o
ool0oooo01D0oooo1000000>0?ooo`800000S`3oool003<0oooo00<000000?ooo`3oool01@3oool2
000000@0oooo1@00000N0?ooo`800000603oool4000000`0oooo0P00002@0?ooo`00<`3oool20000
00P0oooo00@000000?ooo`3oool0oooo1@00000M0?ooo`8000006`3oool2000000`0oooo00<00000
0?ooo`3oool0S`3oool003<0oooo0P0000080?ooo`8000000P3oool5000001d0oooo00<000000?oo
o`3oool06`3oool2000000X0oooo0P00002A0?ooo`00<`3oool3000000@0oooo00D000000?ooo`3o
ool0oooo000000020?ooo`D00000703oool2000001h0oooo0P0000080?ooo`800000TP3oool003@0
oooo0P0000040?ooo`030000003oool0oooo008000000P3oool5000001`0oooo00<000000?ooo`3o
ool07P3oool2000000L0oooo00<000000?ooo`3oool0T@3oool003@0oooo0`0000040?ooo`<00000
0`3oool5000001/0oooo0P00000P0?ooo`@00000103oool2000009<0oooo000e0?ooo`8000002`3o
ool4000001/0oooo00<000000?ooo`3oool0803oool400000080oooo0P00002D0?ooo`00=@3oool2
000000/0oooo1000000J0?ooo`800000903oool6000009@0oooo000e0?ooo`8000002`3oool40000
01X0oooo00<000000?ooo`3oool0903oool4000009D0oooo000e0?ooo`<000002P3oool4000001X0
oooo00<000000?ooo`3oool09@3oool2000009H0oooo000f0?ooo`8000002P3oool3000001X0oooo
0P00000X0?ooo`030000003oool0oooo09@0oooo000f0?ooo`8000002P3oool3000001X0oooo00<0
00000?ooo`3oool0_P3oool003H0oooo0P00000:0?ooo`<000006@3oool200000<00oooo000f0?oo
o`8000002P3oool3000001T0oooo00<000000?ooo`3oool0_`3oool003L0oooo0P0000090?ooo`<0
0000603oool200000<40oooo000g0?ooo`8000000P3oool3000000@0oooo0`00000H0?ooo`800000
`@3oool003L0oooo0P000000103oool000000?ooo`3oool2000000<0oooo0`00000G0?ooo`<00000
`@3oool003L0oooo0P0000000`3oool000000?ooo`020?ooo`040000003oool0oooo0?ooo`<00000
5`3oool200000<80oooo000g0?ooo`<00000103oool010000000oooo0?ooo`3oool3000001L0oooo
0P0000320?ooo`00>03oool2000000<0oooo00<000000?ooo`3oool00P3oool4000001D0oooo0`00
00320?ooo`00>03oool200000080oooo0P0000040?ooo`<000005P3oool200000<<0oooo000h0?oo
o`<000000P3oool00`000000oooo0?ooo`020?ooo`<000005P3oool200000<<0oooo000i0?ooo`80
00000P3oool2000000<0oooo0`00000F0?ooo`800000``3oool003T0oooo0P0000020?ooo`030000
003oool0oooo0080oooo0`00000E0?ooo`<00000``3oool003T0oooo1@0000040?ooo`<000005@3o
ool200000<@0oooo000j0?ooo`8000001P3oool3000001D0oooo0P0000340?ooo`00>P3oool20000
00H0oooo0`00000D0?ooo`<00000a03oool003X0oooo0P0000060?ooo`<00000503oool200000<D0
oooo000j0?ooo`8000001P3oool3000001@0oooo0P0000350?ooo`00>P3oool2000000H0oooo0`00
000D0?ooo`800000a@3oool003X0oooo0P0000060?ooo`<000004`3oool300000<D0oooo000j0?oo
o`8000001P3oool3000001<0oooo0P0000360?ooo`00>`3oool2000000D0oooo0`00000C0?ooo`80
0000aP3oool003/0oooo0P0000050?ooo`<000004`3oool200000<H0oooo000k0?ooo`<00000103o
ool300000180oooo0`0000360?ooo`00>`3oool3000000@0oooo0`00000B0?ooo`800000a`3oool0
03/0oooo0`0000040?ooo`<000004P3oool200000<L0oooo000j0?ooo`@00000103oool400000140
oooo0P0000370?ooo`00>P3oool4000000@0oooo0`00000A0?ooo`<00000a`3oool003/0oooo0`00
00040?ooo`<000004@3oool200000<P0oooo000k0?ooo`<00000103oool300000140oooo0P000038
0?ooo`00?03oool2000000@0oooo0`00000A0?ooo`800000b03oool003`0oooo0P0000040?ooo`<0
0000403oool300000<P0oooo000l0?ooo`800000103oool300000100oooo0P0000390?ooo`00?03o
ool2000000@0oooo0`00000@0?ooo`800000b@3oool003d0oooo0P0000030?ooo`<00000403oool2
00000<T0oooo000m0?ooo`8000000`3oool3000000l0oooo0`0000390?ooo`00?@3oool2000000<0
oooo0`00000?0?ooo`800000bP3oool003d0oooo0P0000030?ooo`<000003`3oool200000<X0oooo
000m0?ooo`8000000`3oool3000000l0oooo0P00003:0?ooo`00?@3oool2000000<0oooo0`00000?
0?ooo`800000bP3oool003h0oooo0P0000020?ooo`<000003P3oool200000</0oooo000k0?ooo`D0
00000P3oool3000000h0oooo0P00003;0?ooo`00>P3oool00`000000oooo0?ooo`0300000080oooo
0`00000>0?ooo`800000b`3oool003X0oooo00<000000?ooo`3oool00`0000020?ooo`<000003P3o
ool200000</0oooo000n0?ooo`8000000P3oool3000000h0oooo0P00003;0?ooo`00?@3oool30000
0080oooo1000000<0?ooo`800000c03oool003X0oooo00<000000?ooo`3oool00`0000020?ooo`<0
00003@3oool200000<`0oooo000j0?ooo`H000000P3oool3000000d0oooo0P00003<0?ooo`00>P3o
ool010000000oooo0?ooo`3oool200000080oooo0`00000=0?ooo`800000c03oool003X0oooo00@0
00000?ooo`3oool0oooo0P0000020?ooo`<000003@3oool200000<`0oooo000j0?ooo`<0000000<0
oooo0000000000000P3oool3000000`0oooo0P00003=0?ooo`00?P3oool200000080oooo0`00000<
0?ooo`800000c@3oool003h0oooo0P0000020?ooo`<00000303oool200000<d0oooo000n0?ooo`80
00000P3oool3000000`0oooo0P00003=0?ooo`00?P3oool200000080oooo0`00000<0?ooo`800000
c@3oool003l0oooo0P000000103oool0000000000000000;0?ooo`<00000c@3oool003l0oooo0P00
0000103oool0000000000000000;0?ooo`800000cP3oool003l0oooo0P000000103oool000000000
0000000;0?ooo`800000cP3oool003l0oooo0P000000103oool0000000000000000:0?ooo`800000
c`3oool003l0oooo0P000000103oool000000000000000090?ooo`800000d03oool003/0oooo0`00
0000103oool000000000003oool3000000P0oooo0`00003@0?ooo`00>P3oool2000000030?ooo`00
0000oooo0080000000@0oooo00000000000000001`3oool300000=40oooo000j0?ooo`030000003o
ool0oooo00@0000000@0oooo00000000000000001`3oool200000=80oooo000j0?ooo`040000003o
ool0oooo0?ooo`<0000000@0oooo00000000000000001`3oool200000=80oooo000j0?ooo`030000
003oool0oooo00@0000000<0oooo0000000000000P0000060?ooo`800000dP3oool003X0oooo0P00
00000`3oool000000?ooo`02000000040?ooo`0000000000000000L0oooo00<000000?ooo`3oool0
d@3oool003X0oooo00<000000?ooo`0000000P3oool2000000040?ooo`0000000000000000H0oooo
0P00003C0?ooo`00>P3oool01@000000oooo0?ooo`000000oooo0080000000@0oooo000000000000
00001P3oool200000=<0oooo000k0?ooo`040000003oool000000?ooo`80000000@0oooo00000000
000000001P3oool200000=<0oooo000k0?ooo`<0000000@0oooo000000000000oooo0`0000050?oo
o`<00000d`3oool003l0oooo0P000000103oool000000000000000050?ooo`800000e03oool003l0
oooo0P000000103oool000000000000000050?ooo`800000e03oool003l0oooo0P000000103oool0
00000000000000050?ooo`800000e03oool003l0oooo0P000000103oool000000000000000050?oo
o`800000e03oool003l0oooo0P000000103oool000000000000000050?ooo`800000e03oool003l0
oooo0P000000103oool000000000000000050?ooo`800000e03oool003l0oooo0P000000103oool0
00000000000000040?ooo`800000e@3oool003l0oooo0P000000103oool000000000000000040?oo
o`800000e@3oool003l0oooo0P000000103oool000000000000000040?ooo`800000e@3oool003l0
oooo0P000000103oool000000000000000040?ooo`800000e@3oool003`0oooo00<000000?ooo`3o
ool00P000000103oool000000000000000030?ooo`<00000e@3oool003`0oooo00<000000?ooo`3o
ool00P000000103oool000000000000000030?ooo`800000eP3oool003`0oooo00<000000?ooo`3o
ool00P000000103oool000000000000000030?ooo`800000eP3oool003`0oooo00<000000?ooo`3o
ool00P0000000`3oool000000000000200000080oooo0P00003F0?ooo`00?@3oool01@000000oooo
000000000000oooo00<000000P3oool300000=H0oooo000m0?ooo`050000003oool000000000003o
ool00`0000020?ooo`800000e`3oool003X0oooo00@000000?ooo`3oool0oooo0`000000103oool0
00000000000000020?ooo`800000e`3oool003X0oooo00<000000?ooo`000000200000020?ooo`80
0000e`3oool003X0oooo0P0000020?ooo`L000000P3oool200000=L0oooo00100?ooo`D000000P3o
ool200000=L0oooo00100?ooo`D000000P3oool200000=L0oooo00100?ooo`D000000P3oool20000
0=L0oooo00100?ooo`D000000P3oool200000=L0oooo00100?ooo`D000000P3oool200000=L0oooo
00100?ooo`D000000P3oool200000=L0oooo00100?ooo`D000000P3oool200000=L0oooo00100?oo
o`D000000P3oool200000=L0oooo00100?ooo`D000000P3oool200000=L0oooo000k0?ooo`<00000
0P3oool5000000030?ooo`00000000000=P0oooo000j0?ooo`030000003oool0oooo0080000000<0
oooo0000000000000`0000000`3oool000000000003H0?ooo`00>P3oool01P000000oooo0?ooo`3o
ool000000?ooo`D0000000<0oooo000000000000f03oool003X0oooo00H000000?ooo`3oool0oooo
0000003oool5000000030?ooo`00000000000=P0oooo000j0?ooo`030000003oool0oooo00800000
00<0oooo0000000000001P00003H0?ooo`00>`3oool300000>80oooo000j0?ooo`80000000<0oooo
0000003oool0h@3oool003X0oooo00<000000?ooo`3oool00P00003Q0?ooo`00>P3oool200000003
0?ooo`000000oooo0>40oooo000k0?ooo`<00000hP3oool00?l0oooo8@3oool00?l0oooo8@3oool0
0001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-1.46594, -1.00032, \
0.021592, 0.0532366}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.0952381 0 0.0618034 [
[.11905 -0.0125 -6 -9 ]
[.11905 -0.0125 6 0 ]
[.30952 -0.0125 -6 -9 ]
[.30952 -0.0125 6 0 ]
[.69048 -0.0125 -3 -9 ]
[.69048 -0.0125 3 0 ]
[.88095 -0.0125 -3 -9 ]
[.88095 -0.0125 3 0 ]
[.4875 .12361 -6 -4.5 ]
[.4875 .12361 0 4.5 ]
[.4875 .24721 -6 -4.5 ]
[.4875 .24721 0 4.5 ]
[.4875 .37082 -6 -4.5 ]
[.4875 .37082 0 4.5 ]
[.4875 .49443 -6 -4.5 ]
[.4875 .49443 0 4.5 ]
[.4875 .61803 -12 -4.5 ]
[.4875 .61803 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11905 0 m
.11905 .00625 L
s
[(-4)] .11905 -0.0125 0 1 Mshowa
.30952 0 m
.30952 .00625 L
s
[(-2)] .30952 -0.0125 0 1 Mshowa
.69048 0 m
.69048 .00625 L
s
[(2)] .69048 -0.0125 0 1 Mshowa
.88095 0 m
.88095 .00625 L
s
[(4)] .88095 -0.0125 0 1 Mshowa
.125 Mabswid
.16667 0 m
.16667 .00375 L
s
.21429 0 m
.21429 .00375 L
s
.2619 0 m
.2619 .00375 L
s
.35714 0 m
.35714 .00375 L
s
.40476 0 m
.40476 .00375 L
s
.45238 0 m
.45238 .00375 L
s
.54762 0 m
.54762 .00375 L
s
.59524 0 m
.59524 .00375 L
s
.64286 0 m
.64286 .00375 L
s
.7381 0 m
.7381 .00375 L
s
.78571 0 m
.78571 .00375 L
s
.83333 0 m
.83333 .00375 L
s
.07143 0 m
.07143 .00375 L
s
.02381 0 m
.02381 .00375 L
s
.92857 0 m
.92857 .00375 L
s
.97619 0 m
.97619 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
.5 .12361 m
.50625 .12361 L
s
[(2)] .4875 .12361 1 0 Mshowa
.5 .24721 m
.50625 .24721 L
s
[(4)] .4875 .24721 1 0 Mshowa
.5 .37082 m
.50625 .37082 L
s
[(6)] .4875 .37082 1 0 Mshowa
.5 .49443 m
.50625 .49443 L
s
[(8)] .4875 .49443 1 0 Mshowa
.5 .61803 m
.50625 .61803 L
s
[(10)] .4875 .61803 1 0 Mshowa
.125 Mabswid
.5 .0309 m
.50375 .0309 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .15451 m
.50375 .15451 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .30902 m
.50375 .30902 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .46353 m
.50375 .46353 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .58713 m
.50375 .58713 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 5e-005 m
.04262 7e-005 L
.06244 .0001 L
.08255 .00014 L
.10458 .0002 L
.12415 .00027 L
.14509 .00038 L
.16639 .00054 L
.18653 .00074 L
.20651 .00104 L
.22495 .00141 L
.24367 .00192 L
.2643 .00273 L
.28371 .0038 L
.29461 .00458 L
.30459 .00545 L
.32357 .0076 L
.33432 .0092 L
.3443 .011 L
.35486 .01333 L
.36482 .01601 L
.38342 .02273 L
.39319 .02745 L
.4035 .03366 L
.42198 .04925 L
.43145 .06049 L
.44161 .07621 L
.4512 .09612 L
.45995 .12081 L
.46475 .13831 L
.46986 .16135 L
.47422 .18613 L
.47903 .22167 L
.48419 .27554 L
.48708 .31829 L
.48974 .37151 L
.49208 .43775 L
.4934 .48925 L
.49464 .55261 L
s
.49464 .55261 m
.49553 .61803 L
s
.50603 .61803 m
.50687 .58546 L
.50803 .55105 L
.50926 .52259 L
.51061 .49804 L
.51207 .47716 L
.51472 .44944 L
.51967 .41082 L
.52452 .34241 L
.52971 .28798 L
.5354 .24242 L
.54071 .20892 L
.55117 .15955 L
.56069 .12719 L
.57152 .09976 L
.58177 .08013 L
.59145 .06562 L
.60172 .05342 L
.62015 .03738 L
.62954 .03131 L
.63966 .02595 L
.65795 .0186 L
.66755 .01566 L
.67803 .013 L
.6891 .0107 L
.69914 .00899 L
.71879 .0064 L
.72958 .00533 L
.73976 .00448 L
.75981 .0032 L
.77828 .00235 L
.79708 .00172 L
.81773 .00122 L
.83722 .00089 L
.85812 .00063 L
.87934 .00045 L
.89945 .00032 L
.91934 .00024 L
.93775 .00018 L
.95601 .00013 L
.97619 9e-005 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00;`3oool3000002d0oooo1000001K0?ooo`@00000<03oool3000002/0oooo000`0?ooo`03
0000003oool0oooo02`0oooo00<000000?ooo`3oool0G03oool00`000000oooo0?ooo`0b0?ooo`03
0000003oool0oooo02X0oooo000]0?ooo`D00000;P3oool00`000000oooo0?ooo`1L0?ooo`030000
003oool0oooo02h0oooo1@00000[0?ooo`009`3oool400000080oooo00@000000?ooo`3oool00000
:03oool4000000@0oooo00<000000?ooo`3oool0G03oool00`000000oooo0?ooo`0]0?ooo`040000
003oool0oooo000002`0oooo000^0?ooo`030000003oool0000002h0oooo00@000000?ooo`3oool0
0000F`3oool010000000oooo0?ooo`00000_0?ooo`030000003oool0000002`0oooo000_0?ooo`80
0000;`3oool2000005d0oooo0P00000a0?ooo`800000;03oool00?l0oooo8@3oool00?l0oooo8@3o
ool00?l0oooo8@3oool00?l0oooo8@3oool00?l0oooo8@3oool000d0ooooo`000006000000h0oooo
000D0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool?000000/0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`030?ooo`l00000103oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo01<0oooo001O0?ooo`L00000:@3oool00`000000oooo0?ooo`0`
0?ooo`@00000FP3oool006H0oooo1@00000T0?ooo`030000003oool0oooo02X0oooo1P00001N0?oo
o`00J`3oool300000240oooo00<000000?ooo`3oool0:03oool2000006@0oooo001^0?ooo`800000
7`3oool00`000000oooo0?ooo`0U0?ooo`<00000IP3oool00700oooo0P00000M0?ooo`030000003o
ool0oooo02<0oooo0P00001Y0?ooo`00LP3oool2000001/0oooo00<000000?ooo`3oool08@3oool2
000006/0oooo001d0?ooo`8000006@3oool2000001l0oooo0`00001]0?ooo`00MP3oool00`000000
oooo0?ooo`0F0?ooo`030000003oool0oooo01`0oooo0P00001`0?ooo`00M`3oool00`000000oooo
0?ooo`0E0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0L03oool007P0oooo0P00
000E0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0L@3oool007X0oooo00<00000
0?ooo`3oool04P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo0780oooo001k0?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool0603oool00`000000oooo0?ooo`1c0?oo
o`00O03oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3o
ool0M03oool007d0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0F0?ooo`030000
003oool0oooo07D0oooo001n0?ooo`030000003oool0oooo00h0oooo0P00000G0?ooo`030000003o
ool0oooo07D0oooo001n0?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool05@3oool0
0`000000oooo0?ooo`1f0?ooo`00O`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
01@0oooo00<000000?ooo`3oool0M`3oool007l0oooo00<000000?ooo`3oool03@3oool00`000000
oooo0?ooo`0C0?ooo`030000003oool0oooo07P0oooo00200?ooo`030000003oool0oooo00`0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`1h0?ooo`00P03oool00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool0N@3oool00840oooo00<00000
0?ooo`3oool02`3oool00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo07T0oooo00210?oo
o`030000003oool0oooo00/0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`1j0?oo
o`00PP3oool00`000000oooo0?ooo`0:0?ooo`8000004P3oool00`000000oooo0?ooo`1j0?ooo`00
PP3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
N`3oool00880oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0@0?ooo`030000003o
ool0oooo07/0oooo00230?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`1k0?ooo`00P`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
00l0oooo00<000000?ooo`3oool0O03oool008@0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo07`0oooo00240?ooo`030000003oool0oooo00@00000
103oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo07d0oooo00250?ooo`030000003o
ool0000000L0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`1m0?ooo`00Q@3oool0
10000000oooo0?ooo`0000060?ooo`<000003@3oool00`000000oooo0?ooo`1n0?ooo`00Q@3oool0
1@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?oo
o`1n0?ooo`00QP3oool200000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo07h0oooo00260?ooo`040000003oool00000000000D0oooo00<00000
0?ooo`3oool0303oool00`000000oooo0?ooo`1o0?ooo`00QP3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00`0oooo00<000000?ooo`3oool0O`3oool008H0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0800oooo00260?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`200?ooo`00QP3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00/0oooo00<000000?ooo`3oool0P03o
ool008L0oooo00<000000?ooo`3oool01@3oool2000000/0oooo00<000000?ooo`3oool0P@3oool0
08L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
0840oooo00270?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`210?ooo`00Q`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0P@3oool008L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo0840oooo00270?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`220?ooo`00R03oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool0PP3oool008P0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0880oooo00280?ooo`030000
003oool0oooo00@0oooo0P00000:0?ooo`030000003oool0oooo0880oooo00280?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`220?ooo`00R03oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0PP3oool0
08T0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
08<0oooo00290?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`230?ooo`00R@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool0P`3oool008T0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo08<0oooo002:0?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`230?ooo`00RP3oool00`000000oooo0?ooo`020?oo
o`8000002@3oool00`000000oooo0?ooo`230?ooo`00RP3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool0Q03oool008X0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo08@0oooo002:0?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`240?ooo`00RP3oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0Q03oool0
08X0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
08D0oooo00290?ooo`<000000`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo08D0
oooo002:0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`250?ooo`00Q`3oool5000000<0oooo0`0000060?ooo`030000003oool0oooo08D0oooo0027
0?ooo`030000003oool0oooo008000000`3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo08D0oooo00280?ooo`040000003oool00000000000<0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`250?ooo`00R@3oool3000000<0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`250?ooo`00R`3oool01@000000oooo0?ooo`3oool0000000P0oooo00<000000?oo
o`3oool0Q@3oool008/0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000003oool0oooo
08H0oooo002;0?ooo`050000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`260?oo
o`00R`3oool01@000000oooo0?ooo`3oool0000000L0oooo00<000000?ooo`3oool0QP3oool008/0
oooo00@000000?ooo`3oool0oooo0P0000060?ooo`030000003oool0oooo08H0oooo002;0?ooo`05
0000003oool0oooo0?ooo`0000001`3oool00`000000oooo0?ooo`260?ooo`00R`3oool01@000000
oooo0?ooo`3oool0000000L0oooo00<000000?ooo`3oool0QP3oool008/0oooo00D000000?ooo`3o
ool0oooo000000070?ooo`030000003oool0oooo08H0oooo002;0?ooo`050000003oool0oooo0?oo
o`0000001`3oool00`000000oooo0?ooo`260?ooo`00S03oool010000000oooo0?ooo`0000070?oo
o`030000003oool0oooo08H0oooo002<0?ooo`040000003oool0oooo000000H0oooo00<000000?oo
o`3oool0Q`3oool008`0oooo00@000000?ooo`3oool000001P3oool00`000000oooo0?ooo`270?oo
o`00S03oool00`000000oooo0?ooo`02000000D0oooo00<000000?ooo`3oool0Q`3oool008`0oooo
00@000000?ooo`3oool000001P3oool00`000000oooo0?ooo`270?ooo`00S03oool010000000oooo
0?ooo`0000060?ooo`030000003oool0oooo08L0oooo002<0?ooo`040000003oool0oooo000000H0
oooo00<000000?ooo`3oool0Q`3oool008`0oooo00@000000?ooo`3oool000001P3oool00`000000
oooo0?ooo`270?ooo`00S03oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo08L0
oooo002<0?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0R03oool008`0oooo
00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`280?ooo`00S03oool00`000000oooo
0?ooo`02000000@0oooo00<000000?ooo`3oool0R03oool008`0oooo00@000000?ooo`3oool00000
1@3oool00`000000oooo0?ooo`280?ooo`00S03oool010000000oooo0?ooo`0000050?ooo`030000
003oool0oooo08P0oooo002<0?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0
R03oool008`0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`280?ooo`00S03o
ool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo08P0oooo00270?ooo`<000000P3o
ool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo08P0oooo00270?ooo`060000003o
ool0oooo0000003oool000000P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo08P0
oooo00270?ooo`060000003oool0oooo0000003oool000000P3oool3000000<0oooo00<000000?oo
o`3oool0R03oool008L0oooo0`0000020?ooo`040000003oool0oooo000000D0oooo00<000000?oo
o`3oool0R03oool008P0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0R@3oool008P0oooo0`0000001@3oool000000?ooo`3oool00000
00@0oooo00<000000?ooo`3oool0R@3oool008`0oooo00@000000?ooo`3oool00000103oool00`00
0000oooo0?ooo`290?ooo`00S03oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo
08T0oooo002<0?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0R@3oool008`0
oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`290?ooo`00S03oool00`000000
oooo0?ooo`02000000<0oooo00<000000?ooo`3oool0R@3oool008d0oooo00<000000?ooo`000000
103oool00`000000oooo0?ooo`290?ooo`00S@3oool00`000000oooo000000040?ooo`030000003o
ool0oooo08T0oooo002=0?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool0R@3oool0
08d0oooo00<000000?ooo`000000103oool00`000000oooo0?ooo`290?ooo`00S@3oool00`000000
oooo000000040?ooo`030000003oool0oooo08T0oooo002=0?ooo`030000003oool0000000@0oooo
00<000000?ooo`3oool0R@3oool008d0oooo00<000000?ooo`0000000`3oool00`000000oooo0?oo
o`2:0?ooo`00S@3oool010000000oooo0000000000020?ooo`030000003oool0oooo08X0oooo002=
0?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool0RP3oool008d0oooo00<000000?oo
o`0000000`3oool00`000000oooo0?ooo`2:0?ooo`00S@3oool00`000000oooo000000030?ooo`03
0000003oool0oooo08X0oooo002=0?ooo`030000003oool0000000<0oooo00<000000?ooo`3oool0
RP3oool008d0oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`2:0?ooo`00S@3oool0
0`000000oooo000000030?ooo`030000003oool0oooo08X0oooo002=0?ooo`030000003oool00000
00<0oooo00<000000?ooo`3oool0RP3oool008d0oooo00H000000?ooo`00000000000?ooo`00002=
0?ooo`00S@3oool00`000000oooo000000020?ooo`030000003oool0oooo08/0oooo002=0?ooo`03
0000003oool000000080oooo00<000000?ooo`3oool0R`3oool008d0oooo00<000000?ooo`000000
0P3oool00`000000oooo0?ooo`2;0?ooo`00S@3oool00`000000oooo000000020?ooo`030000003o
ool0oooo08/0oooo002=0?ooo`030000003oool000000080oooo00<000000?ooo`3oool0R`3oool0
08P0oooo0P0000030?ooo`030000003oool000000080oooo00<000000?ooo`3oool0R`3oool008L0
oooo00@000000?ooo`3oool000000P3oool00`000000oooo000000020?ooo`030000003oool0oooo
08/0oooo00270?ooo`040000003oool0oooo00000080oooo00<000000?ooo`0000000`00002=0?oo
o`00R03oool2000000<0oooo00<000000?ooo`0000000P3oool00`000000oooo0?ooo`2;0?ooo`00
Q`3oool010000000oooo0?ooo`0000020?ooo`030000003oool000000080oooo00<000000?ooo`3o
ool0R`3oool008P0oooo0P0000030?ooo`030000003oool000000080oooo00<000000?ooo`3oool0
R`3oool008d0oooo00D000000?ooo`000000oooo0000002>0?ooo`00S@3oool01@000000oooo0000
003oool0000008h0oooo002=0?ooo`050000003oool000000?ooo`000000SP3oool008d0oooo00D0
00000?ooo`000000oooo0000002>0?ooo`00SP3oool4000008h0oooo002>0?ooo`80000000<0oooo
0000003oool0S@3oool008h0oooo0P0000000`3oool000000?ooo`2=0?ooo`00SP3oool200000003
0?ooo`000000oooo08d0oooo002>0?ooo`80000000<0oooo0000003oool0S@3oool008h0oooo0P00
00000`3oool000000?ooo`2=0?ooo`00SP3oool2000000030?ooo`000000oooo08d0oooo002>0?oo
o`80000000<0oooo0000003oool0S@3oool008h0oooo1000002>0?ooo`00SP3oool2000000030?oo
o`000000oooo08d0oooo002>0?ooo`80000000<0oooo0000003oool0S@3oool008h0oooo0P000000
0`3oool000000?ooo`2=0?ooo`00SP3oool2000000030?ooo`000000oooo08d0oooo002>0?ooo`80
000000<0oooo0000003oool0S@3oool008h0oooo0P0000000`3oool000000?ooo`2=0?ooo`00SP3o
ool2000000030?ooo`000000oooo08d0oooo002>0?ooo`@00000SP3oool008h0oooo0P0000000`3o
ool000000?ooo`2=0?ooo`00SP3oool2000000030?ooo`000000oooo08d0oooo002>0?ooo`800000
00<0oooo0000003oool0S@3oool008h0oooo0P0000000`3oool000000?ooo`2=0?ooo`00SP3oool2
000000030?ooo`000000oooo08d0oooo00210?ooo`D000000P3oool2000000@0oooo0P0000000`3o
ool000000?ooo`2=0?ooo`00P`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?oo
o`3oool0oooo0P0000000`3oool000000?ooo`2=0?ooo`00P`3oool01@000000oooo0?ooo`3oool0
00000080oooo00@000000?ooo`3oool0oooo1000002>0?ooo`00P`3oool01@000000oooo0?ooo`3o
ool000000080oooo00<000000?ooo`3oool0T`3oool008<0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`030000003oool0oooo09<0oooo00220?ooo`800000103oool2000009H0oooo003o0?oo
ob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-5.81299, -0.764114, \
0.0405086, 0.0624232}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(lambdaexp[k_, mu_] := \((2\ k - 1)\)/Sqrt[2\ mu]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[lambdaexp[k, \ 1/2], {k, 0.5, 1}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928572 1.90476 0.0147151 0.588604 [
[.02381 .00222 -9 -9 ]
[.02381 .00222 9 0 ]
[.21429 .00222 -9 -9 ]
[.21429 .00222 9 0 ]
[.40476 .00222 -9 -9 ]
[.40476 .00222 9 0 ]
[.59524 .00222 -9 -9 ]
[.59524 .00222 9 0 ]
[.78571 .00222 -9 -9 ]
[.78571 .00222 9 0 ]
[.96369 .13244 -18 -4.5 ]
[.96369 .13244 0 4.5 ]
[.96369 .25016 -18 -4.5 ]
[.96369 .25016 0 4.5 ]
[.96369 .36788 -18 -4.5 ]
[.96369 .36788 0 4.5 ]
[.96369 .4856 -18 -4.5 ]
[.96369 .4856 0 4.5 ]
[.96369 .60332 -6 -4.5 ]
[.96369 .60332 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01472 m
.02381 .02097 L
s
[(0.5)] .02381 .00222 0 1 Mshowa
.21429 .01472 m
.21429 .02097 L
s
[(0.6)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(0.7)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(0.8)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(0.9)] .78571 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.97619 .13244 m
.98244 .13244 L
s
[(0.2)] .96369 .13244 1 0 Mshowa
.97619 .25016 m
.98244 .25016 L
s
[(0.4)] .96369 .25016 1 0 Mshowa
.97619 .36788 m
.98244 .36788 L
s
[(0.6)] .96369 .36788 1 0 Mshowa
.97619 .4856 m
.98244 .4856 L
s
[(0.8)] .96369 .4856 1 0 Mshowa
.97619 .60332 m
.98244 .60332 L
s
[(1)] .96369 .60332 1 0 Mshowa
.125 Mabswid
.97619 .04415 m
.97994 .04415 L
s
.97619 .07358 m
.97994 .07358 L
s
.97619 .10301 m
.97994 .10301 L
s
.97619 .16187 m
.97994 .16187 L
s
.97619 .1913 m
.97994 .1913 L
s
.97619 .22073 m
.97994 .22073 L
s
.97619 .27959 m
.97994 .27959 L
s
.97619 .30902 m
.97994 .30902 L
s
.97619 .33845 m
.97994 .33845 L
s
.97619 .39731 m
.97994 .39731 L
s
.97619 .42674 m
.97994 .42674 L
s
.97619 .45617 m
.97994 .45617 L
s
.97619 .51503 m
.97994 .51503 L
s
.97619 .54446 m
.97994 .54446 L
s
.97619 .57389 m
.97994 .57389 L
s
.25 Mabswid
.97619 0 m
.97619 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01472 m
.06244 .03859 L
.10458 .06463 L
.14415 .08909 L
.18221 .11261 L
.22272 .13765 L
.26171 .16175 L
.30316 .18736 L
.34309 .21204 L
.3815 .23578 L
.42237 .26104 L
.46172 .28536 L
.49955 .30874 L
.53984 .33364 L
.57861 .3576 L
.61984 .38308 L
.65954 .40762 L
.69774 .43123 L
.73838 .45635 L
.77751 .48053 L
.81909 .50623 L
.85916 .53099 L
.89771 .55482 L
.93871 .58016 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00203oool2000000@0oooo0P0000040?ooo`8000009P3oool2000000@0oooo0P0000030?oo
o`<000009@3oool2000000@0oooo0P0000050?ooo`030000003oool0oooo02@0oooo0P0000040?oo
o`800000103oool2000002H0oooo0P0000040?ooo`8000000`3oool3000003/0oooo00070?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool00000903oool010000000oooo0?ooo`00
00080?ooo`040000003oool0oooo000002<0oooo00@000000?ooo`3oool000002P3oool00`000000
oooo0?ooo`0S0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000903oool0
10000000oooo0?ooo`00000:0?ooo`030000003oool0oooo03T0oooo00070?ooo`040000003oool0
oooo000000/0oooo00<000000?ooo`3oool08P3oool010000000oooo0?ooo`0000080?ooo`040000
003oool0oooo000002<0oooo00@000000?ooo`3oool000002P3oool00`000000oooo0?ooo`0S0?oo
o`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000903oool010000000oooo0?oo
o`0000090?ooo`<00000>P3oool000L0oooo00@000000?ooo`3oool000002@3oool2000002D0oooo
00@000000?ooo`3oool00000203oool3000002@0oooo00@000000?ooo`3oool000002`3oool00`00
0000oooo0?ooo`0R0?ooo`040000003oool0oooo000000T0oooo0P00000U0?ooo`040000003oool0
oooo000000P0oooo00@000000?ooo`3oool00000>P3oool000L0oooo00@000000?ooo`3oool00000
2@3oool00`000000oooo0?ooo`0T0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3o
ool08`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000002@0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`00000T0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool00000>P3oool000P0oooo0P00000:0?ooo`<000009@3oool2000000X0
oooo0`00000T0?ooo`8000002@3oool4000002D0oooo0P00000:0?ooo`8000009P3oool2000000X0
oooo0`00000j0?ooo`00o`3ooolQ0?ooo`00o`3ooolC0?ooo`030000003oool0oooo00/0oooo003o
0?oooa<0oooo00<000000?ooo`3oool02`3oool00?l0oooo4`3oool00`000000oooo0?ooo`0;0?oo
o`00o`3ooolC0?ooo`030000003oool0oooo00/0oooo00080?ooool000004P0000070?ooo`003`3o
ool3000000L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00P0oooo00<000000?ooo`3oool02`3oool000l0oooo00<000000?ooo`3oool00P00000_
0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0<@3oool00`000000oooo0?ooo`0a
0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool02`3oool001@0oooo00<000000?oo
o`3oool0n`3oool00`000000oooo0?ooo`0;0?ooo`005@3oool200000?/0oooo00<000000?ooo`3o
ool02`3oool001L0oooo0P00003i0?ooo`030000003oool0oooo00/0oooo000I0?ooo`030000003o
ool0oooo0?H0oooo00<000000?ooo`3oool02`3oool001X0oooo0P00003f0?ooo`030000003oool0
oooo00/0oooo000L0?ooo`030000003oool0oooo0?<0oooo0P00000<0?ooo`007@3oool200000?<0
oooo00<000000?ooo`3oool02`3oool001l0oooo00<000000?ooo`3oool0l03oool00`000000oooo
0?ooo`0;0?ooo`00803oool200000?00oooo00<000000?ooo`3oool02`3oool00280oooo00<00000
0?ooo`3oool0k@3oool00`000000oooo0?ooo`0;0?ooo`008`3oool200000>d0oooo00<000000?oo
o`3oool02`3oool002D0oooo00<000000?ooo`3oool0jP3oool00`000000oooo0?ooo`0;0?ooo`00
9P3oool200000>X0oooo00<000000?ooo`3oool02`3oool002P0oooo0P00003X0?ooo`800000303o
ool002X0oooo0P00003V0?ooo`030000003oool0oooo00/0oooo000/0?ooo`800000i03oool00`00
0000oooo0?ooo`0;0?ooo`00;P3oool200000>80oooo00<000000?ooo`3oool02`3oool00300oooo
00<000000?ooo`3oool0g`3oool00`000000oooo0?ooo`0;0?ooo`00<@3oool200000=l0oooo00<0
00000?ooo`3oool02`3oool003<0oooo00<000000?ooo`3oool0g03oool00`000000oooo0?ooo`0;
0?ooo`00=03oool00`000000oooo0?ooo`3K0?ooo`030000003oool0oooo00/0oooo000e0?ooo`80
0000f`3oool2000000`0oooo000g0?ooo`030000003oool0oooo0=P0oooo00<000000?ooo`3oool0
2`3oool003P0oooo0P00003H0?ooo`030000003oool0oooo00/0oooo000j0?ooo`030000003oool0
oooo0=D0oooo00<000000?ooo`3oool02`3oool003/0oooo0P00003E0?ooo`030000003oool0oooo
00/0oooo000m0?ooo`800000d`3oool00`000000oooo0?ooo`0;0?ooo`00?`3oool200000;d0oooo
0P0000040?ooo`8000000`3oool4000000D0oooo00<000000?ooo`3oool02`3oool00440oooo0P00
002j0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`0;0?ooo`00@`3oool200000;P0oooo00@000000?ooo`3oool000002@3oool00`000000oooo
0?ooo`050?ooo`800000303oool004D0oooo00<000000?ooo`3oool0]@3oool010000000oooo0?oo
o`00000:0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool02`3oool004H0oooo0P00
002e0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000001@3oool00`000000
oooo0?ooo`0;0?ooo`00B03oool00`000000oooo0?ooo`2c0?ooo`8000002P3oool2000000H0oooo
00<000000?ooo`3oool02`3oool004T0oooo00<000000?ooo`3oool0aP3oool00`000000oooo0?oo
o`0;0?ooo`00BP3oool200000<H0oooo00<000000?ooo`3oool02`3oool004`0oooo00<000000?oo
o`3oool0``3oool00`000000oooo0?ooo`0;0?ooo`00C@3oool200000<<0oooo00<000000?ooo`3o
ool02`3oool004l0oooo00<000000?ooo`3oool0`03oool2000000`0oooo001@0?ooo`800000`03o
ool00`000000oooo0?ooo`0;0?ooo`00DP3oool200000;h0oooo00<000000?ooo`3oool02`3oool0
05@0oooo00<000000?ooo`3oool0^`3oool00`000000oooo0?ooo`0;0?ooo`00E@3oool200000;/0
oooo00<000000?ooo`3oool02`3oool005L0oooo0P00002i0?ooo`030000003oool0oooo00/0oooo
001I0?ooo`800000]`3oool00`000000oooo0?ooo`0;0?ooo`00F`3oool00`000000oooo0?ooo`2d
0?ooo`030000003oool0oooo00/0oooo001L0?ooo`800000]03oool2000000`0oooo001N0?ooo`03
0000003oool0oooo0;40oooo00<000000?ooo`3oool02`3oool005l0oooo0P00002a0?ooo`030000
003oool0oooo00/0oooo001Q0?ooo`800000[`3oool00`000000oooo0?ooo`0;0?ooo`00H`3oool0
0`000000oooo0?ooo`2/0?ooo`030000003oool0oooo00/0oooo001T0?ooo`800000[03oool00`00
0000oooo0?ooo`0;0?ooo`00IP3oool00`000000oooo0?ooo`2Y0?ooo`030000003oool0oooo00/0
oooo001W0?ooo`800000Z@3oool00`000000oooo0?ooo`0;0?ooo`00J@3oool200000:L0oooo0P00
000<0?ooo`00J`3oool00`000000oooo0?ooo`2T0?ooo`030000003oool0oooo00/0oooo001/0?oo
o`800000Y03oool00`000000oooo0?ooo`0;0?ooo`00KP3oool200000:80oooo00<000000?ooo`3o
ool02`3oool00700oooo00<000000?ooo`3oool0W`3oool00`000000oooo0?ooo`0;0?ooo`00L@3o
ool2000009l0oooo00<000000?ooo`3oool02`3oool007<0oooo00<000000?ooo`3oool0R03oool2
000000@0oooo0P0000050?ooo`<00000103oool00`000000oooo0?ooo`0;0?ooo`00M03oool20000
08L0oooo00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`030?ooo`030000003oool0
oooo00/0oooo001f0?ooo`800000Q@3oool010000000oooo0?ooo`0000080?ooo`D00000103oool2
000000`0oooo001h0?ooo`030000003oool0oooo0880oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`0000050?ooo`030000003oool0oooo00/0oooo001i0?ooo`800000PP3oool0
10000000oooo0?ooo`0000090?ooo`030000003oool0000000D0oooo00<000000?ooo`3oool02`3o
ool007/0oooo00<000000?ooo`3oool0P03oool2000000/0oooo0P0000050?ooo`030000003oool0
oooo00/0oooo001l0?ooo`800000U03oool00`000000oooo0?ooo`0;0?ooo`00OP3oool00`000000
oooo0?ooo`2A0?ooo`030000003oool0oooo00/0oooo001o0?ooo`800000T@3oool00`000000oooo
0?ooo`0;0?ooo`00P@3oool2000008l0oooo00<000000?ooo`3oool02`3oool008<0oooo00<00000
0?ooo`3oool0S03oool2000000`0oooo00240?ooo`800000S03oool00`000000oooo0?ooo`0;0?oo
o`00QP3oool00`000000oooo0?ooo`290?ooo`030000003oool0oooo00/0oooo00270?ooo`800000
R@3oool00`000000oooo0?ooo`0;0?ooo`00R@3oool2000008L0oooo00<000000?ooo`3oool02`3o
ool008/0oooo00<000000?ooo`3oool0Q03oool00`000000oooo0?ooo`0;0?ooo`00S03oool20000
08@0oooo00<000000?ooo`3oool02`3oool008h0oooo0P0000220?ooo`030000003oool0oooo00/0
oooo002@0?ooo`030000003oool0oooo07l0oooo0P00000<0?ooo`00T@3oool2000007l0oooo00<0
00000?ooo`3oool02`3oool009<0oooo00<000000?ooo`3oool0O03oool00`000000oooo0?ooo`0;
0?ooo`00U03oool2000007`0oooo00<000000?ooo`3oool02`3oool009H0oooo0P00001j0?ooo`03
0000003oool0oooo00/0oooo002H0?ooo`030000003oool0oooo07L0oooo00<000000?ooo`3oool0
2`3oool009T0oooo0P00001g0?ooo`030000003oool0oooo00/0oooo002K0?ooo`030000003oool0
oooo07@0oooo00<000000?ooo`3oool02`3oool009`0oooo0P00001d0?ooo`800000303oool009h0
oooo0P00001b0?ooo`030000003oool0oooo00/0oooo002P0?ooo`800000L03oool00`000000oooo
0?ooo`0;0?ooo`00XP3oool2000006h0oooo00<000000?ooo`3oool02`3oool00:@0oooo0P00001/
0?ooo`030000003oool0oooo00/0oooo002V0?ooo`030000003oool0oooo06T0oooo00<000000?oo
o`3oool02`3oool00:L0oooo0P00001E0?ooo`800000103oool2000000<0oooo0`0000060?ooo`03
0000003oool0oooo00/0oooo002Y0?ooo`030000003oool0oooo0540oooo00@000000?ooo`3oool0
0000203oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo00/0oooo002Z0?ooo`80
0000D@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000000D0oooo0P00000<
0?ooo`00[03oool2000004l0oooo00@000000?ooo`3oool00000203oool3000000H0oooo00<00000
0?ooo`3oool02`3oool00:h0oooo00<000000?ooo`3oool0C03oool010000000oooo0?ooo`000009
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool02`3oool00:l0oooo0P00001=0?oo
o`8000002P3oool3000000D0oooo00<000000?ooo`3oool02`3oool00;40oooo00<000000?ooo`3o
ool0GP3oool00`000000oooo0?ooo`0;0?ooo`00/P3oool2000005h0oooo00<000000?ooo`3oool0
2`3oool00;@0oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?ooo`0;0?ooo`00]@3oool2
000005/0oooo00<000000?ooo`3oool02`3oool00;L0oooo0P00001I0?ooo`800000303oool00;T0
oooo00<000000?ooo`3oool0EP3oool00`000000oooo0?ooo`0;0?ooo`00^P3oool2000005H0oooo
00<000000?ooo`3oool02`3oool00;`0oooo00<000000?ooo`3oool0D`3oool00`000000oooo0?oo
o`0;0?ooo`00_@3oool2000005<0oooo00<000000?ooo`3oool02`3oool00;l0oooo0P00001A0?oo
o`030000003oool0oooo00/0oooo00310?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3o
ool02`3oool00<80oooo0P00001>0?ooo`030000003oool0oooo00/0oooo00340?ooo`800000C03o
ool2000000`0oooo00360?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3oool02`3oool0
0<L0oooo0P0000190?ooo`030000003oool0oooo00/0oooo00390?ooo`030000003oool0oooo04H0
oooo00<000000?ooo`3oool02`3oool00<X0oooo0P0000160?ooo`030000003oool0oooo00/0oooo
003<0?ooo`800000A03oool00`000000oooo0?ooo`0;0?ooo`00cP3oool00`000000oooo0?ooo`11
0?ooo`030000003oool0oooo00/0oooo003?0?ooo`800000@@3oool00`000000oooo0?ooo`0;0?oo
o`00d@3oool00`000000oooo0?ooo`0n0?ooo`800000303oool00=80oooo0P00000n0?ooo`030000
003oool0oooo00/0oooo003D0?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool02`3o
ool00=D0oooo0P00000k0?ooo`030000003oool0oooo00/0oooo003G0?ooo`800000>@3oool00`00
0000oooo0?ooo`0;0?ooo`00f@3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo00/0
oooo003J0?ooo`8000008P3oool2000000@0oooo0P0000040?ooo`8000001P3oool00`000000oooo
0?ooo`0;0?ooo`00g03oool00`000000oooo0?ooo`0N0?ooo`040000003oool0oooo000000P0oooo
00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`0;0?ooo`00g@3oool2000001h0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000050?ooo`800000303oool00=l0
oooo00<000000?ooo`3oool06`3oool010000000oooo0?ooo`0000090?ooo`8000001P3oool00`00
0000oooo0?ooo`0;0?ooo`00h03oool2000001/0oooo00@000000?ooo`3oool00000203oool01000
0000oooo0?ooo`0000050?ooo`030000003oool0oooo00/0oooo003R0?ooo`8000006P3oool20000
00X0oooo0P0000060?ooo`030000003oool0oooo00/0oooo003T0?ooo`030000003oool0oooo02/0
oooo00<000000?ooo`3oool02`3oool00>D0oooo0P00000[0?ooo`030000003oool0oooo00/0oooo
003W0?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool02`3oool00>P0oooo0P00000X
0?ooo`030000003oool0oooo00/0oooo003Z0?ooo`8000009P3oool2000000`0oooo003/0?ooo`80
0000903oool00`000000oooo0?ooo`0;0?ooo`00kP3oool200000280oooo00<000000?ooo`3oool0
2`3oool00?00oooo0P00000P0?ooo`030000003oool0oooo00/0oooo003b0?ooo`030000003oool0
oooo01d0oooo00<000000?ooo`3oool02`3oool00?<0oooo0P00000M0?ooo`030000003oool0oooo
00/0oooo003e0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool02`3oool00?H0oooo
00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0;0?ooo`00m`3oool2000001T0oooo0P00
000<0?ooo`00n@3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo00/0oooo003j0?oo
o`8000005P3oool00`000000oooo0?ooo`0;0?ooo`00o03oool00`000000oooo0?ooo`0C0?ooo`03
0000003oool0oooo00/0oooo003m0?ooo`8000004`3oool00`000000oooo0?ooo`0;0?ooo`00o`3o
ool200000140oooo00<000000?ooo`3oool02`3oool00?l0oooo0P3oool00`000000oooo0?ooo`0>
0?ooo`030000003oool0oooo00/0oooo003o0?ooo`<0oooo0P00000>0?ooo`030000003oool0oooo
00/0oooo003o0?ooo`D0oooo0P00000<0?ooo`800000303oool00?l0oooo1`3oool2000000X0oooo
00<000000?ooo`3oool02`3oool00?l0oooo2@3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo00/0oooo003o0?ooo`X0oooo0P0000070?ooo`030000003oool0oooo00/0oooo003o0?oo
o``0oooo0P0000050?ooo`030000003oool0oooo00/0oooo003o0?ooo`h0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`0;0?ooo`00o`3oool:0?ooo`L000000P3oool00`000000oooo
0?ooo`0;0?ooo`00o`3oool<0?ooo`030000003oool0oooo0080oooo0`00000=0?ooo`00o`3oool<
0?ooo`030000003oool0oooo00@0oooo0P00000<0?ooo`00o`3oool<0?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool02`3oool00?l0oooo303oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00/0oooo003o0?ooo`/0oooo0P0000060?ooo`030000003oool0oooo00/0oooo
003o0?oooa<0oooo00<000000?ooo`3oool02`3oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.470478, -0.07747, \
0.0019309, 0.00624851}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(trule[dd_, k_] := 
        If[\((Abs[dd] \[GreaterEqual] lambdaexp[k, 1/2])\), dd, 
          0];\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(Plot[{trule[dd, 0.75], dd}, {dd, \(-1\), 
        1}, \[IndentingNewLine]AspectRatio \[Rule] 
        Automatic, \[IndentingNewLine]\ 
      PlotStyle\  \[Rule] \ {{Thickness[
              0.01]}, {Dashing[{0.02}]}}, \[IndentingNewLine]\ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 
          12}, \ \ \ AxesLabel\  \[Rule] \ {"\<d\>", \ 
          None}]\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.476191 0.5 0.476191 [
[.02381 .4875 -9.03125 -15.75 ]
[.02381 .4875 9.03125 0 ]
[.2619 .4875 -13.3125 -15.75 ]
[.2619 .4875 13.3125 0 ]
[.7381 .4875 -9.125 -15.75 ]
[.7381 .4875 9.125 0 ]
[.97619 .4875 -4.84375 -15.75 ]
[.97619 .4875 4.84375 0 ]
[1.025 .5 0 -7.875 ]
[1.025 .5 10 7.875 ]
[.4875 .02381 -18.0625 -7.875 ]
[.4875 .02381 0 7.875 ]
[.4875 .2619 -26.625 -7.875 ]
[.4875 .2619 0 7.875 ]
[.4875 .7381 -18.25 -7.875 ]
[.4875 .7381 0 7.875 ]
[.4875 .97619 -9.6875 -7.875 ]
[.4875 .97619 0 7.875 ]
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .5 m
.02381 .50625 L
s
gsave
.02381 .4875 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.2619 .5 m
.2619 .50625 L
s
gsave
.2619 .4875 -74.3125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.7381 .5 m
.7381 .50625 L
s
gsave
.7381 .4875 -70.125 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.97619 .5 m
.97619 .50625 L
s
gsave
.97619 .4875 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.125 Mabswid
.07143 .5 m
.07143 .50375 L
s
.11905 .5 m
.11905 .50375 L
s
.16667 .5 m
.16667 .50375 L
s
.21429 .5 m
.21429 .50375 L
s
.30952 .5 m
.30952 .50375 L
s
.35714 .5 m
.35714 .50375 L
s
.40476 .5 m
.40476 .50375 L
s
.45238 .5 m
.45238 .50375 L
s
.54762 .5 m
.54762 .50375 L
s
.59524 .5 m
.59524 .50375 L
s
.64286 .5 m
.64286 .50375 L
s
.69048 .5 m
.69048 .50375 L
s
.78571 .5 m
.78571 .50375 L
s
.83333 .5 m
.83333 .50375 L
s
.88095 .5 m
.88095 .50375 L
s
.92857 .5 m
.92857 .50375 L
s
.25 Mabswid
0 .5 m
1 .5 L
s
gsave
1.025 .5 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
69.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 .02381 m
.50625 .02381 L
s
gsave
.4875 .02381 -79.0625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.5 .2619 m
.50625 .2619 L
s
gsave
.4875 .2619 -87.625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.5 .7381 m
.50625 .7381 L
s
gsave
.4875 .7381 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.5 .97619 m
.50625 .97619 L
s
gsave
.4875 .97619 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .07143 m
.50375 .07143 L
s
.5 .11905 m
.50375 .11905 L
s
.5 .16667 m
.50375 .16667 L
s
.5 .21429 m
.50375 .21429 L
s
.5 .30952 m
.50375 .30952 L
s
.5 .35714 m
.50375 .35714 L
s
.5 .40476 m
.50375 .40476 L
s
.5 .45238 m
.50375 .45238 L
s
.5 .54762 m
.50375 .54762 L
s
.5 .59524 m
.50375 .59524 L
s
.5 .64286 m
.50375 .64286 L
s
.5 .69048 m
.50375 .69048 L
s
.5 .78571 m
.50375 .78571 L
s
.5 .83333 m
.50375 .83333 L
s
.5 .88095 m
.50375 .88095 L
s
.5 .92857 m
.50375 .92857 L
s
.25 Mabswid
.5 0 m
.5 1 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.01 w
.02381 .02381 m
.06244 .06244 L
.10458 .10458 L
.14415 .14415 L
.18221 .18221 L
.22272 .22272 L
.24141 .24141 L
.25127 .25127 L
.25666 .25666 L
.2593 .2593 L
.26045 .26045 L
.26171 .26171 L
.26301 .5 L
.26425 .5 L
.26494 .5 L
.26567 .5 L
.26698 .5 L
.26773 .5 L
.26855 .5 L
.26932 .5 L
.27003 .5 L
.27067 .5 L
.27137 .5 L
.2721 .5 L
.27279 .5 L
.27342 .5 L
.27411 .5 L
.27537 .5 L
.27659 .5 L
.27772 .5 L
.27894 .5 L
.27964 .5 L
.28029 .5 L
.2816 .5 L
.28234 .5 L
.28302 .5 L
.28419 .5 L
.28544 .5 L
.28663 .5 L
.2877 .5 L
.28897 .5 L
.28968 .5 L
.29034 .5 L
.29155 .5 L
.29283 .5 L
.29405 .5 L
.29537 .5 L
.29661 .5 L
.29774 .5 L
.29843 .5 L
Mistroke
.29907 .5 L
.29977 .5 L
.30052 .5 L
.30123 .5 L
.3019 .5 L
.30316 .5 L
.30432 .5 L
.30557 .5 L
.30675 .5 L
.30783 .5 L
.30909 .5 L
.3098 .5 L
.31046 .5 L
.31166 .5 L
.31294 .5 L
.31417 .5 L
.31548 .5 L
.31672 .5 L
.31786 .5 L
.31912 .5 L
.31983 .5 L
.3205 .5 L
.3212 .5 L
.32184 .5 L
.32258 .5 L
.32327 .5 L
.32434 .5 L
.32552 .5 L
.32675 .5 L
.32789 .5 L
.32897 .5 L
.32995 .5 L
.33108 .5 L
.33215 .5 L
.33331 .5 L
.33454 .5 L
.33559 .5 L
.33675 .5 L
.33799 .5 L
.33869 .5 L
.33933 .5 L
.34051 .5 L
.34176 .5 L
.34299 .5 L
.34368 .5 L
.34432 .5 L
.3455 .5 L
.34675 .5 L
.34786 .5 L
.34891 .5 L
Mistroke
.35005 .5 L
.35129 .5 L
.35259 .5 L
.35333 .5 L
.35402 .5 L
.35527 .5 L
.35597 .5 L
.35661 .5 L
.35781 .5 L
.35912 .5 L
.36034 .5 L
.36148 .5 L
.36254 .5 L
.36368 .5 L
.36475 .5 L
.36573 .5 L
.36688 .5 L
.36813 .5 L
.36931 .5 L
.37041 .5 L
.37153 .5 L
.37258 .5 L
.37373 .5 L
.37498 .5 L
.37621 .5 L
.37751 .5 L
.37862 .5 L
.37983 .5 L
.38116 .5 L
.38237 .5 L
.38301 .5 L
.38371 .5 L
.38444 .5 L
.38513 .5 L
.38638 .5 L
.38753 .5 L
.38817 .5 L
.38886 .5 L
.39012 .5 L
.39135 .5 L
.39247 .5 L
.39376 .5 L
.39497 .5 L
.39609 .5 L
.39713 .5 L
.39826 .5 L
.39946 .5 L
.40077 .5 L
.40196 .5 L
.40262 .5 L
Mistroke
.40334 .5 L
.40464 .5 L
.40585 .5 L
.40714 .5 L
.40825 .5 L
.40946 .5 L
.41019 .5 L
.41088 .5 L
.41218 .5 L
.41291 .5 L
.41358 .5 L
.41433 .5 L
.41512 .5 L
.4158 .5 L
.41655 .5 L
.41725 .5 L
.41789 .5 L
.41912 .5 L
.42042 .5 L
.42163 .5 L
.42232 .5 L
.42296 .5 L
.42413 .5 L
.42537 .5 L
.42648 .5 L
.42752 .5 L
.42866 .5 L
.42989 .5 L
.43112 .5 L
.43182 .5 L
.43247 .5 L
.43378 .5 L
.43452 .5 L
.43518 .5 L
.43638 .5 L
.43768 .5 L
.43891 .5 L
.44004 .5 L
.4411 .5 L
.44223 .5 L
.4433 .5 L
.44428 .5 L
.44543 .5 L
.44667 .5 L
.44785 .5 L
.44895 .5 L
.45018 .5 L
.45134 .5 L
.45239 .5 L
.45351 .5 L
Mistroke
.45474 .5 L
.45605 .5 L
.45716 .5 L
.45837 .5 L
.45968 .5 L
.46089 .5 L
.46152 .5 L
.46222 .5 L
.46295 .5 L
.46363 .5 L
.46488 .5 L
.46602 .5 L
.46728 .5 L
.4686 .5 L
.46972 .5 L
.47091 .5 L
.47203 .5 L
.47305 .5 L
.47425 .5 L
.47555 .5 L
.47678 .5 L
.47791 .5 L
.47912 .5 L
.48042 .5 L
.48164 .5 L
.48276 .5 L
.48407 .5 L
.48481 .5 L
.48549 .5 L
.48675 .5 L
.48738 .5 L
.48808 .5 L
.48876 .5 L
.48947 .5 L
.49075 .5 L
.49146 .5 L
.49212 .5 L
.49285 .5 L
.49363 .5 L
.4943 .5 L
.49503 .5 L
.49572 .5 L
.49636 .5 L
.49756 .5 L
.49884 .5 L
.50004 .5 L
.50136 .5 L
.5026 .5 L
.50376 .5 L
.5049 .5 L
Mistroke
.50593 .5 L
.50713 .5 L
.50825 .5 L
.50949 .5 L
.51079 .5 L
.5119 .5 L
.51312 .5 L
.51443 .5 L
.51517 .5 L
.51584 .5 L
.51714 .5 L
.51838 .5 L
.51943 .5 L
.52059 .5 L
.5218 .5 L
.52293 .5 L
.52399 .5 L
.52496 .5 L
.52603 .5 L
.52715 .5 L
.52829 .5 L
.52951 .5 L
.53066 .5 L
.5317 .5 L
.53293 .5 L
.53362 .5 L
.53426 .5 L
.53544 .5 L
.53668 .5 L
.53789 .5 L
.53921 .5 L
.54046 .5 L
.54161 .5 L
.54276 .5 L
.5438 .5 L
.545 .5 L
.54612 .5 L
.54736 .5 L
.54866 .5 L
.54978 .5 L
.551 .5 L
.55231 .5 L
.55305 .5 L
.55372 .5 L
.55503 .5 L
.55626 .5 L
.55731 .5 L
.55848 .5 L
.55969 .5 L
.56083 .5 L
Mistroke
.56188 .5 L
.56286 .5 L
.56398 .5 L
.56504 .5 L
.56618 .5 L
.5674 .5 L
.56855 .5 L
.5696 .5 L
.57083 .5 L
.57152 .5 L
.57216 .5 L
.57334 .5 L
.57458 .5 L
.57579 .5 L
.57648 .5 L
.57712 .5 L
.57829 .5 L
.57953 .5 L
.58063 .5 L
.58167 .5 L
.58281 .5 L
.58404 .5 L
.58527 .5 L
.58597 .5 L
.58662 .5 L
.58793 .5 L
.58867 .5 L
.58934 .5 L
.59054 .5 L
.59184 .5 L
.59306 .5 L
.5942 .5 L
.59525 .5 L
.59638 .5 L
.59745 .5 L
.59843 .5 L
.59958 .5 L
.60082 .5 L
.602 .5 L
.6031 .5 L
.60433 .5 L
.60549 .5 L
.60653 .5 L
.60766 .5 L
.60889 .5 L
.61019 .5 L
.61131 .5 L
.61252 .5 L
.61383 .5 L
.61504 .5 L
Mistroke
.61567 .5 L
.61637 .5 L
.61709 .5 L
.61777 .5 L
.61902 .5 L
.62017 .5 L
.62142 .5 L
.62274 .5 L
.62386 .5 L
.62505 .5 L
.62617 .5 L
.62719 .5 L
.62839 .5 L
.62969 .5 L
.63092 .5 L
.63205 .5 L
.63326 .5 L
.63456 .5 L
.63578 .5 L
.6369 .5 L
.6382 .5 L
.63894 .5 L
.63963 .5 L
.64088 .5 L
.64159 .5 L
.64222 .5 L
.6429 .5 L
.64361 .5 L
.64489 .5 L
.6456 .5 L
.64626 .5 L
.64699 .5 L
.64776 .5 L
.64844 .5 L
.64917 .5 L
.64986 .5 L
.65049 .5 L
.6517 .5 L
.65298 .5 L
.65418 .5 L
.65549 .5 L
.65674 .5 L
.65789 .5 L
.65903 .5 L
.66006 .5 L
.66126 .5 L
.66238 .5 L
.66362 .5 L
.66492 .5 L
.66603 .5 L
Mistroke
.66725 .5 L
.66856 .5 L
.6693 .5 L
.66997 .5 L
.67127 .5 L
.67251 .5 L
.67356 .5 L
.67471 .5 L
.67592 .5 L
.67706 .5 L
.67812 .5 L
.67909 .5 L
.68015 .5 L
.68127 .5 L
.68241 .5 L
.68363 .5 L
.68478 .5 L
.68582 .5 L
.68705 .5 L
.68775 .5 L
.68839 .5 L
.68956 .5 L
.69081 .5 L
.69202 .5 L
.69333 .5 L
.69458 .5 L
.69574 .5 L
.69688 .5 L
.69792 .5 L
.69911 .5 L
.70024 .5 L
.70148 .5 L
.70278 .5 L
.70389 .5 L
.70511 .5 L
.70643 .5 L
.70716 .5 L
.70784 .5 L
.70914 .5 L
.71038 .5 L
.71143 .5 L
.71259 .5 L
.7138 .5 L
.71494 .5 L
.716 .5 L
.71697 .5 L
.71803 .5 L
.71915 .5 L
.7203 .5 L
.72151 .5 L
Mistroke
.72267 .5 L
.72371 .5 L
.72494 .5 L
.72563 .5 L
.72627 .5 L
.72745 .5 L
.72869 .5 L
.7299 .5 L
.73059 .5 L
.73123 .5 L
.73239 .5 L
.73363 .5 L
.73474 .5 L
.73578 .5 L
.73692 .5 L
.73815 .73815 L
.73938 .73938 L
.74073 .74073 L
.74344 .74344 L
.7483 .7483 L
.76662 .76662 L
.80715 .80715 L
.84616 .84616 L
.88762 .88762 L
.92756 .92756 L
.96599 .96599 L
.97619 .97619 L
Mfstroke
.5 Mabswid
[ .02 ] 0 setdash
.02381 .02381 m
.06244 .06244 L
.10458 .10458 L
.14415 .14415 L
.18221 .18221 L
.22272 .22272 L
.26171 .26171 L
.30316 .30316 L
.34309 .34309 L
.3815 .3815 L
.42237 .42237 L
.46172 .46172 L
.49955 .49955 L
.53984 .53984 L
.57861 .57861 L
.61984 .61984 L
.65954 .65954 L
.69774 .69774 L
.73838 .73838 L
.77751 .77751 L
.81909 .81909 L
.85916 .85916 L
.89771 .89771 L
.93871 .93871 L
.97619 .97619 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00R03oool0
0`000000oooo0?ooo`2E0?ooo`00R03oool00`000000oooo0?ooo`2E0?ooo`00R03oool00`000000
oooo0?ooo`2E0?ooo`00O`3oool2000000L0oooo00<000000?ooo`3oool0U@3oool00800oooo00<0
00000?ooo`3oool01@3oool00`000000oooo0?ooo`2E0?ooo`00P03oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo09D0oooo00090?ooo`030000003oool0oooo07@0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`2E0?ooo`00203oool3000006/0oooo1`0000030?ooo`03
0000003oool0oooo00D0oooo0`00002E0?ooo`002@3oool3000007@0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`2E0?ooo`002P3oool3000007<0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`2E0?ooo`002`3oool300000780oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`2E0?ooo`00303oool300000700oooo0P0000070?ooo`030000003oool0oooo
09D0oooo000=0?ooo`<00000L03oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09D0
oooo000>0?ooo`<00000M`3oool00`000000oooo0?ooo`2E0?ooo`003`3oool3000007H0oooo00<0
00000?ooo`3oool0U@3oool00100oooo0`00001e0?ooo`030000003oool0oooo09D0oooo000A0?oo
o`<00000M03oool00`000000oooo0?ooo`2E0?ooo`004P3oool3000007<0oooo00<000000?ooo`3o
ool0U@3oool001<0oooo0`00001b0?ooo`030000003oool0oooo09D0oooo000D0?ooo`<00000L@3o
ool2000009H0oooo000E0?ooo`<00000L03oool00`000000oooo0?ooo`2E0?ooo`005P3oool30000
06l0oooo00<000000?ooo`3oool0U@3oool001L0oooo0`00001^0?ooo`030000003oool0oooo09D0
oooo000H0?ooo`<00000K@3oool00`000000oooo0?ooo`2E0?ooo`006@3oool3000006`0oooo00<0
00000?ooo`3oool0U@3oool001X0oooo0`00001[0?ooo`030000003oool0oooo09D0oooo000K0?oo
o`<00000JP3oool00`000000oooo0?ooo`2E0?ooo`00703oool3000006T0oooo00<000000?ooo`3o
ool0U@3oool001d0oooo0`00001X0?ooo`030000003oool0oooo09D0oooo000N0?ooo`<00000I`3o
ool00`000000oooo0?ooo`2E0?ooo`007`3oool3000006H0oooo00<000000?ooo`3oool0U@3oool0
0200oooo0`00001U0?ooo`030000003oool0oooo09D0oooo000Q0?ooo`<00000I03oool2000009H0
oooo000R0?ooo`<00000H`3oool00`000000oooo0?ooo`2E0?ooo`008`3oool300000680oooo00<0
00000?ooo`3oool0U@3oool002@0oooo0`00001Q0?ooo`030000003oool0oooo09D0oooo000U0?oo
o`<00000H03oool00`000000oooo0?ooo`2E0?ooo`009P3oool3000005l0oooo00<000000?ooo`3o
ool0U@3oool002L0oooo0`00001N0?ooo`030000003oool0oooo09D0oooo000X0?ooo`<00000G@3o
ool00`000000oooo0?ooo`2E0?ooo`00:@3oool3000005`0oooo00<000000?ooo`3oool0U@3oool0
02X0oooo0`00001K0?ooo`030000003oool0oooo09D0oooo000[0?ooo`<00000FP3oool00`000000
oooo0?ooo`2E0?ooo`00;03oool3000005T0oooo00<000000?ooo`3oool0U@3oool002d0oooo0`00
001H0?ooo`030000003oool0oooo09D0oooo000^0?ooo`<00000E`3oool2000009H0oooo000_0?oo
o`<00000EP3oool00`000000oooo0?ooo`2E0?ooo`00<03oool3000005D0oooo00<000000?ooo`3o
ool0U@3oool00340oooo0`00001D0?ooo`030000003oool0oooo09D0oooo000b0?ooo`<00000D`3o
ool00`000000oooo0?ooo`2E0?ooo`00<`3oool300000580oooo00<000000?ooo`3oool0U@3oool0
03@0oooo0`00001A0?ooo`030000003oool0oooo09D0oooo000e0?ooo`<00000D03oool00`000000
oooo0?ooo`2E0?ooo`00=P3oool3000004l0oooo00<000000?ooo`3oool0U@3oool003L0oooo0`00
001>0?ooo`030000003oool0oooo09D0oooo000h0?ooo`<00000C@3oool00`000000oooo0?ooo`2E
0?ooo`00>@3oool3000004`0oooo00<000000?ooo`3oool0U@3oool003X0oooo0`00001;0?ooo`03
0000003oool0oooo09D0oooo000k0?ooo`<00000BP3oool2000009H0oooo000l0?ooo`<00000B@3o
ool00`000000oooo0?ooo`2E0?ooo`00?@3oool3000004P0oooo00<000000?ooo`3oool0U@3oool0
03h0oooo0`0000170?ooo`030000003oool0oooo09D0oooo000o0?ooo`<00000AP3oool00`000000
oooo0?ooo`2E0?ooo`00@03oool3000004D0oooo00<000000?ooo`3oool0U@3oool00440oooo0`00
00140?ooo`030000003oool0oooo09D0oooo00120?ooo`<00000@`3oool00`000000oooo0?ooo`2E
0?ooo`00@`3oool300000300oooo0`0000020?ooo`040000003oool0oooo0?ooo`<000001P3oool0
0`000000oooo0?ooo`2E0?ooo`00A03oool3000002h0oooo0P0000000`3oool000000?ooo`040?oo
o`040000003oool0oooo000000H0oooo00<000000?ooo`3oool0U@3oool004D0oooo0`00000]0?oo
o`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000000D0oooo00<000000?oo
o`3oool0U@3oool004H0oooo0`00000/0?ooo`030000003oool0oooo00800000203oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo09D0oooo00170?ooo`800000903oool7000000030?oo
o`000000oooo0080oooo00<000000?ooo`3oool01@3oool2000000D0oooo0`00002E0?ooo`00B03o
ool2000002/0oooo00D000000?ooo`3oool0oooo000000040?ooo`040000003oool0oooo000000H0
oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000[0?ooo`030000003oool0oooo00800000
103oool4000000H0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000[0?ooo`030000003o
ool0oooo00800000103oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo09D0oooo0018
0?ooo`800000:`3oool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`2E0?ooo`00B03oool2000000<0oooo00<000000?ooo`3oool09P3oool30000
00D0oooo0`0000070?ooo`030000003oool0oooo09D0oooo00180?ooo`800000103oool00`000000
oooo0?ooo`0g0?ooo`030000003oool0oooo09D0oooo00180?ooo`800000103oool00`000000oooo
0?ooo`0g0?ooo`030000003oool0oooo09D0oooo00180?ooo`8000001@3oool00`000000oooo0?oo
o`0f0?ooo`030000003oool0oooo09D0oooo00180?ooo`8000001P3oool00`000000oooo0?ooo`0e
0?ooo`030000003oool0oooo09D0oooo00180?ooo`800000?P3oool00`000000oooo0?ooo`2E0?oo
o`00B03oool2000003h0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000:0?ooo`030000
003oool0oooo0340oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000;0?ooo`030000003o
ool0oooo0300oooo0P00002F0?ooo`00B03oool2000000`0oooo00<000000?ooo`3oool0;`3oool0
0`000000oooo0?ooo`2E0?ooo`00B03oool2000000d0oooo00<000000?ooo`3oool0;P3oool00`00
0000oooo0?ooo`2E0?ooo`00B03oool2000000h0oooo00<000000?ooo`3oool0;@3oool00`000000
oooo0?ooo`2E0?ooo`00B03oool2000003h0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00
000n0?ooo`030000003oool0oooo09D0oooo00180?ooo`800000?P3oool00`000000oooo0?ooo`2E
0?ooo`00B03oool200000180oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`2E0?oo
o`00B03oool2000001<0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`2E0?ooo`00
B03oool2000001@0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`2E0?ooo`00B03o
ool2000001D0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?ooo`2E0?ooo`00B03oool2
000001H0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`2E0?ooo`00B03oool20000
03h0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000n0?ooo`800000UP3oool004P0oooo
0P00000I0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00
000J0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000K
0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000L0?oo
o`030000003oool0oooo01l0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000M0?ooo`03
0000003oool0oooo01h0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000n0?ooo`030000
003oool0oooo09D0oooo00180?ooo`800000?P3oool00`000000oooo0?ooo`2E0?ooo`00B03oool2
000003h0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000Q0?ooo`030000003oool0oooo
01X0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000R0?ooo`030000003oool0oooo01T0
oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000S0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool0U@3oool004P0oooo0P00000T0?ooo`030000003oool0oooo01L0oooo00<0
00000?ooo`3oool0U@3oool004P0oooo0P00000U0?ooo`030000003oool0oooo01H0oooo0P00002F
0?ooo`00B03oool2000003h0oooo00<000000?ooo`3oool0U@3oool004P0oooo0P00000n0?ooo`03
0000003oool0oooo09D0oooo00180?ooo`800000?P3oool00`000000oooo0?ooo`2E0?ooo`00B03o
ool2000002P0oooo0P00000D0?ooo`030000003oool0oooo09D0oooo00180?ooo`800000:P3oool0
0`000000oooo0?ooo`0A0?ooo`030000003oool0oooo09D0oooo00180?ooo`800000:`3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo09D0oooo00180?ooo`800000;03oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo09D0oooo00180?ooo`800000?P3oool00`000000oooo
0?ooo`2E0?ooo`00B03oool2000003h0oooo00<000000?ooo`3oool0U@3oool000`0oooo0P00000i
0?ooo`<000000P3oool010000000oooo0?ooo`3oool3000003D0oooo00<000000?ooo`3oool0>03o
ool300000080oooo00@000000?ooo`3oool0oooo0`00000h0?ooo`8000005`3oool000d0oooo00<0
00000?ooo`3oool0=P3oool4000000D0oooo00@000000?ooo`3oool000009`3oool00`000000oooo
0?ooo`0;0?ooo`030000003oool0oooo03L0oooo0P0000000`3oool000000?ooo`040?ooo`040000
003oool0oooo000003T0oooo00<000000?ooo`3oool05@3oool000d0oooo00<000000?ooo`3oool0
=P3oool00`000000oooo00000002000000@0oooo00<000000?ooo`3oool00P00000W0?ooo`030000
003oool0oooo00X0oooo0P00000h0?ooo`030000003oool0oooo00800000103oool00`000000oooo
0?ooo`02000003P0oooo00<000000?ooo`3oool05@3oool000d0oooo00<000000?ooo`3oool0=P3o
ool00`000000oooo00000002000000P0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool00P0000080?ooo`030000003o
ool0oooo03H0oooo00<000000?ooo`3oool05@3oool000<0oooo1`0000030?ooo`030000003oool0
oooo02h0oooo1`0000000`3oool000000?ooo`03000000L0oooo0P00000Y0?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0=`3oool01@000000oooo0?ooo`3oool0000000L0oooo0P00
000h0?ooo`030000003oool0oooo01D0oooo000=0?ooo`030000003oool0oooo03H0oooo00<00000
0?ooo`0000000P0000040?ooo`040000003oool0oooo000002/0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`0g0?ooo`050000003oool0oooo0?ooo`000000103oool010000000oooo
0?ooo`00000i0?ooo`030000003oool0oooo01D0oooo000=0?ooo`030000003oool0oooo03H0oooo
00<000000?ooo`0000000P0000040?ooo`@00000=@3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo00800000103oool4000003T0oooo00<000000?ooo`3oool05@3oool000d0oooo00<0
00000?ooo`3oool0=P3oool00`000000oooo00000002000000@0oooo00<000000?ooo`3oool0=P3o
ool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?oo
o`0j0?ooo`030000003oool0oooo01D0oooo000<0?ooo`800000>03oool4000000D0oooo00<00000
0?ooo`3oool0=P3oool00`000000oooo0?ooo`0g0?ooo`80000000<0oooo0000003oool0103oool0
0`000000oooo0?ooo`0i0?ooo`8000005`3oool000d0oooo00<000000?ooo`3oool0=`3oool30000
00D0oooo0`00000`0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0>03oool30000
00D0oooo0`00000j0?ooo`030000003oool0oooo01D0oooo00180?ooo`800000>@3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo09D0oooo00180?ooo`800000>@3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo08h0oooo0`0000040?ooo`00B03oool2000003X0oooo00D0
00000?ooo`3oool0oooo0000002?0?ooo`80000000<0oooo0000000000000`3oool004P0oooo0P00
000k0?ooo`040000003oool0oooo000008l0oooo00<000000?ooo`3oool00P0000030?ooo`00B03o
ool2000003h0oooo00<000000?ooo`3oool0S@3oool00`000000oooo0?ooo`02000000<0oooo0002
0?ooool000003P0000090?ooo`030000003oool0oooo008000000`3oool000T0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?oo
o`3oool02P3oool00`000000oooo0?ooo`090?oooh4000002`3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00h0oooo0P0000000`3oool00000000000030?ooo`002@3oool00`000000
oooo0?ooo`0l0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`000000?03oool2000003h0
oooo00<000000?ooo`3oool03`3oool4000000<0oooo00280?ooo`040000003oool0oooo000003/0
oooo0P00001B0?ooo`8000000`3oool008P0oooo00D000000?ooo`3oool0oooo0000000j0?ooo`80
0000DP3oool2000000<0oooo00280?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
=`3oool200000540oooo0`0000030?ooo`00R03oool00`000000oooo0?ooo`0l0?ooo`800000E`3o
ool008P0oooo00<000000?ooo`3oool0?03oool2000005L0oooo00280?ooo`030000003oool0oooo
03`0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo03<0
oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0380oooo
0P00001G0?ooo`00R03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0340oooo0P00
001G0?ooo`00R03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0300oooo0P00001G
0?ooo`00R03oool2000000/0oooo00<000000?ooo`3oool0;`3oool2000005L0oooo00280?ooo`03
0000003oool0oooo03`0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0l0?ooo`800000
E`3oool008P0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0/0?ooo`800000E`3o
ool008P0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0[0?ooo`800000E`3oool0
08P0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0Z0?ooo`800000E`3oool008P0
oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0Y0?ooo`800000E`3oool008P0oooo
00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0X0?ooo`800000E`3oool008P0oooo00<0
00000?ooo`3oool0?03oool2000005L0oooo00280?ooo`030000003oool0oooo03`0oooo0P00001G
0?ooo`00R03oool00`000000oooo0?ooo`0l0?ooo`800000E`3oool008P0oooo00<000000?ooo`3o
ool05@3oool00`000000oooo0?ooo`0T0?ooo`800000E`3oool008P0oooo0P00000G0?ooo`030000
003oool0oooo02<0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0G0?ooo`030000003o
ool0oooo0280oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0H0?ooo`030000003oool0
oooo0240oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0I0?ooo`030000003oool0oooo
0200oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0l0?ooo`800000E`3oool008P0oooo
00<000000?ooo`3oool0?03oool2000005L0oooo00280?ooo`030000003oool0oooo03`0oooo0P00
001G0?ooo`00R03oool00`000000oooo0?ooo`0L0?ooo`8000007P3oool2000005L0oooo00280?oo
o`030000003oool0oooo01h0oooo00<000000?ooo`3oool06`3oool2000005L0oooo00280?ooo`03
0000003oool0oooo01l0oooo00<000000?ooo`3oool06P3oool2000005L0oooo00280?ooo`030000
003oool0oooo0200oooo00<000000?ooo`3oool06@3oool2000005L0oooo00280?ooo`030000003o
ool0oooo03`0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0l0?ooo`800000E`3oool0
08P0oooo0P00000m0?ooo`800000E`3oool008P0oooo00<000000?ooo`3oool0903oool00`000000
oooo0?ooo`0E0?ooo`800000E`3oool008P0oooo00<000000?ooo`3oool09@3oool00`000000oooo
0?ooo`0D0?ooo`800000E`3oool008P0oooo00<000000?ooo`3oool09P3oool00`000000oooo0?oo
o`0C0?ooo`800000E`3oool008P0oooo00<000000?ooo`3oool09`3oool00`000000oooo0?ooo`0B
0?ooo`800000E`3oool008P0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`0A0?oo
o`800000E`3oool008P0oooo00<000000?ooo`3oool0?03oool2000005L0oooo00280?ooo`030000
003oool0oooo03`0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0l0?ooo`800000E`3o
ool008P0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`0=0?ooo`800000E`3oool0
08P0oooo00<000000?ooo`3oool0;@3oool00`000000oooo0?ooo`0<0?ooo`800000E`3oool008P0
oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`0;0?ooo`800000E`3oool008P0oooo
00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`0:0?ooo`800000E`3oool008P0oooo0P00
000m0?ooo`800000E`3oool008P0oooo00<000000?ooo`3oool0?03oool2000005L0oooo00280?oo
o`030000003oool0oooo03`0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0c0?ooo`03
0000003oool0oooo00H0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0d0?ooo`030000
003oool0oooo00D0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0e0?ooo`030000003o
ool0oooo00@0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0f0?ooo`030000003oool0
oooo00<0oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo
0080oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0l0?ooo`800000E`3oool007H0oooo
0`0000020?ooo`040000003oool0oooo0?ooo`<000001P3oool00`000000oooo0?ooo`0l0?ooo`80
0000E`3oool007D0oooo0P0000000`3oool000000?ooo`040?ooo`040000003oool0oooo000000H0
oooo00<000000?ooo`3oool0?03oool2000005L0oooo001e0?ooo`030000003oool0oooo00800000
103oool00`000000oooo0?ooo`02000000D0oooo00<000000?ooo`3oool0>`3oool3000005L0oooo
001e0?ooo`030000003oool0oooo00800000203oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo03`0oooo0P00001G0?ooo`00M@3oool01@000000oooo0?ooo`3oool0000000L0oooo0P00
00050?ooo`<00000?03oool3000005H0oooo001e0?ooo`050000003oool0oooo0?ooo`000000103o
ool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo03d0oooo0`00001E0?ooo`00M@3o
ool00`000000oooo0?ooo`02000000@0oooo100000060?ooo`030000003oool0oooo03h0oooo0`00
001D0?ooo`00M@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`0o0?ooo`<00000D`3oool007D0oooo0P0000000`3oool000000?ooo`040?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool0@03oool300000580oooo001f0?ooo`<0
00001@3oool3000000L0oooo00<000000?ooo`3oool0@@3oool300000540oooo00280?ooo`030000
003oool0oooo0480oooo0`00001@0?ooo`00R03oool00`000000oooo0?ooo`130?ooo`<00000C`3o
ool008P0oooo00<000000?ooo`3oool0A03oool3000004h0oooo00280?ooo`030000003oool0oooo
04D0oooo0`00001=0?ooo`00R03oool00`000000oooo0?ooo`160?ooo`<00000C03oool008P0oooo
00<000000?ooo`3oool0A`3oool3000004/0oooo00280?ooo`800000B@3oool3000004X0oooo0028
0?ooo`030000003oool0oooo04T0oooo0`0000190?ooo`00R03oool00`000000oooo0?ooo`1:0?oo
o`<00000B03oool008P0oooo00<000000?ooo`3oool0B`3oool3000004L0oooo00280?ooo`030000
003oool0oooo04`0oooo0`0000160?ooo`00R03oool00`000000oooo0?ooo`1=0?ooo`<00000A@3o
ool008P0oooo00<000000?ooo`3oool0CP3oool3000004@0oooo00280?ooo`030000003oool0oooo
04l0oooo0`0000130?ooo`00R03oool00`000000oooo0?ooo`1@0?ooo`<00000@P3oool008P0oooo
00<000000?ooo`3oool0D@3oool300000440oooo00280?ooo`030000003oool0oooo0580oooo0`00
00100?ooo`00R03oool00`000000oooo0?ooo`1C0?ooo`<00000?`3oool008P0oooo00<000000?oo
o`3oool0E03oool3000003h0oooo00280?ooo`800000EP3oool3000003d0oooo00280?ooo`030000
003oool0oooo05H0oooo0`00000l0?ooo`00R03oool00`000000oooo0?ooo`1G0?ooo`<00000>`3o
ool008P0oooo00<000000?ooo`3oool0F03oool3000003X0oooo00280?ooo`030000003oool0oooo
05T0oooo0`00000i0?ooo`00R03oool00`000000oooo0?ooo`1J0?ooo`<00000>03oool008P0oooo
00<000000?ooo`3oool0F`3oool3000003L0oooo00280?ooo`030000003oool0oooo05`0oooo0`00
000f0?ooo`00R03oool00`000000oooo0?ooo`1M0?ooo`<00000=@3oool008P0oooo00<000000?oo
o`3oool0GP3oool3000003@0oooo00280?ooo`030000003oool0oooo05l0oooo0`00000c0?ooo`00
R03oool00`000000oooo0?ooo`1P0?ooo`<00000<P3oool008P0oooo00<000000?ooo`3oool0H@3o
ool300000340oooo00280?ooo`800000H`3oool300000300oooo00280?ooo`030000003oool0oooo
06<0oooo0`00000_0?ooo`00R03oool00`000000oooo0?ooo`1T0?ooo`<00000;P3oool008P0oooo
00<000000?ooo`3oool0I@3oool3000002d0oooo00280?ooo`030000003oool0oooo06H0oooo0`00
000/0?ooo`00R03oool00`000000oooo0?ooo`1W0?ooo`<00000:`3oool008P0oooo00<000000?oo
o`3oool0J03oool3000002X0oooo00280?ooo`030000003oool0oooo06T0oooo0`00000Y0?ooo`00
R03oool00`000000oooo0?ooo`1Z0?ooo`<00000:03oool008P0oooo00<000000?ooo`3oool0J`3o
ool3000002L0oooo00280?ooo`030000003oool0oooo06`0oooo0`00000V0?ooo`00R03oool00`00
0000oooo0?ooo`1]0?ooo`<000009@3oool008P0oooo00<000000?ooo`3oool0KP3oool3000002@0
oooo00280?ooo`800000L03oool3000002<0oooo00280?ooo`030000003oool0oooo0700oooo0`00
000R0?ooo`00R03oool00`000000oooo0?ooo`1a0?ooo`<000008@3oool008P0oooo00<000000?oo
o`3oool0LP3oool300000200oooo00280?ooo`030000003oool0oooo07<0oooo0`00000O0?ooo`00
R03oool00`000000oooo0?ooo`1d0?ooo`<000007P3oool008P0oooo00<000000?ooo`3oool0M@3o
ool3000001d0oooo00280?ooo`030000003oool0oooo07H0oooo0`00000L0?ooo`00R03oool00`00
0000oooo0?ooo`1g0?ooo`<000006`3oool007l0oooo0P0000070?ooo`030000003oool0oooo07P0
oooo0`00000J0?ooo`00P03oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo07T0oooo
0`00000I0?ooo`00P03oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo07X0oooo0`00
000H0?ooo`00P03oool00`000000oooo0?ooo`050?ooo`<00000N`3oool3000001L0oooo00200?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0O03oool00`000000oooo0?ooo`0F0?oo
o`00P03oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo09D0oooo00200?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool0U@3oool00800oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`2E0?ooo`00O`3oool2000000L0oooo00<000000?ooo`3oool0U@3oool0
0800oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2E0?ooo`00R03oool00`000000
oooo0?ooo`2E0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-1.07087, -1.12592, 0.00784613, \
0.00784613}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1440}, {0, 783}},
WindowSize->{491, 537},
WindowMargins->{{134, Automatic}, {Automatic, 106}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 26, 0, 30, "Input"],
Cell[1783, 53, 167, 4, 50, "Input"],
Cell[1953, 59, 68, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[2046, 64, 423, 9, 150, "Input"],
Cell[2472, 75, 27005, 952, 186, 17223, 827, "GraphicsData", "PostScript", \
"Graphics"],
Cell[29480, 1029, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[29647, 1037, 493, 11, 190, "Input"],
Cell[30143, 1050, 29694, 953, 186, 16591, 787, "GraphicsData", "PostScript", \
"Graphics"],
Cell[59840, 2005, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[60007, 2013, 354, 8, 130, "Input"],
Cell[60364, 2023, 33096, 1118, 186, 19486, 945, "GraphicsData", "PostScript", \
"Graphics"],
Cell[93463, 3143, 130, 3, 29, "Output"],
Cell[93596, 3148, 17174, 451, 186, 3878, 282, "GraphicsData", "PostScript", \
"Graphics"],
Cell[110773, 3601, 130, 3, 29, "Output"]
}, Open  ]],
Cell[110918, 3607, 81, 1, 30, "Input"],

Cell[CellGroupData[{
Cell[111024, 3612, 71, 1, 30, "Input"],
Cell[111098, 3615, 16359, 405, 186, 3432, 241, "GraphicsData", "PostScript", \
"Graphics"],
Cell[127460, 4022, 130, 3, 29, "Output"]
}, Open  ]],
Cell[127605, 4028, 161, 3, 70, "Input"],

Cell[CellGroupData[{
Cell[127791, 4035, 449, 9, 150, "Input"],
Cell[128243, 4046, 37186, 1293, 296, 17992, 1051, "GraphicsData", \
"PostScript", "Graphics"],
Cell[165432, 5341, 130, 3, 29, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

