(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    149666,       4638]*)
(*NotebookOutlinePosition[    150311,       4660]*)
(*  CellTagsIndexPosition[    150267,       4656]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(\(cumred[th_, d_, k_, a_, 
        b_] := \((th^2)\)^\((0.5 - k)\)\ \((\((d - th)\)^2 + 
              2\ b)\)^\((\(-a\) - 0.5)\)\)\(\[IndentingNewLine]\)
    \)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(a = 
      Plot[cumred[th, 2.7, 0.85, 2.5, 2], {th, \(-2\), 
          10}, \[IndentingNewLine]\ 
        PlotStyle\  \[Rule] \ {{Thickness[0.01]}}, \[IndentingNewLine]\ 
        DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.18254 0.0793651 0.0147151 22.2458 [
[.02381 .00222 -9.03125 -15.75 ]
[.02381 .00222 9.03125 0 ]
[.34127 .00222 -4.84375 -15.75 ]
[.34127 .00222 4.84375 0 ]
[.5 .00222 -4.84375 -15.75 ]
[.5 .00222 4.84375 0 ]
[.65873 .00222 -4.84375 -15.75 ]
[.65873 .00222 4.84375 0 ]
[.81746 .00222 -4.84375 -15.75 ]
[.81746 .00222 4.84375 0 ]
[.97619 .00222 -7.6875 -15.75 ]
[.97619 .00222 7.6875 0 ]
[.17004 .12594 -29.625 -7.875 ]
[.17004 .12594 0 7.875 ]
[.17004 .23717 -23.9375 -7.875 ]
[.17004 .23717 0 7.875 ]
[.17004 .3484 -29.625 -7.875 ]
[.17004 .3484 0 7.875 ]
[.17004 .45963 -23.9375 -7.875 ]
[.17004 .45963 0 7.875 ]
[.17004 .57086 -29.625 -7.875 ]
[.17004 .57086 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01472 m
.02381 .02097 L
s
gsave
.02381 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.34127 .01472 m
.34127 .02097 L
s
gsave
.34127 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .01472 m
.5 .02097 L
s
gsave
.5 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.65873 .01472 m
.65873 .02097 L
s
gsave
.65873 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.81746 .01472 m
.81746 .02097 L
s
gsave
.81746 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.97619 .01472 m
.97619 .02097 L
s
gsave
.97619 .00222 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.06349 .01472 m
.06349 .01847 L
s
.10317 .01472 m
.10317 .01847 L
s
.14286 .01472 m
.14286 .01847 L
s
.22222 .01472 m
.22222 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30159 .01472 m
.30159 .01847 L
s
.38095 .01472 m
.38095 .01847 L
s
.42063 .01472 m
.42063 .01847 L
s
.46032 .01472 m
.46032 .01847 L
s
.53968 .01472 m
.53968 .01847 L
s
.57937 .01472 m
.57937 .01847 L
s
.61905 .01472 m
.61905 .01847 L
s
.69841 .01472 m
.69841 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.77778 .01472 m
.77778 .01847 L
s
.85714 .01472 m
.85714 .01847 L
s
.89683 .01472 m
.89683 .01847 L
s
.93651 .01472 m
.93651 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.18254 .12594 m
.18879 .12594 L
s
gsave
.17004 .12594 -90.625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.005) show
1.000 setlinewidth
grestore
.18254 .23717 m
.18879 .23717 L
s
gsave
.17004 .23717 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.01) show
1.000 setlinewidth
grestore
.18254 .3484 m
.18879 .3484 L
s
gsave
.17004 .3484 -90.625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.015) show
1.000 setlinewidth
grestore
.18254 .45963 m
.18879 .45963 L
s
gsave
.17004 .45963 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.02) show
1.000 setlinewidth
grestore
.18254 .57086 m
.18879 .57086 L
s
gsave
.17004 .57086 -90.625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.025) show
1.000 setlinewidth
grestore
.125 Mabswid
.18254 .03696 m
.18629 .03696 L
s
.18254 .05921 m
.18629 .05921 L
s
.18254 .08145 m
.18629 .08145 L
s
.18254 .1037 m
.18629 .1037 L
s
.18254 .14819 m
.18629 .14819 L
s
.18254 .17044 m
.18629 .17044 L
s
.18254 .19268 m
.18629 .19268 L
s
.18254 .21493 m
.18629 .21493 L
s
.18254 .25942 m
.18629 .25942 L
s
.18254 .28166 m
.18629 .28166 L
s
.18254 .30391 m
.18629 .30391 L
s
.18254 .32616 m
.18629 .32616 L
s
.18254 .37065 m
.18629 .37065 L
s
.18254 .39289 m
.18629 .39289 L
s
.18254 .41514 m
.18629 .41514 L
s
.18254 .43739 m
.18629 .43739 L
s
.18254 .48188 m
.18629 .48188 L
s
.18254 .50412 m
.18629 .50412 L
s
.18254 .52637 m
.18629 .52637 L
s
.18254 .54861 m
.18629 .54861 L
s
.18254 .59311 m
.18629 .59311 L
s
.18254 .61535 m
.18629 .61535 L
s
.25 Mabswid
.18254 0 m
.18254 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .01549 m
.03279 .01562 L
.04262 .01581 L
.053 .01605 L
.06244 .01633 L
.07298 .01673 L
.08426 .01729 L
.0947 .01799 L
.10458 .01888 L
.11428 .02005 L
.12455 .02178 L
.13333 .02388 L
.13832 .02546 L
.14299 .02729 L
.14796 .02975 L
.15337 .03331 L
.15585 .03537 L
.15849 .03797 L
.16324 .0442 L
.16564 .04847 L
.16824 .05445 L
.1707 .06207 L
.17187 .0667 L
.17296 .07188 L
.175 .08483 L
.17608 .09438 L
.17724 .10815 L
.17846 .12931 L
.17961 .16225 L
.18064 .21848 L
.18177 .40441 L
.18298 .60332 L
.1841 .26369 L
.18532 .18435 L
.18661 .14775 L
.18774 .12918 L
.18879 .11732 L
.18994 .10781 L
.19117 .10022 L
.19251 .09391 L
.19396 .08865 L
.19524 .08498 L
.1966 .08181 L
.19917 .07727 L
.20154 .07425 L
.20403 .07191 L
.20671 .07008 L
.20924 .06885 L
.21154 .06804 L
.21295 .06768 L
Mistroke
.21424 .06742 L
.21567 .0672 L
.21647 .06711 L
.21719 .06705 L
.21788 .067 L
.21852 .06698 L
.21921 .06696 L
.21995 .06695 L
.22119 .06698 L
.22189 .06701 L
.22255 .06705 L
.22381 .06716 L
.22516 .06731 L
.22757 .06767 L
.23017 .06819 L
.23303 .0689 L
.24294 .07236 L
.25252 .07701 L
.26151 .08246 L
.28173 .09843 L
.30025 .11726 L
.32081 .14157 L
.33992 .16448 L
.34943 .17461 L
.35839 .18258 L
.36335 .18613 L
.36596 .18771 L
.36871 .18915 L
.37104 .19016 L
.37359 .19107 L
.37471 .19139 L
.37592 .19169 L
.37703 .19192 L
.37809 .19209 L
.3793 .19224 L
.37994 .1923 L
.38064 .19234 L
.38133 .19237 L
.38206 .19238 L
.38336 .19234 L
.38457 .19225 L
.38569 .19211 L
.38692 .1919 L
.38824 .19162 L
.39122 .19073 L
.39403 .18958 L
.3993 .18663 L
.40432 .18289 L
.40895 .1787 L
.41941 .16695 L
Mistroke
.45878 .10958 L
.47856 .08302 L
.49664 .06355 L
.51606 .04795 L
.52677 .04143 L
.53695 .03636 L
.54654 .03245 L
.55677 .02906 L
.57516 .02452 L
.58546 .02266 L
.59659 .02106 L
.60621 .01995 L
.61676 .01896 L
.63672 .01761 L
.64762 .01707 L
.65779 .01667 L
.66825 .01633 L
.67815 .01607 L
.69671 .0157 L
.70638 .01555 L
.71664 .01542 L
.73506 .01524 L
.75455 .0151 L
.77283 .01501 L
.79303 .01494 L
.81154 .01489 L
.83048 .01485 L
.85119 .01482 L
.87081 .01479 L
.89177 .01478 L
.91313 .01476 L
.93328 .01475 L
.95331 .01475 L
.97177 .01474 L
.97619 .01474 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005`3oool2000004d0oooo0P00
000X0?ooo`8000009P3oool3000002L0oooo0`00000T0?ooo`800000103oool3000000h0oooo000E
0?ooo`<0000000<0oooo0000003oool0B@3oool3000000030?ooo`000000oooo02H0oooo0P00000U
0?ooo`80000000<0oooo0000003oool09@3oool00`000000oooo0?ooo`02000002@0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0=0?ooo`005@3oool00`000000oooo0?ooo`1<
0?ooo`030000003oool0oooo02T0oooo0P00000U0?ooo`030000003oool0oooo008000009@3oool0
1@000000oooo0?ooo`3oool0000002@0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000
3@3oool001D0oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0W0?ooo`@000009@3o
ool01@000000oooo0?ooo`3oool0000002D0oooo00D000000?ooo`3oool0oooo0000000T0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool2000000d0oooo000=0?ooo`L000000P3oool2000004d0
oooo0P00000W0?ooo`040000003oool00000000002D0oooo00<000000?ooo`3oool00P00000U0?oo
o`030000003oool0oooo00800000903oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool02`3oool001P0oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0U0?oo
o`<000009@3oool2000000030?ooo`000000oooo02H0oooo0`00000U0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0;0?ooo`00603oool2000004d0oooo0P00000V0?oo
o`<000009@3oool00`000000oooo0000000W0?ooo`80000000<0oooo0000003oool0903oool01@00
0000oooo0?ooo`3oool000000080oooo0P00000=0?ooo`005@3oool01@000000oooo0?ooo`3oool0
000004X0oooo00D000000?ooo`3oool0oooo0000000W0?ooo`8000009@3oool010000000oooo0?oo
o`00000V0?ooo`030000003oool0oooo00800000903oool01@000000oooo0?ooo`3oool000000080
oooo0P00000=0?ooo`005@3oool00`000000oooo0?ooo`02000004X0oooo00<000000?ooo`3oool0
0P00000W0?ooo`8000009P3oool00`000000oooo0000000V0?ooo`80000000<0oooo0000003oool0
8`3oool2000000<0oooo0P0000000`3oool000000?ooo`0=0?ooo`005P3oool3000004`0oooo0`00
000Y0?ooo`030000003oool0oooo02@0oooo0`00000W0?ooo`<000009@3oool00`000000oooo0?oo
o`020?ooo`<000003P3oool00?l0oooo8@3oool003d0oooo00<000000?ooo`3oool0h03oool003d0
oooo00<000000?ooo`3oool0h03oool003d0oooo00<000000?ooo`3oool0h03oool003d0oooo00<0
00000?ooo`3oool0h03oool000d0ooooo`000008000000`0oooo000B0?oooal0000000<0oooo0000
003oool02@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`070?ooo`030000003oool0000006H000004`3oool002P0
oooo2`00000:0?ooo`030000003oool0oooo05l0oooo3`00001b0?ooo`00<03oool5000000P0oooo
00<000000?ooo`3oool0G03oool;000007T0oooo000b0?ooo`D000001P3oool00`000000oooo0?oo
o`1I0?ooo`L00000P03oool003@0oooo0`0000060?ooo`800000F@3oool5000008<0oooo000e0?oo
o`@00000103oool00`000000oooo0?ooo`1G0?ooo`<00000QP3oool003H0oooo0`0000040?ooo`03
0000003oool0oooo05@0oooo1@0000270?ooo`00>03oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo05<0oooo1@0000280?ooo`00>03oool2000000<0oooo00<000000?ooo`3oool0D@3o
ool4000008/0oooo000i0?ooo`050000003oool0oooo0?ooo`000000DP3oool4000008`0oooo000h
0?ooo`8000000`3oool200000500oooo0`00002>0?ooo`00>03oool300000080oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`160?ooo`<00000S`3oool003T0oooo0P0000020?ooo`03
0000003oool0oooo00@0oooo1P0000130?ooo`<00000T03oool003T0oooo0P0000020?ooo`030000
003oool0oooo0080oooo2`00000o0?ooo`<00000T@3oool003T0oooo0`0000000`3oool000000?oo
o`020?ooo`@00000103oool7000003/0oooo0`00002B0?ooo`00>P3oool2000000040?ooo`000000
oooo0?ooo`<000002@3oool6000003P0oooo0`00002C0?ooo`00>P3oool2000000030?ooo`000000
000000<000003@3oool4000003L0oooo0P00002D0?ooo`00>P3oool2000000030?ooo`000000oooo
00800000403oool4000003@0oooo0P00002E0?ooo`00>P3oool2000000030?ooo`000000oooo0080
00004@3oool400000380oooo0P00002F0?ooo`00>P3oool2000000030?ooo`000000000000800000
4`3oool4000002l0oooo0P00002G0?ooo`00>P3oool2000000040?ooo`0000000000000001D0oooo
1000000^0?ooo`030000003oool0oooo09H0oooo000j0?ooo`80000000@0oooo0000000000000000
5`3oool3000002`0oooo0P00002H0?ooo`00>P3oool2000000040?ooo`0000000000000001P0oooo
0P00000[0?ooo`800000V@3oool003X0oooo0P000000103oool0000000000000000I0?ooo`800000
:P3oool00`000000oooo0?ooo`2H0?ooo`00803oool300000080oooo00@000000?ooo`3oool0oooo
0`0000030?ooo`<000000`3oool3000000<0oooo1@00000I0?ooo`<00000:03oool2000009X0oooo
000O0?ooo`80000000<0oooo0000003oool0103oool2000000040?ooo`000000oooo0?ooo`800000
00D0oooo0000003oool0oooo000000020?ooo`040000003oool0oooo0?ooo`@000006`3oool30000
02H0oooo0P00002K0?ooo`007`3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3o
ool00P000000103oool000000?ooo`3oool2000000040?ooo`000000oooo0?ooo`8000000P3oool4
000001`0oooo0`00000U0?ooo`030000003oool0oooo09X0oooo000O0?ooo`030000003oool0oooo
00800000103oool00`000000oooo0?ooo`02000000040?ooo`000000oooo0?ooo`8000001@3oool0
0`000000oooo0?ooo`04000001d0oooo0`00000S0?ooo`800000W03oool001l0oooo00D000000?oo
o`3oool0oooo000000040?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`030000
003oool0oooo0080oooo0P0000020?ooo`@000007P3oool200000280oooo0P00002M0?ooo`007`3o
ool01@000000oooo0?ooo`3oool0000000@0oooo00L000000?ooo`3oool0oooo0000003oool00000
00<0oooo00<000000?ooo`0000000P3oool010000000oooo0?ooo`3oool4000001l0oooo0P00000Q
0?ooo`030000003oool0oooo09`0oooo000O0?ooo`030000003oool0oooo00800000103oool00`00
0000oooo0?ooo`02000000040?ooo`000000oooo0?ooo`80000000<0oooo0000000000000P000003
0?ooo`@000007`3oool3000001l0oooo0P00002N0?ooo`007`3oool00`000000oooo0?ooo`020000
00@0oooo00<000000?ooo`3oool00P000000103oool000000?ooo`3oool2000000030?ooo`000000
oooo00D0oooo1000000P0?ooo`<000007@3oool2000009l0oooo000O0?ooo`80000000<0oooo0000
003oool0103oool2000000040?ooo`000000oooo0?ooo`80000000D0oooo0000003oool0oooo0000
00060?ooo`@000008@3oool3000001`0oooo00<000000?ooo`3oool0WP3oool00200oooo0`000006
0?ooo`<000000`3oool300000080oooo0`0000040?ooo`@000008P3oool3000001X0oooo0P00002P
0?ooo`00>`3oool4000002<0oooo0P00000I0?ooo`800000X@3oool003/0oooo1000000T0?ooo`80
0000603oool00`000000oooo0?ooo`2P0?ooo`00>`3oool4000002@0oooo0`00000F0?ooo`800000
XP3oool003/0oooo1000000U0?ooo`<00000503oool200000:<0oooo000k0?ooo`@000009P3oool3
000001<0oooo00<000000?ooo`3oool0XP3oool003/0oooo1000000W0?ooo`<000004@3oool20000
0:@0oooo000k0?ooo`@00000:03oool3000000l0oooo0P00002U0?ooo`00>`3oool4000002T0oooo
0`00000=0?ooo`800000YP3oool003/0oooo1000000Z0?ooo`<000002`3oool200000:L0oooo000k
0?ooo`<00000;03oool4000000L0oooo1000002W0?ooo`00>`3oool3000002d0oooo100000040?oo
o`D00000Z03oool003/0oooo1000000^0?ooo`T00000ZP3oool003/0oooo0`00000`0?ooo`H00000
[03oool003/0oooo0`00003R0?ooo`00>`3oool300000>80oooo000k0?ooo`<00000hP3oool003/0
oooo0`00003R0?ooo`00>`3oool400000>40oooo000k0?ooo`<00000hP3oool002D0oooo0`000002
0?ooo`040000003oool0oooo0?ooo`<000000`3oool2000000D0oooo0`00003R0?ooo`00903oool2
000000030?ooo`000000oooo00@0oooo0P0000000`3oool000000?ooo`030?ooo`030000003oool0
oooo00<0oooo0`00003R0?ooo`00903oool00`000000oooo0?ooo`02000000@0oooo00<000000?oo
o`3oool00P0000030?ooo`030000003oool0oooo00<0oooo0`00003R0?ooo`00903oool00`000000
oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000030?ooo`030000003oool0oooo00<0
oooo0`00003R0?ooo`00903oool01@000000oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3o
ool0oooo000000030?ooo`030000003oool0oooo00<0oooo1000003Q0?ooo`00903oool01@000000
oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0
oooo00<0oooo0`00003R0?ooo`00903oool00`000000oooo0?ooo`02000000@0oooo00<000000?oo
o`3oool00P0000030?ooo`030000003oool0oooo00<0oooo0`00003R0?ooo`00903oool00`000000
oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000030?ooo`030000003oool0oooo00<0
oooo0`00003R0?ooo`00903oool2000000030?ooo`000000oooo00@0oooo0P0000000`3oool00000
0?ooo`020?ooo`8000001@3oool300000>80oooo000U0?ooo`<000001P3oool3000000@0oooo00<0
00000?ooo`3oool00`3oool300000>80oooo000k0?ooo`@00000h@3oool003/0oooo0`00003R0?oo
o`00>`3oool300000>80oooo000k0?ooo`<00000hP3oool003/0oooo0`00003R0?ooo`00>`3oool4
00000>40oooo000k0?ooo`<00000hP3oool003/0oooo0`00003R0?ooo`00>`3oool300000>80oooo
000k0?ooo`<00000hP3oool003/0oooo0`00003R0?ooo`00>`3oool400000>40oooo000k0?ooo`<0
0000hP3oool003/0oooo0`00003R0?ooo`00>`3oool300000>80oooo000k0?ooo`<00000hP3oool0
03/0oooo0`00003R0?ooo`00>`3oool400000>40oooo000k0?ooo`<00000hP3oool00200oooo0`00
00020?ooo`040000003oool0oooo0?ooo`<000000`3oool2000000@0oooo0`0000030?ooo`<00000
hP3oool001l0oooo0P0000000`3oool000000?ooo`040?ooo`80000000<0oooo0000003oool00`3o
ool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0oooo0`00003R0?ooo`00
7`3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000030?ooo`050000
003oool0oooo0?ooo`0000000P3oool200000080oooo0`00003R0?ooo`007`3oool00`000000oooo
0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000030?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool00`00003R0?ooo`007`3oool01@000000oooo0?ooo`3oool0000000@0oooo
00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0oooo00@0oooo0P0000020?ooo`@0
0000h@3oool001l0oooo00D000000?ooo`3oool0oooo000000040?ooo`050000003oool0oooo0?oo
o`0000000`3oool01@000000oooo0?ooo`3oool000000080oooo00@000000?ooo`3oool0oooo0`00
003R0?ooo`007`3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P000003
0?ooo`040000003oool0oooo0?ooo`@000000`3oool300000>80oooo000O0?ooo`030000003oool0
oooo00800000103oool00`000000oooo0?ooo`02000000<0oooo00D000000?ooo`3oool0oooo0000
00060?ooo`<00000hP3oool001l0oooo0P0000000`3oool000000?ooo`040?ooo`80000000<0oooo
0000003oool00P3oool2000000<0oooo00<000000?ooo`3oool0103oool300000>80oooo000P0?oo
o`<000001P3oool3000000@0oooo00@000000?ooo`3oool0oooo0`0000040?ooo`<00000hP3oool0
03/0oooo1000003Q0?ooo`00>`3oool300000>80oooo000k0?ooo`<00000hP3oool003/0oooo0`00
003R0?ooo`00>`3oool300000>80oooo000k0?ooo`<00000hP3oool003/0oooo1000003Q0?ooo`00
>`3oool300000>80oooo000k0?ooo`<00000hP3oool003/0oooo0`00003R0?ooo`00?03oool20000
0>80oooo000l0?ooo`<00000h@3oool003`0oooo0P00003R0?ooo`00?03oool200000>80oooo000l
0?ooo`800000hP3oool003`0oooo0P00003R0?ooo`00?03oool200000>80oooo000l0?ooo`<00000
h@3oool003`0oooo0P00003R0?ooo`009@3oool300000080oooo00@000000?ooo`3oool0oooo0`00
00040?ooo`8000001@3oool200000>80oooo000T0?ooo`80000000<0oooo0000003oool0103oool2
000000040?ooo`000000oooo0?ooo`<0000000<0oooo0000003oool00`3oool200000>80oooo000T
0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000000030?ooo`000000
oooo00L0oooo0P00003R0?ooo`00903oool00`000000oooo0?ooo`02000000@0oooo00<000000?oo
o`3oool00P0000000`3oool000000?ooo`070?ooo`800000hP3oool002@0oooo00D000000?ooo`3o
ool0oooo000000040?ooo`050000003oool0oooo0?ooo`0000000P3oool2000000H0oooo0`00003Q
0?ooo`00903oool01@000000oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3oool0oooo0000
00040?ooo`030000003oool0oooo00<0oooo0P00003R0?ooo`00903oool00`000000oooo0?ooo`02
000000@0oooo00<000000?ooo`3oool00P0000040?ooo`800000103oool200000>80oooo000T0?oo
o`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000000030?ooo`000000oooo
0080oooo00<000000?ooo`3oool00P3oool200000>80oooo000T0?ooo`80000000<0oooo0000003o
ool0103oool2000000050?ooo`000000oooo0?ooo`0000000P3oool2000000@0oooo0P00003R0?oo
o`009@3oool3000000H0oooo0`0000030?ooo`<000001@3oool200000>80oooo000l0?ooo`<00000
h@3oool003`0oooo0P00003R0?ooo`00?03oool200000>80oooo000l0?ooo`800000hP3oool003`0
oooo0P00003R0?ooo`00?03oool200000>80oooo000l0?ooo`<00000h@3oool003`0oooo0P00003R
0?ooo`00?03oool200000>80oooo000l0?ooo`800000hP3oool003`0oooo0P00003R0?ooo`00?03o
ool200000>80oooo000l0?ooo`<00000h@3oool003`0oooo0P00003R0?ooo`00?03oool200000>80
oooo000l0?ooo`800000hP3oool003`0oooo0P00003R0?ooo`00?03oool300000>40oooo000l0?oo
o`800000hP3oool00200oooo0`0000020?ooo`040000003oool0oooo0?ooo`<00000103oool20000
00<0oooo0`0000040?ooo`800000hP3oool001l0oooo0P0000000`3oool000000?ooo`040?ooo`80
000000@0oooo0000003oool0oooo0`000000103oool000000?ooo`0000020?ooo`030000003oool0
oooo0080oooo0P00003R0?ooo`007`3oool00`000000oooo0?ooo`02000000@0oooo00<000000?oo
o`3oool00P0000000`3oool000000?ooo`040?ooo`030000003oool0oooo008000000`3oool20000
0>80oooo000O0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`0200000003
0?ooo`000000oooo00P0oooo00@000000?ooo`3oool0oooo0P00003R0?ooo`007`3oool01@000000
oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3oool0oooo000000020?ooo`8000001P3oool2
000000<0oooo0`00003Q0?ooo`007`3oool01@000000oooo0?ooo`3oool0000000@0oooo00D00000
0?ooo`3oool0oooo000000040?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0
0P3oool200000>80oooo000O0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?oo
o`02000000@0oooo0P0000000`3oool0000000000002000000@0oooo0P00003R0?ooo`007`3oool0
0`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000000`3oool000000?ooo`02
0?ooo`030000003oool0000000L0oooo0P00003R0?ooo`007`3oool2000000030?ooo`000000oooo
00@0oooo0P0000001@3oool000000?ooo`3oool000000080oooo0P0000000`3oool000000?ooo`06
0?ooo`800000hP3oool00200oooo0`0000060?ooo`<000000`3oool300000080oooo0`0000050?oo
o`800000hP3oool003`0oooo0`00003Q0?ooo`00?03oool200000>80oooo000l0?ooo`800000hP3o
ool003`0oooo0P00003R0?ooo`00?@3oool00`000000oooo0?ooo`3P0?ooo`00?@3oool00`000000
oooo0?ooo`3P0?ooo`00?@3oool200000>40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-2.94018, -0.00326673, \
0.0481382, 0.00017174}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(b = 
      Plot[cumred[th, 0.7, 0.85, 2.5, 2], {th, \(-2\), 
          10}, \[IndentingNewLine]\ 
        PlotStyle\  \[Rule] \ {{Thickness[0.01]}, {Dashing[
                0.2]}}, \[IndentingNewLine]\ 
        DefaultFont\  \[Rule] \ {"\<Roman\>", 12}]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.18254 0.0793651 0.0147151 4.77923 [
[.02381 .00222 -9.03125 -15.75 ]
[.02381 .00222 9.03125 0 ]
[.34127 .00222 -4.84375 -15.75 ]
[.34127 .00222 4.84375 0 ]
[.5 .00222 -4.84375 -15.75 ]
[.5 .00222 4.84375 0 ]
[.65873 .00222 -4.84375 -15.75 ]
[.65873 .00222 4.84375 0 ]
[.81746 .00222 -4.84375 -15.75 ]
[.81746 .00222 4.84375 0 ]
[.97619 .00222 -7.6875 -15.75 ]
[.97619 .00222 7.6875 0 ]
[.17004 .1103 -23.9375 -7.875 ]
[.17004 .1103 0 7.875 ]
[.17004 .20588 -23.9375 -7.875 ]
[.17004 .20588 0 7.875 ]
[.17004 .30147 -23.9375 -7.875 ]
[.17004 .30147 0 7.875 ]
[.17004 .39705 -23.9375 -7.875 ]
[.17004 .39705 0 7.875 ]
[.17004 .49264 -18.25 -7.875 ]
[.17004 .49264 0 7.875 ]
[.17004 .58822 -23.9375 -7.875 ]
[.17004 .58822 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01472 m
.02381 .02097 L
s
gsave
.02381 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.34127 .01472 m
.34127 .02097 L
s
gsave
.34127 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .01472 m
.5 .02097 L
s
gsave
.5 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.65873 .01472 m
.65873 .02097 L
s
gsave
.65873 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.81746 .01472 m
.81746 .02097 L
s
gsave
.81746 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.97619 .01472 m
.97619 .02097 L
s
gsave
.97619 .00222 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.06349 .01472 m
.06349 .01847 L
s
.10317 .01472 m
.10317 .01847 L
s
.14286 .01472 m
.14286 .01847 L
s
.22222 .01472 m
.22222 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30159 .01472 m
.30159 .01847 L
s
.38095 .01472 m
.38095 .01847 L
s
.42063 .01472 m
.42063 .01847 L
s
.46032 .01472 m
.46032 .01847 L
s
.53968 .01472 m
.53968 .01847 L
s
.57937 .01472 m
.57937 .01847 L
s
.61905 .01472 m
.61905 .01847 L
s
.69841 .01472 m
.69841 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.77778 .01472 m
.77778 .01847 L
s
.85714 .01472 m
.85714 .01847 L
s
.89683 .01472 m
.89683 .01847 L
s
.93651 .01472 m
.93651 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.18254 .1103 m
.18879 .1103 L
s
gsave
.17004 .1103 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.02) show
1.000 setlinewidth
grestore
.18254 .20588 m
.18879 .20588 L
s
gsave
.17004 .20588 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.04) show
1.000 setlinewidth
grestore
.18254 .30147 m
.18879 .30147 L
s
gsave
.17004 .30147 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.06) show
1.000 setlinewidth
grestore
.18254 .39705 m
.18879 .39705 L
s
gsave
.17004 .39705 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.08) show
1.000 setlinewidth
grestore
.18254 .49264 m
.18879 .49264 L
s
gsave
.17004 .49264 -79.25 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.1) show
1.000 setlinewidth
grestore
.18254 .58822 m
.18879 .58822 L
s
gsave
.17004 .58822 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.12) show
1.000 setlinewidth
grestore
.125 Mabswid
.18254 .03861 m
.18629 .03861 L
s
.18254 .06251 m
.18629 .06251 L
s
.18254 .0864 m
.18629 .0864 L
s
.18254 .1342 m
.18629 .1342 L
s
.18254 .15809 m
.18629 .15809 L
s
.18254 .18199 m
.18629 .18199 L
s
.18254 .22978 m
.18629 .22978 L
s
.18254 .25368 m
.18629 .25368 L
s
.18254 .27757 m
.18629 .27757 L
s
.18254 .32536 m
.18629 .32536 L
s
.18254 .34926 m
.18629 .34926 L
s
.18254 .37316 m
.18629 .37316 L
s
.18254 .42095 m
.18629 .42095 L
s
.18254 .44485 m
.18629 .44485 L
s
.18254 .46874 m
.18629 .46874 L
s
.18254 .51653 m
.18629 .51653 L
s
.18254 .54043 m
.18629 .54043 L
s
.18254 .56433 m
.18629 .56433 L
s
.18254 .61212 m
.18629 .61212 L
s
.25 Mabswid
.18254 0 m
.18254 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .01676 m
.03279 .01722 L
.04262 .01787 L
.05288 .01874 L
.06244 .01979 L
.0731 .02134 L
.0828 .0232 L
.094 .02611 L
.10458 .0299 L
.11428 .03465 L
.12455 .04164 L
.13333 .04998 L
.13832 .05613 L
.14299 .06317 L
.14796 .07246 L
.15337 .08566 L
.15849 .10259 L
.16094 .11298 L
.16324 .12472 L
.1655 .13872 L
.16794 .15777 L
.17016 .18029 L
.17221 .20785 L
.17442 .2502 L
.17568 .28402 L
.17686 .3265 L
.17809 .39091 L
.17923 .48322 L
s
.17923 .48322 m
.18007 .61803 L
s
.18516 .61803 m
.18529 .58807 L
.18635 .47638 L
.18753 .4021 L
.18882 .34921 L
.18947 .32908 L
.19017 .3109 L
.19142 .28448 L
.19275 .26274 L
.19418 .2441 L
.19679 .21881 L
.19933 .20086 L
.20168 .18801 L
.20594 .17035 L
.21062 .15615 L
.21552 .14475 L
.2201 .13605 L
.24038 .10784 L
.25892 .08759 L
.27955 .06795 L
.29868 .05275 L
.3172 .04122 L
.33693 .03226 L
.34724 .02874 L
.35838 .02568 L
.36801 .02357 L
.37856 .02171 L
.38821 .02036 L
.39854 .0192 L
.40945 .01824 L
.41962 .01754 L
.42981 .01698 L
.4409 .01651 L
.45047 .01618 L
.46103 .0159 L
.48084 .01551 L
.49169 .01536 L
.50186 .01524 L
.51172 .01516 L
.52209 .01508 L
.5406 .01498 L
.55017 .01494 L
.56038 .0149 L
.57876 .01485 L
.58903 .01483 L
.60015 .01481 L
.62031 .01479 L
.64023 .01477 L
.66128 .01475 L
.6809 .01475 L
Mistroke
.69922 .01474 L
.71955 .01473 L
.7381 .01473 L
.75716 .01473 L
.77791 .01472 L
.79766 .01472 L
.81866 .01472 L
.85638 .01472 L
.8757 .01472 L
.89655 .01472 L
.91618 .01472 L
.93766 .01472 L
.97619 .01472 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`005`3oool2000004d0oooo0P00
000X0?ooo`8000009P3oool3000002L0oooo0`00000T0?ooo`800000103oool3000000h0oooo000E
0?ooo`<0000000<0oooo0000003oool0B@3oool3000000030?ooo`000000oooo02H0oooo0P00000U
0?ooo`80000000<0oooo0000003oool09@3oool00`000000oooo0?ooo`02000002@0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0=0?ooo`005@3oool00`000000oooo0?ooo`1<
0?ooo`030000003oool0oooo02T0oooo0P00000U0?ooo`030000003oool0oooo008000009@3oool0
1@000000oooo0?ooo`3oool0000002@0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000
3@3oool001D0oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0W0?ooo`@000009@3o
ool01@000000oooo0?ooo`3oool0000002D0oooo00D000000?ooo`3oool0oooo0000000T0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool2000000d0oooo000=0?ooo`L000000P3oool2000004d0
oooo0P00000W0?ooo`040000003oool00000000002D0oooo00<000000?ooo`3oool00P00000U0?oo
o`030000003oool0oooo00800000903oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool02`3oool001P0oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`0U0?oo
o`<000009@3oool2000000030?ooo`000000oooo02H0oooo0`00000U0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0;0?ooo`00603oool2000004d0oooo0P00000V0?oo
o`<000009@3oool00`000000oooo0000000W0?ooo`80000000<0oooo0000003oool0903oool01@00
0000oooo0?ooo`3oool000000080oooo0P00000=0?ooo`005@3oool01@000000oooo0?ooo`3oool0
000004X0oooo00D000000?ooo`3oool0oooo0000000W0?ooo`8000009@3oool010000000oooo0?oo
o`00000V0?ooo`030000003oool0oooo00800000903oool01@000000oooo0?ooo`3oool000000080
oooo0P00000=0?ooo`005@3oool00`000000oooo0?ooo`02000004X0oooo00<000000?ooo`3oool0
0P00000W0?ooo`8000009P3oool00`000000oooo0000000V0?ooo`80000000<0oooo0000003oool0
8`3oool2000000<0oooo0P0000000`3oool000000?ooo`0=0?ooo`005P3oool3000004`0oooo0`00
000Y0?ooo`030000003oool0oooo02@0oooo0`00000W0?ooo`<000009@3oool00`000000oooo0?oo
o`020?ooo`<000003P3oool00?l0oooo8@3oool003d0oooo00<000000?ooo`3oool0h03oool003d0
oooo00<000000?ooo`3oool0h03oool003d0oooo00<000000?ooo`3oool0h03oool003d0oooo00<0
00000?ooo`3oool0h03oool000d0ooooo`000007000000d0oooo000B0?oooa800000103oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`040?oooj0000004`3oool001/0oooo2`00000G0?ooo`030000003oool0oooo02P0
oooo4@00002W0?ooo`008`3oool6000001@0oooo00<000000?ooo`3oool09@3oool900000;80oooo
000U0?ooo`L000004@3oool00`000000oooo0?ooo`0S0?ooo`H00000]`3oool002P0oooo1@00000@
0?ooo`030000003oool0oooo0280oooo1000002j0?ooo`00:`3oool3000000l0oooo0P00000Q0?oo
o`@00000_03oool002`0oooo0`00000>0?ooo`030000003oool0oooo01h0oooo1@00002m0?ooo`00
;@3oool4000000`0oooo00<000000?ooo`3oool07@3oool400000;l0oooo000^0?ooo`@000002`3o
ool00`000000oooo0?ooo`0K0?ooo`@00000`@3oool00300oooo0P00000;0?ooo`030000003oool0
oooo01X0oooo100000320?ooo`00<@3oool2000000X0oooo00<000000?ooo`3oool0603oool40000
0<@0oooo000b0?ooo`030000003oool0oooo00P0oooo0P00000H0?ooo`@00000a@3oool00380oooo
0P0000090?ooo`030000003oool0oooo01H0oooo0`0000370?ooo`00<`3oool2000000P0oooo00<0
00000?ooo`3oool05@3oool300000<P0oooo000d0?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool0503oool300000<T0oooo000d0?ooo`8000001`3oool00`000000oooo0?ooo`0C0?oo
o`<00000bP3oool003@0oooo0P0000070?ooo`030000003oool0oooo0180oooo0`00003;0?ooo`00
=03oool2000000L0oooo0P00000B0?ooo`<00000c03oool003D0oooo0P0000060?ooo`030000003o
ool0oooo0100oooo0`00003=0?ooo`00=@3oool2000000H0oooo00<000000?ooo`3oool03`3oool3
00000<h0oooo000U0?ooo`<000000P3oool010000000oooo0?ooo`3oool3000000@0oooo0P000006
0?ooo`030000003oool0oooo00h0oooo0`00003?0?ooo`00903oool2000000030?ooo`000000oooo
00@0oooo0P000000103oool000000?ooo`3oool5000000D0oooo00<000000?ooo`3oool03@3oool3
00000=00oooo000T0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`020000
00050?ooo`000000oooo0?ooo`0000001P3oool00`000000oooo0?ooo`0<0?ooo`<00000d@3oool0
02@0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo0080000000@0oooo0000
003oool0oooo0P0000050?ooo`030000003oool0oooo00/0oooo0`00003B0?ooo`00903oool01@00
0000oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3oool0oooo000000020?ooo`80000000<0
oooo0000003oool0103oool2000000/0oooo0`00003C0?ooo`00903oool01@000000oooo0?ooo`3o
ool0000000@0oooo00D000000?ooo`3oool0oooo000000040?ooo`<00000103oool00`000000oooo
0?ooo`090?ooo`<00000e03oool002@0oooo00<000000?ooo`3oool00P0000040?ooo`030000003o
ool0oooo00800000103oool3000000@0oooo00<000000?ooo`3oool02@3oool200000=D0oooo000T
0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000000030?ooo`000000
oooo0080oooo0P0000040?ooo`030000003oool0oooo00P0oooo0P00003F0?ooo`00903oool20000
00030?ooo`000000oooo00@0oooo0P0000001@3oool000000?ooo`3oool000000080oooo0`000004
0?ooo`030000003oool0oooo00L0oooo0`00003F0?ooo`009@3oool3000000H0oooo0`0000030?oo
o`D00000103oool00`000000oooo0?ooo`060?ooo`<00000e`3oool003L0oooo0P0000040?ooo`80
00001P3oool300000=P0oooo000g0?ooo`800000103oool00`000000oooo0?ooo`050?ooo`800000
f@3oool003P0oooo0P0000030?ooo`030000003oool0oooo00D0oooo0P00003I0?ooo`00>03oool2
000000<0oooo00<000000?ooo`3oool0103oool300000=T0oooo000h0?ooo`8000000`3oool00`00
0000oooo0?ooo`040?ooo`800000fP3oool003P0oooo0P0000030?ooo`030000003oool0oooo00@0
oooo0P00003J0?ooo`00>03oool2000000<0oooo0P0000040?ooo`<00000fP3oool003P0oooo0P00
00030?ooo`030000003oool0oooo00<0oooo0P00003K0?ooo`00>03oool2000000<0oooo00<00000
0?ooo`3oool00`3oool200000=/0oooo000h0?ooo`8000000`3oool00`000000oooo0?ooo`020?oo
o`<00000f`3oool003P0oooo0P0000030?ooo`030000003oool0oooo0080oooo0P00003L0?ooo`00
>03oool2000000<0oooo00<000000?ooo`3oool00P3oool200000=`0oooo000h0?ooo`8000000`3o
ool2000000<0oooo0P00003L0?ooo`00>@3oool200000080oooo00<000000?ooo`3oool00P3oool2
00000=`0oooo000i0?ooo`8000000P3oool010000000oooo0?ooo`3oool200000=d0oooo000U0?oo
o`<000000P3oool010000000oooo0?ooo`3oool3000000@0oooo0P0000020?ooo`8000000P3oool0
10000000oooo0?ooo`3oool200000=d0oooo000T0?ooo`80000000<0oooo0000003oool0103oool2
000000030?ooo`000000oooo00<0oooo0P0000020?ooo`8000000P3oool010000000oooo0?ooo`3o
ool200000=d0oooo000T0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02
000000<0oooo0P0000020?ooo`8000000P3oool00`000000oooo0?ooo`0300000=d0oooo000T0?oo
o`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000000030?ooo`0000000000
008000000P3oool200000080oooo00<000000?ooo`3oool00P00003N0?ooo`00903oool01@000000
oooo0?ooo`3oool0000000@0oooo00P000000?ooo`3oool0oooo0000003oool000000?ooo`800000
0P3oool200000080oooo0P0000000`3oool000000000003N0?ooo`00903oool01@000000oooo0?oo
o`3oool0000000@0oooo00D000000?ooo`3oool0oooo000000020?ooo`<000000P3oool200000080
oooo00<000000?ooo`3oool00P00003N0?ooo`00903oool00`000000oooo0?ooo`02000000@0oooo
00<000000?ooo`3oool00P0000020?ooo`<000000P3oool200000080oooo00<000000?ooo`3oool0
0P00003N0?ooo`00903oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P00
00030?ooo`8000000P3oool200000080oooo00@000000?ooo`0000000000g`3oool002@0oooo0P00
00000`3oool000000?ooo`040?ooo`80000000<0oooo0000003oool00`3oool200000080oooo0P00
00020?ooo`040000003oool0000000000=l0oooo000U0?ooo`<000001P3oool3000000D0oooo00<0
00000?ooo`3oool00P0000020?ooo`040000003oool0000000000=l0oooo000i0?ooo`8000000P3o
ool400000=l0oooo000i0?ooo`8000000P3oool010000000oooo00000000003O0?ooo`00>@3oool2
00000080oooo00@000000?ooo`0000000000g`3oool003T0oooo0P0000020?ooo`040000003oool0
000000000=l0oooo000i0?ooo`8000000P3oool010000000oooo00000000003O0?ooo`00>@3oool2
00000080oooo00@000000?ooo`0000000000g`3oool003X0oooo0P0000000`3oool0000000000002
00000=l0oooo000j0?ooo`80000000<0oooo0000003oool00P00003O0?ooo`00>P3oool200000003
0?ooo`000000000000800000g`3oool003X0oooo0P000000103oool0000000000000003P0?ooo`00
>P3oool2000000040?ooo`000000000000000>00oooo000j0?ooo`80000000@0oooo000000000000
0000h03oool003X0oooo0P000000103oool0000000000000003P0?ooo`00>P3oool2000000040?oo
o`000000000000000>00oooo000j0?ooo`80000000@0oooo0000000000000000h03oool002D0oooo
0`0000020?ooo`040000003oool0oooo0?ooo`<000000`3oool3000000<0oooo0P000000103oool0
000000000000003P0?ooo`00903oool2000000030?ooo`000000oooo00@0oooo0P000000103oool0
00000?ooo`3oool2000000030?ooo`000000oooo0080oooo0P000000103oool0000000000000003P
0?ooo`00903oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P000000103o
ool000000?ooo`3oool200000080oooo0P000000103oool0000000000000003P0?ooo`00903oool0
0`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000000`3oool000000?ooo`02
0?ooo`030000003oool0oooo0080000000@0oooo0000000000000000h03oool002@0oooo00D00000
0?ooo`3oool0oooo000000040?ooo`070000003oool0oooo0?ooo`000000oooo000000020?ooo`80
00000P3oool2000000040?ooo`000000000000000>00oooo000T0?ooo`050000003oool0oooo0?oo
o`000000103oool01P000000oooo0?ooo`3oool000000?ooo`80000000<0oooo0000003oool00P3o
ool2000000040?ooo`000000000000000>00oooo000T0?ooo`030000003oool0oooo00800000103o
ool00`000000oooo0?ooo`02000000040?ooo`000000oooo000000@0oooo0P000000103oool00000
00000000003P0?ooo`00903oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0
0P0000001@3oool000000?ooo`3oool0000000<0oooo0P000000103oool0000000000000003P0?oo
o`00903oool2000000030?ooo`000000oooo00@0oooo0P0000000`3oool000000?ooo`020?ooo`03
0000003oool0000000<0oooo0P000000103oool0000000000000003P0?ooo`009@3oool3000000H0
oooo0`0000030?ooo`<000000`3oool2000000040?ooo`000000000000000>00oooo000j0?ooo`80
000000@0oooo0000000000000000h03oool003X0oooo0P0000000`3oool000000000003Q0?ooo`00
>P3oool2000000030?ooo`00000000000>40oooo000j0?ooo`80000000<0oooo000000000000h@3o
ool003X0oooo0P0000000`3oool000000000003Q0?ooo`00>P3oool2000000030?ooo`0000000000
0>40oooo000j0?ooo`80000000<0oooo000000000000h@3oool003X0oooo0P0000000`3oool00000
0000003Q0?ooo`00>P3oool2000000030?ooo`00000000000>40oooo000j0?ooo`80000000<0oooo
000000000000h@3oool003X0oooo0P0000000`3oool000000000003Q0?ooo`00>P3oool200000003
0?ooo`00000000000>40oooo000j0?ooo`80000000<0oooo000000000000h@3oool003X0oooo0P00
00000`3oool000000000003Q0?ooo`00>P3oool2000000030?ooo`00000000000>40oooo000U0?oo
o`<000000P3oool010000000oooo0?ooo`3oool3000000<0oooo0`0000030?ooo`80000000<0oooo
000000000000h@3oool002@0oooo0P0000000`3oool000000?ooo`040?ooo`80000000D0oooo0000
003oool0oooo000000020?ooo`8000000P3oool2000000030?ooo`00000000000>40oooo000T0?oo
o`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000000030?ooo`000000oooo
0080oooo00<000000?ooo`3oool00P0000000`3oool000000000003Q0?ooo`00903oool00`000000
oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000000`3oool000000?ooo`020?ooo`04
0000003oool0oooo0?ooo`@00000h@3oool002@0oooo00D000000?ooo`3oool0oooo000000040?oo
o`070000003oool0oooo0?ooo`000000oooo000000020?ooo`8000000`3oool400000>40oooo000T
0?ooo`050000003oool0oooo0?ooo`000000103oool01@000000oooo0?ooo`3oool000000080oooo
0`0000040?ooo`@00000h@3oool002@0oooo00<000000?ooo`3oool00P0000040?ooo`030000003o
ool0oooo0080000000D0oooo000000000000oooo000000040?ooo`@00000h@3oool002@0oooo00<0
00000?ooo`3oool00P0000040?ooo`030000003oool0oooo0080000000@0oooo0000003oool0oooo
0P0000030?ooo`@00000h@3oool002@0oooo0P0000000`3oool000000?ooo`040?ooo`80000000@0
oooo0000003oool0oooo0P0000000`3oool000000?ooo`030?ooo`@00000h@3oool002D0oooo0`00
00060?ooo`<000000`3oool3000000@0oooo1000003Q0?ooo`00>`3oool400000>40oooo000k0?oo
o`@00000h@3oool003/0oooo1000003Q0?ooo`00>`3oool400000>40oooo000k0?ooo`@00000h@3o
ool003/0oooo1000003Q0?ooo`00>`3oool400000>40oooo000k0?ooo`@00000h@3oool003/0oooo
1000003Q0?ooo`00>`3oool400000>40oooo000k0?ooo`@00000h@3oool003/0oooo1000003Q0?oo
o`00>`3oool400000>40oooo000k0?ooo`@00000h@3oool003/0oooo1000003Q0?ooo`00:`3oool3
00000080oooo00@000000?ooo`3oool0oooo0P0000050?ooo`@00000h@3oool002X0oooo0P000000
0`3oool000000?ooo`060?ooo`030000003oool0oooo00<0oooo1000003Q0?ooo`00:P3oool00`00
0000oooo0?ooo`02000000H0oooo00<000000?ooo`3oool00`3oool400000>40oooo000Z0?ooo`03
0000003oool0oooo008000001P3oool00`000000oooo0?ooo`030?ooo`@00000h@3oool002X0oooo
00D000000?ooo`3oool0oooo000000060?ooo`030000003oool0oooo00<0oooo1000003Q0?ooo`00
:P3oool01@000000oooo0?ooo`3oool0000000H0oooo00<000000?ooo`3oool00`3oool400000>40
oooo000Z0?ooo`030000003oool0oooo008000001P3oool00`000000oooo0?ooo`030?ooo`@00000
h@3oool002X0oooo00<000000?ooo`3oool00P0000060?ooo`030000003oool0oooo00<0oooo1000
003Q0?ooo`00:P3oool2000000030?ooo`000000oooo00D0oooo0P0000050?ooo`@00000h@3oool0
02/0oooo0`0000070?ooo`030000003oool0oooo00<0oooo1000003Q0?ooo`00>`3oool400000>40
oooo000k0?ooo`@00000h@3oool003/0oooo1000003Q0?ooo`00>`3oool400000>40oooo000k0?oo
o`@00000h@3oool003/0oooo1000003Q0?ooo`00>`3oool400000>40oooo000k0?ooo`@00000h@3o
ool003/0oooo1000003Q0?ooo`00>`3oool400000>40oooo000k0?ooo`@00000h@3oool003/0oooo
1000003Q0?ooo`00>`3oool400000>40oooo000k0?ooo`@00000h@3oool003/0oooo1000003Q0?oo
o`009@3oool300000080oooo00@000000?ooo`3oool0oooo0P0000050?ooo`800000103oool40000
0>40oooo000T0?ooo`80000000<0oooo0000003oool01P3oool010000000oooo0?ooo`3oool30000
00030?ooo`000000oooo0080oooo1000003Q0?ooo`00903oool00`000000oooo0?ooo`02000000H0
oooo00D000000?ooo`3oool0oooo000000070?ooo`@00000h@3oool002@0oooo00<000000?ooo`3o
ool00P0000060?ooo`050000003oool0oooo0?ooo`0000001`3oool400000>40oooo000T0?ooo`05
0000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`020?ooo`8000001@3oool40000
0>40oooo000T0?ooo`050000003oool0oooo0?ooo`0000001P3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0080oooo0`00003R0?ooo`00903oool00`000000oooo0?ooo`02000000H0
oooo00<000000?ooo`3oool0103oool2000000<0oooo0`00003R0?ooo`00903oool00`000000oooo
0?ooo`02000000H0oooo00D000000?ooo`3oool0oooo000000030?ooo`040000003oool0oooo0?oo
o`<00000hP3oool002@0oooo0P0000000`3oool000000?ooo`050?ooo`8000000`3oool00`000000
oooo0?ooo`02000000<0oooo0`00003R0?ooo`009@3oool3000000L0oooo00<000000?ooo`3oool0
0P3oool3000000@0oooo0`00003R0?ooo`00>`3oool400000>40oooo000k0?ooo`<00000hP3oool0
0001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-2.94346, -0.0152115, \
0.0481609, 0.000799773}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[a, b, \ \ AxesLabel\  \[Rule] \ {\[Theta], \ None}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.18254 0.0793651 0.0147151 23.287 [
[.02381 .00222 -9.03125 -15.75 ]
[.02381 .00222 9.03125 0 ]
[.34127 .00222 -4.84375 -15.75 ]
[.34127 .00222 4.84375 0 ]
[.5 .00222 -4.84375 -15.75 ]
[.5 .00222 4.84375 0 ]
[.65873 .00222 -4.84375 -15.75 ]
[.65873 .00222 4.84375 0 ]
[.81746 .00222 -4.84375 -15.75 ]
[.81746 .00222 4.84375 0 ]
[.97619 .00222 -7.6875 -15.75 ]
[.97619 .00222 7.6875 0 ]
[1.025 .01472 0 -7.875 ]
[1.025 .01472 9.4375 7.875 ]
[.17004 .13115 -29.625 -7.875 ]
[.17004 .13115 0 7.875 ]
[.17004 .24759 -23.9375 -7.875 ]
[.17004 .24759 0 7.875 ]
[.17004 .36402 -29.625 -7.875 ]
[.17004 .36402 0 7.875 ]
[.17004 .48046 -23.9375 -7.875 ]
[.17004 .48046 0 7.875 ]
[.17004 .59689 -29.625 -7.875 ]
[.17004 .59689 0 7.875 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01472 m
.02381 .02097 L
s
gsave
.02381 .00222 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.34127 .01472 m
.34127 .02097 L
s
gsave
.34127 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .01472 m
.5 .02097 L
s
gsave
.5 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.65873 .01472 m
.65873 .02097 L
s
gsave
.65873 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.81746 .01472 m
.81746 .02097 L
s
gsave
.81746 .00222 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.97619 .01472 m
.97619 .02097 L
s
gsave
.97619 .00222 -68.6875 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.125 Mabswid
.06349 .01472 m
.06349 .01847 L
s
.10317 .01472 m
.10317 .01847 L
s
.14286 .01472 m
.14286 .01847 L
s
.22222 .01472 m
.22222 .01847 L
s
.2619 .01472 m
.2619 .01847 L
s
.30159 .01472 m
.30159 .01847 L
s
.38095 .01472 m
.38095 .01847 L
s
.42063 .01472 m
.42063 .01847 L
s
.46032 .01472 m
.46032 .01847 L
s
.53968 .01472 m
.53968 .01847 L
s
.57937 .01472 m
.57937 .01847 L
s
.61905 .01472 m
.61905 .01847 L
s
.69841 .01472 m
.69841 .01847 L
s
.7381 .01472 m
.7381 .01847 L
s
.77778 .01472 m
.77778 .01847 L
s
.85714 .01472 m
.85714 .01847 L
s
.89683 .01472 m
.89683 .01847 L
s
.93651 .01472 m
.93651 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
gsave
1.025 .01472 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(q) show
1.000 setlinewidth
grestore
.18254 .13115 m
.18879 .13115 L
s
gsave
.17004 .13115 -90.625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.005) show
1.000 setlinewidth
grestore
.18254 .24759 m
.18879 .24759 L
s
gsave
.17004 .24759 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.01) show
1.000 setlinewidth
grestore
.18254 .36402 m
.18879 .36402 L
s
gsave
.17004 .36402 -90.625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.015) show
1.000 setlinewidth
grestore
.18254 .48046 m
.18879 .48046 L
s
gsave
.17004 .48046 -84.9375 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.02) show
1.000 setlinewidth
grestore
.18254 .59689 m
.18879 .59689 L
s
gsave
.17004 .59689 -90.625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.025) show
1.000 setlinewidth
grestore
.125 Mabswid
.18254 .038 m
.18629 .038 L
s
.18254 .06129 m
.18629 .06129 L
s
.18254 .08458 m
.18629 .08458 L
s
.18254 .10786 m
.18629 .10786 L
s
.18254 .15444 m
.18629 .15444 L
s
.18254 .17772 m
.18629 .17772 L
s
.18254 .20101 m
.18629 .20101 L
s
.18254 .2243 m
.18629 .2243 L
s
.18254 .27087 m
.18629 .27087 L
s
.18254 .29416 m
.18629 .29416 L
s
.18254 .31745 m
.18629 .31745 L
s
.18254 .34073 m
.18629 .34073 L
s
.18254 .38731 m
.18629 .38731 L
s
.18254 .41059 m
.18629 .41059 L
s
.18254 .43388 m
.18629 .43388 L
s
.18254 .45717 m
.18629 .45717 L
s
.18254 .50374 m
.18629 .50374 L
s
.18254 .52703 m
.18629 .52703 L
s
.18254 .55032 m
.18629 .55032 L
s
.18254 .5736 m
.18629 .5736 L
s
.25 Mabswid
.18254 0 m
.18254 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.01 w
.02381 .01552 m
.03279 .01567 L
.04262 .01586 L
.053 .01612 L
.06244 .01641 L
.07298 .01683 L
.08426 .01741 L
.0947 .01815 L
.10458 .01907 L
.11428 .0203 L
.12455 .02211 L
.13333 .02431 L
.13832 .02596 L
.14299 .02788 L
.14796 .03045 L
.15337 .03418 L
.15585 .03633 L
.15849 .03906 L
.16324 .04558 L
.16564 .05005 L
.16824 .05631 L
.1707 .06428 L
.17187 .06914 L
.17296 .07455 L
.175 .08811 L
.17608 .09811 L
.17724 .11252 L
.17846 .13468 L
.17961 .16915 L
.18064 .22802 L
.18177 .42265 L
s
.18177 .42265 m
.18291 .61803 L
s
.18302 .61803 m
.1841 .27535 L
.18532 .19229 L
.18661 .15398 L
.18774 .13454 L
.18879 .12212 L
.18994 .11217 L
.19117 .10422 L
.19251 .09761 L
.19396 .09211 L
.19524 .08827 L
.1966 .08495 L
.19917 .0802 L
.20154 .07704 L
.20403 .07459 L
.20671 .07268 L
.20924 .07138 L
.21154 .07054 L
.21295 .07016 L
.21424 .06988 L
.21567 .06966 L
.21647 .06956 L
.21719 .0695 L
.21788 .06945 L
.21852 .06942 L
.21921 .0694 L
.21995 .0694 L
.22119 .06942 L
.22189 .06946 L
.22255 .0695 L
.22381 .06961 L
.22516 .06977 L
.22757 .07015 L
.23017 .07069 L
.23303 .07144 L
.24294 .07506 L
.25252 .07993 L
.26151 .08563 L
.28173 .10235 L
.30025 .12206 L
.32081 .14751 L
.33992 .17149 L
.34943 .18209 L
.35839 .19044 L
.36335 .19415 L
.36596 .19581 L
.36871 .19731 L
.37104 .19838 L
.37359 .19932 L
.37471 .19966 L
Mistroke
.37592 .19997 L
.37703 .20021 L
.37809 .2004 L
.3793 .20055 L
.37994 .20061 L
.38064 .20066 L
.38133 .20068 L
.38206 .20069 L
.38336 .20065 L
.38457 .20056 L
.38569 .20041 L
.38692 .2002 L
.38824 .1999 L
.39122 .19897 L
.39403 .19776 L
.3993 .19467 L
.40432 .19076 L
.40895 .18638 L
.41941 .17408 L
.45878 .11403 L
.47856 .08622 L
.49664 .06584 L
.51606 .04951 L
.52677 .04268 L
.53695 .03738 L
.54654 .03328 L
.55677 .02973 L
.57516 .02498 L
.58546 .02303 L
.59659 .02135 L
.60621 .02019 L
.61676 .01916 L
.63672 .01774 L
.64762 .01718 L
.65779 .01676 L
.66825 .01641 L
.67815 .01614 L
.69671 .01575 L
.70638 .01559 L
.71664 .01545 L
.73506 .01527 L
.75455 .01512 L
.77283 .01502 L
.79303 .01495 L
.81154 .01489 L
.83048 .01485 L
.85119 .01482 L
.87081 .0148 L
.89177 .01478 L
.91313 .01476 L
Mistroke
.93328 .01475 L
.95331 .01475 L
.97177 .01474 L
.97619 .01474 L
Mfstroke
.02381 .02468 m
.03279 .02693 L
.04262 .03006 L
.05288 .03431 L
.06244 .03945 L
.0731 .04698 L
.0828 .05608 L
.094 .07024 L
.10458 .08872 L
.11428 .11187 L
.12455 .14593 L
.13333 .18654 L
.13832 .2165 L
.14299 .2508 L
.14796 .2961 L
.15337 .36039 L
.15849 .44287 L
.16094 .49351 L
.16324 .55073 L
s
.16324 .55073 m
.16547 .61803 L
s
.21879 .61803 m
.2201 .60594 L
.24038 .46848 L
.25892 .36982 L
.27955 .27409 L
.29868 .20006 L
.3172 .14388 L
.33693 .10018 L
.34724 .08304 L
.35838 .06816 L
.36801 .05785 L
.37856 .0488 L
.38821 .0422 L
.39854 .03656 L
.40945 .03189 L
.41962 .02848 L
.42981 .02576 L
.4409 .02345 L
.45047 .02186 L
.46103 .02047 L
.48084 .01858 L
.49169 .01785 L
.50186 .0173 L
.51172 .01686 L
.52209 .01649 L
.5406 .01599 L
.55017 .0158 L
.56038 .01562 L
.57876 .01539 L
.58903 .01528 L
.60015 .01519 L
.62031 .01507 L
.64023 .01498 L
.66128 .01491 L
.6809 .01486 L
.69922 .01483 L
.71955 .01481 L
.7381 .01479 L
.75716 .01477 L
.77791 .01476 L
.79766 .01475 L
.81866 .01474 L
.85638 .01473 L
.8757 .01473 L
.89655 .01473 L
.91618 .01473 L
.93766 .01472 L
.97619 .01472 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`004P3oool2000004`0oooo0P00
000W0?ooo`8000009P3oool3000002H0oooo0`00000S0?ooo`800000103oool3000001L0oooo000@
0?ooo`<0000000<0oooo0000003oool0B03oool3000000030?ooo`000000oooo02D0oooo0P00000U
0?ooo`80000000<0oooo0000003oool0903oool00`000000oooo0?ooo`02000002<0oooo00@00000
0?ooo`3oool0oooo0P0000000`3oool000000?ooo`0F0?ooo`00403oool00`000000oooo0?ooo`1;
0?ooo`030000003oool0oooo02P0oooo0P00000U0?ooo`030000003oool0oooo00800000903oool0
1@000000oooo0?ooo`3oool0000002<0oooo00D000000?ooo`3oool0oooo000000020?ooo`800000
5P3oool00100oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`0V0?ooo`@000009@3o
ool01@000000oooo0?ooo`3oool0000002@0oooo00D000000?ooo`3oool0oooo0000000S0?ooo`05
0000003oool0oooo0?ooo`0000000P3oool2000001H0oooo00080?ooo`L000000P3oool2000004`0
oooo0P00000V0?ooo`040000003oool00000000002D0oooo00<000000?ooo`3oool00P00000T0?oo
o`030000003oool0oooo008000008`3oool01@000000oooo0?ooo`3oool0000000<0oooo00<00000
0?ooo`3oool0503oool001<0oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`0T0?oo
o`<000009@3oool2000000030?ooo`000000oooo02D0oooo0`00000T0?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`0D0?ooo`004`3oool2000004`0oooo0P00000U0?oo
o`<000009@3oool00`000000oooo0000000V0?ooo`80000000<0oooo0000003oool08`3oool01@00
0000oooo0?ooo`3oool000000080oooo0P00000F0?ooo`00403oool01@000000oooo0?ooo`3oool0
000004T0oooo00D000000?ooo`3oool0oooo0000000V0?ooo`8000009@3oool010000000oooo0?oo
o`00000U0?ooo`030000003oool0oooo008000008`3oool01@000000oooo0?ooo`3oool000000080
oooo0P00000F0?ooo`00403oool00`000000oooo0?ooo`02000004T0oooo00<000000?ooo`3oool0
0P00000V0?ooo`8000009P3oool00`000000oooo0000000U0?ooo`80000000<0oooo0000003oool0
8P3oool2000000<0oooo0P0000000`3oool000000?ooo`0F0?ooo`004@3oool3000004/0oooo0`00
000X0?ooo`030000003oool0oooo02@0oooo0`00000V0?ooo`<00000903oool00`000000oooo0?oo
o`020?ooo`<000005`3oool00?l0oooo8@3oool003L0oooo00<000000?ooo`3oool0iP3oool003L0
oooo00<000000?ooo`3oool0f@3oool2000000/0oooo000g0?ooo`030000003oool0oooo0=P0oooo
00@000000?ooo`3oool000002P3oool003L0oooo00<000000?ooo`3oool0f03oool010000000oooo
0?ooo`00000:0?ooo`00203ooooo000000<00000203oool01@000000oooo0?ooo`3oool0000000T0
oooo000=0?oooah0000000<0oooo0000003oool02@3oool00`000000oooo0?ooo`070?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`020?oooh/00000
3P3oool5000000T0oooo000=0?ooo`@000004P3oool:000000X0oooo00<000000?ooo`3oool0>P3o
oolA00000180oooo4000001/0?ooo`040000003oool0oooo000000T0oooo000>0?ooo`L000005@3o
ool5000000P0oooo00<000000?ooo`3oool0=`3oool9000001/0oooo2`00001c0?ooo`040000003o
ool0oooo000000T0oooo000@0?ooo`H000005P3oool4000000L0oooo00<000000?ooo`3oool0=03o
ool7000001d0oooo1P00001l0?ooo`<000002@3oool001@0oooo1@00000E0?ooo`<000001P3oool0
0`000000oooo0?ooo`0c0?ooo`D000007P3oool6000008X0oooo000E0?ooo`D000005@3oool40000
00@0oooo0P00000c0?ooo`<00000803oool4000008d0oooo000H0?ooo`<000005@3oool3000000@0
oooo00<000000?ooo`3oool0;`3oool500000200oooo0`00002?0?ooo`006@3oool3000001D0oooo
0P0000040?ooo`030000003oool0oooo02h0oooo1@00000P0?ooo`<00000T03oool001X0oooo1000
000C0?ooo`<000000`3oool00`000000oooo0?ooo`0]0?ooo`<000008P3oool300000940oooo000K
0?ooo`<00000503oool2000000<0oooo00<000000?ooo`3oool0;03oool300000240oooo1000002B
0?ooo`007@3oool2000001@0oooo0P0000020?ooo`030000003oool0oooo02/0oooo0`00000Q0?oo
o`@00000T`3oool001h0oooo0P00000D0?ooo`030000003oool0oooo00800000:`3oool300000240
oooo0`00002E0?ooo`007`3oool200000180oooo0P0000020?ooo`030000003oool0oooo02X0oooo
0P00000Q0?ooo`<00000UP3oool00200oooo00<000000?ooo`3oool0403oool200000080oooo00<0
00000?ooo`3oool00P3oool;000001`0oooo0P00000Q0?ooo`<00000U`3oool00200oooo0P00000A
0?ooo`<0000000<0oooo0000003oool00P3oool?000001P0oooo0P00000Q0?ooo`<00000V03oool0
0240oooo00<000000?ooo`3oool0403oool2000000030?ooo`000000oooo0080oooo0P0000090?oo
o`D000005P3oool200000240oooo0`00002I0?ooo`008@3oool200000140oooo0P000000103oool0
00000?ooo`3oool3000000`0oooo0`00000E0?ooo`030000003oool0oooo01l0oooo0`00002J0?oo
o`008P3oool200000100oooo0P0000001@3oool000000000003oool0000000l0oooo0`00000C0?oo
o`8000008@3oool2000009/0oooo000S0?ooo`030000003oool0oooo00h0oooo0P0000000`3oool0
00000?ooo`0200000100oooo0`00000A0?ooo`8000008@3oool2000009`0oooo000S0?ooo`800000
3`3oool2000000030?ooo`000000oooo008000004@3oool4000000l0oooo00<000000?ooo`3oool0
7`3oool2000009d0oooo000S0?ooo`8000003`3oool2000000040?ooo`000000oooo000001<0oooo
1000000=0?ooo`800000803oool2000009h0oooo000S0?ooo`<000003P3oool2000000040?ooo`00
00000000000001D0oooo0`00000<0?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool0
W@3oool002@0oooo0P00000>0?ooo`80000000@0oooo00000000000000005P3oool3000000X0oooo
0P00000P0?ooo`800000W`3oool002@0oooo0P00000>0?ooo`80000000@0oooo0000000000000000
5`3oool3000000T0oooo00<000000?ooo`3oool07P3oool200000:00oooo000T0?ooo`<000003@3o
ool2000000040?ooo`0000000000000001P0oooo0`0000070?ooo`800000803oool00`000000oooo
0?ooo`2O0?ooo`006P3oool300000080oooo00@000000?ooo`3oool0oooo100000020?ooo`<00000
0`3oool3000000<0oooo1@00000I0?ooo`<000001P3oool00`000000oooo0?ooo`0N0?ooo`800000
X@3oool001T0oooo0P0000000`3oool000000?ooo`040?ooo`80000000@0oooo000000000000oooo
0P0000001@3oool000000?ooo`3oool000000080oooo00@000000?ooo`3oool0oooo1000000K0?oo
o`8000001@3oool2000001l0oooo0P00002R0?ooo`006@3oool00`000000oooo0?ooo`02000000@0
oooo00<000000?ooo`3oool0100000020?ooo`80000000@0oooo0000003oool0oooo0P0000020?oo
o`@00000703oool2000000@0oooo00<000000?ooo`3oool07P3oool00`000000oooo0?ooo`2Q0?oo
o`006@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0100000020?ooo`80
00001@3oool00`000000oooo0?ooo`04000001d0oooo0P0000030?ooo`030000003oool0oooo01d0
oooo0P00002S0?ooo`006@3oool01@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3o
ool0oooo0`0000030?ooo`030000003oool0oooo0080oooo0P0000020?ooo`@000007P3oool00`00
0000oooo0?ooo`02000001l0oooo00<000000?ooo`3oool0XP3oool001T0oooo00D000000?ooo`3o
ool0oooo000000040?ooo`040000003oool0oooo0?ooo`<000000`3oool00`000000oooo00000002
0?ooo`040000003oool0oooo0?ooo`@000007P3oool2000000030?ooo`000000oooo01h0oooo0P00
002T0?ooo`006@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool010000002
0?ooo`80000000<0oooo0000000000000P0000030?ooo`@000007`3oool3000001h0oooo0P00002U
0?ooo`006@3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool0100000020?oo
o`80000000<0oooo0000003oool01@3oool400000200oooo0P00000N0?ooo`030000003oool0oooo
0:@0oooo000I0?ooo`80000000<0oooo0000003oool0103oool2000000040?ooo`000000oooo0?oo
o`80000000D0oooo0000003oool0oooo000000060?ooo`@000007`3oool4000001`0oooo0P00002V
0?ooo`006P3oool3000000H0oooo0`0000020?ooo`@000000P3oool3000000@0oooo1000000O0?oo
o`D000006P3oool200000:L0oooo000X0?ooo`8000002`3oool4000001h0oooo0`0000000`3oool0
00000000000J0?ooo`030000003oool0oooo0:H0oooo000X0?ooo`8000002`3oool4000001h0oooo
0P0000030?ooo`800000603oool200000:P0oooo000X0?ooo`8000002`3oool4000001h0oooo0P00
00030?ooo`<000005`3oool00`000000oooo0?ooo`2W0?ooo`00:@3oool2000000X0oooo1000000N
0?ooo`800000103oool3000001D0oooo0P00002Y0?ooo`00:@3oool2000000X0oooo1000000M0?oo
o`<000001@3oool3000001<0oooo0P00002Z0?ooo`00:@3oool2000000X0oooo1000000M0?ooo`80
00001`3oool300000140oooo0P00002[0?ooo`00:@3oool2000000X0oooo1000000M0?ooo`800000
203oool3000000l0oooo0`00002[0?ooo`00:@3oool2000000X0oooo1000000L0?ooo`<000002@3o
ool3000000d0oooo0`00002/0?ooo`00:@3oool2000000X0oooo1000000L0?ooo`8000002`3oool3
000000/0oooo0`00002]0?ooo`00:P3oool2000000T0oooo0`00000M0?ooo`800000303oool30000
00T0oooo0`00002^0?ooo`00:P3oool2000000T0oooo0`00000M0?ooo`8000003@3oool4000000D0
oooo1000002_0?ooo`00:P3oool2000000T0oooo0`00000L0?ooo`<000003P3oool;00000;00oooo
000Z0?ooo`8000002@3oool4000001/0oooo0P00000A0?ooo`L00000/P3oool002X0oooo0P000009
0?ooo`<00000703oool200000<X0oooo000Z0?ooo`8000002@3oool3000001`0oooo0P00003:0?oo
o`00:P3oool2000000T0oooo0`00000K0?ooo`<00000bP3oool002X0oooo0P0000090?ooo`<00000
6`3oool200000</0oooo000[0?ooo`800000203oool3000001/0oooo0P00003;0?ooo`00:`3oool2
000000P0oooo1000000J0?ooo`800000b`3oool002/0oooo0P0000080?ooo`<000006P3oool30000
0</0oooo000P0?ooo`<000000P3oool010000000oooo0?ooo`3oool400000080oooo0P0000040?oo
o`<000006P3oool200000<`0oooo000O0?ooo`80000000<0oooo0000003oool0103oool200000003
0?ooo`000000000000<0oooo00<000000?ooo`3oool00P3oool3000001X0oooo0P00003<0?ooo`00
7`3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000030?ooo`030000
003oool0oooo0080oooo0`00000I0?ooo`<00000c03oool001l0oooo00<000000?ooo`3oool00P00
00040?ooo`030000003oool0oooo008000000`3oool00`000000oooo0?ooo`020?ooo`<000006@3o
ool200000<d0oooo000O0?ooo`050000003oool0oooo0?ooo`000000103oool00`000000oooo0?oo
o`02000000<0oooo00<000000?ooo`3oool00P3oool4000001P0oooo0P00003=0?ooo`007`3oool0
1@000000oooo0?ooo`3oool0000000@0oooo00@000000?ooo`3oool0oooo0P0000020?ooo`030000
003oool0oooo0080oooo0`00000I0?ooo`800000c@3oool001l0oooo00<000000?ooo`3oool00P00
00040?ooo`030000003oool0oooo00<000000P3oool00`000000oooo0?ooo`020?ooo`<00000603o
ool300000<d0oooo000O0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`03
00000080oooo00<000000?ooo`3oool00P3oool3000001P0oooo0P00003>0?ooo`007`3oool20000
00030?ooo`000000oooo00@0oooo0P0000001@3oool00000000000000000oooo00800000103oool3
000001P0oooo0P00003>0?ooo`00803oool3000000H0oooo1@0000020?ooo`030000003oool0oooo
0080oooo0`00000H0?ooo`800000cP3oool002`0oooo0P0000070?ooo`@000005P3oool300000<h0
oooo000]0?ooo`8000001P3oool3000001L0oooo0P00003?0?ooo`00;@3oool2000000H0oooo0`00
000G0?ooo`800000c`3oool002d0oooo0P0000060?ooo`<000005`3oool200000<l0oooo000]0?oo
o`8000001P3oool3000001H0oooo0`00003?0?ooo`00;@3oool2000000H0oooo0`00000F0?ooo`80
0000d03oool002d0oooo0P0000060?ooo`@000005@3oool200000=00oooo000^0?ooo`8000001@3o
ool3000001H0oooo0P00003@0?ooo`00;P3oool2000000D0oooo0`00000E0?ooo`<00000d03oool0
02h0oooo0P0000050?ooo`<000005@3oool200000=40oooo000^0?ooo`8000001@3oool3000001D0
oooo0P00003A0?ooo`00;P3oool2000000D0oooo0`00000E0?ooo`800000d@3oool002h0oooo0P00
00050?ooo`@000004`3oool300000=40oooo000^0?ooo`8000001@3oool3000001@0oooo0P00003B
0?ooo`00;P3oool2000000D0oooo0`00000D0?ooo`800000dP3oool002h0oooo0P0000050?ooo`<0
0000503oool200000=80oooo000^0?ooo`8000001@3oool3000001@0oooo0P00003B0?ooo`00;P3o
ool2000000D0oooo0`00000C0?ooo`<00000dP3oool002h0oooo0P0000050?ooo`@000004P3oool2
00000=<0oooo000^0?ooo`8000001@3oool3000001<0oooo0P00003C0?ooo`006P3oool300000080
oooo00@000000?ooo`3oool0oooo0`0000030?ooo`8000000`3oool4000000<0oooo0`00000C0?oo
o`800000d`3oool001T0oooo0P0000000`3oool000000?ooo`040?ooo`80000000<0oooo0000003o
ool00`3oool010000000oooo0?ooo`3oool2000000030?ooo`000000oooo0080oooo0`00000B0?oo
o`<00000d`3oool001T0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo0080
00000`3oool010000000oooo0?ooo`3oool2000000030?ooo`00000000000080oooo0`00000B0?oo
o`800000e03oool001T0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo0080
00000`3oool010000000oooo0?ooo`3oool200000080oooo00<000000?ooo`3oool00`00000B0?oo
o`800000e03oool001T0oooo00D000000?ooo`3oool0oooo000000040?ooo`050000003oool0oooo
0?ooo`0000000`3oool00`000000oooo0?ooo`020?ooo`@000000P3oool400000140oooo0P00003D
0?ooo`006@3oool01@000000oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`040000003oool0oooo0?ooo`@000000`3oool300000140oooo0`00003D0?ooo`006@3o
ool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000030?ooo`040000003o
ool0oooo0?ooo`@000000`3oool300000140oooo0P00003E0?ooo`006@3oool00`000000oooo0?oo
o`02000000@0oooo00<000000?ooo`3oool00P0000030?ooo`040000003oool0oooo0?ooo`<00000
103oool300000140oooo0P00003E0?ooo`006@3oool2000000030?ooo`000000oooo00@0oooo0P00
00000`3oool000000?ooo`020?ooo`8000000`3oool3000000@0oooo0`00000A0?ooo`800000e@3o
ool001X0oooo0`0000060?ooo`<00000103oool010000000oooo0?ooo`3oool3000000@0oooo0`00
000A0?ooo`800000e@3oool002l0oooo0P0000040?ooo`@00000403oool200000=D0oooo000_0?oo
o`800000103oool300000140oooo0P00003E0?ooo`00;`3oool2000000@0oooo0`00000@0?ooo`80
0000eP3oool002l0oooo0P0000040?ooo`<00000403oool200000=H0oooo000_0?ooo`800000103o
ool300000100oooo0P00003F0?ooo`00;`3oool2000000@0oooo0`00000@0?ooo`800000eP3oool0
02l0oooo0P0000040?ooo`@000003`3oool200000=H0oooo000_0?ooo`800000103oool300000100
oooo0P00003F0?ooo`00;`3oool2000000@0oooo0`00000?0?ooo`800000e`3oool002l0oooo0P00
00040?ooo`<000003`3oool200000=L0oooo000_0?ooo`800000103oool3000000l0oooo0P00003G
0?ooo`00;`3oool2000000D0oooo0P00000?0?ooo`800000e`3oool002l0oooo0P0000050?ooo`<0
00003P3oool200000=L0oooo000_0?ooo`8000001@3oool2000000l0oooo0P00003G0?ooo`00;`3o
ool2000000D0oooo0P00000?0?ooo`800000e`3oool00300oooo0P0000040?ooo`8000003P3oool2
00000=P0oooo000`0?ooo`800000103oool2000000h0oooo0P00003H0?ooo`00<03oool2000000@0
oooo0P00000>0?ooo`800000f03oool00300oooo0P0000040?ooo`<000003@3oool200000=P0oooo
000`0?ooo`800000103oool2000000h0oooo0P00003H0?ooo`00803oool300000080oooo00@00000
0?ooo`3oool0oooo0`0000040?ooo`800000103oool2000000h0oooo0P00003H0?ooo`007`3oool2
000000030?ooo`000000oooo00@0oooo0P000000103oool000000?ooo`3oool5000000<0oooo0P00
000=0?ooo`800000f@3oool001l0oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0
oooo0080000000<0oooo0000003oool00P0000040?ooo`8000003@3oool200000=T0oooo000O0?oo
o`030000003oool0oooo00800000103oool00`000000oooo0?ooo`02000000030?ooo`000000oooo
00800000103oool2000000d0oooo0P00003I0?ooo`007`3oool01@000000oooo0?ooo`3oool00000
00@0oooo00D000000?ooo`3oool0oooo000000020?ooo`<00000103oool3000000`0oooo0P00003I
0?ooo`007`3oool01@000000oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`800000103oool2000000d0oooo0P00003I0?ooo`007`3oool00`000000oooo0?ooo`02
000000@0oooo00<000000?ooo`3oool00P0000030?ooo`<000000`3oool2000000d0oooo0P00003I
0?ooo`007`3oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool00P0000000`3o
ool000000?ooo`03000000<0oooo0P00000<0?ooo`800000fP3oool001l0oooo0P0000000`3oool0
00000?ooo`040?ooo`80000000D0oooo0000003oool0oooo000000020?ooo`8000000`3oool20000
00`0oooo0P00003J0?ooo`00803oool3000000H0oooo0`0000030?ooo`@000000`3oool2000000`0
oooo0P00003J0?ooo`00<@3oool2000000<0oooo0`00000;0?ooo`800000fP3oool00340oooo0P00
00030?ooo`800000303oool200000=X0oooo000a0?ooo`8000000`3oool2000000`0oooo0P00003J
0?ooo`00<@3oool2000000<0oooo0P00000;0?ooo`800000f`3oool00340oooo0P0000030?ooo`80
00002`3oool200000=/0oooo000a0?ooo`8000000`3oool2000000/0oooo0P00003K0?ooo`00<@3o
ool2000000<0oooo0`00000:0?ooo`800000f`3oool00340oooo0P0000030?ooo`8000002`3oool2
00000=/0oooo000a0?ooo`8000000`3oool2000000/0oooo0P00003K0?ooo`00<@3oool2000000<0
oooo0P00000:0?ooo`800000g03oool00340oooo0P0000030?ooo`8000002P3oool200000=`0oooo
000a0?ooo`8000000`3oool2000000X0oooo0P00003L0?ooo`00<@3oool2000000<0oooo0`000009
0?ooo`800000g03oool00340oooo0`0000020?ooo`8000002P3oool200000=`0oooo000a0?ooo`80
00000`3oool2000000X0oooo0P00003L0?ooo`00<@3oool2000000<0oooo0P0000090?ooo`800000
g@3oool00340oooo0P0000030?ooo`8000002@3oool200000=d0oooo000a0?ooo`8000000`3oool2
000000T0oooo0P00003M0?ooo`00<@3oool2000000<0oooo0`0000080?ooo`800000g@3oool00340
oooo0P0000030?ooo`8000002@3oool200000=d0oooo000J0?ooo`<000000P3oool010000000oooo
0?ooo`3oool3000000@0oooo0P0000030?ooo`@000000`3oool2000000T0oooo0P00003M0?ooo`00
6@3oool2000000030?ooo`000000oooo00@0oooo0P000000103oool000000?ooo`3oool300000004
0?ooo`000000oooo00000080oooo0P0000030?ooo`800000203oool200000=h0oooo000I0?ooo`03
0000003oool0oooo00800000103oool00`000000oooo0?ooo`02000000030?ooo`000000oooo00@0
oooo00<000000?ooo`3oool00P0000030?ooo`800000203oool200000=h0oooo000I0?ooo`030000
003oool0oooo00800000103oool00`000000oooo0?ooo`02000000030?ooo`000000oooo00L0oooo
0P0000030?ooo`800000203oool200000=h0oooo000I0?ooo`050000003oool0oooo0?ooo`000000
103oool01@000000oooo0?ooo`3oool000000080oooo0P0000060?ooo`8000000`3oool3000000L0
oooo0P00003N0?ooo`006@3oool01@000000oooo0?ooo`3oool0000000@0oooo00D000000?ooo`3o
ool0oooo000000040?ooo`040000003oool0oooo00000080oooo0P0000030?ooo`800000203oool2
00000=h0oooo000I0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`020000
00@0oooo0P0000000`3oool0000000000003000000<0oooo0P0000070?ooo`800000g`3oool001T0
oooo00<000000?ooo`3oool00P0000040?ooo`030000003oool0oooo0080000000<0oooo0000003o
ool00P3oool00`000000oooo000000020?ooo`8000000`3oool2000000L0oooo0P00003O0?ooo`00
6@3oool2000000030?ooo`000000oooo00@0oooo0P0000001@3oool000000?ooo`3oool000000080
oooo0P000000103oool000000?ooo`3oool2000000<0oooo0P0000070?ooo`800000g`3oool001X0
oooo0`0000060?ooo`<000000`3oool300000080oooo1@0000030?ooo`8000001`3oool200000=l0
oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-2.69592, -0.00316013, \
0.0488735, 0.000166567}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(lambdaig[k_, a_, b_] := 
      4\ Sqrt[\((\((2\ k - 1)\)\ \((k + 
                    a)\)\ b)\)/\((\((2\ a + 4\ k - 1)\)^2 + 
                8\ \((k + a)\)\ \((1 - 2\ k)\))\)]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[lambdaig[k, 2, 2], {k, 1/2, 1}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928572 1.90476 0.0147151 0.300371 [
[.02381 .00222 -9 -9 ]
[.02381 .00222 9 0 ]
[.21429 .00222 -9 -9 ]
[.21429 .00222 9 0 ]
[.40476 .00222 -9 -9 ]
[.40476 .00222 9 0 ]
[.59524 .00222 -9 -9 ]
[.59524 .00222 9 0 ]
[.78571 .00222 -9 -9 ]
[.78571 .00222 9 0 ]
[.96369 .1649 -18 -4.5 ]
[.96369 .1649 0 4.5 ]
[.96369 .31509 -6 -4.5 ]
[.96369 .31509 0 4.5 ]
[.96369 .46527 -18 -4.5 ]
[.96369 .46527 0 4.5 ]
[.96369 .61546 -6 -4.5 ]
[.96369 .61546 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .01472 m
.02381 .02097 L
s
[(0.5)] .02381 .00222 0 1 Mshowa
.21429 .01472 m
.21429 .02097 L
s
[(0.6)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(0.7)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(0.8)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(0.9)] .78571 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.97619 .1649 m
.98244 .1649 L
s
[(0.5)] .96369 .1649 1 0 Mshowa
.97619 .31509 m
.98244 .31509 L
s
[(1)] .96369 .31509 1 0 Mshowa
.97619 .46527 m
.98244 .46527 L
s
[(1.5)] .96369 .46527 1 0 Mshowa
.97619 .61546 m
.98244 .61546 L
s
[(2)] .96369 .61546 1 0 Mshowa
.125 Mabswid
.97619 .04475 m
.97994 .04475 L
s
.97619 .07479 m
.97994 .07479 L
s
.97619 .10483 m
.97994 .10483 L
s
.97619 .13486 m
.97994 .13486 L
s
.97619 .19494 m
.97994 .19494 L
s
.97619 .22497 m
.97994 .22497 L
s
.97619 .25501 m
.97994 .25501 L
s
.97619 .28505 m
.97994 .28505 L
s
.97619 .34512 m
.97994 .34512 L
s
.97619 .37516 m
.97994 .37516 L
s
.97619 .4052 m
.97994 .4052 L
s
.97619 .43523 m
.97994 .43523 L
s
.97619 .49531 m
.97994 .49531 L
s
.97619 .52535 m
.97994 .52535 L
s
.97619 .55538 m
.97994 .55538 L
s
.97619 .58542 m
.97994 .58542 L
s
.25 Mabswid
.97619 0 m
.97619 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .01482 m
.02499 .0336 L
.02605 .04081 L
.02846 .05227 L
.03279 .06693 L
.04262 .09037 L
.05281 .10876 L
.06244 .12338 L
.10458 .17251 L
.14299 .20716 L
.18386 .23866 L
.22321 .26567 L
.26105 .28949 L
.30133 .3131 L
.34011 .33449 L
.38133 .35606 L
.42104 .37591 L
.45923 .39428 L
.49988 .41315 L
.53901 .43074 L
.58059 .44891 L
.62066 .46595 L
.65921 .48196 L
.70021 .49863 L
.7397 .51436 L
.77767 .52921 L
.81809 .54476 L
.857 .55948 L
.89836 .5749 L
.93821 .58954 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`002P3oool2000000@0oooo0P0000040?ooo`8000009@3oool2000000@0oooo0P0000030?oo
o`<000009@3oool2000000@0oooo0P0000050?ooo`030000003oool0oooo02<0oooo0P0000040?oo
o`800000103oool2000002@0oooo0P0000040?ooo`8000000`3oool3000003d0oooo00090?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool000008`3oool010000000oooo0?ooo`00
00080?ooo`040000003oool0oooo000002<0oooo00@000000?ooo`3oool000002P3oool00`000000
oooo0?ooo`0R0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000008P3oool0
10000000oooo0?ooo`00000:0?ooo`030000003oool0oooo03/0oooo00090?ooo`040000003oool0
oooo000000/0oooo00<000000?ooo`3oool08@3oool010000000oooo0?ooo`0000080?ooo`040000
003oool0oooo000002<0oooo00@000000?ooo`3oool000002P3oool00`000000oooo0?ooo`0R0?oo
o`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000008P3oool010000000oooo0?oo
o`0000090?ooo`<00000?03oool000T0oooo00@000000?ooo`3oool000002@3oool2000002@0oooo
00@000000?ooo`3oool00000203oool3000002@0oooo00@000000?ooo`3oool000002`3oool00`00
0000oooo0?ooo`0Q0?ooo`040000003oool0oooo000000T0oooo0P00000S0?ooo`040000003oool0
oooo000000P0oooo00@000000?ooo`3oool00000?03oool000T0oooo00@000000?ooo`3oool00000
2@3oool00`000000oooo0?ooo`0S0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3o
ool08`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo000002<0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`00000R0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool00000?03oool000X0oooo0P00000:0?ooo`<00000903oool2000000X0
oooo0`00000T0?ooo`8000002@3oool4000002@0oooo0P00000:0?ooo`800000903oool2000000X0
oooo0`00000l0?ooo`00o`3ooolQ0?ooo`00o`3oool@0?ooo`030000003oool0oooo00h0oooo003o
0?oooa00oooo00<000000?ooo`3oool03P3oool00?l0oooo403oool00`000000oooo0?ooo`0>0?oo
o`00o`3oool@0?ooo`030000003oool0oooo00h0oooo000;0?ooool000003@0000090?ooo`004@3o
ool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0203o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00h0oooo000A0?ooo`030000003oool0
oooo0300oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0`0?ooo`030000003oool0
oooo02l0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`0>0?ooo`004P3oool00`00
0000oooo0?ooo`3j0?ooo`030000003oool0oooo00h0oooo000B0?ooo`030000003oool0oooo0?X0
oooo00<000000?ooo`3oool03P3oool00180oooo00<000000?ooo`3oool0nP3oool00`000000oooo
0?ooo`0>0?ooo`004P3oool00`000000oooo0?ooo`3j0?ooo`030000003oool0oooo00h0oooo000B
0?ooo`030000003oool0oooo0?X0oooo00<000000?ooo`3oool03P3oool00180oooo00<000000?oo
o`3oool0nP3oool2000000l0oooo000C0?ooo`030000003oool0oooo0?T0oooo00<000000?ooo`3o
ool03P3oool001<0oooo00<000000?ooo`3oool0n@3oool00`000000oooo0?ooo`0>0?ooo`004`3o
ool00`000000oooo0?ooo`3i0?ooo`030000003oool0oooo00h0oooo000C0?ooo`030000003oool0
oooo0?T0oooo00<000000?ooo`3oool03P3oool001@0oooo00<000000?ooo`3oool0n03oool00`00
0000oooo0?ooo`0>0?ooo`00503oool00`000000oooo0?ooo`3h0?ooo`030000003oool0oooo00h0
oooo000D0?ooo`030000003oool0oooo0?P0oooo00<000000?ooo`3oool03P3oool001D0oooo00<0
00000?ooo`3oool0m`3oool2000000l0oooo000E0?ooo`030000003oool0oooo0?L0oooo00<00000
0?ooo`3oool03P3oool001D0oooo00<000000?ooo`3oool0m`3oool00`000000oooo0?ooo`0>0?oo
o`005P3oool00`000000oooo0?ooo`3f0?ooo`030000003oool0oooo00h0oooo000F0?ooo`030000
003oool0oooo0?H0oooo00<000000?ooo`3oool03P3oool001L0oooo00<000000?ooo`3oool0m@3o
ool00`000000oooo0?ooo`0>0?ooo`005`3oool00`000000oooo0?ooo`3e0?ooo`030000003oool0
oooo00h0oooo000H0?ooo`030000003oool0oooo0?@0oooo00<000000?ooo`3oool03P3oool001P0
oooo00<000000?ooo`3oool0m03oool2000000l0oooo000I0?ooo`030000003oool0oooo0?<0oooo
00<000000?ooo`3oool03P3oool001X0oooo00<000000?ooo`3oool0lP3oool00`000000oooo0?oo
o`0>0?ooo`006P3oool00`000000oooo0?ooo`3b0?ooo`030000003oool0oooo00h0oooo000K0?oo
o`030000003oool0oooo0?40oooo00<000000?ooo`3oool03P3oool001`0oooo00<000000?ooo`3o
ool0l03oool00`000000oooo0?ooo`0>0?ooo`007@3oool00`000000oooo0?ooo`3_0?ooo`030000
003oool0oooo00h0oooo000N0?ooo`030000003oool0oooo0>h0oooo00<000000?ooo`3oool03P3o
ool001l0oooo00<000000?ooo`3oool0k@3oool2000000l0oooo000O0?ooo`030000003oool0oooo
0>d0oooo00<000000?ooo`3oool03P3oool00200oooo00<000000?ooo`3oool0k03oool00`000000
oooo0?ooo`0>0?ooo`008@3oool00`000000oooo0?ooo`3[0?ooo`030000003oool0oooo00h0oooo
000R0?ooo`030000003oool0oooo0>X0oooo00<000000?ooo`3oool03P3oool002<0oooo00<00000
0?ooo`3oool0j@3oool00`000000oooo0?ooo`0>0?ooo`00903oool00`000000oooo0?ooo`3E0?oo
o`800000103oool2000000@0oooo0P0000050?ooo`030000003oool0oooo00h0oooo000T0?ooo`03
0000003oool0oooo0=@0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`000004
0?ooo`030000003oool0oooo00h0oooo000U0?ooo`030000003oool0oooo0=<0oooo00@000000?oo
o`3oool000002`3oool00`000000oooo0?ooo`020?ooo`<000003P3oool002H0oooo00<000000?oo
o`3oool0dP3oool010000000oooo0?ooo`0000090?ooo`8000001@3oool00`000000oooo0?ooo`0>
0?ooo`009`3oool00`000000oooo0?ooo`3A0?ooo`040000003oool0oooo000000T0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`0>0?ooo`00:03oool00`000000oooo0?ooo`3A0?oo
o`8000002P3oool3000000@0oooo00<000000?ooo`3oool03P3oool002T0oooo00<000000?ooo`3o
ool0h`3oool00`000000oooo0?ooo`0>0?ooo`00:P3oool00`000000oooo0?ooo`3R0?ooo`030000
003oool0oooo00h0oooo000[0?ooo`030000003oool0oooo0>40oooo00<000000?ooo`3oool03P3o
ool002`0oooo0P00003Q0?ooo`030000003oool0oooo00h0oooo000^0?ooo`030000003oool0oooo
0=h0oooo0P00000?0?ooo`00;`3oool00`000000oooo0?ooo`3M0?ooo`030000003oool0oooo00h0
oooo000`0?ooo`030000003oool0oooo0=`0oooo00<000000?ooo`3oool03P3oool00340oooo00<0
00000?ooo`3oool0f`3oool00`000000oooo0?ooo`0>0?ooo`00<P3oool00`000000oooo0?ooo`3J
0?ooo`030000003oool0oooo00h0oooo000c0?ooo`800000fP3oool00`000000oooo0?ooo`0>0?oo
o`00=@3oool00`000000oooo0?ooo`3G0?ooo`030000003oool0oooo00h0oooo000f0?ooo`030000
003oool0oooo0=H0oooo00<000000?ooo`3oool03P3oool003L0oooo00<000000?ooo`3oool0e@3o
ool2000000l0oooo000h0?ooo`030000003oool0oooo0=@0oooo00<000000?ooo`3oool03P3oool0
03T0oooo0P00003D0?ooo`030000003oool0oooo00h0oooo000k0?ooo`030000003oool0oooo0=40
oooo00<000000?ooo`3oool03P3oool003`0oooo00<000000?ooo`3oool0d03oool00`000000oooo
0?ooo`0>0?ooo`00?@3oool200000=00oooo00<000000?ooo`3oool03P3oool003l0oooo00<00000
0?ooo`3oool0c@3oool00`000000oooo0?ooo`0>0?ooo`00@03oool200000<d0oooo00<000000?oo
o`3oool03P3oool00480oooo0P00003;0?ooo`8000003`3oool004@0oooo00<000000?ooo`3oool0
b03oool00`000000oooo0?ooo`0>0?ooo`00A@3oool200000<P0oooo00<000000?ooo`3oool03P3o
ool004L0oooo00<000000?ooo`3oool0a@3oool00`000000oooo0?ooo`0>0?ooo`00B03oool20000
0<D0oooo00<000000?ooo`3oool03P3oool004X0oooo0P0000330?ooo`030000003oool0oooo00h0
oooo001<0?ooo`030000003oool0oooo0<00oooo00<000000?ooo`3oool03P3oool004d0oooo0P00
00300?ooo`030000003oool0oooo00h0oooo001?0?ooo`800000_P3oool2000000l0oooo001A0?oo
o`030000003oool0oooo0;/0oooo00<000000?ooo`3oool03P3oool00580oooo0P00002k0?ooo`03
0000003oool0oooo00h0oooo001D0?ooo`800000^@3oool00`000000oooo0?ooo`0>0?ooo`00EP3o
ool00`000000oooo0?ooo`2f0?ooo`030000003oool0oooo00h0oooo001G0?ooo`800000]P3oool0
0`000000oooo0?ooo`0>0?ooo`00F@3oool200000:`0oooo1@0000030?ooo`030000003oool0oooo
00h0oooo001K0?ooo`030000003oool0oooo0:/0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`0>0?ooo`00G03oool200000:/0oooo00<000000?ooo`3oool00`3oool3000000h0oooo
001N0?ooo`800000Z@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo001P
0?ooo`800000Y`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo001R0?oo
o`800000Y03oool2000000D0oooo00<000000?ooo`3oool03P3oool006@0oooo0P00002Y0?ooo`03
0000003oool0oooo00h0oooo001V0?ooo`030000003oool0oooo0:H0oooo00<000000?ooo`3oool0
3P3oool006L0oooo0P00002V0?ooo`030000003oool0oooo00h0oooo001Y0?ooo`800000Y03oool0
0`000000oooo0?ooo`0>0?ooo`00J`3oool200000:80oooo0P00000?0?ooo`00K@3oool200000:00
oooo00<000000?ooo`3oool03P3oool006l0oooo0P00002N0?ooo`030000003oool0oooo00h0oooo
001a0?ooo`030000003oool0oooo09/0oooo00<000000?ooo`3oool03P3oool00780oooo0P00002K
0?ooo`030000003oool0oooo00h0oooo001d0?ooo`800000V@3oool00`000000oooo0?ooo`0>0?oo
o`00MP3oool2000009L0oooo00<000000?ooo`3oool03P3oool007P0oooo0P00002E0?ooo`030000
003oool0oooo00h0oooo001j0?ooo`800000T`3oool2000000l0oooo001l0?ooo`800000T@3oool0
0`000000oooo0?ooo`0>0?ooo`00OP3oool2000008l0oooo00<000000?ooo`3oool03P3oool00800
oooo0P00002=0?ooo`030000003oool0oooo00h0oooo00220?ooo`800000R`3oool00`000000oooo
0?ooo`0>0?ooo`00Q03oool3000008P0oooo00<000000?ooo`3oool03P3oool008L0oooo0P000026
0?ooo`030000003oool0oooo00h0oooo00290?ooo`800000Q03oool00`000000oooo0?ooo`0>0?oo
o`00R`3oool200000880oooo0P00000?0?ooo`00S@3oool200000800oooo00<000000?ooo`3oool0
3P3oool008l0oooo0`00001m0?ooo`030000003oool0oooo00h0oooo002B0?ooo`800000N`3oool0
0`000000oooo0?ooo`0>0?ooo`00U03oool2000007T0oooo00<000000?ooo`3oool03P3oool009H0
oooo0P00001g0?ooo`030000003oool0oooo00h0oooo002H0?ooo`800000M@3oool00`000000oooo
0?ooo`0>0?ooo`00VP3oool300000780oooo00<000000?ooo`3oool03P3oool009d0oooo0P00001`
0?ooo`8000003`3oool009l0oooo0P00001^0?ooo`030000003oool0oooo00h0oooo002Q0?ooo`80
0000K03oool00`000000oooo0?ooo`0>0?ooo`00X`3oool2000006X0oooo00<000000?ooo`3oool0
3P3oool00:D0oooo0`00001W0?ooo`030000003oool0oooo00h0oooo002X0?ooo`800000I@3oool0
0`000000oooo0?ooo`0>0?ooo`00ZP3oool3000004h0oooo1@0000020?ooo`800000103oool20000
00D0oooo00<000000?ooo`3oool03P3oool00:d0oooo0P00001>0?ooo`030000003oool0oooo00L0
oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`0>0?ooo`00[`3oool3000004/0
oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`020?ooo`<000003P3oool00;80oooo
0`0000180?ooo`030000003oool0oooo00P0oooo0P0000050?ooo`030000003oool0oooo00h0oooo
002e0?ooo`800000AP3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool03P3oool00;L0oooo0`0000120?ooo`8000002P3oool3000000@0oooo00<00000
0?ooo`3oool03P3oool00;X0oooo0`00001B0?ooo`030000003oool0oooo00h0oooo002m0?ooo`80
0000D03oool00`000000oooo0?ooo`0>0?ooo`00_`3oool2000004h0oooo00<000000?ooo`3oool0
3P3oool00<40oooo0P00001<0?ooo`030000003oool0oooo00h0oooo00330?ooo`800000BP3oool2
000000l0oooo00350?ooo`<00000A`3oool00`000000oooo0?ooo`0>0?ooo`00b03oool2000004D0
oooo00<000000?ooo`3oool03P3oool00<X0oooo0`0000120?ooo`030000003oool0oooo00h0oooo
003=0?ooo`800000@03oool00`000000oooo0?ooo`0>0?ooo`00c`3oool3000003d0oooo00<00000
0?ooo`3oool03P3oool00=80oooo0P00000k0?ooo`030000003oool0oooo00h0oooo003D0?ooo`<0
0000>03oool00`000000oooo0?ooo`0>0?ooo`00e`3oool2000003H0oooo0P00000?0?ooo`00f@3o
ool3000003<0oooo00<000000?ooo`3oool03P3oool00=`0oooo0`00000`0?ooo`030000003oool0
oooo00h0oooo003O0?ooo`800000;P3oool00`000000oooo0?ooo`0>0?ooo`00h@3oool3000002/0
oooo00<000000?ooo`3oool03P3oool00>@0oooo0`00000X0?ooo`030000003oool0oooo00h0oooo
003W0?ooo`8000009P3oool00`000000oooo0?ooo`0>0?ooo`00j@3oool3000002<0oooo00<00000
0?ooo`3oool03P3oool00>`0oooo0P00000Q0?ooo`8000003`3oool00>h0oooo0`00000N0?ooo`03
0000003oool0oooo00h0oooo003a0?ooo`<000006`3oool00`000000oooo0?ooo`0>0?ooo`00m03o
ool2000001T0oooo00<000000?ooo`3oool03P3oool00?H0oooo0`00000F0?ooo`030000003oool0
oooo00h0oooo003i0?ooo`<000004`3oool00`000000oooo0?ooo`0>0?ooo`00o03oool300000100
oooo00<000000?ooo`3oool03P3oool00?l0oooo0P00000>0?ooo`030000003oool0oooo00h0oooo
003o0?ooo`80oooo0`00000;0?ooo`8000003`3oool00?l0oooo1@3oool3000000P0oooo00<00000
0?ooo`3oool03P3oool00?l0oooo203oool2000000H0oooo00<000000?ooo`3oool03P3oool00?l0
oooo2P3oool3000000<0oooo00<000000?ooo`3oool03P3oool00?l0oooo3@3oool2000000030?oo
o`000000oooo00l0oooo003o0?ooo`l0oooo0P00000@0?ooo`00o`3oool80?ooo`@00000103oool0
0`000000oooo0?ooo`0>0?ooo`00o`3oool80?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool03P3oool00?l0oooo2@3oool00`000000oooo0?ooo`040?ooo`<000003P3oool00?l0oooo
2P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00h0oooo003o0?ooo`P0oooo00@0
00000?ooo`3oool000005@3oool00?l0oooo2@3oool2000001H0oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {0.464707, -0.154035, \
0.00196989, 0.0124918}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[BoxData[
    \(estimig[d_, a_, b_, 
        k_] := \((\((2\ a + 4\ k - 1)\)\ d + 
            Sign[d]\ Sqrt[\((\((2\ a + 1)\)\ d)\)^2 + 
                  16\ \((1 - 2\ k)\)\ \((k + a)\)\ b])\)/\((4\ \((k + 
                a)\))\)\)], "Input"],

Cell[BoxData[
    \(srigamma[d_, k_, a_, b_] := 
      If[\((Abs[d] \[GreaterEqual] lambdaig[k, a, b])\), estimig[d, a, b, k], 
        0]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(Plot[{srigamma[d, 0.85, 2, 2], d}, {d, \(-4\), 4}, \ 
      AspectRatio \[Rule] Automatic, \[IndentingNewLine]\ 
      PlotStyle\  \[Rule] \ {{Thickness[
              0.01]}, {Dashing[{0.02}]}}, \[IndentingNewLine]\ 
      DefaultFont\  \[Rule] \ {"\<Roman\>", 
          12}, \ \ \ AxesLabel\  \[Rule] \ {d, \ 
          None}]\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12  scalefont  setfont
% Scaling calculations
0.5 0.119048 0.5 0.119048 [
[.02381 .4875 -9.03125 -15.75 ]
[.02381 .4875 9.03125 0 ]
[.2619 .4875 -9.03125 -15.75 ]
[.2619 .4875 9.03125 0 ]
[.7381 .4875 -4.84375 -15.75 ]
[.7381 .4875 4.84375 0 ]
[.97619 .4875 -4.84375 -15.75 ]
[.97619 .4875 4.84375 0 ]
[1.025 .5 0 -7.875 ]
[1.025 .5 10 7.875 ]
[.4875 .02381 -18.0625 -7.875 ]
[.4875 .02381 0 7.875 ]
[.4875 .2619 -18.0625 -7.875 ]
[.4875 .2619 0 7.875 ]
[.4875 .7381 -9.6875 -7.875 ]
[.4875 .7381 0 7.875 ]
[.4875 .97619 -9.6875 -7.875 ]
[.4875 .97619 0 7.875 ]
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .5 m
.02381 .50625 L
s
gsave
.02381 .4875 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.2619 .5 m
.2619 .50625 L
s
gsave
.2619 .4875 -70.0313 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.7381 .5 m
.7381 .50625 L
s
gsave
.7381 .4875 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.97619 .5 m
.97619 .50625 L
s
gsave
.97619 .4875 -65.8438 -19.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.08333 .5 m
.08333 .50375 L
s
.14286 .5 m
.14286 .50375 L
s
.20238 .5 m
.20238 .50375 L
s
.32143 .5 m
.32143 .50375 L
s
.38095 .5 m
.38095 .50375 L
s
.44048 .5 m
.44048 .50375 L
s
.55952 .5 m
.55952 .50375 L
s
.61905 .5 m
.61905 .50375 L
s
.67857 .5 m
.67857 .50375 L
s
.79762 .5 m
.79762 .50375 L
s
.85714 .5 m
.85714 .50375 L
s
.91667 .5 m
.91667 .50375 L
s
.25 Mabswid
0 .5 m
1 .5 L
s
gsave
1.025 .5 -61 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(d) show
1.000 setlinewidth
grestore
.5 .02381 m
.50625 .02381 L
s
gsave
.4875 .02381 -79.0625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.5 .2619 m
.50625 .2619 L
s
gsave
.4875 .2619 -79.0625 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.375 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .7381 m
.50625 .7381 L
s
gsave
.4875 .7381 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.5 .97619 m
.50625 .97619 L
s
gsave
.4875 .97619 -70.6875 -11.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 23.75 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 15.750 moveto
%%IncludeResource: font Roman
%%IncludeFont: Roman
/Roman findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.5 .08333 m
.50375 .08333 L
s
.5 .14286 m
.50375 .14286 L
s
.5 .20238 m
.50375 .20238 L
s
.5 .32143 m
.50375 .32143 L
s
.5 .38095 m
.50375 .38095 L
s
.5 .44048 m
.50375 .44048 L
s
.5 .55952 m
.50375 .55952 L
s
.5 .61905 m
.50375 .61905 L
s
.5 .67857 m
.50375 .67857 L
s
.5 .79762 m
.50375 .79762 L
s
.5 .85714 m
.50375 .85714 L
s
.5 .91667 m
.50375 .91667 L
s
.25 Mabswid
.5 0 m
.5 1 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.01 w
.02381 .0412 m
.06244 .08153 L
.10458 .12597 L
.14415 .16833 L
.18221 .20994 L
.22272 .25585 L
.26171 .30329 L
.28158 .33031 L
.29205 .34643 L
.29779 .35641 L
.30316 .36731 L
.3056 .3733 L
.3068 .37675 L
.30791 .38051 L
.30919 .38642 L
.30987 .5 L
.31059 .5 L
.31187 .5 L
.31304 .5 L
.31372 .5 L
.31444 .5 L
.31573 .5 L
.31644 .5 L
.31711 .5 L
.31785 .5 L
.31864 .5 L
.31932 .5 L
.32006 .5 L
.32075 .5 L
.3214 .5 L
.32262 .5 L
.32392 .5 L
.3251 .5 L
.32618 .5 L
.32737 .5 L
.32862 .5 L
.32971 .5 L
.33072 .5 L
.33184 .5 L
.33303 .5 L
.33433 .5 L
.33506 .5 L
.33574 .5 L
.33698 .5 L
.3383 .5 L
.33948 .5 L
.34058 .5 L
.34179 .5 L
.34309 .5 L
.34377 .5 L
Mistroke
.34442 .5 L
.34563 .5 L
.34693 .5 L
.34767 .5 L
.34834 .5 L
.34947 .5 L
.35071 .5 L
.35201 .5 L
.35322 .5 L
.3539 .5 L
.35465 .5 L
.35536 .5 L
.35601 .5 L
.35724 .5 L
.35855 .5 L
.35922 .5 L
.35995 .5 L
.36127 .5 L
.36203 .5 L
.36283 .5 L
.36351 .5 L
.36426 .5 L
.36491 .5 L
.36562 .5 L
.3669 .5 L
.36815 .5 L
.3693 .5 L
.37055 .5 L
.37125 .5 L
.37192 .5 L
.37261 .5 L
.37325 .5 L
.37398 .5 L
.37468 .5 L
.37585 .5 L
.37709 .5 L
.37815 .5 L
.37932 .5 L
.38057 .5 L
.38127 .5 L
.38192 .5 L
.38311 .5 L
.38436 .5 L
.38559 .5 L
.38629 .5 L
.38693 .5 L
.3881 .5 L
.38935 .5 L
.39047 .5 L
.39151 .5 L
Mistroke
.39266 .5 L
.39389 .5 L
.3952 .5 L
.39593 .5 L
.39662 .5 L
.39787 .5 L
.39858 .5 L
.39921 .5 L
.40042 .5 L
.40172 .5 L
.40295 .5 L
.40408 .5 L
.40514 .5 L
.40628 .5 L
.40736 .5 L
.40834 .5 L
.40949 .5 L
.41074 .5 L
.41192 .5 L
.41301 .5 L
.41413 .5 L
.41518 .5 L
.41634 .5 L
.41758 .5 L
.41882 .5 L
.42012 .5 L
.42122 .5 L
.42244 .5 L
.42376 .5 L
.42498 .5 L
.42561 .5 L
.42631 .5 L
.42705 .5 L
.42773 .5 L
.42899 .5 L
.43014 .5 L
.43077 .5 L
.43146 .5 L
.43272 .5 L
.43396 .5 L
.43507 .5 L
.43636 .5 L
.43757 .5 L
.4387 .5 L
.43973 .5 L
.44087 .5 L
.44206 .5 L
.44337 .5 L
.44456 .5 L
.44522 .5 L
Mistroke
.44594 .5 L
.44724 .5 L
.44846 .5 L
.44975 .5 L
.45085 .5 L
.45206 .5 L
.45279 .5 L
.45349 .5 L
.45479 .5 L
.45551 .5 L
.45619 .5 L
.45693 .5 L
.45772 .5 L
.45841 .5 L
.45915 .5 L
.45985 .5 L
.4605 .5 L
.46172 .5 L
.46302 .5 L
.46424 .5 L
.46493 .5 L
.46556 .5 L
.46673 .5 L
.46797 .5 L
.46908 .5 L
.47012 .5 L
.47126 .5 L
.47249 .5 L
.47372 .5 L
.47442 .5 L
.47507 .5 L
.47638 .5 L
.47712 .5 L
.47779 .5 L
.47899 .5 L
.48029 .5 L
.48152 .5 L
.48265 .5 L
.4837 .5 L
.48484 .5 L
.48591 .5 L
.48689 .5 L
.48803 .5 L
.48928 .5 L
.49046 .5 L
.49155 .5 L
.49278 .5 L
.49395 .5 L
.49499 .5 L
.49612 .5 L
Mistroke
.49735 .5 L
.49865 .5 L
.49976 .5 L
.50098 .5 L
.50229 .5 L
.5035 .5 L
.50413 .5 L
.50482 .5 L
.50555 .5 L
.50623 .5 L
.50748 .5 L
.50863 .5 L
.50988 .5 L
.5112 .5 L
.51232 .5 L
.51351 .5 L
.51463 .5 L
.51565 .5 L
.51686 .5 L
.51816 .5 L
.51939 .5 L
.52052 .5 L
.52173 .5 L
.52302 .5 L
.52425 .5 L
.52536 .5 L
.52667 .5 L
.52741 .5 L
.5281 .5 L
.52935 .5 L
.52999 .5 L
.53069 .5 L
.53136 .5 L
.53208 .5 L
.53335 .5 L
.53406 .5 L
.53473 .5 L
.53545 .5 L
.53623 .5 L
.5369 .5 L
.53763 .5 L
.53832 .5 L
.53896 .5 L
.54017 .5 L
.54144 .5 L
.54265 .5 L
.54396 .5 L
.54521 .5 L
.54636 .5 L
.5475 .5 L
Mistroke
.54854 .5 L
.54973 .5 L
.55086 .5 L
.55209 .5 L
.55339 .5 L
.5545 .5 L
.55572 .5 L
.55704 .5 L
.55777 .5 L
.55844 .5 L
.55975 .5 L
.56098 .5 L
.56203 .5 L
.56319 .5 L
.5644 .5 L
.56554 .5 L
.56659 .5 L
.56756 .5 L
.56863 .5 L
.56975 .5 L
.57089 .5 L
.57211 .5 L
.57326 .5 L
.5743 .5 L
.57553 .5 L
.57623 .5 L
.57687 .5 L
.57804 .5 L
.57929 .5 L
.5805 .5 L
.58182 .5 L
.58306 .5 L
.58422 .5 L
.58536 .5 L
.5864 .5 L
.5876 .5 L
.58873 .5 L
.58996 .5 L
.59127 .5 L
.59238 .5 L
.5936 .5 L
.59492 .5 L
.59565 .5 L
.59632 .5 L
.59763 .5 L
.59886 .5 L
.59992 .5 L
.60108 .5 L
.60229 .5 L
.60343 .5 L
Mistroke
.60449 .5 L
.60546 .5 L
.60658 .5 L
.60764 .5 L
.60879 .5 L
.61001 .5 L
.61116 .5 L
.6122 .5 L
.61343 .5 L
.61413 .5 L
.61476 .5 L
.61594 .5 L
.61718 .5 L
.6184 .5 L
.61908 .5 L
.61972 .5 L
.62089 .5 L
.62213 .5 L
.62324 .5 L
.62428 .5 L
.62542 .5 L
.62665 .5 L
.62788 .5 L
.62857 .5 L
.62922 .5 L
.63054 .5 L
.63127 .5 L
.63194 .5 L
.63314 .5 L
.63444 .5 L
.63567 .5 L
.6368 .5 L
.63785 .5 L
.63899 .5 L
.64006 .5 L
.64104 .5 L
.64218 .5 L
.64343 .5 L
.64461 .5 L
.6457 .5 L
.64693 .5 L
.64809 .5 L
.64914 .5 L
.65026 .5 L
.6515 .5 L
.6528 .5 L
.65391 .5 L
.65513 .5 L
.65643 .5 L
.65764 .5 L
Mistroke
.65827 .5 L
.65897 .5 L
.6597 .5 L
.66038 .5 L
.66163 .5 L
.66277 .5 L
.66402 .5 L
.66535 .5 L
.66646 .5 L
.66765 .5 L
.66877 .5 L
.66979 .5 L
.671 .5 L
.6723 .5 L
.67353 .5 L
.67466 .5 L
.67586 .5 L
.67716 .5 L
.67838 .5 L
.6795 .5 L
.68081 .5 L
.68155 .5 L
.68223 .5 L
.68349 .5 L
.68419 .5 L
.68482 .5 L
.6855 .5 L
.68621 .5 L
.68749 .5 L
.6882 .5 L
.68886 .5 L
.68959 .5 L
.69037 .60995 L
.69104 .61492 L
.69177 .61827 L
.6931 .62292 L
.69558 .62971 L
.70502 .64862 L
.71541 .66526 L
.73644 .69432 L
.77672 .74349 L
.81549 .7875 L
.85671 .8326 L
.89641 .87509 L
.9346 .91537 L
.97524 .95781 L
.97619 .9588 L
Mfstroke
.5 Mabswid
[ .02 ] 0 setdash
.02381 .02381 m
.06244 .06244 L
.10458 .10458 L
.14415 .14415 L
.18221 .18221 L
.22272 .22272 L
.26171 .26171 L
.30316 .30316 L
.34309 .34309 L
.3815 .3815 L
.42237 .42237 L
.46172 .46172 L
.49955 .49955 L
.53984 .53984 L
.57861 .57861 L
.61984 .61984 L
.65954 .65954 L
.69774 .69774 L
.73838 .73838 L
.77751 .77751 L
.81909 .81909 L
.85916 .85916 L
.89771 .89771 L
.93871 .93871 L
.97619 .97619 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 288},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00R03oool0
0`000000oooo0?ooo`2E0?ooo`00R03oool00`000000oooo0?ooo`2E0?ooo`00R03oool00`000000
oooo0?ooo`2E0?ooo`00P03oool2000000H0oooo00<000000?ooo`3oool0U@3oool00800oooo0P00
00060?ooo`030000003oool0oooo09D0oooo00200?ooo`8000001P3oool00`000000oooo0?ooo`2E
0?ooo`00OP3oool4000000H0oooo00<000000?ooo`3oool0U@3oool000T0oooo00<000000?ooo`3o
ool0JP3oool7000000030?ooo`000000oooo008000001P3oool3000009D0oooo000:0?ooo`030000
003oool0oooo0780oooo0`0000060?ooo`030000003oool0oooo09D0oooo000;0?ooo`030000003o
ool0oooo0740oooo0`0000060?ooo`030000003oool0oooo09D0oooo00090?ooo`040000003oool0
oooo000007<0oooo0P0000060?ooo`030000003oool0oooo09D0oooo00080?ooo`<00000M@3oool2
000000H0oooo00<000000?ooo`3oool0U@3oool000T0oooo0`00001e0?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool0U@3oool000X0oooo0`00001k0?ooo`030000003oool0oooo09D0
oooo000;0?ooo`<000000P3oool00`000000oooo0?ooo`1e0?ooo`030000003oool0oooo09D0oooo
000<0?ooo`<000000P3oool00`000000oooo0?ooo`1d0?ooo`030000003oool0oooo09D0oooo000=
0?ooo`8000000`3oool00`000000oooo0?ooo`1c0?ooo`030000003oool0oooo09D0oooo000>0?oo
o`8000000`3oool00`000000oooo0?ooo`1b0?ooo`030000003oool0oooo09D0oooo000>0?ooo`<0
00000`3oool00`000000oooo0?ooo`1a0?ooo`030000003oool0oooo09D0oooo000?0?ooo`<00000
MP3oool00`000000oooo0?ooo`2E0?ooo`00403oool3000007D0oooo00<000000?ooo`3oool0U@3o
ool00140oooo0`00001d0?ooo`030000003oool0oooo09D0oooo000B0?ooo`<000000`3oool00`00
0000oooo0?ooo`1]0?ooo`800000UP3oool001<0oooo0`0000030?ooo`030000003oool0oooo06`0
oooo00<000000?ooo`3oool0U@3oool001@0oooo0`0000030?ooo`030000003oool0oooo06/0oooo
00<000000?ooo`3oool0U@3oool001D0oooo0`0000030?ooo`030000003oool0oooo06X0oooo00<0
00000?ooo`3oool0U@3oool001H0oooo0`00001_0?ooo`030000003oool0oooo09D0oooo000G0?oo
o`800000K`3oool00`000000oooo0?ooo`2E0?ooo`00603oool2000006h0oooo00<000000?ooo`3o
ool0U@3oool001P0oooo0`0000040?ooo`030000003oool0oooo06H0oooo00<000000?ooo`3oool0
U@3oool001T0oooo0`0000040?ooo`030000003oool0oooo06D0oooo00<000000?ooo`3oool0U@3o
ool001X0oooo0`0000040?ooo`030000003oool0oooo06@0oooo00<000000?ooo`3oool0U@3oool0
01/0oooo0`0000040?ooo`030000003oool0oooo06<0oooo00<000000?ooo`3oool0U@3oool001`0
oooo0`0000040?ooo`030000003oool0oooo0680oooo00<000000?ooo`3oool0U@3oool001d0oooo
0`00001X0?ooo`030000003oool0oooo09D0oooo000N0?ooo`<00000I`3oool00`000000oooo0?oo
o`2E0?ooo`007`3oool3000006H0oooo00<000000?ooo`3oool0U@3oool00200oooo0`0000040?oo
o`030000003oool0oooo05h0oooo00<000000?ooo`3oool0U@3oool00240oooo0`0000040?ooo`03
0000003oool0oooo05d0oooo0P00002F0?ooo`008P3oool3000000@0oooo00<000000?ooo`3oool0
G03oool00`000000oooo0?ooo`2E0?ooo`008`3oool3000000@0oooo00<000000?ooo`3oool0F`3o
ool00`000000oooo0?ooo`2E0?ooo`00903oool3000000@0oooo00<000000?ooo`3oool0FP3oool0
0`000000oooo0?ooo`2E0?ooo`009@3oool300000600oooo00<000000?ooo`3oool0U@3oool002H0
oooo0`00001O0?ooo`030000003oool0oooo09D0oooo000W0?ooo`<00000103oool00`000000oooo
0?ooo`1G0?ooo`030000003oool0oooo09D0oooo000X0?ooo`<00000103oool00`000000oooo0?oo
o`1F0?ooo`030000003oool0oooo09D0oooo000Y0?ooo`<00000103oool00`000000oooo0?ooo`1E
0?ooo`030000003oool0oooo09D0oooo000Z0?ooo`<00000103oool00`000000oooo0?ooo`1D0?oo
o`030000003oool0oooo09D0oooo000[0?ooo`<00000103oool00`000000oooo0?ooo`1C0?ooo`03
0000003oool0oooo09D0oooo000/0?ooo`<00000F@3oool00`000000oooo0?ooo`2E0?ooo`00;@3o
ool2000005T0oooo00<000000?ooo`3oool0U@3oool002h0oooo0P00001H0?ooo`030000003oool0
oooo09D0oooo000^0?ooo`<000001@3oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo
09D0oooo000_0?ooo`<000001@3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo09D0
oooo000`0?ooo`<000001@3oool00`000000oooo0?ooo`1=0?ooo`800000UP3oool00340oooo0`00
00050?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool0U@3oool00380oooo0`000005
0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0U@3oool003<0oooo0`00001B0?oo
o`030000003oool0oooo09D0oooo000d0?ooo`<00000D@3oool00`000000oooo0?ooo`2E0?ooo`00
=@3oool200000540oooo00<000000?ooo`3oool0U@3oool003H0oooo0P0000050?ooo`800000B@3o
ool00`000000oooo0?ooo`2E0?ooo`00=P3oool3000000H0oooo00<000000?ooo`3oool0AP3oool0
0`000000oooo0?ooo`2E0?ooo`00=`3oool3000000H0oooo00<000000?ooo`3oool0A@3oool00`00
0000oooo0?ooo`2E0?ooo`00>03oool3000000H0oooo00<000000?ooo`3oool0A03oool00`000000
oooo0?ooo`2E0?ooo`00>@3oool3000004`0oooo00<000000?ooo`3oool0U@3oool003X0oooo0P00
001<0?ooo`030000003oool0oooo09D0oooo000k0?ooo`800000@`3oool2000000H0oooo00<00000
0?ooo`3oool0U@3oool003/0oooo0`0000070?ooo`030000003oool0oooo03H0oooo0`0000000`3o
ool000000?ooo`040?ooo`030000003oool0oooo09D0oooo000l0?ooo`<000001`3oool00`000000
oooo0?ooo`0e0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0U@3oool003d0oooo
0`0000070?ooo`030000003oool0oooo03@0oooo00<000000?ooo`3oool01`3oool00`000000oooo
0?ooo`2E0?ooo`00?P3oool3000000L0oooo00<000000?ooo`3oool0:`3oool700000080oooo0P00
00070?ooo`<00000U@3oool003l0oooo0P0000080?ooo`030000003oool0oooo03D0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`2E0?ooo`00@03oool2000003l0oooo0P0000050?oo
o`030000003oool0oooo09D0oooo00100?ooo`<00000>`3oool01@000000oooo0?ooo`3oool00000
00D0oooo00<000000?ooo`3oool0U@3oool00440oooo0`00000j0?ooo`030000003oool0oooo0080
00001@3oool00`000000oooo0?ooo`2E0?ooo`00@P3oool3000000P0oooo00<000000?ooo`3oool0
;`3oool3000000H0oooo00<000000?ooo`3oool0U@3oool004<0oooo0`0000080?ooo`030000003o
ool0oooo03L0oooo00<000000?ooo`3oool0U@3oool004@0oooo0P0000080?ooo`030000003oool0
oooo03L0oooo00<000000?ooo`3oool0U@3oool004D0oooo0P0000080?ooo`030000003oool0oooo
03H0oooo00<000000?ooo`3oool0U@3oool004D0oooo0`0000080?ooo`030000003oool0oooo03D0
oooo00<000000?ooo`3oool0U@3oool004H0oooo0`00000o0?ooo`030000003oool0oooo09D0oooo
00170?ooo`800000?`3oool00`000000oooo0?ooo`2E0?ooo`00B03oool2000000X0oooo00<00000
0?ooo`3oool0<@3oool00`000000oooo0?ooo`2E0?ooo`00B@3oool2000000X0oooo00<000000?oo
o`3oool0<03oool00`000000oooo0?ooo`2E0?ooo`00BP3oool2000000X0oooo00<000000?ooo`3o
ool0;`3oool00`000000oooo0?ooo`2E0?ooo`00B`3oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo02h0oooo00<000000?ooo`3oool0U@3oool004/0oooo0P00000;0?ooo`030000003o
ool0oooo02d0oooo0P00002F0?ooo`00C03oool2000003X0oooo00<000000?ooo`3oool0U@3oool0
04d0oooo0P00000i0?ooo`030000003oool0oooo09D0oooo001>0?ooo`030000003oool0oooo03L0
oooo00<000000?ooo`3oool0U@3oool004h0oooo0P00000<0?ooo`030000003oool0oooo02T0oooo
00<000000?ooo`3oool0U@3oool004l0oooo00<000000?ooo`3oool02`3oool00`000000oooo0?oo
o`0X0?ooo`030000003oool0oooo09D0oooo001?0?ooo`8000003@3oool00`000000oooo0?ooo`0W
0?ooo`030000003oool0oooo09D0oooo001@0?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool09P3oool00`000000oooo0?ooo`2E0?ooo`00D03oool2000000h0oooo00<000000?ooo`3o
ool09@3oool00`000000oooo0?ooo`2E0?ooo`00D@3oool2000003D0oooo00<000000?ooo`3oool0
U@3oool00580oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`2E0?ooo`00DP3oool2
000000l0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`2E0?ooo`00D`3oool00`00
0000oooo0?ooo`0>0?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0U@3oool005<0
oooo0P00000@0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool0U@3oool005@0oooo
00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0O0?ooo`030000003oool0oooo09D0oooo
001C0?ooo`<000004@3oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo09D0oooo001D
0?ooo`800000<P3oool2000009H0oooo001D0?ooo`800000<P3oool00`000000oooo0?ooo`2E0?oo
o`00E03oool200000380oooo00<000000?ooo`3oool0U@3oool005@0oooo0P00000E0?ooo`030000
003oool0oooo01X0oooo00<000000?ooo`3oool0U@3oool005@0oooo0P00000F0?ooo`030000003o
ool0oooo01T0oooo00<000000?ooo`3oool0U@3oool005@0oooo0P00000G0?ooo`030000003oool0
oooo01P0oooo00<000000?ooo`3oool0U@3oool005@0oooo0P00000H0?ooo`030000003oool0oooo
01L0oooo00<000000?ooo`3oool0U@3oool005@0oooo0P00000I0?ooo`030000003oool0oooo01H0
oooo00<000000?ooo`3oool0U@3oool005@0oooo0P00000b0?ooo`030000003oool0oooo09D0oooo
001D0?ooo`800000<P3oool00`000000oooo0?ooo`2E0?ooo`00E03oool200000380oooo00<00000
0?ooo`3oool0U@3oool005@0oooo0P00000L0?ooo`800000503oool00`000000oooo0?ooo`2E0?oo
o`00E03oool2000001h0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`2E0?ooo`00
E03oool2000001l0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`2E0?ooo`00E03o
ool200000200oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`2E0?ooo`00E03oool2
00000380oooo00<000000?ooo`3oool0U@3oool005@0oooo0P00000b0?ooo`800000UP3oool000d0
oooo0P00000n0?ooo`8000001@3oool200000380oooo00<000000?ooo`3oool0?@3oool2000003h0
oooo0P00000F0?ooo`003@3oool2000003`0oooo0`0000000`3oool000000?ooo`030?ooo`800000
903oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo03/0oooo0`0000000`3oool00000
0?ooo`0l0?ooo`8000005P3oool000d0oooo0P00000l0?ooo`030000003oool0oooo00H0oooo0P00
000U0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?oo
o`0o0?ooo`8000005P3oool000/0oooo1000000l0?ooo`030000003oool0oooo00H0oooo0P00000V
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0>`3oool00`000000oooo0?ooo`0m
0?ooo`@000005P3oool000<0oooo1`0000000`3oool000000?ooo`02000003<0oooo1`0000030?oo
o`8000001P3oool2000002L0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0l0?oo
o`800000?@3oool010000000oooo00000000000F0?ooo`00303oool3000003l0oooo00<000000?oo
o`3oool00`3oool2000002P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0n0?oo
o`030000003oool0oooo03/0oooo0`00000F0?ooo`00303oool3000003l0oooo0P0000040?ooo`80
0000<P3oool00`000000oooo0?ooo`0n0?ooo`800000?03oool3000001H0oooo000=0?ooo`800000
?03oool01@000000oooo0?ooo`3oool0000000@0oooo0P00000b0?ooo`030000003oool0oooo03/0
oooo00D000000?ooo`3oool0oooo0000000m0?ooo`8000005P3oool000d0oooo0P00000l0?ooo`03
0000003oool0oooo00800000103oool200000380oooo00<000000?ooo`3oool0>`3oool00`000000
oooo0?ooo`02000003d0oooo0P00000F0?ooo`003P3oool00`000000oooo0?ooo`0k0?ooo`<00000
1@3oool2000002`0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0l0?ooo`<00000
?`3oool00`000000oooo0?ooo`0D0?ooo`00E03oool2000002d0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`2E0?ooo`00E03oool2000002d0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`2>0?ooo`<00000103oool005@0oooo0P00000^0?ooo`050000003oool0oooo
0?ooo`000000S`3oool2000000030?ooo`000000000000<0oooo001D0?ooo`800000;`3oool01000
0000oooo0?ooo`00002?0?ooo`030000003oool0oooo008000000`3oool005@0oooo0P00000b0?oo
o`030000003oool0oooo08d0oooo00<000000?ooo`3oool00P0000030?ooo`000P3ooooo000000h0
00002@3oool00`000000oooo0?ooo`02000000<0oooo00090?ooo`030000003oool0oooo00`0oooo
00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00d0oooo
00<000000?ooo`3oool02@3ooomX000000`0oooo00<000000?ooo`3oool03@3oool00`000000oooo
0?ooo`0=0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3oool0303oool00`000000oooo
0?ooo`0>0?ooo`80000000<0oooo0000000000000`3oool000T0oooo00<000000?ooo`3oool0?03o
ool00`000000oooo0?ooo`0m0?ooo`030000003oool0000002l0oooo0P00000<0?ooo`030000003o
ool0oooo03`0oooo00<000000?ooo`3oool03`3oool4000000<0oooo00280?ooo`040000003oool0
oooo000002h0oooo0P00001O0?ooo`8000000`3oool008P0oooo00D000000?ooo`3oool0oooo0000
000]0?ooo`800000G`3oool2000000<0oooo00280?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0:P3oool2000005h0oooo0`0000030?ooo`00R03oool00`000000oooo0?ooo`0_0?oo
o`800000I03oool008P0oooo00<000000?ooo`3oool0;`3oool2000006@0oooo00280?ooo`030000
003oool0oooo02l0oooo0P00001T0?ooo`00R03oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo02H0oooo0P00001T0?ooo`00R03oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo02D0oooo0P00001T0?ooo`00R03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo
02@0oooo0P00001T0?ooo`00R03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo02<0
oooo0P00001T0?ooo`00R03oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo0280oooo
0P00001T0?ooo`00R03oool00`000000oooo0?ooo`0_0?ooo`800000I03oool008P0oooo00<00000
0?ooo`3oool0;`3oool2000006@0oooo00280?ooo`8000003P3oool00`000000oooo0?ooo`0O0?oo
o`800000I03oool008P0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0N0?ooo`80
0000I03oool008P0oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0M0?ooo`800000
I03oool008P0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0L0?ooo`800000I03o
ool008P0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0K0?ooo`800000I03oool0
08P0oooo00<000000?ooo`3oool0;`3oool2000006@0oooo00280?ooo`030000003oool0oooo02l0
oooo0P00001T0?ooo`00R03oool00`000000oooo0?ooo`0_0?ooo`800000I03oool008P0oooo00<0
00000?ooo`3oool05@3oool00`000000oooo0?ooo`0G0?ooo`800000I03oool008P0oooo00<00000
0?ooo`3oool05P3oool00`000000oooo0?ooo`0F0?ooo`800000I03oool008P0oooo00<000000?oo
o`3oool05`3oool00`000000oooo0?ooo`0E0?ooo`800000I03oool008P0oooo00<000000?ooo`3o
ool0603oool00`000000oooo0?ooo`0D0?ooo`800000I03oool008P0oooo00<000000?ooo`3oool0
6@3oool00`000000oooo0?ooo`0C0?ooo`800000I03oool008P0oooo00<000000?ooo`3oool0;`3o
ool2000006@0oooo00280?ooo`030000003oool0oooo02l0oooo0P00001T0?ooo`00R03oool00`00
0000oooo0?ooo`0_0?ooo`800000I03oool008P0oooo0P00000M0?ooo`8000004@3oool3000006<0
oooo00280?ooo`030000003oool0oooo01h0oooo00<000000?ooo`3oool03`3oool2000006<0oooo
00280?ooo`030000003oool0oooo01l0oooo00<000000?ooo`3oool03P3oool2000006<0oooo0028
0?ooo`030000003oool0oooo0200oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`1Q
0?ooo`00R03oool00`000000oooo0?ooo`0a0?ooo`800000HP3oool008P0oooo00<000000?ooo`3o
ool0<P3oool00`000000oooo0?ooo`1P0?ooo`00R03oool00`000000oooo0?ooo`0b0?ooo`800000
H@3oool008P0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0<0?ooo`800000H03o
ool008P0oooo00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0
oooo05h0oooo00280?ooo`030000003oool0oooo02H0oooo00<000000?ooo`3oool02`3oool20000
05l0oooo00280?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool02`3oool2000005h0
oooo00280?ooo`030000003oool0oooo02P0oooo00<000000?ooo`3oool02`3oool2000005d0oooo
00280?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0F`3oool008P0oooo00<00000
0?ooo`3oool0=`3oool2000005`0oooo00280?ooo`030000003oool0oooo03P0oooo0P00001K0?oo
o`00R03oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool0F@3oool008P0oooo0P00000^0?ooo`030000003oool0oooo00T0oooo0P00001J0?ooo`00R03o
ool00`000000oooo0?ooo`0^0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0F03o
ool008P0oooo00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`080?ooo`800000F@3oool0
08P0oooo00<000000?ooo`3oool0>`3oool2000005P0oooo00280?ooo`030000003oool0oooo03`0
oooo0P00001G0?ooo`00R03oool00`000000oooo0?ooo`0l0?ooo`<00000EP3oool008P0oooo00<0
00000?ooo`3oool0<`3oool00`000000oooo0?ooo`070?ooo`<00000E@3oool008P0oooo00<00000
0?ooo`3oool0=03oool00`000000oooo0?ooo`070?ooo`800000E@3oool008P0oooo00<000000?oo
o`3oool0=@3oool00`000000oooo0?ooo`070?ooo`800000E03oool008P0oooo00<000000?ooo`3o
ool0=P3oool00`000000oooo0?ooo`060?ooo`<00000D`3oool008P0oooo00<000000?ooo`3oool0
=`3oool00`000000oooo0?ooo`060?ooo`<00000DP3oool008P0oooo00<000000?ooo`3oool0@@3o
ool300000540oooo00200?ooo`8000001P3oool00`000000oooo0?ooo`120?ooo`<00000D03oool0
07h0oooo0`0000000`3oool000000?ooo`040?ooo`030000003oool0oooo04<0oooo0P00001@0?oo
o`00OP3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3o
ool01P3oool2000004l0oooo001n0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
?03oool00`000000oooo0?ooo`050?ooo`<00000CP3oool007l0oooo0P0000070?ooo`<00000?@3o
ool00`000000oooo0?ooo`050?ooo`<00000C@3oool00840oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`0n0?ooo`030000003oool0oooo00D0oooo0`00001<0?ooo`00P@3oool20000
00D0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`050?ooo`<00000B`3oool007h0
oooo00D000000?ooo`3oool0oooo000000050?ooo`030000003oool0oooo04P0oooo0P00001;0?oo
o`00OP3oool00`000000oooo0?ooo`02000000D0oooo00<000000?ooo`3oool0B@3oool2000004X0
oooo001o0?ooo`<000001P3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo00@0oooo
0`0000190?ooo`00R03oool00`000000oooo0?ooo`130?ooo`030000003oool0oooo00@0oooo0`00
00180?ooo`00R03oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo00@0oooo0`000017
0?ooo`00R03oool00`000000oooo0?ooo`150?ooo`030000003oool0oooo00@0oooo0`0000160?oo
o`00R03oool00`000000oooo0?ooo`160?ooo`030000003oool0oooo00@0oooo0P0000160?ooo`00
R03oool00`000000oooo0?ooo`1>0?ooo`800000A@3oool008P0oooo00<000000?ooo`3oool0CP3o
ool3000004@0oooo00280?ooo`030000003oool0oooo04l0oooo0`0000130?ooo`00R03oool00`00
0000oooo0?ooo`1:0?ooo`030000003oool0oooo00<0oooo0`0000120?ooo`00R03oool00`000000
oooo0?ooo`1;0?ooo`030000003oool0oooo00<0oooo0`0000110?ooo`00R03oool00`000000oooo
0?ooo`1<0?ooo`030000003oool0oooo00<0oooo0`0000100?ooo`00R03oool2000004h0oooo00<0
00000?ooo`3oool00`3oool3000003l0oooo00280?ooo`030000003oool0oooo04h0oooo00<00000
0?ooo`3oool00`3oool3000003h0oooo00280?ooo`030000003oool0oooo05D0oooo0P00000n0?oo
o`00R03oool00`000000oooo0?ooo`1F0?ooo`800000?@3oool008P0oooo00<000000?ooo`3oool0
EP3oool3000003`0oooo00280?ooo`030000003oool0oooo0540oooo0P0000040?ooo`<00000>`3o
ool008P0oooo00<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`020?ooo`<00000>P3oool0
08P0oooo00<000000?ooo`3oool0E03oool00`000000oooo0?ooo`020?ooo`<00000>@3oool008P0
oooo00<000000?ooo`3oool0E@3oool00`000000oooo0?ooo`020?ooo`<00000>03oool008P0oooo
00<000000?ooo`3oool0F`3oool3000003L0oooo00280?ooo`030000003oool0oooo05`0oooo0`00
000f0?ooo`00R03oool00`000000oooo0?ooo`1M0?ooo`<00000=@3oool008P0oooo00<000000?oo
o`3oool0F@3oool00`000000oooo0?ooo`020?ooo`<00000=03oool008P0oooo00<000000?ooo`3o
ool0FP3oool00`000000oooo0?ooo`020?ooo`<00000<`3oool008P0oooo00<000000?ooo`3oool0
F`3oool00`000000oooo0?ooo`020?ooo`<00000<P3oool008P0oooo00<000000?ooo`3oool0G03o
ool00`000000oooo0?ooo`020?ooo`<00000<@3oool008P0oooo0P00001N0?ooo`030000003oool0
oooo0080oooo0`00000`0?ooo`00R03oool00`000000oooo0?ooo`1S0?ooo`<00000;`3oool008P0
oooo00<000000?ooo`3oool0I03oool3000002h0oooo00280?ooo`030000003oool0oooo06D0oooo
0`00000]0?ooo`00R03oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo0080oooo0`00
000/0?ooo`00R03oool00`000000oooo0?ooo`1R0?ooo`030000003oool0oooo0080oooo0`00000[
0?ooo`00R03oool00`000000oooo0?ooo`1S0?ooo`030000003oool0oooo0080oooo0`00000Z0?oo
o`00R03oool00`000000oooo0?ooo`1T0?ooo`030000003oool0oooo0080oooo0`00000Y0?ooo`00
R03oool00`000000oooo0?ooo`1Z0?ooo`<00000:03oool008P0oooo00<000000?ooo`3oool0J`3o
ool2000002P0oooo00280?ooo`030000003oool0oooo06`0oooo0P00000W0?ooo`00R03oool00`00
0000oooo0?ooo`1X0?ooo`040000003oool0oooo0?ooo`<000009P3oool008P0oooo00<000000?oo
o`3oool0J@3oool010000000oooo0?ooo`3oool3000002D0oooo00280?ooo`030000003oool0oooo
06X0oooo00@000000?ooo`3oool0oooo0`00000T0?ooo`00R03oool00`000000oooo0?ooo`1[0?oo
o`040000003oool0oooo0?ooo`<000008`3oool008P0oooo00<000000?ooo`3oool0K03oool01000
0000oooo0?ooo`3oool300000280oooo00280?ooo`800000LP3oool300000240oooo00280?ooo`03
0000003oool0oooo0780oooo0`00000P0?ooo`00R03oool00`000000oooo0?ooo`1c0?ooo`<00000
7`3oool008P0oooo00<000000?ooo`3oool0L03oool010000000oooo0?ooo`3oool3000001h0oooo
00280?ooo`030000003oool0oooo0740oooo00@000000?ooo`3oool0oooo0P00000N0?ooo`00R03o
ool00`000000oooo0?ooo`1b0?ooo`040000003oool0oooo0?ooo`8000007@3oool008P0oooo00<0
00000?ooo`3oool0L`3oool00`000000oooo0?ooo`03000001`0oooo00280?ooo`030000003oool0
oooo07@0oooo00<000000?ooo`3oool00`00000K0?ooo`00R03oool00`000000oooo0?ooo`1h0?oo
o`<000006P3oool008P0oooo00<000000?ooo`3oool0N@3oool3000001T0oooo00280?ooo`030000
003oool0oooo07L0oooo00<000000?ooo`3oool00`00000H0?ooo`00R03oool00`000000oooo0?oo
o`1h0?ooo`030000003oool0oooo00<000005`3oool00800oooo0P0000060?ooo`030000003oool0
oooo07T0oooo00@000000?ooo`3oool00000603oool00800oooo0P0000060?ooo`030000003oool0
oooo07X0oooo00<000000?ooo`3oool0603oool00800oooo0P0000060?ooo`030000003oool0oooo
07/0oooo00<000000?ooo`3oool05`3oool007h0oooo100000060?ooo`<00000U@3oool007h0oooo
00@000000?ooo`00000000001P3oool00`000000oooo0?ooo`2E0?ooo`00O`3oool3000000H0oooo
00<000000?ooo`3oool0U@3oool007l0oooo0`0000060?ooo`030000003oool0oooo09D0oooo0020
0?ooo`8000001P3oool00`000000oooo0?ooo`2E0?ooo`00P03oool2000000H0oooo00<000000?oo
o`3oool0U@3oool00840oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2E0?ooo`00
R03oool00`000000oooo0?ooo`2E0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?oo
o`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {287, 0}} -> {-4.28347, -4.50367, 0.0313845, \
0.0313845}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1440}, {0, 783}},
WindowSize->{496, 599},
WindowMargins->{{379, Automatic}, {Automatic, 7}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 223, 4, 90, "Input"],

Cell[CellGroupData[{
Cell[2002, 59, 254, 5, 70, "Input"],
Cell[2259, 66, 28641, 911, 186, 15472, 744, "GraphicsData", "PostScript", \
"Graphics"],
Cell[30903, 979, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[31070, 987, 323, 7, 90, "Input"],
Cell[31396, 996, 29633, 910, 186, 15694, 733, "GraphicsData", "PostScript", \
"Graphics"],
Cell[61032, 1908, 130, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[61199, 1916, 89, 1, 30, "Input"],
Cell[61291, 1919, 34444, 1075, 186, 17795, 865, "GraphicsData", "PostScript", \
"Graphics"],
Cell[95738, 2996, 130, 3, 29, "Output"]
}, Open  ]],
Cell[95883, 3002, 210, 4, 90, "Input"],

Cell[CellGroupData[{
Cell[96118, 3010, 69, 1, 30, "Input"],
Cell[96190, 3013, 15828, 401, 186, 3439, 244, "GraphicsData", "PostScript", \
"Graphics"],
Cell[112021, 3416, 130, 3, 29, "Output"]
}, Open  ]],
Cell[112166, 3422, 249, 5, 90, "Input"],
Cell[112418, 3429, 151, 3, 50, "Input"],

Cell[CellGroupData[{
Cell[112594, 3436, 398, 8, 110, "Input"],
Cell[112995, 3446, 36522, 1184, 296, 16423, 931, "GraphicsData", \
"PostScript", "Graphics"],
Cell[149520, 4632, 130, 3, 29, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

